# autogenerated by genrb from AckermannDrive.msg. Do not edit.
require 'ros/message'


module Ackermann_msgs

class AckermannDrive <::ROS::Message
  def self.md5sum
    "3512e91b48d69674a0e86fadf1ea8231"
  end

  def self.type
    "ackermann_msgs/AckermannDrive"
  end

  def has_header?
    false
  end

  def message_definition
    "## Driving command for a car-like vehicle using Ackermann steering.
#  $Id$

# Assumes Ackermann front-wheel steering. The left and right front
# wheels are generally at different angles. To simplify, the commanded
# angle corresponds to the yaw of a virtual wheel located at the
# center of the front axle, like on a tricycle.  Positive yaw is to
# the left. (This is *not* the angle of the steering wheel inside the
# passenger compartment.)
#
# Zero steering angle velocity means change the steering angle as
# quickly as possible. Positive velocity indicates a desired absolute
# rate of change either left or right. The controller tries not to
# exceed this limit in either direction, but sometimes it might.
#
float32 steering_angle          # desired virtual angle (radians)
float32 steering_angle_velocity # desired rate of change (radians/s)

# Drive at requested speed, acceleration and jerk (the 1st, 2nd and
# 3rd derivatives of position). All are measured at the vehicle's
# center of rotation, typically the center of the rear axle. The
# controller tries not to exceed these limits in either direction, but
# sometimes it might.
#
# Speed is the desired scalar magnitude of the velocity vector.
# Direction is forward unless the sign is negative, indicating reverse.
#
# Zero acceleration means change speed as quickly as
# possible. Positive acceleration indicates a desired absolute
# magnitude; that includes deceleration.
#
# Zero jerk means change acceleration as quickly as possible. Positive
# jerk indicates a desired absolute rate of acceleration change in
# either direction (increasing or decreasing).
#
float32 speed                   # desired forward speed (m/s)
float32 acceleration            # desired acceleration (m/s^2)
float32 jerk                    # desired jerk (m/s^3)

"
  end
  attr_accessor :steering_angle, :steering_angle_velocity, :speed, :acceleration, :jerk

  @@struct_f5 = ::ROS::Struct.new("f5")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['float32','float32','float32','float32','float32']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [float32] :steering_angle initialize value
  # @option args [float32] :steering_angle_velocity initialize value
  # @option args [float32] :speed initialize value
  # @option args [float32] :acceleration initialize value
  # @option args [float32] :jerk initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:steering_angle]
      @steering_angle = args[:steering_angle]
    else
      @steering_angle = 0.0
    end
    if args[:steering_angle_velocity]
      @steering_angle_velocity = args[:steering_angle_velocity]
    else
      @steering_angle_velocity = 0.0
    end
    if args[:speed]
      @speed = args[:speed]
    else
      @speed = 0.0
    end
    if args[:acceleration]
      @acceleration = args[:acceleration]
    else
      @acceleration = 0.0
    end
    if args[:jerk]
      @jerk = args[:jerk]
    else
      @jerk = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_f5.pack(@steering_angle, @steering_angle_velocity, @speed, @acceleration, @jerk))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('f5')
      (@steering_angle, @steering_angle_velocity, @speed, @acceleration, @jerk,) = @@struct_f5.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
