# autogenerated by genrb from DenseLaserSnapshot.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "ros/time"

module Calibration_msgs

class DenseLaserSnapshot <::ROS::Message
  def self.md5sum
    "deb2810d3530db3484f886a81243195d"
  end

  def self.type
    "calibration_msgs/DenseLaserSnapshot"
  end

  def has_header?
    true
  end

  def message_definition
    "# Provides all the state & sensor information for
# a single sweep of laser attached to some mechanism.
# Most likely, this will be used with PR2's tilting laser mechanism
Header header

# Store the laser intrinsics. This is very similar to the
# intrinsics commonly stored in 
float32 angle_min        # start angle of the scan [rad]
float32 angle_max        # end angle of the scan [rad]
float32 angle_increment  # angular distance between measurements [rad]
float32 time_increment   # time between measurements [seconds]
float32 range_min        # minimum range value [m]
float32 range_max        # maximum range value [m]

# Define the size of the binary data
uint32 readings_per_scan    # (Width)
uint32 num_scans            # (Height)

# 2D Arrays storing laser data.
# We can think of each type data as being a single channel image.
# Each row of the image has data from a single scan, and scans are
# concatenated to form the entire 'image'.
float32[] ranges            # (Image data)
float32[] intensities       # (Image data)

# Store the start time of each scan
time[] scan_start

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  attr_accessor :header, :angle_min, :angle_max, :angle_increment, :time_increment, :range_min, :range_max, :readings_per_scan, :num_scans, :ranges, :intensities, :scan_start

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_f6L2 = ::ROS::Struct.new("f6L2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','float32','float32','float32','float32','float32','float32','uint32','uint32','float32[]','float32[]','time[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [float32] :angle_min initialize value
  # @option args [float32] :angle_max initialize value
  # @option args [float32] :angle_increment initialize value
  # @option args [float32] :time_increment initialize value
  # @option args [float32] :range_min initialize value
  # @option args [float32] :range_max initialize value
  # @option args [uint32] :readings_per_scan initialize value
  # @option args [uint32] :num_scans initialize value
  # @option args [float32[]] :ranges initialize value
  # @option args [float32[]] :intensities initialize value
  # @option args [time[]] :scan_start initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:angle_min]
      @angle_min = args[:angle_min]
    else
      @angle_min = 0.0
    end
    if args[:angle_max]
      @angle_max = args[:angle_max]
    else
      @angle_max = 0.0
    end
    if args[:angle_increment]
      @angle_increment = args[:angle_increment]
    else
      @angle_increment = 0.0
    end
    if args[:time_increment]
      @time_increment = args[:time_increment]
    else
      @time_increment = 0.0
    end
    if args[:range_min]
      @range_min = args[:range_min]
    else
      @range_min = 0.0
    end
    if args[:range_max]
      @range_max = args[:range_max]
    else
      @range_max = 0.0
    end
    if args[:readings_per_scan]
      @readings_per_scan = args[:readings_per_scan]
    else
      @readings_per_scan = 0
    end
    if args[:num_scans]
      @num_scans = args[:num_scans]
    else
      @num_scans = 0
    end
    if args[:ranges]
      @ranges = args[:ranges]
    else
      @ranges = []
    end
    if args[:intensities]
      @intensities = args[:intensities]
    else
      @intensities = []
    end
    if args[:scan_start]
      @scan_start = args[:scan_start]
    else
      @scan_start = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_f6L2.pack(@angle_min, @angle_max, @angle_increment, @time_increment, @range_min, @range_max, @readings_per_scan, @num_scans))
      length = @ranges.length
      buff.write(@@struct_L.pack(length))
      pattern = "f#{length}"
      buff.write(*@ranges.pack(pattern))
      length = @intensities.length
      buff.write(@@struct_L.pack(length))
      pattern = "f#{length}"
      buff.write(*@intensities.pack(pattern))
      length = @scan_start.length
      buff.write(@@struct_L.pack(length))
      for val1 in @scan_start
        _x = val1
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @scan_start == nil
        @scan_start = None
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('f6L2')
      (@angle_min, @angle_max, @angle_increment, @time_increment, @range_min, @range_max, @readings_per_scan, @num_scans,) = @@struct_f6L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "f#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @ranges = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "f#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @intensities = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @scan_start = []
      length.times do
        val1 = ROS::Time.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        @scan_start.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
