# autogenerated by genrb from LaserMeasurement.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "sensor_msgs/Image"
require "calibration_msgs/CalibrationPattern"
require "sensor_msgs/JointState"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "calibration_msgs/JointStateCalibrationPattern"
require "calibration_msgs/DenseLaserSnapshot"

module Calibration_msgs

class LaserMeasurement <::ROS::Message
  def self.md5sum
    "7fa7e818b1234a443aa5d8e315175d17"
  end

  def self.type
    "calibration_msgs/LaserMeasurement"
  end

  def has_header?
    true
  end

  def message_definition
    "Header header
string laser_id
sensor_msgs/JointState[] joint_points

# True -> The extra debugging fields are populated
bool verbose

# Extra, partially processed data. Only needed for debugging
calibration_msgs/DenseLaserSnapshot snapshot
sensor_msgs/Image laser_image
calibration_msgs/CalibrationPattern image_features
calibration_msgs/JointStateCalibrationPattern joint_features

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: calibration_msgs/DenseLaserSnapshot
# Provides all the state & sensor information for
# a single sweep of laser attached to some mechanism.
# Most likely, this will be used with PR2's tilting laser mechanism
Header header

# Store the laser intrinsics. This is very similar to the
# intrinsics commonly stored in 
float32 angle_min        # start angle of the scan [rad]
float32 angle_max        # end angle of the scan [rad]
float32 angle_increment  # angular distance between measurements [rad]
float32 time_increment   # time between measurements [seconds]
float32 range_min        # minimum range value [m]
float32 range_max        # maximum range value [m]

# Define the size of the binary data
uint32 readings_per_scan    # (Width)
uint32 num_scans            # (Height)

# 2D Arrays storing laser data.
# We can think of each type data as being a single channel image.
# Each row of the image has data from a single scan, and scans are
# concatenated to form the entire 'image'.
float32[] ranges            # (Image data)
float32[] intensities       # (Image data)

# Store the start time of each scan
time[] scan_start

================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in include/sensor_msgs/image_encodings.h

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: calibration_msgs/CalibrationPattern
Header header
geometry_msgs/Point[] object_points
geometry_msgs/Point[] image_points
uint8 success

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: calibration_msgs/JointStateCalibrationPattern
Header header
geometry_msgs/Point[]  object_points
sensor_msgs/JointState[] joint_points


"
  end
  attr_accessor :header, :laser_id, :joint_points, :verbose, :snapshot, :laser_image, :image_features, :joint_features

  @@struct_CL = ::ROS::Struct.new("CL")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_CL3 = ::ROS::Struct.new("CL3")
  @@struct_f6L2 = ::ROS::Struct.new("f6L2")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','string','sensor_msgs/JointState[]','bool','calibration_msgs/DenseLaserSnapshot','sensor_msgs/Image','calibration_msgs/CalibrationPattern','calibration_msgs/JointStateCalibrationPattern']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [string] :laser_id initialize value
  # @option args [sensor_msgs/JointState[]] :joint_points initialize value
  # @option args [bool] :verbose initialize value
  # @option args [calibration_msgs/DenseLaserSnapshot] :snapshot initialize value
  # @option args [sensor_msgs/Image] :laser_image initialize value
  # @option args [calibration_msgs/CalibrationPattern] :image_features initialize value
  # @option args [calibration_msgs/JointStateCalibrationPattern] :joint_features initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:laser_id]
      @laser_id = args[:laser_id]
    else
      @laser_id = ''
    end
    if args[:joint_points]
      @joint_points = args[:joint_points]
    else
      @joint_points = []
    end
    if args[:verbose]
      @verbose = args[:verbose]
    else
      @verbose = false
    end
    if args[:snapshot]
      @snapshot = args[:snapshot]
    else
      @snapshot = Calibration_msgs::DenseLaserSnapshot.new
    end
    if args[:laser_image]
      @laser_image = args[:laser_image]
    else
      @laser_image = Sensor_msgs::Image.new
    end
    if args[:image_features]
      @image_features = args[:image_features]
    else
      @image_features = Calibration_msgs::CalibrationPattern.new
    end
    if args[:joint_features]
      @joint_features = args[:joint_features]
    else
      @joint_features = Calibration_msgs::JointStateCalibrationPattern.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @laser_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @joint_points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @joint_points
        _v219 = val1.header
        buff.write(@@struct_L.pack(_v219.seq))
        _v220 = _v219.stamp
        _x = _v220
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v219.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.name.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.name
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        length = val1.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.position.pack(pattern))
        length = val1.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.velocity.pack(pattern))
        length = val1.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.effort.pack(pattern))
      end
      buff.write(@@struct_CL3.pack(@verbose, @snapshot.header.seq, @snapshot.header.stamp.secs, @snapshot.header.stamp.nsecs))
      _x = @snapshot.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_f6L2.pack(@snapshot.angle_min, @snapshot.angle_max, @snapshot.angle_increment, @snapshot.time_increment, @snapshot.range_min, @snapshot.range_max, @snapshot.readings_per_scan, @snapshot.num_scans))
      length = @snapshot.ranges.length
      buff.write(@@struct_L.pack(length))
      pattern = "f#{length}"
      buff.write(*@snapshot.ranges.pack(pattern))
      length = @snapshot.intensities.length
      buff.write(@@struct_L.pack(length))
      pattern = "f#{length}"
      buff.write(*@snapshot.intensities.pack(pattern))
      length = @snapshot.scan_start.length
      buff.write(@@struct_L.pack(length))
      for val1 in @snapshot.scan_start
        _x = val1
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_L3.pack(@laser_image.header.seq, @laser_image.header.stamp.secs, @laser_image.header.stamp.nsecs))
      _x = @laser_image.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@laser_image.height, @laser_image.width))
      _x = @laser_image.encoding
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_CL.pack(@laser_image.is_bigendian, @laser_image.step))
      _x = @laser_image.data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@image_features.header.seq, @image_features.header.stamp.secs, @image_features.header.stamp.nsecs))
      _x = @image_features.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @image_features.object_points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @image_features.object_points
        _x = val1
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @image_features.image_points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @image_features.image_points
        _x = val1
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      buff.write(@@struct_CL3.pack(@image_features.success, @joint_features.header.seq, @joint_features.header.stamp.secs, @joint_features.header.stamp.nsecs))
      _x = @joint_features.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @joint_features.object_points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @joint_features.object_points
        _x = val1
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @joint_features.joint_points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @joint_features.joint_points
        _v221 = val1.header
        buff.write(@@struct_L.pack(_v221.seq))
        _v222 = _v221.stamp
        _x = _v222
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v221.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.name.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.name
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        length = val1.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.position.pack(pattern))
        length = val1.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.velocity.pack(pattern))
        length = val1.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.effort.pack(pattern))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @joint_points == nil
        @joint_points = Sensor_msgs::JointState[].new
      end
      if @snapshot == nil
        @snapshot = Calibration_msgs::DenseLaserSnapshot.new
      end
      if @laser_image == nil
        @laser_image = Sensor_msgs::Image.new
      end
      if @image_features == nil
        @image_features = Calibration_msgs::CalibrationPattern.new
      end
      if @joint_features == nil
        @joint_features = Calibration_msgs::JointStateCalibrationPattern.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @laser_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @joint_points = []
      length.times do
        val1 = Sensor_msgs::JointState.new
        _v223 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v223.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v224 = _v223.stamp
        _x = _v224
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v223.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.name.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.effort = str[start..(end_point-1)].unpack(pattern)
        @joint_points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('CL3')
      (@verbose, @snapshot.header.seq, @snapshot.header.stamp.secs, @snapshot.header.stamp.nsecs,) = @@struct_CL3.unpack(str[start..(end_point-1)])
      @verbose = bool(@verbose)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @snapshot.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('f6L2')
      (@snapshot.angle_min, @snapshot.angle_max, @snapshot.angle_increment, @snapshot.time_increment, @snapshot.range_min, @snapshot.range_max, @snapshot.readings_per_scan, @snapshot.num_scans,) = @@struct_f6L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "f#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @snapshot.ranges = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "f#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @snapshot.intensities = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @snapshot.scan_start = []
      length.times do
        val1 = ROS::Time.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        @snapshot.scan_start.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@laser_image.header.seq, @laser_image.header.stamp.secs, @laser_image.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @laser_image.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@laser_image.height, @laser_image.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @laser_image.encoding = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('CL')
      (@laser_image.is_bigendian, @laser_image.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @laser_image.data = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@image_features.header.seq, @image_features.header.stamp.secs, @image_features.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @image_features.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @image_features.object_points = []
      length.times do
        val1 = Geometry_msgs::Point.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @image_features.object_points.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @image_features.image_points = []
      length.times do
        val1 = Geometry_msgs::Point.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @image_features.image_points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('CL3')
      (@image_features.success, @joint_features.header.seq, @joint_features.header.stamp.secs, @joint_features.header.stamp.nsecs,) = @@struct_CL3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @joint_features.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @joint_features.object_points = []
      length.times do
        val1 = Geometry_msgs::Point.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @joint_features.object_points.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @joint_features.joint_points = []
      length.times do
        val1 = Sensor_msgs::JointState.new
        _v225 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v225.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v226 = _v225.stamp
        _x = _v226
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v225.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.name.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.effort = str[start..(end_point-1)].unpack(pattern)
        @joint_features.joint_points.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
