# autogenerated by genrb from RobotMeasurement.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "calibration_msgs/DenseLaserSnapshot"
require "sensor_msgs/Image"
require "calibration_msgs/CalibrationPattern"
require "sensor_msgs/JointState"
require "sensor_msgs/RegionOfInterest"
require "calibration_msgs/CameraMeasurement"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "calibration_msgs/LaserMeasurement"
require "calibration_msgs/JointStateCalibrationPattern"
require "sensor_msgs/CameraInfo"
require "calibration_msgs/ChainMeasurement"

module Calibration_msgs

class RobotMeasurement <::ROS::Message
  def self.md5sum
    "fe22486c078efbf7892430dd0b99305c"
  end

  def self.type
    "calibration_msgs/RobotMeasurement"
  end

  def has_header?
    false
  end

  def message_definition
    "string sample_id    # Tag to figure out which yaml file this was generated from

string target_id    # Defines the target that we were sensing.
string chain_id     # Defines where this target was attached

CameraMeasurement[] M_cam
LaserMeasurement[]  M_laser
ChainMeasurement[]  M_chain

================================================================================
MSG: calibration_msgs/CameraMeasurement
Header header
string camera_id
geometry_msgs/Point[] image_points
sensor_msgs/CameraInfo cam_info

# True -> The extra debugging fields are populated
bool verbose

# Extra, partially processed data. Only needed for debugging
sensor_msgs/Image image
sensor_msgs/Image image_rect
calibration_msgs/CalibrationPattern features

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: sensor_msgs/CameraInfo
# This message defines meta information for a camera. It should be in a
# camera namespace on topic \"camera_info\" and accompanied by up to five
# image topics named:
#
#   image_raw - raw data from the camera driver, possibly Bayer encoded
#   image            - monochrome, distorted
#   image_color      - color, distorted
#   image_rect       - monochrome, rectified
#   image_rect_color - color, rectified
#
# The image_pipeline contains packages (image_proc, stereo_image_proc)
# for producing the four processed image topics from image_raw and
# camera_info. The meaning of the camera parameters are described in
# detail at http://www.ros.org/wiki/image_pipeline/CameraInfo.
#
# The image_geometry package provides a user-friendly interface to
# common operations using this meta information. If you want to, e.g.,
# project a 3d point into image coordinates, we strongly recommend
# using image_geometry.
#
# If the camera is uncalibrated, the matrices D, K, R, P should be left
# zeroed out. In particular, clients may assume that K[0] == 0.0
# indicates an uncalibrated camera.

#######################################################################
#                     Image acquisition info                          #
#######################################################################

# Time of image acquisition, camera coordinate frame ID
Header header    # Header timestamp should be acquisition time of image
                 # Header frame_id should be optical frame of camera
                 # origin of frame should be optical center of camera
                 # +x should point to the right in the image
                 # +y should point down in the image
                 # +z should point into the plane of the image


#######################################################################
#                      Calibration Parameters                         #
#######################################################################
# These are fixed during camera calibration. Their values will be the #
# same in all messages until the camera is recalibrated. Note that    #
# self-calibrating systems may \"recalibrate\" frequently.              #
#                                                                     #
# The internal parameters can be used to warp a raw (distorted) image #
# to:                                                                 #
#   1. An undistorted image (requires D and K)                        #
#   2. A rectified image (requires D, K, R)                           #
# The projection matrix P projects 3D points into the rectified image.#
#######################################################################

# The image dimensions with which the camera was calibrated. Normally
# this will be the full camera resolution in pixels.
uint32 height
uint32 width

# The distortion model used. Supported models are listed in
# sensor_msgs/distortion_models.h. For most cameras, \"plumb_bob\" - a
# simple model of radial and tangential distortion - is sufficent.
string distortion_model

# The distortion parameters, size depending on the distortion model.
# For \"plumb_bob\", the 5 parameters are: (k1, k2, t1, t2, k3).
float64[] D

# Intrinsic camera matrix for the raw (distorted) images.
#     [fx  0 cx]
# K = [ 0 fy cy]
#     [ 0  0  1]
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy).
float64[9]  K # 3x3 row-major matrix

# Rectification matrix (stereo cameras only)
# A rotation matrix aligning the camera coordinate system to the ideal
# stereo image plane so that epipolar lines in both stereo images are
# parallel.
float64[9]  R # 3x3 row-major matrix

# Projection/camera matrix
#     [fx'  0  cx' Tx]
# P = [ 0  fy' cy' Ty]
#     [ 0   0   1   0]
# By convention, this matrix specifies the intrinsic (camera) matrix
#  of the processed (rectified) image. That is, the left 3x3 portion
#  is the normal camera intrinsic matrix for the rectified image.
# It projects 3D points in the camera coordinate frame to 2D pixel
#  coordinates using the focal lengths (fx', fy') and principal point
#  (cx', cy') - these may differ from the values in K.
# For monocular cameras, Tx = Ty = 0. Normally, monocular cameras will
#  also have R = the identity and P[1:3,1:3] = K.
# For a stereo pair, the fourth column [Tx Ty 0]' is related to the
#  position of the optical center of the second camera in the first
#  camera's frame. We assume Tz = 0 so both cameras are in the same
#  stereo image plane. The first camera always has Tx = Ty = 0. For
#  the right (second) camera of a horizontal stereo pair, Ty = 0 and
#  Tx = -fx' * B, where B is the baseline between the cameras.
# Given a 3D point [X Y Z]', the projection (x, y) of the point onto
#  the rectified image is given by:
#  [u v w]' = P * [X Y Z 1]'
#         x = u / w
#         y = v / w
#  This holds for both images of a stereo pair.
float64[12] P # 3x4 row-major matrix


#######################################################################
#                      Operational Parameters                         #
#######################################################################
# These define the image region actually captured by the camera       #
# driver. Although they affect the geometry of the output image, they #
# may be changed freely without recalibrating the camera.             #
#######################################################################

# Binning refers here to any camera setting which combines rectangular
#  neighborhoods of pixels into larger \"super-pixels.\" It reduces the
#  resolution of the output image to
#  (width / binning_x) x (height / binning_y).
# The default values binning_x = binning_y = 0 is considered the same
#  as binning_x = binning_y = 1 (no subsampling).
uint32 binning_x
uint32 binning_y

# Region of interest (subwindow of full camera resolution), given in
#  full resolution (unbinned) image coordinates. A particular ROI
#  always denotes the same window of pixels on the camera sensor,
#  regardless of binning settings.
# The default setting of roi (all values 0) is considered the same as
#  full resolution (roi.width = width, roi.height = height).
RegionOfInterest roi

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image.
#
# When used to specify the ROI setting of the camera when the image was
# taken, the height and width fields should either match the height and
# width fields for the associated image; or height = width = 0
# indicates that the full resolution image was captured.

uint32 x_offset  # Leftmost pixel of the ROI
                 # (0 if the ROI includes the left edge of the image)
uint32 y_offset  # Topmost pixel of the ROI
                 # (0 if the ROI includes the top edge of the image)
uint32 height    # Height of ROI
uint32 width     # Width of ROI

# True if a distinct rectified ROI should be calculated from the \"raw\"
# ROI in this message. Typically this should be False if the full image
# is captured (ROI not used), and True if a subwindow is captured (ROI
# used).
bool do_rectify

================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in include/sensor_msgs/image_encodings.h

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: calibration_msgs/CalibrationPattern
Header header
geometry_msgs/Point[] object_points
geometry_msgs/Point[] image_points
uint8 success

================================================================================
MSG: calibration_msgs/LaserMeasurement
Header header
string laser_id
sensor_msgs/JointState[] joint_points

# True -> The extra debugging fields are populated
bool verbose

# Extra, partially processed data. Only needed for debugging
calibration_msgs/DenseLaserSnapshot snapshot
sensor_msgs/Image laser_image
calibration_msgs/CalibrationPattern image_features
calibration_msgs/JointStateCalibrationPattern joint_features

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: calibration_msgs/DenseLaserSnapshot
# Provides all the state & sensor information for
# a single sweep of laser attached to some mechanism.
# Most likely, this will be used with PR2's tilting laser mechanism
Header header

# Store the laser intrinsics. This is very similar to the
# intrinsics commonly stored in 
float32 angle_min        # start angle of the scan [rad]
float32 angle_max        # end angle of the scan [rad]
float32 angle_increment  # angular distance between measurements [rad]
float32 time_increment   # time between measurements [seconds]
float32 range_min        # minimum range value [m]
float32 range_max        # maximum range value [m]

# Define the size of the binary data
uint32 readings_per_scan    # (Width)
uint32 num_scans            # (Height)

# 2D Arrays storing laser data.
# We can think of each type data as being a single channel image.
# Each row of the image has data from a single scan, and scans are
# concatenated to form the entire 'image'.
float32[] ranges            # (Image data)
float32[] intensities       # (Image data)

# Store the start time of each scan
time[] scan_start

================================================================================
MSG: calibration_msgs/JointStateCalibrationPattern
Header header
geometry_msgs/Point[]  object_points
sensor_msgs/JointState[] joint_points


================================================================================
MSG: calibration_msgs/ChainMeasurement
Header header
string chain_id
sensor_msgs/JointState chain_state

"
  end
  attr_accessor :sample_id, :target_id, :chain_id, :M_cam, :M_laser, :M_chain

  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d12 = ::ROS::Struct.new("d12")
  @@struct_d9 = ::ROS::Struct.new("d9")
  @@struct_CL = ::ROS::Struct.new("CL")
  @@struct_f6L2 = ::ROS::Struct.new("f6L2")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_L4C = ::ROS::Struct.new("L4C")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','string','string','calibration_msgs/CameraMeasurement[]','calibration_msgs/LaserMeasurement[]','calibration_msgs/ChainMeasurement[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :sample_id initialize value
  # @option args [string] :target_id initialize value
  # @option args [string] :chain_id initialize value
  # @option args [calibration_msgs/CameraMeasurement[]] :M_cam initialize value
  # @option args [calibration_msgs/LaserMeasurement[]] :M_laser initialize value
  # @option args [calibration_msgs/ChainMeasurement[]] :M_chain initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:sample_id]
      @sample_id = args[:sample_id]
    else
      @sample_id = ''
    end
    if args[:target_id]
      @target_id = args[:target_id]
    else
      @target_id = ''
    end
    if args[:chain_id]
      @chain_id = args[:chain_id]
    else
      @chain_id = ''
    end
    if args[:M_cam]
      @M_cam = args[:M_cam]
    else
      @M_cam = []
    end
    if args[:M_laser]
      @M_laser = args[:M_laser]
    else
      @M_laser = []
    end
    if args[:M_chain]
      @M_chain = args[:M_chain]
    else
      @M_chain = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @sample_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @target_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @chain_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @M_cam.length
      buff.write(@@struct_L.pack(length))
      for val1 in @M_cam
        _v227 = val1.header
        buff.write(@@struct_L.pack(_v227.seq))
        _v228 = _v227.stamp
        _x = _v228
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v227.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.camera_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.image_points.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.image_points
          _x = val2
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        _v229 = val1.cam_info
        _v230 = _v229.header
        buff.write(@@struct_L.pack(_v230.seq))
        _v231 = _v230.stamp
        _x = _v231
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v230.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v229
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        _x = _v229.distortion_model
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v229.D.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v229.D.pack(pattern))
        buff.write(@@struct_d9.pack(*_v229.K))
        buff.write(@@struct_d9.pack(*_v229.R))
        buff.write(@@struct_d12.pack(*_v229.P))
        _x = _v229
        buff.write(@@struct_L2.pack(_x.binning_x, _x.binning_y))
        _v232 = _v229.roi
        _x = _v232
        buff.write(@@struct_L4C.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
        buff.write(@@struct_C.pack(val1.verbose))
        _v233 = val1.image
        _v234 = _v233.header
        buff.write(@@struct_L.pack(_v234.seq))
        _v235 = _v234.stamp
        _x = _v235
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v234.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v233
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        _x = _v233.encoding
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v233
        buff.write(@@struct_CL.pack(_x.is_bigendian, _x.step))
        _x = _v233.data
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v236 = val1.image_rect
        _v237 = _v236.header
        buff.write(@@struct_L.pack(_v237.seq))
        _v238 = _v237.stamp
        _x = _v238
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v237.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v236
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        _x = _v236.encoding
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v236
        buff.write(@@struct_CL.pack(_x.is_bigendian, _x.step))
        _x = _v236.data
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v239 = val1.features
        _v240 = _v239.header
        buff.write(@@struct_L.pack(_v240.seq))
        _v241 = _v240.stamp
        _x = _v241
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v240.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v239.object_points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v239.object_points
          _x = val3
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        length = _v239.image_points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v239.image_points
          _x = val3
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        buff.write(@@struct_C.pack(_v239.success))
      end
      length = @M_laser.length
      buff.write(@@struct_L.pack(length))
      for val1 in @M_laser
        _v242 = val1.header
        buff.write(@@struct_L.pack(_v242.seq))
        _v243 = _v242.stamp
        _x = _v243
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v242.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.laser_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.joint_points.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.joint_points
          _v244 = val2.header
          buff.write(@@struct_L.pack(_v244.seq))
          _v245 = _v244.stamp
          _x = _v245
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v244.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          length = val2.name.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.name
            length = val3.length
            buff.write([length, val3].pack("La#{length}"))
          end
          length = val2.position.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val2.position.pack(pattern))
          length = val2.velocity.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val2.velocity.pack(pattern))
          length = val2.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val2.effort.pack(pattern))
        end
        buff.write(@@struct_C.pack(val1.verbose))
        _v246 = val1.snapshot
        _v247 = _v246.header
        buff.write(@@struct_L.pack(_v247.seq))
        _v248 = _v247.stamp
        _x = _v248
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v247.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v246
        buff.write(@@struct_f6L2.pack(_x.angle_min, _x.angle_max, _x.angle_increment, _x.time_increment, _x.range_min, _x.range_max, _x.readings_per_scan, _x.num_scans))
        length = _v246.ranges.length
        buff.write(@@struct_L.pack(length))
        pattern = "f#{length}"
        buff.write(*_v246.ranges.pack(pattern))
        length = _v246.intensities.length
        buff.write(@@struct_L.pack(length))
        pattern = "f#{length}"
        buff.write(*_v246.intensities.pack(pattern))
        length = _v246.scan_start.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v246.scan_start
          _x = val3
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        end
        _v249 = val1.laser_image
        _v250 = _v249.header
        buff.write(@@struct_L.pack(_v250.seq))
        _v251 = _v250.stamp
        _x = _v251
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v250.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v249
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        _x = _v249.encoding
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v249
        buff.write(@@struct_CL.pack(_x.is_bigendian, _x.step))
        _x = _v249.data
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v252 = val1.image_features
        _v253 = _v252.header
        buff.write(@@struct_L.pack(_v253.seq))
        _v254 = _v253.stamp
        _x = _v254
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v253.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v252.object_points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v252.object_points
          _x = val3
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        length = _v252.image_points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v252.image_points
          _x = val3
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        buff.write(@@struct_C.pack(_v252.success))
        _v255 = val1.joint_features
        _v256 = _v255.header
        buff.write(@@struct_L.pack(_v256.seq))
        _v257 = _v256.stamp
        _x = _v257
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v256.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v255.object_points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v255.object_points
          _x = val3
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        length = _v255.joint_points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v255.joint_points
          _v258 = val3.header
          buff.write(@@struct_L.pack(_v258.seq))
          _v259 = _v258.stamp
          _x = _v259
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v258.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          length = val3.name.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.name
            length = val4.length
            buff.write([length, val4].pack("La#{length}"))
          end
          length = val3.position.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.position.pack(pattern))
          length = val3.velocity.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocity.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
        end
      end
      length = @M_chain.length
      buff.write(@@struct_L.pack(length))
      for val1 in @M_chain
        _v260 = val1.header
        buff.write(@@struct_L.pack(_v260.seq))
        _v261 = _v260.stamp
        _x = _v261
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v260.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.chain_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v262 = val1.chain_state
        _v263 = _v262.header
        buff.write(@@struct_L.pack(_v263.seq))
        _v264 = _v263.stamp
        _x = _v264
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v263.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v262.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v262.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v262.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v262.position.pack(pattern))
        length = _v262.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v262.velocity.pack(pattern))
        length = _v262.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v262.effort.pack(pattern))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @M_cam == nil
        @M_cam = Calibration_msgs::CameraMeasurement[].new
      end
      if @M_laser == nil
        @M_laser = Calibration_msgs::LaserMeasurement[].new
      end
      if @M_chain == nil
        @M_chain = Calibration_msgs::ChainMeasurement[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @sample_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @chain_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @M_cam = []
      length.times do
        val1 = Calibration_msgs::CameraMeasurement.new
        _v265 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v265.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v266 = _v265.stamp
        _x = _v266
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v265.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.camera_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.image_points = []
        length.times do
          val2 = Geometry_msgs::Point.new
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.image_points.push(val2)
        end
        _v267 = val1.cam_info
        _v268 = _v267.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v268.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v269 = _v268.stamp
        _x = _v269
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v268.frame_id = str[start..(end_point-1)]
        _x = _v267
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v267.distortion_model = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v267.D = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += ROS::Struct::calc_size('d9')
        _v267.K = @@struct_d9.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d9')
        _v267.R = @@struct_d9.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d12')
        _v267.P = @@struct_d12.unpack(str[start..(end_point-1)])
        _x = _v267
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.binning_x, _x.binning_y,) = @@struct_L2.unpack(str[start..(end_point-1)])
        _v270 = _v267.roi
        _x = _v270
        start = end_point
        end_point += ROS::Struct::calc_size('L4C')
        (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = @@struct_L4C.unpack(str[start..(end_point-1)])
        _v270.do_rectify = bool(_v270.do_rectify)
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (val1.verbose,) = @@struct_C.unpack(str[start..(end_point-1)])
        val1.verbose = bool(val1.verbose)
        _v271 = val1.image
        _v272 = _v271.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v272.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v273 = _v272.stamp
        _x = _v273
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v272.frame_id = str[start..(end_point-1)]
        _x = _v271
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v271.encoding = str[start..(end_point-1)]
        _x = _v271
        start = end_point
        end_point += ROS::Struct::calc_size('CL')
        (_x.is_bigendian, _x.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v271.data = str[start..(end_point-1)]
        _v274 = val1.image_rect
        _v275 = _v274.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v275.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v276 = _v275.stamp
        _x = _v276
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v275.frame_id = str[start..(end_point-1)]
        _x = _v274
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v274.encoding = str[start..(end_point-1)]
        _x = _v274
        start = end_point
        end_point += ROS::Struct::calc_size('CL')
        (_x.is_bigendian, _x.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v274.data = str[start..(end_point-1)]
        _v277 = val1.features
        _v278 = _v277.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v278.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v279 = _v278.stamp
        _x = _v279
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v278.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v277.object_points = []
        length.times do
          val3 = Geometry_msgs::Point.new
          _x = val3
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v277.object_points.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v277.image_points = []
        length.times do
          val3 = Geometry_msgs::Point.new
          _x = val3
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v277.image_points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (_v277.success,) = @@struct_C.unpack(str[start..(end_point-1)])
        @M_cam.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @M_laser = []
      length.times do
        val1 = Calibration_msgs::LaserMeasurement.new
        _v280 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v280.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v281 = _v280.stamp
        _x = _v281
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v280.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.laser_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.joint_points = []
        length.times do
          val2 = Sensor_msgs::JointState.new
          _v282 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v282.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v283 = _v282.stamp
          _x = _v283
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v282.frame_id = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.name = []
          length.times do
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += length
            val3 = str[start..(end_point-1)]
            val2.name.push(val3)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val2.position = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val2.velocity = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val2.effort = str[start..(end_point-1)].unpack(pattern)
          val1.joint_points.push(val2)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (val1.verbose,) = @@struct_C.unpack(str[start..(end_point-1)])
        val1.verbose = bool(val1.verbose)
        _v284 = val1.snapshot
        _v285 = _v284.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v285.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v286 = _v285.stamp
        _x = _v286
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v285.frame_id = str[start..(end_point-1)]
        _x = _v284
        start = end_point
        end_point += ROS::Struct::calc_size('f6L2')
        (_x.angle_min, _x.angle_max, _x.angle_increment, _x.time_increment, _x.range_min, _x.range_max, _x.readings_per_scan, _x.num_scans,) = @@struct_f6L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "f#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v284.ranges = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "f#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v284.intensities = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v284.scan_start = []
        length.times do
          val3 = ROS::Time.new
          _x = val3
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          _v284.scan_start.push(val3)
        end
        _v287 = val1.laser_image
        _v288 = _v287.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v288.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v289 = _v288.stamp
        _x = _v289
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v288.frame_id = str[start..(end_point-1)]
        _x = _v287
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v287.encoding = str[start..(end_point-1)]
        _x = _v287
        start = end_point
        end_point += ROS::Struct::calc_size('CL')
        (_x.is_bigendian, _x.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v287.data = str[start..(end_point-1)]
        _v290 = val1.image_features
        _v291 = _v290.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v291.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v292 = _v291.stamp
        _x = _v292
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v291.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v290.object_points = []
        length.times do
          val3 = Geometry_msgs::Point.new
          _x = val3
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v290.object_points.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v290.image_points = []
        length.times do
          val3 = Geometry_msgs::Point.new
          _x = val3
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v290.image_points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (_v290.success,) = @@struct_C.unpack(str[start..(end_point-1)])
        _v293 = val1.joint_features
        _v294 = _v293.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v294.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v295 = _v294.stamp
        _x = _v295
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v294.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v293.object_points = []
        length.times do
          val3 = Geometry_msgs::Point.new
          _x = val3
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v293.object_points.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v293.joint_points = []
        length.times do
          val3 = Sensor_msgs::JointState.new
          _v296 = val3.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v296.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v297 = _v296.stamp
          _x = _v297
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v296.frame_id = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.name = []
          length.times do
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += length
            val4 = str[start..(end_point-1)]
            val3.name.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.position = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocity = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v293.joint_points.push(val3)
        end
        @M_laser.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @M_chain = []
      length.times do
        val1 = Calibration_msgs::ChainMeasurement.new
        _v298 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v298.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v299 = _v298.stamp
        _x = _v299
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v298.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.chain_id = str[start..(end_point-1)]
        _v300 = val1.chain_state
        _v301 = _v300.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v301.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v302 = _v301.stamp
        _x = _v302
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v301.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v300.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v300.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v300.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v300.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v300.effort = str[start..(end_point-1)].unpack(pattern)
        @M_chain.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
