# autogenerated by genrb from GetPoseStampedTransformedRequest.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Point"
require "geometry_msgs/Pose"
require "geometry_msgs/PoseStamped"

module Cob_srvs

class GetPoseStampedTransformedRequest <::ROS::Message
  def self.md5sum
    "7f6050054c7441aa5c8e1b131c78c448"
  end

  def self.type
    "cob_srvs/GetPoseStampedTransformedRequest"
  end

  def has_header?
    false
  end

  def message_definition
    "geometry_msgs/PoseStamped target
geometry_msgs/PoseStamped origin
geometry_msgs/Quaternion  orientation_override
string root_name
string tip_name

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :target, :origin, :orientation_override, :root_name, :tip_name

  @@struct_d11 = ::ROS::Struct.new("d11")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d7L3 = ::ROS::Struct.new("d7L3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['geometry_msgs/PoseStamped','geometry_msgs/PoseStamped','geometry_msgs/Quaternion','string','string']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [geometry_msgs/PoseStamped] :target initialize value
  # @option args [geometry_msgs/PoseStamped] :origin initialize value
  # @option args [geometry_msgs/Quaternion] :orientation_override initialize value
  # @option args [string] :root_name initialize value
  # @option args [string] :tip_name initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:target]
      @target = args[:target]
    else
      @target = Geometry_msgs::PoseStamped.new
    end
    if args[:origin]
      @origin = args[:origin]
    else
      @origin = Geometry_msgs::PoseStamped.new
    end
    if args[:orientation_override]
      @orientation_override = args[:orientation_override]
    else
      @orientation_override = Geometry_msgs::Quaternion.new
    end
    if args[:root_name]
      @root_name = args[:root_name]
    else
      @root_name = ''
    end
    if args[:tip_name]
      @tip_name = args[:tip_name]
    else
      @tip_name = ''
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@target.header.seq, @target.header.stamp.secs, @target.header.stamp.nsecs))
      _x = @target.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7L3.pack(@target.pose.position.x, @target.pose.position.y, @target.pose.position.z, @target.pose.orientation.x, @target.pose.orientation.y, @target.pose.orientation.z, @target.pose.orientation.w, @origin.header.seq, @origin.header.stamp.secs, @origin.header.stamp.nsecs))
      _x = @origin.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d11.pack(@origin.pose.position.x, @origin.pose.position.y, @origin.pose.position.z, @origin.pose.orientation.x, @origin.pose.orientation.y, @origin.pose.orientation.z, @origin.pose.orientation.w, @orientation_override.x, @orientation_override.y, @orientation_override.z, @orientation_override.w))
      _x = @root_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @tip_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @target == nil
        @target = Geometry_msgs::PoseStamped.new
      end
      if @origin == nil
        @origin = Geometry_msgs::PoseStamped.new
      end
      if @orientation_override == nil
        @orientation_override = Geometry_msgs::Quaternion.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@target.header.seq, @target.header.stamp.secs, @target.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7L3')
      (@target.pose.position.x, @target.pose.position.y, @target.pose.position.z, @target.pose.orientation.x, @target.pose.orientation.y, @target.pose.orientation.z, @target.pose.orientation.w, @origin.header.seq, @origin.header.stamp.secs, @origin.header.stamp.nsecs,) = @@struct_d7L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @origin.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d11')
      (@origin.pose.position.x, @origin.pose.position.y, @origin.pose.position.z, @origin.pose.orientation.x, @origin.pose.orientation.y, @origin.pose.orientation.z, @origin.pose.orientation.w, @orientation_override.x, @orientation_override.y, @orientation_override.z, @orientation_override.w,) = @@struct_d11.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @root_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @tip_name = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
# autogenerated by genrb from GetPoseStampedTransformedResponse.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Point"
require "geometry_msgs/Pose"
require "geometry_msgs/PoseStamped"

module Cob_srvs

class GetPoseStampedTransformedResponse <::ROS::Message
  def self.md5sum
    "aa1ecfaaa2557395e49e336255c7a317"
  end

  def self.type
    "cob_srvs/GetPoseStampedTransformedResponse"
  end

  def has_header?
    false
  end

  def message_definition
    "bool success
geometry_msgs/PoseStamped result


================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :success, :result

  @@struct_d7 = ::ROS::Struct.new("d7")
  @@struct_CL3 = ::ROS::Struct.new("CL3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['bool','geometry_msgs/PoseStamped']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [bool] :success initialize value
  # @option args [geometry_msgs/PoseStamped] :result initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:success]
      @success = args[:success]
    else
      @success = false
    end
    if args[:result]
      @result = args[:result]
    else
      @result = Geometry_msgs::PoseStamped.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_CL3.pack(@success, @result.header.seq, @result.header.stamp.secs, @result.header.stamp.nsecs))
      _x = @result.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7.pack(@result.pose.position.x, @result.pose.position.y, @result.pose.position.z, @result.pose.orientation.x, @result.pose.orientation.y, @result.pose.orientation.z, @result.pose.orientation.w))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @result == nil
        @result = Geometry_msgs::PoseStamped.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('CL3')
      (@success, @result.header.seq, @result.header.stamp.secs, @result.header.stamp.nsecs,) = @@struct_CL3.unpack(str[start..(end_point-1)])
      @success = bool(@success)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @result.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7')
      (@result.pose.position.x, @result.pose.position.y, @result.pose.position.z, @result.pose.orientation.x, @result.pose.orientation.y, @result.pose.orientation.z, @result.pose.orientation.w,) = @@struct_d7.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
module Cob_srvs
class GetPoseStampedTransformed
  def self.type
    'cob_srvs/GetPoseStampedTransformed'
  end
  def self.md5sum
    'ed0069a0a6ce5102fc39c3328eef052f'
  end
  def self.request_class
    GetPoseStampedTransformedRequest
  end
  def self.response_class
    GetPoseStampedTransformedResponse
  end
end
end