# autogenerated by genrb from ConcertClient.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "rocon_app_manager_msgs/App"
require "rocon_app_manager_msgs/Icon"
require "rocon_app_manager_msgs/PairingClient"
require "rocon_app_manager_msgs/KeyValue"

module Concert_msgs

class ConcertClient <::ROS::Message
  def self.md5sum
    "b3a232588ecbbea02126d208e1faa1a9"
  end

  def self.type
    "concert_msgs/ConcertClient"
  end

  def has_header?
    false
  end

  def message_definition
    "# 
# Describes a concert client - used only on the concert side
#
# Unique names - human consumable rocon name as well as global gateway name
string name
string gateway_name

# The platform id triple (refer to concert_clients/PlatformInfo.msg for string values)
string platform
string system
string robot

# Current status of the concert client (refer to concert_msgs/ConcertClient.msg for mode strings)
string client_status
string app_status

# Depracate this
string status

# Statistics
time last_connection_timestamp

rocon_app_manager_msgs/App[] apps

================================================================================
MSG: rocon_app_manager_msgs/App
# app name
string name
# user-friendly display name
string display_name
string description
string platform
string status

# icon for showing the app
Icon icon
#  ordered list (by preference) of pairing clients to interact with this robot app.
PairingClient[] pairing_clients
================================================================================
MSG: rocon_app_manager_msgs/Icon
# Image data format.  \"jpeg\" or \"png\"
string format

# Image data.
uint8[] data
================================================================================
MSG: rocon_app_manager_msgs/PairingClient
# like \"android\" or \"web\" or \"linux\"
string client_type

# like \"intent = ros.android.teleop\" and \"accelerometer = true\", used to choose which ClientApp to use
KeyValue[] manager_data

# parameters which just get passed through to the client app.
KeyValue[] app_data
================================================================================
MSG: rocon_app_manager_msgs/KeyValue
string key
string value
"
  end
  attr_accessor :name, :gateway_name, :platform, :system, :robot, :client_status, :app_status, :status, :last_connection_timestamp, :apps

  @@struct_L2 = ::ROS::Struct.new("L2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','string','string','string','string','string','string','string','time','rocon_app_manager_msgs/App[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :name initialize value
  # @option args [string] :gateway_name initialize value
  # @option args [string] :platform initialize value
  # @option args [string] :system initialize value
  # @option args [string] :robot initialize value
  # @option args [string] :client_status initialize value
  # @option args [string] :app_status initialize value
  # @option args [string] :status initialize value
  # @option args [time] :last_connection_timestamp initialize value
  # @option args [rocon_app_manager_msgs/App[]] :apps initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
    if args[:gateway_name]
      @gateway_name = args[:gateway_name]
    else
      @gateway_name = ''
    end
    if args[:platform]
      @platform = args[:platform]
    else
      @platform = ''
    end
    if args[:system]
      @system = args[:system]
    else
      @system = ''
    end
    if args[:robot]
      @robot = args[:robot]
    else
      @robot = ''
    end
    if args[:client_status]
      @client_status = args[:client_status]
    else
      @client_status = ''
    end
    if args[:app_status]
      @app_status = args[:app_status]
    else
      @app_status = ''
    end
    if args[:status]
      @status = args[:status]
    else
      @status = ''
    end
    if args[:last_connection_timestamp]
      @last_connection_timestamp = args[:last_connection_timestamp]
    else
      @last_connection_timestamp = ROS::Time.new
    end
    if args[:apps]
      @apps = args[:apps]
    else
      @apps = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @gateway_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @platform
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @system
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @robot
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @client_status
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @app_status
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @status
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@last_connection_timestamp.secs, @last_connection_timestamp.nsecs))
      length = @apps.length
      buff.write(@@struct_L.pack(length))
      for val1 in @apps
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.display_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.description
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.platform
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.status
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v175 = val1.icon
        _x = _v175.format
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v175.data
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.pairing_clients.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.pairing_clients
          _x = val2.client_type
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          length = val2.manager_data.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.manager_data
            _x = val3.key
            length = _x.length
            buff.write([length, _x].pack("La#{length}"))
            _x = val3.value
            length = _x.length
            buff.write([length, _x].pack("La#{length}"))
          end
          length = val2.app_data.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.app_data
            _x = val3.key
            length = _x.length
            buff.write([length, _x].pack("La#{length}"))
            _x = val3.value
            length = _x.length
            buff.write([length, _x].pack("La#{length}"))
          end
        end
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @last_connection_timestamp == nil
        @last_connection_timestamp = ROS::Time.new
      end
      if @apps == nil
        @apps = Rocon_app_manager_msgs::App[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @gateway_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @platform = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @system = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @robot = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @client_status = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @app_status = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @status = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@last_connection_timestamp.secs, @last_connection_timestamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @apps = []
      length.times do
        val1 = Rocon_app_manager_msgs::App.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.display_name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.description = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.platform = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.status = str[start..(end_point-1)]
        _v176 = val1.icon
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v176.format = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v176.data = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.pairing_clients = []
        length.times do
          val2 = Rocon_app_manager_msgs::PairingClient.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.client_type = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.manager_data = []
          length.times do
            val3 = Rocon_app_manager_msgs::KeyValue.new
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += length
            val3.key = str[start..(end_point-1)]
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += length
            val3.value = str[start..(end_point-1)]
            val2.manager_data.push(val3)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.app_data = []
          length.times do
            val3 = Rocon_app_manager_msgs::KeyValue.new
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += length
            val3.key = str[start..(end_point-1)]
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += length
            val3.value = str[start..(end_point-1)]
            val2.app_data.push(val3)
          end
          val1.pairing_clients.push(val2)
        end
        @apps.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
