# autogenerated by genrb from ConcertClients.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "concert_msgs/ConcertClient"
require "rocon_app_manager_msgs/PairingClient"
require "rocon_app_manager_msgs/KeyValue"
require "rocon_app_manager_msgs/App"
require "rocon_app_manager_msgs/Icon"

module Concert_msgs

class ConcertClients <::ROS::Message
  def self.md5sum
    "9572afe4f30b1567d33f03cf448620a8"
  end

  def self.type
    "concert_msgs/ConcertClients"
  end

  def has_header?
    false
  end

  def message_definition
    "# 
# List of ConcertClient's.
#
concert_msgs/ConcertClient[] clients

================================================================================
MSG: concert_msgs/ConcertClient
# 
# Describes a concert client - used only on the concert side
#
# Unique names - human consumable rocon name as well as global gateway name
string name
string gateway_name

# The platform id triple (refer to concert_clients/PlatformInfo.msg for string values)
string platform
string system
string robot

# Current status of the concert client (refer to concert_msgs/ConcertClient.msg for mode strings)
string client_status
string app_status

# Depracate this
string status

# Statistics
time last_connection_timestamp

rocon_app_manager_msgs/App[] apps

================================================================================
MSG: rocon_app_manager_msgs/App
# app name
string name
# user-friendly display name
string display_name
string description
string platform
string status

# icon for showing the app
Icon icon
#  ordered list (by preference) of pairing clients to interact with this robot app.
PairingClient[] pairing_clients
================================================================================
MSG: rocon_app_manager_msgs/Icon
# Image data format.  \"jpeg\" or \"png\"
string format

# Image data.
uint8[] data
================================================================================
MSG: rocon_app_manager_msgs/PairingClient
# like \"android\" or \"web\" or \"linux\"
string client_type

# like \"intent = ros.android.teleop\" and \"accelerometer = true\", used to choose which ClientApp to use
KeyValue[] manager_data

# parameters which just get passed through to the client app.
KeyValue[] app_data
================================================================================
MSG: rocon_app_manager_msgs/KeyValue
string key
string value
"
  end
  attr_accessor :clients

  @@struct_L2 = ::ROS::Struct.new("L2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['concert_msgs/ConcertClient[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [concert_msgs/ConcertClient[]] :clients initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:clients]
      @clients = args[:clients]
    else
      @clients = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      length = @clients.length
      buff.write(@@struct_L.pack(length))
      for val1 in @clients
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.gateway_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.platform
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.system
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.robot
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.client_status
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.app_status
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.status
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v177 = val1.last_connection_timestamp
        _x = _v177
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        length = val1.apps.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.apps
          _x = val2.name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.display_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.description
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.platform
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.status
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v178 = val2.icon
          _x = _v178.format
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = _v178.data
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          length = val2.pairing_clients.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.pairing_clients
            _x = val3.client_type
            length = _x.length
            buff.write([length, _x].pack("La#{length}"))
            length = val3.manager_data.length
            buff.write(@@struct_L.pack(length))
            for val4 in val3.manager_data
              _x = val4.key
              length = _x.length
              buff.write([length, _x].pack("La#{length}"))
              _x = val4.value
              length = _x.length
              buff.write([length, _x].pack("La#{length}"))
            end
            length = val3.app_data.length
            buff.write(@@struct_L.pack(length))
            for val4 in val3.app_data
              _x = val4.key
              length = _x.length
              buff.write([length, _x].pack("La#{length}"))
              _x = val4.value
              length = _x.length
              buff.write([length, _x].pack("La#{length}"))
            end
          end
        end
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @clients == nil
        @clients = Concert_msgs::ConcertClient[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @clients = []
      length.times do
        val1 = Concert_msgs::ConcertClient.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.gateway_name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.platform = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.system = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.robot = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.client_status = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.app_status = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.status = str[start..(end_point-1)]
        _v179 = val1.last_connection_timestamp
        _x = _v179
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.apps = []
        length.times do
          val2 = Rocon_app_manager_msgs::App.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.name = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.display_name = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.description = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.platform = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.status = str[start..(end_point-1)]
          _v180 = val2.icon
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v180.format = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v180.data = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.pairing_clients = []
          length.times do
            val3 = Rocon_app_manager_msgs::PairingClient.new
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += length
            val3.client_type = str[start..(end_point-1)]
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val3.manager_data = []
            length.times do
              val4 = Rocon_app_manager_msgs::KeyValue.new
              start = end_point
              end_point += 4
              (length,) = @@struct_L.unpack(str[start..(end_point-1)])
              start = end_point
              end_point += length
              val4.key = str[start..(end_point-1)]
              start = end_point
              end_point += 4
              (length,) = @@struct_L.unpack(str[start..(end_point-1)])
              start = end_point
              end_point += length
              val4.value = str[start..(end_point-1)]
              val3.manager_data.push(val4)
            end
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val3.app_data = []
            length.times do
              val4 = Rocon_app_manager_msgs::KeyValue.new
              start = end_point
              end_point += 4
              (length,) = @@struct_L.unpack(str[start..(end_point-1)])
              start = end_point
              end_point += length
              val4.key = str[start..(end_point-1)]
              start = end_point
              end_point += 4
              (length,) = @@struct_L.unpack(str[start..(end_point-1)])
              start = end_point
              end_point += length
              val4.value = str[start..(end_point-1)]
              val3.app_data.push(val4)
            end
            val2.pairing_clients.push(val3)
          end
          val1.apps.push(val2)
        end
        @clients.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
