# autogenerated by genrb from Implementation.msg. Do not edit.
require 'ros/message'

require "concert_msgs/LinkNode"
require "concert_msgs/LinkEdge"
require "concert_msgs/LinkGraph"
require "concert_msgs/LinkConnection"

module Concert_msgs

class Implementation <::ROS::Message
  def self.md5sum
    "aeb0655c516d030025a8fe13f0998166"
  end

  def self.type
    "concert_msgs/Implementation"
  end

  def has_header?
    false
  end

  def message_definition
    "string name
LinkGraph link_graph
string dot_graph

================================================================================
MSG: concert_msgs/LinkGraph
# A list of 'named' nodes, e.g. linux.ros.robosem.rocon_teleop

LinkNode[] nodes
LinkConnection[] topics
LinkConnection[] actions
LinkEdge[] edges

================================================================================
MSG: concert_msgs/LinkNode
# Representation of a concert client node in the implementation graph

# unique identifier
string id

# tuple representing the client node - platform.system.robot.app, e.g. linux.ros.turtlebot.turtle_stroll
string tuple

# Constraints on how many of these nodes may exist
#   min, max not set -> min = 1, max = 1
#   min not set -> min = 1
#   max not set -> max = UNLIMITED_RESOURCE
# Zero is a valid minimum value
int8 UNLIMITED_RESOURCE=-1
int8 min
int8 max

# Force matching of robot name (only really useful for demos)
bool force_name_matching
================================================================================
MSG: concert_msgs/LinkConnection
# Representation of a topic/action node in the 
# implementation graph

# unique identifier
string id
# type of the topic, e.g. std_msgs/String
string type

================================================================================
MSG: concert_msgs/LinkEdge
# Edge of the implementation graph. Client-Topic, or 
# Topic-Client or Client-Action or Action-Client

string start
string finish
string remap_from
string remap_to
"
  end
  attr_accessor :name, :link_graph, :dot_graph

  @@struct_c2C = ::ROS::Struct.new("c2C")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','concert_msgs/LinkGraph','string']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :name initialize value
  # @option args [concert_msgs/LinkGraph] :link_graph initialize value
  # @option args [string] :dot_graph initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
    if args[:link_graph]
      @link_graph = args[:link_graph]
    else
      @link_graph = Concert_msgs::LinkGraph.new
    end
    if args[:dot_graph]
      @dot_graph = args[:dot_graph]
    else
      @dot_graph = ''
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @link_graph.nodes.length
      buff.write(@@struct_L.pack(length))
      for val1 in @link_graph.nodes
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.tuple
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_c2C.pack(_x.min, _x.max, _x.force_name_matching))
      end
      length = @link_graph.topics.length
      buff.write(@@struct_L.pack(length))
      for val1 in @link_graph.topics
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      length = @link_graph.actions.length
      buff.write(@@struct_L.pack(length))
      for val1 in @link_graph.actions
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      length = @link_graph.edges.length
      buff.write(@@struct_L.pack(length))
      for val1 in @link_graph.edges
        _x = val1.start
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.finish
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.remap_from
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.remap_to
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      _x = @dot_graph
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @link_graph == nil
        @link_graph = Concert_msgs::LinkGraph.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @link_graph.nodes = []
      length.times do
        val1 = Concert_msgs::LinkNode.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.tuple = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('c2C')
        (_x.min, _x.max, _x.force_name_matching,) = @@struct_c2C.unpack(str[start..(end_point-1)])
        val1.force_name_matching = bool(val1.force_name_matching)
        @link_graph.nodes.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @link_graph.topics = []
      length.times do
        val1 = Concert_msgs::LinkConnection.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.type = str[start..(end_point-1)]
        @link_graph.topics.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @link_graph.actions = []
      length.times do
        val1 = Concert_msgs::LinkConnection.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.type = str[start..(end_point-1)]
        @link_graph.actions.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @link_graph.edges = []
      length.times do
        val1 = Concert_msgs::LinkEdge.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.start = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.finish = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.remap_from = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.remap_to = str[start..(end_point-1)]
        @link_graph.edges.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @dot_graph = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
