# autogenerated by genrb from LinkGraph.msg. Do not edit.
require 'ros/message'

require "concert_msgs/LinkNode"
require "concert_msgs/LinkEdge"
require "concert_msgs/LinkConnection"

module Concert_msgs

class LinkGraph <::ROS::Message
  def self.md5sum
    "6b8d2cdce844002beff4e2b35b1567e2"
  end

  def self.type
    "concert_msgs/LinkGraph"
  end

  def has_header?
    false
  end

  def message_definition
    "# A list of 'named' nodes, e.g. linux.ros.robosem.rocon_teleop

LinkNode[] nodes
LinkConnection[] topics
LinkConnection[] actions
LinkEdge[] edges

================================================================================
MSG: concert_msgs/LinkNode
# Representation of a concert client node in the implementation graph

# unique identifier
string id

# tuple representing the client node - platform.system.robot.app, e.g. linux.ros.turtlebot.turtle_stroll
string tuple

# Constraints on how many of these nodes may exist
#   min, max not set -> min = 1, max = 1
#   min not set -> min = 1
#   max not set -> max = UNLIMITED_RESOURCE
# Zero is a valid minimum value
int8 UNLIMITED_RESOURCE=-1
int8 min
int8 max

# Force matching of robot name (only really useful for demos)
bool force_name_matching
================================================================================
MSG: concert_msgs/LinkConnection
# Representation of a topic/action node in the 
# implementation graph

# unique identifier
string id
# type of the topic, e.g. std_msgs/String
string type

================================================================================
MSG: concert_msgs/LinkEdge
# Edge of the implementation graph. Client-Topic, or 
# Topic-Client or Client-Action or Action-Client

string start
string finish
string remap_from
string remap_to
"
  end
  attr_accessor :nodes, :topics, :actions, :edges

  @@struct_c2C = ::ROS::Struct.new("c2C")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['concert_msgs/LinkNode[]','concert_msgs/LinkConnection[]','concert_msgs/LinkConnection[]','concert_msgs/LinkEdge[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [concert_msgs/LinkNode[]] :nodes initialize value
  # @option args [concert_msgs/LinkConnection[]] :topics initialize value
  # @option args [concert_msgs/LinkConnection[]] :actions initialize value
  # @option args [concert_msgs/LinkEdge[]] :edges initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:nodes]
      @nodes = args[:nodes]
    else
      @nodes = []
    end
    if args[:topics]
      @topics = args[:topics]
    else
      @topics = []
    end
    if args[:actions]
      @actions = args[:actions]
    else
      @actions = []
    end
    if args[:edges]
      @edges = args[:edges]
    else
      @edges = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      length = @nodes.length
      buff.write(@@struct_L.pack(length))
      for val1 in @nodes
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.tuple
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_c2C.pack(_x.min, _x.max, _x.force_name_matching))
      end
      length = @topics.length
      buff.write(@@struct_L.pack(length))
      for val1 in @topics
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      length = @actions.length
      buff.write(@@struct_L.pack(length))
      for val1 in @actions
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      length = @edges.length
      buff.write(@@struct_L.pack(length))
      for val1 in @edges
        _x = val1.start
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.finish
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.remap_from
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.remap_to
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @nodes == nil
        @nodes = Concert_msgs::LinkNode[].new
      end
      if @topics == nil
        @topics = Concert_msgs::LinkConnection[].new
      end
      if @actions == nil
        @actions = Concert_msgs::LinkConnection[].new
      end
      if @edges == nil
        @edges = Concert_msgs::LinkEdge[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @nodes = []
      length.times do
        val1 = Concert_msgs::LinkNode.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.tuple = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('c2C')
        (_x.min, _x.max, _x.force_name_matching,) = @@struct_c2C.unpack(str[start..(end_point-1)])
        val1.force_name_matching = bool(val1.force_name_matching)
        @nodes.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @topics = []
      length.times do
        val1 = Concert_msgs::LinkConnection.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.type = str[start..(end_point-1)]
        @topics.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @actions = []
      length.times do
        val1 = Concert_msgs::LinkConnection.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.type = str[start..(end_point-1)]
        @actions.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @edges = []
      length.times do
        val1 = Concert_msgs::LinkEdge.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.start = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.finish = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.remap_from = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.remap_to = str[start..(end_point-1)]
        @edges.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
