# autogenerated by genrb from JointTolerance.msg. Do not edit.
require 'ros/message'


module Control_msgs

class JointTolerance <::ROS::Message
  def self.md5sum
    "f544fe9c16cf04547e135dd6063ff5be"
  end

  def self.type
    "control_msgs/JointTolerance"
  end

  def has_header?
    false
  end

  def message_definition
    "# The tolerances specify the amount the position, velocity, and
# accelerations can vary from the setpoints.  For example, in the case
# of trajectory control, when the actual position varies beyond
# (desired position + position tolerance), the trajectory goal may
# abort.
# 
# There are two special values for tolerances:
#  * 0 - The tolerance is unspecified and will remain at whatever the default is
#  * -1 - The tolerance is \"erased\".  If there was a default, the joint will be
#         allowed to move without restriction.

string name
float64 position  # in radians or meters (for a revolute or prismatic joint, respectively)
float64 velocity  # in rad/sec or m/sec
float64 acceleration  # in rad/sec^2 or m/sec^2

"
  end
  attr_accessor :name, :position, :velocity, :acceleration

  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','float64','float64','float64']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :name initialize value
  # @option args [float64] :position initialize value
  # @option args [float64] :velocity initialize value
  # @option args [float64] :acceleration initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
    if args[:position]
      @position = args[:position]
    else
      @position = 0.0
    end
    if args[:velocity]
      @velocity = args[:velocity]
    else
      @velocity = 0.0
    end
    if args[:acceleration]
      @acceleration = args[:acceleration]
    else
      @acceleration = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3.pack(@position, @velocity, @acceleration))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3')
      (@position, @velocity, @acceleration,) = @@struct_d3.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
