# autogenerated by genrb from PointHeadActionGoal.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "geometry_msgs/PointStamped"
require "ros/duration"
require "std_msgs/Header"
require "actionlib_msgs/GoalID"
require "geometry_msgs/Point"
require "geometry_msgs/Vector3"
require "control_msgs/PointHeadGoal"

module Control_msgs

class PointHeadActionGoal <::ROS::Message
  def self.md5sum
    "b53a8323d0ba7b310ba17a2d3a82a6b8"
  end

  def self.type
    "control_msgs/PointHeadActionGoal"
  end

  def has_header?
    true
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalID goal_id
PointHeadGoal goal

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: control_msgs/PointHeadGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
geometry_msgs/PointStamped target
geometry_msgs/Vector3 pointing_axis
string pointing_frame
duration min_duration
float64 max_velocity

================================================================================
MSG: geometry_msgs/PointStamped
# This represents a Point with reference coordinate frame and timestamp
Header header
Point point

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :header, :goal_id, :goal

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d6 = ::ROS::Struct.new("d6")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_l2d = ::ROS::Struct.new("l2d")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','actionlib_msgs/GoalID','control_msgs/PointHeadGoal']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [actionlib_msgs/GoalID] :goal_id initialize value
  # @option args [control_msgs/PointHeadGoal] :goal initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:goal_id]
      @goal_id = args[:goal_id]
    else
      @goal_id = Actionlib_msgs::GoalID.new
    end
    if args[:goal]
      @goal = args[:goal]
    else
      @goal = Control_msgs::PointHeadGoal.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@goal_id.stamp.secs, @goal_id.stamp.nsecs))
      _x = @goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@goal.target.header.seq, @goal.target.header.stamp.secs, @goal.target.header.stamp.nsecs))
      _x = @goal.target.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d6.pack(@goal.target.point.x, @goal.target.point.y, @goal.target.point.z, @goal.pointing_axis.x, @goal.pointing_axis.y, @goal.pointing_axis.z))
      _x = @goal.pointing_frame
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_l2d.pack(@goal.min_duration.secs, @goal.min_duration.nsecs, @goal.max_velocity))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @goal_id == nil
        @goal_id = Actionlib_msgs::GoalID.new
      end
      if @goal == nil
        @goal = Control_msgs::PointHeadGoal.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@goal_id.stamp.secs, @goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@goal.target.header.seq, @goal.target.header.stamp.secs, @goal.target.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d6')
      (@goal.target.point.x, @goal.target.point.y, @goal.target.point.z, @goal.pointing_axis.x, @goal.pointing_axis.y, @goal.pointing_axis.z,) = @@struct_d6.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.pointing_frame = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('l2d')
      (@goal.min_duration.secs, @goal.min_duration.nsecs, @goal.max_velocity,) = @@struct_l2d.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
