# autogenerated by genrb from ControllersStatistics.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "ros/time"
require "ros/duration"
require "controller_manager_msgs/ControllerStatistics"

module Controller_manager_msgs

class ControllersStatistics <::ROS::Message
  def self.md5sum
    "a154c347736773e3700d1719105df29d"
  end

  def self.type
    "controller_manager_msgs/ControllersStatistics"
  end

  def has_header?
    true
  end

  def message_definition
    "std_msgs/Header header
controller_manager_msgs/ControllerStatistics[] controller

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: controller_manager_msgs/ControllerStatistics
# This message contains the state of one realtime controller
# that was spawned in the controller manager

# the name of the controller
string name

# the type of the controller
string type

# the time at which these controller statistics were measured
time timestamp

# bool that indicates if the controller is currently
# in a running or a stopped state
bool running

# the maximum time the update loop of the controller ever needed to complete
duration max_time

# the average time the update loop of the controller needs to complete.
# the average is computed in a sliding time window.
duration mean_time

# the variance on the time the update loop of the controller needs to complete.
# the variance applies to a sliding time window.
duration variance_time

# the number of times this controller broke the realtime loop
int32 num_control_loop_overruns

# the timestamp of the last time this controller broke the realtime loop
time time_last_control_loop_overrun
"
  end
  attr_accessor :header, :controller

  @@struct_l = ::ROS::Struct.new("l")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_l2 = ::ROS::Struct.new("l2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','controller_manager_msgs/ControllerStatistics[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [controller_manager_msgs/ControllerStatistics[]] :controller initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:controller]
      @controller = args[:controller]
    else
      @controller = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @controller.length
      buff.write(@@struct_L.pack(length))
      for val1 in @controller
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v319 = val1.timestamp
        _x = _v319
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        buff.write(@@struct_C.pack(val1.running))
        _v320 = val1.max_time
        _x = _v320
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        _v321 = val1.mean_time
        _x = _v321
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        _v322 = val1.variance_time
        _x = _v322
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        buff.write(@@struct_l.pack(val1.num_control_loop_overruns))
        _v323 = val1.time_last_control_loop_overrun
        _x = _v323
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @controller == nil
        @controller = Controller_manager_msgs::ControllerStatistics[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @controller = []
      length.times do
        val1 = Controller_manager_msgs::ControllerStatistics.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.type = str[start..(end_point-1)]
        _v324 = val1.timestamp
        _x = _v324
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (val1.running,) = @@struct_C.unpack(str[start..(end_point-1)])
        val1.running = bool(val1.running)
        _v325 = val1.max_time
        _x = _v325
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        _v326 = val1.mean_time
        _x = _v326
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        _v327 = val1.variance_time
        _x = _v327
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('l')
        (val1.num_control_loop_overruns,) = @@struct_l.unpack(str[start..(end_point-1)])
        _v328 = val1.time_last_control_loop_overrun
        _x = _v328
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        @controller.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
