# autogenerated by genrb from DiagnosticArray.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "diagnostic_msgs/KeyValue"
require "diagnostic_msgs/DiagnosticStatus"

module Diagnostic_msgs

class DiagnosticArray <::ROS::Message
  def self.md5sum
    "3cfbeff055e708a24c3d946a5c8139cd"
  end

  def self.type
    "diagnostic_msgs/DiagnosticArray"
  end

  def has_header?
    true
  end

  def message_definition
    "# This message is used to send diagnostic information about the state of the robot
Header header #for timestamp
DiagnosticStatus[] status # an array of components being reported on
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: diagnostic_msgs/DiagnosticStatus
# This message holds the status of an individual component of the robot.
# 

# Possible levels of operations
byte OK=0
byte WARN=1
byte ERROR=2

byte level # level of operation enumerated above 
string name # a description of the test/component reporting
string message # a description of the status
string hardware_id # a hardware unique string
KeyValue[] values # an array of values associated with the status


================================================================================
MSG: diagnostic_msgs/KeyValue
string key # what to label this value when viewing
string value # a value to track over time

"
  end
  attr_accessor :header, :status

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_c = ::ROS::Struct.new("c")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','diagnostic_msgs/DiagnosticStatus[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [diagnostic_msgs/DiagnosticStatus[]] :status initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:status]
      @status = args[:status]
    else
      @status = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @status.length
      buff.write(@@struct_L.pack(length))
      for val1 in @status
        buff.write(@@struct_c.pack(val1.level))
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.message
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.hardware_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.values.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.values
          _x = val2.key
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.value
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
        end
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @status == nil
        @status = Diagnostic_msgs::DiagnosticStatus[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @status = []
      length.times do
        val1 = Diagnostic_msgs::DiagnosticStatus.new
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (val1.level,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.message = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.hardware_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.values = []
        length.times do
          val2 = Diagnostic_msgs::KeyValue.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.key = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.value = str[start..(end_point-1)]
          val1.values.push(val2)
        end
        @status.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
