# autogenerated by genrb from JointState.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"

module Dynamixel_msgs

class JointState <::ROS::Message
  def self.md5sum
    "2b8449320cde76616338e2539db27c32"
  end

  def self.type
    "dynamixel_msgs/JointState"
  end

  def has_header?
    true
  end

  def message_definition
    "Header header
string name         # joint name
int32[] motor_ids   # motor ids controlling this joint
int32[] motor_temps # motor temperatures, same order as motor_ids

float64 goal_pos    # commanded position (in radians)
float64 current_pos # current joint position (in radians)
float64 error       # error between commanded and current positions (in radians)
float64 velocity    # current joint speed (in radians per second)
float64 load        # current load
bool is_moving      # is joint currently in motion


================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  attr_accessor :header, :name, :motor_ids, :motor_temps, :goal_pos, :current_pos, :error, :velocity, :load, :is_moving

  @@struct_d5C = ::ROS::Struct.new("d5C")
  @@struct_L3 = ::ROS::Struct.new("L3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','string','int32[]','int32[]','float64','float64','float64','float64','float64','bool']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [string] :name initialize value
  # @option args [int32[]] :motor_ids initialize value
  # @option args [int32[]] :motor_temps initialize value
  # @option args [float64] :goal_pos initialize value
  # @option args [float64] :current_pos initialize value
  # @option args [float64] :error initialize value
  # @option args [float64] :velocity initialize value
  # @option args [float64] :load initialize value
  # @option args [bool] :is_moving initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
    if args[:motor_ids]
      @motor_ids = args[:motor_ids]
    else
      @motor_ids = []
    end
    if args[:motor_temps]
      @motor_temps = args[:motor_temps]
    else
      @motor_temps = []
    end
    if args[:goal_pos]
      @goal_pos = args[:goal_pos]
    else
      @goal_pos = 0.0
    end
    if args[:current_pos]
      @current_pos = args[:current_pos]
    else
      @current_pos = 0.0
    end
    if args[:error]
      @error = args[:error]
    else
      @error = 0.0
    end
    if args[:velocity]
      @velocity = args[:velocity]
    else
      @velocity = 0.0
    end
    if args[:load]
      @load = args[:load]
    else
      @load = 0.0
    end
    if args[:is_moving]
      @is_moving = args[:is_moving]
    else
      @is_moving = false
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @motor_ids.length
      buff.write(@@struct_L.pack(length))
      pattern = "l#{length}"
      buff.write(*@motor_ids.pack(pattern))
      length = @motor_temps.length
      buff.write(@@struct_L.pack(length))
      pattern = "l#{length}"
      buff.write(*@motor_temps.pack(pattern))
      buff.write(@@struct_d5C.pack(@goal_pos, @current_pos, @error, @velocity, @load, @is_moving))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "l#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @motor_ids = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "l#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @motor_temps = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('d5C')
      (@goal_pos, @current_pos, @error, @velocity, @load, @is_moving,) = @@struct_d5C.unpack(str[start..(end_point-1)])
      @is_moving = bool(@is_moving)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
