# autogenerated by genrb from MotorState.msg. Do not edit.
require 'ros/message'


module Dynamixel_msgs

class MotorState <::ROS::Message
  def self.md5sum
    "1cefdc3ff0c7d52e475886024476b74d"
  end

  def self.type
    "dynamixel_msgs/MotorState"
  end

  def has_header?
    false
  end

  def message_definition
    "float64 timestamp   # motor state is at this time
int32 id            # motor id
int32 goal          # commanded position (in encoder units)
int32 position      # current position (in encoder units)
int32 error         # difference between current and goal positions
int32 speed         # current speed (0.111 rpm per unit)
float64 load        # current load - ratio of applied torque over maximum torque
float64 voltage     # current voltage (V)
int32 temperature   # current temperature (degrees Celsius)
bool moving         # whether the motor is currently in motion

"
  end
  attr_accessor :timestamp, :id, :goal, :position, :error, :speed, :load, :voltage, :temperature, :moving

  @@struct_dl5d2lC = ::ROS::Struct.new("dl5d2lC")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['float64','int32','int32','int32','int32','int32','float64','float64','int32','bool']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [float64] :timestamp initialize value
  # @option args [int32] :id initialize value
  # @option args [int32] :goal initialize value
  # @option args [int32] :position initialize value
  # @option args [int32] :error initialize value
  # @option args [int32] :speed initialize value
  # @option args [float64] :load initialize value
  # @option args [float64] :voltage initialize value
  # @option args [int32] :temperature initialize value
  # @option args [bool] :moving initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:timestamp]
      @timestamp = args[:timestamp]
    else
      @timestamp = 0.0
    end
    if args[:id]
      @id = args[:id]
    else
      @id = 0
    end
    if args[:goal]
      @goal = args[:goal]
    else
      @goal = 0
    end
    if args[:position]
      @position = args[:position]
    else
      @position = 0
    end
    if args[:error]
      @error = args[:error]
    else
      @error = 0
    end
    if args[:speed]
      @speed = args[:speed]
    else
      @speed = 0
    end
    if args[:load]
      @load = args[:load]
    else
      @load = 0.0
    end
    if args[:voltage]
      @voltage = args[:voltage]
    else
      @voltage = 0.0
    end
    if args[:temperature]
      @temperature = args[:temperature]
    else
      @temperature = 0
    end
    if args[:moving]
      @moving = args[:moving]
    else
      @moving = false
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_dl5d2lC.pack(@timestamp, @id, @goal, @position, @error, @speed, @load, @voltage, @temperature, @moving))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('dl5d2lC')
      (@timestamp, @id, @goal, @position, @error, @speed, @load, @voltage, @temperature, @moving,) = @@struct_dl5d2lC.unpack(str[start..(end_point-1)])
      @moving = bool(@moving)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
