# autogenerated by genrb from GatewayInfo.msg. Do not edit.
require 'ros/message'

require "gateway_msgs/RemoteRule"
require "gateway_msgs/Rule"

module Gateway_msgs

class GatewayInfo <::ROS::Message
  def self.md5sum
    "dd256c395b10a23239961795b562f6bd"
  end

  def self.type
    "gateway_msgs/GatewayInfo"
  end

  def has_header?
    false
  end

  def message_definition
    "###### Gateway information ######

# Gateway parameters
string name
bool connected
string ip

# Hub parameters
string[] hub_names
string[] hub_uris

bool firewall

###### Public Interface ######

Rule[] public_watchlist
Rule[] public_interface

###### Flipped Interface ######

RemoteRule[] flipped_connections
RemoteRule[] flip_watchlist
RemoteRule[] flipped_in_connections

###### Pulled Interface ######

RemoteRule[] pull_watchlist
RemoteRule[] pulled_connections


================================================================================
MSG: gateway_msgs/Rule
# Standard gateway connection rule

# type of connection (from gateway_msgs.msg.Connection)
string type

# this is the topic/service name or the action base name (a regex is supported)
string name 

# (optional) an optional node name can be provided. if node name is not provided
# then all nodes are matched (also supports regex)
string node

================================================================================
MSG: gateway_msgs/RemoteRule
# Definition for a flip. It represents either:
#
# 1) an existing flipped connection (from the local gateway)
# 2) a rule that is put on a watchlist

# The target recipient of the flip
string gateway

# Connection has the following parameters that need setting
# - name : fully qualified name of the connection (str)
# - type : connection type (str)
#  
# Use one of the types defined in Connection string constants:
#     (publisher, subscriber, service, action_client, action_server)
#
# - node : name of the node it originates from (str)(optional)
#
# Node name is necessary, for instance, if you have multiple subscribers
# publishing to a single topic. Most of the time it is not necessary,
# but in some cases it helps refine the rule. It helps refine the rule.
#
Rule rule

"
  end
  attr_accessor :name, :connected, :ip, :hub_names, :hub_uris, :firewall, :public_watchlist, :public_interface, :flipped_connections, :flip_watchlist, :flipped_in_connections, :pull_watchlist, :pulled_connections

  @@struct_C = ::ROS::Struct.new("C")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','bool','string','string[]','string[]','bool','gateway_msgs/Rule[]','gateway_msgs/Rule[]','gateway_msgs/RemoteRule[]','gateway_msgs/RemoteRule[]','gateway_msgs/RemoteRule[]','gateway_msgs/RemoteRule[]','gateway_msgs/RemoteRule[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :name initialize value
  # @option args [bool] :connected initialize value
  # @option args [string] :ip initialize value
  # @option args [string[]] :hub_names initialize value
  # @option args [string[]] :hub_uris initialize value
  # @option args [bool] :firewall initialize value
  # @option args [gateway_msgs/Rule[]] :public_watchlist initialize value
  # @option args [gateway_msgs/Rule[]] :public_interface initialize value
  # @option args [gateway_msgs/RemoteRule[]] :flipped_connections initialize value
  # @option args [gateway_msgs/RemoteRule[]] :flip_watchlist initialize value
  # @option args [gateway_msgs/RemoteRule[]] :flipped_in_connections initialize value
  # @option args [gateway_msgs/RemoteRule[]] :pull_watchlist initialize value
  # @option args [gateway_msgs/RemoteRule[]] :pulled_connections initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
    if args[:connected]
      @connected = args[:connected]
    else
      @connected = false
    end
    if args[:ip]
      @ip = args[:ip]
    else
      @ip = ''
    end
    if args[:hub_names]
      @hub_names = args[:hub_names]
    else
      @hub_names = []
    end
    if args[:hub_uris]
      @hub_uris = args[:hub_uris]
    else
      @hub_uris = []
    end
    if args[:firewall]
      @firewall = args[:firewall]
    else
      @firewall = false
    end
    if args[:public_watchlist]
      @public_watchlist = args[:public_watchlist]
    else
      @public_watchlist = []
    end
    if args[:public_interface]
      @public_interface = args[:public_interface]
    else
      @public_interface = []
    end
    if args[:flipped_connections]
      @flipped_connections = args[:flipped_connections]
    else
      @flipped_connections = []
    end
    if args[:flip_watchlist]
      @flip_watchlist = args[:flip_watchlist]
    else
      @flip_watchlist = []
    end
    if args[:flipped_in_connections]
      @flipped_in_connections = args[:flipped_in_connections]
    else
      @flipped_in_connections = []
    end
    if args[:pull_watchlist]
      @pull_watchlist = args[:pull_watchlist]
    else
      @pull_watchlist = []
    end
    if args[:pulled_connections]
      @pulled_connections = args[:pulled_connections]
    else
      @pulled_connections = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@connected))
      _x = @ip
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @hub_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @hub_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @hub_uris.length
      buff.write(@@struct_L.pack(length))
      for val1 in @hub_uris
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      buff.write(@@struct_C.pack(@firewall))
      length = @public_watchlist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @public_watchlist
        _x = val1.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.node
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      length = @public_interface.length
      buff.write(@@struct_L.pack(length))
      for val1 in @public_interface
        _x = val1.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.node
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      length = @flipped_connections.length
      buff.write(@@struct_L.pack(length))
      for val1 in @flipped_connections
        _x = val1.gateway
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4499 = val1.rule
        _x = _v4499.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4499.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4499.node
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      length = @flip_watchlist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @flip_watchlist
        _x = val1.gateway
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4500 = val1.rule
        _x = _v4500.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4500.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4500.node
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      length = @flipped_in_connections.length
      buff.write(@@struct_L.pack(length))
      for val1 in @flipped_in_connections
        _x = val1.gateway
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4501 = val1.rule
        _x = _v4501.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4501.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4501.node
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      length = @pull_watchlist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @pull_watchlist
        _x = val1.gateway
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4502 = val1.rule
        _x = _v4502.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4502.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4502.node
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      length = @pulled_connections.length
      buff.write(@@struct_L.pack(length))
      for val1 in @pulled_connections
        _x = val1.gateway
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4503 = val1.rule
        _x = _v4503.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4503.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4503.node
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @public_watchlist == nil
        @public_watchlist = Gateway_msgs::Rule[].new
      end
      if @public_interface == nil
        @public_interface = Gateway_msgs::Rule[].new
      end
      if @flipped_connections == nil
        @flipped_connections = Gateway_msgs::RemoteRule[].new
      end
      if @flip_watchlist == nil
        @flip_watchlist = Gateway_msgs::RemoteRule[].new
      end
      if @flipped_in_connections == nil
        @flipped_in_connections = Gateway_msgs::RemoteRule[].new
      end
      if @pull_watchlist == nil
        @pull_watchlist = Gateway_msgs::RemoteRule[].new
      end
      if @pulled_connections == nil
        @pulled_connections = Gateway_msgs::RemoteRule[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@connected,) = @@struct_C.unpack(str[start..(end_point-1)])
      @connected = bool(@connected)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @ip = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @hub_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @hub_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @hub_uris = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @hub_uris.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@firewall,) = @@struct_C.unpack(str[start..(end_point-1)])
      @firewall = bool(@firewall)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @public_watchlist = []
      length.times do
        val1 = Gateway_msgs::Rule.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.type = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.node = str[start..(end_point-1)]
        @public_watchlist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @public_interface = []
      length.times do
        val1 = Gateway_msgs::Rule.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.type = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.node = str[start..(end_point-1)]
        @public_interface.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @flipped_connections = []
      length.times do
        val1 = Gateway_msgs::RemoteRule.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.gateway = str[start..(end_point-1)]
        _v4504 = val1.rule
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4504.type = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4504.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4504.node = str[start..(end_point-1)]
        @flipped_connections.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @flip_watchlist = []
      length.times do
        val1 = Gateway_msgs::RemoteRule.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.gateway = str[start..(end_point-1)]
        _v4505 = val1.rule
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4505.type = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4505.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4505.node = str[start..(end_point-1)]
        @flip_watchlist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @flipped_in_connections = []
      length.times do
        val1 = Gateway_msgs::RemoteRule.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.gateway = str[start..(end_point-1)]
        _v4506 = val1.rule
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4506.type = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4506.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4506.node = str[start..(end_point-1)]
        @flipped_in_connections.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @pull_watchlist = []
      length.times do
        val1 = Gateway_msgs::RemoteRule.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.gateway = str[start..(end_point-1)]
        _v4507 = val1.rule
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4507.type = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4507.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4507.node = str[start..(end_point-1)]
        @pull_watchlist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @pulled_connections = []
      length.times do
        val1 = Gateway_msgs::RemoteRule.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.gateway = str[start..(end_point-1)]
        _v4508 = val1.rule
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4508.type = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4508.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4508.node = str[start..(end_point-1)]
        @pulled_connections.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
