# autogenerated by genrb from RemoteRequest.msg. Do not edit.
require 'ros/message'

require "gateway_msgs/RemoteRule"
require "gateway_msgs/Rule"

module Gateway_msgs

class RemoteRequest <::ROS::Message
  def self.md5sum
    "e9d79fdaee662b9f88ad5ffedb506465"
  end

  def self.type
    "gateway_msgs/RemoteRequest"
  end

  def has_header?
    false
  end

  def message_definition
    "



RemoteRule[] remotes


bool cancel


================================================================================
MSG: gateway_msgs/RemoteRule
# Definition for a flip. It represents either:
#
# 1) an existing flipped connection (from the local gateway)
# 2) a rule that is put on a watchlist

# The target recipient of the flip
string gateway

# Connection has the following parameters that need setting
# - name : fully qualified name of the connection (str)
# - type : connection type (str)
#  
# Use one of the types defined in Connection string constants:
#     (publisher, subscriber, service, action_client, action_server)
#
# - node : name of the node it originates from (str)(optional)
#
# Node name is necessary, for instance, if you have multiple subscribers
# publishing to a single topic. Most of the time it is not necessary,
# but in some cases it helps refine the rule. It helps refine the rule.
#
Rule rule

================================================================================
MSG: gateway_msgs/Rule
# Standard gateway connection rule

# type of connection (from gateway_msgs.msg.Connection)
string type

# this is the topic/service name or the action base name (a regex is supported)
string name 

# (optional) an optional node name can be provided. if node name is not provided
# then all nodes are matched (also supports regex)
string node

"
  end
  attr_accessor :remotes, :cancel

  @@struct_C = ::ROS::Struct.new("C")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['gateway_msgs/RemoteRule[]','bool']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [gateway_msgs/RemoteRule[]] :remotes initialize value
  # @option args [bool] :cancel initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:remotes]
      @remotes = args[:remotes]
    else
      @remotes = []
    end
    if args[:cancel]
      @cancel = args[:cancel]
    else
      @cancel = false
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      length = @remotes.length
      buff.write(@@struct_L.pack(length))
      for val1 in @remotes
        _x = val1.gateway
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v5671 = val1.rule
        _x = _v5671.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v5671.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v5671.node
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      buff.write(@@struct_C.pack(@cancel))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @remotes == nil
        @remotes = Gateway_msgs::RemoteRule[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @remotes = []
      length.times do
        val1 = Gateway_msgs::RemoteRule.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.gateway = str[start..(end_point-1)]
        _v5672 = val1.rule
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v5672.type = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v5672.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v5672.node = str[start..(end_point-1)]
        @remotes.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@cancel,) = @@struct_C.unpack(str[start..(end_point-1)])
      @cancel = bool(@cancel)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
# autogenerated by genrb from RemoteResponse.msg. Do not edit.
require 'ros/message'


module Gateway_msgs

class RemoteResponse <::ROS::Message
  def self.md5sum
    "cb1e85ae0c5f4b1c31221493724cc5aa"
  end

  def self.type
    "gateway_msgs/RemoteResponse"
  end

  def has_header?
    false
  end

  def message_definition
    "


int8 result
string error_message



"
  end
  attr_accessor :result, :error_message

  @@struct_c = ::ROS::Struct.new("c")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['int8','string']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [int8] :result initialize value
  # @option args [string] :error_message initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:result]
      @result = args[:result]
    else
      @result = 0
    end
    if args[:error_message]
      @error_message = args[:error_message]
    else
      @error_message = ''
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_c.pack(@result))
      _x = @error_message
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('c')
      (@result,) = @@struct_c.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @error_message = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
module Gateway_msgs
class Remote
  def self.type
    'gateway_msgs/Remote'
  end
  def self.md5sum
    'd2170021bdea1c8bfca632d3d43a6993'
  end
  def self.request_class
    RemoteRequest
  end
  def self.response_class
    RemoteResponse
  end
end
end