# autogenerated by genrb from RemoteGateway.msg. Do not edit.
require 'ros/message'

require "gateway_msgs/RemoteRule"
require "gateway_msgs/Rule"

module Gateway_msgs

class RemoteGateway <::ROS::Message
  def self.md5sum
    "c2825a110d4bc0a2e94421a89778e5f4"
  end

  def self.type
    "gateway_msgs/RemoteGateway"
  end

  def has_header?
    false
  end

  def message_definition
    "###### Gateway information ######
string name
string ip
#TODO blocking status,health
bool firewall

###### Public Interface ######

Rule[] public_interface


###### Flipped Interface ######

# Flipped and pulled interfaces would be useful for debugging 
#    https://github.com/robotics-in-concert/rocon_multimaster/issues/84

RemoteRule[] flipped_interface
RemoteRule[] pulled_interface

###### Foreign Interface ######

# Q) Should we show these?
# A) Probably not, in the overall scheme of things, 
#    it doubles up the information from above

# RemoteRule[] flipped_in_connections
# RemoteRule[] pulled_connections

================================================================================
MSG: gateway_msgs/Rule
# Standard gateway connection rule

# type of connection (from gateway_msgs.msg.Connection)
string type

# this is the topic/service name or the action base name (a regex is supported)
string name 

# (optional) an optional node name can be provided. if node name is not provided
# then all nodes are matched (also supports regex)
string node

================================================================================
MSG: gateway_msgs/RemoteRule
# Definition for a flip. It represents either:
#
# 1) an existing flipped connection (from the local gateway)
# 2) a rule that is put on a watchlist

# The target recipient of the flip
string gateway

# Connection has the following parameters that need setting
# - name : fully qualified name of the connection (str)
# - type : connection type (str)
#  
# Use one of the types defined in Connection string constants:
#     (publisher, subscriber, service, action_client, action_server)
#
# - node : name of the node it originates from (str)(optional)
#
# Node name is necessary, for instance, if you have multiple subscribers
# publishing to a single topic. Most of the time it is not necessary,
# but in some cases it helps refine the rule. It helps refine the rule.
#
Rule rule

"
  end
  attr_accessor :name, :ip, :firewall, :public_interface, :flipped_interface, :pulled_interface

  @@struct_C = ::ROS::Struct.new("C")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','string','bool','gateway_msgs/Rule[]','gateway_msgs/RemoteRule[]','gateway_msgs/RemoteRule[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :name initialize value
  # @option args [string] :ip initialize value
  # @option args [bool] :firewall initialize value
  # @option args [gateway_msgs/Rule[]] :public_interface initialize value
  # @option args [gateway_msgs/RemoteRule[]] :flipped_interface initialize value
  # @option args [gateway_msgs/RemoteRule[]] :pulled_interface initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
    if args[:ip]
      @ip = args[:ip]
    else
      @ip = ''
    end
    if args[:firewall]
      @firewall = args[:firewall]
    else
      @firewall = false
    end
    if args[:public_interface]
      @public_interface = args[:public_interface]
    else
      @public_interface = []
    end
    if args[:flipped_interface]
      @flipped_interface = args[:flipped_interface]
    else
      @flipped_interface = []
    end
    if args[:pulled_interface]
      @pulled_interface = args[:pulled_interface]
    else
      @pulled_interface = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @ip
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@firewall))
      length = @public_interface.length
      buff.write(@@struct_L.pack(length))
      for val1 in @public_interface
        _x = val1.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.node
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      length = @flipped_interface.length
      buff.write(@@struct_L.pack(length))
      for val1 in @flipped_interface
        _x = val1.gateway
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4509 = val1.rule
        _x = _v4509.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4509.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4509.node
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      length = @pulled_interface.length
      buff.write(@@struct_L.pack(length))
      for val1 in @pulled_interface
        _x = val1.gateway
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4510 = val1.rule
        _x = _v4510.type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4510.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4510.node
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @public_interface == nil
        @public_interface = Gateway_msgs::Rule[].new
      end
      if @flipped_interface == nil
        @flipped_interface = Gateway_msgs::RemoteRule[].new
      end
      if @pulled_interface == nil
        @pulled_interface = Gateway_msgs::RemoteRule[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @ip = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@firewall,) = @@struct_C.unpack(str[start..(end_point-1)])
      @firewall = bool(@firewall)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @public_interface = []
      length.times do
        val1 = Gateway_msgs::Rule.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.type = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.node = str[start..(end_point-1)]
        @public_interface.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @flipped_interface = []
      length.times do
        val1 = Gateway_msgs::RemoteRule.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.gateway = str[start..(end_point-1)]
        _v4511 = val1.rule
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4511.type = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4511.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4511.node = str[start..(end_point-1)]
        @flipped_interface.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @pulled_interface = []
      length.times do
        val1 = Gateway_msgs::RemoteRule.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.gateway = str[start..(end_point-1)]
        _v4512 = val1.rule
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4512.type = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4512.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4512.node = str[start..(end_point-1)]
        @pulled_interface.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
