# autogenerated by genrb from RemoteRule.msg. Do not edit.
require 'ros/message'

require "gateway_msgs/Rule"

module Gateway_msgs

class RemoteRule <::ROS::Message
  def self.md5sum
    "14f4c5aaf33b32b22c50fd514747f99f"
  end

  def self.type
    "gateway_msgs/RemoteRule"
  end

  def has_header?
    false
  end

  def message_definition
    "# Definition for a flip. It represents either:
#
# 1) an existing flipped connection (from the local gateway)
# 2) a rule that is put on a watchlist

# The target recipient of the flip
string gateway

# Connection has the following parameters that need setting
# - name : fully qualified name of the connection (str)
# - type : connection type (str)
#  
# Use one of the types defined in Connection string constants:
#     (publisher, subscriber, service, action_client, action_server)
#
# - node : name of the node it originates from (str)(optional)
#
# Node name is necessary, for instance, if you have multiple subscribers
# publishing to a single topic. Most of the time it is not necessary,
# but in some cases it helps refine the rule. It helps refine the rule.
#
Rule rule

================================================================================
MSG: gateway_msgs/Rule
# Standard gateway connection rule

# type of connection (from gateway_msgs.msg.Connection)
string type

# this is the topic/service name or the action base name (a regex is supported)
string name 

# (optional) an optional node name can be provided. if node name is not provided
# then all nodes are matched (also supports regex)
string node

"
  end
  attr_accessor :gateway, :rule


  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','gateway_msgs/Rule']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :gateway initialize value
  # @option args [gateway_msgs/Rule] :rule initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:gateway]
      @gateway = args[:gateway]
    else
      @gateway = ''
    end
    if args[:rule]
      @rule = args[:rule]
    else
      @rule = Gateway_msgs::Rule.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @gateway
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @rule.type
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @rule.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @rule.node
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @rule == nil
        @rule = Gateway_msgs::Rule.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @gateway = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @rule.type = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @rule.name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @rule.node = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
