# autogenerated by genrb from ContactState.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Vector3"
require "geometry_msgs/Wrench"

module Gazebo_msgs

class ContactState <::ROS::Message
  def self.md5sum
    "48c0ffb054b8c444f870cecea1ee50d9"
  end

  def self.type
    "gazebo_msgs/ContactState"
  end

  def has_header?
    false
  end

  def message_definition
    "string info                                   # text info on this contact
string collision1_name                        # name of contact collision1
string collision2_name                        # name of contact collision2
geometry_msgs/Wrench[] wrenches               # list of forces/torques
geometry_msgs/Wrench total_wrench             # sum of forces/torques in every DOF
geometry_msgs/Vector3[] contact_positions     # list of contact position
geometry_msgs/Vector3[] contact_normals       # list of contact normals
float64[] depths                              # list of penetration depths

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :info, :collision1_name, :collision2_name, :wrenches, :total_wrench, :contact_positions, :contact_normals, :depths

  @@struct_d6 = ::ROS::Struct.new("d6")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','string','string','geometry_msgs/Wrench[]','geometry_msgs/Wrench','geometry_msgs/Vector3[]','geometry_msgs/Vector3[]','float64[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :info initialize value
  # @option args [string] :collision1_name initialize value
  # @option args [string] :collision2_name initialize value
  # @option args [geometry_msgs/Wrench[]] :wrenches initialize value
  # @option args [geometry_msgs/Wrench] :total_wrench initialize value
  # @option args [geometry_msgs/Vector3[]] :contact_positions initialize value
  # @option args [geometry_msgs/Vector3[]] :contact_normals initialize value
  # @option args [float64[]] :depths initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:info]
      @info = args[:info]
    else
      @info = ''
    end
    if args[:collision1_name]
      @collision1_name = args[:collision1_name]
    else
      @collision1_name = ''
    end
    if args[:collision2_name]
      @collision2_name = args[:collision2_name]
    else
      @collision2_name = ''
    end
    if args[:wrenches]
      @wrenches = args[:wrenches]
    else
      @wrenches = []
    end
    if args[:total_wrench]
      @total_wrench = args[:total_wrench]
    else
      @total_wrench = Geometry_msgs::Wrench.new
    end
    if args[:contact_positions]
      @contact_positions = args[:contact_positions]
    else
      @contact_positions = []
    end
    if args[:contact_normals]
      @contact_normals = args[:contact_normals]
    else
      @contact_normals = []
    end
    if args[:depths]
      @depths = args[:depths]
    else
      @depths = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @info
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @collision1_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @collision2_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @wrenches.length
      buff.write(@@struct_L.pack(length))
      for val1 in @wrenches
        _v3725 = val1.force
        _x = _v3725
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3726 = val1.torque
        _x = _v3726
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      buff.write(@@struct_d6.pack(@total_wrench.force.x, @total_wrench.force.y, @total_wrench.force.z, @total_wrench.torque.x, @total_wrench.torque.y, @total_wrench.torque.z))
      length = @contact_positions.length
      buff.write(@@struct_L.pack(length))
      for val1 in @contact_positions
        _x = val1
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @contact_normals.length
      buff.write(@@struct_L.pack(length))
      for val1 in @contact_normals
        _x = val1
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @depths.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@depths.pack(pattern))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @wrenches == nil
        @wrenches = Geometry_msgs::Wrench[].new
      end
      if @total_wrench == nil
        @total_wrench = Geometry_msgs::Wrench.new
      end
      if @contact_positions == nil
        @contact_positions = Geometry_msgs::Vector3[].new
      end
      if @contact_normals == nil
        @contact_normals = Geometry_msgs::Vector3[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @info = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @collision1_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @collision2_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @wrenches = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v3727 = val1.force
        _x = _v3727
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3728 = val1.torque
        _x = _v3728
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @wrenches.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('d6')
      (@total_wrench.force.x, @total_wrench.force.y, @total_wrench.force.z, @total_wrench.torque.x, @total_wrench.torque.y, @total_wrench.torque.z,) = @@struct_d6.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @contact_positions = []
      length.times do
        val1 = Geometry_msgs::Vector3.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @contact_positions.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @contact_normals = []
      length.times do
        val1 = Geometry_msgs::Vector3.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @contact_normals.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @depths = str[start..(end_point-1)].unpack(pattern)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
