# autogenerated by genrb from ContactsState.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "gazebo_msgs/ContactState"
require "geometry_msgs/Wrench"
require "geometry_msgs/Vector3"

module Gazebo_msgs

class ContactsState <::ROS::Message
  def self.md5sum
    "acbcb1601a8e525bf72509f18e6f668d"
  end

  def self.type
    "gazebo_msgs/ContactsState"
  end

  def has_header?
    true
  end

  def message_definition
    "Header header                                   # stamp
gazebo_msgs/ContactState[] states            # array of geom pairs in contact

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: gazebo_msgs/ContactState
string info                                   # text info on this contact
string collision1_name                        # name of contact collision1
string collision2_name                        # name of contact collision2
geometry_msgs/Wrench[] wrenches               # list of forces/torques
geometry_msgs/Wrench total_wrench             # sum of forces/torques in every DOF
geometry_msgs/Vector3[] contact_positions     # list of contact position
geometry_msgs/Vector3[] contact_normals       # list of contact normals
float64[] depths                              # list of penetration depths

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :header, :states

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','gazebo_msgs/ContactState[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [gazebo_msgs/ContactState[]] :states initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:states]
      @states = args[:states]
    else
      @states = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @states.length
      buff.write(@@struct_L.pack(length))
      for val1 in @states
        _x = val1.info
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.collision1_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.collision2_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.wrenches.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.wrenches
          _v3729 = val2.force
          _x = _v3729
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v3730 = val2.torque
          _x = _v3730
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        _v3731 = val1.total_wrench
        _v3732 = _v3731.force
        _x = _v3732
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3733 = _v3731.torque
        _x = _v3733
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        length = val1.contact_positions.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.contact_positions
          _x = val2
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        length = val1.contact_normals.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.contact_normals
          _x = val2
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        length = val1.depths.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.depths.pack(pattern))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @states == nil
        @states = Gazebo_msgs::ContactState[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @states = []
      length.times do
        val1 = Gazebo_msgs::ContactState.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.info = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.collision1_name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.collision2_name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.wrenches = []
        length.times do
          val2 = Geometry_msgs::Wrench.new
          _v3734 = val2.force
          _x = _v3734
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v3735 = val2.torque
          _x = _v3735
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.wrenches.push(val2)
        end
        _v3736 = val1.total_wrench
        _v3737 = _v3736.force
        _x = _v3737
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3738 = _v3736.torque
        _x = _v3738
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.contact_positions = []
        length.times do
          val2 = Geometry_msgs::Vector3.new
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.contact_positions.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.contact_normals = []
        length.times do
          val2 = Geometry_msgs::Vector3.new
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.contact_normals.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.depths = str[start..(end_point-1)].unpack(pattern)
        @states.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
