# autogenerated by genrb from LinkState.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Quaternion"
require "geometry_msgs/Point"
require "geometry_msgs/Twist"
require "geometry_msgs/Vector3"
require "geometry_msgs/Pose"

module Gazebo_msgs

class LinkState <::ROS::Message
  def self.md5sum
    "0818ebbf28ce3a08d48ab1eaa7309ebe"
  end

  def self.type
    "gazebo_msgs/LinkState"
  end

  def has_header?
    false
  end

  def message_definition
    "# @todo: FIXME: sets pose and twist of a link.  All children link poses/twists of the URDF tree are not updated accordingly, but should be.
string link_name            # link name, link_names are in gazebo scoped name notation, [model_name::body_name]
geometry_msgs/Pose pose     # desired pose in reference frame
geometry_msgs/Twist twist   # desired twist in reference frame
string reference_frame      # set pose/twist relative to the frame of this link/body
                            # leave empty or \"world\" or \"map\" defaults to world-frame

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :link_name, :pose, :twist, :reference_frame

  @@struct_d13 = ::ROS::Struct.new("d13")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','geometry_msgs/Pose','geometry_msgs/Twist','string']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :link_name initialize value
  # @option args [geometry_msgs/Pose] :pose initialize value
  # @option args [geometry_msgs/Twist] :twist initialize value
  # @option args [string] :reference_frame initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:link_name]
      @link_name = args[:link_name]
    else
      @link_name = ''
    end
    if args[:pose]
      @pose = args[:pose]
    else
      @pose = Geometry_msgs::Pose.new
    end
    if args[:twist]
      @twist = args[:twist]
    else
      @twist = Geometry_msgs::Twist.new
    end
    if args[:reference_frame]
      @reference_frame = args[:reference_frame]
    else
      @reference_frame = ''
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @link_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d13.pack(@pose.position.x, @pose.position.y, @pose.position.z, @pose.orientation.x, @pose.orientation.y, @pose.orientation.z, @pose.orientation.w, @twist.linear.x, @twist.linear.y, @twist.linear.z, @twist.angular.x, @twist.angular.y, @twist.angular.z))
      _x = @reference_frame
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @pose == nil
        @pose = Geometry_msgs::Pose.new
      end
      if @twist == nil
        @twist = Geometry_msgs::Twist.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @link_name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d13')
      (@pose.position.x, @pose.position.y, @pose.position.z, @pose.orientation.x, @pose.orientation.y, @pose.orientation.z, @pose.orientation.w, @twist.linear.x, @twist.linear.y, @twist.linear.z, @twist.angular.x, @twist.angular.y, @twist.angular.z,) = @@struct_d13.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @reference_frame = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
