# autogenerated by genrb from ModelStates.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Quaternion"
require "geometry_msgs/Point"
require "geometry_msgs/Twist"
require "geometry_msgs/Vector3"
require "geometry_msgs/Pose"

module Gazebo_msgs

class ModelStates <::ROS::Message
  def self.md5sum
    "48c080191eb15c41858319b4d8a609c2"
  end

  def self.type
    "gazebo_msgs/ModelStates"
  end

  def has_header?
    false
  end

  def message_definition
    "# broadcast all model states in world frame
string[] name                 # model names
geometry_msgs/Pose[] pose     # desired pose in world frame
geometry_msgs/Twist[] twist   # desired twist in world frame

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :name, :pose, :twist

  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string[]','geometry_msgs/Pose[]','geometry_msgs/Twist[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string[]] :name initialize value
  # @option args [geometry_msgs/Pose[]] :pose initialize value
  # @option args [geometry_msgs/Twist[]] :twist initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:name]
      @name = args[:name]
    else
      @name = []
    end
    if args[:pose]
      @pose = args[:pose]
    else
      @pose = []
    end
    if args[:twist]
      @twist = args[:twist]
    else
      @twist = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      length = @name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @pose.length
      buff.write(@@struct_L.pack(length))
      for val1 in @pose
        _v3747 = val1.position
        _x = _v3747
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3748 = val1.orientation
        _x = _v3748
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @twist
        _v3749 = val1.linear
        _x = _v3749
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3750 = val1.angular
        _x = _v3750
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @pose == nil
        @pose = Geometry_msgs::Pose[].new
      end
      if @twist == nil
        @twist = Geometry_msgs::Twist[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @pose = []
      length.times do
        val1 = Geometry_msgs::Pose.new
        _v3751 = val1.position
        _x = _v3751
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3752 = val1.orientation
        _x = _v3752
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @pose.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v3753 = val1.linear
        _x = _v3753
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3754 = val1.angular
        _x = _v3754
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @twist.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
