# autogenerated by genrb from SetPhysicsPropertiesRequest.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Vector3"
require "gazebo_msgs/ODEPhysics"

module Gazebo_msgs

class SetPhysicsPropertiesRequest <::ROS::Message
  def self.md5sum
    "abd9f82732b52b92e9d6bb36e6a82452"
  end

  def self.type
    "gazebo_msgs/SetPhysicsPropertiesRequest"
  end

  def has_header?
    false
  end

  def message_definition
    "
float64 time_step
float64 max_update_rate
geometry_msgs/Vector3 gravity
gazebo_msgs/ODEPhysics ode_config

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: gazebo_msgs/ODEPhysics
bool auto_disable_bodies           # enable auto disabling of bodies, default false
uint32 sor_pgs_precon_iters        # preconditioning inner iterations when uisng projected Gauss Seidel
uint32 sor_pgs_iters               # inner iterations when uisng projected Gauss Seidel
float64 sor_pgs_w                  # relaxation parameter when using projected Gauss Seidel, 1 = no relaxation
float64 sor_pgs_rms_error_tol      # rms error tolerance before stopping inner iterations
float64 contact_surface_layer      # contact \"dead-band\" width
float64 contact_max_correcting_vel # contact maximum correction velocity
float64 cfm                        # global constraint force mixing
float64 erp                        # global error reduction parameter
uint32 max_contacts                # maximum contact joints between two geoms

"
  end
  attr_accessor :time_step, :max_update_rate, :gravity, :ode_config

  @@struct_d5CL2d6L = ::ROS::Struct.new("d5CL2d6L")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['float64','float64','geometry_msgs/Vector3','gazebo_msgs/ODEPhysics']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [float64] :time_step initialize value
  # @option args [float64] :max_update_rate initialize value
  # @option args [geometry_msgs/Vector3] :gravity initialize value
  # @option args [gazebo_msgs/ODEPhysics] :ode_config initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:time_step]
      @time_step = args[:time_step]
    else
      @time_step = 0.0
    end
    if args[:max_update_rate]
      @max_update_rate = args[:max_update_rate]
    else
      @max_update_rate = 0.0
    end
    if args[:gravity]
      @gravity = args[:gravity]
    else
      @gravity = Geometry_msgs::Vector3.new
    end
    if args[:ode_config]
      @ode_config = args[:ode_config]
    else
      @ode_config = Gazebo_msgs::ODEPhysics.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_d5CL2d6L.pack(@time_step, @max_update_rate, @gravity.x, @gravity.y, @gravity.z, @ode_config.auto_disable_bodies, @ode_config.sor_pgs_precon_iters, @ode_config.sor_pgs_iters, @ode_config.sor_pgs_w, @ode_config.sor_pgs_rms_error_tol, @ode_config.contact_surface_layer, @ode_config.contact_max_correcting_vel, @ode_config.cfm, @ode_config.erp, @ode_config.max_contacts))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @gravity == nil
        @gravity = Geometry_msgs::Vector3.new
      end
      if @ode_config == nil
        @ode_config = Gazebo_msgs::ODEPhysics.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('d5CL2d6L')
      (@time_step, @max_update_rate, @gravity.x, @gravity.y, @gravity.z, @ode_config.auto_disable_bodies, @ode_config.sor_pgs_precon_iters, @ode_config.sor_pgs_iters, @ode_config.sor_pgs_w, @ode_config.sor_pgs_rms_error_tol, @ode_config.contact_surface_layer, @ode_config.contact_max_correcting_vel, @ode_config.cfm, @ode_config.erp, @ode_config.max_contacts,) = @@struct_d5CL2d6L.unpack(str[start..(end_point-1)])
      @ode_config.auto_disable_bodies = bool(@ode_config.auto_disable_bodies)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
# autogenerated by genrb from SetPhysicsPropertiesResponse.msg. Do not edit.
require 'ros/message'


module Gazebo_msgs

class SetPhysicsPropertiesResponse <::ROS::Message
  def self.md5sum
    "2ec6f3eff0161f4257b808b12bc830c2"
  end

  def self.type
    "gazebo_msgs/SetPhysicsPropertiesResponse"
  end

  def has_header?
    false
  end

  def message_definition
    "bool success
string status_message


"
  end
  attr_accessor :success, :status_message

  @@struct_C = ::ROS::Struct.new("C")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['bool','string']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [bool] :success initialize value
  # @option args [string] :status_message initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:success]
      @success = args[:success]
    else
      @success = false
    end
    if args[:status_message]
      @status_message = args[:status_message]
    else
      @status_message = ''
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_C.pack(@success))
      _x = @status_message
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@success,) = @@struct_C.unpack(str[start..(end_point-1)])
      @success = bool(@success)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @status_message = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
module Gazebo_msgs
class SetPhysicsProperties
  def self.type
    'gazebo_msgs/SetPhysicsProperties'
  end
  def self.md5sum
    '97e2057080558ce4730434b5fae75c91'
  end
  def self.request_class
    SetPhysicsPropertiesRequest
  end
  def self.response_class
    SetPhysicsPropertiesResponse
  end
end
end