# autogenerated by genrb from BoundingBox.msg. Do not edit.
require 'ros/message'

require "geographic_msgs/GeoPoint"

module Geographic_msgs

class BoundingBox <::ROS::Message
  def self.md5sum
    "f62e8b5e390a3ac7603250d46e8f8446"
  end

  def self.type
    "geographic_msgs/BoundingBox"
  end

  def has_header?
    false
  end

  def message_definition
    "# Geographic map bounding box. 
#
# The two GeoPoints denote diagonally opposite corners of the box.
#
# If min_pt.latitude is NaN, the bounding box is \"global\", matching
# any valid latitude, longitude and altitude.
#
# If min_pt.altitude is NaN, the bounding box is two-dimensional and
# matches any altitude within the specified latitude and longitude
# range.

GeoPoint min_pt         # lowest and most Southwestern corner
GeoPoint max_pt         # highest and most Northeastern corner

================================================================================
MSG: geographic_msgs/GeoPoint
# Geographic point, using the WGS 84 reference ellipsoid.

# Latitude [degrees]. Positive is north of equator; negative is south
# (-90 <= latitude <= +90).
float64 latitude

# Longitude [degrees]. Positive is east of prime meridian; negative is
# west (-180 <= longitude <= +180). At the poles, latitude is -90 or
# +90, and longitude is irrelevant, but must be in range.
float64 longitude

# Altitude [m]. Positive is above the WGS 84 ellipsoid (NaN if unspecified).
float64 altitude

"
  end
  attr_accessor :min_pt, :max_pt

  @@struct_d6 = ::ROS::Struct.new("d6")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['geographic_msgs/GeoPoint','geographic_msgs/GeoPoint']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [geographic_msgs/GeoPoint] :min_pt initialize value
  # @option args [geographic_msgs/GeoPoint] :max_pt initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:min_pt]
      @min_pt = args[:min_pt]
    else
      @min_pt = Geographic_msgs::GeoPoint.new
    end
    if args[:max_pt]
      @max_pt = args[:max_pt]
    else
      @max_pt = Geographic_msgs::GeoPoint.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_d6.pack(@min_pt.latitude, @min_pt.longitude, @min_pt.altitude, @max_pt.latitude, @max_pt.longitude, @max_pt.altitude))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @min_pt == nil
        @min_pt = Geographic_msgs::GeoPoint.new
      end
      if @max_pt == nil
        @max_pt = Geographic_msgs::GeoPoint.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('d6')
      (@min_pt.latitude, @min_pt.longitude, @min_pt.altitude, @max_pt.latitude, @max_pt.longitude, @max_pt.altitude,) = @@struct_d6.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
