# autogenerated by genrb from GeoPoint.msg. Do not edit.
require 'ros/message'


module Geographic_msgs

class GeoPoint <::ROS::Message
  def self.md5sum
    "c48027a852aeff972be80478ff38e81a"
  end

  def self.type
    "geographic_msgs/GeoPoint"
  end

  def has_header?
    false
  end

  def message_definition
    "# Geographic point, using the WGS 84 reference ellipsoid.

# Latitude [degrees]. Positive is north of equator; negative is south
# (-90 <= latitude <= +90).
float64 latitude

# Longitude [degrees]. Positive is east of prime meridian; negative is
# west (-180 <= longitude <= +180). At the poles, latitude is -90 or
# +90, and longitude is irrelevant, but must be in range.
float64 longitude

# Altitude [m]. Positive is above the WGS 84 ellipsoid (NaN if unspecified).
float64 altitude

"
  end
  attr_accessor :latitude, :longitude, :altitude

  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['float64','float64','float64']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [float64] :latitude initialize value
  # @option args [float64] :longitude initialize value
  # @option args [float64] :altitude initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:latitude]
      @latitude = args[:latitude]
    else
      @latitude = 0.0
    end
    if args[:longitude]
      @longitude = args[:longitude]
    else
      @longitude = 0.0
    end
    if args[:altitude]
      @altitude = args[:altitude]
    else
      @altitude = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_d3.pack(@latitude, @longitude, @altitude))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('d3')
      (@latitude, @longitude, @altitude,) = @@struct_d3.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
