# autogenerated by genrb from GeoPose.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Quaternion"
require "geographic_msgs/GeoPoint"

module Geographic_msgs

class GeoPose <::ROS::Message
  def self.md5sum
    "778680b5172de58b7c057d973576c784"
  end

  def self.type
    "geographic_msgs/GeoPose"
  end

  def has_header?
    false
  end

  def message_definition
    "# Geographic pose, using the WGS 84 reference ellipsoid.
#
# Orientation uses the East-North-Up (ENU) frame of reference.
# (But, what about singularities at the poles?)

GeoPoint position
geometry_msgs/Quaternion orientation

================================================================================
MSG: geographic_msgs/GeoPoint
# Geographic point, using the WGS 84 reference ellipsoid.

# Latitude [degrees]. Positive is north of equator; negative is south
# (-90 <= latitude <= +90).
float64 latitude

# Longitude [degrees]. Positive is east of prime meridian; negative is
# west (-180 <= longitude <= +180). At the poles, latitude is -90 or
# +90, and longitude is irrelevant, but must be in range.
float64 longitude

# Altitude [m]. Positive is above the WGS 84 ellipsoid (NaN if unspecified).
float64 altitude

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :position, :orientation

  @@struct_d7 = ::ROS::Struct.new("d7")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['geographic_msgs/GeoPoint','geometry_msgs/Quaternion']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [geographic_msgs/GeoPoint] :position initialize value
  # @option args [geometry_msgs/Quaternion] :orientation initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:position]
      @position = args[:position]
    else
      @position = Geographic_msgs::GeoPoint.new
    end
    if args[:orientation]
      @orientation = args[:orientation]
    else
      @orientation = Geometry_msgs::Quaternion.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_d7.pack(@position.latitude, @position.longitude, @position.altitude, @orientation.x, @orientation.y, @orientation.z, @orientation.w))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @position == nil
        @position = Geographic_msgs::GeoPoint.new
      end
      if @orientation == nil
        @orientation = Geometry_msgs::Quaternion.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('d7')
      (@position.latitude, @position.longitude, @position.altitude, @orientation.x, @orientation.y, @orientation.z, @orientation.w,) = @@struct_d7.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
