# autogenerated by genrb from GeographicMap.msg. Do not edit.
require 'ros/message'

require "geographic_msgs/BoundingBox"
require "geographic_msgs/GeoPoint"
require "geographic_msgs/KeyValue"
require "std_msgs/Header"
require "geographic_msgs/WayPoint"
require "geographic_msgs/MapFeature"
require "uuid_msgs/UniqueID"

module Geographic_msgs

class GeographicMap <::ROS::Message
  def self.md5sum
    "0f4ce6d2ebf9ac9c7c4f3308f6ae0731"
  end

  def self.type
    "geographic_msgs/GeographicMap"
  end

  def has_header?
    true
  end

  def message_definition
    "# Geographic map for a specified region.

Header header            # stamp specifies time
                         # frame_id (normally /map)

uuid_msgs/UniqueID id    # identifier for this map
BoundingBox  bounds      # 2D bounding box containing map

WayPoint[]   points      # way-points
MapFeature[] features    # map features
KeyValue[]   props       # map properties

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: uuid_msgs/UniqueID
# A universally unique identifier (UUID).
#
#  http://en.wikipedia.org/wiki/Universally_unique_identifier
#  http://tools.ietf.org/html/rfc4122.html

uint8[16] uuid

================================================================================
MSG: geographic_msgs/BoundingBox
# Geographic map bounding box. 
#
# The two GeoPoints denote diagonally opposite corners of the box.
#
# If min_pt.latitude is NaN, the bounding box is \"global\", matching
# any valid latitude, longitude and altitude.
#
# If min_pt.altitude is NaN, the bounding box is two-dimensional and
# matches any altitude within the specified latitude and longitude
# range.

GeoPoint min_pt         # lowest and most Southwestern corner
GeoPoint max_pt         # highest and most Northeastern corner

================================================================================
MSG: geographic_msgs/GeoPoint
# Geographic point, using the WGS 84 reference ellipsoid.

# Latitude [degrees]. Positive is north of equator; negative is south
# (-90 <= latitude <= +90).
float64 latitude

# Longitude [degrees]. Positive is east of prime meridian; negative is
# west (-180 <= longitude <= +180). At the poles, latitude is -90 or
# +90, and longitude is irrelevant, but must be in range.
float64 longitude

# Altitude [m]. Positive is above the WGS 84 ellipsoid (NaN if unspecified).
float64 altitude

================================================================================
MSG: geographic_msgs/WayPoint
# Way-point element for a geographic map.

uuid_msgs/UniqueID id   # Unique way-point identifier
GeoPoint   position     # Position relative to WGS 84 ellipsoid
KeyValue[] props        # Key/value properties for this point

================================================================================
MSG: geographic_msgs/KeyValue
# Geographic map tag (key, value) pair
#
# This is equivalent to diagnostic_msgs/KeyValue, repeated here to
# avoid introducing a trivial stack dependency.

string key                     # tag label
string value                   # corresponding value

================================================================================
MSG: geographic_msgs/MapFeature
# Geographic map feature.
#
# A list of WayPoint IDs for features like streets, highways, hiking
# trails, the outlines of buildings and parking lots in sequential
# order.
#
# Feature lists may also contain other feature lists as members.

uuid_msgs/UniqueID   id         # Unique feature identifier
uuid_msgs/UniqueID[] components # Sequence of feature components
KeyValue[] props                # Key/value properties for this feature

"
  end
  attr_accessor :header, :id, :bounds, :points, :features, :props

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d6 = ::ROS::Struct.new("d6")
  @@struct_C16 = ::ROS::Struct.new("C16")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','uuid_msgs/UniqueID','geographic_msgs/BoundingBox','geographic_msgs/WayPoint[]','geographic_msgs/MapFeature[]','geographic_msgs/KeyValue[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [uuid_msgs/UniqueID] :id initialize value
  # @option args [geographic_msgs/BoundingBox] :bounds initialize value
  # @option args [geographic_msgs/WayPoint[]] :points initialize value
  # @option args [geographic_msgs/MapFeature[]] :features initialize value
  # @option args [geographic_msgs/KeyValue[]] :props initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:id]
      @id = args[:id]
    else
      @id = Uuid_msgs::UniqueID.new
    end
    if args[:bounds]
      @bounds = args[:bounds]
    else
      @bounds = Geographic_msgs::BoundingBox.new
    end
    if args[:points]
      @points = args[:points]
    else
      @points = []
    end
    if args[:features]
      @features = args[:features]
    else
      @features = []
    end
    if args[:props]
      @props = args[:props]
    else
      @props = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @id.uuid
      buff.write(@@struct_C16.pack(_x))
      buff.write(@@struct_d6.pack(@bounds.min_pt.latitude, @bounds.min_pt.longitude, @bounds.min_pt.altitude, @bounds.max_pt.latitude, @bounds.max_pt.longitude, @bounds.max_pt.altitude))
      length = @points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @points
        _v4477 = val1.id
        _x = _v4477.uuid
        buff.write(@@struct_C16.pack(_x))
        _v4478 = val1.position
        _x = _v4478
        buff.write(@@struct_d3.pack(_x.latitude, _x.longitude, _x.altitude))
        length = val1.props.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.props
          _x = val2.key
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.value
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
        end
      end
      length = @features.length
      buff.write(@@struct_L.pack(length))
      for val1 in @features
        _v4479 = val1.id
        _x = _v4479.uuid
        buff.write(@@struct_C16.pack(_x))
        length = val1.components.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.components
          _x = val2.uuid
          buff.write(@@struct_C16.pack(_x))
        end
        length = val1.props.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.props
          _x = val2.key
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.value
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
        end
      end
      length = @props.length
      buff.write(@@struct_L.pack(length))
      for val1 in @props
        _x = val1.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.value
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @id == nil
        @id = Uuid_msgs::UniqueID.new
      end
      if @bounds == nil
        @bounds = Geographic_msgs::BoundingBox.new
      end
      if @points == nil
        @points = Geographic_msgs::WayPoint[].new
      end
      if @features == nil
        @features = Geographic_msgs::MapFeature[].new
      end
      if @props == nil
        @props = Geographic_msgs::KeyValue[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 16
      @id.uuid = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d6')
      (@bounds.min_pt.latitude, @bounds.min_pt.longitude, @bounds.min_pt.altitude, @bounds.max_pt.latitude, @bounds.max_pt.longitude, @bounds.max_pt.altitude,) = @@struct_d6.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @points = []
      length.times do
        val1 = Geographic_msgs::WayPoint.new
        _v4480 = val1.id
        start = end_point
        end_point += 16
        _v4480.uuid = str[start..(end_point-1)]
        _v4481 = val1.position
        _x = _v4481
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.latitude, _x.longitude, _x.altitude,) = @@struct_d3.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.props = []
        length.times do
          val2 = Geographic_msgs::KeyValue.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.key = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.value = str[start..(end_point-1)]
          val1.props.push(val2)
        end
        @points.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @features = []
      length.times do
        val1 = Geographic_msgs::MapFeature.new
        _v4482 = val1.id
        start = end_point
        end_point += 16
        _v4482.uuid = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.components = []
        length.times do
          val2 = Uuid_msgs::UniqueID.new
          start = end_point
          end_point += 16
          val2.uuid = str[start..(end_point-1)]
          val1.components.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.props = []
        length.times do
          val2 = Geographic_msgs::KeyValue.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.key = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.value = str[start..(end_point-1)]
          val1.props.push(val2)
        end
        @features.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @props = []
      length.times do
        val1 = Geographic_msgs::KeyValue.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.value = str[start..(end_point-1)]
        @props.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
