# autogenerated by genrb from GeographicMapChanges.msg. Do not edit.
require 'ros/message'

require "geographic_msgs/BoundingBox"
require "geographic_msgs/GeoPoint"
require "geographic_msgs/KeyValue"
require "std_msgs/Header"
require "geographic_msgs/WayPoint"
require "geographic_msgs/MapFeature"
require "uuid_msgs/UniqueID"
require "geographic_msgs/GeographicMap"

module Geographic_msgs

class GeographicMapChanges <::ROS::Message
  def self.md5sum
    "4fd027f54298203ec12aa1c4b20e6cb8"
  end

  def self.type
    "geographic_msgs/GeographicMapChanges"
  end

  def has_header?
    true
  end

  def message_definition
    "# A list of geographic map changes.

Header header                   # stamp specifies time of change
                                # frame_id (normally /map)

GeographicMap diffs             # new and changed points and features
uuid_msgs/UniqueID[] deletes    # deleted map components

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geographic_msgs/GeographicMap
# Geographic map for a specified region.

Header header            # stamp specifies time
                         # frame_id (normally /map)

uuid_msgs/UniqueID id    # identifier for this map
BoundingBox  bounds      # 2D bounding box containing map

WayPoint[]   points      # way-points
MapFeature[] features    # map features
KeyValue[]   props       # map properties

================================================================================
MSG: uuid_msgs/UniqueID
# A universally unique identifier (UUID).
#
#  http://en.wikipedia.org/wiki/Universally_unique_identifier
#  http://tools.ietf.org/html/rfc4122.html

uint8[16] uuid

================================================================================
MSG: geographic_msgs/BoundingBox
# Geographic map bounding box. 
#
# The two GeoPoints denote diagonally opposite corners of the box.
#
# If min_pt.latitude is NaN, the bounding box is \"global\", matching
# any valid latitude, longitude and altitude.
#
# If min_pt.altitude is NaN, the bounding box is two-dimensional and
# matches any altitude within the specified latitude and longitude
# range.

GeoPoint min_pt         # lowest and most Southwestern corner
GeoPoint max_pt         # highest and most Northeastern corner

================================================================================
MSG: geographic_msgs/GeoPoint
# Geographic point, using the WGS 84 reference ellipsoid.

# Latitude [degrees]. Positive is north of equator; negative is south
# (-90 <= latitude <= +90).
float64 latitude

# Longitude [degrees]. Positive is east of prime meridian; negative is
# west (-180 <= longitude <= +180). At the poles, latitude is -90 or
# +90, and longitude is irrelevant, but must be in range.
float64 longitude

# Altitude [m]. Positive is above the WGS 84 ellipsoid (NaN if unspecified).
float64 altitude

================================================================================
MSG: geographic_msgs/WayPoint
# Way-point element for a geographic map.

uuid_msgs/UniqueID id   # Unique way-point identifier
GeoPoint   position     # Position relative to WGS 84 ellipsoid
KeyValue[] props        # Key/value properties for this point

================================================================================
MSG: geographic_msgs/KeyValue
# Geographic map tag (key, value) pair
#
# This is equivalent to diagnostic_msgs/KeyValue, repeated here to
# avoid introducing a trivial stack dependency.

string key                     # tag label
string value                   # corresponding value

================================================================================
MSG: geographic_msgs/MapFeature
# Geographic map feature.
#
# A list of WayPoint IDs for features like streets, highways, hiking
# trails, the outlines of buildings and parking lots in sequential
# order.
#
# Feature lists may also contain other feature lists as members.

uuid_msgs/UniqueID   id         # Unique feature identifier
uuid_msgs/UniqueID[] components # Sequence of feature components
KeyValue[] props                # Key/value properties for this feature

"
  end
  attr_accessor :header, :diffs, :deletes

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d6 = ::ROS::Struct.new("d6")
  @@struct_C16 = ::ROS::Struct.new("C16")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','geographic_msgs/GeographicMap','uuid_msgs/UniqueID[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [geographic_msgs/GeographicMap] :diffs initialize value
  # @option args [uuid_msgs/UniqueID[]] :deletes initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:diffs]
      @diffs = args[:diffs]
    else
      @diffs = Geographic_msgs::GeographicMap.new
    end
    if args[:deletes]
      @deletes = args[:deletes]
    else
      @deletes = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@diffs.header.seq, @diffs.header.stamp.secs, @diffs.header.stamp.nsecs))
      _x = @diffs.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @diffs.id.uuid
      buff.write(@@struct_C16.pack(_x))
      buff.write(@@struct_d6.pack(@diffs.bounds.min_pt.latitude, @diffs.bounds.min_pt.longitude, @diffs.bounds.min_pt.altitude, @diffs.bounds.max_pt.latitude, @diffs.bounds.max_pt.longitude, @diffs.bounds.max_pt.altitude))
      length = @diffs.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @diffs.points
        _v4483 = val1.id
        _x = _v4483.uuid
        buff.write(@@struct_C16.pack(_x))
        _v4484 = val1.position
        _x = _v4484
        buff.write(@@struct_d3.pack(_x.latitude, _x.longitude, _x.altitude))
        length = val1.props.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.props
          _x = val2.key
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.value
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
        end
      end
      length = @diffs.features.length
      buff.write(@@struct_L.pack(length))
      for val1 in @diffs.features
        _v4485 = val1.id
        _x = _v4485.uuid
        buff.write(@@struct_C16.pack(_x))
        length = val1.components.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.components
          _x = val2.uuid
          buff.write(@@struct_C16.pack(_x))
        end
        length = val1.props.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.props
          _x = val2.key
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.value
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
        end
      end
      length = @diffs.props.length
      buff.write(@@struct_L.pack(length))
      for val1 in @diffs.props
        _x = val1.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.value
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      length = @deletes.length
      buff.write(@@struct_L.pack(length))
      for val1 in @deletes
        _x = val1.uuid
        buff.write(@@struct_C16.pack(_x))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @diffs == nil
        @diffs = Geographic_msgs::GeographicMap.new
      end
      if @deletes == nil
        @deletes = Uuid_msgs::UniqueID[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@diffs.header.seq, @diffs.header.stamp.secs, @diffs.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @diffs.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 16
      @diffs.id.uuid = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d6')
      (@diffs.bounds.min_pt.latitude, @diffs.bounds.min_pt.longitude, @diffs.bounds.min_pt.altitude, @diffs.bounds.max_pt.latitude, @diffs.bounds.max_pt.longitude, @diffs.bounds.max_pt.altitude,) = @@struct_d6.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @diffs.points = []
      length.times do
        val1 = Geographic_msgs::WayPoint.new
        _v4486 = val1.id
        start = end_point
        end_point += 16
        _v4486.uuid = str[start..(end_point-1)]
        _v4487 = val1.position
        _x = _v4487
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.latitude, _x.longitude, _x.altitude,) = @@struct_d3.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.props = []
        length.times do
          val2 = Geographic_msgs::KeyValue.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.key = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.value = str[start..(end_point-1)]
          val1.props.push(val2)
        end
        @diffs.points.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @diffs.features = []
      length.times do
        val1 = Geographic_msgs::MapFeature.new
        _v4488 = val1.id
        start = end_point
        end_point += 16
        _v4488.uuid = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.components = []
        length.times do
          val2 = Uuid_msgs::UniqueID.new
          start = end_point
          end_point += 16
          val2.uuid = str[start..(end_point-1)]
          val1.components.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.props = []
        length.times do
          val2 = Geographic_msgs::KeyValue.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.key = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.value = str[start..(end_point-1)]
          val1.props.push(val2)
        end
        @diffs.features.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @diffs.props = []
      length.times do
        val1 = Geographic_msgs::KeyValue.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.value = str[start..(end_point-1)]
        @diffs.props.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @deletes = []
      length.times do
        val1 = Uuid_msgs::UniqueID.new
        start = end_point
        end_point += 16
        val1.uuid = str[start..(end_point-1)]
        @deletes.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
