# autogenerated by genrb from MapFeature.msg. Do not edit.
require 'ros/message'

require "geographic_msgs/KeyValue"
require "uuid_msgs/UniqueID"

module Geographic_msgs

class MapFeature <::ROS::Message
  def self.md5sum
    "e2505ace5e8da8a15b610eaf62bdefae"
  end

  def self.type
    "geographic_msgs/MapFeature"
  end

  def has_header?
    false
  end

  def message_definition
    "# Geographic map feature.
#
# A list of WayPoint IDs for features like streets, highways, hiking
# trails, the outlines of buildings and parking lots in sequential
# order.
#
# Feature lists may also contain other feature lists as members.

uuid_msgs/UniqueID   id         # Unique feature identifier
uuid_msgs/UniqueID[] components # Sequence of feature components
KeyValue[] props                # Key/value properties for this feature

================================================================================
MSG: uuid_msgs/UniqueID
# A universally unique identifier (UUID).
#
#  http://en.wikipedia.org/wiki/Universally_unique_identifier
#  http://tools.ietf.org/html/rfc4122.html

uint8[16] uuid

================================================================================
MSG: geographic_msgs/KeyValue
# Geographic map tag (key, value) pair
#
# This is equivalent to diagnostic_msgs/KeyValue, repeated here to
# avoid introducing a trivial stack dependency.

string key                     # tag label
string value                   # corresponding value

"
  end
  attr_accessor :id, :components, :props

  @@struct_C16 = ::ROS::Struct.new("C16")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['uuid_msgs/UniqueID','uuid_msgs/UniqueID[]','geographic_msgs/KeyValue[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [uuid_msgs/UniqueID] :id initialize value
  # @option args [uuid_msgs/UniqueID[]] :components initialize value
  # @option args [geographic_msgs/KeyValue[]] :props initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:id]
      @id = args[:id]
    else
      @id = Uuid_msgs::UniqueID.new
    end
    if args[:components]
      @components = args[:components]
    else
      @components = []
    end
    if args[:props]
      @props = args[:props]
    else
      @props = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @id.uuid
      buff.write(@@struct_C16.pack(_x))
      length = @components.length
      buff.write(@@struct_L.pack(length))
      for val1 in @components
        _x = val1.uuid
        buff.write(@@struct_C16.pack(_x))
      end
      length = @props.length
      buff.write(@@struct_L.pack(length))
      for val1 in @props
        _x = val1.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.value
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @id == nil
        @id = Uuid_msgs::UniqueID.new
      end
      if @components == nil
        @components = Uuid_msgs::UniqueID[].new
      end
      if @props == nil
        @props = Geographic_msgs::KeyValue[].new
      end
      end_point = 0
      start = end_point
      end_point += 16
      @id.uuid = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @components = []
      length.times do
        val1 = Uuid_msgs::UniqueID.new
        start = end_point
        end_point += 16
        val1.uuid = str[start..(end_point-1)]
        @components.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @props = []
      length.times do
        val1 = Geographic_msgs::KeyValue.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.value = str[start..(end_point-1)]
        @props.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
