# autogenerated by genrb from RoutePath.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geographic_msgs/KeyValue"
require "uuid_msgs/UniqueID"

module Geographic_msgs

class RoutePath <::ROS::Message
  def self.md5sum
    "0aa2dd809a8091bdb4466dfefecbb8cf"
  end

  def self.type
    "geographic_msgs/RoutePath"
  end

  def has_header?
    true
  end

  def message_definition
    "# Path through a route network.
#
# A path is a sequence of RouteSegment edges.  This information is
# extracted from a RouteNetwork graph.  A RoutePath lists the route
# segments needed to reach some chosen goal.

Header header

uuid_msgs/UniqueID   network    # Route network containing this path
uuid_msgs/UniqueID[] segments   # Sequence of RouteSegment IDs
KeyValue[]           props      # Key/value properties

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: uuid_msgs/UniqueID
# A universally unique identifier (UUID).
#
#  http://en.wikipedia.org/wiki/Universally_unique_identifier
#  http://tools.ietf.org/html/rfc4122.html

uint8[16] uuid

================================================================================
MSG: geographic_msgs/KeyValue
# Geographic map tag (key, value) pair
#
# This is equivalent to diagnostic_msgs/KeyValue, repeated here to
# avoid introducing a trivial stack dependency.

string key                     # tag label
string value                   # corresponding value

"
  end
  attr_accessor :header, :network, :segments, :props

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_C16 = ::ROS::Struct.new("C16")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','uuid_msgs/UniqueID','uuid_msgs/UniqueID[]','geographic_msgs/KeyValue[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [uuid_msgs/UniqueID] :network initialize value
  # @option args [uuid_msgs/UniqueID[]] :segments initialize value
  # @option args [geographic_msgs/KeyValue[]] :props initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:network]
      @network = args[:network]
    else
      @network = Uuid_msgs::UniqueID.new
    end
    if args[:segments]
      @segments = args[:segments]
    else
      @segments = []
    end
    if args[:props]
      @props = args[:props]
    else
      @props = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @network.uuid
      buff.write(@@struct_C16.pack(_x))
      length = @segments.length
      buff.write(@@struct_L.pack(length))
      for val1 in @segments
        _x = val1.uuid
        buff.write(@@struct_C16.pack(_x))
      end
      length = @props.length
      buff.write(@@struct_L.pack(length))
      for val1 in @props
        _x = val1.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.value
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @network == nil
        @network = Uuid_msgs::UniqueID.new
      end
      if @segments == nil
        @segments = Uuid_msgs::UniqueID[].new
      end
      if @props == nil
        @props = Geographic_msgs::KeyValue[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 16
      @network.uuid = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @segments = []
      length.times do
        val1 = Uuid_msgs::UniqueID.new
        start = end_point
        end_point += 16
        val1.uuid = str[start..(end_point-1)]
        @segments.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @props = []
      length.times do
        val1 = Geographic_msgs::KeyValue.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.value = str[start..(end_point-1)]
        @props.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
