# autogenerated by genrb from UpdateGeographicMapRequest.msg. Do not edit.
require 'ros/message'

require "geographic_msgs/BoundingBox"
require "geographic_msgs/GeographicMapChanges"
require "geographic_msgs/GeoPoint"
require "geographic_msgs/KeyValue"
require "std_msgs/Header"
require "geographic_msgs/WayPoint"
require "geographic_msgs/MapFeature"
require "uuid_msgs/UniqueID"
require "geographic_msgs/GeographicMap"

module Geographic_msgs

class UpdateGeographicMapRequest <::ROS::Message
  def self.md5sum
    "8d8da723a1fadc5f7621a18b4e72fc3b"
  end

  def self.type
    "geographic_msgs/UpdateGeographicMapRequest"
  end

  def has_header?
    false
  end

  def message_definition
    "


GeographicMapChanges updates


================================================================================
MSG: geographic_msgs/GeographicMapChanges
# A list of geographic map changes.

Header header                   # stamp specifies time of change
                                # frame_id (normally /map)

GeographicMap diffs             # new and changed points and features
uuid_msgs/UniqueID[] deletes    # deleted map components

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geographic_msgs/GeographicMap
# Geographic map for a specified region.

Header header            # stamp specifies time
                         # frame_id (normally /map)

uuid_msgs/UniqueID id    # identifier for this map
BoundingBox  bounds      # 2D bounding box containing map

WayPoint[]   points      # way-points
MapFeature[] features    # map features
KeyValue[]   props       # map properties

================================================================================
MSG: uuid_msgs/UniqueID
# A universally unique identifier (UUID).
#
#  http://en.wikipedia.org/wiki/Universally_unique_identifier
#  http://tools.ietf.org/html/rfc4122.html

uint8[16] uuid

================================================================================
MSG: geographic_msgs/BoundingBox
# Geographic map bounding box. 
#
# The two GeoPoints denote diagonally opposite corners of the box.
#
# If min_pt.latitude is NaN, the bounding box is \"global\", matching
# any valid latitude, longitude and altitude.
#
# If min_pt.altitude is NaN, the bounding box is two-dimensional and
# matches any altitude within the specified latitude and longitude
# range.

GeoPoint min_pt         # lowest and most Southwestern corner
GeoPoint max_pt         # highest and most Northeastern corner

================================================================================
MSG: geographic_msgs/GeoPoint
# Geographic point, using the WGS 84 reference ellipsoid.

# Latitude [degrees]. Positive is north of equator; negative is south
# (-90 <= latitude <= +90).
float64 latitude

# Longitude [degrees]. Positive is east of prime meridian; negative is
# west (-180 <= longitude <= +180). At the poles, latitude is -90 or
# +90, and longitude is irrelevant, but must be in range.
float64 longitude

# Altitude [m]. Positive is above the WGS 84 ellipsoid (NaN if unspecified).
float64 altitude

================================================================================
MSG: geographic_msgs/WayPoint
# Way-point element for a geographic map.

uuid_msgs/UniqueID id   # Unique way-point identifier
GeoPoint   position     # Position relative to WGS 84 ellipsoid
KeyValue[] props        # Key/value properties for this point

================================================================================
MSG: geographic_msgs/KeyValue
# Geographic map tag (key, value) pair
#
# This is equivalent to diagnostic_msgs/KeyValue, repeated here to
# avoid introducing a trivial stack dependency.

string key                     # tag label
string value                   # corresponding value

================================================================================
MSG: geographic_msgs/MapFeature
# Geographic map feature.
#
# A list of WayPoint IDs for features like streets, highways, hiking
# trails, the outlines of buildings and parking lots in sequential
# order.
#
# Feature lists may also contain other feature lists as members.

uuid_msgs/UniqueID   id         # Unique feature identifier
uuid_msgs/UniqueID[] components # Sequence of feature components
KeyValue[] props                # Key/value properties for this feature

"
  end
  attr_accessor :updates

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d6 = ::ROS::Struct.new("d6")
  @@struct_C16 = ::ROS::Struct.new("C16")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['geographic_msgs/GeographicMapChanges']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [geographic_msgs/GeographicMapChanges] :updates initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:updates]
      @updates = args[:updates]
    else
      @updates = Geographic_msgs::GeographicMapChanges.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@updates.header.seq, @updates.header.stamp.secs, @updates.header.stamp.nsecs))
      _x = @updates.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@updates.diffs.header.seq, @updates.diffs.header.stamp.secs, @updates.diffs.header.stamp.nsecs))
      _x = @updates.diffs.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @updates.diffs.id.uuid
      buff.write(@@struct_C16.pack(_x))
      buff.write(@@struct_d6.pack(@updates.diffs.bounds.min_pt.latitude, @updates.diffs.bounds.min_pt.longitude, @updates.diffs.bounds.min_pt.altitude, @updates.diffs.bounds.max_pt.latitude, @updates.diffs.bounds.max_pt.longitude, @updates.diffs.bounds.max_pt.altitude))
      length = @updates.diffs.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @updates.diffs.points
        _v5665 = val1.id
        _x = _v5665.uuid
        buff.write(@@struct_C16.pack(_x))
        _v5666 = val1.position
        _x = _v5666
        buff.write(@@struct_d3.pack(_x.latitude, _x.longitude, _x.altitude))
        length = val1.props.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.props
          _x = val2.key
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.value
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
        end
      end
      length = @updates.diffs.features.length
      buff.write(@@struct_L.pack(length))
      for val1 in @updates.diffs.features
        _v5667 = val1.id
        _x = _v5667.uuid
        buff.write(@@struct_C16.pack(_x))
        length = val1.components.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.components
          _x = val2.uuid
          buff.write(@@struct_C16.pack(_x))
        end
        length = val1.props.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.props
          _x = val2.key
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.value
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
        end
      end
      length = @updates.diffs.props.length
      buff.write(@@struct_L.pack(length))
      for val1 in @updates.diffs.props
        _x = val1.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.value
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      length = @updates.deletes.length
      buff.write(@@struct_L.pack(length))
      for val1 in @updates.deletes
        _x = val1.uuid
        buff.write(@@struct_C16.pack(_x))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @updates == nil
        @updates = Geographic_msgs::GeographicMapChanges.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@updates.header.seq, @updates.header.stamp.secs, @updates.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @updates.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@updates.diffs.header.seq, @updates.diffs.header.stamp.secs, @updates.diffs.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @updates.diffs.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 16
      @updates.diffs.id.uuid = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d6')
      (@updates.diffs.bounds.min_pt.latitude, @updates.diffs.bounds.min_pt.longitude, @updates.diffs.bounds.min_pt.altitude, @updates.diffs.bounds.max_pt.latitude, @updates.diffs.bounds.max_pt.longitude, @updates.diffs.bounds.max_pt.altitude,) = @@struct_d6.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @updates.diffs.points = []
      length.times do
        val1 = Geographic_msgs::WayPoint.new
        _v5668 = val1.id
        start = end_point
        end_point += 16
        _v5668.uuid = str[start..(end_point-1)]
        _v5669 = val1.position
        _x = _v5669
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.latitude, _x.longitude, _x.altitude,) = @@struct_d3.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.props = []
        length.times do
          val2 = Geographic_msgs::KeyValue.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.key = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.value = str[start..(end_point-1)]
          val1.props.push(val2)
        end
        @updates.diffs.points.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @updates.diffs.features = []
      length.times do
        val1 = Geographic_msgs::MapFeature.new
        _v5670 = val1.id
        start = end_point
        end_point += 16
        _v5670.uuid = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.components = []
        length.times do
          val2 = Uuid_msgs::UniqueID.new
          start = end_point
          end_point += 16
          val2.uuid = str[start..(end_point-1)]
          val1.components.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.props = []
        length.times do
          val2 = Geographic_msgs::KeyValue.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.key = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.value = str[start..(end_point-1)]
          val1.props.push(val2)
        end
        @updates.diffs.features.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @updates.diffs.props = []
      length.times do
        val1 = Geographic_msgs::KeyValue.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.value = str[start..(end_point-1)]
        @updates.diffs.props.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @updates.deletes = []
      length.times do
        val1 = Uuid_msgs::UniqueID.new
        start = end_point
        end_point += 16
        val1.uuid = str[start..(end_point-1)]
        @updates.deletes.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
# autogenerated by genrb from UpdateGeographicMapResponse.msg. Do not edit.
require 'ros/message'


module Geographic_msgs

class UpdateGeographicMapResponse <::ROS::Message
  def self.md5sum
    "38b8954d32a849f31d78416b12bff5d1"
  end

  def self.type
    "geographic_msgs/UpdateGeographicMapResponse"
  end

  def has_header?
    false
  end

  def message_definition
    "
bool   success
string status


"
  end
  attr_accessor :success, :status

  @@struct_C = ::ROS::Struct.new("C")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['bool','string']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [bool] :success initialize value
  # @option args [string] :status initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:success]
      @success = args[:success]
    else
      @success = false
    end
    if args[:status]
      @status = args[:status]
    else
      @status = ''
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_C.pack(@success))
      _x = @status
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@success,) = @@struct_C.unpack(str[start..(end_point-1)])
      @success = bool(@success)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @status = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
module Geographic_msgs
class UpdateGeographicMap
  def self.type
    'geographic_msgs/UpdateGeographicMap'
  end
  def self.md5sum
    '93db3f1ec099e9f1b7e442d7d397e244'
  end
  def self.request_class
    UpdateGeographicMapRequest
  end
  def self.response_class
    UpdateGeographicMapResponse
  end
end
end