# autogenerated by genrb from WayPoint.msg. Do not edit.
require 'ros/message'

require "geographic_msgs/KeyValue"
require "uuid_msgs/UniqueID"
require "geographic_msgs/GeoPoint"

module Geographic_msgs

class WayPoint <::ROS::Message
  def self.md5sum
    "ef04f823aef332455a49eaec3f1761b7"
  end

  def self.type
    "geographic_msgs/WayPoint"
  end

  def has_header?
    false
  end

  def message_definition
    "# Way-point element for a geographic map.

uuid_msgs/UniqueID id   # Unique way-point identifier
GeoPoint   position     # Position relative to WGS 84 ellipsoid
KeyValue[] props        # Key/value properties for this point

================================================================================
MSG: uuid_msgs/UniqueID
# A universally unique identifier (UUID).
#
#  http://en.wikipedia.org/wiki/Universally_unique_identifier
#  http://tools.ietf.org/html/rfc4122.html

uint8[16] uuid

================================================================================
MSG: geographic_msgs/GeoPoint
# Geographic point, using the WGS 84 reference ellipsoid.

# Latitude [degrees]. Positive is north of equator; negative is south
# (-90 <= latitude <= +90).
float64 latitude

# Longitude [degrees]. Positive is east of prime meridian; negative is
# west (-180 <= longitude <= +180). At the poles, latitude is -90 or
# +90, and longitude is irrelevant, but must be in range.
float64 longitude

# Altitude [m]. Positive is above the WGS 84 ellipsoid (NaN if unspecified).
float64 altitude

================================================================================
MSG: geographic_msgs/KeyValue
# Geographic map tag (key, value) pair
#
# This is equivalent to diagnostic_msgs/KeyValue, repeated here to
# avoid introducing a trivial stack dependency.

string key                     # tag label
string value                   # corresponding value

"
  end
  attr_accessor :id, :position, :props

  @@struct_C16 = ::ROS::Struct.new("C16")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['uuid_msgs/UniqueID','geographic_msgs/GeoPoint','geographic_msgs/KeyValue[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [uuid_msgs/UniqueID] :id initialize value
  # @option args [geographic_msgs/GeoPoint] :position initialize value
  # @option args [geographic_msgs/KeyValue[]] :props initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:id]
      @id = args[:id]
    else
      @id = Uuid_msgs::UniqueID.new
    end
    if args[:position]
      @position = args[:position]
    else
      @position = Geographic_msgs::GeoPoint.new
    end
    if args[:props]
      @props = args[:props]
    else
      @props = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @id.uuid
      buff.write(@@struct_C16.pack(_x))
      buff.write(@@struct_d3.pack(@position.latitude, @position.longitude, @position.altitude))
      length = @props.length
      buff.write(@@struct_L.pack(length))
      for val1 in @props
        _x = val1.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.value
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @id == nil
        @id = Uuid_msgs::UniqueID.new
      end
      if @position == nil
        @position = Geographic_msgs::GeoPoint.new
      end
      if @props == nil
        @props = Geographic_msgs::KeyValue[].new
      end
      end_point = 0
      start = end_point
      end_point += 16
      @id.uuid = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3')
      (@position.latitude, @position.longitude, @position.altitude,) = @@struct_d3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @props = []
      length.times do
        val1 = Geographic_msgs::KeyValue.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.value = str[start..(end_point-1)]
        @props.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
