# autogenerated by genrb from GetNormalRequest.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Point"
require "geometry_msgs/PointStamped"

module Hector_nav_msgs

class GetNormalRequest <::ROS::Message
  def self.md5sum
    "47dfdbd810b48d0a47b7ad67e4191bcc"
  end

  def self.type
    "hector_nav_msgs/GetNormalRequest"
  end

  def has_header?
    false
  end

  def message_definition
    "geometry_msgs/PointStamped point

================================================================================
MSG: geometry_msgs/PointStamped
# This represents a Point with reference coordinate frame and timestamp
Header header
Point point

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

"
  end
  attr_accessor :point

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['geometry_msgs/PointStamped']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [geometry_msgs/PointStamped] :point initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:point]
      @point = args[:point]
    else
      @point = Geometry_msgs::PointStamped.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@point.header.seq, @point.header.stamp.secs, @point.header.stamp.nsecs))
      _x = @point.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3.pack(@point.point.x, @point.point.y, @point.point.z))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @point == nil
        @point = Geometry_msgs::PointStamped.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@point.header.seq, @point.header.stamp.secs, @point.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @point.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3')
      (@point.point.x, @point.point.y, @point.point.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
# autogenerated by genrb from GetNormalResponse.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Vector3"

module Hector_nav_msgs

class GetNormalResponse <::ROS::Message
  def self.md5sum
    "8ea5d051594753307ebd995c02db60a3"
  end

  def self.type
    "hector_nav_msgs/GetNormalResponse"
  end

  def has_header?
    false
  end

  def message_definition
    "geometry_msgs/Vector3 normal
float32 yaw



================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :normal, :yaw

  @@struct_d3f = ::ROS::Struct.new("d3f")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['geometry_msgs/Vector3','float32']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [geometry_msgs/Vector3] :normal initialize value
  # @option args [float32] :yaw initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:normal]
      @normal = args[:normal]
    else
      @normal = Geometry_msgs::Vector3.new
    end
    if args[:yaw]
      @yaw = args[:yaw]
    else
      @yaw = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_d3f.pack(@normal.x, @normal.y, @normal.z, @yaw))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @normal == nil
        @normal = Geometry_msgs::Vector3.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('d3f')
      (@normal.x, @normal.y, @normal.z, @yaw,) = @@struct_d3f.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
module Hector_nav_msgs
class GetNormal
  def self.type
    'hector_nav_msgs/GetNormal'
  end
  def self.md5sum
    '78e9a71258a9d6fdc4aeba5a9c33a01e'
  end
  def self.request_class
    GetNormalRequest
  end
  def self.response_class
    GetNormalResponse
  end
end
end