# autogenerated by genrb from Object.msg. Do not edit.
require 'ros/message'

require "hector_worldmodel_msgs/ObjectState"
require "geometry_msgs/PoseWithCovariance"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "hector_worldmodel_msgs/ObjectInfo"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Pose"

module Hector_worldmodel_msgs

class Object <::ROS::Message
  def self.md5sum
    "02dea96e80640703553490052f13918d"
  end

  def self.type
    "hector_worldmodel_msgs/Object"
  end

  def has_header?
    true
  end

  def message_definition
    "# hector_worldmodel_msgs/Object
# This message represents an estimate of an object's pose and identity.

# The header.
#   stamp: Timestamp of last update.
#   frame_id: Coordinate frame, in which the pose is given
Header header

# The pose
geometry_msgs/PoseWithCovariance pose

# Further information about the object
ObjectInfo info

# The tracked state of the object
ObjectState state

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/PoseWithCovariance
# This represents a pose in free space with uncertainty.

Pose pose

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: hector_worldmodel_msgs/ObjectInfo
# hector_worldmodel_msgs/ObjectInfo
# This message contains information about the estimated class affiliation, object id and corresponding support

# A string identifying the object's class (all objects of a class look the same)
string class_id

# A string identifying the specific object
string object_id

# A string that contains the name or a description of the specific object
string name

# The support (degree of belief) of the object's presence given as log odd ratio
float32 support


================================================================================
MSG: hector_worldmodel_msgs/ObjectState
# The state of an object estimate used to track
# states smaller than 0 disable all updates

# Predefined states. Use states smaller than 0 or bigger than 63 for user defined states.
int8 UNKNOWN = 0
int8 PENDING = 1
int8 ACTIVE  = 2
int8 INACTIVE = 3
int8 CONFIRMED = -1
int8 DISCARDED = -2
int8 APPROACHING = -3

int8 state

"
  end
  attr_accessor :header, :pose, :info, :state

  @@struct_fc = ::ROS::Struct.new("fc")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d7 = ::ROS::Struct.new("d7")
  @@struct_d36 = ::ROS::Struct.new("d36")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','geometry_msgs/PoseWithCovariance','hector_worldmodel_msgs/ObjectInfo','hector_worldmodel_msgs/ObjectState']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [geometry_msgs/PoseWithCovariance] :pose initialize value
  # @option args [hector_worldmodel_msgs/ObjectInfo] :info initialize value
  # @option args [hector_worldmodel_msgs/ObjectState] :state initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:pose]
      @pose = args[:pose]
    else
      @pose = Geometry_msgs::PoseWithCovariance.new
    end
    if args[:info]
      @info = args[:info]
    else
      @info = Hector_worldmodel_msgs::ObjectInfo.new
    end
    if args[:state]
      @state = args[:state]
    else
      @state = Hector_worldmodel_msgs::ObjectState.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7.pack(@pose.pose.position.x, @pose.pose.position.y, @pose.pose.position.z, @pose.pose.orientation.x, @pose.pose.orientation.y, @pose.pose.orientation.z, @pose.pose.orientation.w))
      buff.write(@@struct_d36.pack(*@pose.covariance))
      _x = @info.class_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @info.object_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @info.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_fc.pack(@info.support, @state.state))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @pose == nil
        @pose = Geometry_msgs::PoseWithCovariance.new
      end
      if @info == nil
        @info = Hector_worldmodel_msgs::ObjectInfo.new
      end
      if @state == nil
        @state = Hector_worldmodel_msgs::ObjectState.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7')
      (@pose.pose.position.x, @pose.pose.position.y, @pose.pose.position.z, @pose.pose.orientation.x, @pose.pose.orientation.y, @pose.pose.orientation.z, @pose.pose.orientation.w,) = @@struct_d7.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d36')
      @pose.covariance = @@struct_d36.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @info.class_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @info.object_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @info.name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('fc')
      (@info.support, @state.state,) = @@struct_fc.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
