# autogenerated by genrb from ObjectModel.msg. Do not edit.
require 'ros/message'

require "hector_worldmodel_msgs/ObjectState"
require "geometry_msgs/PoseWithCovariance"
require "hector_worldmodel_msgs/Object"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "hector_worldmodel_msgs/ObjectInfo"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Pose"

module Hector_worldmodel_msgs

class ObjectModel <::ROS::Message
  def self.md5sum
    "0e38ac3cfe11f476b7d55135cfbc074a"
  end

  def self.type
    "hector_worldmodel_msgs/ObjectModel"
  end

  def has_header?
    true
  end

  def message_definition
    "# hector_worldmodel_msgs/ObjectModel
# This message represents a collection of known objects.

Header header
Object[] objects

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: hector_worldmodel_msgs/Object
# hector_worldmodel_msgs/Object
# This message represents an estimate of an object's pose and identity.

# The header.
#   stamp: Timestamp of last update.
#   frame_id: Coordinate frame, in which the pose is given
Header header

# The pose
geometry_msgs/PoseWithCovariance pose

# Further information about the object
ObjectInfo info

# The tracked state of the object
ObjectState state

================================================================================
MSG: geometry_msgs/PoseWithCovariance
# This represents a pose in free space with uncertainty.

Pose pose

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: hector_worldmodel_msgs/ObjectInfo
# hector_worldmodel_msgs/ObjectInfo
# This message contains information about the estimated class affiliation, object id and corresponding support

# A string identifying the object's class (all objects of a class look the same)
string class_id

# A string identifying the specific object
string object_id

# A string that contains the name or a description of the specific object
string name

# The support (degree of belief) of the object's presence given as log odd ratio
float32 support


================================================================================
MSG: hector_worldmodel_msgs/ObjectState
# The state of an object estimate used to track
# states smaller than 0 disable all updates

# Predefined states. Use states smaller than 0 or bigger than 63 for user defined states.
int8 UNKNOWN = 0
int8 PENDING = 1
int8 ACTIVE  = 2
int8 INACTIVE = 3
int8 CONFIRMED = -1
int8 DISCARDED = -2
int8 APPROACHING = -3

int8 state

"
  end
  attr_accessor :header, :objects

  @@struct_c = ::ROS::Struct.new("c")
  @@struct_f = ::ROS::Struct.new("f")
  @@struct_d36 = ::ROS::Struct.new("d36")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','hector_worldmodel_msgs/Object[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [hector_worldmodel_msgs/Object[]] :objects initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:objects]
      @objects = args[:objects]
    else
      @objects = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @objects
        _v303 = val1.header
        buff.write(@@struct_L.pack(_v303.seq))
        _v304 = _v303.stamp
        _x = _v304
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v303.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v305 = val1.pose
        _v306 = _v305.pose
        _v307 = _v306.position
        _x = _v307
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v308 = _v306.orientation
        _x = _v308
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_d36.pack(*_v305.covariance))
        _v309 = val1.info
        _x = _v309.class_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v309.object_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v309.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_f.pack(_v309.support))
        _v310 = val1.state
        buff.write(@@struct_c.pack(_v310.state))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @objects == nil
        @objects = Hector_worldmodel_msgs::Object[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @objects = []
      length.times do
        val1 = Hector_worldmodel_msgs::Object.new
        _v311 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v311.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v312 = _v311.stamp
        _x = _v312
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v311.frame_id = str[start..(end_point-1)]
        _v313 = val1.pose
        _v314 = _v313.pose
        _v315 = _v314.position
        _x = _v315
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v316 = _v314.orientation
        _x = _v316
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d36')
        _v313.covariance = @@struct_d36.unpack(str[start..(end_point-1)])
        _v317 = val1.info
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v317.class_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v317.object_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v317.name = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (_v317.support,) = @@struct_f.unpack(str[start..(end_point-1)])
        _v318 = val1.state
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v318.state,) = @@struct_c.unpack(str[start..(end_point-1)])
        @objects.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
