# autogenerated by genrb from PerceptInfo.msg. Do not edit.
require 'ros/message'


module Hector_worldmodel_msgs

class PerceptInfo <::ROS::Message
  def self.md5sum
    "6d276cf0fa6b560cbfd07a3f9eab88b5"
  end

  def self.type
    "hector_worldmodel_msgs/PerceptInfo"
  end

  def has_header?
    false
  end

  def message_definition
    "# hector_worldmodel_msgs/PerceptInfo
# This message contains information about the estimated class and object identity 

# A string identifying the object's class (all objects of a class look the same)
string class_id

# The class association support of the observation
# The support is the log odd likelihood ratio given by log(p(y/observation y belongs to object of class class_id) / p(y/observation y is a false positive))
float32 class_support

# A string identifying a specific object
string object_id

# The object association support of the observation
# The support is the log odd likelihood ratio given by log(p(observation belongs to object object_id) / p(observation is false positive or belongs to another object))
float32 object_support

# A string that contains the name or a description of the specific object
string name

"
  end
  attr_accessor :class_id, :class_support, :object_id, :object_support, :name

  @@struct_f = ::ROS::Struct.new("f")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','float32','string','float32','string']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :class_id initialize value
  # @option args [float32] :class_support initialize value
  # @option args [string] :object_id initialize value
  # @option args [float32] :object_support initialize value
  # @option args [string] :name initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:class_id]
      @class_id = args[:class_id]
    else
      @class_id = ''
    end
    if args[:class_support]
      @class_support = args[:class_support]
    else
      @class_support = 0.0
    end
    if args[:object_id]
      @object_id = args[:object_id]
    else
      @object_id = ''
    end
    if args[:object_support]
      @object_support = args[:object_support]
    else
      @object_support = 0.0
    end
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @class_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_f.pack(@class_support))
      _x = @object_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_f.pack(@object_support))
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @class_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('f')
      (@class_support,) = @@struct_f.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @object_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('f')
      (@object_support,) = @@struct_f.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
