# autogenerated by genrb from VerifyPerceptRequest.msg. Do not edit.
require 'ros/message'

require "hector_worldmodel_msgs/PerceptInfo"
require "geometry_msgs/PoseWithCovariance"
require "hector_worldmodel_msgs/PosePercept"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Pose"

module Hector_worldmodel_msgs

class VerifyPerceptRequest <::ROS::Message
  def self.md5sum
    "9bd63c0c584500367d789d059094e625"
  end

  def self.type
    "hector_worldmodel_msgs/VerifyPerceptRequest"
  end

  def has_header?
    false
  end

  def message_definition
    "


PosePercept percept

================================================================================
MSG: hector_worldmodel_msgs/PosePercept
# hector_worldmodel_msgs/PosePercept
# This message represents an observation of an object in a single image.

# The header should equal the header of the corresponding image.
Header header

# The estimated pose of the object with its covariance
geometry_msgs/PoseWithCovariance pose

# Additional information about the percept
PerceptInfo info

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/PoseWithCovariance
# This represents a pose in free space with uncertainty.

Pose pose

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: hector_worldmodel_msgs/PerceptInfo
# hector_worldmodel_msgs/PerceptInfo
# This message contains information about the estimated class and object identity 

# A string identifying the object's class (all objects of a class look the same)
string class_id

# The class association support of the observation
# The support is the log odd likelihood ratio given by log(p(y/observation y belongs to object of class class_id) / p(y/observation y is a false positive))
float32 class_support

# A string identifying a specific object
string object_id

# The object association support of the observation
# The support is the log odd likelihood ratio given by log(p(observation belongs to object object_id) / p(observation is false positive or belongs to another object))
float32 object_support

# A string that contains the name or a description of the specific object
string name

"
  end
  attr_accessor :percept

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d7 = ::ROS::Struct.new("d7")
  @@struct_d36 = ::ROS::Struct.new("d36")
  @@struct_f = ::ROS::Struct.new("f")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['hector_worldmodel_msgs/PosePercept']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [hector_worldmodel_msgs/PosePercept] :percept initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:percept]
      @percept = args[:percept]
    else
      @percept = Hector_worldmodel_msgs::PosePercept.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@percept.header.seq, @percept.header.stamp.secs, @percept.header.stamp.nsecs))
      _x = @percept.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7.pack(@percept.pose.pose.position.x, @percept.pose.pose.position.y, @percept.pose.pose.position.z, @percept.pose.pose.orientation.x, @percept.pose.pose.orientation.y, @percept.pose.pose.orientation.z, @percept.pose.pose.orientation.w))
      buff.write(@@struct_d36.pack(*@percept.pose.covariance))
      _x = @percept.info.class_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_f.pack(@percept.info.class_support))
      _x = @percept.info.object_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_f.pack(@percept.info.object_support))
      _x = @percept.info.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @percept == nil
        @percept = Hector_worldmodel_msgs::PosePercept.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@percept.header.seq, @percept.header.stamp.secs, @percept.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @percept.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7')
      (@percept.pose.pose.position.x, @percept.pose.pose.position.y, @percept.pose.pose.position.z, @percept.pose.pose.orientation.x, @percept.pose.pose.orientation.y, @percept.pose.pose.orientation.z, @percept.pose.pose.orientation.w,) = @@struct_d7.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d36')
      @percept.pose.covariance = @@struct_d36.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @percept.info.class_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('f')
      (@percept.info.class_support,) = @@struct_f.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @percept.info.object_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('f')
      (@percept.info.object_support,) = @@struct_f.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @percept.info.name = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
# autogenerated by genrb from VerifyPerceptResponse.msg. Do not edit.
require 'ros/message'


module Hector_worldmodel_msgs

class VerifyPerceptResponse <::ROS::Message
  def self.md5sum
    "a4e2509e523147799a63deb6a40a0721"
  end

  def self.type
    "hector_worldmodel_msgs/VerifyPerceptResponse"
  end

  def has_header?
    false
  end

  def message_definition
    "
uint8 response
uint8 UNKNOWN = 0
uint8 DISCARD = 1
uint8 CONFIRM = 2


"
  end
  # Pseudo-constants
  UNKNOWN = 0
  DISCARD = 1
  CONFIRM = 2

  attr_accessor :response

  @@struct_C = ::ROS::Struct.new("C")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['uint8']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [uint8] :response initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:response]
      @response = args[:response]
    else
      @response = 0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_C.pack(@response))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@response,) = @@struct_C.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
module Hector_worldmodel_msgs
class VerifyPercept
  def self.type
    'hector_worldmodel_msgs/VerifyPercept'
  end
  def self.md5sum
    '4274b9c0812a5a8c107aa29835bb1b45'
  end
  def self.request_class
    VerifyPerceptRequest
  end
  def self.response_class
    VerifyPerceptResponse
  end
end
end