# autogenerated by genrb from DatabaseModelPoseList.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/PoseStamped"
require "object_recognition_msgs/ObjectType"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "household_objects_database_msgs/DatabaseModelPose"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Pose"

module Household_objects_database_msgs

class DatabaseModelPoseList <::ROS::Message
  def self.md5sum
    "f0bb2aa8d2ededee0ffe0f5d2107e099"
  end

  def self.type
    "household_objects_database_msgs/DatabaseModelPoseList"
  end

  def has_header?
    false
  end

  def message_definition
    "# stores a list of possible database models recognition results
DatabaseModelPose[] model_list
================================================================================
MSG: household_objects_database_msgs/DatabaseModelPose
# Informs that a specific model from the Model Database has been 
# identified at a certain location

# the database id of the model
int32 model_id

# if the object was recognized by the ORK pipeline, its type will be in here
# if this is not empty, then the string in here will be converted to a household_objects_database id
# leave this empty if providing an id in the model_id field
object_recognition_msgs/ObjectType type

# the pose that it can be found in
geometry_msgs/PoseStamped pose

# a measure of the confidence level in this detection result
float32 confidence

# the name of the object detector that generated this detection result
string detector_name

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :model_list

  @@struct_f = ::ROS::Struct.new("f")
  @@struct_l = ::ROS::Struct.new("l")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['household_objects_database_msgs/DatabaseModelPose[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [household_objects_database_msgs/DatabaseModelPose[]] :model_list initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:model_list]
      @model_list = args[:model_list]
    else
      @model_list = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      length = @model_list.length
      buff.write(@@struct_L.pack(length))
      for val1 in @model_list
        buff.write(@@struct_l.pack(val1.model_id))
        _v1 = val1.type
        _x = _v1.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v1.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2 = val1.pose
        _v3 = _v2.header
        buff.write(@@struct_L.pack(_v3.seq))
        _v4 = _v3.stamp
        _x = _v4
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v5 = _v2.pose
        _v6 = _v5.position
        _x = _v6
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v7 = _v5.orientation
        _x = _v7
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_f.pack(val1.confidence))
        _x = val1.detector_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @model_list == nil
        @model_list = Household_objects_database_msgs::DatabaseModelPose[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @model_list = []
      length.times do
        val1 = Household_objects_database_msgs::DatabaseModelPose.new
        start = end_point
        end_point += ROS::Struct::calc_size('l')
        (val1.model_id,) = @@struct_l.unpack(str[start..(end_point-1)])
        _v8 = val1.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v8.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v8.db = str[start..(end_point-1)]
        _v9 = val1.pose
        _v10 = _v9.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v10.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v11 = _v10.stamp
        _x = _v11
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v10.frame_id = str[start..(end_point-1)]
        _v12 = _v9.pose
        _v13 = _v12.position
        _x = _v13
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v14 = _v12.orientation
        _x = _v14
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.confidence,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.detector_name = str[start..(end_point-1)]
        @model_list.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
