# autogenerated by genrb from DatabaseScan.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Point"
require "geometry_msgs/Pose"
require "geometry_msgs/PoseStamped"

module Household_objects_database_msgs

class DatabaseScan <::ROS::Message
  def self.md5sum
    "7edb7abec4973143a801c25c336b4bb1"
  end

  def self.type
    "household_objects_database_msgs/DatabaseScan"
  end

  def has_header?
    false
  end

  def message_definition
    "# Contains the location of a stored point cloud scan of an object, 
# as well as additional metadata about that scan 

# the database id of the model
int32 model_id

# the location of the bag file storing the scan
string bagfile_location

# the source of the scan (e.g. simulation)
string scan_source

# the ground truth pose of the object that was scanned
geometry_msgs/PoseStamped pose

# the topic that the points in the bag are published on
string cloud_topic
================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :model_id, :bagfile_location, :scan_source, :pose, :cloud_topic

  @@struct_l = ::ROS::Struct.new("l")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d7 = ::ROS::Struct.new("d7")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['int32','string','string','geometry_msgs/PoseStamped','string']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [int32] :model_id initialize value
  # @option args [string] :bagfile_location initialize value
  # @option args [string] :scan_source initialize value
  # @option args [geometry_msgs/PoseStamped] :pose initialize value
  # @option args [string] :cloud_topic initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:model_id]
      @model_id = args[:model_id]
    else
      @model_id = 0
    end
    if args[:bagfile_location]
      @bagfile_location = args[:bagfile_location]
    else
      @bagfile_location = ''
    end
    if args[:scan_source]
      @scan_source = args[:scan_source]
    else
      @scan_source = ''
    end
    if args[:pose]
      @pose = args[:pose]
    else
      @pose = Geometry_msgs::PoseStamped.new
    end
    if args[:cloud_topic]
      @cloud_topic = args[:cloud_topic]
    else
      @cloud_topic = ''
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_l.pack(@model_id))
      _x = @bagfile_location
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @scan_source
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@pose.header.seq, @pose.header.stamp.secs, @pose.header.stamp.nsecs))
      _x = @pose.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7.pack(@pose.pose.position.x, @pose.pose.position.y, @pose.pose.position.z, @pose.pose.orientation.x, @pose.pose.orientation.y, @pose.pose.orientation.z, @pose.pose.orientation.w))
      _x = @cloud_topic
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @pose == nil
        @pose = Geometry_msgs::PoseStamped.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('l')
      (@model_id,) = @@struct_l.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @bagfile_location = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @scan_source = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@pose.header.seq, @pose.header.stamp.secs, @pose.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @pose.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7')
      (@pose.pose.position.x, @pose.pose.position.y, @pose.pose.position.z, @pose.pose.orientation.x, @pose.pose.orientation.y, @pose.pose.orientation.z, @pose.pose.orientation.w,) = @@struct_d7.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @cloud_topic = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
