# autogenerated by genrb from SaveScanRequest.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Point"
require "geometry_msgs/Pose"
require "geometry_msgs/PoseStamped"

module Household_objects_database_msgs

class SaveScanRequest <::ROS::Message
  def self.md5sum
    "492f49d320aa26325df5fb078c297fa5"
  end

  def self.type
    "household_objects_database_msgs/SaveScanRequest"
  end

  def has_header?
    false
  end

  def message_definition
    "


int32 scaled_model_id


geometry_msgs/PoseStamped ground_truth_pose


string bagfile_location


string scan_source


string cloud_topic


================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :scaled_model_id, :ground_truth_pose, :bagfile_location, :scan_source, :cloud_topic

  @@struct_lL3 = ::ROS::Struct.new("lL3")
  @@struct_d7 = ::ROS::Struct.new("d7")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['int32','geometry_msgs/PoseStamped','string','string','string']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [int32] :scaled_model_id initialize value
  # @option args [geometry_msgs/PoseStamped] :ground_truth_pose initialize value
  # @option args [string] :bagfile_location initialize value
  # @option args [string] :scan_source initialize value
  # @option args [string] :cloud_topic initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:scaled_model_id]
      @scaled_model_id = args[:scaled_model_id]
    else
      @scaled_model_id = 0
    end
    if args[:ground_truth_pose]
      @ground_truth_pose = args[:ground_truth_pose]
    else
      @ground_truth_pose = Geometry_msgs::PoseStamped.new
    end
    if args[:bagfile_location]
      @bagfile_location = args[:bagfile_location]
    else
      @bagfile_location = ''
    end
    if args[:scan_source]
      @scan_source = args[:scan_source]
    else
      @scan_source = ''
    end
    if args[:cloud_topic]
      @cloud_topic = args[:cloud_topic]
    else
      @cloud_topic = ''
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_lL3.pack(@scaled_model_id, @ground_truth_pose.header.seq, @ground_truth_pose.header.stamp.secs, @ground_truth_pose.header.stamp.nsecs))
      _x = @ground_truth_pose.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7.pack(@ground_truth_pose.pose.position.x, @ground_truth_pose.pose.position.y, @ground_truth_pose.pose.position.z, @ground_truth_pose.pose.orientation.x, @ground_truth_pose.pose.orientation.y, @ground_truth_pose.pose.orientation.z, @ground_truth_pose.pose.orientation.w))
      _x = @bagfile_location
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @scan_source
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @cloud_topic
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @ground_truth_pose == nil
        @ground_truth_pose = Geometry_msgs::PoseStamped.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('lL3')
      (@scaled_model_id, @ground_truth_pose.header.seq, @ground_truth_pose.header.stamp.secs, @ground_truth_pose.header.stamp.nsecs,) = @@struct_lL3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @ground_truth_pose.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7')
      (@ground_truth_pose.pose.position.x, @ground_truth_pose.pose.position.y, @ground_truth_pose.pose.position.z, @ground_truth_pose.pose.orientation.x, @ground_truth_pose.pose.orientation.y, @ground_truth_pose.pose.orientation.z, @ground_truth_pose.pose.orientation.w,) = @@struct_d7.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @bagfile_location = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @scan_source = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @cloud_topic = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
# autogenerated by genrb from SaveScanResponse.msg. Do not edit.
require 'ros/message'

require "household_objects_database_msgs/DatabaseReturnCode"

module Household_objects_database_msgs

class SaveScanResponse <::ROS::Message
  def self.md5sum
    "b49fccceeb56b964ed23601916a24082"
  end

  def self.type
    "household_objects_database_msgs/SaveScanResponse"
  end

  def has_header?
    false
  end

  def message_definition
    "

DatabaseReturnCode return_code

================================================================================
MSG: household_objects_database_msgs/DatabaseReturnCode
# return codes for database-related services

int32 UNKNOWN_ERROR = 1
int32 DATABASE_NOT_CONNECTED = 2
int32 DATABASE_QUERY_ERROR = 3
int32 SUCCESS = -1

int32 code
"
  end
  attr_accessor :return_code

  @@struct_l = ::ROS::Struct.new("l")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['household_objects_database_msgs/DatabaseReturnCode']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [household_objects_database_msgs/DatabaseReturnCode] :return_code initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:return_code]
      @return_code = args[:return_code]
    else
      @return_code = Household_objects_database_msgs::DatabaseReturnCode.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_l.pack(@return_code.code))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @return_code == nil
        @return_code = Household_objects_database_msgs::DatabaseReturnCode.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('l')
      (@return_code.code,) = @@struct_l.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
module Household_objects_database_msgs
class SaveScan
  def self.type
    'household_objects_database_msgs/SaveScan'
  end
  def self.md5sum
    '855c7b6f2658d8a9de03dd9a5f7b1f1e'
  end
  def self.request_class
    SaveScanRequest
  end
  def self.response_class
    SaveScanResponse
  end
end
end