# autogenerated by genrb from Helm.msg. Do not edit.
require 'ros/message'


module Kingfisher_msgs

class Helm <::ROS::Message
  def self.md5sum
    "e2d59470d537e1bf55bc57a5005f3cd5"
  end

  def self.type
    "kingfisher_msgs/Helm"
  end

  def has_header?
    false
  end

  def message_definition
    "# Command a percentage amount of total thrust capacity, and an turn rate.
# On a conventional craft, turn rate would map to rudder.

# Thrust amount ranges from [-1.0..1.0], where 1.0 pushes Kingfisher forward.
float32 thrust

# Yaw rate specified in radians/sec, where positive values cause Kingfisher
# to turn toward the port deck. The controller will use feedback from the
# IMU's gyroscopes to attempt to match the command rate.
float32 yaw_rate


"
  end
  attr_accessor :thrust, :yaw_rate

  @@struct_f2 = ::ROS::Struct.new("f2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['float32','float32']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [float32] :thrust initialize value
  # @option args [float32] :yaw_rate initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:thrust]
      @thrust = args[:thrust]
    else
      @thrust = 0.0
    end
    if args[:yaw_rate]
      @yaw_rate = args[:yaw_rate]
    else
      @yaw_rate = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_f2.pack(@thrust, @yaw_rate))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('f2')
      (@thrust, @yaw_rate,) = @@struct_f2.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
