# autogenerated by genrb from Sense.msg. Do not edit.
require 'ros/message'


module Kingfisher_msgs

class Sense <::ROS::Message
  def self.md5sum
    "b0209acddc7f26d2e3dc1338d6c4df94"
  end

  def self.type
    "kingfisher_msgs/Sense"
  end

  def has_header?
    false
  end

  def message_definition
    "# General MCU status for Kingfisher transmitted from the MCU
# to higher-level software on the /sense topic.

# Voltage level of battery, in volts
float32 battery

# Instantaneous current drawn by each motor, in amps.
float32 current_left
float32 current_right

# Temperature of PCB as measured by internal AVR thermometer,
# reported in degrees centigrade.
float32 pcb_temperature
bool fan_on

# Bitfield represents status of hobby R/C override.
uint8 RC_INRANGE=1
uint8 RC_INUSE=2
uint8 rc

# Pulse lengths received from the three R/C channels.
uint16 rc_throttle
uint16 rc_rotation
uint16 rc_enable

"
  end
  # Pseudo-constants
  RC_INRANGE = 1
  RC_INUSE = 2

  attr_accessor :battery, :current_left, :current_right, :pcb_temperature, :fan_on, :rc, :rc_throttle, :rc_rotation, :rc_enable

  @@struct_f4C2S3 = ::ROS::Struct.new("f4C2S3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['float32','float32','float32','float32','bool','uint8','uint16','uint16','uint16']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [float32] :battery initialize value
  # @option args [float32] :current_left initialize value
  # @option args [float32] :current_right initialize value
  # @option args [float32] :pcb_temperature initialize value
  # @option args [bool] :fan_on initialize value
  # @option args [uint8] :rc initialize value
  # @option args [uint16] :rc_throttle initialize value
  # @option args [uint16] :rc_rotation initialize value
  # @option args [uint16] :rc_enable initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:battery]
      @battery = args[:battery]
    else
      @battery = 0.0
    end
    if args[:current_left]
      @current_left = args[:current_left]
    else
      @current_left = 0.0
    end
    if args[:current_right]
      @current_right = args[:current_right]
    else
      @current_right = 0.0
    end
    if args[:pcb_temperature]
      @pcb_temperature = args[:pcb_temperature]
    else
      @pcb_temperature = 0.0
    end
    if args[:fan_on]
      @fan_on = args[:fan_on]
    else
      @fan_on = false
    end
    if args[:rc]
      @rc = args[:rc]
    else
      @rc = 0
    end
    if args[:rc_throttle]
      @rc_throttle = args[:rc_throttle]
    else
      @rc_throttle = 0
    end
    if args[:rc_rotation]
      @rc_rotation = args[:rc_rotation]
    else
      @rc_rotation = 0
    end
    if args[:rc_enable]
      @rc_enable = args[:rc_enable]
    else
      @rc_enable = 0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_f4C2S3.pack(@battery, @current_left, @current_right, @pcb_temperature, @fan_on, @rc, @rc_throttle, @rc_rotation, @rc_enable))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('f4C2S3')
      (@battery, @current_left, @current_right, @pcb_temperature, @fan_on, @rc, @rc_throttle, @rc_rotation, @rc_enable,) = @@struct_f4C2S3.unpack(str[start..(end_point-1)])
      @fan_on = bool(@fan_on)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
