# autogenerated by genrb from CliffEvent.msg. Do not edit.
require 'ros/message'


module Kobuki_msgs

class CliffEvent <::ROS::Message
  def self.md5sum
    "c5b106efbb1427a94f517c5e05f06295"
  end

  def self.type
    "kobuki_msgs/CliffEvent"
  end

  def has_header?
    false
  end

  def message_definition
    "# Provides a cliff sensor event.
# This message is generated whenever a particular cliff sensor signals that the
# robot approaches or moves away from a cliff.
# Note that, despite cliff field on SensorState messages, state field is not a
# bitmask, but the new state of a single sensor.

# cliff sensor
uint8 LEFT   = 0
uint8 CENTER = 1
uint8 RIGHT  = 2

# cliff sensor state
uint8 FLOOR = 0
uint8 CLIFF = 1

uint8 sensor
uint8 state

# distance to floor when cliff was detected
uint16 bottom
"
  end
  # Pseudo-constants
  LEFT = 0
  CENTER = 1
  RIGHT = 2
  FLOOR = 0
  CLIFF = 1

  attr_accessor :sensor, :state, :bottom

  @@struct_C2S = ::ROS::Struct.new("C2S")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['uint8','uint8','uint16']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [uint8] :sensor initialize value
  # @option args [uint8] :state initialize value
  # @option args [uint16] :bottom initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:sensor]
      @sensor = args[:sensor]
    else
      @sensor = 0
    end
    if args[:state]
      @state = args[:state]
    else
      @state = 0
    end
    if args[:bottom]
      @bottom = args[:bottom]
    else
      @bottom = 0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_C2S.pack(@sensor, @state, @bottom))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('C2S')
      (@sensor, @state, @bottom,) = @@struct_C2S.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
