# autogenerated by genrb from SensorState.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"

module Kobuki_msgs

class SensorState <::ROS::Message
  def self.md5sum
    "430a4bfd78449c8740bfef32b26613a6"
  end

  def self.type
    "kobuki_msgs/SensorState"
  end

  def has_header?
    true
  end

  def message_definition
    "# Kobuki Sensor Data Messages
#
# For more direct simple interactions (buttons, leds, gyro, motor velocity
# etc) use the other topics. This provides detailed information about the
# entire state package that is transmitted at 50Hz from the robot.
#


###### CONSTANTS ######
# Bumper states (states are combined, when multiple bumpers are pressed)
uint8 BUMPER_RIGHT  = 1
uint8 BUMPER_CENTRE = 2
uint8 BUMPER_LEFT   = 4

# Wheel drop sensor states (states are combined, when both wheel drop sensors are triggered)
uint8 WHEEL_DROP_RIGHT = 1
uint8 WHEEL_DROP_LEFT  = 2

# Cliff sensor states (states are combined, when multiple cliff sensors are triggered)
uint8 CLIFF_RIGHT  = 1
uint8 CLIFF_CENTRE = 2
uint8 CLIFF_LEFT   = 4

# Button states (only one button can be triggered at a time)
uint8 BUTTON0 = 1
uint8 BUTTON1 = 2
uint8 BUTTON2 = 4

# Charger state is a combination of charging device (adapter, docking station)
# and state (charging, charged, discharging):
uint8 DISCHARGING      = 0
uint8 DOCKING_CHARGED  = 2
uint8 DOCKING_CHARGING = 6
uint8 ADAPTER_CHARGED  = 18
uint8 ADAPTER_CHARGING = 22

# Over current states
uint8 OVER_CURRENT_LEFT_WHEEL  = 1
uint8 OVER_CURRENT_RIGHT_WHEEL = 2
uint8 OVER_CURRENT_BOTH_WHEELS = 3

# Digital input states (states are combined, when multiple inputs are set at the same time)
# When connecting Yujin's test board, it acts as pull-up what inverts the behaviour:
# No input: 79, all inputs set (e.g. buttons pressed): 64
uint8 DIGITAL_INPUT0 = 1
uint8 DIGITAL_INPUT1 = 2
uint8 DIGITAL_INPUT2 = 4
uint8 DIGITAL_INPUT3 = 8
uint8 DB25_TEST_BOARD_CONNECTED = 64

###### MESSAGE ######

Header header

###################
# Core Packet
###################
uint16 time_stamp      # milliseconds starting when turning on Kobuki (max. 65536, then starts from 0 again)
uint8  bumper          # see bumper states
uint8  wheel_drop      # see wheel drop sensor states
uint8  cliff           # see cliff sensor states
uint16 left_encoder    # accumulated ticks left wheel starting with turning on Kobuki (max. 65535)
uint16 right_encoder   # accumulated ticks right wheel starting with turning on Kobuki (max. 65535)
int8   left_pwm        # % of applied maximum voltage left wheel: -100 (max. voltage backward) to +100 (max. voltage forward)
int8   right_pwm       # % of applied maximum voltage right wheel: -100 (max. voltage backward) to +100 (max. voltage forward)
uint8  buttons         # see button states
uint8  charger         # see charger states
uint8  battery         # battery voltage in 0.1V (ex. 16.1V -> 161)

###################
# Cliff Packet
###################
uint16[] bottom        # ADC output of the right, centre, left cliff PSD sensor (0 - 4095, distance measure is non-linear)

###################
# Current Packet
###################
uint8[] current        # motor current for the left and right motor in 10mA (ex. 12 -> 120mA)
uint8   over_current   # see over current states

###################
# Input Packet
###################
uint16   digital_input # see digital input states; will show garbage when nothing is connected
uint16[] analog_input  # ADC values for the 4 analog inputs; 0 - 4095: 0.0 - 3.3V; will show garbage when nothing is connected

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  # Pseudo-constants
  BUMPER_RIGHT = 1
  BUMPER_CENTRE = 2
  BUMPER_LEFT = 4
  WHEEL_DROP_RIGHT = 1
  WHEEL_DROP_LEFT = 2
  CLIFF_RIGHT = 1
  CLIFF_CENTRE = 2
  CLIFF_LEFT = 4
  BUTTON0 = 1
  BUTTON1 = 2
  BUTTON2 = 4
  DISCHARGING = 0
  DOCKING_CHARGED = 2
  DOCKING_CHARGING = 6
  ADAPTER_CHARGED = 18
  ADAPTER_CHARGING = 22
  OVER_CURRENT_LEFT_WHEEL = 1
  OVER_CURRENT_RIGHT_WHEEL = 2
  OVER_CURRENT_BOTH_WHEELS = 3
  DIGITAL_INPUT0 = 1
  DIGITAL_INPUT1 = 2
  DIGITAL_INPUT2 = 4
  DIGITAL_INPUT3 = 8
  DB25_TEST_BOARD_CONNECTED = 64

  attr_accessor :header, :time_stamp, :bumper, :wheel_drop, :cliff, :left_encoder, :right_encoder, :left_pwm, :right_pwm, :buttons, :charger, :battery, :bottom, :current, :over_current, :digital_input, :analog_input

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_SC3S2c2C3 = ::ROS::Struct.new("SC3S2c2C3")
  @@struct_CS = ::ROS::Struct.new("CS")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','uint16','uint8','uint8','uint8','uint16','uint16','int8','int8','uint8','uint8','uint8','uint16[]','uint8[]','uint8','uint16','uint16[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [uint16] :time_stamp initialize value
  # @option args [uint8] :bumper initialize value
  # @option args [uint8] :wheel_drop initialize value
  # @option args [uint8] :cliff initialize value
  # @option args [uint16] :left_encoder initialize value
  # @option args [uint16] :right_encoder initialize value
  # @option args [int8] :left_pwm initialize value
  # @option args [int8] :right_pwm initialize value
  # @option args [uint8] :buttons initialize value
  # @option args [uint8] :charger initialize value
  # @option args [uint8] :battery initialize value
  # @option args [uint16[]] :bottom initialize value
  # @option args [uint8[]] :current initialize value
  # @option args [uint8] :over_current initialize value
  # @option args [uint16] :digital_input initialize value
  # @option args [uint16[]] :analog_input initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:time_stamp]
      @time_stamp = args[:time_stamp]
    else
      @time_stamp = 0
    end
    if args[:bumper]
      @bumper = args[:bumper]
    else
      @bumper = 0
    end
    if args[:wheel_drop]
      @wheel_drop = args[:wheel_drop]
    else
      @wheel_drop = 0
    end
    if args[:cliff]
      @cliff = args[:cliff]
    else
      @cliff = 0
    end
    if args[:left_encoder]
      @left_encoder = args[:left_encoder]
    else
      @left_encoder = 0
    end
    if args[:right_encoder]
      @right_encoder = args[:right_encoder]
    else
      @right_encoder = 0
    end
    if args[:left_pwm]
      @left_pwm = args[:left_pwm]
    else
      @left_pwm = 0
    end
    if args[:right_pwm]
      @right_pwm = args[:right_pwm]
    else
      @right_pwm = 0
    end
    if args[:buttons]
      @buttons = args[:buttons]
    else
      @buttons = 0
    end
    if args[:charger]
      @charger = args[:charger]
    else
      @charger = 0
    end
    if args[:battery]
      @battery = args[:battery]
    else
      @battery = 0
    end
    if args[:bottom]
      @bottom = args[:bottom]
    else
      @bottom = []
    end
    if args[:current]
      @current = args[:current]
    else
      @current = ''
    end
    if args[:over_current]
      @over_current = args[:over_current]
    else
      @over_current = 0
    end
    if args[:digital_input]
      @digital_input = args[:digital_input]
    else
      @digital_input = 0
    end
    if args[:analog_input]
      @analog_input = args[:analog_input]
    else
      @analog_input = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_SC3S2c2C3.pack(@time_stamp, @bumper, @wheel_drop, @cliff, @left_encoder, @right_encoder, @left_pwm, @right_pwm, @buttons, @charger, @battery))
      length = @bottom.length
      buff.write(@@struct_L.pack(length))
      pattern = "S#{length}"
      buff.write(*@bottom.pack(pattern))
      _x = @current
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_CS.pack(@over_current, @digital_input))
      length = @analog_input.length
      buff.write(@@struct_L.pack(length))
      pattern = "S#{length}"
      buff.write(*@analog_input.pack(pattern))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('SC3S2c2C3')
      (@time_stamp, @bumper, @wheel_drop, @cliff, @left_encoder, @right_encoder, @left_pwm, @right_pwm, @buttons, @charger, @battery,) = @@struct_SC3S2c2C3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "S#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @bottom = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @current = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('CS')
      (@over_current, @digital_input,) = @@struct_CS.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "S#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @analog_input = str[start..(end_point-1)].unpack(pattern)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
