# autogenerated by genrb from VersionInfo.msg. Do not edit.
require 'ros/message'


module Kobuki_msgs

class VersionInfo <::ROS::Message
  def self.md5sum
    "3dc0ce6edd49be1fc86730f4a4a21861"
  end

  def self.type
    "kobuki_msgs/VersionInfo"
  end

  def has_header?
    false
  end

  def message_definition
    "# Contains unique device id, version info and available features for the kobuki platform.
# Useful for compatibility checking and introspection

string hardware   # <major>.<minor>.<patch>
string firmware   # <major>.<minor>.<patch>
string software   # Still to decide how it will look
uint32[] udid

# Bitmask that specifies the available features in the firmware and/or driver
uint64 features

# The following represent the bit fields corresponding to bits in the features value

# Provided firmware kobuki_firmware_1.1.1.hex
uint64 SMOOTH_MOVE_START    = 0000000000000001
uint64 GYROSCOPE_3D_DATA    = 0000000000000002

"
  end
  # Pseudo-constants
  SMOOTH_MOVE_START = 1
  GYROSCOPE_3D_DATA = 2

  attr_accessor :hardware, :firmware, :software, :udid, :features

  @@struct_Q = ::ROS::Struct.new("Q")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','string','string','uint32[]','uint64']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :hardware initialize value
  # @option args [string] :firmware initialize value
  # @option args [string] :software initialize value
  # @option args [uint32[]] :udid initialize value
  # @option args [uint64] :features initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:hardware]
      @hardware = args[:hardware]
    else
      @hardware = ''
    end
    if args[:firmware]
      @firmware = args[:firmware]
    else
      @firmware = ''
    end
    if args[:software]
      @software = args[:software]
    else
      @software = ''
    end
    if args[:udid]
      @udid = args[:udid]
    else
      @udid = []
    end
    if args[:features]
      @features = args[:features]
    else
      @features = 0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @hardware
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @firmware
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @software
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @udid.length
      buff.write(@@struct_L.pack(length))
      pattern = "L#{length}"
      buff.write(*@udid.pack(pattern))
      buff.write(@@struct_Q.pack(@features))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @hardware = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @firmware = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @software = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "L#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @udid = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('Q')
      (@features,) = @@struct_Q.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
