# autogenerated by genrb from ClusterBoundingBox.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/PoseStamped"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "geometry_msgs/Pose"

module Manipulation_msgs

class ClusterBoundingBox <::ROS::Message
  def self.md5sum
    "9bf2b7a44ad666dc3a6a2bbc21782dad"
  end

  def self.type
    "manipulation_msgs/ClusterBoundingBox"
  end

  def has_header?
    false
  end

  def message_definition
    "# contains a bounding box, which is essentially a box somewhere in space
# used here ususally for the outlier-invariant bounding box of a cluster of points

#the pose of the box frame
geometry_msgs/PoseStamped pose_stamped

#the dimensions of the box
geometry_msgs/Vector3 dimensions

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :pose_stamped, :dimensions

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d10 = ::ROS::Struct.new("d10")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['geometry_msgs/PoseStamped','geometry_msgs/Vector3']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [geometry_msgs/PoseStamped] :pose_stamped initialize value
  # @option args [geometry_msgs/Vector3] :dimensions initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:pose_stamped]
      @pose_stamped = args[:pose_stamped]
    else
      @pose_stamped = Geometry_msgs::PoseStamped.new
    end
    if args[:dimensions]
      @dimensions = args[:dimensions]
    else
      @dimensions = Geometry_msgs::Vector3.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@pose_stamped.header.seq, @pose_stamped.header.stamp.secs, @pose_stamped.header.stamp.nsecs))
      _x = @pose_stamped.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d10.pack(@pose_stamped.pose.position.x, @pose_stamped.pose.position.y, @pose_stamped.pose.position.z, @pose_stamped.pose.orientation.x, @pose_stamped.pose.orientation.y, @pose_stamped.pose.orientation.z, @pose_stamped.pose.orientation.w, @dimensions.x, @dimensions.y, @dimensions.z))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @pose_stamped == nil
        @pose_stamped = Geometry_msgs::PoseStamped.new
      end
      if @dimensions == nil
        @dimensions = Geometry_msgs::Vector3.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@pose_stamped.header.seq, @pose_stamped.header.stamp.secs, @pose_stamped.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @pose_stamped.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d10')
      (@pose_stamped.pose.position.x, @pose_stamped.pose.position.y, @pose_stamped.pose.position.z, @pose_stamped.pose.orientation.x, @pose_stamped.pose.orientation.y, @pose_stamped.pose.orientation.z, @pose_stamped.pose.orientation.w, @dimensions.x, @dimensions.y, @dimensions.z,) = @@struct_d10.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
