# autogenerated by genrb from Grasp.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Vector3Stamped"
require "geometry_msgs/PoseStamped"
require "sensor_msgs/JointState"
require "manipulation_msgs/GripperTranslation"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "geometry_msgs/Pose"

module Manipulation_msgs

class Grasp <::ROS::Message
  def self.md5sum
    "83bd11da422ea1917259ee456c0e315a"
  end

  def self.type
    "manipulation_msgs/Grasp"
  end

  def has_header?
    false
  end

  def message_definition
    "# A name for this grasp
string id

# The internal posture of the hand for the pre-grasp
# only positions are used
sensor_msgs/JointState pre_grasp_posture

# The internal posture of the hand for the grasp
# positions and efforts are used
sensor_msgs/JointState grasp_posture

# The position of the end-effector for the grasp 
geometry_msgs/PoseStamped grasp_pose

# The estimated probability of success for this grasp, or some other
# measure of how \"good\" it is.
float64 grasp_quality

# The approach motion
GripperTranslation approach

# The retreat motion
GripperTranslation retreat

# the maximum contact force to use while grasping (<=0 to disable)
float32 max_contact_force

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping
string[] allowed_touch_objects

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: manipulation_msgs/GripperTranslation
# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :id, :pre_grasp_posture, :grasp_posture, :grasp_pose, :grasp_quality, :approach, :retreat, :max_contact_force, :allowed_touch_objects

  @@struct_d8L3 = ::ROS::Struct.new("d8L3")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d3f3 = ::ROS::Struct.new("d3f3")
  @@struct_d3f2L3 = ::ROS::Struct.new("d3f2L3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','sensor_msgs/JointState','sensor_msgs/JointState','geometry_msgs/PoseStamped','float64','manipulation_msgs/GripperTranslation','manipulation_msgs/GripperTranslation','float32','string[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :id initialize value
  # @option args [sensor_msgs/JointState] :pre_grasp_posture initialize value
  # @option args [sensor_msgs/JointState] :grasp_posture initialize value
  # @option args [geometry_msgs/PoseStamped] :grasp_pose initialize value
  # @option args [float64] :grasp_quality initialize value
  # @option args [manipulation_msgs/GripperTranslation] :approach initialize value
  # @option args [manipulation_msgs/GripperTranslation] :retreat initialize value
  # @option args [float32] :max_contact_force initialize value
  # @option args [string[]] :allowed_touch_objects initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:id]
      @id = args[:id]
    else
      @id = ''
    end
    if args[:pre_grasp_posture]
      @pre_grasp_posture = args[:pre_grasp_posture]
    else
      @pre_grasp_posture = Sensor_msgs::JointState.new
    end
    if args[:grasp_posture]
      @grasp_posture = args[:grasp_posture]
    else
      @grasp_posture = Sensor_msgs::JointState.new
    end
    if args[:grasp_pose]
      @grasp_pose = args[:grasp_pose]
    else
      @grasp_pose = Geometry_msgs::PoseStamped.new
    end
    if args[:grasp_quality]
      @grasp_quality = args[:grasp_quality]
    else
      @grasp_quality = 0.0
    end
    if args[:approach]
      @approach = args[:approach]
    else
      @approach = Manipulation_msgs::GripperTranslation.new
    end
    if args[:retreat]
      @retreat = args[:retreat]
    else
      @retreat = Manipulation_msgs::GripperTranslation.new
    end
    if args[:max_contact_force]
      @max_contact_force = args[:max_contact_force]
    else
      @max_contact_force = 0.0
    end
    if args[:allowed_touch_objects]
      @allowed_touch_objects = args[:allowed_touch_objects]
    else
      @allowed_touch_objects = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@pre_grasp_posture.header.seq, @pre_grasp_posture.header.stamp.secs, @pre_grasp_posture.header.stamp.nsecs))
      _x = @pre_grasp_posture.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @pre_grasp_posture.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @pre_grasp_posture.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @pre_grasp_posture.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@pre_grasp_posture.position.pack(pattern))
      length = @pre_grasp_posture.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@pre_grasp_posture.velocity.pack(pattern))
      length = @pre_grasp_posture.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@pre_grasp_posture.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@grasp_posture.header.seq, @grasp_posture.header.stamp.secs, @grasp_posture.header.stamp.nsecs))
      _x = @grasp_posture.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @grasp_posture.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @grasp_posture.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @grasp_posture.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@grasp_posture.position.pack(pattern))
      length = @grasp_posture.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@grasp_posture.velocity.pack(pattern))
      length = @grasp_posture.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@grasp_posture.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@grasp_pose.header.seq, @grasp_pose.header.stamp.secs, @grasp_pose.header.stamp.nsecs))
      _x = @grasp_pose.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d8L3.pack(@grasp_pose.pose.position.x, @grasp_pose.pose.position.y, @grasp_pose.pose.position.z, @grasp_pose.pose.orientation.x, @grasp_pose.pose.orientation.y, @grasp_pose.pose.orientation.z, @grasp_pose.pose.orientation.w, @grasp_quality, @approach.direction.header.seq, @approach.direction.header.stamp.secs, @approach.direction.header.stamp.nsecs))
      _x = @approach.direction.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3f2L3.pack(@approach.direction.vector.x, @approach.direction.vector.y, @approach.direction.vector.z, @approach.desired_distance, @approach.min_distance, @retreat.direction.header.seq, @retreat.direction.header.stamp.secs, @retreat.direction.header.stamp.nsecs))
      _x = @retreat.direction.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3f3.pack(@retreat.direction.vector.x, @retreat.direction.vector.y, @retreat.direction.vector.z, @retreat.desired_distance, @retreat.min_distance, @max_contact_force))
      length = @allowed_touch_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @allowed_touch_objects
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @pre_grasp_posture == nil
        @pre_grasp_posture = Sensor_msgs::JointState.new
      end
      if @grasp_posture == nil
        @grasp_posture = Sensor_msgs::JointState.new
      end
      if @grasp_pose == nil
        @grasp_pose = Geometry_msgs::PoseStamped.new
      end
      if @approach == nil
        @approach = Manipulation_msgs::GripperTranslation.new
      end
      if @retreat == nil
        @retreat = Manipulation_msgs::GripperTranslation.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@pre_grasp_posture.header.seq, @pre_grasp_posture.header.stamp.secs, @pre_grasp_posture.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @pre_grasp_posture.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @pre_grasp_posture.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @pre_grasp_posture.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @pre_grasp_posture.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @pre_grasp_posture.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @pre_grasp_posture.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@grasp_posture.header.seq, @grasp_posture.header.stamp.secs, @grasp_posture.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @grasp_posture.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @grasp_posture.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @grasp_posture.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @grasp_posture.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @grasp_posture.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @grasp_posture.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@grasp_pose.header.seq, @grasp_pose.header.stamp.secs, @grasp_pose.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @grasp_pose.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d8L3')
      (@grasp_pose.pose.position.x, @grasp_pose.pose.position.y, @grasp_pose.pose.position.z, @grasp_pose.pose.orientation.x, @grasp_pose.pose.orientation.y, @grasp_pose.pose.orientation.z, @grasp_pose.pose.orientation.w, @grasp_quality, @approach.direction.header.seq, @approach.direction.header.stamp.secs, @approach.direction.header.stamp.nsecs,) = @@struct_d8L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @approach.direction.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3f2L3')
      (@approach.direction.vector.x, @approach.direction.vector.y, @approach.direction.vector.z, @approach.desired_distance, @approach.min_distance, @retreat.direction.header.seq, @retreat.direction.header.stamp.secs, @retreat.direction.header.stamp.nsecs,) = @@struct_d3f2L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @retreat.direction.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3f3')
      (@retreat.direction.vector.x, @retreat.direction.vector.y, @retreat.direction.vector.z, @retreat.desired_distance, @retreat.min_distance, @max_contact_force,) = @@struct_d3f3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @allowed_touch_objects = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @allowed_touch_objects.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
