# autogenerated by genrb from GraspPlanningAction.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "sensor_msgs/PointField"
require "geometry_msgs/Point32"
require "geometry_msgs/Point"
require "geometry_msgs/Vector3Stamped"
require "manipulation_msgs/GraspPlanningErrorCode"
require "sensor_msgs/CameraInfo"
require "household_objects_database_msgs/DatabaseModelPose"
require "sensor_msgs/PointCloud2"
require "actionlib_msgs/GoalStatus"
require "sensor_msgs/Image"
require "manipulation_msgs/GraspPlanningActionGoal"
require "geometry_msgs/PoseStamped"
require "std_msgs/Header"
require "sensor_msgs/ChannelFloat32"
require "geometry_msgs/Pose"
require "sensor_msgs/RegionOfInterest"
require "manipulation_msgs/GripperTranslation"
require "manipulation_msgs/GraspPlanningResult"
require "manipulation_msgs/GraspPlanningFeedback"
require "geometry_msgs/Quaternion"
require "manipulation_msgs/GraspPlanningGoal"
require "actionlib_msgs/GoalID"
require "manipulation_msgs/GraspPlanningActionFeedback"
require "manipulation_msgs/Grasp"
require "sensor_msgs/JointState"
require "manipulation_msgs/GraspPlanningActionResult"
require "sensor_msgs/PointCloud"
require "object_recognition_msgs/ObjectType"
require "manipulation_msgs/GraspableObject"
require "manipulation_msgs/SceneRegion"
require "geometry_msgs/Vector3"

module Manipulation_msgs

class GraspPlanningAction <::ROS::Message
  def self.md5sum
    "f2d7ee4c83f481d31e151ec1b1f209b4"
  end

  def self.type
    "manipulation_msgs/GraspPlanningAction"
  end

  def has_header?
    false
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

GraspPlanningActionGoal action_goal
GraspPlanningActionResult action_result
GraspPlanningActionFeedback action_feedback

================================================================================
MSG: manipulation_msgs/GraspPlanningActionGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalID goal_id
GraspPlanningGoal goal

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: manipulation_msgs/GraspPlanningGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Requests that grasp planning be performed on the object to be grasped
# returns a list of grasps to be tested and executed

# the arm being used
string arm_name

# the object to be grasped
GraspableObject target

# the name that the target object has in the collision environment
# can be left empty if no name is available
string collision_object_name

# the name that the support surface (e.g. table) has in the collision map
# can be left empty if no name is available
string collision_support_surface_name

# an optional list of grasps to be evaluated by the planner
Grasp[] grasps_to_evaluate

# an optional list of obstacles that we have semantic information about
# and that can be moved in the course of grasping
GraspableObject[] movable_obstacles


================================================================================
MSG: manipulation_msgs/GraspableObject
# an object that the object_manipulator can work on

# a graspable object can be represented in multiple ways. This message
# can contain all of them. Which one is actually used is up to the receiver
# of this message. When adding new representations, one must be careful that
# they have reasonable lightweight defaults indicating that that particular
# representation is not available.

# the tf frame to be used as a reference frame when combining information from
# the different representations below
string reference_frame_id

# potential recognition results from a database of models
# all poses are relative to the object reference pose
household_objects_database_msgs/DatabaseModelPose[] potential_models

# the point cloud itself
sensor_msgs/PointCloud cluster

# a region of a PointCloud2 of interest
SceneRegion region

# the name that this object has in the collision environment
string collision_name
================================================================================
MSG: household_objects_database_msgs/DatabaseModelPose
# Informs that a specific model from the Model Database has been 
# identified at a certain location

# the database id of the model
int32 model_id

# if the object was recognized by the ORK pipeline, its type will be in here
# if this is not empty, then the string in here will be converted to a household_objects_database id
# leave this empty if providing an id in the model_id field
object_recognition_msgs/ObjectType type

# the pose that it can be found in
geometry_msgs/PoseStamped pose

# a measure of the confidence level in this detection result
float32 confidence

# the name of the object detector that generated this detection result
string detector_name

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: sensor_msgs/PointCloud
# This message holds a collection of 3d points, plus optional additional
# information about each point.

# Time of sensor data acquisition, coordinate frame ID.
Header header

# Array of 3d points. Each Point32 should be interpreted as a 3d point
# in the frame given in the header.
geometry_msgs/Point32[] points

# Each channel should have the same number of elements as points array,
# and the data in each channel should correspond 1:1 with each point.
# Channel names in common practice are listed in ChannelFloat32.msg.
ChannelFloat32[] channels

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: sensor_msgs/ChannelFloat32
# This message is used by the PointCloud message to hold optional data
# associated with each point in the cloud. The length of the values
# array should be the same as the length of the points array in the
# PointCloud, and each value should be associated with the corresponding
# point.

# Channel names in existing practice include:
#   \"u\", \"v\" - row and column (respectively) in the left stereo image.
#              This is opposite to usual conventions but remains for
#              historical reasons. The newer PointCloud2 message has no
#              such problem.
#   \"rgb\" - For point clouds produced by color stereo cameras. uint8
#           (R,G,B) values packed into the least significant 24 bits,
#           in order.
#   \"intensity\" - laser or pixel intensity.
#   \"distance\"

# The channel name should give semantics of the channel (e.g.
# \"intensity\" instead of \"value\").
string name

# The values array should be 1-1 with the elements of the associated
# PointCloud.
float32[] values

================================================================================
MSG: manipulation_msgs/SceneRegion
# Point cloud
sensor_msgs/PointCloud2 cloud

# Indices for the region of interest
int32[] mask

# One of the corresponding 2D images, if applicable
sensor_msgs/Image image

# The disparity image, if applicable
sensor_msgs/Image disparity_image

# Camera info for the camera that took the image
sensor_msgs/CameraInfo cam_info

# a 3D region of interest for grasp planning
geometry_msgs/PoseStamped  roi_box_pose
geometry_msgs/Vector3 	   roi_box_dims

================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the \"fields\" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field

================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in include/sensor_msgs/image_encodings.h

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: sensor_msgs/CameraInfo
# This message defines meta information for a camera. It should be in a
# camera namespace on topic \"camera_info\" and accompanied by up to five
# image topics named:
#
#   image_raw - raw data from the camera driver, possibly Bayer encoded
#   image            - monochrome, distorted
#   image_color      - color, distorted
#   image_rect       - monochrome, rectified
#   image_rect_color - color, rectified
#
# The image_pipeline contains packages (image_proc, stereo_image_proc)
# for producing the four processed image topics from image_raw and
# camera_info. The meaning of the camera parameters are described in
# detail at http://www.ros.org/wiki/image_pipeline/CameraInfo.
#
# The image_geometry package provides a user-friendly interface to
# common operations using this meta information. If you want to, e.g.,
# project a 3d point into image coordinates, we strongly recommend
# using image_geometry.
#
# If the camera is uncalibrated, the matrices D, K, R, P should be left
# zeroed out. In particular, clients may assume that K[0] == 0.0
# indicates an uncalibrated camera.

#######################################################################
#                     Image acquisition info                          #
#######################################################################

# Time of image acquisition, camera coordinate frame ID
Header header    # Header timestamp should be acquisition time of image
                 # Header frame_id should be optical frame of camera
                 # origin of frame should be optical center of camera
                 # +x should point to the right in the image
                 # +y should point down in the image
                 # +z should point into the plane of the image


#######################################################################
#                      Calibration Parameters                         #
#######################################################################
# These are fixed during camera calibration. Their values will be the #
# same in all messages until the camera is recalibrated. Note that    #
# self-calibrating systems may \"recalibrate\" frequently.              #
#                                                                     #
# The internal parameters can be used to warp a raw (distorted) image #
# to:                                                                 #
#   1. An undistorted image (requires D and K)                        #
#   2. A rectified image (requires D, K, R)                           #
# The projection matrix P projects 3D points into the rectified image.#
#######################################################################

# The image dimensions with which the camera was calibrated. Normally
# this will be the full camera resolution in pixels.
uint32 height
uint32 width

# The distortion model used. Supported models are listed in
# sensor_msgs/distortion_models.h. For most cameras, \"plumb_bob\" - a
# simple model of radial and tangential distortion - is sufficent.
string distortion_model

# The distortion parameters, size depending on the distortion model.
# For \"plumb_bob\", the 5 parameters are: (k1, k2, t1, t2, k3).
float64[] D

# Intrinsic camera matrix for the raw (distorted) images.
#     [fx  0 cx]
# K = [ 0 fy cy]
#     [ 0  0  1]
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy).
float64[9]  K # 3x3 row-major matrix

# Rectification matrix (stereo cameras only)
# A rotation matrix aligning the camera coordinate system to the ideal
# stereo image plane so that epipolar lines in both stereo images are
# parallel.
float64[9]  R # 3x3 row-major matrix

# Projection/camera matrix
#     [fx'  0  cx' Tx]
# P = [ 0  fy' cy' Ty]
#     [ 0   0   1   0]
# By convention, this matrix specifies the intrinsic (camera) matrix
#  of the processed (rectified) image. That is, the left 3x3 portion
#  is the normal camera intrinsic matrix for the rectified image.
# It projects 3D points in the camera coordinate frame to 2D pixel
#  coordinates using the focal lengths (fx', fy') and principal point
#  (cx', cy') - these may differ from the values in K.
# For monocular cameras, Tx = Ty = 0. Normally, monocular cameras will
#  also have R = the identity and P[1:3,1:3] = K.
# For a stereo pair, the fourth column [Tx Ty 0]' is related to the
#  position of the optical center of the second camera in the first
#  camera's frame. We assume Tz = 0 so both cameras are in the same
#  stereo image plane. The first camera always has Tx = Ty = 0. For
#  the right (second) camera of a horizontal stereo pair, Ty = 0 and
#  Tx = -fx' * B, where B is the baseline between the cameras.
# Given a 3D point [X Y Z]', the projection (x, y) of the point onto
#  the rectified image is given by:
#  [u v w]' = P * [X Y Z 1]'
#         x = u / w
#         y = v / w
#  This holds for both images of a stereo pair.
float64[12] P # 3x4 row-major matrix


#######################################################################
#                      Operational Parameters                         #
#######################################################################
# These define the image region actually captured by the camera       #
# driver. Although they affect the geometry of the output image, they #
# may be changed freely without recalibrating the camera.             #
#######################################################################

# Binning refers here to any camera setting which combines rectangular
#  neighborhoods of pixels into larger \"super-pixels.\" It reduces the
#  resolution of the output image to
#  (width / binning_x) x (height / binning_y).
# The default values binning_x = binning_y = 0 is considered the same
#  as binning_x = binning_y = 1 (no subsampling).
uint32 binning_x
uint32 binning_y

# Region of interest (subwindow of full camera resolution), given in
#  full resolution (unbinned) image coordinates. A particular ROI
#  always denotes the same window of pixels on the camera sensor,
#  regardless of binning settings.
# The default setting of roi (all values 0) is considered the same as
#  full resolution (roi.width = width, roi.height = height).
RegionOfInterest roi

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image.
#
# When used to specify the ROI setting of the camera when the image was
# taken, the height and width fields should either match the height and
# width fields for the associated image; or height = width = 0
# indicates that the full resolution image was captured.

uint32 x_offset  # Leftmost pixel of the ROI
                 # (0 if the ROI includes the left edge of the image)
uint32 y_offset  # Topmost pixel of the ROI
                 # (0 if the ROI includes the top edge of the image)
uint32 height    # Height of ROI
uint32 width     # Width of ROI

# True if a distinct rectified ROI should be calculated from the \"raw\"
# ROI in this message. Typically this should be False if the full image
# is captured (ROI not used), and True if a subwindow is captured (ROI
# used).
bool do_rectify

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: manipulation_msgs/Grasp
# A name for this grasp
string id

# The internal posture of the hand for the pre-grasp
# only positions are used
sensor_msgs/JointState pre_grasp_posture

# The internal posture of the hand for the grasp
# positions and efforts are used
sensor_msgs/JointState grasp_posture

# The position of the end-effector for the grasp 
geometry_msgs/PoseStamped grasp_pose

# The estimated probability of success for this grasp, or some other
# measure of how \"good\" it is.
float64 grasp_quality

# The approach motion
GripperTranslation approach

# The retreat motion
GripperTranslation retreat

# the maximum contact force to use while grasping (<=0 to disable)
float32 max_contact_force

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping
string[] allowed_touch_objects

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: manipulation_msgs/GripperTranslation
# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: manipulation_msgs/GraspPlanningActionResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
GraspPlanningResult result

================================================================================
MSG: actionlib_msgs/GoalStatus
GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: manipulation_msgs/GraspPlanningResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# the list of planned grasps
Grasp[] grasps

# whether an error occurred
GraspPlanningErrorCode error_code


================================================================================
MSG: manipulation_msgs/GraspPlanningErrorCode
# Error codes for grasp and place planning

# plan completed as expected
int32 SUCCESS = 0

# tf error encountered while transforming
int32 TF_ERROR = 1 

# some other error
int32 OTHER_ERROR = 2

# the actual value of this error code
int32 value
================================================================================
MSG: manipulation_msgs/GraspPlanningActionFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
GraspPlanningFeedback feedback

================================================================================
MSG: manipulation_msgs/GraspPlanningFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# grasps planned so far
Grasp[] grasps



"
  end
  attr_accessor :action_goal, :action_result, :action_feedback

  @@struct_LCL = ::ROS::Struct.new("LCL")
  @@struct_L6CL3 = ::ROS::Struct.new("L6CL3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d12 = ::ROS::Struct.new("d12")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_f = ::ROS::Struct.new("f")
  @@struct_l = ::ROS::Struct.new("l")
  @@struct_CL = ::ROS::Struct.new("CL")
  @@struct_d10 = ::ROS::Struct.new("d10")
  @@struct_f3 = ::ROS::Struct.new("f3")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d9 = ::ROS::Struct.new("d9")
  @@struct_f2 = ::ROS::Struct.new("f2")
  @@struct_CL2 = ::ROS::Struct.new("CL2")
  @@struct_lL3 = ::ROS::Struct.new("lL3")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_L4C = ::ROS::Struct.new("L4C")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['manipulation_msgs/GraspPlanningActionGoal','manipulation_msgs/GraspPlanningActionResult','manipulation_msgs/GraspPlanningActionFeedback']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [manipulation_msgs/GraspPlanningActionGoal] :action_goal initialize value
  # @option args [manipulation_msgs/GraspPlanningActionResult] :action_result initialize value
  # @option args [manipulation_msgs/GraspPlanningActionFeedback] :action_feedback initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:action_goal]
      @action_goal = args[:action_goal]
    else
      @action_goal = Manipulation_msgs::GraspPlanningActionGoal.new
    end
    if args[:action_result]
      @action_result = args[:action_result]
    else
      @action_result = Manipulation_msgs::GraspPlanningActionResult.new
    end
    if args[:action_feedback]
      @action_feedback = args[:action_feedback]
    else
      @action_feedback = Manipulation_msgs::GraspPlanningActionFeedback.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@action_goal.header.seq, @action_goal.header.stamp.secs, @action_goal.header.stamp.nsecs))
      _x = @action_goal.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_goal.goal_id.stamp.secs, @action_goal.goal_id.stamp.nsecs))
      _x = @action_goal.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @action_goal.goal.arm_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @action_goal.goal.target.reference_frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.target.potential_models.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.target.potential_models
        buff.write(@@struct_l.pack(val1.model_id))
        _v3771 = val1.type
        _x = _v3771.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v3771.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3772 = val1.pose
        _v3773 = _v3772.header
        buff.write(@@struct_L.pack(_v3773.seq))
        _v3774 = _v3773.stamp
        _x = _v3774
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3773.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3775 = _v3772.pose
        _v3776 = _v3775.position
        _x = _v3776
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3777 = _v3775.orientation
        _x = _v3777
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_f.pack(val1.confidence))
        _x = val1.detector_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      buff.write(@@struct_L3.pack(@action_goal.goal.target.cluster.header.seq, @action_goal.goal.target.cluster.header.stamp.secs, @action_goal.goal.target.cluster.header.stamp.nsecs))
      _x = @action_goal.goal.target.cluster.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.target.cluster.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.target.cluster.points
        _x = val1
        buff.write(@@struct_f3.pack(_x.x, _x.y, _x.z))
      end
      length = @action_goal.goal.target.cluster.channels.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.target.cluster.channels
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.values.length
        buff.write(@@struct_L.pack(length))
        pattern = "f#{length}"
        buff.write(*val1.values.pack(pattern))
      end
      buff.write(@@struct_L3.pack(@action_goal.goal.target.region.cloud.header.seq, @action_goal.goal.target.region.cloud.header.stamp.secs, @action_goal.goal.target.region.cloud.header.stamp.nsecs))
      _x = @action_goal.goal.target.region.cloud.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_goal.goal.target.region.cloud.height, @action_goal.goal.target.region.cloud.width))
      length = @action_goal.goal.target.region.cloud.fields.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.target.region.cloud.fields
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_LCL.pack(_x.offset, _x.datatype, _x.count))
      end
      buff.write(@@struct_CL2.pack(@action_goal.goal.target.region.cloud.is_bigendian, @action_goal.goal.target.region.cloud.point_step, @action_goal.goal.target.region.cloud.row_step))
      _x = @action_goal.goal.target.region.cloud.data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_goal.goal.target.region.cloud.is_dense))
      length = @action_goal.goal.target.region.mask.length
      buff.write(@@struct_L.pack(length))
      pattern = "l#{length}"
      buff.write(*@action_goal.goal.target.region.mask.pack(pattern))
      buff.write(@@struct_L3.pack(@action_goal.goal.target.region.image.header.seq, @action_goal.goal.target.region.image.header.stamp.secs, @action_goal.goal.target.region.image.header.stamp.nsecs))
      _x = @action_goal.goal.target.region.image.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_goal.goal.target.region.image.height, @action_goal.goal.target.region.image.width))
      _x = @action_goal.goal.target.region.image.encoding
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_CL.pack(@action_goal.goal.target.region.image.is_bigendian, @action_goal.goal.target.region.image.step))
      _x = @action_goal.goal.target.region.image.data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@action_goal.goal.target.region.disparity_image.header.seq, @action_goal.goal.target.region.disparity_image.header.stamp.secs, @action_goal.goal.target.region.disparity_image.header.stamp.nsecs))
      _x = @action_goal.goal.target.region.disparity_image.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_goal.goal.target.region.disparity_image.height, @action_goal.goal.target.region.disparity_image.width))
      _x = @action_goal.goal.target.region.disparity_image.encoding
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_CL.pack(@action_goal.goal.target.region.disparity_image.is_bigendian, @action_goal.goal.target.region.disparity_image.step))
      _x = @action_goal.goal.target.region.disparity_image.data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@action_goal.goal.target.region.cam_info.header.seq, @action_goal.goal.target.region.cam_info.header.stamp.secs, @action_goal.goal.target.region.cam_info.header.stamp.nsecs))
      _x = @action_goal.goal.target.region.cam_info.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_goal.goal.target.region.cam_info.height, @action_goal.goal.target.region.cam_info.width))
      _x = @action_goal.goal.target.region.cam_info.distortion_model
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.target.region.cam_info.D.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_goal.goal.target.region.cam_info.D.pack(pattern))
      buff.write(@@struct_d9.pack(*@action_goal.goal.target.region.cam_info.K))
      buff.write(@@struct_d9.pack(*@action_goal.goal.target.region.cam_info.R))
      buff.write(@@struct_d12.pack(*@action_goal.goal.target.region.cam_info.P))
      buff.write(@@struct_L6CL3.pack(@action_goal.goal.target.region.cam_info.binning_x, @action_goal.goal.target.region.cam_info.binning_y, @action_goal.goal.target.region.cam_info.roi.x_offset, @action_goal.goal.target.region.cam_info.roi.y_offset, @action_goal.goal.target.region.cam_info.roi.height, @action_goal.goal.target.region.cam_info.roi.width, @action_goal.goal.target.region.cam_info.roi.do_rectify, @action_goal.goal.target.region.roi_box_pose.header.seq, @action_goal.goal.target.region.roi_box_pose.header.stamp.secs, @action_goal.goal.target.region.roi_box_pose.header.stamp.nsecs))
      _x = @action_goal.goal.target.region.roi_box_pose.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d10.pack(@action_goal.goal.target.region.roi_box_pose.pose.position.x, @action_goal.goal.target.region.roi_box_pose.pose.position.y, @action_goal.goal.target.region.roi_box_pose.pose.position.z, @action_goal.goal.target.region.roi_box_pose.pose.orientation.x, @action_goal.goal.target.region.roi_box_pose.pose.orientation.y, @action_goal.goal.target.region.roi_box_pose.pose.orientation.z, @action_goal.goal.target.region.roi_box_pose.pose.orientation.w, @action_goal.goal.target.region.roi_box_dims.x, @action_goal.goal.target.region.roi_box_dims.y, @action_goal.goal.target.region.roi_box_dims.z))
      _x = @action_goal.goal.target.collision_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @action_goal.goal.collision_object_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @action_goal.goal.collision_support_surface_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.grasps_to_evaluate.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.grasps_to_evaluate
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3778 = val1.pre_grasp_posture
        _v3779 = _v3778.header
        buff.write(@@struct_L.pack(_v3779.seq))
        _v3780 = _v3779.stamp
        _x = _v3780
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3779.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3778.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3778.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v3778.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3778.position.pack(pattern))
        length = _v3778.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3778.velocity.pack(pattern))
        length = _v3778.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3778.effort.pack(pattern))
        _v3781 = val1.grasp_posture
        _v3782 = _v3781.header
        buff.write(@@struct_L.pack(_v3782.seq))
        _v3783 = _v3782.stamp
        _x = _v3783
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3782.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3781.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3781.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v3781.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3781.position.pack(pattern))
        length = _v3781.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3781.velocity.pack(pattern))
        length = _v3781.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3781.effort.pack(pattern))
        _v3784 = val1.grasp_pose
        _v3785 = _v3784.header
        buff.write(@@struct_L.pack(_v3785.seq))
        _v3786 = _v3785.stamp
        _x = _v3786
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3785.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3787 = _v3784.pose
        _v3788 = _v3787.position
        _x = _v3788
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3789 = _v3787.orientation
        _x = _v3789
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_d.pack(val1.grasp_quality))
        _v3790 = val1.approach
        _v3791 = _v3790.direction
        _v3792 = _v3791.header
        buff.write(@@struct_L.pack(_v3792.seq))
        _v3793 = _v3792.stamp
        _x = _v3793
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3792.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3794 = _v3791.vector
        _x = _v3794
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v3790
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        _v3795 = val1.retreat
        _v3796 = _v3795.direction
        _v3797 = _v3796.header
        buff.write(@@struct_L.pack(_v3797.seq))
        _v3798 = _v3797.stamp
        _x = _v3798
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3797.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3799 = _v3796.vector
        _x = _v3799
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v3795
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        buff.write(@@struct_f.pack(val1.max_contact_force))
        length = val1.allowed_touch_objects.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.allowed_touch_objects
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
      end
      length = @action_goal.goal.movable_obstacles.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.movable_obstacles
        _x = val1.reference_frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.potential_models.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.potential_models
          buff.write(@@struct_l.pack(val2.model_id))
          _v3800 = val2.type
          _x = _v3800.key
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = _v3800.db
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v3801 = val2.pose
          _v3802 = _v3801.header
          buff.write(@@struct_L.pack(_v3802.seq))
          _v3803 = _v3802.stamp
          _x = _v3803
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v3802.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v3804 = _v3801.pose
          _v3805 = _v3804.position
          _x = _v3805
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v3806 = _v3804.orientation
          _x = _v3806
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(@@struct_f.pack(val2.confidence))
          _x = val2.detector_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
        end
        _v3807 = val1.cluster
        _v3808 = _v3807.header
        buff.write(@@struct_L.pack(_v3808.seq))
        _v3809 = _v3808.stamp
        _x = _v3809
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3808.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3807.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3807.points
          _x = val3
          buff.write(@@struct_f3.pack(_x.x, _x.y, _x.z))
        end
        length = _v3807.channels.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3807.channels
          _x = val3.name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          length = val3.values.length
          buff.write(@@struct_L.pack(length))
          pattern = "f#{length}"
          buff.write(*val3.values.pack(pattern))
        end
        _v3810 = val1.region
        _v3811 = _v3810.cloud
        _v3812 = _v3811.header
        buff.write(@@struct_L.pack(_v3812.seq))
        _v3813 = _v3812.stamp
        _x = _v3813
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3812.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v3811
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        length = _v3811.fields.length
        buff.write(@@struct_L.pack(length))
        for val4 in _v3811.fields
          _x = val4.name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val4
          buff.write(@@struct_LCL.pack(_x.offset, _x.datatype, _x.count))
        end
        _x = _v3811
        buff.write(@@struct_CL2.pack(_x.is_bigendian, _x.point_step, _x.row_step))
        _x = _v3811.data
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_C.pack(_v3811.is_dense))
        length = _v3810.mask.length
        buff.write(@@struct_L.pack(length))
        pattern = "l#{length}"
        buff.write(*_v3810.mask.pack(pattern))
        _v3814 = _v3810.image
        _v3815 = _v3814.header
        buff.write(@@struct_L.pack(_v3815.seq))
        _v3816 = _v3815.stamp
        _x = _v3816
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3815.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v3814
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        _x = _v3814.encoding
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v3814
        buff.write(@@struct_CL.pack(_x.is_bigendian, _x.step))
        _x = _v3814.data
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3817 = _v3810.disparity_image
        _v3818 = _v3817.header
        buff.write(@@struct_L.pack(_v3818.seq))
        _v3819 = _v3818.stamp
        _x = _v3819
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3818.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v3817
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        _x = _v3817.encoding
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v3817
        buff.write(@@struct_CL.pack(_x.is_bigendian, _x.step))
        _x = _v3817.data
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3820 = _v3810.cam_info
        _v3821 = _v3820.header
        buff.write(@@struct_L.pack(_v3821.seq))
        _v3822 = _v3821.stamp
        _x = _v3822
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3821.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v3820
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        _x = _v3820.distortion_model
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3820.D.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3820.D.pack(pattern))
        buff.write(@@struct_d9.pack(*_v3820.K))
        buff.write(@@struct_d9.pack(*_v3820.R))
        buff.write(@@struct_d12.pack(*_v3820.P))
        _x = _v3820
        buff.write(@@struct_L2.pack(_x.binning_x, _x.binning_y))
        _v3823 = _v3820.roi
        _x = _v3823
        buff.write(@@struct_L4C.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
        _v3824 = _v3810.roi_box_pose
        _v3825 = _v3824.header
        buff.write(@@struct_L.pack(_v3825.seq))
        _v3826 = _v3825.stamp
        _x = _v3826
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3825.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3827 = _v3824.pose
        _v3828 = _v3827.position
        _x = _v3828
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3829 = _v3827.orientation
        _x = _v3829
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _v3830 = _v3810.roi_box_dims
        _x = _v3830
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = val1.collision_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      buff.write(@@struct_L3.pack(@action_result.header.seq, @action_result.header.stamp.secs, @action_result.header.stamp.nsecs))
      _x = @action_result.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_result.status.goal_id.stamp.secs, @action_result.status.goal_id.stamp.nsecs))
      _x = @action_result.status.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_result.status.status))
      _x = @action_result.status.text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_result.result.grasps.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.grasps
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3831 = val1.pre_grasp_posture
        _v3832 = _v3831.header
        buff.write(@@struct_L.pack(_v3832.seq))
        _v3833 = _v3832.stamp
        _x = _v3833
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3832.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3831.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3831.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v3831.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3831.position.pack(pattern))
        length = _v3831.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3831.velocity.pack(pattern))
        length = _v3831.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3831.effort.pack(pattern))
        _v3834 = val1.grasp_posture
        _v3835 = _v3834.header
        buff.write(@@struct_L.pack(_v3835.seq))
        _v3836 = _v3835.stamp
        _x = _v3836
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3835.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3834.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3834.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v3834.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3834.position.pack(pattern))
        length = _v3834.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3834.velocity.pack(pattern))
        length = _v3834.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3834.effort.pack(pattern))
        _v3837 = val1.grasp_pose
        _v3838 = _v3837.header
        buff.write(@@struct_L.pack(_v3838.seq))
        _v3839 = _v3838.stamp
        _x = _v3839
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3838.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3840 = _v3837.pose
        _v3841 = _v3840.position
        _x = _v3841
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3842 = _v3840.orientation
        _x = _v3842
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_d.pack(val1.grasp_quality))
        _v3843 = val1.approach
        _v3844 = _v3843.direction
        _v3845 = _v3844.header
        buff.write(@@struct_L.pack(_v3845.seq))
        _v3846 = _v3845.stamp
        _x = _v3846
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3845.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3847 = _v3844.vector
        _x = _v3847
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v3843
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        _v3848 = val1.retreat
        _v3849 = _v3848.direction
        _v3850 = _v3849.header
        buff.write(@@struct_L.pack(_v3850.seq))
        _v3851 = _v3850.stamp
        _x = _v3851
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3850.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3852 = _v3849.vector
        _x = _v3852
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v3848
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        buff.write(@@struct_f.pack(val1.max_contact_force))
        length = val1.allowed_touch_objects.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.allowed_touch_objects
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
      end
      buff.write(@@struct_lL3.pack(@action_result.result.error_code.value, @action_feedback.header.seq, @action_feedback.header.stamp.secs, @action_feedback.header.stamp.nsecs))
      _x = @action_feedback.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_feedback.status.goal_id.stamp.secs, @action_feedback.status.goal_id.stamp.nsecs))
      _x = @action_feedback.status.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_feedback.status.status))
      _x = @action_feedback.status.text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_feedback.feedback.grasps.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_feedback.feedback.grasps
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3853 = val1.pre_grasp_posture
        _v3854 = _v3853.header
        buff.write(@@struct_L.pack(_v3854.seq))
        _v3855 = _v3854.stamp
        _x = _v3855
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3854.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3853.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3853.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v3853.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3853.position.pack(pattern))
        length = _v3853.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3853.velocity.pack(pattern))
        length = _v3853.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3853.effort.pack(pattern))
        _v3856 = val1.grasp_posture
        _v3857 = _v3856.header
        buff.write(@@struct_L.pack(_v3857.seq))
        _v3858 = _v3857.stamp
        _x = _v3858
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3857.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3856.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3856.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v3856.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3856.position.pack(pattern))
        length = _v3856.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3856.velocity.pack(pattern))
        length = _v3856.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3856.effort.pack(pattern))
        _v3859 = val1.grasp_pose
        _v3860 = _v3859.header
        buff.write(@@struct_L.pack(_v3860.seq))
        _v3861 = _v3860.stamp
        _x = _v3861
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3860.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3862 = _v3859.pose
        _v3863 = _v3862.position
        _x = _v3863
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3864 = _v3862.orientation
        _x = _v3864
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_d.pack(val1.grasp_quality))
        _v3865 = val1.approach
        _v3866 = _v3865.direction
        _v3867 = _v3866.header
        buff.write(@@struct_L.pack(_v3867.seq))
        _v3868 = _v3867.stamp
        _x = _v3868
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3867.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3869 = _v3866.vector
        _x = _v3869
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v3865
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        _v3870 = val1.retreat
        _v3871 = _v3870.direction
        _v3872 = _v3871.header
        buff.write(@@struct_L.pack(_v3872.seq))
        _v3873 = _v3872.stamp
        _x = _v3873
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3872.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3874 = _v3871.vector
        _x = _v3874
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v3870
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        buff.write(@@struct_f.pack(val1.max_contact_force))
        length = val1.allowed_touch_objects.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.allowed_touch_objects
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @action_goal == nil
        @action_goal = Manipulation_msgs::GraspPlanningActionGoal.new
      end
      if @action_result == nil
        @action_result = Manipulation_msgs::GraspPlanningActionResult.new
      end
      if @action_feedback == nil
        @action_feedback = Manipulation_msgs::GraspPlanningActionFeedback.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.header.seq, @action_goal.header.stamp.secs, @action_goal.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_goal.goal_id.stamp.secs, @action_goal.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.arm_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target.reference_frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.target.potential_models = []
      length.times do
        val1 = Household_objects_database_msgs::DatabaseModelPose.new
        start = end_point
        end_point += ROS::Struct::calc_size('l')
        (val1.model_id,) = @@struct_l.unpack(str[start..(end_point-1)])
        _v3875 = val1.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3875.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3875.db = str[start..(end_point-1)]
        _v3876 = val1.pose
        _v3877 = _v3876.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3877.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3878 = _v3877.stamp
        _x = _v3878
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3877.frame_id = str[start..(end_point-1)]
        _v3879 = _v3876.pose
        _v3880 = _v3879.position
        _x = _v3880
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3881 = _v3879.orientation
        _x = _v3881
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.confidence,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.detector_name = str[start..(end_point-1)]
        @action_goal.goal.target.potential_models.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.goal.target.cluster.header.seq, @action_goal.goal.target.cluster.header.stamp.secs, @action_goal.goal.target.cluster.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target.cluster.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.target.cluster.points = []
      length.times do
        val1 = Geometry_msgs::Point32.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('f3')
        (_x.x, _x.y, _x.z,) = @@struct_f3.unpack(str[start..(end_point-1)])
        @action_goal.goal.target.cluster.points.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.target.cluster.channels = []
      length.times do
        val1 = Sensor_msgs::ChannelFloat32.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "f#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.values = str[start..(end_point-1)].unpack(pattern)
        @action_goal.goal.target.cluster.channels.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.goal.target.region.cloud.header.seq, @action_goal.goal.target.region.cloud.header.stamp.secs, @action_goal.goal.target.region.cloud.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target.region.cloud.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_goal.goal.target.region.cloud.height, @action_goal.goal.target.region.cloud.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.target.region.cloud.fields = []
      length.times do
        val1 = Sensor_msgs::PointField.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('LCL')
        (_x.offset, _x.datatype, _x.count,) = @@struct_LCL.unpack(str[start..(end_point-1)])
        @action_goal.goal.target.region.cloud.fields.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('CL2')
      (@action_goal.goal.target.region.cloud.is_bigendian, @action_goal.goal.target.region.cloud.point_step, @action_goal.goal.target.region.cloud.row_step,) = @@struct_CL2.unpack(str[start..(end_point-1)])
      @action_goal.goal.target.region.cloud.is_bigendian = bool(@action_goal.goal.target.region.cloud.is_bigendian)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target.region.cloud.data = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_goal.goal.target.region.cloud.is_dense,) = @@struct_C.unpack(str[start..(end_point-1)])
      @action_goal.goal.target.region.cloud.is_dense = bool(@action_goal.goal.target.region.cloud.is_dense)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "l#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.target.region.mask = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.goal.target.region.image.header.seq, @action_goal.goal.target.region.image.header.stamp.secs, @action_goal.goal.target.region.image.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target.region.image.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_goal.goal.target.region.image.height, @action_goal.goal.target.region.image.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target.region.image.encoding = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('CL')
      (@action_goal.goal.target.region.image.is_bigendian, @action_goal.goal.target.region.image.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target.region.image.data = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.goal.target.region.disparity_image.header.seq, @action_goal.goal.target.region.disparity_image.header.stamp.secs, @action_goal.goal.target.region.disparity_image.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target.region.disparity_image.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_goal.goal.target.region.disparity_image.height, @action_goal.goal.target.region.disparity_image.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target.region.disparity_image.encoding = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('CL')
      (@action_goal.goal.target.region.disparity_image.is_bigendian, @action_goal.goal.target.region.disparity_image.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target.region.disparity_image.data = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.goal.target.region.cam_info.header.seq, @action_goal.goal.target.region.cam_info.header.stamp.secs, @action_goal.goal.target.region.cam_info.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target.region.cam_info.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_goal.goal.target.region.cam_info.height, @action_goal.goal.target.region.cam_info.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target.region.cam_info.distortion_model = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.target.region.cam_info.D = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('d9')
      @action_goal.goal.target.region.cam_info.K = @@struct_d9.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d9')
      @action_goal.goal.target.region.cam_info.R = @@struct_d9.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d12')
      @action_goal.goal.target.region.cam_info.P = @@struct_d12.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('L6CL3')
      (@action_goal.goal.target.region.cam_info.binning_x, @action_goal.goal.target.region.cam_info.binning_y, @action_goal.goal.target.region.cam_info.roi.x_offset, @action_goal.goal.target.region.cam_info.roi.y_offset, @action_goal.goal.target.region.cam_info.roi.height, @action_goal.goal.target.region.cam_info.roi.width, @action_goal.goal.target.region.cam_info.roi.do_rectify, @action_goal.goal.target.region.roi_box_pose.header.seq, @action_goal.goal.target.region.roi_box_pose.header.stamp.secs, @action_goal.goal.target.region.roi_box_pose.header.stamp.nsecs,) = @@struct_L6CL3.unpack(str[start..(end_point-1)])
      @action_goal.goal.target.region.cam_info.roi.do_rectify = bool(@action_goal.goal.target.region.cam_info.roi.do_rectify)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target.region.roi_box_pose.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d10')
      (@action_goal.goal.target.region.roi_box_pose.pose.position.x, @action_goal.goal.target.region.roi_box_pose.pose.position.y, @action_goal.goal.target.region.roi_box_pose.pose.position.z, @action_goal.goal.target.region.roi_box_pose.pose.orientation.x, @action_goal.goal.target.region.roi_box_pose.pose.orientation.y, @action_goal.goal.target.region.roi_box_pose.pose.orientation.z, @action_goal.goal.target.region.roi_box_pose.pose.orientation.w, @action_goal.goal.target.region.roi_box_dims.x, @action_goal.goal.target.region.roi_box_dims.y, @action_goal.goal.target.region.roi_box_dims.z,) = @@struct_d10.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target.collision_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.collision_object_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.collision_support_surface_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.grasps_to_evaluate = []
      length.times do
        val1 = Manipulation_msgs::Grasp.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v3882 = val1.pre_grasp_posture
        _v3883 = _v3882.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3883.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3884 = _v3883.stamp
        _x = _v3884
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3883.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3882.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v3882.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3882.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3882.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3882.effort = str[start..(end_point-1)].unpack(pattern)
        _v3885 = val1.grasp_posture
        _v3886 = _v3885.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3886.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3887 = _v3886.stamp
        _x = _v3887
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3886.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3885.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v3885.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3885.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3885.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3885.effort = str[start..(end_point-1)].unpack(pattern)
        _v3888 = val1.grasp_pose
        _v3889 = _v3888.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3889.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3890 = _v3889.stamp
        _x = _v3890
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3889.frame_id = str[start..(end_point-1)]
        _v3891 = _v3888.pose
        _v3892 = _v3891.position
        _x = _v3892
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3893 = _v3891.orientation
        _x = _v3893
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.grasp_quality,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v3894 = val1.approach
        _v3895 = _v3894.direction
        _v3896 = _v3895.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3896.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3897 = _v3896.stamp
        _x = _v3897
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3896.frame_id = str[start..(end_point-1)]
        _v3898 = _v3895.vector
        _x = _v3898
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v3894
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        _v3899 = val1.retreat
        _v3900 = _v3899.direction
        _v3901 = _v3900.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3901.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3902 = _v3901.stamp
        _x = _v3902
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3901.frame_id = str[start..(end_point-1)]
        _v3903 = _v3900.vector
        _x = _v3903
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v3899
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.max_contact_force,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.allowed_touch_objects = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.allowed_touch_objects.push(val2)
        end
        @action_goal.goal.grasps_to_evaluate.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.movable_obstacles = []
      length.times do
        val1 = Manipulation_msgs::GraspableObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.reference_frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.potential_models = []
        length.times do
          val2 = Household_objects_database_msgs::DatabaseModelPose.new
          start = end_point
          end_point += ROS::Struct::calc_size('l')
          (val2.model_id,) = @@struct_l.unpack(str[start..(end_point-1)])
          _v3904 = val2.type
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v3904.key = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v3904.db = str[start..(end_point-1)]
          _v3905 = val2.pose
          _v3906 = _v3905.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v3906.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v3907 = _v3906.stamp
          _x = _v3907
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v3906.frame_id = str[start..(end_point-1)]
          _v3908 = _v3905.pose
          _v3909 = _v3908.position
          _x = _v3909
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v3910 = _v3908.orientation
          _x = _v3910
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += ROS::Struct::calc_size('f')
          (val2.confidence,) = @@struct_f.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.detector_name = str[start..(end_point-1)]
          val1.potential_models.push(val2)
        end
        _v3911 = val1.cluster
        _v3912 = _v3911.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3912.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3913 = _v3912.stamp
        _x = _v3913
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3912.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3911.points = []
        length.times do
          val3 = Geometry_msgs::Point32.new
          _x = val3
          start = end_point
          end_point += ROS::Struct::calc_size('f3')
          (_x.x, _x.y, _x.z,) = @@struct_f3.unpack(str[start..(end_point-1)])
          _v3911.points.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3911.channels = []
        length.times do
          val3 = Sensor_msgs::ChannelFloat32.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3.name = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "f#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.values = str[start..(end_point-1)].unpack(pattern)
          _v3911.channels.push(val3)
        end
        _v3914 = val1.region
        _v3915 = _v3914.cloud
        _v3916 = _v3915.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3916.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3917 = _v3916.stamp
        _x = _v3917
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3916.frame_id = str[start..(end_point-1)]
        _x = _v3915
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3915.fields = []
        length.times do
          val4 = Sensor_msgs::PointField.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val4.name = str[start..(end_point-1)]
          _x = val4
          start = end_point
          end_point += ROS::Struct::calc_size('LCL')
          (_x.offset, _x.datatype, _x.count,) = @@struct_LCL.unpack(str[start..(end_point-1)])
          _v3915.fields.push(val4)
        end
        _x = _v3915
        start = end_point
        end_point += ROS::Struct::calc_size('CL2')
        (_x.is_bigendian, _x.point_step, _x.row_step,) = @@struct_CL2.unpack(str[start..(end_point-1)])
        _v3915.is_bigendian = bool(_v3915.is_bigendian)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3915.data = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (_v3915.is_dense,) = @@struct_C.unpack(str[start..(end_point-1)])
        _v3915.is_dense = bool(_v3915.is_dense)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "l#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3914.mask = str[start..(end_point-1)].unpack(pattern)
        _v3918 = _v3914.image
        _v3919 = _v3918.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3919.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3920 = _v3919.stamp
        _x = _v3920
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3919.frame_id = str[start..(end_point-1)]
        _x = _v3918
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3918.encoding = str[start..(end_point-1)]
        _x = _v3918
        start = end_point
        end_point += ROS::Struct::calc_size('CL')
        (_x.is_bigendian, _x.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3918.data = str[start..(end_point-1)]
        _v3921 = _v3914.disparity_image
        _v3922 = _v3921.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3922.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3923 = _v3922.stamp
        _x = _v3923
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3922.frame_id = str[start..(end_point-1)]
        _x = _v3921
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3921.encoding = str[start..(end_point-1)]
        _x = _v3921
        start = end_point
        end_point += ROS::Struct::calc_size('CL')
        (_x.is_bigendian, _x.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3921.data = str[start..(end_point-1)]
        _v3924 = _v3914.cam_info
        _v3925 = _v3924.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3925.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3926 = _v3925.stamp
        _x = _v3926
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3925.frame_id = str[start..(end_point-1)]
        _x = _v3924
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3924.distortion_model = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3924.D = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += ROS::Struct::calc_size('d9')
        _v3924.K = @@struct_d9.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d9')
        _v3924.R = @@struct_d9.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d12')
        _v3924.P = @@struct_d12.unpack(str[start..(end_point-1)])
        _x = _v3924
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.binning_x, _x.binning_y,) = @@struct_L2.unpack(str[start..(end_point-1)])
        _v3927 = _v3924.roi
        _x = _v3927
        start = end_point
        end_point += ROS::Struct::calc_size('L4C')
        (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = @@struct_L4C.unpack(str[start..(end_point-1)])
        _v3927.do_rectify = bool(_v3927.do_rectify)
        _v3928 = _v3914.roi_box_pose
        _v3929 = _v3928.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3929.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3930 = _v3929.stamp
        _x = _v3930
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3929.frame_id = str[start..(end_point-1)]
        _v3931 = _v3928.pose
        _v3932 = _v3931.position
        _x = _v3932
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3933 = _v3931.orientation
        _x = _v3933
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        _v3934 = _v3914.roi_box_dims
        _x = _v3934
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.collision_name = str[start..(end_point-1)]
        @action_goal.goal.movable_obstacles.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_result.header.seq, @action_result.header.stamp.secs, @action_result.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_result.status.goal_id.stamp.secs, @action_result.status.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.status.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_result.status.status,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.status.text = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.grasps = []
      length.times do
        val1 = Manipulation_msgs::Grasp.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v3935 = val1.pre_grasp_posture
        _v3936 = _v3935.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3936.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3937 = _v3936.stamp
        _x = _v3937
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3936.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3935.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v3935.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3935.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3935.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3935.effort = str[start..(end_point-1)].unpack(pattern)
        _v3938 = val1.grasp_posture
        _v3939 = _v3938.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3939.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3940 = _v3939.stamp
        _x = _v3940
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3939.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3938.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v3938.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3938.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3938.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3938.effort = str[start..(end_point-1)].unpack(pattern)
        _v3941 = val1.grasp_pose
        _v3942 = _v3941.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3942.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3943 = _v3942.stamp
        _x = _v3943
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3942.frame_id = str[start..(end_point-1)]
        _v3944 = _v3941.pose
        _v3945 = _v3944.position
        _x = _v3945
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3946 = _v3944.orientation
        _x = _v3946
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.grasp_quality,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v3947 = val1.approach
        _v3948 = _v3947.direction
        _v3949 = _v3948.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3949.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3950 = _v3949.stamp
        _x = _v3950
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3949.frame_id = str[start..(end_point-1)]
        _v3951 = _v3948.vector
        _x = _v3951
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v3947
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        _v3952 = val1.retreat
        _v3953 = _v3952.direction
        _v3954 = _v3953.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3954.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3955 = _v3954.stamp
        _x = _v3955
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3954.frame_id = str[start..(end_point-1)]
        _v3956 = _v3953.vector
        _x = _v3956
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v3952
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.max_contact_force,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.allowed_touch_objects = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.allowed_touch_objects.push(val2)
        end
        @action_result.result.grasps.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('lL3')
      (@action_result.result.error_code.value, @action_feedback.header.seq, @action_feedback.header.stamp.secs, @action_feedback.header.stamp.nsecs,) = @@struct_lL3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_feedback.status.goal_id.stamp.secs, @action_feedback.status.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.status.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_feedback.status.status,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.status.text = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_feedback.feedback.grasps = []
      length.times do
        val1 = Manipulation_msgs::Grasp.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v3957 = val1.pre_grasp_posture
        _v3958 = _v3957.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3958.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3959 = _v3958.stamp
        _x = _v3959
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3958.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3957.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v3957.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3957.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3957.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3957.effort = str[start..(end_point-1)].unpack(pattern)
        _v3960 = val1.grasp_posture
        _v3961 = _v3960.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3961.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3962 = _v3961.stamp
        _x = _v3962
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3961.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3960.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v3960.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3960.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3960.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v3960.effort = str[start..(end_point-1)].unpack(pattern)
        _v3963 = val1.grasp_pose
        _v3964 = _v3963.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3964.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3965 = _v3964.stamp
        _x = _v3965
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3964.frame_id = str[start..(end_point-1)]
        _v3966 = _v3963.pose
        _v3967 = _v3966.position
        _x = _v3967
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3968 = _v3966.orientation
        _x = _v3968
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.grasp_quality,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v3969 = val1.approach
        _v3970 = _v3969.direction
        _v3971 = _v3970.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3971.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3972 = _v3971.stamp
        _x = _v3972
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3971.frame_id = str[start..(end_point-1)]
        _v3973 = _v3970.vector
        _x = _v3973
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v3969
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        _v3974 = val1.retreat
        _v3975 = _v3974.direction
        _v3976 = _v3975.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3976.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3977 = _v3976.stamp
        _x = _v3977
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3976.frame_id = str[start..(end_point-1)]
        _v3978 = _v3975.vector
        _x = _v3978
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v3974
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.max_contact_force,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.allowed_touch_objects = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.allowed_touch_objects.push(val2)
        end
        @action_feedback.feedback.grasps.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
