# autogenerated by genrb from GraspPlanningActionFeedback.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "geometry_msgs/Vector3Stamped"
require "manipulation_msgs/Grasp"
require "geometry_msgs/PoseStamped"
require "sensor_msgs/JointState"
require "manipulation_msgs/GraspPlanningFeedback"
require "std_msgs/Header"
require "actionlib_msgs/GoalID"
require "geometry_msgs/Point"
require "manipulation_msgs/GripperTranslation"
require "geometry_msgs/Quaternion"
require "actionlib_msgs/GoalStatus"
require "geometry_msgs/Vector3"
require "geometry_msgs/Pose"

module Manipulation_msgs

class GraspPlanningActionFeedback <::ROS::Message
  def self.md5sum
    "25a75a7c3117e1e7efda49b65ff22a06"
  end

  def self.type
    "manipulation_msgs/GraspPlanningActionFeedback"
  end

  def has_header?
    true
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
GraspPlanningFeedback feedback

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalStatus
GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: manipulation_msgs/GraspPlanningFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# grasps planned so far
Grasp[] grasps



================================================================================
MSG: manipulation_msgs/Grasp
# A name for this grasp
string id

# The internal posture of the hand for the pre-grasp
# only positions are used
sensor_msgs/JointState pre_grasp_posture

# The internal posture of the hand for the grasp
# positions and efforts are used
sensor_msgs/JointState grasp_posture

# The position of the end-effector for the grasp 
geometry_msgs/PoseStamped grasp_pose

# The estimated probability of success for this grasp, or some other
# measure of how \"good\" it is.
float64 grasp_quality

# The approach motion
GripperTranslation approach

# The retreat motion
GripperTranslation retreat

# the maximum contact force to use while grasping (<=0 to disable)
float32 max_contact_force

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping
string[] allowed_touch_objects

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: manipulation_msgs/GripperTranslation
# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :header, :status, :feedback

  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_f = ::ROS::Struct.new("f")
  @@struct_f2 = ::ROS::Struct.new("f2")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','actionlib_msgs/GoalStatus','manipulation_msgs/GraspPlanningFeedback']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [actionlib_msgs/GoalStatus] :status initialize value
  # @option args [manipulation_msgs/GraspPlanningFeedback] :feedback initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:status]
      @status = args[:status]
    else
      @status = Actionlib_msgs::GoalStatus.new
    end
    if args[:feedback]
      @feedback = args[:feedback]
    else
      @feedback = Manipulation_msgs::GraspPlanningFeedback.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@status.goal_id.stamp.secs, @status.goal_id.stamp.nsecs))
      _x = @status.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@status.status))
      _x = @status.text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @feedback.grasps.length
      buff.write(@@struct_L.pack(length))
      for val1 in @feedback.grasps
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3979 = val1.pre_grasp_posture
        _v3980 = _v3979.header
        buff.write(@@struct_L.pack(_v3980.seq))
        _v3981 = _v3980.stamp
        _x = _v3981
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3980.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3979.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3979.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v3979.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3979.position.pack(pattern))
        length = _v3979.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3979.velocity.pack(pattern))
        length = _v3979.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3979.effort.pack(pattern))
        _v3982 = val1.grasp_posture
        _v3983 = _v3982.header
        buff.write(@@struct_L.pack(_v3983.seq))
        _v3984 = _v3983.stamp
        _x = _v3984
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3983.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3982.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3982.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v3982.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3982.position.pack(pattern))
        length = _v3982.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3982.velocity.pack(pattern))
        length = _v3982.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v3982.effort.pack(pattern))
        _v3985 = val1.grasp_pose
        _v3986 = _v3985.header
        buff.write(@@struct_L.pack(_v3986.seq))
        _v3987 = _v3986.stamp
        _x = _v3987
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3986.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3988 = _v3985.pose
        _v3989 = _v3988.position
        _x = _v3989
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3990 = _v3988.orientation
        _x = _v3990
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_d.pack(val1.grasp_quality))
        _v3991 = val1.approach
        _v3992 = _v3991.direction
        _v3993 = _v3992.header
        buff.write(@@struct_L.pack(_v3993.seq))
        _v3994 = _v3993.stamp
        _x = _v3994
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3993.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3995 = _v3992.vector
        _x = _v3995
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v3991
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        _v3996 = val1.retreat
        _v3997 = _v3996.direction
        _v3998 = _v3997.header
        buff.write(@@struct_L.pack(_v3998.seq))
        _v3999 = _v3998.stamp
        _x = _v3999
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3998.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4000 = _v3997.vector
        _x = _v4000
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v3996
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        buff.write(@@struct_f.pack(val1.max_contact_force))
        length = val1.allowed_touch_objects.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.allowed_touch_objects
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @status == nil
        @status = Actionlib_msgs::GoalStatus.new
      end
      if @feedback == nil
        @feedback = Manipulation_msgs::GraspPlanningFeedback.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@status.goal_id.stamp.secs, @status.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @status.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@status.status,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @status.text = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @feedback.grasps = []
      length.times do
        val1 = Manipulation_msgs::Grasp.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v4001 = val1.pre_grasp_posture
        _v4002 = _v4001.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4002.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4003 = _v4002.stamp
        _x = _v4003
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4002.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4001.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v4001.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4001.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4001.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4001.effort = str[start..(end_point-1)].unpack(pattern)
        _v4004 = val1.grasp_posture
        _v4005 = _v4004.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4005.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4006 = _v4005.stamp
        _x = _v4006
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4005.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4004.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v4004.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4004.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4004.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4004.effort = str[start..(end_point-1)].unpack(pattern)
        _v4007 = val1.grasp_pose
        _v4008 = _v4007.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4008.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4009 = _v4008.stamp
        _x = _v4009
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4008.frame_id = str[start..(end_point-1)]
        _v4010 = _v4007.pose
        _v4011 = _v4010.position
        _x = _v4011
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v4012 = _v4010.orientation
        _x = _v4012
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.grasp_quality,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v4013 = val1.approach
        _v4014 = _v4013.direction
        _v4015 = _v4014.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4015.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4016 = _v4015.stamp
        _x = _v4016
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4015.frame_id = str[start..(end_point-1)]
        _v4017 = _v4014.vector
        _x = _v4017
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v4013
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        _v4018 = val1.retreat
        _v4019 = _v4018.direction
        _v4020 = _v4019.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4020.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4021 = _v4020.stamp
        _x = _v4021
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4020.frame_id = str[start..(end_point-1)]
        _v4022 = _v4019.vector
        _x = _v4022
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v4018
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.max_contact_force,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.allowed_touch_objects = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.allowed_touch_objects.push(val2)
        end
        @feedback.grasps.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
