# autogenerated by genrb from GraspPlanningActionGoal.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "sensor_msgs/PointField"
require "geometry_msgs/Point32"
require "geometry_msgs/Point"
require "geometry_msgs/Vector3Stamped"
require "sensor_msgs/CameraInfo"
require "household_objects_database_msgs/DatabaseModelPose"
require "sensor_msgs/PointCloud2"
require "sensor_msgs/Image"
require "geometry_msgs/PoseStamped"
require "std_msgs/Header"
require "sensor_msgs/ChannelFloat32"
require "geometry_msgs/Pose"
require "sensor_msgs/RegionOfInterest"
require "manipulation_msgs/GripperTranslation"
require "geometry_msgs/Quaternion"
require "manipulation_msgs/GraspPlanningGoal"
require "actionlib_msgs/GoalID"
require "manipulation_msgs/Grasp"
require "sensor_msgs/JointState"
require "sensor_msgs/PointCloud"
require "object_recognition_msgs/ObjectType"
require "manipulation_msgs/GraspableObject"
require "manipulation_msgs/SceneRegion"
require "geometry_msgs/Vector3"

module Manipulation_msgs

class GraspPlanningActionGoal <::ROS::Message
  def self.md5sum
    "51f78205082ab7818f66534367bff5f5"
  end

  def self.type
    "manipulation_msgs/GraspPlanningActionGoal"
  end

  def has_header?
    true
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalID goal_id
GraspPlanningGoal goal

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: manipulation_msgs/GraspPlanningGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Requests that grasp planning be performed on the object to be grasped
# returns a list of grasps to be tested and executed

# the arm being used
string arm_name

# the object to be grasped
GraspableObject target

# the name that the target object has in the collision environment
# can be left empty if no name is available
string collision_object_name

# the name that the support surface (e.g. table) has in the collision map
# can be left empty if no name is available
string collision_support_surface_name

# an optional list of grasps to be evaluated by the planner
Grasp[] grasps_to_evaluate

# an optional list of obstacles that we have semantic information about
# and that can be moved in the course of grasping
GraspableObject[] movable_obstacles


================================================================================
MSG: manipulation_msgs/GraspableObject
# an object that the object_manipulator can work on

# a graspable object can be represented in multiple ways. This message
# can contain all of them. Which one is actually used is up to the receiver
# of this message. When adding new representations, one must be careful that
# they have reasonable lightweight defaults indicating that that particular
# representation is not available.

# the tf frame to be used as a reference frame when combining information from
# the different representations below
string reference_frame_id

# potential recognition results from a database of models
# all poses are relative to the object reference pose
household_objects_database_msgs/DatabaseModelPose[] potential_models

# the point cloud itself
sensor_msgs/PointCloud cluster

# a region of a PointCloud2 of interest
SceneRegion region

# the name that this object has in the collision environment
string collision_name
================================================================================
MSG: household_objects_database_msgs/DatabaseModelPose
# Informs that a specific model from the Model Database has been 
# identified at a certain location

# the database id of the model
int32 model_id

# if the object was recognized by the ORK pipeline, its type will be in here
# if this is not empty, then the string in here will be converted to a household_objects_database id
# leave this empty if providing an id in the model_id field
object_recognition_msgs/ObjectType type

# the pose that it can be found in
geometry_msgs/PoseStamped pose

# a measure of the confidence level in this detection result
float32 confidence

# the name of the object detector that generated this detection result
string detector_name

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: sensor_msgs/PointCloud
# This message holds a collection of 3d points, plus optional additional
# information about each point.

# Time of sensor data acquisition, coordinate frame ID.
Header header

# Array of 3d points. Each Point32 should be interpreted as a 3d point
# in the frame given in the header.
geometry_msgs/Point32[] points

# Each channel should have the same number of elements as points array,
# and the data in each channel should correspond 1:1 with each point.
# Channel names in common practice are listed in ChannelFloat32.msg.
ChannelFloat32[] channels

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: sensor_msgs/ChannelFloat32
# This message is used by the PointCloud message to hold optional data
# associated with each point in the cloud. The length of the values
# array should be the same as the length of the points array in the
# PointCloud, and each value should be associated with the corresponding
# point.

# Channel names in existing practice include:
#   \"u\", \"v\" - row and column (respectively) in the left stereo image.
#              This is opposite to usual conventions but remains for
#              historical reasons. The newer PointCloud2 message has no
#              such problem.
#   \"rgb\" - For point clouds produced by color stereo cameras. uint8
#           (R,G,B) values packed into the least significant 24 bits,
#           in order.
#   \"intensity\" - laser or pixel intensity.
#   \"distance\"

# The channel name should give semantics of the channel (e.g.
# \"intensity\" instead of \"value\").
string name

# The values array should be 1-1 with the elements of the associated
# PointCloud.
float32[] values

================================================================================
MSG: manipulation_msgs/SceneRegion
# Point cloud
sensor_msgs/PointCloud2 cloud

# Indices for the region of interest
int32[] mask

# One of the corresponding 2D images, if applicable
sensor_msgs/Image image

# The disparity image, if applicable
sensor_msgs/Image disparity_image

# Camera info for the camera that took the image
sensor_msgs/CameraInfo cam_info

# a 3D region of interest for grasp planning
geometry_msgs/PoseStamped  roi_box_pose
geometry_msgs/Vector3 	   roi_box_dims

================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the \"fields\" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field

================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in include/sensor_msgs/image_encodings.h

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: sensor_msgs/CameraInfo
# This message defines meta information for a camera. It should be in a
# camera namespace on topic \"camera_info\" and accompanied by up to five
# image topics named:
#
#   image_raw - raw data from the camera driver, possibly Bayer encoded
#   image            - monochrome, distorted
#   image_color      - color, distorted
#   image_rect       - monochrome, rectified
#   image_rect_color - color, rectified
#
# The image_pipeline contains packages (image_proc, stereo_image_proc)
# for producing the four processed image topics from image_raw and
# camera_info. The meaning of the camera parameters are described in
# detail at http://www.ros.org/wiki/image_pipeline/CameraInfo.
#
# The image_geometry package provides a user-friendly interface to
# common operations using this meta information. If you want to, e.g.,
# project a 3d point into image coordinates, we strongly recommend
# using image_geometry.
#
# If the camera is uncalibrated, the matrices D, K, R, P should be left
# zeroed out. In particular, clients may assume that K[0] == 0.0
# indicates an uncalibrated camera.

#######################################################################
#                     Image acquisition info                          #
#######################################################################

# Time of image acquisition, camera coordinate frame ID
Header header    # Header timestamp should be acquisition time of image
                 # Header frame_id should be optical frame of camera
                 # origin of frame should be optical center of camera
                 # +x should point to the right in the image
                 # +y should point down in the image
                 # +z should point into the plane of the image


#######################################################################
#                      Calibration Parameters                         #
#######################################################################
# These are fixed during camera calibration. Their values will be the #
# same in all messages until the camera is recalibrated. Note that    #
# self-calibrating systems may \"recalibrate\" frequently.              #
#                                                                     #
# The internal parameters can be used to warp a raw (distorted) image #
# to:                                                                 #
#   1. An undistorted image (requires D and K)                        #
#   2. A rectified image (requires D, K, R)                           #
# The projection matrix P projects 3D points into the rectified image.#
#######################################################################

# The image dimensions with which the camera was calibrated. Normally
# this will be the full camera resolution in pixels.
uint32 height
uint32 width

# The distortion model used. Supported models are listed in
# sensor_msgs/distortion_models.h. For most cameras, \"plumb_bob\" - a
# simple model of radial and tangential distortion - is sufficent.
string distortion_model

# The distortion parameters, size depending on the distortion model.
# For \"plumb_bob\", the 5 parameters are: (k1, k2, t1, t2, k3).
float64[] D

# Intrinsic camera matrix for the raw (distorted) images.
#     [fx  0 cx]
# K = [ 0 fy cy]
#     [ 0  0  1]
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy).
float64[9]  K # 3x3 row-major matrix

# Rectification matrix (stereo cameras only)
# A rotation matrix aligning the camera coordinate system to the ideal
# stereo image plane so that epipolar lines in both stereo images are
# parallel.
float64[9]  R # 3x3 row-major matrix

# Projection/camera matrix
#     [fx'  0  cx' Tx]
# P = [ 0  fy' cy' Ty]
#     [ 0   0   1   0]
# By convention, this matrix specifies the intrinsic (camera) matrix
#  of the processed (rectified) image. That is, the left 3x3 portion
#  is the normal camera intrinsic matrix for the rectified image.
# It projects 3D points in the camera coordinate frame to 2D pixel
#  coordinates using the focal lengths (fx', fy') and principal point
#  (cx', cy') - these may differ from the values in K.
# For monocular cameras, Tx = Ty = 0. Normally, monocular cameras will
#  also have R = the identity and P[1:3,1:3] = K.
# For a stereo pair, the fourth column [Tx Ty 0]' is related to the
#  position of the optical center of the second camera in the first
#  camera's frame. We assume Tz = 0 so both cameras are in the same
#  stereo image plane. The first camera always has Tx = Ty = 0. For
#  the right (second) camera of a horizontal stereo pair, Ty = 0 and
#  Tx = -fx' * B, where B is the baseline between the cameras.
# Given a 3D point [X Y Z]', the projection (x, y) of the point onto
#  the rectified image is given by:
#  [u v w]' = P * [X Y Z 1]'
#         x = u / w
#         y = v / w
#  This holds for both images of a stereo pair.
float64[12] P # 3x4 row-major matrix


#######################################################################
#                      Operational Parameters                         #
#######################################################################
# These define the image region actually captured by the camera       #
# driver. Although they affect the geometry of the output image, they #
# may be changed freely without recalibrating the camera.             #
#######################################################################

# Binning refers here to any camera setting which combines rectangular
#  neighborhoods of pixels into larger \"super-pixels.\" It reduces the
#  resolution of the output image to
#  (width / binning_x) x (height / binning_y).
# The default values binning_x = binning_y = 0 is considered the same
#  as binning_x = binning_y = 1 (no subsampling).
uint32 binning_x
uint32 binning_y

# Region of interest (subwindow of full camera resolution), given in
#  full resolution (unbinned) image coordinates. A particular ROI
#  always denotes the same window of pixels on the camera sensor,
#  regardless of binning settings.
# The default setting of roi (all values 0) is considered the same as
#  full resolution (roi.width = width, roi.height = height).
RegionOfInterest roi

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image.
#
# When used to specify the ROI setting of the camera when the image was
# taken, the height and width fields should either match the height and
# width fields for the associated image; or height = width = 0
# indicates that the full resolution image was captured.

uint32 x_offset  # Leftmost pixel of the ROI
                 # (0 if the ROI includes the left edge of the image)
uint32 y_offset  # Topmost pixel of the ROI
                 # (0 if the ROI includes the top edge of the image)
uint32 height    # Height of ROI
uint32 width     # Width of ROI

# True if a distinct rectified ROI should be calculated from the \"raw\"
# ROI in this message. Typically this should be False if the full image
# is captured (ROI not used), and True if a subwindow is captured (ROI
# used).
bool do_rectify

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: manipulation_msgs/Grasp
# A name for this grasp
string id

# The internal posture of the hand for the pre-grasp
# only positions are used
sensor_msgs/JointState pre_grasp_posture

# The internal posture of the hand for the grasp
# positions and efforts are used
sensor_msgs/JointState grasp_posture

# The position of the end-effector for the grasp 
geometry_msgs/PoseStamped grasp_pose

# The estimated probability of success for this grasp, or some other
# measure of how \"good\" it is.
float64 grasp_quality

# The approach motion
GripperTranslation approach

# The retreat motion
GripperTranslation retreat

# the maximum contact force to use while grasping (<=0 to disable)
float32 max_contact_force

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping
string[] allowed_touch_objects

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: manipulation_msgs/GripperTranslation
# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

"
  end
  attr_accessor :header, :goal_id, :goal

  @@struct_LCL = ::ROS::Struct.new("LCL")
  @@struct_L6CL3 = ::ROS::Struct.new("L6CL3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d12 = ::ROS::Struct.new("d12")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_f = ::ROS::Struct.new("f")
  @@struct_l = ::ROS::Struct.new("l")
  @@struct_CL = ::ROS::Struct.new("CL")
  @@struct_d10 = ::ROS::Struct.new("d10")
  @@struct_f3 = ::ROS::Struct.new("f3")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d9 = ::ROS::Struct.new("d9")
  @@struct_f2 = ::ROS::Struct.new("f2")
  @@struct_CL2 = ::ROS::Struct.new("CL2")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_L4C = ::ROS::Struct.new("L4C")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','actionlib_msgs/GoalID','manipulation_msgs/GraspPlanningGoal']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [actionlib_msgs/GoalID] :goal_id initialize value
  # @option args [manipulation_msgs/GraspPlanningGoal] :goal initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:goal_id]
      @goal_id = args[:goal_id]
    else
      @goal_id = Actionlib_msgs::GoalID.new
    end
    if args[:goal]
      @goal = args[:goal]
    else
      @goal = Manipulation_msgs::GraspPlanningGoal.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@goal_id.stamp.secs, @goal_id.stamp.nsecs))
      _x = @goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @goal.arm_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @goal.target.reference_frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.target.potential_models.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.target.potential_models
        buff.write(@@struct_l.pack(val1.model_id))
        _v4023 = val1.type
        _x = _v4023.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4023.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4024 = val1.pose
        _v4025 = _v4024.header
        buff.write(@@struct_L.pack(_v4025.seq))
        _v4026 = _v4025.stamp
        _x = _v4026
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4025.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4027 = _v4024.pose
        _v4028 = _v4027.position
        _x = _v4028
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4029 = _v4027.orientation
        _x = _v4029
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_f.pack(val1.confidence))
        _x = val1.detector_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      buff.write(@@struct_L3.pack(@goal.target.cluster.header.seq, @goal.target.cluster.header.stamp.secs, @goal.target.cluster.header.stamp.nsecs))
      _x = @goal.target.cluster.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.target.cluster.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.target.cluster.points
        _x = val1
        buff.write(@@struct_f3.pack(_x.x, _x.y, _x.z))
      end
      length = @goal.target.cluster.channels.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.target.cluster.channels
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.values.length
        buff.write(@@struct_L.pack(length))
        pattern = "f#{length}"
        buff.write(*val1.values.pack(pattern))
      end
      buff.write(@@struct_L3.pack(@goal.target.region.cloud.header.seq, @goal.target.region.cloud.header.stamp.secs, @goal.target.region.cloud.header.stamp.nsecs))
      _x = @goal.target.region.cloud.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@goal.target.region.cloud.height, @goal.target.region.cloud.width))
      length = @goal.target.region.cloud.fields.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.target.region.cloud.fields
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_LCL.pack(_x.offset, _x.datatype, _x.count))
      end
      buff.write(@@struct_CL2.pack(@goal.target.region.cloud.is_bigendian, @goal.target.region.cloud.point_step, @goal.target.region.cloud.row_step))
      _x = @goal.target.region.cloud.data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@goal.target.region.cloud.is_dense))
      length = @goal.target.region.mask.length
      buff.write(@@struct_L.pack(length))
      pattern = "l#{length}"
      buff.write(*@goal.target.region.mask.pack(pattern))
      buff.write(@@struct_L3.pack(@goal.target.region.image.header.seq, @goal.target.region.image.header.stamp.secs, @goal.target.region.image.header.stamp.nsecs))
      _x = @goal.target.region.image.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@goal.target.region.image.height, @goal.target.region.image.width))
      _x = @goal.target.region.image.encoding
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_CL.pack(@goal.target.region.image.is_bigendian, @goal.target.region.image.step))
      _x = @goal.target.region.image.data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@goal.target.region.disparity_image.header.seq, @goal.target.region.disparity_image.header.stamp.secs, @goal.target.region.disparity_image.header.stamp.nsecs))
      _x = @goal.target.region.disparity_image.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@goal.target.region.disparity_image.height, @goal.target.region.disparity_image.width))
      _x = @goal.target.region.disparity_image.encoding
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_CL.pack(@goal.target.region.disparity_image.is_bigendian, @goal.target.region.disparity_image.step))
      _x = @goal.target.region.disparity_image.data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@goal.target.region.cam_info.header.seq, @goal.target.region.cam_info.header.stamp.secs, @goal.target.region.cam_info.header.stamp.nsecs))
      _x = @goal.target.region.cam_info.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@goal.target.region.cam_info.height, @goal.target.region.cam_info.width))
      _x = @goal.target.region.cam_info.distortion_model
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.target.region.cam_info.D.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@goal.target.region.cam_info.D.pack(pattern))
      buff.write(@@struct_d9.pack(*@goal.target.region.cam_info.K))
      buff.write(@@struct_d9.pack(*@goal.target.region.cam_info.R))
      buff.write(@@struct_d12.pack(*@goal.target.region.cam_info.P))
      buff.write(@@struct_L6CL3.pack(@goal.target.region.cam_info.binning_x, @goal.target.region.cam_info.binning_y, @goal.target.region.cam_info.roi.x_offset, @goal.target.region.cam_info.roi.y_offset, @goal.target.region.cam_info.roi.height, @goal.target.region.cam_info.roi.width, @goal.target.region.cam_info.roi.do_rectify, @goal.target.region.roi_box_pose.header.seq, @goal.target.region.roi_box_pose.header.stamp.secs, @goal.target.region.roi_box_pose.header.stamp.nsecs))
      _x = @goal.target.region.roi_box_pose.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d10.pack(@goal.target.region.roi_box_pose.pose.position.x, @goal.target.region.roi_box_pose.pose.position.y, @goal.target.region.roi_box_pose.pose.position.z, @goal.target.region.roi_box_pose.pose.orientation.x, @goal.target.region.roi_box_pose.pose.orientation.y, @goal.target.region.roi_box_pose.pose.orientation.z, @goal.target.region.roi_box_pose.pose.orientation.w, @goal.target.region.roi_box_dims.x, @goal.target.region.roi_box_dims.y, @goal.target.region.roi_box_dims.z))
      _x = @goal.target.collision_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @goal.collision_object_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @goal.collision_support_surface_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.grasps_to_evaluate.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.grasps_to_evaluate
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4030 = val1.pre_grasp_posture
        _v4031 = _v4030.header
        buff.write(@@struct_L.pack(_v4031.seq))
        _v4032 = _v4031.stamp
        _x = _v4032
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4031.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4030.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4030.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v4030.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4030.position.pack(pattern))
        length = _v4030.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4030.velocity.pack(pattern))
        length = _v4030.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4030.effort.pack(pattern))
        _v4033 = val1.grasp_posture
        _v4034 = _v4033.header
        buff.write(@@struct_L.pack(_v4034.seq))
        _v4035 = _v4034.stamp
        _x = _v4035
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4034.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4033.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4033.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v4033.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4033.position.pack(pattern))
        length = _v4033.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4033.velocity.pack(pattern))
        length = _v4033.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4033.effort.pack(pattern))
        _v4036 = val1.grasp_pose
        _v4037 = _v4036.header
        buff.write(@@struct_L.pack(_v4037.seq))
        _v4038 = _v4037.stamp
        _x = _v4038
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4037.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4039 = _v4036.pose
        _v4040 = _v4039.position
        _x = _v4040
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4041 = _v4039.orientation
        _x = _v4041
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_d.pack(val1.grasp_quality))
        _v4042 = val1.approach
        _v4043 = _v4042.direction
        _v4044 = _v4043.header
        buff.write(@@struct_L.pack(_v4044.seq))
        _v4045 = _v4044.stamp
        _x = _v4045
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4044.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4046 = _v4043.vector
        _x = _v4046
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v4042
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        _v4047 = val1.retreat
        _v4048 = _v4047.direction
        _v4049 = _v4048.header
        buff.write(@@struct_L.pack(_v4049.seq))
        _v4050 = _v4049.stamp
        _x = _v4050
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4049.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4051 = _v4048.vector
        _x = _v4051
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v4047
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        buff.write(@@struct_f.pack(val1.max_contact_force))
        length = val1.allowed_touch_objects.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.allowed_touch_objects
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
      end
      length = @goal.movable_obstacles.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.movable_obstacles
        _x = val1.reference_frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.potential_models.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.potential_models
          buff.write(@@struct_l.pack(val2.model_id))
          _v4052 = val2.type
          _x = _v4052.key
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = _v4052.db
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v4053 = val2.pose
          _v4054 = _v4053.header
          buff.write(@@struct_L.pack(_v4054.seq))
          _v4055 = _v4054.stamp
          _x = _v4055
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v4054.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v4056 = _v4053.pose
          _v4057 = _v4056.position
          _x = _v4057
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v4058 = _v4056.orientation
          _x = _v4058
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(@@struct_f.pack(val2.confidence))
          _x = val2.detector_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
        end
        _v4059 = val1.cluster
        _v4060 = _v4059.header
        buff.write(@@struct_L.pack(_v4060.seq))
        _v4061 = _v4060.stamp
        _x = _v4061
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4060.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4059.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4059.points
          _x = val3
          buff.write(@@struct_f3.pack(_x.x, _x.y, _x.z))
        end
        length = _v4059.channels.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4059.channels
          _x = val3.name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          length = val3.values.length
          buff.write(@@struct_L.pack(length))
          pattern = "f#{length}"
          buff.write(*val3.values.pack(pattern))
        end
        _v4062 = val1.region
        _v4063 = _v4062.cloud
        _v4064 = _v4063.header
        buff.write(@@struct_L.pack(_v4064.seq))
        _v4065 = _v4064.stamp
        _x = _v4065
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4064.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4063
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        length = _v4063.fields.length
        buff.write(@@struct_L.pack(length))
        for val4 in _v4063.fields
          _x = val4.name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val4
          buff.write(@@struct_LCL.pack(_x.offset, _x.datatype, _x.count))
        end
        _x = _v4063
        buff.write(@@struct_CL2.pack(_x.is_bigendian, _x.point_step, _x.row_step))
        _x = _v4063.data
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_C.pack(_v4063.is_dense))
        length = _v4062.mask.length
        buff.write(@@struct_L.pack(length))
        pattern = "l#{length}"
        buff.write(*_v4062.mask.pack(pattern))
        _v4066 = _v4062.image
        _v4067 = _v4066.header
        buff.write(@@struct_L.pack(_v4067.seq))
        _v4068 = _v4067.stamp
        _x = _v4068
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4067.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4066
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        _x = _v4066.encoding
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4066
        buff.write(@@struct_CL.pack(_x.is_bigendian, _x.step))
        _x = _v4066.data
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4069 = _v4062.disparity_image
        _v4070 = _v4069.header
        buff.write(@@struct_L.pack(_v4070.seq))
        _v4071 = _v4070.stamp
        _x = _v4071
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4070.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4069
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        _x = _v4069.encoding
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4069
        buff.write(@@struct_CL.pack(_x.is_bigendian, _x.step))
        _x = _v4069.data
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4072 = _v4062.cam_info
        _v4073 = _v4072.header
        buff.write(@@struct_L.pack(_v4073.seq))
        _v4074 = _v4073.stamp
        _x = _v4074
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4073.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4072
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        _x = _v4072.distortion_model
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4072.D.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4072.D.pack(pattern))
        buff.write(@@struct_d9.pack(*_v4072.K))
        buff.write(@@struct_d9.pack(*_v4072.R))
        buff.write(@@struct_d12.pack(*_v4072.P))
        _x = _v4072
        buff.write(@@struct_L2.pack(_x.binning_x, _x.binning_y))
        _v4075 = _v4072.roi
        _x = _v4075
        buff.write(@@struct_L4C.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
        _v4076 = _v4062.roi_box_pose
        _v4077 = _v4076.header
        buff.write(@@struct_L.pack(_v4077.seq))
        _v4078 = _v4077.stamp
        _x = _v4078
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4077.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4079 = _v4076.pose
        _v4080 = _v4079.position
        _x = _v4080
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4081 = _v4079.orientation
        _x = _v4081
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _v4082 = _v4062.roi_box_dims
        _x = _v4082
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = val1.collision_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @goal_id == nil
        @goal_id = Actionlib_msgs::GoalID.new
      end
      if @goal == nil
        @goal = Manipulation_msgs::GraspPlanningGoal.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@goal_id.stamp.secs, @goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.arm_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.reference_frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.target.potential_models = []
      length.times do
        val1 = Household_objects_database_msgs::DatabaseModelPose.new
        start = end_point
        end_point += ROS::Struct::calc_size('l')
        (val1.model_id,) = @@struct_l.unpack(str[start..(end_point-1)])
        _v4083 = val1.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4083.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4083.db = str[start..(end_point-1)]
        _v4084 = val1.pose
        _v4085 = _v4084.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4085.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4086 = _v4085.stamp
        _x = _v4086
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4085.frame_id = str[start..(end_point-1)]
        _v4087 = _v4084.pose
        _v4088 = _v4087.position
        _x = _v4088
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v4089 = _v4087.orientation
        _x = _v4089
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.confidence,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.detector_name = str[start..(end_point-1)]
        @goal.target.potential_models.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@goal.target.cluster.header.seq, @goal.target.cluster.header.stamp.secs, @goal.target.cluster.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.cluster.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.target.cluster.points = []
      length.times do
        val1 = Geometry_msgs::Point32.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('f3')
        (_x.x, _x.y, _x.z,) = @@struct_f3.unpack(str[start..(end_point-1)])
        @goal.target.cluster.points.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.target.cluster.channels = []
      length.times do
        val1 = Sensor_msgs::ChannelFloat32.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "f#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.values = str[start..(end_point-1)].unpack(pattern)
        @goal.target.cluster.channels.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@goal.target.region.cloud.header.seq, @goal.target.region.cloud.header.stamp.secs, @goal.target.region.cloud.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.region.cloud.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@goal.target.region.cloud.height, @goal.target.region.cloud.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.target.region.cloud.fields = []
      length.times do
        val1 = Sensor_msgs::PointField.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('LCL')
        (_x.offset, _x.datatype, _x.count,) = @@struct_LCL.unpack(str[start..(end_point-1)])
        @goal.target.region.cloud.fields.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('CL2')
      (@goal.target.region.cloud.is_bigendian, @goal.target.region.cloud.point_step, @goal.target.region.cloud.row_step,) = @@struct_CL2.unpack(str[start..(end_point-1)])
      @goal.target.region.cloud.is_bigendian = bool(@goal.target.region.cloud.is_bigendian)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.region.cloud.data = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@goal.target.region.cloud.is_dense,) = @@struct_C.unpack(str[start..(end_point-1)])
      @goal.target.region.cloud.is_dense = bool(@goal.target.region.cloud.is_dense)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "l#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.target.region.mask = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@goal.target.region.image.header.seq, @goal.target.region.image.header.stamp.secs, @goal.target.region.image.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.region.image.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@goal.target.region.image.height, @goal.target.region.image.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.region.image.encoding = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('CL')
      (@goal.target.region.image.is_bigendian, @goal.target.region.image.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.region.image.data = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@goal.target.region.disparity_image.header.seq, @goal.target.region.disparity_image.header.stamp.secs, @goal.target.region.disparity_image.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.region.disparity_image.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@goal.target.region.disparity_image.height, @goal.target.region.disparity_image.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.region.disparity_image.encoding = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('CL')
      (@goal.target.region.disparity_image.is_bigendian, @goal.target.region.disparity_image.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.region.disparity_image.data = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@goal.target.region.cam_info.header.seq, @goal.target.region.cam_info.header.stamp.secs, @goal.target.region.cam_info.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.region.cam_info.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@goal.target.region.cam_info.height, @goal.target.region.cam_info.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.region.cam_info.distortion_model = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.target.region.cam_info.D = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('d9')
      @goal.target.region.cam_info.K = @@struct_d9.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d9')
      @goal.target.region.cam_info.R = @@struct_d9.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d12')
      @goal.target.region.cam_info.P = @@struct_d12.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('L6CL3')
      (@goal.target.region.cam_info.binning_x, @goal.target.region.cam_info.binning_y, @goal.target.region.cam_info.roi.x_offset, @goal.target.region.cam_info.roi.y_offset, @goal.target.region.cam_info.roi.height, @goal.target.region.cam_info.roi.width, @goal.target.region.cam_info.roi.do_rectify, @goal.target.region.roi_box_pose.header.seq, @goal.target.region.roi_box_pose.header.stamp.secs, @goal.target.region.roi_box_pose.header.stamp.nsecs,) = @@struct_L6CL3.unpack(str[start..(end_point-1)])
      @goal.target.region.cam_info.roi.do_rectify = bool(@goal.target.region.cam_info.roi.do_rectify)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.region.roi_box_pose.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d10')
      (@goal.target.region.roi_box_pose.pose.position.x, @goal.target.region.roi_box_pose.pose.position.y, @goal.target.region.roi_box_pose.pose.position.z, @goal.target.region.roi_box_pose.pose.orientation.x, @goal.target.region.roi_box_pose.pose.orientation.y, @goal.target.region.roi_box_pose.pose.orientation.z, @goal.target.region.roi_box_pose.pose.orientation.w, @goal.target.region.roi_box_dims.x, @goal.target.region.roi_box_dims.y, @goal.target.region.roi_box_dims.z,) = @@struct_d10.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.target.collision_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.collision_object_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.collision_support_surface_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.grasps_to_evaluate = []
      length.times do
        val1 = Manipulation_msgs::Grasp.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v4090 = val1.pre_grasp_posture
        _v4091 = _v4090.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4091.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4092 = _v4091.stamp
        _x = _v4092
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4091.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4090.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v4090.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4090.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4090.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4090.effort = str[start..(end_point-1)].unpack(pattern)
        _v4093 = val1.grasp_posture
        _v4094 = _v4093.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4094.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4095 = _v4094.stamp
        _x = _v4095
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4094.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4093.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v4093.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4093.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4093.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4093.effort = str[start..(end_point-1)].unpack(pattern)
        _v4096 = val1.grasp_pose
        _v4097 = _v4096.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4097.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4098 = _v4097.stamp
        _x = _v4098
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4097.frame_id = str[start..(end_point-1)]
        _v4099 = _v4096.pose
        _v4100 = _v4099.position
        _x = _v4100
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v4101 = _v4099.orientation
        _x = _v4101
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.grasp_quality,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v4102 = val1.approach
        _v4103 = _v4102.direction
        _v4104 = _v4103.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4104.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4105 = _v4104.stamp
        _x = _v4105
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4104.frame_id = str[start..(end_point-1)]
        _v4106 = _v4103.vector
        _x = _v4106
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v4102
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        _v4107 = val1.retreat
        _v4108 = _v4107.direction
        _v4109 = _v4108.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4109.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4110 = _v4109.stamp
        _x = _v4110
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4109.frame_id = str[start..(end_point-1)]
        _v4111 = _v4108.vector
        _x = _v4111
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v4107
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.max_contact_force,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.allowed_touch_objects = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.allowed_touch_objects.push(val2)
        end
        @goal.grasps_to_evaluate.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.movable_obstacles = []
      length.times do
        val1 = Manipulation_msgs::GraspableObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.reference_frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.potential_models = []
        length.times do
          val2 = Household_objects_database_msgs::DatabaseModelPose.new
          start = end_point
          end_point += ROS::Struct::calc_size('l')
          (val2.model_id,) = @@struct_l.unpack(str[start..(end_point-1)])
          _v4112 = val2.type
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v4112.key = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v4112.db = str[start..(end_point-1)]
          _v4113 = val2.pose
          _v4114 = _v4113.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v4114.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v4115 = _v4114.stamp
          _x = _v4115
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v4114.frame_id = str[start..(end_point-1)]
          _v4116 = _v4113.pose
          _v4117 = _v4116.position
          _x = _v4117
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v4118 = _v4116.orientation
          _x = _v4118
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += ROS::Struct::calc_size('f')
          (val2.confidence,) = @@struct_f.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.detector_name = str[start..(end_point-1)]
          val1.potential_models.push(val2)
        end
        _v4119 = val1.cluster
        _v4120 = _v4119.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4120.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4121 = _v4120.stamp
        _x = _v4121
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4120.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4119.points = []
        length.times do
          val3 = Geometry_msgs::Point32.new
          _x = val3
          start = end_point
          end_point += ROS::Struct::calc_size('f3')
          (_x.x, _x.y, _x.z,) = @@struct_f3.unpack(str[start..(end_point-1)])
          _v4119.points.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4119.channels = []
        length.times do
          val3 = Sensor_msgs::ChannelFloat32.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3.name = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "f#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.values = str[start..(end_point-1)].unpack(pattern)
          _v4119.channels.push(val3)
        end
        _v4122 = val1.region
        _v4123 = _v4122.cloud
        _v4124 = _v4123.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4124.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4125 = _v4124.stamp
        _x = _v4125
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4124.frame_id = str[start..(end_point-1)]
        _x = _v4123
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4123.fields = []
        length.times do
          val4 = Sensor_msgs::PointField.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val4.name = str[start..(end_point-1)]
          _x = val4
          start = end_point
          end_point += ROS::Struct::calc_size('LCL')
          (_x.offset, _x.datatype, _x.count,) = @@struct_LCL.unpack(str[start..(end_point-1)])
          _v4123.fields.push(val4)
        end
        _x = _v4123
        start = end_point
        end_point += ROS::Struct::calc_size('CL2')
        (_x.is_bigendian, _x.point_step, _x.row_step,) = @@struct_CL2.unpack(str[start..(end_point-1)])
        _v4123.is_bigendian = bool(_v4123.is_bigendian)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4123.data = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (_v4123.is_dense,) = @@struct_C.unpack(str[start..(end_point-1)])
        _v4123.is_dense = bool(_v4123.is_dense)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "l#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4122.mask = str[start..(end_point-1)].unpack(pattern)
        _v4126 = _v4122.image
        _v4127 = _v4126.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4127.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4128 = _v4127.stamp
        _x = _v4128
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4127.frame_id = str[start..(end_point-1)]
        _x = _v4126
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4126.encoding = str[start..(end_point-1)]
        _x = _v4126
        start = end_point
        end_point += ROS::Struct::calc_size('CL')
        (_x.is_bigendian, _x.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4126.data = str[start..(end_point-1)]
        _v4129 = _v4122.disparity_image
        _v4130 = _v4129.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4130.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4131 = _v4130.stamp
        _x = _v4131
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4130.frame_id = str[start..(end_point-1)]
        _x = _v4129
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4129.encoding = str[start..(end_point-1)]
        _x = _v4129
        start = end_point
        end_point += ROS::Struct::calc_size('CL')
        (_x.is_bigendian, _x.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4129.data = str[start..(end_point-1)]
        _v4132 = _v4122.cam_info
        _v4133 = _v4132.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4133.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4134 = _v4133.stamp
        _x = _v4134
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4133.frame_id = str[start..(end_point-1)]
        _x = _v4132
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4132.distortion_model = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4132.D = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += ROS::Struct::calc_size('d9')
        _v4132.K = @@struct_d9.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d9')
        _v4132.R = @@struct_d9.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d12')
        _v4132.P = @@struct_d12.unpack(str[start..(end_point-1)])
        _x = _v4132
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.binning_x, _x.binning_y,) = @@struct_L2.unpack(str[start..(end_point-1)])
        _v4135 = _v4132.roi
        _x = _v4135
        start = end_point
        end_point += ROS::Struct::calc_size('L4C')
        (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = @@struct_L4C.unpack(str[start..(end_point-1)])
        _v4135.do_rectify = bool(_v4135.do_rectify)
        _v4136 = _v4122.roi_box_pose
        _v4137 = _v4136.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4137.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4138 = _v4137.stamp
        _x = _v4138
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4137.frame_id = str[start..(end_point-1)]
        _v4139 = _v4136.pose
        _v4140 = _v4139.position
        _x = _v4140
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v4141 = _v4139.orientation
        _x = _v4141
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        _v4142 = _v4122.roi_box_dims
        _x = _v4142
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.collision_name = str[start..(end_point-1)]
        @goal.movable_obstacles.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
