# autogenerated by genrb from GraspPlanningActionResult.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "geometry_msgs/Vector3Stamped"
require "manipulation_msgs/Grasp"
require "geometry_msgs/PoseStamped"
require "sensor_msgs/JointState"
require "geometry_msgs/Point"
require "manipulation_msgs/GripperTranslation"
require "std_msgs/Header"
require "actionlib_msgs/GoalID"
require "manipulation_msgs/GraspPlanningResult"
require "manipulation_msgs/GraspPlanningErrorCode"
require "geometry_msgs/Quaternion"
require "actionlib_msgs/GoalStatus"
require "geometry_msgs/Vector3"
require "geometry_msgs/Pose"

module Manipulation_msgs

class GraspPlanningActionResult <::ROS::Message
  def self.md5sum
    "3e6fbb82747590d8df5c4c99a3c657e8"
  end

  def self.type
    "manipulation_msgs/GraspPlanningActionResult"
  end

  def has_header?
    true
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
GraspPlanningResult result

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalStatus
GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: manipulation_msgs/GraspPlanningResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# the list of planned grasps
Grasp[] grasps

# whether an error occurred
GraspPlanningErrorCode error_code


================================================================================
MSG: manipulation_msgs/Grasp
# A name for this grasp
string id

# The internal posture of the hand for the pre-grasp
# only positions are used
sensor_msgs/JointState pre_grasp_posture

# The internal posture of the hand for the grasp
# positions and efforts are used
sensor_msgs/JointState grasp_posture

# The position of the end-effector for the grasp 
geometry_msgs/PoseStamped grasp_pose

# The estimated probability of success for this grasp, or some other
# measure of how \"good\" it is.
float64 grasp_quality

# The approach motion
GripperTranslation approach

# The retreat motion
GripperTranslation retreat

# the maximum contact force to use while grasping (<=0 to disable)
float32 max_contact_force

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping
string[] allowed_touch_objects

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: manipulation_msgs/GripperTranslation
# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: manipulation_msgs/GraspPlanningErrorCode
# Error codes for grasp and place planning

# plan completed as expected
int32 SUCCESS = 0

# tf error encountered while transforming
int32 TF_ERROR = 1 

# some other error
int32 OTHER_ERROR = 2

# the actual value of this error code
int32 value
"
  end
  attr_accessor :header, :status, :result

  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_f = ::ROS::Struct.new("f")
  @@struct_f2 = ::ROS::Struct.new("f2")
  @@struct_l = ::ROS::Struct.new("l")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','actionlib_msgs/GoalStatus','manipulation_msgs/GraspPlanningResult']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [actionlib_msgs/GoalStatus] :status initialize value
  # @option args [manipulation_msgs/GraspPlanningResult] :result initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:status]
      @status = args[:status]
    else
      @status = Actionlib_msgs::GoalStatus.new
    end
    if args[:result]
      @result = args[:result]
    else
      @result = Manipulation_msgs::GraspPlanningResult.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@status.goal_id.stamp.secs, @status.goal_id.stamp.nsecs))
      _x = @status.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@status.status))
      _x = @status.text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @result.grasps.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.grasps
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4143 = val1.pre_grasp_posture
        _v4144 = _v4143.header
        buff.write(@@struct_L.pack(_v4144.seq))
        _v4145 = _v4144.stamp
        _x = _v4145
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4144.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4143.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4143.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v4143.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4143.position.pack(pattern))
        length = _v4143.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4143.velocity.pack(pattern))
        length = _v4143.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4143.effort.pack(pattern))
        _v4146 = val1.grasp_posture
        _v4147 = _v4146.header
        buff.write(@@struct_L.pack(_v4147.seq))
        _v4148 = _v4147.stamp
        _x = _v4148
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4147.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4146.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4146.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v4146.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4146.position.pack(pattern))
        length = _v4146.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4146.velocity.pack(pattern))
        length = _v4146.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4146.effort.pack(pattern))
        _v4149 = val1.grasp_pose
        _v4150 = _v4149.header
        buff.write(@@struct_L.pack(_v4150.seq))
        _v4151 = _v4150.stamp
        _x = _v4151
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4150.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4152 = _v4149.pose
        _v4153 = _v4152.position
        _x = _v4153
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4154 = _v4152.orientation
        _x = _v4154
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_d.pack(val1.grasp_quality))
        _v4155 = val1.approach
        _v4156 = _v4155.direction
        _v4157 = _v4156.header
        buff.write(@@struct_L.pack(_v4157.seq))
        _v4158 = _v4157.stamp
        _x = _v4158
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4157.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4159 = _v4156.vector
        _x = _v4159
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v4155
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        _v4160 = val1.retreat
        _v4161 = _v4160.direction
        _v4162 = _v4161.header
        buff.write(@@struct_L.pack(_v4162.seq))
        _v4163 = _v4162.stamp
        _x = _v4163
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4162.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4164 = _v4161.vector
        _x = _v4164
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v4160
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        buff.write(@@struct_f.pack(val1.max_contact_force))
        length = val1.allowed_touch_objects.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.allowed_touch_objects
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
      end
      buff.write(@@struct_l.pack(@result.error_code.value))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @status == nil
        @status = Actionlib_msgs::GoalStatus.new
      end
      if @result == nil
        @result = Manipulation_msgs::GraspPlanningResult.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@status.goal_id.stamp.secs, @status.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @status.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@status.status,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @status.text = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.grasps = []
      length.times do
        val1 = Manipulation_msgs::Grasp.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v4165 = val1.pre_grasp_posture
        _v4166 = _v4165.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4166.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4167 = _v4166.stamp
        _x = _v4167
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4166.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4165.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v4165.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4165.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4165.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4165.effort = str[start..(end_point-1)].unpack(pattern)
        _v4168 = val1.grasp_posture
        _v4169 = _v4168.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4169.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4170 = _v4169.stamp
        _x = _v4170
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4169.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4168.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v4168.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4168.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4168.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4168.effort = str[start..(end_point-1)].unpack(pattern)
        _v4171 = val1.grasp_pose
        _v4172 = _v4171.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4172.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4173 = _v4172.stamp
        _x = _v4173
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4172.frame_id = str[start..(end_point-1)]
        _v4174 = _v4171.pose
        _v4175 = _v4174.position
        _x = _v4175
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v4176 = _v4174.orientation
        _x = _v4176
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.grasp_quality,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v4177 = val1.approach
        _v4178 = _v4177.direction
        _v4179 = _v4178.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4179.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4180 = _v4179.stamp
        _x = _v4180
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4179.frame_id = str[start..(end_point-1)]
        _v4181 = _v4178.vector
        _x = _v4181
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v4177
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        _v4182 = val1.retreat
        _v4183 = _v4182.direction
        _v4184 = _v4183.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4184.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4185 = _v4184.stamp
        _x = _v4185
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4184.frame_id = str[start..(end_point-1)]
        _v4186 = _v4183.vector
        _x = _v4186
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v4182
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.max_contact_force,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.allowed_touch_objects = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.allowed_touch_objects.push(val2)
        end
        @result.grasps.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('l')
      (@result.error_code.value,) = @@struct_l.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
