# autogenerated by genrb from GraspPlanningFeedback.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Vector3Stamped"
require "manipulation_msgs/Grasp"
require "geometry_msgs/PoseStamped"
require "sensor_msgs/JointState"
require "manipulation_msgs/GripperTranslation"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "geometry_msgs/Pose"

module Manipulation_msgs

class GraspPlanningFeedback <::ROS::Message
  def self.md5sum
    "0b493f83ef98679f05dc681205fbe54c"
  end

  def self.type
    "manipulation_msgs/GraspPlanningFeedback"
  end

  def has_header?
    false
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# grasps planned so far
Grasp[] grasps



================================================================================
MSG: manipulation_msgs/Grasp
# A name for this grasp
string id

# The internal posture of the hand for the pre-grasp
# only positions are used
sensor_msgs/JointState pre_grasp_posture

# The internal posture of the hand for the grasp
# positions and efforts are used
sensor_msgs/JointState grasp_posture

# The position of the end-effector for the grasp 
geometry_msgs/PoseStamped grasp_pose

# The estimated probability of success for this grasp, or some other
# measure of how \"good\" it is.
float64 grasp_quality

# The approach motion
GripperTranslation approach

# The retreat motion
GripperTranslation retreat

# the maximum contact force to use while grasping (<=0 to disable)
float32 max_contact_force

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping
string[] allowed_touch_objects

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: manipulation_msgs/GripperTranslation
# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :grasps

  @@struct_d = ::ROS::Struct.new("d")
  @@struct_f = ::ROS::Struct.new("f")
  @@struct_f2 = ::ROS::Struct.new("f2")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['manipulation_msgs/Grasp[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [manipulation_msgs/Grasp[]] :grasps initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:grasps]
      @grasps = args[:grasps]
    else
      @grasps = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      length = @grasps.length
      buff.write(@@struct_L.pack(length))
      for val1 in @grasps
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4187 = val1.pre_grasp_posture
        _v4188 = _v4187.header
        buff.write(@@struct_L.pack(_v4188.seq))
        _v4189 = _v4188.stamp
        _x = _v4189
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4188.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4187.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4187.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v4187.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4187.position.pack(pattern))
        length = _v4187.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4187.velocity.pack(pattern))
        length = _v4187.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4187.effort.pack(pattern))
        _v4190 = val1.grasp_posture
        _v4191 = _v4190.header
        buff.write(@@struct_L.pack(_v4191.seq))
        _v4192 = _v4191.stamp
        _x = _v4192
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4191.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4190.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4190.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v4190.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4190.position.pack(pattern))
        length = _v4190.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4190.velocity.pack(pattern))
        length = _v4190.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4190.effort.pack(pattern))
        _v4193 = val1.grasp_pose
        _v4194 = _v4193.header
        buff.write(@@struct_L.pack(_v4194.seq))
        _v4195 = _v4194.stamp
        _x = _v4195
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4194.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4196 = _v4193.pose
        _v4197 = _v4196.position
        _x = _v4197
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4198 = _v4196.orientation
        _x = _v4198
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_d.pack(val1.grasp_quality))
        _v4199 = val1.approach
        _v4200 = _v4199.direction
        _v4201 = _v4200.header
        buff.write(@@struct_L.pack(_v4201.seq))
        _v4202 = _v4201.stamp
        _x = _v4202
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4201.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4203 = _v4200.vector
        _x = _v4203
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v4199
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        _v4204 = val1.retreat
        _v4205 = _v4204.direction
        _v4206 = _v4205.header
        buff.write(@@struct_L.pack(_v4206.seq))
        _v4207 = _v4206.stamp
        _x = _v4207
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4206.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4208 = _v4205.vector
        _x = _v4208
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v4204
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        buff.write(@@struct_f.pack(val1.max_contact_force))
        length = val1.allowed_touch_objects.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.allowed_touch_objects
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @grasps == nil
        @grasps = Manipulation_msgs::Grasp[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @grasps = []
      length.times do
        val1 = Manipulation_msgs::Grasp.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v4209 = val1.pre_grasp_posture
        _v4210 = _v4209.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4210.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4211 = _v4210.stamp
        _x = _v4211
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4210.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4209.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v4209.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4209.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4209.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4209.effort = str[start..(end_point-1)].unpack(pattern)
        _v4212 = val1.grasp_posture
        _v4213 = _v4212.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4213.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4214 = _v4213.stamp
        _x = _v4214
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4213.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4212.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v4212.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4212.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4212.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4212.effort = str[start..(end_point-1)].unpack(pattern)
        _v4215 = val1.grasp_pose
        _v4216 = _v4215.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4216.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4217 = _v4216.stamp
        _x = _v4217
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4216.frame_id = str[start..(end_point-1)]
        _v4218 = _v4215.pose
        _v4219 = _v4218.position
        _x = _v4219
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v4220 = _v4218.orientation
        _x = _v4220
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.grasp_quality,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v4221 = val1.approach
        _v4222 = _v4221.direction
        _v4223 = _v4222.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4223.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4224 = _v4223.stamp
        _x = _v4224
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4223.frame_id = str[start..(end_point-1)]
        _v4225 = _v4222.vector
        _x = _v4225
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v4221
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        _v4226 = val1.retreat
        _v4227 = _v4226.direction
        _v4228 = _v4227.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4228.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4229 = _v4228.stamp
        _x = _v4229
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4228.frame_id = str[start..(end_point-1)]
        _v4230 = _v4227.vector
        _x = _v4230
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v4226
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.max_contact_force,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.allowed_touch_objects = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.allowed_touch_objects.push(val2)
        end
        @grasps.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
