# autogenerated by genrb from GraspPlanningGoal.msg. Do not edit.
require 'ros/message'

require "sensor_msgs/PointField"
require "geometry_msgs/Point32"
require "geometry_msgs/Point"
require "geometry_msgs/Vector3Stamped"
require "sensor_msgs/CameraInfo"
require "household_objects_database_msgs/DatabaseModelPose"
require "sensor_msgs/PointCloud2"
require "sensor_msgs/Image"
require "geometry_msgs/PoseStamped"
require "std_msgs/Header"
require "sensor_msgs/ChannelFloat32"
require "geometry_msgs/Pose"
require "sensor_msgs/RegionOfInterest"
require "manipulation_msgs/GripperTranslation"
require "geometry_msgs/Quaternion"
require "manipulation_msgs/Grasp"
require "sensor_msgs/JointState"
require "sensor_msgs/PointCloud"
require "object_recognition_msgs/ObjectType"
require "manipulation_msgs/GraspableObject"
require "manipulation_msgs/SceneRegion"
require "geometry_msgs/Vector3"

module Manipulation_msgs

class GraspPlanningGoal <::ROS::Message
  def self.md5sum
    "077dca08a07415d82d6ab047890161f4"
  end

  def self.type
    "manipulation_msgs/GraspPlanningGoal"
  end

  def has_header?
    false
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Requests that grasp planning be performed on the object to be grasped
# returns a list of grasps to be tested and executed

# the arm being used
string arm_name

# the object to be grasped
GraspableObject target

# the name that the target object has in the collision environment
# can be left empty if no name is available
string collision_object_name

# the name that the support surface (e.g. table) has in the collision map
# can be left empty if no name is available
string collision_support_surface_name

# an optional list of grasps to be evaluated by the planner
Grasp[] grasps_to_evaluate

# an optional list of obstacles that we have semantic information about
# and that can be moved in the course of grasping
GraspableObject[] movable_obstacles


================================================================================
MSG: manipulation_msgs/GraspableObject
# an object that the object_manipulator can work on

# a graspable object can be represented in multiple ways. This message
# can contain all of them. Which one is actually used is up to the receiver
# of this message. When adding new representations, one must be careful that
# they have reasonable lightweight defaults indicating that that particular
# representation is not available.

# the tf frame to be used as a reference frame when combining information from
# the different representations below
string reference_frame_id

# potential recognition results from a database of models
# all poses are relative to the object reference pose
household_objects_database_msgs/DatabaseModelPose[] potential_models

# the point cloud itself
sensor_msgs/PointCloud cluster

# a region of a PointCloud2 of interest
SceneRegion region

# the name that this object has in the collision environment
string collision_name
================================================================================
MSG: household_objects_database_msgs/DatabaseModelPose
# Informs that a specific model from the Model Database has been 
# identified at a certain location

# the database id of the model
int32 model_id

# if the object was recognized by the ORK pipeline, its type will be in here
# if this is not empty, then the string in here will be converted to a household_objects_database id
# leave this empty if providing an id in the model_id field
object_recognition_msgs/ObjectType type

# the pose that it can be found in
geometry_msgs/PoseStamped pose

# a measure of the confidence level in this detection result
float32 confidence

# the name of the object detector that generated this detection result
string detector_name

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: sensor_msgs/PointCloud
# This message holds a collection of 3d points, plus optional additional
# information about each point.

# Time of sensor data acquisition, coordinate frame ID.
Header header

# Array of 3d points. Each Point32 should be interpreted as a 3d point
# in the frame given in the header.
geometry_msgs/Point32[] points

# Each channel should have the same number of elements as points array,
# and the data in each channel should correspond 1:1 with each point.
# Channel names in common practice are listed in ChannelFloat32.msg.
ChannelFloat32[] channels

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
================================================================================
MSG: sensor_msgs/ChannelFloat32
# This message is used by the PointCloud message to hold optional data
# associated with each point in the cloud. The length of the values
# array should be the same as the length of the points array in the
# PointCloud, and each value should be associated with the corresponding
# point.

# Channel names in existing practice include:
#   \"u\", \"v\" - row and column (respectively) in the left stereo image.
#              This is opposite to usual conventions but remains for
#              historical reasons. The newer PointCloud2 message has no
#              such problem.
#   \"rgb\" - For point clouds produced by color stereo cameras. uint8
#           (R,G,B) values packed into the least significant 24 bits,
#           in order.
#   \"intensity\" - laser or pixel intensity.
#   \"distance\"

# The channel name should give semantics of the channel (e.g.
# \"intensity\" instead of \"value\").
string name

# The values array should be 1-1 with the elements of the associated
# PointCloud.
float32[] values

================================================================================
MSG: manipulation_msgs/SceneRegion
# Point cloud
sensor_msgs/PointCloud2 cloud

# Indices for the region of interest
int32[] mask

# One of the corresponding 2D images, if applicable
sensor_msgs/Image image

# The disparity image, if applicable
sensor_msgs/Image disparity_image

# Camera info for the camera that took the image
sensor_msgs/CameraInfo cam_info

# a 3D region of interest for grasp planning
geometry_msgs/PoseStamped  roi_box_pose
geometry_msgs/Vector3 	   roi_box_dims

================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the \"fields\" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field

================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in include/sensor_msgs/image_encodings.h

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: sensor_msgs/CameraInfo
# This message defines meta information for a camera. It should be in a
# camera namespace on topic \"camera_info\" and accompanied by up to five
# image topics named:
#
#   image_raw - raw data from the camera driver, possibly Bayer encoded
#   image            - monochrome, distorted
#   image_color      - color, distorted
#   image_rect       - monochrome, rectified
#   image_rect_color - color, rectified
#
# The image_pipeline contains packages (image_proc, stereo_image_proc)
# for producing the four processed image topics from image_raw and
# camera_info. The meaning of the camera parameters are described in
# detail at http://www.ros.org/wiki/image_pipeline/CameraInfo.
#
# The image_geometry package provides a user-friendly interface to
# common operations using this meta information. If you want to, e.g.,
# project a 3d point into image coordinates, we strongly recommend
# using image_geometry.
#
# If the camera is uncalibrated, the matrices D, K, R, P should be left
# zeroed out. In particular, clients may assume that K[0] == 0.0
# indicates an uncalibrated camera.

#######################################################################
#                     Image acquisition info                          #
#######################################################################

# Time of image acquisition, camera coordinate frame ID
Header header    # Header timestamp should be acquisition time of image
                 # Header frame_id should be optical frame of camera
                 # origin of frame should be optical center of camera
                 # +x should point to the right in the image
                 # +y should point down in the image
                 # +z should point into the plane of the image


#######################################################################
#                      Calibration Parameters                         #
#######################################################################
# These are fixed during camera calibration. Their values will be the #
# same in all messages until the camera is recalibrated. Note that    #
# self-calibrating systems may \"recalibrate\" frequently.              #
#                                                                     #
# The internal parameters can be used to warp a raw (distorted) image #
# to:                                                                 #
#   1. An undistorted image (requires D and K)                        #
#   2. A rectified image (requires D, K, R)                           #
# The projection matrix P projects 3D points into the rectified image.#
#######################################################################

# The image dimensions with which the camera was calibrated. Normally
# this will be the full camera resolution in pixels.
uint32 height
uint32 width

# The distortion model used. Supported models are listed in
# sensor_msgs/distortion_models.h. For most cameras, \"plumb_bob\" - a
# simple model of radial and tangential distortion - is sufficent.
string distortion_model

# The distortion parameters, size depending on the distortion model.
# For \"plumb_bob\", the 5 parameters are: (k1, k2, t1, t2, k3).
float64[] D

# Intrinsic camera matrix for the raw (distorted) images.
#     [fx  0 cx]
# K = [ 0 fy cy]
#     [ 0  0  1]
# Projects 3D points in the camera coordinate frame to 2D pixel
# coordinates using the focal lengths (fx, fy) and principal point
# (cx, cy).
float64[9]  K # 3x3 row-major matrix

# Rectification matrix (stereo cameras only)
# A rotation matrix aligning the camera coordinate system to the ideal
# stereo image plane so that epipolar lines in both stereo images are
# parallel.
float64[9]  R # 3x3 row-major matrix

# Projection/camera matrix
#     [fx'  0  cx' Tx]
# P = [ 0  fy' cy' Ty]
#     [ 0   0   1   0]
# By convention, this matrix specifies the intrinsic (camera) matrix
#  of the processed (rectified) image. That is, the left 3x3 portion
#  is the normal camera intrinsic matrix for the rectified image.
# It projects 3D points in the camera coordinate frame to 2D pixel
#  coordinates using the focal lengths (fx', fy') and principal point
#  (cx', cy') - these may differ from the values in K.
# For monocular cameras, Tx = Ty = 0. Normally, monocular cameras will
#  also have R = the identity and P[1:3,1:3] = K.
# For a stereo pair, the fourth column [Tx Ty 0]' is related to the
#  position of the optical center of the second camera in the first
#  camera's frame. We assume Tz = 0 so both cameras are in the same
#  stereo image plane. The first camera always has Tx = Ty = 0. For
#  the right (second) camera of a horizontal stereo pair, Ty = 0 and
#  Tx = -fx' * B, where B is the baseline between the cameras.
# Given a 3D point [X Y Z]', the projection (x, y) of the point onto
#  the rectified image is given by:
#  [u v w]' = P * [X Y Z 1]'
#         x = u / w
#         y = v / w
#  This holds for both images of a stereo pair.
float64[12] P # 3x4 row-major matrix


#######################################################################
#                      Operational Parameters                         #
#######################################################################
# These define the image region actually captured by the camera       #
# driver. Although they affect the geometry of the output image, they #
# may be changed freely without recalibrating the camera.             #
#######################################################################

# Binning refers here to any camera setting which combines rectangular
#  neighborhoods of pixels into larger \"super-pixels.\" It reduces the
#  resolution of the output image to
#  (width / binning_x) x (height / binning_y).
# The default values binning_x = binning_y = 0 is considered the same
#  as binning_x = binning_y = 1 (no subsampling).
uint32 binning_x
uint32 binning_y

# Region of interest (subwindow of full camera resolution), given in
#  full resolution (unbinned) image coordinates. A particular ROI
#  always denotes the same window of pixels on the camera sensor,
#  regardless of binning settings.
# The default setting of roi (all values 0) is considered the same as
#  full resolution (roi.width = width, roi.height = height).
RegionOfInterest roi

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image.
#
# When used to specify the ROI setting of the camera when the image was
# taken, the height and width fields should either match the height and
# width fields for the associated image; or height = width = 0
# indicates that the full resolution image was captured.

uint32 x_offset  # Leftmost pixel of the ROI
                 # (0 if the ROI includes the left edge of the image)
uint32 y_offset  # Topmost pixel of the ROI
                 # (0 if the ROI includes the top edge of the image)
uint32 height    # Height of ROI
uint32 width     # Width of ROI

# True if a distinct rectified ROI should be calculated from the \"raw\"
# ROI in this message. Typically this should be False if the full image
# is captured (ROI not used), and True if a subwindow is captured (ROI
# used).
bool do_rectify

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: manipulation_msgs/Grasp
# A name for this grasp
string id

# The internal posture of the hand for the pre-grasp
# only positions are used
sensor_msgs/JointState pre_grasp_posture

# The internal posture of the hand for the grasp
# positions and efforts are used
sensor_msgs/JointState grasp_posture

# The position of the end-effector for the grasp 
geometry_msgs/PoseStamped grasp_pose

# The estimated probability of success for this grasp, or some other
# measure of how \"good\" it is.
float64 grasp_quality

# The approach motion
GripperTranslation approach

# The retreat motion
GripperTranslation retreat

# the maximum contact force to use while grasping (<=0 to disable)
float32 max_contact_force

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping
string[] allowed_touch_objects

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: manipulation_msgs/GripperTranslation
# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

"
  end
  attr_accessor :arm_name, :target, :collision_object_name, :collision_support_surface_name, :grasps_to_evaluate, :movable_obstacles

  @@struct_LCL = ::ROS::Struct.new("LCL")
  @@struct_L6CL3 = ::ROS::Struct.new("L6CL3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d12 = ::ROS::Struct.new("d12")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_f = ::ROS::Struct.new("f")
  @@struct_l = ::ROS::Struct.new("l")
  @@struct_CL = ::ROS::Struct.new("CL")
  @@struct_d10 = ::ROS::Struct.new("d10")
  @@struct_f3 = ::ROS::Struct.new("f3")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d9 = ::ROS::Struct.new("d9")
  @@struct_f2 = ::ROS::Struct.new("f2")
  @@struct_CL2 = ::ROS::Struct.new("CL2")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_L4C = ::ROS::Struct.new("L4C")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','manipulation_msgs/GraspableObject','string','string','manipulation_msgs/Grasp[]','manipulation_msgs/GraspableObject[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :arm_name initialize value
  # @option args [manipulation_msgs/GraspableObject] :target initialize value
  # @option args [string] :collision_object_name initialize value
  # @option args [string] :collision_support_surface_name initialize value
  # @option args [manipulation_msgs/Grasp[]] :grasps_to_evaluate initialize value
  # @option args [manipulation_msgs/GraspableObject[]] :movable_obstacles initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:arm_name]
      @arm_name = args[:arm_name]
    else
      @arm_name = ''
    end
    if args[:target]
      @target = args[:target]
    else
      @target = Manipulation_msgs::GraspableObject.new
    end
    if args[:collision_object_name]
      @collision_object_name = args[:collision_object_name]
    else
      @collision_object_name = ''
    end
    if args[:collision_support_surface_name]
      @collision_support_surface_name = args[:collision_support_surface_name]
    else
      @collision_support_surface_name = ''
    end
    if args[:grasps_to_evaluate]
      @grasps_to_evaluate = args[:grasps_to_evaluate]
    else
      @grasps_to_evaluate = []
    end
    if args[:movable_obstacles]
      @movable_obstacles = args[:movable_obstacles]
    else
      @movable_obstacles = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @arm_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @target.reference_frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @target.potential_models.length
      buff.write(@@struct_L.pack(length))
      for val1 in @target.potential_models
        buff.write(@@struct_l.pack(val1.model_id))
        _v4231 = val1.type
        _x = _v4231.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4231.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4232 = val1.pose
        _v4233 = _v4232.header
        buff.write(@@struct_L.pack(_v4233.seq))
        _v4234 = _v4233.stamp
        _x = _v4234
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4233.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4235 = _v4232.pose
        _v4236 = _v4235.position
        _x = _v4236
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4237 = _v4235.orientation
        _x = _v4237
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_f.pack(val1.confidence))
        _x = val1.detector_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
      buff.write(@@struct_L3.pack(@target.cluster.header.seq, @target.cluster.header.stamp.secs, @target.cluster.header.stamp.nsecs))
      _x = @target.cluster.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @target.cluster.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @target.cluster.points
        _x = val1
        buff.write(@@struct_f3.pack(_x.x, _x.y, _x.z))
      end
      length = @target.cluster.channels.length
      buff.write(@@struct_L.pack(length))
      for val1 in @target.cluster.channels
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.values.length
        buff.write(@@struct_L.pack(length))
        pattern = "f#{length}"
        buff.write(*val1.values.pack(pattern))
      end
      buff.write(@@struct_L3.pack(@target.region.cloud.header.seq, @target.region.cloud.header.stamp.secs, @target.region.cloud.header.stamp.nsecs))
      _x = @target.region.cloud.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@target.region.cloud.height, @target.region.cloud.width))
      length = @target.region.cloud.fields.length
      buff.write(@@struct_L.pack(length))
      for val1 in @target.region.cloud.fields
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_LCL.pack(_x.offset, _x.datatype, _x.count))
      end
      buff.write(@@struct_CL2.pack(@target.region.cloud.is_bigendian, @target.region.cloud.point_step, @target.region.cloud.row_step))
      _x = @target.region.cloud.data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@target.region.cloud.is_dense))
      length = @target.region.mask.length
      buff.write(@@struct_L.pack(length))
      pattern = "l#{length}"
      buff.write(*@target.region.mask.pack(pattern))
      buff.write(@@struct_L3.pack(@target.region.image.header.seq, @target.region.image.header.stamp.secs, @target.region.image.header.stamp.nsecs))
      _x = @target.region.image.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@target.region.image.height, @target.region.image.width))
      _x = @target.region.image.encoding
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_CL.pack(@target.region.image.is_bigendian, @target.region.image.step))
      _x = @target.region.image.data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@target.region.disparity_image.header.seq, @target.region.disparity_image.header.stamp.secs, @target.region.disparity_image.header.stamp.nsecs))
      _x = @target.region.disparity_image.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@target.region.disparity_image.height, @target.region.disparity_image.width))
      _x = @target.region.disparity_image.encoding
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_CL.pack(@target.region.disparity_image.is_bigendian, @target.region.disparity_image.step))
      _x = @target.region.disparity_image.data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@target.region.cam_info.header.seq, @target.region.cam_info.header.stamp.secs, @target.region.cam_info.header.stamp.nsecs))
      _x = @target.region.cam_info.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@target.region.cam_info.height, @target.region.cam_info.width))
      _x = @target.region.cam_info.distortion_model
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @target.region.cam_info.D.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@target.region.cam_info.D.pack(pattern))
      buff.write(@@struct_d9.pack(*@target.region.cam_info.K))
      buff.write(@@struct_d9.pack(*@target.region.cam_info.R))
      buff.write(@@struct_d12.pack(*@target.region.cam_info.P))
      buff.write(@@struct_L6CL3.pack(@target.region.cam_info.binning_x, @target.region.cam_info.binning_y, @target.region.cam_info.roi.x_offset, @target.region.cam_info.roi.y_offset, @target.region.cam_info.roi.height, @target.region.cam_info.roi.width, @target.region.cam_info.roi.do_rectify, @target.region.roi_box_pose.header.seq, @target.region.roi_box_pose.header.stamp.secs, @target.region.roi_box_pose.header.stamp.nsecs))
      _x = @target.region.roi_box_pose.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d10.pack(@target.region.roi_box_pose.pose.position.x, @target.region.roi_box_pose.pose.position.y, @target.region.roi_box_pose.pose.position.z, @target.region.roi_box_pose.pose.orientation.x, @target.region.roi_box_pose.pose.orientation.y, @target.region.roi_box_pose.pose.orientation.z, @target.region.roi_box_pose.pose.orientation.w, @target.region.roi_box_dims.x, @target.region.roi_box_dims.y, @target.region.roi_box_dims.z))
      _x = @target.collision_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @collision_object_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @collision_support_surface_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @grasps_to_evaluate.length
      buff.write(@@struct_L.pack(length))
      for val1 in @grasps_to_evaluate
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4238 = val1.pre_grasp_posture
        _v4239 = _v4238.header
        buff.write(@@struct_L.pack(_v4239.seq))
        _v4240 = _v4239.stamp
        _x = _v4240
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4239.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4238.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4238.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v4238.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4238.position.pack(pattern))
        length = _v4238.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4238.velocity.pack(pattern))
        length = _v4238.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4238.effort.pack(pattern))
        _v4241 = val1.grasp_posture
        _v4242 = _v4241.header
        buff.write(@@struct_L.pack(_v4242.seq))
        _v4243 = _v4242.stamp
        _x = _v4243
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4242.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4241.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4241.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v4241.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4241.position.pack(pattern))
        length = _v4241.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4241.velocity.pack(pattern))
        length = _v4241.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4241.effort.pack(pattern))
        _v4244 = val1.grasp_pose
        _v4245 = _v4244.header
        buff.write(@@struct_L.pack(_v4245.seq))
        _v4246 = _v4245.stamp
        _x = _v4246
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4245.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4247 = _v4244.pose
        _v4248 = _v4247.position
        _x = _v4248
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4249 = _v4247.orientation
        _x = _v4249
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_d.pack(val1.grasp_quality))
        _v4250 = val1.approach
        _v4251 = _v4250.direction
        _v4252 = _v4251.header
        buff.write(@@struct_L.pack(_v4252.seq))
        _v4253 = _v4252.stamp
        _x = _v4253
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4252.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4254 = _v4251.vector
        _x = _v4254
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v4250
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        _v4255 = val1.retreat
        _v4256 = _v4255.direction
        _v4257 = _v4256.header
        buff.write(@@struct_L.pack(_v4257.seq))
        _v4258 = _v4257.stamp
        _x = _v4258
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4257.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4259 = _v4256.vector
        _x = _v4259
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v4255
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        buff.write(@@struct_f.pack(val1.max_contact_force))
        length = val1.allowed_touch_objects.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.allowed_touch_objects
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
      end
      length = @movable_obstacles.length
      buff.write(@@struct_L.pack(length))
      for val1 in @movable_obstacles
        _x = val1.reference_frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.potential_models.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.potential_models
          buff.write(@@struct_l.pack(val2.model_id))
          _v4260 = val2.type
          _x = _v4260.key
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = _v4260.db
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v4261 = val2.pose
          _v4262 = _v4261.header
          buff.write(@@struct_L.pack(_v4262.seq))
          _v4263 = _v4262.stamp
          _x = _v4263
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v4262.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v4264 = _v4261.pose
          _v4265 = _v4264.position
          _x = _v4265
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v4266 = _v4264.orientation
          _x = _v4266
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(@@struct_f.pack(val2.confidence))
          _x = val2.detector_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
        end
        _v4267 = val1.cluster
        _v4268 = _v4267.header
        buff.write(@@struct_L.pack(_v4268.seq))
        _v4269 = _v4268.stamp
        _x = _v4269
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4268.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4267.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4267.points
          _x = val3
          buff.write(@@struct_f3.pack(_x.x, _x.y, _x.z))
        end
        length = _v4267.channels.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4267.channels
          _x = val3.name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          length = val3.values.length
          buff.write(@@struct_L.pack(length))
          pattern = "f#{length}"
          buff.write(*val3.values.pack(pattern))
        end
        _v4270 = val1.region
        _v4271 = _v4270.cloud
        _v4272 = _v4271.header
        buff.write(@@struct_L.pack(_v4272.seq))
        _v4273 = _v4272.stamp
        _x = _v4273
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4272.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4271
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        length = _v4271.fields.length
        buff.write(@@struct_L.pack(length))
        for val4 in _v4271.fields
          _x = val4.name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val4
          buff.write(@@struct_LCL.pack(_x.offset, _x.datatype, _x.count))
        end
        _x = _v4271
        buff.write(@@struct_CL2.pack(_x.is_bigendian, _x.point_step, _x.row_step))
        _x = _v4271.data
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_C.pack(_v4271.is_dense))
        length = _v4270.mask.length
        buff.write(@@struct_L.pack(length))
        pattern = "l#{length}"
        buff.write(*_v4270.mask.pack(pattern))
        _v4274 = _v4270.image
        _v4275 = _v4274.header
        buff.write(@@struct_L.pack(_v4275.seq))
        _v4276 = _v4275.stamp
        _x = _v4276
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4275.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4274
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        _x = _v4274.encoding
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4274
        buff.write(@@struct_CL.pack(_x.is_bigendian, _x.step))
        _x = _v4274.data
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4277 = _v4270.disparity_image
        _v4278 = _v4277.header
        buff.write(@@struct_L.pack(_v4278.seq))
        _v4279 = _v4278.stamp
        _x = _v4279
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4278.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4277
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        _x = _v4277.encoding
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4277
        buff.write(@@struct_CL.pack(_x.is_bigendian, _x.step))
        _x = _v4277.data
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4280 = _v4270.cam_info
        _v4281 = _v4280.header
        buff.write(@@struct_L.pack(_v4281.seq))
        _v4282 = _v4281.stamp
        _x = _v4282
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4281.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4280
        buff.write(@@struct_L2.pack(_x.height, _x.width))
        _x = _v4280.distortion_model
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4280.D.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4280.D.pack(pattern))
        buff.write(@@struct_d9.pack(*_v4280.K))
        buff.write(@@struct_d9.pack(*_v4280.R))
        buff.write(@@struct_d12.pack(*_v4280.P))
        _x = _v4280
        buff.write(@@struct_L2.pack(_x.binning_x, _x.binning_y))
        _v4283 = _v4280.roi
        _x = _v4283
        buff.write(@@struct_L4C.pack(_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify))
        _v4284 = _v4270.roi_box_pose
        _v4285 = _v4284.header
        buff.write(@@struct_L.pack(_v4285.seq))
        _v4286 = _v4285.stamp
        _x = _v4286
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4285.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4287 = _v4284.pose
        _v4288 = _v4287.position
        _x = _v4288
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4289 = _v4287.orientation
        _x = _v4289
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _v4290 = _v4270.roi_box_dims
        _x = _v4290
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = val1.collision_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @target == nil
        @target = Manipulation_msgs::GraspableObject.new
      end
      if @grasps_to_evaluate == nil
        @grasps_to_evaluate = Manipulation_msgs::Grasp[].new
      end
      if @movable_obstacles == nil
        @movable_obstacles = Manipulation_msgs::GraspableObject[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @arm_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.reference_frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @target.potential_models = []
      length.times do
        val1 = Household_objects_database_msgs::DatabaseModelPose.new
        start = end_point
        end_point += ROS::Struct::calc_size('l')
        (val1.model_id,) = @@struct_l.unpack(str[start..(end_point-1)])
        _v4291 = val1.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4291.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4291.db = str[start..(end_point-1)]
        _v4292 = val1.pose
        _v4293 = _v4292.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4293.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4294 = _v4293.stamp
        _x = _v4294
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4293.frame_id = str[start..(end_point-1)]
        _v4295 = _v4292.pose
        _v4296 = _v4295.position
        _x = _v4296
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v4297 = _v4295.orientation
        _x = _v4297
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.confidence,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.detector_name = str[start..(end_point-1)]
        @target.potential_models.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@target.cluster.header.seq, @target.cluster.header.stamp.secs, @target.cluster.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.cluster.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @target.cluster.points = []
      length.times do
        val1 = Geometry_msgs::Point32.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('f3')
        (_x.x, _x.y, _x.z,) = @@struct_f3.unpack(str[start..(end_point-1)])
        @target.cluster.points.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @target.cluster.channels = []
      length.times do
        val1 = Sensor_msgs::ChannelFloat32.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "f#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.values = str[start..(end_point-1)].unpack(pattern)
        @target.cluster.channels.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@target.region.cloud.header.seq, @target.region.cloud.header.stamp.secs, @target.region.cloud.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.region.cloud.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@target.region.cloud.height, @target.region.cloud.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @target.region.cloud.fields = []
      length.times do
        val1 = Sensor_msgs::PointField.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('LCL')
        (_x.offset, _x.datatype, _x.count,) = @@struct_LCL.unpack(str[start..(end_point-1)])
        @target.region.cloud.fields.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('CL2')
      (@target.region.cloud.is_bigendian, @target.region.cloud.point_step, @target.region.cloud.row_step,) = @@struct_CL2.unpack(str[start..(end_point-1)])
      @target.region.cloud.is_bigendian = bool(@target.region.cloud.is_bigendian)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.region.cloud.data = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@target.region.cloud.is_dense,) = @@struct_C.unpack(str[start..(end_point-1)])
      @target.region.cloud.is_dense = bool(@target.region.cloud.is_dense)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "l#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @target.region.mask = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@target.region.image.header.seq, @target.region.image.header.stamp.secs, @target.region.image.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.region.image.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@target.region.image.height, @target.region.image.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.region.image.encoding = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('CL')
      (@target.region.image.is_bigendian, @target.region.image.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.region.image.data = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@target.region.disparity_image.header.seq, @target.region.disparity_image.header.stamp.secs, @target.region.disparity_image.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.region.disparity_image.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@target.region.disparity_image.height, @target.region.disparity_image.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.region.disparity_image.encoding = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('CL')
      (@target.region.disparity_image.is_bigendian, @target.region.disparity_image.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.region.disparity_image.data = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@target.region.cam_info.header.seq, @target.region.cam_info.header.stamp.secs, @target.region.cam_info.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.region.cam_info.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@target.region.cam_info.height, @target.region.cam_info.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.region.cam_info.distortion_model = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @target.region.cam_info.D = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('d9')
      @target.region.cam_info.K = @@struct_d9.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d9')
      @target.region.cam_info.R = @@struct_d9.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d12')
      @target.region.cam_info.P = @@struct_d12.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('L6CL3')
      (@target.region.cam_info.binning_x, @target.region.cam_info.binning_y, @target.region.cam_info.roi.x_offset, @target.region.cam_info.roi.y_offset, @target.region.cam_info.roi.height, @target.region.cam_info.roi.width, @target.region.cam_info.roi.do_rectify, @target.region.roi_box_pose.header.seq, @target.region.roi_box_pose.header.stamp.secs, @target.region.roi_box_pose.header.stamp.nsecs,) = @@struct_L6CL3.unpack(str[start..(end_point-1)])
      @target.region.cam_info.roi.do_rectify = bool(@target.region.cam_info.roi.do_rectify)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.region.roi_box_pose.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d10')
      (@target.region.roi_box_pose.pose.position.x, @target.region.roi_box_pose.pose.position.y, @target.region.roi_box_pose.pose.position.z, @target.region.roi_box_pose.pose.orientation.x, @target.region.roi_box_pose.pose.orientation.y, @target.region.roi_box_pose.pose.orientation.z, @target.region.roi_box_pose.pose.orientation.w, @target.region.roi_box_dims.x, @target.region.roi_box_dims.y, @target.region.roi_box_dims.z,) = @@struct_d10.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.collision_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @collision_object_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @collision_support_surface_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @grasps_to_evaluate = []
      length.times do
        val1 = Manipulation_msgs::Grasp.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v4298 = val1.pre_grasp_posture
        _v4299 = _v4298.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4299.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4300 = _v4299.stamp
        _x = _v4300
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4299.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4298.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v4298.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4298.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4298.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4298.effort = str[start..(end_point-1)].unpack(pattern)
        _v4301 = val1.grasp_posture
        _v4302 = _v4301.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4302.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4303 = _v4302.stamp
        _x = _v4303
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4302.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4301.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v4301.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4301.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4301.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4301.effort = str[start..(end_point-1)].unpack(pattern)
        _v4304 = val1.grasp_pose
        _v4305 = _v4304.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4305.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4306 = _v4305.stamp
        _x = _v4306
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4305.frame_id = str[start..(end_point-1)]
        _v4307 = _v4304.pose
        _v4308 = _v4307.position
        _x = _v4308
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v4309 = _v4307.orientation
        _x = _v4309
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.grasp_quality,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v4310 = val1.approach
        _v4311 = _v4310.direction
        _v4312 = _v4311.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4312.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4313 = _v4312.stamp
        _x = _v4313
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4312.frame_id = str[start..(end_point-1)]
        _v4314 = _v4311.vector
        _x = _v4314
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v4310
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        _v4315 = val1.retreat
        _v4316 = _v4315.direction
        _v4317 = _v4316.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4317.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4318 = _v4317.stamp
        _x = _v4318
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4317.frame_id = str[start..(end_point-1)]
        _v4319 = _v4316.vector
        _x = _v4319
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v4315
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.max_contact_force,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.allowed_touch_objects = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.allowed_touch_objects.push(val2)
        end
        @grasps_to_evaluate.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @movable_obstacles = []
      length.times do
        val1 = Manipulation_msgs::GraspableObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.reference_frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.potential_models = []
        length.times do
          val2 = Household_objects_database_msgs::DatabaseModelPose.new
          start = end_point
          end_point += ROS::Struct::calc_size('l')
          (val2.model_id,) = @@struct_l.unpack(str[start..(end_point-1)])
          _v4320 = val2.type
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v4320.key = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v4320.db = str[start..(end_point-1)]
          _v4321 = val2.pose
          _v4322 = _v4321.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v4322.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v4323 = _v4322.stamp
          _x = _v4323
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v4322.frame_id = str[start..(end_point-1)]
          _v4324 = _v4321.pose
          _v4325 = _v4324.position
          _x = _v4325
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v4326 = _v4324.orientation
          _x = _v4326
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += ROS::Struct::calc_size('f')
          (val2.confidence,) = @@struct_f.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.detector_name = str[start..(end_point-1)]
          val1.potential_models.push(val2)
        end
        _v4327 = val1.cluster
        _v4328 = _v4327.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4328.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4329 = _v4328.stamp
        _x = _v4329
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4328.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4327.points = []
        length.times do
          val3 = Geometry_msgs::Point32.new
          _x = val3
          start = end_point
          end_point += ROS::Struct::calc_size('f3')
          (_x.x, _x.y, _x.z,) = @@struct_f3.unpack(str[start..(end_point-1)])
          _v4327.points.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4327.channels = []
        length.times do
          val3 = Sensor_msgs::ChannelFloat32.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3.name = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "f#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.values = str[start..(end_point-1)].unpack(pattern)
          _v4327.channels.push(val3)
        end
        _v4330 = val1.region
        _v4331 = _v4330.cloud
        _v4332 = _v4331.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4332.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4333 = _v4332.stamp
        _x = _v4333
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4332.frame_id = str[start..(end_point-1)]
        _x = _v4331
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4331.fields = []
        length.times do
          val4 = Sensor_msgs::PointField.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val4.name = str[start..(end_point-1)]
          _x = val4
          start = end_point
          end_point += ROS::Struct::calc_size('LCL')
          (_x.offset, _x.datatype, _x.count,) = @@struct_LCL.unpack(str[start..(end_point-1)])
          _v4331.fields.push(val4)
        end
        _x = _v4331
        start = end_point
        end_point += ROS::Struct::calc_size('CL2')
        (_x.is_bigendian, _x.point_step, _x.row_step,) = @@struct_CL2.unpack(str[start..(end_point-1)])
        _v4331.is_bigendian = bool(_v4331.is_bigendian)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4331.data = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (_v4331.is_dense,) = @@struct_C.unpack(str[start..(end_point-1)])
        _v4331.is_dense = bool(_v4331.is_dense)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "l#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4330.mask = str[start..(end_point-1)].unpack(pattern)
        _v4334 = _v4330.image
        _v4335 = _v4334.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4335.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4336 = _v4335.stamp
        _x = _v4336
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4335.frame_id = str[start..(end_point-1)]
        _x = _v4334
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4334.encoding = str[start..(end_point-1)]
        _x = _v4334
        start = end_point
        end_point += ROS::Struct::calc_size('CL')
        (_x.is_bigendian, _x.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4334.data = str[start..(end_point-1)]
        _v4337 = _v4330.disparity_image
        _v4338 = _v4337.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4338.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4339 = _v4338.stamp
        _x = _v4339
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4338.frame_id = str[start..(end_point-1)]
        _x = _v4337
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4337.encoding = str[start..(end_point-1)]
        _x = _v4337
        start = end_point
        end_point += ROS::Struct::calc_size('CL')
        (_x.is_bigendian, _x.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4337.data = str[start..(end_point-1)]
        _v4340 = _v4330.cam_info
        _v4341 = _v4340.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4341.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4342 = _v4341.stamp
        _x = _v4342
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4341.frame_id = str[start..(end_point-1)]
        _x = _v4340
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4340.distortion_model = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4340.D = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += ROS::Struct::calc_size('d9')
        _v4340.K = @@struct_d9.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d9')
        _v4340.R = @@struct_d9.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d12')
        _v4340.P = @@struct_d12.unpack(str[start..(end_point-1)])
        _x = _v4340
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.binning_x, _x.binning_y,) = @@struct_L2.unpack(str[start..(end_point-1)])
        _v4343 = _v4340.roi
        _x = _v4343
        start = end_point
        end_point += ROS::Struct::calc_size('L4C')
        (_x.x_offset, _x.y_offset, _x.height, _x.width, _x.do_rectify,) = @@struct_L4C.unpack(str[start..(end_point-1)])
        _v4343.do_rectify = bool(_v4343.do_rectify)
        _v4344 = _v4330.roi_box_pose
        _v4345 = _v4344.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4345.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4346 = _v4345.stamp
        _x = _v4346
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4345.frame_id = str[start..(end_point-1)]
        _v4347 = _v4344.pose
        _v4348 = _v4347.position
        _x = _v4348
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v4349 = _v4347.orientation
        _x = _v4349
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        _v4350 = _v4330.roi_box_dims
        _x = _v4350
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.collision_name = str[start..(end_point-1)]
        @movable_obstacles.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
