# autogenerated by genrb from GraspPlanningResult.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Vector3Stamped"
require "manipulation_msgs/Grasp"
require "geometry_msgs/PoseStamped"
require "sensor_msgs/JointState"
require "manipulation_msgs/GripperTranslation"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "manipulation_msgs/GraspPlanningErrorCode"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "geometry_msgs/Pose"

module Manipulation_msgs

class GraspPlanningResult <::ROS::Message
  def self.md5sum
    "ff7a88c4aec40207164535a24dc9c440"
  end

  def self.type
    "manipulation_msgs/GraspPlanningResult"
  end

  def has_header?
    false
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# the list of planned grasps
Grasp[] grasps

# whether an error occurred
GraspPlanningErrorCode error_code


================================================================================
MSG: manipulation_msgs/Grasp
# A name for this grasp
string id

# The internal posture of the hand for the pre-grasp
# only positions are used
sensor_msgs/JointState pre_grasp_posture

# The internal posture of the hand for the grasp
# positions and efforts are used
sensor_msgs/JointState grasp_posture

# The position of the end-effector for the grasp 
geometry_msgs/PoseStamped grasp_pose

# The estimated probability of success for this grasp, or some other
# measure of how \"good\" it is.
float64 grasp_quality

# The approach motion
GripperTranslation approach

# The retreat motion
GripperTranslation retreat

# the maximum contact force to use while grasping (<=0 to disable)
float32 max_contact_force

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping
string[] allowed_touch_objects

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: manipulation_msgs/GripperTranslation
# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: manipulation_msgs/GraspPlanningErrorCode
# Error codes for grasp and place planning

# plan completed as expected
int32 SUCCESS = 0

# tf error encountered while transforming
int32 TF_ERROR = 1 

# some other error
int32 OTHER_ERROR = 2

# the actual value of this error code
int32 value
"
  end
  attr_accessor :grasps, :error_code

  @@struct_d = ::ROS::Struct.new("d")
  @@struct_f = ::ROS::Struct.new("f")
  @@struct_l = ::ROS::Struct.new("l")
  @@struct_f2 = ::ROS::Struct.new("f2")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['manipulation_msgs/Grasp[]','manipulation_msgs/GraspPlanningErrorCode']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [manipulation_msgs/Grasp[]] :grasps initialize value
  # @option args [manipulation_msgs/GraspPlanningErrorCode] :error_code initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:grasps]
      @grasps = args[:grasps]
    else
      @grasps = []
    end
    if args[:error_code]
      @error_code = args[:error_code]
    else
      @error_code = Manipulation_msgs::GraspPlanningErrorCode.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      length = @grasps.length
      buff.write(@@struct_L.pack(length))
      for val1 in @grasps
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4351 = val1.pre_grasp_posture
        _v4352 = _v4351.header
        buff.write(@@struct_L.pack(_v4352.seq))
        _v4353 = _v4352.stamp
        _x = _v4353
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4352.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4351.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4351.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v4351.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4351.position.pack(pattern))
        length = _v4351.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4351.velocity.pack(pattern))
        length = _v4351.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4351.effort.pack(pattern))
        _v4354 = val1.grasp_posture
        _v4355 = _v4354.header
        buff.write(@@struct_L.pack(_v4355.seq))
        _v4356 = _v4355.stamp
        _x = _v4356
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4355.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4354.name.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4354.name
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v4354.position.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4354.position.pack(pattern))
        length = _v4354.velocity.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4354.velocity.pack(pattern))
        length = _v4354.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*_v4354.effort.pack(pattern))
        _v4357 = val1.grasp_pose
        _v4358 = _v4357.header
        buff.write(@@struct_L.pack(_v4358.seq))
        _v4359 = _v4358.stamp
        _x = _v4359
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4358.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4360 = _v4357.pose
        _v4361 = _v4360.position
        _x = _v4361
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4362 = _v4360.orientation
        _x = _v4362
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_d.pack(val1.grasp_quality))
        _v4363 = val1.approach
        _v4364 = _v4363.direction
        _v4365 = _v4364.header
        buff.write(@@struct_L.pack(_v4365.seq))
        _v4366 = _v4365.stamp
        _x = _v4366
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4365.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4367 = _v4364.vector
        _x = _v4367
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v4363
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        _v4368 = val1.retreat
        _v4369 = _v4368.direction
        _v4370 = _v4369.header
        buff.write(@@struct_L.pack(_v4370.seq))
        _v4371 = _v4370.stamp
        _x = _v4371
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4370.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4372 = _v4369.vector
        _x = _v4372
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v4368
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        buff.write(@@struct_f.pack(val1.max_contact_force))
        length = val1.allowed_touch_objects.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.allowed_touch_objects
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
      end
      buff.write(@@struct_l.pack(@error_code.value))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @grasps == nil
        @grasps = Manipulation_msgs::Grasp[].new
      end
      if @error_code == nil
        @error_code = Manipulation_msgs::GraspPlanningErrorCode.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @grasps = []
      length.times do
        val1 = Manipulation_msgs::Grasp.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v4373 = val1.pre_grasp_posture
        _v4374 = _v4373.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4374.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4375 = _v4374.stamp
        _x = _v4375
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4374.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4373.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v4373.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4373.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4373.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4373.effort = str[start..(end_point-1)].unpack(pattern)
        _v4376 = val1.grasp_posture
        _v4377 = _v4376.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4377.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4378 = _v4377.stamp
        _x = _v4378
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4377.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4376.name = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v4376.name.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4376.position = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4376.velocity = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        _v4376.effort = str[start..(end_point-1)].unpack(pattern)
        _v4379 = val1.grasp_pose
        _v4380 = _v4379.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4380.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4381 = _v4380.stamp
        _x = _v4381
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4380.frame_id = str[start..(end_point-1)]
        _v4382 = _v4379.pose
        _v4383 = _v4382.position
        _x = _v4383
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v4384 = _v4382.orientation
        _x = _v4384
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.grasp_quality,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v4385 = val1.approach
        _v4386 = _v4385.direction
        _v4387 = _v4386.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4387.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4388 = _v4387.stamp
        _x = _v4388
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4387.frame_id = str[start..(end_point-1)]
        _v4389 = _v4386.vector
        _x = _v4389
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v4385
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        _v4390 = val1.retreat
        _v4391 = _v4390.direction
        _v4392 = _v4391.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4392.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4393 = _v4392.stamp
        _x = _v4393
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4392.frame_id = str[start..(end_point-1)]
        _v4394 = _v4391.vector
        _x = _v4394
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v4390
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.max_contact_force,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.allowed_touch_objects = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.allowed_touch_objects.push(val2)
        end
        @grasps.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('l')
      (@error_code.value,) = @@struct_l.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
