# autogenerated by genrb from PlaceLocation.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Vector3Stamped"
require "geometry_msgs/PoseStamped"
require "sensor_msgs/JointState"
require "manipulation_msgs/GripperTranslation"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "geometry_msgs/Pose"

module Manipulation_msgs

class PlaceLocation <::ROS::Message
  def self.md5sum
    "0139dab9852add0e64233c5fb3b8a25a"
  end

  def self.type
    "manipulation_msgs/PlaceLocation"
  end

  def has_header?
    false
  end

  def message_definition
    "# A name for this grasp
string id

# The internal posture of the hand for the grasp
# positions and efforts are used
sensor_msgs/JointState post_place_posture

# The position of the end-effector for the grasp relative to a reference frame 
# (that is always specified elsewhere, not in this message)
geometry_msgs/PoseStamped place_pose

# The approach motion
GripperTranslation approach

# The retreat motion
GripperTranslation retreat

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping
string[] allowed_touch_objects

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: manipulation_msgs/GripperTranslation
# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :id, :post_place_posture, :place_pose, :approach, :retreat, :allowed_touch_objects

  @@struct_d3f2 = ::ROS::Struct.new("d3f2")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d7L3 = ::ROS::Struct.new("d7L3")
  @@struct_d3f2L3 = ::ROS::Struct.new("d3f2L3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','sensor_msgs/JointState','geometry_msgs/PoseStamped','manipulation_msgs/GripperTranslation','manipulation_msgs/GripperTranslation','string[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :id initialize value
  # @option args [sensor_msgs/JointState] :post_place_posture initialize value
  # @option args [geometry_msgs/PoseStamped] :place_pose initialize value
  # @option args [manipulation_msgs/GripperTranslation] :approach initialize value
  # @option args [manipulation_msgs/GripperTranslation] :retreat initialize value
  # @option args [string[]] :allowed_touch_objects initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:id]
      @id = args[:id]
    else
      @id = ''
    end
    if args[:post_place_posture]
      @post_place_posture = args[:post_place_posture]
    else
      @post_place_posture = Sensor_msgs::JointState.new
    end
    if args[:place_pose]
      @place_pose = args[:place_pose]
    else
      @place_pose = Geometry_msgs::PoseStamped.new
    end
    if args[:approach]
      @approach = args[:approach]
    else
      @approach = Manipulation_msgs::GripperTranslation.new
    end
    if args[:retreat]
      @retreat = args[:retreat]
    else
      @retreat = Manipulation_msgs::GripperTranslation.new
    end
    if args[:allowed_touch_objects]
      @allowed_touch_objects = args[:allowed_touch_objects]
    else
      @allowed_touch_objects = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@post_place_posture.header.seq, @post_place_posture.header.stamp.secs, @post_place_posture.header.stamp.nsecs))
      _x = @post_place_posture.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @post_place_posture.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @post_place_posture.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @post_place_posture.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@post_place_posture.position.pack(pattern))
      length = @post_place_posture.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@post_place_posture.velocity.pack(pattern))
      length = @post_place_posture.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@post_place_posture.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@place_pose.header.seq, @place_pose.header.stamp.secs, @place_pose.header.stamp.nsecs))
      _x = @place_pose.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7L3.pack(@place_pose.pose.position.x, @place_pose.pose.position.y, @place_pose.pose.position.z, @place_pose.pose.orientation.x, @place_pose.pose.orientation.y, @place_pose.pose.orientation.z, @place_pose.pose.orientation.w, @approach.direction.header.seq, @approach.direction.header.stamp.secs, @approach.direction.header.stamp.nsecs))
      _x = @approach.direction.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3f2L3.pack(@approach.direction.vector.x, @approach.direction.vector.y, @approach.direction.vector.z, @approach.desired_distance, @approach.min_distance, @retreat.direction.header.seq, @retreat.direction.header.stamp.secs, @retreat.direction.header.stamp.nsecs))
      _x = @retreat.direction.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3f2.pack(@retreat.direction.vector.x, @retreat.direction.vector.y, @retreat.direction.vector.z, @retreat.desired_distance, @retreat.min_distance))
      length = @allowed_touch_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @allowed_touch_objects
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @post_place_posture == nil
        @post_place_posture = Sensor_msgs::JointState.new
      end
      if @place_pose == nil
        @place_pose = Geometry_msgs::PoseStamped.new
      end
      if @approach == nil
        @approach = Manipulation_msgs::GripperTranslation.new
      end
      if @retreat == nil
        @retreat = Manipulation_msgs::GripperTranslation.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@post_place_posture.header.seq, @post_place_posture.header.stamp.secs, @post_place_posture.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @post_place_posture.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @post_place_posture.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @post_place_posture.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @post_place_posture.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @post_place_posture.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @post_place_posture.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@place_pose.header.seq, @place_pose.header.stamp.secs, @place_pose.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @place_pose.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7L3')
      (@place_pose.pose.position.x, @place_pose.pose.position.y, @place_pose.pose.position.z, @place_pose.pose.orientation.x, @place_pose.pose.orientation.y, @place_pose.pose.orientation.z, @place_pose.pose.orientation.w, @approach.direction.header.seq, @approach.direction.header.stamp.secs, @approach.direction.header.stamp.nsecs,) = @@struct_d7L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @approach.direction.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3f2L3')
      (@approach.direction.vector.x, @approach.direction.vector.y, @approach.direction.vector.z, @approach.desired_distance, @approach.min_distance, @retreat.direction.header.seq, @retreat.direction.header.stamp.secs, @retreat.direction.header.stamp.nsecs,) = @@struct_d3f2L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @retreat.direction.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3f2')
      (@retreat.direction.vector.x, @retreat.direction.vector.y, @retreat.direction.vector.z, @retreat.desired_distance, @retreat.min_distance,) = @@struct_d3f2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @allowed_touch_objects = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @allowed_touch_objects.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
