# autogenerated by genrb from ProjectedMap.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "nav_msgs/MapMetaData"
require "geometry_msgs/Quaternion"
require "nav_msgs/OccupancyGrid"
require "geometry_msgs/Pose"

module Map_msgs

class ProjectedMap <::ROS::Message
  def self.md5sum
    "7bbe8f96e45089681dc1ea7d023cbfca"
  end

  def self.type
    "map_msgs/ProjectedMap"
  end

  def has_header?
    false
  end

  def message_definition
    "nav_msgs/OccupancyGrid map
float64 min_z
float64 max_z
================================================================================
MSG: nav_msgs/OccupancyGrid
# This represents a 2-D grid map, in which each cell represents the probability of
# occupancy.

Header header 

#MetaData for the map
MapMetaData info

# The map data, in row-major order, starting with (0,0).  Occupancy
# probabilities are in the range [0,100].  Unknown is -1.
int8[] data

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: nav_msgs/MapMetaData
# This hold basic information about the characterists of the OccupancyGrid

# The time at which the map was loaded
time map_load_time
# The map resolution [m/cell]
float32 resolution
# Map width [cells]
uint32 width
# Map height [cells]
uint32 height
# The origin of the map [m, m, rad].  This is the real-world pose of the
# cell (0,0) in the map.
geometry_msgs/Pose origin
================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :map, :min_z, :max_z

  @@struct_d2 = ::ROS::Struct.new("d2")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_L2fL2d7 = ::ROS::Struct.new("L2fL2d7")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['nav_msgs/OccupancyGrid','float64','float64']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [nav_msgs/OccupancyGrid] :map initialize value
  # @option args [float64] :min_z initialize value
  # @option args [float64] :max_z initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:map]
      @map = args[:map]
    else
      @map = Nav_msgs::OccupancyGrid.new
    end
    if args[:min_z]
      @min_z = args[:min_z]
    else
      @min_z = 0.0
    end
    if args[:max_z]
      @max_z = args[:max_z]
    else
      @max_z = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@map.header.seq, @map.header.stamp.secs, @map.header.stamp.nsecs))
      _x = @map.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2fL2d7.pack(@map.info.map_load_time.secs, @map.info.map_load_time.nsecs, @map.info.resolution, @map.info.width, @map.info.height, @map.info.origin.position.x, @map.info.origin.position.y, @map.info.origin.position.z, @map.info.origin.orientation.x, @map.info.origin.orientation.y, @map.info.origin.orientation.z, @map.info.origin.orientation.w))
      length = @map.data.length
      buff.write(@@struct_L.pack(length))
      pattern = "c#{length}"
      buff.write(*@map.data.pack(pattern))
      buff.write(@@struct_d2.pack(@min_z, @max_z))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @map == nil
        @map = Nav_msgs::OccupancyGrid.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@map.header.seq, @map.header.stamp.secs, @map.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @map.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2fL2d7')
      (@map.info.map_load_time.secs, @map.info.map_load_time.nsecs, @map.info.resolution, @map.info.width, @map.info.height, @map.info.origin.position.x, @map.info.origin.position.y, @map.info.origin.position.z, @map.info.origin.orientation.x, @map.info.origin.orientation.y, @map.info.origin.orientation.z, @map.info.origin.orientation.w,) = @@struct_L2fL2d7.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "c#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @map.data = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('d2')
      (@min_z, @max_z,) = @@struct_d2.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
