# autogenerated by genrb from MoveBaseGoal.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Point"
require "geometry_msgs/Pose"
require "geometry_msgs/PoseStamped"

module Move_base_msgs

class MoveBaseGoal <::ROS::Message
  def self.md5sum
    "257d089627d7eb7136c24d3593d05a16"
  end

  def self.type
    "move_base_msgs/MoveBaseGoal"
  end

  def has_header?
    false
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
geometry_msgs/PoseStamped target_pose

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :target_pose

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d7 = ::ROS::Struct.new("d7")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['geometry_msgs/PoseStamped']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [geometry_msgs/PoseStamped] :target_pose initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:target_pose]
      @target_pose = args[:target_pose]
    else
      @target_pose = Geometry_msgs::PoseStamped.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@target_pose.header.seq, @target_pose.header.stamp.secs, @target_pose.header.stamp.nsecs))
      _x = @target_pose.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7.pack(@target_pose.pose.position.x, @target_pose.pose.position.y, @target_pose.pose.position.z, @target_pose.pose.orientation.x, @target_pose.pose.orientation.y, @target_pose.pose.orientation.z, @target_pose.pose.orientation.w))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @target_pose == nil
        @target_pose = Geometry_msgs::PoseStamped.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@target_pose.header.seq, @target_pose.header.stamp.secs, @target_pose.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target_pose.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7')
      (@target_pose.pose.position.x, @target_pose.pose.position.y, @target_pose.pose.position.z, @target_pose.pose.orientation.x, @target_pose.pose.orientation.y, @target_pose.pose.orientation.z, @target_pose.pose.orientation.w,) = @@struct_d7.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
