# autogenerated by genrb from AllowedCollisionMatrix.msg. Do not edit.
require 'ros/message'

require "moveit_msgs/AllowedCollisionEntry"

module Moveit_msgs

class AllowedCollisionMatrix <::ROS::Message
  def self.md5sum
    "aedce13587eef0d79165a075659c1879"
  end

  def self.type
    "moveit_msgs/AllowedCollisionMatrix"
  end

  def has_header?
    false
  end

  def message_definition
    "# The list of entry names in the matrix
string[] entry_names

# The individual entries in the allowed collision matrix
# square, symmetric, with same order as entry_names
AllowedCollisionEntry[] entry_values

# In addition to the collision matrix itself, we also have 
# the default entry value for each entry name.

# If the allowed collision flag is queried for a pair of names (n1, n2)
# that is not found in the collision matrix itself, the value of
# the collision flag is considered to be that of the entry (n1 or n2)
# specified in the list below. If both n1 and n2 are found in the list 
# of defaults, the result is computed with an AND operation

string[] default_entry_names
bool[] default_entry_values

================================================================================
MSG: moveit_msgs/AllowedCollisionEntry
# whether or not collision checking is enabled
bool[] enabled

"
  end
  attr_accessor :entry_names, :entry_values, :default_entry_names, :default_entry_values


  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string[]','moveit_msgs/AllowedCollisionEntry[]','string[]','bool[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string[]] :entry_names initialize value
  # @option args [moveit_msgs/AllowedCollisionEntry[]] :entry_values initialize value
  # @option args [string[]] :default_entry_names initialize value
  # @option args [bool[]] :default_entry_values initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:entry_names]
      @entry_names = args[:entry_names]
    else
      @entry_names = []
    end
    if args[:entry_values]
      @entry_values = args[:entry_values]
    else
      @entry_values = []
    end
    if args[:default_entry_names]
      @default_entry_names = args[:default_entry_names]
    else
      @default_entry_names = []
    end
    if args[:default_entry_values]
      @default_entry_values = args[:default_entry_values]
    else
      @default_entry_values = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      length = @entry_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @entry_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @entry_values.length
      buff.write(@@struct_L.pack(length))
      for val1 in @entry_values
        length = val1.enabled.length
        buff.write(@@struct_L.pack(length))
        pattern = "C#{length}"
        buff.write(*val1.enabled.pack(pattern))
      end
      length = @default_entry_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @default_entry_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @default_entry_values.length
      buff.write(@@struct_L.pack(length))
      pattern = "C#{length}"
      buff.write(*@default_entry_values.pack(pattern))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @entry_values == nil
        @entry_values = Moveit_msgs::AllowedCollisionEntry[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @entry_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @entry_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @entry_values = []
      length.times do
        val1 = Moveit_msgs::AllowedCollisionEntry.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "C#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.enabled = str[start..(end_point-1)].unpack(pattern)
        val1.enabled = map(bool, val1.enabled)
        @entry_values.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @default_entry_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @default_entry_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "C#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @default_entry_values = str[start..(end_point-1)].unpack(pattern)
      @default_entry_values = map(bool, @default_entry_values)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
