# autogenerated by genrb from BoundingVolume.msg. Do not edit.
require 'ros/message'

require "shape_msgs/MeshTriangle"
require "shape_msgs/SolidPrimitive"
require "geometry_msgs/Point"
require "shape_msgs/Mesh"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Pose"

module Moveit_msgs

class BoundingVolume <::ROS::Message
  def self.md5sum
    "22db94010f39e9198032cb4a1aeda26e"
  end

  def self.type
    "moveit_msgs/BoundingVolume"
  end

  def has_header?
    false
  end

  def message_definition
    "# Define a volume in 3D

# A set of solid geometric primitives that make up the volume to define (as a union)
shape_msgs/SolidPrimitive[] primitives

# The poses at which the primitives are located
geometry_msgs/Pose[] primitive_poses

# In addition to primitives, meshes can be specified to add to the bounding volume (again, as union)
shape_msgs/Mesh[] meshes

# The poses at which the meshes are located
geometry_msgs/Pose[] mesh_poses

================================================================================
MSG: shape_msgs/SolidPrimitive
# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

"
  end
  attr_accessor :primitives, :primitive_poses, :meshes, :mesh_poses

  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['shape_msgs/SolidPrimitive[]','geometry_msgs/Pose[]','shape_msgs/Mesh[]','geometry_msgs/Pose[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [shape_msgs/SolidPrimitive[]] :primitives initialize value
  # @option args [geometry_msgs/Pose[]] :primitive_poses initialize value
  # @option args [shape_msgs/Mesh[]] :meshes initialize value
  # @option args [geometry_msgs/Pose[]] :mesh_poses initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:primitives]
      @primitives = args[:primitives]
    else
      @primitives = []
    end
    if args[:primitive_poses]
      @primitive_poses = args[:primitive_poses]
    else
      @primitive_poses = []
    end
    if args[:meshes]
      @meshes = args[:meshes]
    else
      @meshes = []
    end
    if args[:mesh_poses]
      @mesh_poses = args[:mesh_poses]
    else
      @mesh_poses = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      length = @primitives.length
      buff.write(@@struct_L.pack(length))
      for val1 in @primitives
        buff.write(@@struct_C.pack(val1.type))
        length = val1.dimensions.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.dimensions.pack(pattern))
      end
      length = @primitive_poses.length
      buff.write(@@struct_L.pack(length))
      for val1 in @primitive_poses
        _v385 = val1.position
        _x = _v385
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v386 = val1.orientation
        _x = _v386
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @meshes.length
      buff.write(@@struct_L.pack(length))
      for val1 in @meshes
        length = val1.triangles.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.triangles
          buff.write(@@struct_L3.pack(*val2.vertex_indices))
        end
        length = val1.vertices.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.vertices
          _x = val2
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
      end
      length = @mesh_poses.length
      buff.write(@@struct_L.pack(length))
      for val1 in @mesh_poses
        _v387 = val1.position
        _x = _v387
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v388 = val1.orientation
        _x = _v388
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @primitives == nil
        @primitives = Shape_msgs::SolidPrimitive[].new
      end
      if @primitive_poses == nil
        @primitive_poses = Geometry_msgs::Pose[].new
      end
      if @meshes == nil
        @meshes = Shape_msgs::Mesh[].new
      end
      if @mesh_poses == nil
        @mesh_poses = Geometry_msgs::Pose[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @primitives = []
      length.times do
        val1 = Shape_msgs::SolidPrimitive.new
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (val1.type,) = @@struct_C.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.dimensions = str[start..(end_point-1)].unpack(pattern)
        @primitives.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @primitive_poses = []
      length.times do
        val1 = Geometry_msgs::Pose.new
        _v389 = val1.position
        _x = _v389
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v390 = val1.orientation
        _x = _v390
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @primitive_poses.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @meshes = []
      length.times do
        val1 = Shape_msgs::Mesh.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.triangles = []
        length.times do
          val2 = Shape_msgs::MeshTriangle.new
          start = end_point
          end_point += ROS::Struct::calc_size('L3')
          val2.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
          val1.triangles.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.vertices = []
        length.times do
          val2 = Geometry_msgs::Point.new
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.vertices.push(val2)
        end
        @meshes.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @mesh_poses = []
      length.times do
        val1 = Geometry_msgs::Pose.new
        _v391 = val1.position
        _x = _v391
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v392 = val1.orientation
        _x = _v392
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @mesh_poses.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
