# autogenerated by genrb from ContactInformation.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Point"
require "geometry_msgs/Vector3"

module Moveit_msgs

class ContactInformation <::ROS::Message
  def self.md5sum
    "116228ca08b0c286ec5ca32a50fdc17b"
  end

  def self.type
    "moveit_msgs/ContactInformation"
  end

  def has_header?
    true
  end

  def message_definition
    "# Standard ROS header contains information 
# about the frame in which this 
# contact is specified
Header header

# Position of the contact point
geometry_msgs/Point position

# Normal corresponding to the contact point
geometry_msgs/Vector3 normal 

# Depth of contact point
float64 depth

# Name of the first body that is in contact
# This could be a link or a namespace that represents a body
string contact_body_1
uint32 body_type_1

# Name of the second body that is in contact
# This could be a link or a namespace that represents a body
string contact_body_2
uint32 body_type_2

uint32 ROBOT_LINK=0
uint32 WORLD_OBJECT=1
uint32 ROBOT_ATTACHED=2

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  # Pseudo-constants
  ROBOT_LINK = 0
  WORLD_OBJECT = 1
  ROBOT_ATTACHED = 2

  attr_accessor :header, :position, :normal, :depth, :contact_body_1, :body_type_1, :contact_body_2, :body_type_2

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d7 = ::ROS::Struct.new("d7")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','geometry_msgs/Point','geometry_msgs/Vector3','float64','string','uint32','string','uint32']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [geometry_msgs/Point] :position initialize value
  # @option args [geometry_msgs/Vector3] :normal initialize value
  # @option args [float64] :depth initialize value
  # @option args [string] :contact_body_1 initialize value
  # @option args [uint32] :body_type_1 initialize value
  # @option args [string] :contact_body_2 initialize value
  # @option args [uint32] :body_type_2 initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:position]
      @position = args[:position]
    else
      @position = Geometry_msgs::Point.new
    end
    if args[:normal]
      @normal = args[:normal]
    else
      @normal = Geometry_msgs::Vector3.new
    end
    if args[:depth]
      @depth = args[:depth]
    else
      @depth = 0.0
    end
    if args[:contact_body_1]
      @contact_body_1 = args[:contact_body_1]
    else
      @contact_body_1 = ''
    end
    if args[:body_type_1]
      @body_type_1 = args[:body_type_1]
    else
      @body_type_1 = 0
    end
    if args[:contact_body_2]
      @contact_body_2 = args[:contact_body_2]
    else
      @contact_body_2 = ''
    end
    if args[:body_type_2]
      @body_type_2 = args[:body_type_2]
    else
      @body_type_2 = 0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7.pack(@position.x, @position.y, @position.z, @normal.x, @normal.y, @normal.z, @depth))
      _x = @contact_body_1
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L.pack(@body_type_1))
      _x = @contact_body_2
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L.pack(@body_type_2))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @position == nil
        @position = Geometry_msgs::Point.new
      end
      if @normal == nil
        @normal = Geometry_msgs::Vector3.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7')
      (@position.x, @position.y, @position.z, @normal.x, @normal.y, @normal.z, @depth,) = @@struct_d7.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @contact_body_1 = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L')
      (@body_type_1,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @contact_body_2 = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L')
      (@body_type_2,) = @@struct_L.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
