# autogenerated by genrb from DisplayRobotState.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Transform"
require "geometry_msgs/Point"
require "geometry_msgs/Twist"
require "shape_msgs/Mesh"
require "std_msgs/Header"
require "moveit_msgs/ObjectColor"
require "ros/duration"
require "shape_msgs/Plane"
require "sensor_msgs/MultiDOFJointState"
require "geometry_msgs/Pose"
require "shape_msgs/MeshTriangle"
require "shape_msgs/SolidPrimitive"
require "geometry_msgs/Wrench"
require "moveit_msgs/RobotState"
require "std_msgs/ColorRGBA"
require "trajectory_msgs/JointTrajectory"
require "sensor_msgs/JointState"
require "trajectory_msgs/JointTrajectoryPoint"
require "object_recognition_msgs/ObjectType"
require "moveit_msgs/AttachedCollisionObject"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "moveit_msgs/CollisionObject"

module Moveit_msgs

class DisplayRobotState <::ROS::Message
  def self.md5sum
    "6a3bab3a33a8c47aee24481a455a21aa"
  end

  def self.type
    "moveit_msgs/DisplayRobotState"
  end

  def has_header?
    false
  end

  def message_definition
    "# The robot state to display
RobotState state

# Optionally, various links can be highlighted
ObjectColor[] highlight_links

================================================================================
MSG: moveit_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state

# Joints that may have multiple DOF are specified here
sensor_msgs/MultiDOFJointState multi_dof_joint_state

# Attached collision objects (attached to some link on the robot)
AttachedCollisionObject[] attached_collision_objects

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
# This is mostly important for handling the attached bodies (whether or not to clear the attached bodies
# of a moveit::core::RobotState before updating it with this message)
bool is_diff

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/MultiDOFJointState
# Representation of state for joints with multiple degrees of freedom, 
# following the structure of JointState.
#
# It is assumed that a joint in a system corresponds to a transform that gets applied 
# along the kinematic chain. For example, a planar joint (as in URDF) is 3DOF (x, y, yaw)
# and those 3DOF can be expressed as a transformation matrix, and that transformation
# matrix can be converted back to (x, y, yaw)
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# wrench associated with them, you can leave the wrench array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

Header header

string[] joint_names
geometry_msgs/Transform[] transforms
geometry_msgs/Twist[] twist
geometry_msgs/Wrench[] wrench

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: moveit_msgs/AttachedCollisionObject
# The CollisionObject will be attached with a fixed joint to this link
string link_name

#This contains the actual shapes and poses for the CollisionObject
#to be attached to the link
#If action is remove and no object.id is set, all objects
#attached to the link indicated by link_name will be removed
CollisionObject object

# The set of links that the attached objects are allowed to touch
# by default - the link_name is already considered by default
string[] touch_links

# If certain links were placed in a particular posture for this object to remain attached 
# (e.g., an end effector closing around an object), the posture necessary for releasing
# the object is stored here
trajectory_msgs/JointTrajectory detach_posture

# The weight of the attached object, if known
float64 weight

================================================================================
MSG: moveit_msgs/CollisionObject
# a header, used for interpreting the poses
Header header

# the id of the object (name used in MoveIt)
string id

# The object type in a database of known objects
object_recognition_msgs/ObjectType type

# the the collision geometries associated with the object;
# their poses are with respect to the specified header

# solid geometric primitives
shape_msgs/SolidPrimitive[] primitives
geometry_msgs/Pose[] primitive_poses

# meshes
shape_msgs/Mesh[] meshes
geometry_msgs/Pose[] mesh_poses

# bounding planes (equation is specified, but the plane can be oriented using an additional pose)
shape_msgs/Plane[] planes
geometry_msgs/Pose[] plane_poses

# Adds the object to the planning scene. If the object previously existed, it is replaced.
byte ADD=0

# Removes the object from the environment entirely (everything that matches the specified id)
byte REMOVE=1

# Append to an object that already exists in the planning scene. If the does not exist, it is added.
byte APPEND=2

# If an object already exists in the scene, new poses can be sent (the geometry arrays must be left empty)
# if solely moving the object is desired
byte MOVE=3

# Operation to be performed
byte operation

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: shape_msgs/SolidPrimitive
# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: shape_msgs/Plane
# Representation of a plane, using the plane equation ax + by + cz + d = 0

# a := coef[0]
# b := coef[1]
# c := coef[2]
# d := coef[3]

float64[4] coef

================================================================================
MSG: trajectory_msgs/JointTrajectory
Header header
string[] joint_names
JointTrajectoryPoint[] points
================================================================================
MSG: trajectory_msgs/JointTrajectoryPoint
# Each trajectory point specifies either positions[, velocities[, accelerations]]
# or positions[, effort] for the trajectory to be executed.
# All specified values are in the same order as the joint names in JointTrajectory.msg

float64[] positions
float64[] velocities
float64[] accelerations
float64[] effort
duration time_from_start

================================================================================
MSG: moveit_msgs/ObjectColor
# The object id for which we specify color
string id

# The value of the color
std_msgs/ColorRGBA color

================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

"
  end
  attr_accessor :state, :highlight_links

  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_c = ::ROS::Struct.new("c")
  @@struct_f4 = ::ROS::Struct.new("f4")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['moveit_msgs/RobotState','moveit_msgs/ObjectColor[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [moveit_msgs/RobotState] :state initialize value
  # @option args [moveit_msgs/ObjectColor[]] :highlight_links initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:state]
      @state = args[:state]
    else
      @state = Moveit_msgs::RobotState.new
    end
    if args[:highlight_links]
      @highlight_links = args[:highlight_links]
    else
      @highlight_links = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@state.joint_state.header.seq, @state.joint_state.header.stamp.secs, @state.joint_state.header.stamp.nsecs))
      _x = @state.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @state.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @state.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @state.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@state.joint_state.position.pack(pattern))
      length = @state.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@state.joint_state.velocity.pack(pattern))
      length = @state.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@state.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@state.multi_dof_joint_state.header.seq, @state.multi_dof_joint_state.header.stamp.secs, @state.multi_dof_joint_state.header.stamp.nsecs))
      _x = @state.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @state.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @state.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @state.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @state.multi_dof_joint_state.transforms
        _v451 = val1.translation
        _x = _v451
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v452 = val1.rotation
        _x = _v452
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @state.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @state.multi_dof_joint_state.twist
        _v453 = val1.linear
        _x = _v453
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v454 = val1.angular
        _x = _v454
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @state.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @state.multi_dof_joint_state.wrench
        _v455 = val1.force
        _x = _v455
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v456 = val1.torque
        _x = _v456
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @state.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @state.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v457 = val1.object
        _v458 = _v457.header
        buff.write(@@struct_L.pack(_v458.seq))
        _v459 = _v458.stamp
        _x = _v459
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v458.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v457.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v460 = _v457.type
        _x = _v460.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v460.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v457.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v457.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v457.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v457.primitive_poses
          _v461 = val3.position
          _x = _v461
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v462 = val3.orientation
          _x = _v462
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v457.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v457.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v457.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v457.mesh_poses
          _v463 = val3.position
          _x = _v463
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v464 = val3.orientation
          _x = _v464
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v457.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v457.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v457.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v457.plane_poses
          _v465 = val3.position
          _x = _v465
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v466 = val3.orientation
          _x = _v466
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v457.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v467 = val1.detach_posture
        _v468 = _v467.header
        buff.write(@@struct_L.pack(_v468.seq))
        _v469 = _v468.stamp
        _x = _v469
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v468.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v467.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v467.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v467.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v467.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v470 = val3.time_from_start
          _x = _v470
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_C.pack(@state.is_diff))
      length = @highlight_links.length
      buff.write(@@struct_L.pack(length))
      for val1 in @highlight_links
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v471 = val1.color
        _x = _v471
        buff.write(@@struct_f4.pack(_x.r, _x.g, _x.b, _x.a))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @state == nil
        @state = Moveit_msgs::RobotState.new
      end
      if @highlight_links == nil
        @highlight_links = Moveit_msgs::ObjectColor[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@state.joint_state.header.seq, @state.joint_state.header.stamp.secs, @state.joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @state.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @state.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @state.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @state.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @state.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @state.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@state.multi_dof_joint_state.header.seq, @state.multi_dof_joint_state.header.stamp.secs, @state.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @state.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @state.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @state.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @state.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v472 = val1.translation
        _x = _v472
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v473 = val1.rotation
        _x = _v473
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @state.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @state.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v474 = val1.linear
        _x = _v474
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v475 = val1.angular
        _x = _v475
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @state.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @state.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v476 = val1.force
        _x = _v476
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v477 = val1.torque
        _x = _v477
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @state.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @state.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v478 = val1.object
        _v479 = _v478.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v479.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v480 = _v479.stamp
        _x = _v480
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v479.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v478.id = str[start..(end_point-1)]
        _v481 = _v478.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v481.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v481.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v478.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v478.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v478.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v482 = val3.position
          _x = _v482
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v483 = val3.orientation
          _x = _v483
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v478.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v478.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v478.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v478.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v484 = val3.position
          _x = _v484
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v485 = val3.orientation
          _x = _v485
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v478.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v478.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v478.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v478.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v486 = val3.position
          _x = _v486
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v487 = val3.orientation
          _x = _v487
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v478.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v478.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v488 = val1.detach_posture
        _v489 = _v488.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v489.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v490 = _v489.stamp
        _x = _v490
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v489.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v488.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v488.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v488.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v491 = val3.time_from_start
          _x = _v491
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v488.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @state.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@state.is_diff,) = @@struct_C.unpack(str[start..(end_point-1)])
      @state.is_diff = bool(@state.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @highlight_links = []
      length.times do
        val1 = Moveit_msgs::ObjectColor.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v492 = val1.color
        _x = _v492
        start = end_point
        end_point += ROS::Struct::calc_size('f4')
        (_x.r, _x.g, _x.b, _x.a,) = @@struct_f4.unpack(str[start..(end_point-1)])
        @highlight_links.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
