# autogenerated by genrb from GetMotionPlanRequest.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Transform"
require "moveit_msgs/VisibilityConstraint"
require "moveit_msgs/OrientationConstraint"
require "moveit_msgs/Constraints"
require "geometry_msgs/Point"
require "geometry_msgs/Twist"
require "shape_msgs/Mesh"
require "moveit_msgs/PositionConstraint"
require "shape_msgs/Plane"
require "geometry_msgs/PoseStamped"
require "ros/duration"
require "moveit_msgs/BoundingVolume"
require "moveit_msgs/JointConstraint"
require "std_msgs/Header"
require "sensor_msgs/MultiDOFJointState"
require "geometry_msgs/Pose"
require "shape_msgs/MeshTriangle"
require "moveit_msgs/TrajectoryConstraints"
require "shape_msgs/SolidPrimitive"
require "geometry_msgs/Wrench"
require "moveit_msgs/WorkspaceParameters"
require "moveit_msgs/RobotState"
require "trajectory_msgs/JointTrajectory"
require "sensor_msgs/JointState"
require "trajectory_msgs/JointTrajectoryPoint"
require "object_recognition_msgs/ObjectType"
require "moveit_msgs/MotionPlanRequest"
require "moveit_msgs/AttachedCollisionObject"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "moveit_msgs/CollisionObject"

module Moveit_msgs

class GetMotionPlanRequest <::ROS::Message
  def self.md5sum
    "fde307a5260284ee255be16f0cdf01d0"
  end

  def self.type
    "moveit_msgs/GetMotionPlanRequest"
  end

  def has_header?
    false
  end

  def message_definition
    "


MotionPlanRequest motion_plan_request


================================================================================
MSG: moveit_msgs/MotionPlanRequest
# This service contains the definition for a request to the motion
# planner and the output it provides

# Parameters for the workspace that the planner should work inside
WorkspaceParameters workspace_parameters

# Starting state updates. If certain joints should be considered
# at positions other than the current ones, these positions should
# be set here
RobotState start_state

# The possible goal states for the model to plan for. Each element of
# the array defines a goal region. The goal is achieved
# if the constraints for a particular region are satisfied
Constraints[] goal_constraints

# No state at any point along the path in the produced motion plan will violate these constraints (this applies to all points, not just waypoints)
Constraints path_constraints

# The constraints the resulting trajectory must satisfy
TrajectoryConstraints trajectory_constraints

# The name of the motion planner to use. If no name is specified,
# a default motion planner will be used
string planner_id

# The name of the group of joints on which this planner is operating
string group_name

# The number of times this plan is to be computed. Shortest solution
# will be reported.
int32 num_planning_attempts

# The maximum amount of time the motion planner is allowed to plan for (in seconds)
float64 allowed_planning_time

================================================================================
MSG: moveit_msgs/WorkspaceParameters
# This message contains a set of parameters useful in
# setting up the volume (a box) in which the robot is allowed to move.
# This is useful only when planning for mobile parts of 
# the robot as well.

# Define the frame of reference for the box corners
Header header

# The minumum corner of the box, with respect to the robot starting pose
geometry_msgs/Vector3 min_corner

# The maximum corner of the box, with respect to the robot starting pose
geometry_msgs/Vector3 max_corner

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: moveit_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state

# Joints that may have multiple DOF are specified here
sensor_msgs/MultiDOFJointState multi_dof_joint_state

# Attached collision objects (attached to some link on the robot)
AttachedCollisionObject[] attached_collision_objects

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
# This is mostly important for handling the attached bodies (whether or not to clear the attached bodies
# of a moveit::core::RobotState before updating it with this message)
bool is_diff

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: sensor_msgs/MultiDOFJointState
# Representation of state for joints with multiple degrees of freedom, 
# following the structure of JointState.
#
# It is assumed that a joint in a system corresponds to a transform that gets applied 
# along the kinematic chain. For example, a planar joint (as in URDF) is 3DOF (x, y, yaw)
# and those 3DOF can be expressed as a transformation matrix, and that transformation
# matrix can be converted back to (x, y, yaw)
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# wrench associated with them, you can leave the wrench array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

Header header

string[] joint_names
geometry_msgs/Transform[] transforms
geometry_msgs/Twist[] twist
geometry_msgs/Wrench[] wrench

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: moveit_msgs/AttachedCollisionObject
# The CollisionObject will be attached with a fixed joint to this link
string link_name

#This contains the actual shapes and poses for the CollisionObject
#to be attached to the link
#If action is remove and no object.id is set, all objects
#attached to the link indicated by link_name will be removed
CollisionObject object

# The set of links that the attached objects are allowed to touch
# by default - the link_name is already considered by default
string[] touch_links

# If certain links were placed in a particular posture for this object to remain attached 
# (e.g., an end effector closing around an object), the posture necessary for releasing
# the object is stored here
trajectory_msgs/JointTrajectory detach_posture

# The weight of the attached object, if known
float64 weight

================================================================================
MSG: moveit_msgs/CollisionObject
# a header, used for interpreting the poses
Header header

# the id of the object (name used in MoveIt)
string id

# The object type in a database of known objects
object_recognition_msgs/ObjectType type

# the the collision geometries associated with the object;
# their poses are with respect to the specified header

# solid geometric primitives
shape_msgs/SolidPrimitive[] primitives
geometry_msgs/Pose[] primitive_poses

# meshes
shape_msgs/Mesh[] meshes
geometry_msgs/Pose[] mesh_poses

# bounding planes (equation is specified, but the plane can be oriented using an additional pose)
shape_msgs/Plane[] planes
geometry_msgs/Pose[] plane_poses

# Adds the object to the planning scene. If the object previously existed, it is replaced.
byte ADD=0

# Removes the object from the environment entirely (everything that matches the specified id)
byte REMOVE=1

# Append to an object that already exists in the planning scene. If the does not exist, it is added.
byte APPEND=2

# If an object already exists in the scene, new poses can be sent (the geometry arrays must be left empty)
# if solely moving the object is desired
byte MOVE=3

# Operation to be performed
byte operation

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: shape_msgs/SolidPrimitive
# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: shape_msgs/Plane
# Representation of a plane, using the plane equation ax + by + cz + d = 0

# a := coef[0]
# b := coef[1]
# c := coef[2]
# d := coef[3]

float64[4] coef

================================================================================
MSG: trajectory_msgs/JointTrajectory
Header header
string[] joint_names
JointTrajectoryPoint[] points
================================================================================
MSG: trajectory_msgs/JointTrajectoryPoint
# Each trajectory point specifies either positions[, velocities[, accelerations]]
# or positions[, effort] for the trajectory to be executed.
# All specified values are in the same order as the joint names in JointTrajectory.msg

float64[] positions
float64[] velocities
float64[] accelerations
float64[] effort
duration time_from_start

================================================================================
MSG: moveit_msgs/Constraints
# This message contains a list of motion planning constraints.
# All constraints must be satisfied for a goal to be considered valid

string name

JointConstraint[] joint_constraints

PositionConstraint[] position_constraints

OrientationConstraint[] orientation_constraints

VisibilityConstraint[] visibility_constraints

================================================================================
MSG: moveit_msgs/JointConstraint
# Constrain the position of a joint to be within a certain bound
string joint_name

# the bound to be achieved is [position - tolerance_below, position + tolerance_above]
float64 position
float64 tolerance_above
float64 tolerance_below

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight
================================================================================
MSG: moveit_msgs/PositionConstraint
# This message contains the definition of a position constraint.

Header header

# The robot link this constraint refers to
string link_name

# The offset (in the link frame) for the target point on the link we are planning for
geometry_msgs/Vector3 target_point_offset

# The volume this constraint refers to 
BoundingVolume constraint_region

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: moveit_msgs/BoundingVolume
# Define a volume in 3D

# A set of solid geometric primitives that make up the volume to define (as a union)
shape_msgs/SolidPrimitive[] primitives

# The poses at which the primitives are located
geometry_msgs/Pose[] primitive_poses

# In addition to primitives, meshes can be specified to add to the bounding volume (again, as union)
shape_msgs/Mesh[] meshes

# The poses at which the meshes are located
geometry_msgs/Pose[] mesh_poses

================================================================================
MSG: moveit_msgs/OrientationConstraint
# This message contains the definition of an orientation constraint.

Header header

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# The robot link this constraint refers to
string link_name

# optional axis-angle error tolerances specified
float64 absolute_x_axis_tolerance
float64 absolute_y_axis_tolerance
float64 absolute_z_axis_tolerance

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: moveit_msgs/VisibilityConstraint
# The constraint is useful to maintain visibility to a disc (the target) in a particular frame.
# This disc forms the base of a visibiliy cone whose tip is at the origin of the sensor.
# Maintaining visibility is done by ensuring the robot does not obstruct the visibility cone.
# Note:
# This constraint does NOT enforce minimum or maximum distances between the sensor
# and the target, nor does it enforce the target to be in the field of view of
# the sensor. A PositionConstraint can (and probably should) be used for such purposes.

# The radius of the disc that should be maintained visible 
float64 target_radius

# The pose of the disc; as the robot moves, the pose of the disc may change as well
# This can be in the frame of a particular robot link, for example
geometry_msgs/PoseStamped target_pose

# From the sensor origin towards the target, the disc forms a visibility cone
# This cone is approximated using many sides. For example, when using 4 sides, 
# that in fact makes the visibility region be a pyramid.
# This value should always be 3 or more.
int32 cone_sides

# The pose in which visibility is to be maintained.
# The frame id should represent the robot link to which the sensor is attached.
# It is assumed the sensor can look directly at the target, in any direction.
# This assumption is usually not true, but additional PositionConstraints
# can resolve this issue.
geometry_msgs/PoseStamped sensor_pose

# Even though the disc is maintained visible, the visibility cone can be very small
# because of the orientation of the disc with respect to the sensor. It is possible
# for example to view the disk almost from a side, in which case the visibility cone 
# can end up having close to 0 volume. The view angle is defined to be the angle between
# the normal to the visibility disc and the direction vector from the sensor origin.
# The value below represents the minimum desired view angle. For a perfect view,
# this value will be 0 (the two vectors are exact opposites). For a completely obstructed view
# this value will be Pi/2 (the vectors are perpendicular). This value defined below 
# is the maximum view angle to be maintained. This should be a value in the open interval
# (0, Pi/2). If 0 is set, the view angle is NOT enforced.
float64 max_view_angle

# This angle is used similarly to max_view_angle but limits the maximum angle
# between the sensor origin direction vector and the axis that connects the
# sensor origin to the target frame origin. The value is again in the range (0, Pi/2)
# and is NOT enforced if set to 0.
float64 max_range_angle

# The axis that is assumed to indicate the direction of view for the sensor
# X = 2, Y = 1, Z = 0
uint8 SENSOR_Z=0
uint8 SENSOR_Y=1
uint8 SENSOR_X=2
uint8 sensor_view_direction

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: moveit_msgs/TrajectoryConstraints
# The array of constraints to consider along the trajectory
Constraints[] constraints

"
  end
  attr_accessor :motion_plan_request

  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_d6L3 = ::ROS::Struct.new("d6L3")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_l = ::ROS::Struct.new("l")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_c = ::ROS::Struct.new("c")
  @@struct_ld = ::ROS::Struct.new("ld")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_d2Cd = ::ROS::Struct.new("d2Cd")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['moveit_msgs/MotionPlanRequest']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [moveit_msgs/MotionPlanRequest] :motion_plan_request initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:motion_plan_request]
      @motion_plan_request = args[:motion_plan_request]
    else
      @motion_plan_request = Moveit_msgs::MotionPlanRequest.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@motion_plan_request.workspace_parameters.header.seq, @motion_plan_request.workspace_parameters.header.stamp.secs, @motion_plan_request.workspace_parameters.header.stamp.nsecs))
      _x = @motion_plan_request.workspace_parameters.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d6L3.pack(@motion_plan_request.workspace_parameters.min_corner.x, @motion_plan_request.workspace_parameters.min_corner.y, @motion_plan_request.workspace_parameters.min_corner.z, @motion_plan_request.workspace_parameters.max_corner.x, @motion_plan_request.workspace_parameters.max_corner.y, @motion_plan_request.workspace_parameters.max_corner.z, @motion_plan_request.start_state.joint_state.header.seq, @motion_plan_request.start_state.joint_state.header.stamp.secs, @motion_plan_request.start_state.joint_state.header.stamp.nsecs))
      _x = @motion_plan_request.start_state.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @motion_plan_request.start_state.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_request.start_state.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @motion_plan_request.start_state.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@motion_plan_request.start_state.joint_state.position.pack(pattern))
      length = @motion_plan_request.start_state.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@motion_plan_request.start_state.joint_state.velocity.pack(pattern))
      length = @motion_plan_request.start_state.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@motion_plan_request.start_state.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@motion_plan_request.start_state.multi_dof_joint_state.header.seq, @motion_plan_request.start_state.multi_dof_joint_state.header.stamp.secs, @motion_plan_request.start_state.multi_dof_joint_state.header.stamp.nsecs))
      _x = @motion_plan_request.start_state.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @motion_plan_request.start_state.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_request.start_state.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @motion_plan_request.start_state.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_request.start_state.multi_dof_joint_state.transforms
        _v4899 = val1.translation
        _x = _v4899
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4900 = val1.rotation
        _x = _v4900
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @motion_plan_request.start_state.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_request.start_state.multi_dof_joint_state.twist
        _v4901 = val1.linear
        _x = _v4901
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4902 = val1.angular
        _x = _v4902
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @motion_plan_request.start_state.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_request.start_state.multi_dof_joint_state.wrench
        _v4903 = val1.force
        _x = _v4903
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4904 = val1.torque
        _x = _v4904
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @motion_plan_request.start_state.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_request.start_state.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4905 = val1.object
        _v4906 = _v4905.header
        buff.write(@@struct_L.pack(_v4906.seq))
        _v4907 = _v4906.stamp
        _x = _v4907
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4906.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4905.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4908 = _v4905.type
        _x = _v4908.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v4908.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4905.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4905.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v4905.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4905.primitive_poses
          _v4909 = val3.position
          _x = _v4909
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v4910 = val3.orientation
          _x = _v4910
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v4905.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4905.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v4905.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4905.mesh_poses
          _v4911 = val3.position
          _x = _v4911
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v4912 = val3.orientation
          _x = _v4912
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v4905.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4905.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v4905.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4905.plane_poses
          _v4913 = val3.position
          _x = _v4913
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v4914 = val3.orientation
          _x = _v4914
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v4905.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v4915 = val1.detach_posture
        _v4916 = _v4915.header
        buff.write(@@struct_L.pack(_v4916.seq))
        _v4917 = _v4916.stamp
        _x = _v4917
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4916.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v4915.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4915.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v4915.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4915.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v4918 = val3.time_from_start
          _x = _v4918
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_C.pack(@motion_plan_request.start_state.is_diff))
      length = @motion_plan_request.goal_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_request.goal_constraints
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.joint_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.joint_constraints
          _x = val2.joint_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
        end
        length = val1.position_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.position_constraints
          _v4919 = val2.header
          buff.write(@@struct_L.pack(_v4919.seq))
          _v4920 = _v4919.stamp
          _x = _v4920
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v4919.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v4921 = val2.target_point_offset
          _x = _v4921
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v4922 = val2.constraint_region
          length = _v4922.primitives.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v4922.primitives
            buff.write(@@struct_C.pack(val4.type))
            length = val4.dimensions.length
            buff.write(@@struct_L.pack(length))
            pattern = "d#{length}"
            buff.write(*val4.dimensions.pack(pattern))
          end
          length = _v4922.primitive_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v4922.primitive_poses
            _v4923 = val4.position
            _x = _v4923
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v4924 = val4.orientation
            _x = _v4924
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          length = _v4922.meshes.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v4922.meshes
            length = val4.triangles.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.triangles
              buff.write(@@struct_L3.pack(*val5.vertex_indices))
            end
            length = val4.vertices.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.vertices
              _x = val5
              buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            end
          end
          length = _v4922.mesh_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v4922.mesh_poses
            _v4925 = val4.position
            _x = _v4925
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v4926 = val4.orientation
            _x = _v4926
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          buff.write(@@struct_d.pack(val2.weight))
        end
        length = val1.orientation_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.orientation_constraints
          _v4927 = val2.header
          buff.write(@@struct_L.pack(_v4927.seq))
          _v4928 = _v4927.stamp
          _x = _v4928
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v4927.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v4929 = val2.orientation
          _x = _v4929
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
        end
        length = val1.visibility_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.visibility_constraints
          buff.write(@@struct_d.pack(val2.target_radius))
          _v4930 = val2.target_pose
          _v4931 = _v4930.header
          buff.write(@@struct_L.pack(_v4931.seq))
          _v4932 = _v4931.stamp
          _x = _v4932
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v4931.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v4933 = _v4930.pose
          _v4934 = _v4933.position
          _x = _v4934
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v4935 = _v4933.orientation
          _x = _v4935
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(@@struct_l.pack(val2.cone_sides))
          _v4936 = val2.sensor_pose
          _v4937 = _v4936.header
          buff.write(@@struct_L.pack(_v4937.seq))
          _v4938 = _v4937.stamp
          _x = _v4938
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v4937.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v4939 = _v4936.pose
          _v4940 = _v4939.position
          _x = _v4940
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v4941 = _v4939.orientation
          _x = _v4941
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2
          buff.write(@@struct_d2Cd.pack(_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight))
        end
      end
      _x = @motion_plan_request.path_constraints.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @motion_plan_request.path_constraints.joint_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_request.path_constraints.joint_constraints
        _x = val1.joint_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_d4.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
      end
      length = @motion_plan_request.path_constraints.position_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_request.path_constraints.position_constraints
        _v4942 = val1.header
        buff.write(@@struct_L.pack(_v4942.seq))
        _v4943 = _v4942.stamp
        _x = _v4943
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4942.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4944 = val1.target_point_offset
        _x = _v4944
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4945 = val1.constraint_region
        length = _v4945.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4945.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v4945.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4945.primitive_poses
          _v4946 = val3.position
          _x = _v4946
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v4947 = val3.orientation
          _x = _v4947
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v4945.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4945.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v4945.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v4945.mesh_poses
          _v4948 = val3.position
          _x = _v4948
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v4949 = val3.orientation
          _x = _v4949
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      length = @motion_plan_request.path_constraints.orientation_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_request.path_constraints.orientation_constraints
        _v4950 = val1.header
        buff.write(@@struct_L.pack(_v4950.seq))
        _v4951 = _v4950.stamp
        _x = _v4951
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4950.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4952 = val1.orientation
        _x = _v4952
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_d4.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
      end
      length = @motion_plan_request.path_constraints.visibility_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_request.path_constraints.visibility_constraints
        buff.write(@@struct_d.pack(val1.target_radius))
        _v4953 = val1.target_pose
        _v4954 = _v4953.header
        buff.write(@@struct_L.pack(_v4954.seq))
        _v4955 = _v4954.stamp
        _x = _v4955
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4954.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4956 = _v4953.pose
        _v4957 = _v4956.position
        _x = _v4957
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4958 = _v4956.orientation
        _x = _v4958
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_l.pack(val1.cone_sides))
        _v4959 = val1.sensor_pose
        _v4960 = _v4959.header
        buff.write(@@struct_L.pack(_v4960.seq))
        _v4961 = _v4960.stamp
        _x = _v4961
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4960.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4962 = _v4959.pose
        _v4963 = _v4962.position
        _x = _v4963
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4964 = _v4962.orientation
        _x = _v4964
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(@@struct_d2Cd.pack(_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight))
      end
      length = @motion_plan_request.trajectory_constraints.constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_request.trajectory_constraints.constraints
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.joint_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.joint_constraints
          _x = val2.joint_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
        end
        length = val1.position_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.position_constraints
          _v4965 = val2.header
          buff.write(@@struct_L.pack(_v4965.seq))
          _v4966 = _v4965.stamp
          _x = _v4966
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v4965.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v4967 = val2.target_point_offset
          _x = _v4967
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v4968 = val2.constraint_region
          length = _v4968.primitives.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v4968.primitives
            buff.write(@@struct_C.pack(val4.type))
            length = val4.dimensions.length
            buff.write(@@struct_L.pack(length))
            pattern = "d#{length}"
            buff.write(*val4.dimensions.pack(pattern))
          end
          length = _v4968.primitive_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v4968.primitive_poses
            _v4969 = val4.position
            _x = _v4969
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v4970 = val4.orientation
            _x = _v4970
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          length = _v4968.meshes.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v4968.meshes
            length = val4.triangles.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.triangles
              buff.write(@@struct_L3.pack(*val5.vertex_indices))
            end
            length = val4.vertices.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.vertices
              _x = val5
              buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            end
          end
          length = _v4968.mesh_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v4968.mesh_poses
            _v4971 = val4.position
            _x = _v4971
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v4972 = val4.orientation
            _x = _v4972
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          buff.write(@@struct_d.pack(val2.weight))
        end
        length = val1.orientation_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.orientation_constraints
          _v4973 = val2.header
          buff.write(@@struct_L.pack(_v4973.seq))
          _v4974 = _v4973.stamp
          _x = _v4974
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v4973.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v4975 = val2.orientation
          _x = _v4975
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
        end
        length = val1.visibility_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.visibility_constraints
          buff.write(@@struct_d.pack(val2.target_radius))
          _v4976 = val2.target_pose
          _v4977 = _v4976.header
          buff.write(@@struct_L.pack(_v4977.seq))
          _v4978 = _v4977.stamp
          _x = _v4978
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v4977.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v4979 = _v4976.pose
          _v4980 = _v4979.position
          _x = _v4980
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v4981 = _v4979.orientation
          _x = _v4981
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(@@struct_l.pack(val2.cone_sides))
          _v4982 = val2.sensor_pose
          _v4983 = _v4982.header
          buff.write(@@struct_L.pack(_v4983.seq))
          _v4984 = _v4983.stamp
          _x = _v4984
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v4983.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v4985 = _v4982.pose
          _v4986 = _v4985.position
          _x = _v4986
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v4987 = _v4985.orientation
          _x = _v4987
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2
          buff.write(@@struct_d2Cd.pack(_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight))
        end
      end
      _x = @motion_plan_request.planner_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @motion_plan_request.group_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_ld.pack(@motion_plan_request.num_planning_attempts, @motion_plan_request.allowed_planning_time))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @motion_plan_request == nil
        @motion_plan_request = Moveit_msgs::MotionPlanRequest.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@motion_plan_request.workspace_parameters.header.seq, @motion_plan_request.workspace_parameters.header.stamp.secs, @motion_plan_request.workspace_parameters.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @motion_plan_request.workspace_parameters.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d6L3')
      (@motion_plan_request.workspace_parameters.min_corner.x, @motion_plan_request.workspace_parameters.min_corner.y, @motion_plan_request.workspace_parameters.min_corner.z, @motion_plan_request.workspace_parameters.max_corner.x, @motion_plan_request.workspace_parameters.max_corner.y, @motion_plan_request.workspace_parameters.max_corner.z, @motion_plan_request.start_state.joint_state.header.seq, @motion_plan_request.start_state.joint_state.header.stamp.secs, @motion_plan_request.start_state.joint_state.header.stamp.nsecs,) = @@struct_d6L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @motion_plan_request.start_state.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_request.start_state.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @motion_plan_request.start_state.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @motion_plan_request.start_state.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @motion_plan_request.start_state.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @motion_plan_request.start_state.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@motion_plan_request.start_state.multi_dof_joint_state.header.seq, @motion_plan_request.start_state.multi_dof_joint_state.header.stamp.secs, @motion_plan_request.start_state.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @motion_plan_request.start_state.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_request.start_state.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @motion_plan_request.start_state.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_request.start_state.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v4988 = val1.translation
        _x = _v4988
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v4989 = val1.rotation
        _x = _v4989
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @motion_plan_request.start_state.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_request.start_state.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v4990 = val1.linear
        _x = _v4990
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v4991 = val1.angular
        _x = _v4991
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @motion_plan_request.start_state.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_request.start_state.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v4992 = val1.force
        _x = _v4992
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v4993 = val1.torque
        _x = _v4993
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @motion_plan_request.start_state.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_request.start_state.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v4994 = val1.object
        _v4995 = _v4994.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4995.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4996 = _v4995.stamp
        _x = _v4996
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4995.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4994.id = str[start..(end_point-1)]
        _v4997 = _v4994.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4997.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4997.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4994.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v4994.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4994.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v4998 = val3.position
          _x = _v4998
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v4999 = val3.orientation
          _x = _v4999
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v4994.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4994.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v4994.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4994.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v5000 = val3.position
          _x = _v5000
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5001 = val3.orientation
          _x = _v5001
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v4994.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4994.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v4994.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4994.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v5002 = val3.position
          _x = _v5002
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5003 = val3.orientation
          _x = _v5003
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v4994.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v4994.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v5004 = val1.detach_posture
        _v5005 = _v5004.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v5005.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5006 = _v5005.stamp
        _x = _v5006
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v5005.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5004.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v5004.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5004.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v5007 = val3.time_from_start
          _x = _v5007
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v5004.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @motion_plan_request.start_state.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@motion_plan_request.start_state.is_diff,) = @@struct_C.unpack(str[start..(end_point-1)])
      @motion_plan_request.start_state.is_diff = bool(@motion_plan_request.start_state.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_request.goal_constraints = []
      length.times do
        val1 = Moveit_msgs::Constraints.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.joint_constraints = []
        length.times do
          val2 = Moveit_msgs::JointConstraint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.joint_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.joint_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.position_constraints = []
        length.times do
          val2 = Moveit_msgs::PositionConstraint.new
          _v5008 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v5008.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5009 = _v5008.stamp
          _x = _v5009
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v5008.frame_id = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _v5010 = val2.target_point_offset
          _x = _v5010
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5011 = val2.constraint_region
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5011.primitives = []
          length.times do
            val4 = Shape_msgs::SolidPrimitive.new
            start = end_point
            end_point += ROS::Struct::calc_size('C')
            (val4.type,) = @@struct_C.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            pattern = "d#{length}"
            start = end_point
            end_point += ROS::Struct::calc_size("#{pattern}")
            val4.dimensions = str[start..(end_point-1)].unpack(pattern)
            _v5011.primitives.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5011.primitive_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v5012 = val4.position
            _x = _v5012
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v5013 = val4.orientation
            _x = _v5013
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v5011.primitive_poses.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5011.meshes = []
          length.times do
            val4 = Shape_msgs::Mesh.new
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.triangles = []
            length.times do
              val5 = Shape_msgs::MeshTriangle.new
              start = end_point
              end_point += ROS::Struct::calc_size('L3')
              val5.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
              val4.triangles.push(val5)
            end
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.vertices = []
            length.times do
              val5 = Geometry_msgs::Point.new
              _x = val5
              start = end_point
              end_point += ROS::Struct::calc_size('d3')
              (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
              val4.vertices.push(val5)
            end
            _v5011.meshes.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5011.mesh_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v5014 = val4.position
            _x = _v5014
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v5015 = val4.orientation
            _x = _v5015
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v5011.mesh_poses.push(val4)
          end
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
          val1.position_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.orientation_constraints = []
        length.times do
          val2 = Moveit_msgs::OrientationConstraint.new
          _v5016 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v5016.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5017 = _v5016.stamp
          _x = _v5017
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v5016.frame_id = str[start..(end_point-1)]
          _v5018 = val2.orientation
          _x = _v5018
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.orientation_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.visibility_constraints = []
        length.times do
          val2 = Moveit_msgs::VisibilityConstraint.new
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.target_radius,) = @@struct_d.unpack(str[start..(end_point-1)])
          _v5019 = val2.target_pose
          _v5020 = _v5019.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v5020.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5021 = _v5020.stamp
          _x = _v5021
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v5020.frame_id = str[start..(end_point-1)]
          _v5022 = _v5019.pose
          _v5023 = _v5022.position
          _x = _v5023
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5024 = _v5022.orientation
          _x = _v5024
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += ROS::Struct::calc_size('l')
          (val2.cone_sides,) = @@struct_l.unpack(str[start..(end_point-1)])
          _v5025 = val2.sensor_pose
          _v5026 = _v5025.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v5026.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5027 = _v5026.stamp
          _x = _v5027
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v5026.frame_id = str[start..(end_point-1)]
          _v5028 = _v5025.pose
          _v5029 = _v5028.position
          _x = _v5029
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5030 = _v5028.orientation
          _x = _v5030
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d2Cd')
          (_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight,) = @@struct_d2Cd.unpack(str[start..(end_point-1)])
          val1.visibility_constraints.push(val2)
        end
        @motion_plan_request.goal_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @motion_plan_request.path_constraints.name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_request.path_constraints.joint_constraints = []
      length.times do
        val1 = Moveit_msgs::JointConstraint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.joint_name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @motion_plan_request.path_constraints.joint_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_request.path_constraints.position_constraints = []
      length.times do
        val1 = Moveit_msgs::PositionConstraint.new
        _v5031 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v5031.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5032 = _v5031.stamp
        _x = _v5032
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v5031.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v5033 = val1.target_point_offset
        _x = _v5033
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v5034 = val1.constraint_region
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5034.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v5034.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5034.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v5035 = val3.position
          _x = _v5035
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5036 = val3.orientation
          _x = _v5036
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v5034.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5034.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v5034.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5034.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v5037 = val3.position
          _x = _v5037
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5038 = val3.orientation
          _x = _v5038
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v5034.mesh_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @motion_plan_request.path_constraints.position_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_request.path_constraints.orientation_constraints = []
      length.times do
        val1 = Moveit_msgs::OrientationConstraint.new
        _v5039 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v5039.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5040 = _v5039.stamp
        _x = _v5040
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v5039.frame_id = str[start..(end_point-1)]
        _v5041 = val1.orientation
        _x = _v5041
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @motion_plan_request.path_constraints.orientation_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_request.path_constraints.visibility_constraints = []
      length.times do
        val1 = Moveit_msgs::VisibilityConstraint.new
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.target_radius,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v5042 = val1.target_pose
        _v5043 = _v5042.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v5043.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5044 = _v5043.stamp
        _x = _v5044
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v5043.frame_id = str[start..(end_point-1)]
        _v5045 = _v5042.pose
        _v5046 = _v5045.position
        _x = _v5046
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v5047 = _v5045.orientation
        _x = _v5047
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('l')
        (val1.cone_sides,) = @@struct_l.unpack(str[start..(end_point-1)])
        _v5048 = val1.sensor_pose
        _v5049 = _v5048.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v5049.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5050 = _v5049.stamp
        _x = _v5050
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v5049.frame_id = str[start..(end_point-1)]
        _v5051 = _v5048.pose
        _v5052 = _v5051.position
        _x = _v5052
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v5053 = _v5051.orientation
        _x = _v5053
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d2Cd')
        (_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight,) = @@struct_d2Cd.unpack(str[start..(end_point-1)])
        @motion_plan_request.path_constraints.visibility_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_request.trajectory_constraints.constraints = []
      length.times do
        val1 = Moveit_msgs::Constraints.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.joint_constraints = []
        length.times do
          val2 = Moveit_msgs::JointConstraint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.joint_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.joint_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.position_constraints = []
        length.times do
          val2 = Moveit_msgs::PositionConstraint.new
          _v5054 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v5054.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5055 = _v5054.stamp
          _x = _v5055
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v5054.frame_id = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _v5056 = val2.target_point_offset
          _x = _v5056
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5057 = val2.constraint_region
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5057.primitives = []
          length.times do
            val4 = Shape_msgs::SolidPrimitive.new
            start = end_point
            end_point += ROS::Struct::calc_size('C')
            (val4.type,) = @@struct_C.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            pattern = "d#{length}"
            start = end_point
            end_point += ROS::Struct::calc_size("#{pattern}")
            val4.dimensions = str[start..(end_point-1)].unpack(pattern)
            _v5057.primitives.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5057.primitive_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v5058 = val4.position
            _x = _v5058
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v5059 = val4.orientation
            _x = _v5059
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v5057.primitive_poses.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5057.meshes = []
          length.times do
            val4 = Shape_msgs::Mesh.new
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.triangles = []
            length.times do
              val5 = Shape_msgs::MeshTriangle.new
              start = end_point
              end_point += ROS::Struct::calc_size('L3')
              val5.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
              val4.triangles.push(val5)
            end
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.vertices = []
            length.times do
              val5 = Geometry_msgs::Point.new
              _x = val5
              start = end_point
              end_point += ROS::Struct::calc_size('d3')
              (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
              val4.vertices.push(val5)
            end
            _v5057.meshes.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5057.mesh_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v5060 = val4.position
            _x = _v5060
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v5061 = val4.orientation
            _x = _v5061
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v5057.mesh_poses.push(val4)
          end
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
          val1.position_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.orientation_constraints = []
        length.times do
          val2 = Moveit_msgs::OrientationConstraint.new
          _v5062 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v5062.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5063 = _v5062.stamp
          _x = _v5063
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v5062.frame_id = str[start..(end_point-1)]
          _v5064 = val2.orientation
          _x = _v5064
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.orientation_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.visibility_constraints = []
        length.times do
          val2 = Moveit_msgs::VisibilityConstraint.new
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.target_radius,) = @@struct_d.unpack(str[start..(end_point-1)])
          _v5065 = val2.target_pose
          _v5066 = _v5065.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v5066.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5067 = _v5066.stamp
          _x = _v5067
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v5066.frame_id = str[start..(end_point-1)]
          _v5068 = _v5065.pose
          _v5069 = _v5068.position
          _x = _v5069
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5070 = _v5068.orientation
          _x = _v5070
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += ROS::Struct::calc_size('l')
          (val2.cone_sides,) = @@struct_l.unpack(str[start..(end_point-1)])
          _v5071 = val2.sensor_pose
          _v5072 = _v5071.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v5072.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v5073 = _v5072.stamp
          _x = _v5073
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v5072.frame_id = str[start..(end_point-1)]
          _v5074 = _v5071.pose
          _v5075 = _v5074.position
          _x = _v5075
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5076 = _v5074.orientation
          _x = _v5076
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d2Cd')
          (_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight,) = @@struct_d2Cd.unpack(str[start..(end_point-1)])
          val1.visibility_constraints.push(val2)
        end
        @motion_plan_request.trajectory_constraints.constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @motion_plan_request.planner_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @motion_plan_request.group_name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('ld')
      (@motion_plan_request.num_planning_attempts, @motion_plan_request.allowed_planning_time,) = @@struct_ld.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
# autogenerated by genrb from GetMotionPlanResponse.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Transform"
require "geometry_msgs/Point"
require "geometry_msgs/Twist"
require "shape_msgs/Mesh"
require "trajectory_msgs/MultiDOFJointTrajectory"
require "std_msgs/Header"
require "moveit_msgs/MoveItErrorCodes"
require "ros/duration"
require "shape_msgs/Plane"
require "sensor_msgs/MultiDOFJointState"
require "geometry_msgs/Pose"
require "shape_msgs/MeshTriangle"
require "moveit_msgs/MotionPlanResponse"
require "shape_msgs/SolidPrimitive"
require "geometry_msgs/Wrench"
require "moveit_msgs/RobotTrajectory"
require "trajectory_msgs/MultiDOFJointTrajectoryPoint"
require "moveit_msgs/RobotState"
require "trajectory_msgs/JointTrajectory"
require "sensor_msgs/JointState"
require "trajectory_msgs/JointTrajectoryPoint"
require "object_recognition_msgs/ObjectType"
require "moveit_msgs/AttachedCollisionObject"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "moveit_msgs/CollisionObject"

module Moveit_msgs

class GetMotionPlanResponse <::ROS::Message
  def self.md5sum
    "37fe7e8f0d4dfa55ccfa53d63c86ae15"
  end

  def self.type
    "moveit_msgs/GetMotionPlanResponse"
  end

  def has_header?
    false
  end

  def message_definition
    "
MotionPlanResponse motion_plan_response


================================================================================
MSG: moveit_msgs/MotionPlanResponse
# The representation of a solution to a planning problem

# The corresponding robot state
RobotState trajectory_start

# The group used for planning (usually the same as in the request)
string group_name

# A solution trajectory, if found
RobotTrajectory trajectory

# Planning time (seconds)
float64 planning_time

# Error code - encodes the overall reason for failure
MoveItErrorCodes error_code

================================================================================
MSG: moveit_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state

# Joints that may have multiple DOF are specified here
sensor_msgs/MultiDOFJointState multi_dof_joint_state

# Attached collision objects (attached to some link on the robot)
AttachedCollisionObject[] attached_collision_objects

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
# This is mostly important for handling the attached bodies (whether or not to clear the attached bodies
# of a moveit::core::RobotState before updating it with this message)
bool is_diff

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/MultiDOFJointState
# Representation of state for joints with multiple degrees of freedom, 
# following the structure of JointState.
#
# It is assumed that a joint in a system corresponds to a transform that gets applied 
# along the kinematic chain. For example, a planar joint (as in URDF) is 3DOF (x, y, yaw)
# and those 3DOF can be expressed as a transformation matrix, and that transformation
# matrix can be converted back to (x, y, yaw)
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# wrench associated with them, you can leave the wrench array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

Header header

string[] joint_names
geometry_msgs/Transform[] transforms
geometry_msgs/Twist[] twist
geometry_msgs/Wrench[] wrench

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: moveit_msgs/AttachedCollisionObject
# The CollisionObject will be attached with a fixed joint to this link
string link_name

#This contains the actual shapes and poses for the CollisionObject
#to be attached to the link
#If action is remove and no object.id is set, all objects
#attached to the link indicated by link_name will be removed
CollisionObject object

# The set of links that the attached objects are allowed to touch
# by default - the link_name is already considered by default
string[] touch_links

# If certain links were placed in a particular posture for this object to remain attached 
# (e.g., an end effector closing around an object), the posture necessary for releasing
# the object is stored here
trajectory_msgs/JointTrajectory detach_posture

# The weight of the attached object, if known
float64 weight

================================================================================
MSG: moveit_msgs/CollisionObject
# a header, used for interpreting the poses
Header header

# the id of the object (name used in MoveIt)
string id

# The object type in a database of known objects
object_recognition_msgs/ObjectType type

# the the collision geometries associated with the object;
# their poses are with respect to the specified header

# solid geometric primitives
shape_msgs/SolidPrimitive[] primitives
geometry_msgs/Pose[] primitive_poses

# meshes
shape_msgs/Mesh[] meshes
geometry_msgs/Pose[] mesh_poses

# bounding planes (equation is specified, but the plane can be oriented using an additional pose)
shape_msgs/Plane[] planes
geometry_msgs/Pose[] plane_poses

# Adds the object to the planning scene. If the object previously existed, it is replaced.
byte ADD=0

# Removes the object from the environment entirely (everything that matches the specified id)
byte REMOVE=1

# Append to an object that already exists in the planning scene. If the does not exist, it is added.
byte APPEND=2

# If an object already exists in the scene, new poses can be sent (the geometry arrays must be left empty)
# if solely moving the object is desired
byte MOVE=3

# Operation to be performed
byte operation

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: shape_msgs/SolidPrimitive
# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: shape_msgs/Plane
# Representation of a plane, using the plane equation ax + by + cz + d = 0

# a := coef[0]
# b := coef[1]
# c := coef[2]
# d := coef[3]

float64[4] coef

================================================================================
MSG: trajectory_msgs/JointTrajectory
Header header
string[] joint_names
JointTrajectoryPoint[] points
================================================================================
MSG: trajectory_msgs/JointTrajectoryPoint
# Each trajectory point specifies either positions[, velocities[, accelerations]]
# or positions[, effort] for the trajectory to be executed.
# All specified values are in the same order as the joint names in JointTrajectory.msg

float64[] positions
float64[] velocities
float64[] accelerations
float64[] effort
duration time_from_start

================================================================================
MSG: moveit_msgs/RobotTrajectory
trajectory_msgs/JointTrajectory joint_trajectory
trajectory_msgs/MultiDOFJointTrajectory multi_dof_joint_trajectory

================================================================================
MSG: trajectory_msgs/MultiDOFJointTrajectory
# The header is used to specify the coordinate frame and the reference time for the trajectory durations
Header header

# A representation of a multi-dof joint trajectory (each point is a transformation)
# Each point along the trajectory will include an array of positions/velocities/accelerations
# that has the same length as the array of joint names, and has the same order of joints as 
# the joint names array.

string[] joint_names
MultiDOFJointTrajectoryPoint[] points

================================================================================
MSG: trajectory_msgs/MultiDOFJointTrajectoryPoint
# Each multi-dof joint can specify a transform (up to 6 DOF)
geometry_msgs/Transform[] transforms

# There can be a velocity specified for the origin of the joint 
geometry_msgs/Twist[] velocities

# There can be an acceleration specified for the origin of the joint 
geometry_msgs/Twist[] accelerations

duration time_from_start

================================================================================
MSG: moveit_msgs/MoveItErrorCodes
int32 val

# overall behavior
int32 SUCCESS=1
int32 FAILURE=99999

int32 PLANNING_FAILED=-1
int32 INVALID_MOTION_PLAN=-2
int32 MOTION_PLAN_INVALIDATED_BY_ENVIRONMENT_CHANGE=-3
int32 CONTROL_FAILED=-4
int32 UNABLE_TO_AQUIRE_SENSOR_DATA=-5
int32 TIMED_OUT=-6
int32 PREEMPTED=-7

# planning & kinematics request errors
int32 START_STATE_IN_COLLISION=-10
int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-11

int32 GOAL_IN_COLLISION=-12
int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-13
int32 GOAL_CONSTRAINTS_VIOLATED=-14

int32 INVALID_GROUP_NAME=-15
int32 INVALID_GOAL_CONSTRAINTS=-16
int32 INVALID_ROBOT_STATE=-17
int32 INVALID_LINK_NAME=-18
int32 INVALID_OBJECT_NAME=-19

# system errors
int32 FRAME_TRANSFORM_FAILURE=-21
int32 COLLISION_CHECKING_UNAVAILABLE=-22
int32 ROBOT_STATE_STALE=-23
int32 SENSOR_INFO_STALE=-24

# kinematics errors
int32 NO_IK_SOLUTION=-31

"
  end
  attr_accessor :motion_plan_response

  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_dl = ::ROS::Struct.new("dl")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_c = ::ROS::Struct.new("c")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['moveit_msgs/MotionPlanResponse']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [moveit_msgs/MotionPlanResponse] :motion_plan_response initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:motion_plan_response]
      @motion_plan_response = args[:motion_plan_response]
    else
      @motion_plan_response = Moveit_msgs::MotionPlanResponse.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@motion_plan_response.trajectory_start.joint_state.header.seq, @motion_plan_response.trajectory_start.joint_state.header.stamp.secs, @motion_plan_response.trajectory_start.joint_state.header.stamp.nsecs))
      _x = @motion_plan_response.trajectory_start.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @motion_plan_response.trajectory_start.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_response.trajectory_start.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @motion_plan_response.trajectory_start.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@motion_plan_response.trajectory_start.joint_state.position.pack(pattern))
      length = @motion_plan_response.trajectory_start.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@motion_plan_response.trajectory_start.joint_state.velocity.pack(pattern))
      length = @motion_plan_response.trajectory_start.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@motion_plan_response.trajectory_start.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@motion_plan_response.trajectory_start.multi_dof_joint_state.header.seq, @motion_plan_response.trajectory_start.multi_dof_joint_state.header.stamp.secs, @motion_plan_response.trajectory_start.multi_dof_joint_state.header.stamp.nsecs))
      _x = @motion_plan_response.trajectory_start.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @motion_plan_response.trajectory_start.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_response.trajectory_start.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @motion_plan_response.trajectory_start.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_response.trajectory_start.multi_dof_joint_state.transforms
        _v5077 = val1.translation
        _x = _v5077
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v5078 = val1.rotation
        _x = _v5078
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @motion_plan_response.trajectory_start.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_response.trajectory_start.multi_dof_joint_state.twist
        _v5079 = val1.linear
        _x = _v5079
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v5080 = val1.angular
        _x = _v5080
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @motion_plan_response.trajectory_start.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_response.trajectory_start.multi_dof_joint_state.wrench
        _v5081 = val1.force
        _x = _v5081
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v5082 = val1.torque
        _x = _v5082
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @motion_plan_response.trajectory_start.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_response.trajectory_start.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v5083 = val1.object
        _v5084 = _v5083.header
        buff.write(@@struct_L.pack(_v5084.seq))
        _v5085 = _v5084.stamp
        _x = _v5085
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v5084.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v5083.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v5086 = _v5083.type
        _x = _v5086.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v5086.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v5083.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v5083.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v5083.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v5083.primitive_poses
          _v5087 = val3.position
          _x = _v5087
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v5088 = val3.orientation
          _x = _v5088
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v5083.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v5083.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v5083.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v5083.mesh_poses
          _v5089 = val3.position
          _x = _v5089
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v5090 = val3.orientation
          _x = _v5090
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v5083.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v5083.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v5083.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v5083.plane_poses
          _v5091 = val3.position
          _x = _v5091
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v5092 = val3.orientation
          _x = _v5092
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v5083.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v5093 = val1.detach_posture
        _v5094 = _v5093.header
        buff.write(@@struct_L.pack(_v5094.seq))
        _v5095 = _v5094.stamp
        _x = _v5095
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v5094.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v5093.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v5093.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v5093.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v5093.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v5096 = val3.time_from_start
          _x = _v5096
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_C.pack(@motion_plan_response.trajectory_start.is_diff))
      _x = @motion_plan_response.group_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@motion_plan_response.trajectory.joint_trajectory.header.seq, @motion_plan_response.trajectory.joint_trajectory.header.stamp.secs, @motion_plan_response.trajectory.joint_trajectory.header.stamp.nsecs))
      _x = @motion_plan_response.trajectory.joint_trajectory.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @motion_plan_response.trajectory.joint_trajectory.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_response.trajectory.joint_trajectory.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @motion_plan_response.trajectory.joint_trajectory.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_response.trajectory.joint_trajectory.points
        length = val1.positions.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.positions.pack(pattern))
        length = val1.velocities.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.velocities.pack(pattern))
        length = val1.accelerations.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.accelerations.pack(pattern))
        length = val1.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.effort.pack(pattern))
        _v5097 = val1.time_from_start
        _x = _v5097
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_L3.pack(@motion_plan_response.trajectory.multi_dof_joint_trajectory.header.seq, @motion_plan_response.trajectory.multi_dof_joint_trajectory.header.stamp.secs, @motion_plan_response.trajectory.multi_dof_joint_trajectory.header.stamp.nsecs))
      _x = @motion_plan_response.trajectory.multi_dof_joint_trajectory.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @motion_plan_response.trajectory.multi_dof_joint_trajectory.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_response.trajectory.multi_dof_joint_trajectory.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @motion_plan_response.trajectory.multi_dof_joint_trajectory.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @motion_plan_response.trajectory.multi_dof_joint_trajectory.points
        length = val1.transforms.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.transforms
          _v5098 = val2.translation
          _x = _v5098
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v5099 = val2.rotation
          _x = _v5099
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.velocities.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.velocities
          _v5100 = val2.linear
          _x = _v5100
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v5101 = val2.angular
          _x = _v5101
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        length = val1.accelerations.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.accelerations
          _v5102 = val2.linear
          _x = _v5102
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v5103 = val2.angular
          _x = _v5103
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        _v5104 = val1.time_from_start
        _x = _v5104
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_dl.pack(@motion_plan_response.planning_time, @motion_plan_response.error_code.val))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @motion_plan_response == nil
        @motion_plan_response = Moveit_msgs::MotionPlanResponse.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@motion_plan_response.trajectory_start.joint_state.header.seq, @motion_plan_response.trajectory_start.joint_state.header.stamp.secs, @motion_plan_response.trajectory_start.joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @motion_plan_response.trajectory_start.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_response.trajectory_start.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @motion_plan_response.trajectory_start.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @motion_plan_response.trajectory_start.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @motion_plan_response.trajectory_start.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @motion_plan_response.trajectory_start.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@motion_plan_response.trajectory_start.multi_dof_joint_state.header.seq, @motion_plan_response.trajectory_start.multi_dof_joint_state.header.stamp.secs, @motion_plan_response.trajectory_start.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @motion_plan_response.trajectory_start.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_response.trajectory_start.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @motion_plan_response.trajectory_start.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_response.trajectory_start.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v5105 = val1.translation
        _x = _v5105
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v5106 = val1.rotation
        _x = _v5106
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @motion_plan_response.trajectory_start.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_response.trajectory_start.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v5107 = val1.linear
        _x = _v5107
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v5108 = val1.angular
        _x = _v5108
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @motion_plan_response.trajectory_start.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_response.trajectory_start.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v5109 = val1.force
        _x = _v5109
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v5110 = val1.torque
        _x = _v5110
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @motion_plan_response.trajectory_start.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_response.trajectory_start.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v5111 = val1.object
        _v5112 = _v5111.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v5112.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5113 = _v5112.stamp
        _x = _v5113
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v5112.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v5111.id = str[start..(end_point-1)]
        _v5114 = _v5111.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v5114.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v5114.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5111.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v5111.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5111.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v5115 = val3.position
          _x = _v5115
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5116 = val3.orientation
          _x = _v5116
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v5111.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5111.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v5111.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5111.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v5117 = val3.position
          _x = _v5117
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5118 = val3.orientation
          _x = _v5118
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v5111.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5111.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v5111.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5111.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v5119 = val3.position
          _x = _v5119
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5120 = val3.orientation
          _x = _v5120
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v5111.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v5111.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v5121 = val1.detach_posture
        _v5122 = _v5121.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v5122.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5123 = _v5122.stamp
        _x = _v5123
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v5122.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5121.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v5121.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v5121.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v5124 = val3.time_from_start
          _x = _v5124
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v5121.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @motion_plan_response.trajectory_start.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@motion_plan_response.trajectory_start.is_diff,) = @@struct_C.unpack(str[start..(end_point-1)])
      @motion_plan_response.trajectory_start.is_diff = bool(@motion_plan_response.trajectory_start.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @motion_plan_response.group_name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@motion_plan_response.trajectory.joint_trajectory.header.seq, @motion_plan_response.trajectory.joint_trajectory.header.stamp.secs, @motion_plan_response.trajectory.joint_trajectory.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @motion_plan_response.trajectory.joint_trajectory.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_response.trajectory.joint_trajectory.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @motion_plan_response.trajectory.joint_trajectory.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_response.trajectory.joint_trajectory.points = []
      length.times do
        val1 = Trajectory_msgs::JointTrajectoryPoint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.positions = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.velocities = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.accelerations = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.effort = str[start..(end_point-1)].unpack(pattern)
        _v5125 = val1.time_from_start
        _x = _v5125
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @motion_plan_response.trajectory.joint_trajectory.points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@motion_plan_response.trajectory.multi_dof_joint_trajectory.header.seq, @motion_plan_response.trajectory.multi_dof_joint_trajectory.header.stamp.secs, @motion_plan_response.trajectory.multi_dof_joint_trajectory.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @motion_plan_response.trajectory.multi_dof_joint_trajectory.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_response.trajectory.multi_dof_joint_trajectory.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @motion_plan_response.trajectory.multi_dof_joint_trajectory.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @motion_plan_response.trajectory.multi_dof_joint_trajectory.points = []
      length.times do
        val1 = Trajectory_msgs::MultiDOFJointTrajectoryPoint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.transforms = []
        length.times do
          val2 = Geometry_msgs::Transform.new
          _v5126 = val2.translation
          _x = _v5126
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5127 = val2.rotation
          _x = _v5127
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.transforms.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.velocities = []
        length.times do
          val2 = Geometry_msgs::Twist.new
          _v5128 = val2.linear
          _x = _v5128
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5129 = val2.angular
          _x = _v5129
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.velocities.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.accelerations = []
        length.times do
          val2 = Geometry_msgs::Twist.new
          _v5130 = val2.linear
          _x = _v5130
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v5131 = val2.angular
          _x = _v5131
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.accelerations.push(val2)
        end
        _v5132 = val1.time_from_start
        _x = _v5132
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @motion_plan_response.trajectory.multi_dof_joint_trajectory.points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('dl')
      (@motion_plan_response.planning_time, @motion_plan_response.error_code.val,) = @@struct_dl.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
module Moveit_msgs
class GetMotionPlan
  def self.type
    'moveit_msgs/GetMotionPlan'
  end
  def self.md5sum
    '14effbee427e7d7da19fe4b7f03b30a6'
  end
  def self.request_class
    GetMotionPlanRequest
  end
  def self.response_class
    GetMotionPlanResponse
  end
end
end