# autogenerated by genrb from GripperTranslation.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Vector3"
require "geometry_msgs/Vector3Stamped"

module Moveit_msgs

class GripperTranslation <::ROS::Message
  def self.md5sum
    "b53bc0ad0f717cdec3b0e42dec300121"
  end

  def self.type
    "moveit_msgs/GripperTranslation"
  end

  def has_header?
    false
  end

  def message_definition
    "# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :direction, :desired_distance, :min_distance

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d3f2 = ::ROS::Struct.new("d3f2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['geometry_msgs/Vector3Stamped','float32','float32']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [geometry_msgs/Vector3Stamped] :direction initialize value
  # @option args [float32] :desired_distance initialize value
  # @option args [float32] :min_distance initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:direction]
      @direction = args[:direction]
    else
      @direction = Geometry_msgs::Vector3Stamped.new
    end
    if args[:desired_distance]
      @desired_distance = args[:desired_distance]
    else
      @desired_distance = 0.0
    end
    if args[:min_distance]
      @min_distance = args[:min_distance]
    else
      @min_distance = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@direction.header.seq, @direction.header.stamp.secs, @direction.header.stamp.nsecs))
      _x = @direction.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3f2.pack(@direction.vector.x, @direction.vector.y, @direction.vector.z, @desired_distance, @min_distance))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @direction == nil
        @direction = Geometry_msgs::Vector3Stamped.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@direction.header.seq, @direction.header.stamp.secs, @direction.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @direction.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3f2')
      (@direction.vector.x, @direction.vector.y, @direction.vector.z, @desired_distance, @min_distance,) = @@struct_d3f2.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
