# autogenerated by genrb from JointLimits.msg. Do not edit.
require 'ros/message'


module Moveit_msgs

class JointLimits <::ROS::Message
  def self.md5sum
    "8ca618c7329ea46142cbc864a2efe856"
  end

  def self.type
    "moveit_msgs/JointLimits"
  end

  def has_header?
    false
  end

  def message_definition
    "# This message contains information about limits of a particular joint (or control dimension)
string joint_name

# true if the joint has position limits
bool has_position_limits

# min and max position limits
float64 min_position
float64 max_position

# true if joint has velocity limits
bool has_velocity_limits

# max velocity limit
float64 max_velocity
# min_velocity is assumed to be -max_velocity

# true if joint has acceleration limits
bool has_acceleration_limits
# max acceleration limit
float64 max_acceleration
# min_acceleration is assumed to be -max_acceleration

"
  end
  attr_accessor :joint_name, :has_position_limits, :min_position, :max_position, :has_velocity_limits, :max_velocity, :has_acceleration_limits, :max_acceleration

  @@struct_Cd2CdCd = ::ROS::Struct.new("Cd2CdCd")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','bool','float64','float64','bool','float64','bool','float64']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :joint_name initialize value
  # @option args [bool] :has_position_limits initialize value
  # @option args [float64] :min_position initialize value
  # @option args [float64] :max_position initialize value
  # @option args [bool] :has_velocity_limits initialize value
  # @option args [float64] :max_velocity initialize value
  # @option args [bool] :has_acceleration_limits initialize value
  # @option args [float64] :max_acceleration initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:joint_name]
      @joint_name = args[:joint_name]
    else
      @joint_name = ''
    end
    if args[:has_position_limits]
      @has_position_limits = args[:has_position_limits]
    else
      @has_position_limits = false
    end
    if args[:min_position]
      @min_position = args[:min_position]
    else
      @min_position = 0.0
    end
    if args[:max_position]
      @max_position = args[:max_position]
    else
      @max_position = 0.0
    end
    if args[:has_velocity_limits]
      @has_velocity_limits = args[:has_velocity_limits]
    else
      @has_velocity_limits = false
    end
    if args[:max_velocity]
      @max_velocity = args[:max_velocity]
    else
      @max_velocity = 0.0
    end
    if args[:has_acceleration_limits]
      @has_acceleration_limits = args[:has_acceleration_limits]
    else
      @has_acceleration_limits = false
    end
    if args[:max_acceleration]
      @max_acceleration = args[:max_acceleration]
    else
      @max_acceleration = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @joint_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_Cd2CdCd.pack(@has_position_limits, @min_position, @max_position, @has_velocity_limits, @max_velocity, @has_acceleration_limits, @max_acceleration))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @joint_name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('Cd2CdCd')
      (@has_position_limits, @min_position, @max_position, @has_velocity_limits, @max_velocity, @has_acceleration_limits, @max_acceleration,) = @@struct_Cd2CdCd.unpack(str[start..(end_point-1)])
      @has_position_limits = bool(@has_position_limits)
      @has_velocity_limits = bool(@has_velocity_limits)
      @has_acceleration_limits = bool(@has_acceleration_limits)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
