# autogenerated by genrb from KinematicSolverInfo.msg. Do not edit.
require 'ros/message'

require "moveit_msgs/JointLimits"

module Moveit_msgs

class KinematicSolverInfo <::ROS::Message
  def self.md5sum
    "cc048557c0f9795c392dd80f8bb00489"
  end

  def self.type
    "moveit_msgs/KinematicSolverInfo"
  end

  def has_header?
    false
  end

  def message_definition
    "# A list of joints in the kinematic tree
string[] joint_names
# A list of joint limits corresponding to the joint names
moveit_msgs/JointLimits[] limits
# A list of links that the kinematics node provides solutions for
string[] link_names

================================================================================
MSG: moveit_msgs/JointLimits
# This message contains information about limits of a particular joint (or control dimension)
string joint_name

# true if the joint has position limits
bool has_position_limits

# min and max position limits
float64 min_position
float64 max_position

# true if joint has velocity limits
bool has_velocity_limits

# max velocity limit
float64 max_velocity
# min_velocity is assumed to be -max_velocity

# true if joint has acceleration limits
bool has_acceleration_limits
# max acceleration limit
float64 max_acceleration
# min_acceleration is assumed to be -max_acceleration

"
  end
  attr_accessor :joint_names, :limits, :link_names

  @@struct_Cd2CdCd = ::ROS::Struct.new("Cd2CdCd")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string[]','moveit_msgs/JointLimits[]','string[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string[]] :joint_names initialize value
  # @option args [moveit_msgs/JointLimits[]] :limits initialize value
  # @option args [string[]] :link_names initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:joint_names]
      @joint_names = args[:joint_names]
    else
      @joint_names = []
    end
    if args[:limits]
      @limits = args[:limits]
    else
      @limits = []
    end
    if args[:link_names]
      @link_names = args[:link_names]
    else
      @link_names = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      length = @joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @limits.length
      buff.write(@@struct_L.pack(length))
      for val1 in @limits
        _x = val1.joint_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_Cd2CdCd.pack(_x.has_position_limits, _x.min_position, _x.max_position, _x.has_velocity_limits, _x.max_velocity, _x.has_acceleration_limits, _x.max_acceleration))
      end
      length = @link_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @link_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @limits == nil
        @limits = Moveit_msgs::JointLimits[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @limits = []
      length.times do
        val1 = Moveit_msgs::JointLimits.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.joint_name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('Cd2CdCd')
        (_x.has_position_limits, _x.min_position, _x.max_position, _x.has_velocity_limits, _x.max_velocity, _x.has_acceleration_limits, _x.max_acceleration,) = @@struct_Cd2CdCd.unpack(str[start..(end_point-1)])
        val1.has_position_limits = bool(val1.has_position_limits)
        val1.has_velocity_limits = bool(val1.has_velocity_limits)
        val1.has_acceleration_limits = bool(val1.has_acceleration_limits)
        @limits.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @link_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @link_names.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
