# autogenerated by genrb from MoveGroupActionGoal.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "geometry_msgs/Transform"
require "moveit_msgs/PlanningSceneWorld"
require "moveit_msgs/VisibilityConstraint"
require "moveit_msgs/OrientationConstraint"
require "octomap_msgs/Octomap"
require "moveit_msgs/Constraints"
require "geometry_msgs/Point"
require "geometry_msgs/Twist"
require "shape_msgs/Mesh"
require "std_msgs/ColorRGBA"
require "moveit_msgs/LinkScale"
require "moveit_msgs/PositionConstraint"
require "shape_msgs/Plane"
require "moveit_msgs/AllowedCollisionEntry"
require "geometry_msgs/PoseStamped"
require "moveit_msgs/PlanningOptions"
require "moveit_msgs/ObjectColor"
require "ros/duration"
require "moveit_msgs/BoundingVolume"
require "moveit_msgs/JointConstraint"
require "std_msgs/Header"
require "moveit_msgs/AllowedCollisionMatrix"
require "sensor_msgs/MultiDOFJointState"
require "geometry_msgs/Pose"
require "shape_msgs/MeshTriangle"
require "moveit_msgs/TrajectoryConstraints"
require "shape_msgs/SolidPrimitive"
require "geometry_msgs/Wrench"
require "moveit_msgs/MoveGroupGoal"
require "geometry_msgs/TransformStamped"
require "moveit_msgs/WorkspaceParameters"
require "moveit_msgs/RobotState"
require "moveit_msgs/PlanningScene"
require "octomap_msgs/OctomapWithPose"
require "trajectory_msgs/JointTrajectory"
require "sensor_msgs/JointState"
require "trajectory_msgs/JointTrajectoryPoint"
require "moveit_msgs/LinkPadding"
require "object_recognition_msgs/ObjectType"
require "moveit_msgs/MotionPlanRequest"
require "actionlib_msgs/GoalID"
require "moveit_msgs/AttachedCollisionObject"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "moveit_msgs/CollisionObject"

module Moveit_msgs

class MoveGroupActionGoal <::ROS::Message
  def self.md5sum
    "5a63f1e432efa5831f25bdbf4067e372"
  end

  def self.type
    "moveit_msgs/MoveGroupActionGoal"
  end

  def has_header?
    true
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalID goal_id
MoveGroupGoal goal

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: moveit_msgs/MoveGroupGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Motion planning request to pass to planner
MotionPlanRequest request

# Planning options
PlanningOptions planning_options


================================================================================
MSG: moveit_msgs/MotionPlanRequest
# This service contains the definition for a request to the motion
# planner and the output it provides

# Parameters for the workspace that the planner should work inside
WorkspaceParameters workspace_parameters

# Starting state updates. If certain joints should be considered
# at positions other than the current ones, these positions should
# be set here
RobotState start_state

# The possible goal states for the model to plan for. Each element of
# the array defines a goal region. The goal is achieved
# if the constraints for a particular region are satisfied
Constraints[] goal_constraints

# No state at any point along the path in the produced motion plan will violate these constraints (this applies to all points, not just waypoints)
Constraints path_constraints

# The constraints the resulting trajectory must satisfy
TrajectoryConstraints trajectory_constraints

# The name of the motion planner to use. If no name is specified,
# a default motion planner will be used
string planner_id

# The name of the group of joints on which this planner is operating
string group_name

# The number of times this plan is to be computed. Shortest solution
# will be reported.
int32 num_planning_attempts

# The maximum amount of time the motion planner is allowed to plan for (in seconds)
float64 allowed_planning_time

================================================================================
MSG: moveit_msgs/WorkspaceParameters
# This message contains a set of parameters useful in
# setting up the volume (a box) in which the robot is allowed to move.
# This is useful only when planning for mobile parts of 
# the robot as well.

# Define the frame of reference for the box corners
Header header

# The minumum corner of the box, with respect to the robot starting pose
geometry_msgs/Vector3 min_corner

# The maximum corner of the box, with respect to the robot starting pose
geometry_msgs/Vector3 max_corner

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: moveit_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state

# Joints that may have multiple DOF are specified here
sensor_msgs/MultiDOFJointState multi_dof_joint_state

# Attached collision objects (attached to some link on the robot)
AttachedCollisionObject[] attached_collision_objects

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
# This is mostly important for handling the attached bodies (whether or not to clear the attached bodies
# of a moveit::core::RobotState before updating it with this message)
bool is_diff

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: sensor_msgs/MultiDOFJointState
# Representation of state for joints with multiple degrees of freedom, 
# following the structure of JointState.
#
# It is assumed that a joint in a system corresponds to a transform that gets applied 
# along the kinematic chain. For example, a planar joint (as in URDF) is 3DOF (x, y, yaw)
# and those 3DOF can be expressed as a transformation matrix, and that transformation
# matrix can be converted back to (x, y, yaw)
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# wrench associated with them, you can leave the wrench array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

Header header

string[] joint_names
geometry_msgs/Transform[] transforms
geometry_msgs/Twist[] twist
geometry_msgs/Wrench[] wrench

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: moveit_msgs/AttachedCollisionObject
# The CollisionObject will be attached with a fixed joint to this link
string link_name

#This contains the actual shapes and poses for the CollisionObject
#to be attached to the link
#If action is remove and no object.id is set, all objects
#attached to the link indicated by link_name will be removed
CollisionObject object

# The set of links that the attached objects are allowed to touch
# by default - the link_name is already considered by default
string[] touch_links

# If certain links were placed in a particular posture for this object to remain attached 
# (e.g., an end effector closing around an object), the posture necessary for releasing
# the object is stored here
trajectory_msgs/JointTrajectory detach_posture

# The weight of the attached object, if known
float64 weight

================================================================================
MSG: moveit_msgs/CollisionObject
# a header, used for interpreting the poses
Header header

# the id of the object (name used in MoveIt)
string id

# The object type in a database of known objects
object_recognition_msgs/ObjectType type

# the the collision geometries associated with the object;
# their poses are with respect to the specified header

# solid geometric primitives
shape_msgs/SolidPrimitive[] primitives
geometry_msgs/Pose[] primitive_poses

# meshes
shape_msgs/Mesh[] meshes
geometry_msgs/Pose[] mesh_poses

# bounding planes (equation is specified, but the plane can be oriented using an additional pose)
shape_msgs/Plane[] planes
geometry_msgs/Pose[] plane_poses

# Adds the object to the planning scene. If the object previously existed, it is replaced.
byte ADD=0

# Removes the object from the environment entirely (everything that matches the specified id)
byte REMOVE=1

# Append to an object that already exists in the planning scene. If the does not exist, it is added.
byte APPEND=2

# If an object already exists in the scene, new poses can be sent (the geometry arrays must be left empty)
# if solely moving the object is desired
byte MOVE=3

# Operation to be performed
byte operation

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: shape_msgs/SolidPrimitive
# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: shape_msgs/Plane
# Representation of a plane, using the plane equation ax + by + cz + d = 0

# a := coef[0]
# b := coef[1]
# c := coef[2]
# d := coef[3]

float64[4] coef

================================================================================
MSG: trajectory_msgs/JointTrajectory
Header header
string[] joint_names
JointTrajectoryPoint[] points
================================================================================
MSG: trajectory_msgs/JointTrajectoryPoint
# Each trajectory point specifies either positions[, velocities[, accelerations]]
# or positions[, effort] for the trajectory to be executed.
# All specified values are in the same order as the joint names in JointTrajectory.msg

float64[] positions
float64[] velocities
float64[] accelerations
float64[] effort
duration time_from_start

================================================================================
MSG: moveit_msgs/Constraints
# This message contains a list of motion planning constraints.
# All constraints must be satisfied for a goal to be considered valid

string name

JointConstraint[] joint_constraints

PositionConstraint[] position_constraints

OrientationConstraint[] orientation_constraints

VisibilityConstraint[] visibility_constraints

================================================================================
MSG: moveit_msgs/JointConstraint
# Constrain the position of a joint to be within a certain bound
string joint_name

# the bound to be achieved is [position - tolerance_below, position + tolerance_above]
float64 position
float64 tolerance_above
float64 tolerance_below

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight
================================================================================
MSG: moveit_msgs/PositionConstraint
# This message contains the definition of a position constraint.

Header header

# The robot link this constraint refers to
string link_name

# The offset (in the link frame) for the target point on the link we are planning for
geometry_msgs/Vector3 target_point_offset

# The volume this constraint refers to 
BoundingVolume constraint_region

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: moveit_msgs/BoundingVolume
# Define a volume in 3D

# A set of solid geometric primitives that make up the volume to define (as a union)
shape_msgs/SolidPrimitive[] primitives

# The poses at which the primitives are located
geometry_msgs/Pose[] primitive_poses

# In addition to primitives, meshes can be specified to add to the bounding volume (again, as union)
shape_msgs/Mesh[] meshes

# The poses at which the meshes are located
geometry_msgs/Pose[] mesh_poses

================================================================================
MSG: moveit_msgs/OrientationConstraint
# This message contains the definition of an orientation constraint.

Header header

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# The robot link this constraint refers to
string link_name

# optional axis-angle error tolerances specified
float64 absolute_x_axis_tolerance
float64 absolute_y_axis_tolerance
float64 absolute_z_axis_tolerance

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: moveit_msgs/VisibilityConstraint
# The constraint is useful to maintain visibility to a disc (the target) in a particular frame.
# This disc forms the base of a visibiliy cone whose tip is at the origin of the sensor.
# Maintaining visibility is done by ensuring the robot does not obstruct the visibility cone.
# Note:
# This constraint does NOT enforce minimum or maximum distances between the sensor
# and the target, nor does it enforce the target to be in the field of view of
# the sensor. A PositionConstraint can (and probably should) be used for such purposes.

# The radius of the disc that should be maintained visible 
float64 target_radius

# The pose of the disc; as the robot moves, the pose of the disc may change as well
# This can be in the frame of a particular robot link, for example
geometry_msgs/PoseStamped target_pose

# From the sensor origin towards the target, the disc forms a visibility cone
# This cone is approximated using many sides. For example, when using 4 sides, 
# that in fact makes the visibility region be a pyramid.
# This value should always be 3 or more.
int32 cone_sides

# The pose in which visibility is to be maintained.
# The frame id should represent the robot link to which the sensor is attached.
# It is assumed the sensor can look directly at the target, in any direction.
# This assumption is usually not true, but additional PositionConstraints
# can resolve this issue.
geometry_msgs/PoseStamped sensor_pose

# Even though the disc is maintained visible, the visibility cone can be very small
# because of the orientation of the disc with respect to the sensor. It is possible
# for example to view the disk almost from a side, in which case the visibility cone 
# can end up having close to 0 volume. The view angle is defined to be the angle between
# the normal to the visibility disc and the direction vector from the sensor origin.
# The value below represents the minimum desired view angle. For a perfect view,
# this value will be 0 (the two vectors are exact opposites). For a completely obstructed view
# this value will be Pi/2 (the vectors are perpendicular). This value defined below 
# is the maximum view angle to be maintained. This should be a value in the open interval
# (0, Pi/2). If 0 is set, the view angle is NOT enforced.
float64 max_view_angle

# This angle is used similarly to max_view_angle but limits the maximum angle
# between the sensor origin direction vector and the axis that connects the
# sensor origin to the target frame origin. The value is again in the range (0, Pi/2)
# and is NOT enforced if set to 0.
float64 max_range_angle

# The axis that is assumed to indicate the direction of view for the sensor
# X = 2, Y = 1, Z = 0
uint8 SENSOR_Z=0
uint8 SENSOR_Y=1
uint8 SENSOR_X=2
uint8 sensor_view_direction

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: moveit_msgs/TrajectoryConstraints
# The array of constraints to consider along the trajectory
Constraints[] constraints

================================================================================
MSG: moveit_msgs/PlanningOptions

# The diff to consider for the planning scene (optional)
PlanningScene planning_scene_diff

# If this flag is set to true, the action
# returns an executable plan in the response but does not attempt execution  
bool plan_only

# If this flag is set to true, the action of planning &
# executing is allowed to look around  (move sensors) if
# it seems that not enough information is available about
# the environment
bool look_around

# If this value is positive, the action of planning & executing
# is allowed to look around for a maximum number of attempts;
# If the value is left as 0, the default value is used, as set
# with dynamic_reconfigure
int32 look_around_attempts

# If set and if look_around is true, this value is used as
# the maximum cost allowed for a path to be considered executable.
# If the cost of a path is higher than this value, more sensing or 
# a new plan needed. If left as 0.0 but look_around is true, then 
# the default value set via dynamic_reconfigure is used
float64 max_safe_execution_cost

# If the plan becomes invalidated during execution, it is possible to have
# that plan recomputed and execution restarted. This flag enables this
# functionality 
bool replan

# The maximum number of replanning attempts 
int32 replan_attempts

# The amount of time to wait in between replanning attempts (in seconds)
float64 replan_delay

================================================================================
MSG: moveit_msgs/PlanningScene
# name of planning scene
string name

# full robot state
RobotState robot_state

# The name of the robot model this scene is for
string robot_model_name

#additional frames for duplicating tf (with respect to the planning frame)
geometry_msgs/TransformStamped[] fixed_frame_transforms

#full allowed collision matrix
AllowedCollisionMatrix allowed_collision_matrix

# all link paddings
LinkPadding[] link_padding

# all link scales
LinkScale[] link_scale

# Attached objects, collision objects, even the octomap or collision map can have 
# colors associated to them. This array specifies them.
ObjectColor[] object_colors

# the collision map
PlanningSceneWorld world

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
bool is_diff

================================================================================
MSG: geometry_msgs/TransformStamped
# This expresses a transform from coordinate frame header.frame_id
# to the coordinate frame child_frame_id
#
# This message is mostly used by the 
# <a href=\"http://www.ros.org/wiki/tf\">tf</a> package. 
# See its documentation for more information.

Header header
string child_frame_id # the frame id of the child frame
Transform transform

================================================================================
MSG: moveit_msgs/AllowedCollisionMatrix
# The list of entry names in the matrix
string[] entry_names

# The individual entries in the allowed collision matrix
# square, symmetric, with same order as entry_names
AllowedCollisionEntry[] entry_values

# In addition to the collision matrix itself, we also have 
# the default entry value for each entry name.

# If the allowed collision flag is queried for a pair of names (n1, n2)
# that is not found in the collision matrix itself, the value of
# the collision flag is considered to be that of the entry (n1 or n2)
# specified in the list below. If both n1 and n2 are found in the list 
# of defaults, the result is computed with an AND operation

string[] default_entry_names
bool[] default_entry_values

================================================================================
MSG: moveit_msgs/AllowedCollisionEntry
# whether or not collision checking is enabled
bool[] enabled

================================================================================
MSG: moveit_msgs/LinkPadding
#name for the link
string link_name

# padding to apply to the link
float64 padding

================================================================================
MSG: moveit_msgs/LinkScale
#name for the link
string link_name

# scaling to apply to the link
float64 scale

================================================================================
MSG: moveit_msgs/ObjectColor
# The object id for which we specify color
string id

# The value of the color
std_msgs/ColorRGBA color

================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

================================================================================
MSG: moveit_msgs/PlanningSceneWorld
# collision objects
CollisionObject[] collision_objects

# The octomap that represents additional collision data
octomap_msgs/OctomapWithPose octomap

================================================================================
MSG: octomap_msgs/OctomapWithPose
# A 3D map in binary format, as Octree
Header header

# The pose of the octree with respect to the header frame 
geometry_msgs/Pose origin

# The actual octree msg
octomap_msgs/Octomap octomap

================================================================================
MSG: octomap_msgs/Octomap
# A 3D map in binary format, as Octree
Header header

# Flag to denote a binary (only free/occupied) or full occupancy octree (.bt/.ot file)
bool binary

# Class id of the contained octree 
string id

# Resolution (in m) of the smallest octree nodes
float64 resolution

# binary serialization of octree, use conversions.h to read and write octrees
int8[] data

"
  end
  attr_accessor :header, :goal_id, :goal

  @@struct_d7L3 = ::ROS::Struct.new("d7L3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_C3ldCld = ::ROS::Struct.new("C3ldCld")
  @@struct_d6L3 = ::ROS::Struct.new("d6L3")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_l = ::ROS::Struct.new("l")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_c = ::ROS::Struct.new("c")
  @@struct_f4 = ::ROS::Struct.new("f4")
  @@struct_ld = ::ROS::Struct.new("ld")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_d2Cd = ::ROS::Struct.new("d2Cd")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','actionlib_msgs/GoalID','moveit_msgs/MoveGroupGoal']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [actionlib_msgs/GoalID] :goal_id initialize value
  # @option args [moveit_msgs/MoveGroupGoal] :goal initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:goal_id]
      @goal_id = args[:goal_id]
    else
      @goal_id = Actionlib_msgs::GoalID.new
    end
    if args[:goal]
      @goal = args[:goal]
    else
      @goal = Moveit_msgs::MoveGroupGoal.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@goal_id.stamp.secs, @goal_id.stamp.nsecs))
      _x = @goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@goal.request.workspace_parameters.header.seq, @goal.request.workspace_parameters.header.stamp.secs, @goal.request.workspace_parameters.header.stamp.nsecs))
      _x = @goal.request.workspace_parameters.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d6L3.pack(@goal.request.workspace_parameters.min_corner.x, @goal.request.workspace_parameters.min_corner.y, @goal.request.workspace_parameters.min_corner.z, @goal.request.workspace_parameters.max_corner.x, @goal.request.workspace_parameters.max_corner.y, @goal.request.workspace_parameters.max_corner.z, @goal.request.start_state.joint_state.header.seq, @goal.request.start_state.joint_state.header.stamp.secs, @goal.request.start_state.joint_state.header.stamp.nsecs))
      _x = @goal.request.start_state.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.request.start_state.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.request.start_state.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @goal.request.start_state.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@goal.request.start_state.joint_state.position.pack(pattern))
      length = @goal.request.start_state.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@goal.request.start_state.joint_state.velocity.pack(pattern))
      length = @goal.request.start_state.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@goal.request.start_state.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@goal.request.start_state.multi_dof_joint_state.header.seq, @goal.request.start_state.multi_dof_joint_state.header.stamp.secs, @goal.request.start_state.multi_dof_joint_state.header.stamp.nsecs))
      _x = @goal.request.start_state.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.request.start_state.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.request.start_state.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @goal.request.start_state.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.request.start_state.multi_dof_joint_state.transforms
        _v1187 = val1.translation
        _x = _v1187
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1188 = val1.rotation
        _x = _v1188
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @goal.request.start_state.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.request.start_state.multi_dof_joint_state.twist
        _v1189 = val1.linear
        _x = _v1189
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1190 = val1.angular
        _x = _v1190
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @goal.request.start_state.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.request.start_state.multi_dof_joint_state.wrench
        _v1191 = val1.force
        _x = _v1191
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1192 = val1.torque
        _x = _v1192
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @goal.request.start_state.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.request.start_state.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1193 = val1.object
        _v1194 = _v1193.header
        buff.write(@@struct_L.pack(_v1194.seq))
        _v1195 = _v1194.stamp
        _x = _v1195
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1194.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v1193.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1196 = _v1193.type
        _x = _v1196.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v1196.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v1193.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1193.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v1193.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1193.primitive_poses
          _v1197 = val3.position
          _x = _v1197
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1198 = val3.orientation
          _x = _v1198
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v1193.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1193.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v1193.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1193.mesh_poses
          _v1199 = val3.position
          _x = _v1199
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1200 = val3.orientation
          _x = _v1200
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v1193.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1193.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v1193.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1193.plane_poses
          _v1201 = val3.position
          _x = _v1201
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1202 = val3.orientation
          _x = _v1202
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v1193.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v1203 = val1.detach_posture
        _v1204 = _v1203.header
        buff.write(@@struct_L.pack(_v1204.seq))
        _v1205 = _v1204.stamp
        _x = _v1205
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1204.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v1203.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1203.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v1203.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1203.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v1206 = val3.time_from_start
          _x = _v1206
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_C.pack(@goal.request.start_state.is_diff))
      length = @goal.request.goal_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.request.goal_constraints
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.joint_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.joint_constraints
          _x = val2.joint_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
        end
        length = val1.position_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.position_constraints
          _v1207 = val2.header
          buff.write(@@struct_L.pack(_v1207.seq))
          _v1208 = _v1207.stamp
          _x = _v1208
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1207.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1209 = val2.target_point_offset
          _x = _v1209
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1210 = val2.constraint_region
          length = _v1210.primitives.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1210.primitives
            buff.write(@@struct_C.pack(val4.type))
            length = val4.dimensions.length
            buff.write(@@struct_L.pack(length))
            pattern = "d#{length}"
            buff.write(*val4.dimensions.pack(pattern))
          end
          length = _v1210.primitive_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1210.primitive_poses
            _v1211 = val4.position
            _x = _v1211
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v1212 = val4.orientation
            _x = _v1212
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          length = _v1210.meshes.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1210.meshes
            length = val4.triangles.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.triangles
              buff.write(@@struct_L3.pack(*val5.vertex_indices))
            end
            length = val4.vertices.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.vertices
              _x = val5
              buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            end
          end
          length = _v1210.mesh_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1210.mesh_poses
            _v1213 = val4.position
            _x = _v1213
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v1214 = val4.orientation
            _x = _v1214
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          buff.write(@@struct_d.pack(val2.weight))
        end
        length = val1.orientation_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.orientation_constraints
          _v1215 = val2.header
          buff.write(@@struct_L.pack(_v1215.seq))
          _v1216 = _v1215.stamp
          _x = _v1216
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1215.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1217 = val2.orientation
          _x = _v1217
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
        end
        length = val1.visibility_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.visibility_constraints
          buff.write(@@struct_d.pack(val2.target_radius))
          _v1218 = val2.target_pose
          _v1219 = _v1218.header
          buff.write(@@struct_L.pack(_v1219.seq))
          _v1220 = _v1219.stamp
          _x = _v1220
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1219.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1221 = _v1218.pose
          _v1222 = _v1221.position
          _x = _v1222
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1223 = _v1221.orientation
          _x = _v1223
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(@@struct_l.pack(val2.cone_sides))
          _v1224 = val2.sensor_pose
          _v1225 = _v1224.header
          buff.write(@@struct_L.pack(_v1225.seq))
          _v1226 = _v1225.stamp
          _x = _v1226
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1225.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1227 = _v1224.pose
          _v1228 = _v1227.position
          _x = _v1228
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1229 = _v1227.orientation
          _x = _v1229
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2
          buff.write(@@struct_d2Cd.pack(_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight))
        end
      end
      _x = @goal.request.path_constraints.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.request.path_constraints.joint_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.request.path_constraints.joint_constraints
        _x = val1.joint_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_d4.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
      end
      length = @goal.request.path_constraints.position_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.request.path_constraints.position_constraints
        _v1230 = val1.header
        buff.write(@@struct_L.pack(_v1230.seq))
        _v1231 = _v1230.stamp
        _x = _v1231
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1230.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1232 = val1.target_point_offset
        _x = _v1232
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1233 = val1.constraint_region
        length = _v1233.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1233.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v1233.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1233.primitive_poses
          _v1234 = val3.position
          _x = _v1234
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1235 = val3.orientation
          _x = _v1235
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v1233.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1233.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v1233.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1233.mesh_poses
          _v1236 = val3.position
          _x = _v1236
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1237 = val3.orientation
          _x = _v1237
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      length = @goal.request.path_constraints.orientation_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.request.path_constraints.orientation_constraints
        _v1238 = val1.header
        buff.write(@@struct_L.pack(_v1238.seq))
        _v1239 = _v1238.stamp
        _x = _v1239
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1238.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1240 = val1.orientation
        _x = _v1240
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_d4.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
      end
      length = @goal.request.path_constraints.visibility_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.request.path_constraints.visibility_constraints
        buff.write(@@struct_d.pack(val1.target_radius))
        _v1241 = val1.target_pose
        _v1242 = _v1241.header
        buff.write(@@struct_L.pack(_v1242.seq))
        _v1243 = _v1242.stamp
        _x = _v1243
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1242.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1244 = _v1241.pose
        _v1245 = _v1244.position
        _x = _v1245
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1246 = _v1244.orientation
        _x = _v1246
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_l.pack(val1.cone_sides))
        _v1247 = val1.sensor_pose
        _v1248 = _v1247.header
        buff.write(@@struct_L.pack(_v1248.seq))
        _v1249 = _v1248.stamp
        _x = _v1249
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1248.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1250 = _v1247.pose
        _v1251 = _v1250.position
        _x = _v1251
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1252 = _v1250.orientation
        _x = _v1252
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(@@struct_d2Cd.pack(_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight))
      end
      length = @goal.request.trajectory_constraints.constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.request.trajectory_constraints.constraints
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.joint_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.joint_constraints
          _x = val2.joint_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
        end
        length = val1.position_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.position_constraints
          _v1253 = val2.header
          buff.write(@@struct_L.pack(_v1253.seq))
          _v1254 = _v1253.stamp
          _x = _v1254
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1253.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1255 = val2.target_point_offset
          _x = _v1255
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1256 = val2.constraint_region
          length = _v1256.primitives.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1256.primitives
            buff.write(@@struct_C.pack(val4.type))
            length = val4.dimensions.length
            buff.write(@@struct_L.pack(length))
            pattern = "d#{length}"
            buff.write(*val4.dimensions.pack(pattern))
          end
          length = _v1256.primitive_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1256.primitive_poses
            _v1257 = val4.position
            _x = _v1257
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v1258 = val4.orientation
            _x = _v1258
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          length = _v1256.meshes.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1256.meshes
            length = val4.triangles.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.triangles
              buff.write(@@struct_L3.pack(*val5.vertex_indices))
            end
            length = val4.vertices.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.vertices
              _x = val5
              buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            end
          end
          length = _v1256.mesh_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1256.mesh_poses
            _v1259 = val4.position
            _x = _v1259
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v1260 = val4.orientation
            _x = _v1260
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          buff.write(@@struct_d.pack(val2.weight))
        end
        length = val1.orientation_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.orientation_constraints
          _v1261 = val2.header
          buff.write(@@struct_L.pack(_v1261.seq))
          _v1262 = _v1261.stamp
          _x = _v1262
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1261.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1263 = val2.orientation
          _x = _v1263
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
        end
        length = val1.visibility_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.visibility_constraints
          buff.write(@@struct_d.pack(val2.target_radius))
          _v1264 = val2.target_pose
          _v1265 = _v1264.header
          buff.write(@@struct_L.pack(_v1265.seq))
          _v1266 = _v1265.stamp
          _x = _v1266
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1265.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1267 = _v1264.pose
          _v1268 = _v1267.position
          _x = _v1268
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1269 = _v1267.orientation
          _x = _v1269
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(@@struct_l.pack(val2.cone_sides))
          _v1270 = val2.sensor_pose
          _v1271 = _v1270.header
          buff.write(@@struct_L.pack(_v1271.seq))
          _v1272 = _v1271.stamp
          _x = _v1272
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1271.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1273 = _v1270.pose
          _v1274 = _v1273.position
          _x = _v1274
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1275 = _v1273.orientation
          _x = _v1275
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2
          buff.write(@@struct_d2Cd.pack(_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight))
        end
      end
      _x = @goal.request.planner_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @goal.request.group_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_ld.pack(@goal.request.num_planning_attempts, @goal.request.allowed_planning_time))
      _x = @goal.planning_options.planning_scene_diff.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@goal.planning_options.planning_scene_diff.robot_state.joint_state.header.seq, @goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.secs, @goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.nsecs))
      _x = @goal.planning_options.planning_scene_diff.robot_state.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.planning_options.planning_scene_diff.robot_state.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.robot_state.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @goal.planning_options.planning_scene_diff.robot_state.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@goal.planning_options.planning_scene_diff.robot_state.joint_state.position.pack(pattern))
      length = @goal.planning_options.planning_scene_diff.robot_state.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@goal.planning_options.planning_scene_diff.robot_state.joint_state.velocity.pack(pattern))
      length = @goal.planning_options.planning_scene_diff.robot_state.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@goal.planning_options.planning_scene_diff.robot_state.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.seq, @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.secs, @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.nsecs))
      _x = @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms
        _v1276 = val1.translation
        _x = _v1276
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1277 = val1.rotation
        _x = _v1277
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist
        _v1278 = val1.linear
        _x = _v1278
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1279 = val1.angular
        _x = _v1279
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench
        _v1280 = val1.force
        _x = _v1280
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1281 = val1.torque
        _x = _v1281
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1282 = val1.object
        _v1283 = _v1282.header
        buff.write(@@struct_L.pack(_v1283.seq))
        _v1284 = _v1283.stamp
        _x = _v1284
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1283.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v1282.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1285 = _v1282.type
        _x = _v1285.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v1285.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v1282.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1282.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v1282.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1282.primitive_poses
          _v1286 = val3.position
          _x = _v1286
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1287 = val3.orientation
          _x = _v1287
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v1282.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1282.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v1282.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1282.mesh_poses
          _v1288 = val3.position
          _x = _v1288
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1289 = val3.orientation
          _x = _v1289
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v1282.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1282.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v1282.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1282.plane_poses
          _v1290 = val3.position
          _x = _v1290
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1291 = val3.orientation
          _x = _v1291
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v1282.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v1292 = val1.detach_posture
        _v1293 = _v1292.header
        buff.write(@@struct_L.pack(_v1293.seq))
        _v1294 = _v1293.stamp
        _x = _v1294
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1293.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v1292.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1292.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v1292.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1292.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v1295 = val3.time_from_start
          _x = _v1295
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_C.pack(@goal.planning_options.planning_scene_diff.robot_state.is_diff))
      _x = @goal.planning_options.planning_scene_diff.robot_model_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.planning_options.planning_scene_diff.fixed_frame_transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.fixed_frame_transforms
        _v1296 = val1.header
        buff.write(@@struct_L.pack(_v1296.seq))
        _v1297 = _v1296.stamp
        _x = _v1297
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1296.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.child_frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1298 = val1.transform
        _v1299 = _v1298.translation
        _x = _v1299
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1300 = _v1298.rotation
        _x = _v1300
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values
        length = val1.enabled.length
        buff.write(@@struct_L.pack(length))
        pattern = "C#{length}"
        buff.write(*val1.enabled.pack(pattern))
      end
      length = @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values.length
      buff.write(@@struct_L.pack(length))
      pattern = "C#{length}"
      buff.write(*@goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values.pack(pattern))
      length = @goal.planning_options.planning_scene_diff.link_padding.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.link_padding
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_d.pack(val1.padding))
      end
      length = @goal.planning_options.planning_scene_diff.link_scale.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.link_scale
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_d.pack(val1.scale))
      end
      length = @goal.planning_options.planning_scene_diff.object_colors.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.object_colors
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1301 = val1.color
        _x = _v1301
        buff.write(@@struct_f4.pack(_x.r, _x.g, _x.b, _x.a))
      end
      length = @goal.planning_options.planning_scene_diff.world.collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.world.collision_objects
        _v1302 = val1.header
        buff.write(@@struct_L.pack(_v1302.seq))
        _v1303 = _v1302.stamp
        _x = _v1303
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1302.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1304 = val1.type
        _x = _v1304.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v1304.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.primitives.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.primitives
          buff.write(@@struct_C.pack(val2.type))
          length = val2.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val2.dimensions.pack(pattern))
        end
        length = val1.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.primitive_poses
          _v1305 = val2.position
          _x = _v1305
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1306 = val2.orientation
          _x = _v1306
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.meshes.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.meshes
          length = val2.triangles.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.triangles
            buff.write(@@struct_L3.pack(*val3.vertex_indices))
          end
          length = val2.vertices.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.vertices
            _x = val3
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = val1.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.mesh_poses
          _v1307 = val2.position
          _x = _v1307
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1308 = val2.orientation
          _x = _v1308
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.planes.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.planes
          buff.write(@@struct_d4.pack(*val2.coef))
        end
        length = val1.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.plane_poses
          _v1309 = val2.position
          _x = _v1309
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1310 = val2.orientation
          _x = _v1310
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(val1.operation))
      end
      buff.write(@@struct_L3.pack(@goal.planning_options.planning_scene_diff.world.octomap.header.seq, @goal.planning_options.planning_scene_diff.world.octomap.header.stamp.secs, @goal.planning_options.planning_scene_diff.world.octomap.header.stamp.nsecs))
      _x = @goal.planning_options.planning_scene_diff.world.octomap.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7L3.pack(@goal.planning_options.planning_scene_diff.world.octomap.origin.position.x, @goal.planning_options.planning_scene_diff.world.octomap.origin.position.y, @goal.planning_options.planning_scene_diff.world.octomap.origin.position.z, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.x, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.y, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.z, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.w, @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.seq, @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.secs, @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.nsecs))
      _x = @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@goal.planning_options.planning_scene_diff.world.octomap.octomap.binary))
      _x = @goal.planning_options.planning_scene_diff.world.octomap.octomap.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d.pack(@goal.planning_options.planning_scene_diff.world.octomap.octomap.resolution))
      length = @goal.planning_options.planning_scene_diff.world.octomap.octomap.data.length
      buff.write(@@struct_L.pack(length))
      pattern = "c#{length}"
      buff.write(*@goal.planning_options.planning_scene_diff.world.octomap.octomap.data.pack(pattern))
      buff.write(@@struct_C3ldCld.pack(@goal.planning_options.planning_scene_diff.is_diff, @goal.planning_options.plan_only, @goal.planning_options.look_around, @goal.planning_options.look_around_attempts, @goal.planning_options.max_safe_execution_cost, @goal.planning_options.replan, @goal.planning_options.replan_attempts, @goal.planning_options.replan_delay))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @goal_id == nil
        @goal_id = Actionlib_msgs::GoalID.new
      end
      if @goal == nil
        @goal = Moveit_msgs::MoveGroupGoal.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@goal_id.stamp.secs, @goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@goal.request.workspace_parameters.header.seq, @goal.request.workspace_parameters.header.stamp.secs, @goal.request.workspace_parameters.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.request.workspace_parameters.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d6L3')
      (@goal.request.workspace_parameters.min_corner.x, @goal.request.workspace_parameters.min_corner.y, @goal.request.workspace_parameters.min_corner.z, @goal.request.workspace_parameters.max_corner.x, @goal.request.workspace_parameters.max_corner.y, @goal.request.workspace_parameters.max_corner.z, @goal.request.start_state.joint_state.header.seq, @goal.request.start_state.joint_state.header.stamp.secs, @goal.request.start_state.joint_state.header.stamp.nsecs,) = @@struct_d6L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.request.start_state.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.request.start_state.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @goal.request.start_state.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.request.start_state.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.request.start_state.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.request.start_state.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@goal.request.start_state.multi_dof_joint_state.header.seq, @goal.request.start_state.multi_dof_joint_state.header.stamp.secs, @goal.request.start_state.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.request.start_state.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.request.start_state.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @goal.request.start_state.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.request.start_state.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v1311 = val1.translation
        _x = _v1311
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1312 = val1.rotation
        _x = _v1312
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @goal.request.start_state.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.request.start_state.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v1313 = val1.linear
        _x = _v1313
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1314 = val1.angular
        _x = _v1314
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @goal.request.start_state.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.request.start_state.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v1315 = val1.force
        _x = _v1315
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1316 = val1.torque
        _x = _v1316
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @goal.request.start_state.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.request.start_state.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v1317 = val1.object
        _v1318 = _v1317.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1318.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1319 = _v1318.stamp
        _x = _v1319
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1318.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1317.id = str[start..(end_point-1)]
        _v1320 = _v1317.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1320.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1320.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1317.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v1317.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1317.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1321 = val3.position
          _x = _v1321
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1322 = val3.orientation
          _x = _v1322
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1317.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1317.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v1317.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1317.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1323 = val3.position
          _x = _v1323
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1324 = val3.orientation
          _x = _v1324
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1317.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1317.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1317.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1317.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1325 = val3.position
          _x = _v1325
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1326 = val3.orientation
          _x = _v1326
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1317.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v1317.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v1327 = val1.detach_posture
        _v1328 = _v1327.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1328.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1329 = _v1328.stamp
        _x = _v1329
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1328.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1327.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v1327.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1327.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v1330 = val3.time_from_start
          _x = _v1330
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v1327.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @goal.request.start_state.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@goal.request.start_state.is_diff,) = @@struct_C.unpack(str[start..(end_point-1)])
      @goal.request.start_state.is_diff = bool(@goal.request.start_state.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.request.goal_constraints = []
      length.times do
        val1 = Moveit_msgs::Constraints.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.joint_constraints = []
        length.times do
          val2 = Moveit_msgs::JointConstraint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.joint_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.joint_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.position_constraints = []
        length.times do
          val2 = Moveit_msgs::PositionConstraint.new
          _v1331 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1331.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1332 = _v1331.stamp
          _x = _v1332
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1331.frame_id = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _v1333 = val2.target_point_offset
          _x = _v1333
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1334 = val2.constraint_region
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1334.primitives = []
          length.times do
            val4 = Shape_msgs::SolidPrimitive.new
            start = end_point
            end_point += ROS::Struct::calc_size('C')
            (val4.type,) = @@struct_C.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            pattern = "d#{length}"
            start = end_point
            end_point += ROS::Struct::calc_size("#{pattern}")
            val4.dimensions = str[start..(end_point-1)].unpack(pattern)
            _v1334.primitives.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1334.primitive_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v1335 = val4.position
            _x = _v1335
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v1336 = val4.orientation
            _x = _v1336
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v1334.primitive_poses.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1334.meshes = []
          length.times do
            val4 = Shape_msgs::Mesh.new
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.triangles = []
            length.times do
              val5 = Shape_msgs::MeshTriangle.new
              start = end_point
              end_point += ROS::Struct::calc_size('L3')
              val5.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
              val4.triangles.push(val5)
            end
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.vertices = []
            length.times do
              val5 = Geometry_msgs::Point.new
              _x = val5
              start = end_point
              end_point += ROS::Struct::calc_size('d3')
              (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
              val4.vertices.push(val5)
            end
            _v1334.meshes.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1334.mesh_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v1337 = val4.position
            _x = _v1337
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v1338 = val4.orientation
            _x = _v1338
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v1334.mesh_poses.push(val4)
          end
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
          val1.position_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.orientation_constraints = []
        length.times do
          val2 = Moveit_msgs::OrientationConstraint.new
          _v1339 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1339.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1340 = _v1339.stamp
          _x = _v1340
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1339.frame_id = str[start..(end_point-1)]
          _v1341 = val2.orientation
          _x = _v1341
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.orientation_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.visibility_constraints = []
        length.times do
          val2 = Moveit_msgs::VisibilityConstraint.new
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.target_radius,) = @@struct_d.unpack(str[start..(end_point-1)])
          _v1342 = val2.target_pose
          _v1343 = _v1342.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1343.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1344 = _v1343.stamp
          _x = _v1344
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1343.frame_id = str[start..(end_point-1)]
          _v1345 = _v1342.pose
          _v1346 = _v1345.position
          _x = _v1346
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1347 = _v1345.orientation
          _x = _v1347
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += ROS::Struct::calc_size('l')
          (val2.cone_sides,) = @@struct_l.unpack(str[start..(end_point-1)])
          _v1348 = val2.sensor_pose
          _v1349 = _v1348.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1349.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1350 = _v1349.stamp
          _x = _v1350
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1349.frame_id = str[start..(end_point-1)]
          _v1351 = _v1348.pose
          _v1352 = _v1351.position
          _x = _v1352
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1353 = _v1351.orientation
          _x = _v1353
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d2Cd')
          (_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight,) = @@struct_d2Cd.unpack(str[start..(end_point-1)])
          val1.visibility_constraints.push(val2)
        end
        @goal.request.goal_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.request.path_constraints.name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.request.path_constraints.joint_constraints = []
      length.times do
        val1 = Moveit_msgs::JointConstraint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.joint_name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @goal.request.path_constraints.joint_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.request.path_constraints.position_constraints = []
      length.times do
        val1 = Moveit_msgs::PositionConstraint.new
        _v1354 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1354.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1355 = _v1354.stamp
        _x = _v1355
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1354.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v1356 = val1.target_point_offset
        _x = _v1356
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1357 = val1.constraint_region
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1357.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v1357.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1357.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1358 = val3.position
          _x = _v1358
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1359 = val3.orientation
          _x = _v1359
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1357.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1357.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v1357.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1357.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1360 = val3.position
          _x = _v1360
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1361 = val3.orientation
          _x = _v1361
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1357.mesh_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @goal.request.path_constraints.position_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.request.path_constraints.orientation_constraints = []
      length.times do
        val1 = Moveit_msgs::OrientationConstraint.new
        _v1362 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1362.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1363 = _v1362.stamp
        _x = _v1363
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1362.frame_id = str[start..(end_point-1)]
        _v1364 = val1.orientation
        _x = _v1364
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @goal.request.path_constraints.orientation_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.request.path_constraints.visibility_constraints = []
      length.times do
        val1 = Moveit_msgs::VisibilityConstraint.new
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.target_radius,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v1365 = val1.target_pose
        _v1366 = _v1365.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1366.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1367 = _v1366.stamp
        _x = _v1367
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1366.frame_id = str[start..(end_point-1)]
        _v1368 = _v1365.pose
        _v1369 = _v1368.position
        _x = _v1369
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1370 = _v1368.orientation
        _x = _v1370
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('l')
        (val1.cone_sides,) = @@struct_l.unpack(str[start..(end_point-1)])
        _v1371 = val1.sensor_pose
        _v1372 = _v1371.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1372.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1373 = _v1372.stamp
        _x = _v1373
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1372.frame_id = str[start..(end_point-1)]
        _v1374 = _v1371.pose
        _v1375 = _v1374.position
        _x = _v1375
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1376 = _v1374.orientation
        _x = _v1376
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d2Cd')
        (_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight,) = @@struct_d2Cd.unpack(str[start..(end_point-1)])
        @goal.request.path_constraints.visibility_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.request.trajectory_constraints.constraints = []
      length.times do
        val1 = Moveit_msgs::Constraints.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.joint_constraints = []
        length.times do
          val2 = Moveit_msgs::JointConstraint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.joint_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.joint_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.position_constraints = []
        length.times do
          val2 = Moveit_msgs::PositionConstraint.new
          _v1377 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1377.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1378 = _v1377.stamp
          _x = _v1378
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1377.frame_id = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _v1379 = val2.target_point_offset
          _x = _v1379
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1380 = val2.constraint_region
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1380.primitives = []
          length.times do
            val4 = Shape_msgs::SolidPrimitive.new
            start = end_point
            end_point += ROS::Struct::calc_size('C')
            (val4.type,) = @@struct_C.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            pattern = "d#{length}"
            start = end_point
            end_point += ROS::Struct::calc_size("#{pattern}")
            val4.dimensions = str[start..(end_point-1)].unpack(pattern)
            _v1380.primitives.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1380.primitive_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v1381 = val4.position
            _x = _v1381
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v1382 = val4.orientation
            _x = _v1382
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v1380.primitive_poses.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1380.meshes = []
          length.times do
            val4 = Shape_msgs::Mesh.new
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.triangles = []
            length.times do
              val5 = Shape_msgs::MeshTriangle.new
              start = end_point
              end_point += ROS::Struct::calc_size('L3')
              val5.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
              val4.triangles.push(val5)
            end
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.vertices = []
            length.times do
              val5 = Geometry_msgs::Point.new
              _x = val5
              start = end_point
              end_point += ROS::Struct::calc_size('d3')
              (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
              val4.vertices.push(val5)
            end
            _v1380.meshes.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1380.mesh_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v1383 = val4.position
            _x = _v1383
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v1384 = val4.orientation
            _x = _v1384
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v1380.mesh_poses.push(val4)
          end
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
          val1.position_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.orientation_constraints = []
        length.times do
          val2 = Moveit_msgs::OrientationConstraint.new
          _v1385 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1385.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1386 = _v1385.stamp
          _x = _v1386
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1385.frame_id = str[start..(end_point-1)]
          _v1387 = val2.orientation
          _x = _v1387
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.orientation_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.visibility_constraints = []
        length.times do
          val2 = Moveit_msgs::VisibilityConstraint.new
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.target_radius,) = @@struct_d.unpack(str[start..(end_point-1)])
          _v1388 = val2.target_pose
          _v1389 = _v1388.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1389.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1390 = _v1389.stamp
          _x = _v1390
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1389.frame_id = str[start..(end_point-1)]
          _v1391 = _v1388.pose
          _v1392 = _v1391.position
          _x = _v1392
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1393 = _v1391.orientation
          _x = _v1393
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += ROS::Struct::calc_size('l')
          (val2.cone_sides,) = @@struct_l.unpack(str[start..(end_point-1)])
          _v1394 = val2.sensor_pose
          _v1395 = _v1394.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1395.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1396 = _v1395.stamp
          _x = _v1396
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1395.frame_id = str[start..(end_point-1)]
          _v1397 = _v1394.pose
          _v1398 = _v1397.position
          _x = _v1398
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1399 = _v1397.orientation
          _x = _v1399
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d2Cd')
          (_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight,) = @@struct_d2Cd.unpack(str[start..(end_point-1)])
          val1.visibility_constraints.push(val2)
        end
        @goal.request.trajectory_constraints.constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.request.planner_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.request.group_name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('ld')
      (@goal.request.num_planning_attempts, @goal.request.allowed_planning_time,) = @@struct_ld.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planning_options.planning_scene_diff.name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@goal.planning_options.planning_scene_diff.robot_state.joint_state.header.seq, @goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.secs, @goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planning_options.planning_scene_diff.robot_state.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.robot_state.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @goal.planning_options.planning_scene_diff.robot_state.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.planning_options.planning_scene_diff.robot_state.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.planning_options.planning_scene_diff.robot_state.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.planning_options.planning_scene_diff.robot_state.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.seq, @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.secs, @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v1400 = val1.translation
        _x = _v1400
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1401 = val1.rotation
        _x = _v1401
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v1402 = val1.linear
        _x = _v1402
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1403 = val1.angular
        _x = _v1403
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v1404 = val1.force
        _x = _v1404
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1405 = val1.torque
        _x = _v1405
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v1406 = val1.object
        _v1407 = _v1406.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1407.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1408 = _v1407.stamp
        _x = _v1408
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1407.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1406.id = str[start..(end_point-1)]
        _v1409 = _v1406.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1409.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1409.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1406.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v1406.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1406.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1410 = val3.position
          _x = _v1410
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1411 = val3.orientation
          _x = _v1411
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1406.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1406.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v1406.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1406.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1412 = val3.position
          _x = _v1412
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1413 = val3.orientation
          _x = _v1413
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1406.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1406.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1406.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1406.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1414 = val3.position
          _x = _v1414
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1415 = val3.orientation
          _x = _v1415
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1406.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v1406.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v1416 = val1.detach_posture
        _v1417 = _v1416.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1417.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1418 = _v1417.stamp
        _x = _v1418
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1417.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1416.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v1416.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1416.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v1419 = val3.time_from_start
          _x = _v1419
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v1416.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@goal.planning_options.planning_scene_diff.robot_state.is_diff,) = @@struct_C.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.robot_state.is_diff = bool(@goal.planning_options.planning_scene_diff.robot_state.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planning_options.planning_scene_diff.robot_model_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.fixed_frame_transforms = []
      length.times do
        val1 = Geometry_msgs::TransformStamped.new
        _v1420 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1420.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1421 = _v1420.stamp
        _x = _v1421
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1420.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.child_frame_id = str[start..(end_point-1)]
        _v1422 = val1.transform
        _v1423 = _v1422.translation
        _x = _v1423
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1424 = _v1422.rotation
        _x = _v1424
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.fixed_frame_transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values = []
      length.times do
        val1 = Moveit_msgs::AllowedCollisionEntry.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "C#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.enabled = str[start..(end_point-1)].unpack(pattern)
        val1.enabled = map(bool, val1.enabled)
        @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "C#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values = str[start..(end_point-1)].unpack(pattern)
      @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values = map(bool, @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.link_padding = []
      length.times do
        val1 = Moveit_msgs::LinkPadding.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.padding,) = @@struct_d.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.link_padding.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.link_scale = []
      length.times do
        val1 = Moveit_msgs::LinkScale.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.scale,) = @@struct_d.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.link_scale.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.object_colors = []
      length.times do
        val1 = Moveit_msgs::ObjectColor.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v1425 = val1.color
        _x = _v1425
        start = end_point
        end_point += ROS::Struct::calc_size('f4')
        (_x.r, _x.g, _x.b, _x.a,) = @@struct_f4.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.object_colors.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.world.collision_objects = []
      length.times do
        val1 = Moveit_msgs::CollisionObject.new
        _v1426 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1426.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1427 = _v1426.stamp
        _x = _v1427
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1426.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v1428 = val1.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1428.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1428.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.primitives = []
        length.times do
          val2 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val2.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val2.dimensions = str[start..(end_point-1)].unpack(pattern)
          val1.primitives.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.primitive_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v1429 = val2.position
          _x = _v1429
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1430 = val2.orientation
          _x = _v1430
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.primitive_poses.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.meshes = []
        length.times do
          val2 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.triangles = []
          length.times do
            val3 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val3.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val2.triangles.push(val3)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.vertices = []
          length.times do
            val3 = Geometry_msgs::Point.new
            _x = val3
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val2.vertices.push(val3)
          end
          val1.meshes.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.mesh_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v1431 = val2.position
          _x = _v1431
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1432 = val2.orientation
          _x = _v1432
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.mesh_poses.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.planes = []
        length.times do
          val2 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val2.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.planes.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.plane_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v1433 = val2.position
          _x = _v1433
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1434 = val2.orientation
          _x = _v1434
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.plane_poses.push(val2)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (val1.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.world.collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@goal.planning_options.planning_scene_diff.world.octomap.header.seq, @goal.planning_options.planning_scene_diff.world.octomap.header.stamp.secs, @goal.planning_options.planning_scene_diff.world.octomap.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planning_options.planning_scene_diff.world.octomap.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7L3')
      (@goal.planning_options.planning_scene_diff.world.octomap.origin.position.x, @goal.planning_options.planning_scene_diff.world.octomap.origin.position.y, @goal.planning_options.planning_scene_diff.world.octomap.origin.position.z, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.x, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.y, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.z, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.w, @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.seq, @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.secs, @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.nsecs,) = @@struct_d7L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@goal.planning_options.planning_scene_diff.world.octomap.octomap.binary,) = @@struct_C.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.world.octomap.octomap.binary = bool(@goal.planning_options.planning_scene_diff.world.octomap.octomap.binary)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planning_options.planning_scene_diff.world.octomap.octomap.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d')
      (@goal.planning_options.planning_scene_diff.world.octomap.octomap.resolution,) = @@struct_d.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "c#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.planning_options.planning_scene_diff.world.octomap.octomap.data = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('C3ldCld')
      (@goal.planning_options.planning_scene_diff.is_diff, @goal.planning_options.plan_only, @goal.planning_options.look_around, @goal.planning_options.look_around_attempts, @goal.planning_options.max_safe_execution_cost, @goal.planning_options.replan, @goal.planning_options.replan_attempts, @goal.planning_options.replan_delay,) = @@struct_C3ldCld.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.is_diff = bool(@goal.planning_options.planning_scene_diff.is_diff)
      @goal.planning_options.plan_only = bool(@goal.planning_options.plan_only)
      @goal.planning_options.look_around = bool(@goal.planning_options.look_around)
      @goal.planning_options.replan = bool(@goal.planning_options.replan)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
