# autogenerated by genrb from MoveGroupActionResult.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "geometry_msgs/Transform"
require "geometry_msgs/Point"
require "geometry_msgs/Twist"
require "shape_msgs/Mesh"
require "trajectory_msgs/MultiDOFJointTrajectory"
require "actionlib_msgs/GoalStatus"
require "moveit_msgs/RobotTrajectory"
require "shape_msgs/Plane"
require "moveit_msgs/MoveItErrorCodes"
require "ros/duration"
require "std_msgs/Header"
require "sensor_msgs/MultiDOFJointState"
require "geometry_msgs/Pose"
require "shape_msgs/MeshTriangle"
require "shape_msgs/SolidPrimitive"
require "geometry_msgs/Wrench"
require "moveit_msgs/MoveGroupResult"
require "trajectory_msgs/MultiDOFJointTrajectoryPoint"
require "moveit_msgs/RobotState"
require "trajectory_msgs/JointTrajectory"
require "sensor_msgs/JointState"
require "trajectory_msgs/JointTrajectoryPoint"
require "object_recognition_msgs/ObjectType"
require "actionlib_msgs/GoalID"
require "moveit_msgs/AttachedCollisionObject"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "moveit_msgs/CollisionObject"

module Moveit_msgs

class MoveGroupActionResult <::ROS::Message
  def self.md5sum
    "6ee8682a508d60603228accdc4a2b30b"
  end

  def self.type
    "moveit_msgs/MoveGroupActionResult"
  end

  def has_header?
    true
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
MoveGroupResult result

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalStatus
GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: moveit_msgs/MoveGroupResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# An error code reflecting what went wrong
MoveItErrorCodes error_code

# The full starting state of the robot at the start of the trajectory
moveit_msgs/RobotState trajectory_start

# The trajectory that moved group produced for execution
moveit_msgs/RobotTrajectory planned_trajectory

# The trace of the trajectory recorded during execution
moveit_msgs/RobotTrajectory executed_trajectory

# The amount of time it took to complete the motion plan
float64 planning_time


================================================================================
MSG: moveit_msgs/MoveItErrorCodes
int32 val

# overall behavior
int32 SUCCESS=1
int32 FAILURE=99999

int32 PLANNING_FAILED=-1
int32 INVALID_MOTION_PLAN=-2
int32 MOTION_PLAN_INVALIDATED_BY_ENVIRONMENT_CHANGE=-3
int32 CONTROL_FAILED=-4
int32 UNABLE_TO_AQUIRE_SENSOR_DATA=-5
int32 TIMED_OUT=-6
int32 PREEMPTED=-7

# planning & kinematics request errors
int32 START_STATE_IN_COLLISION=-10
int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-11

int32 GOAL_IN_COLLISION=-12
int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-13
int32 GOAL_CONSTRAINTS_VIOLATED=-14

int32 INVALID_GROUP_NAME=-15
int32 INVALID_GOAL_CONSTRAINTS=-16
int32 INVALID_ROBOT_STATE=-17
int32 INVALID_LINK_NAME=-18
int32 INVALID_OBJECT_NAME=-19

# system errors
int32 FRAME_TRANSFORM_FAILURE=-21
int32 COLLISION_CHECKING_UNAVAILABLE=-22
int32 ROBOT_STATE_STALE=-23
int32 SENSOR_INFO_STALE=-24

# kinematics errors
int32 NO_IK_SOLUTION=-31

================================================================================
MSG: moveit_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state

# Joints that may have multiple DOF are specified here
sensor_msgs/MultiDOFJointState multi_dof_joint_state

# Attached collision objects (attached to some link on the robot)
AttachedCollisionObject[] attached_collision_objects

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
# This is mostly important for handling the attached bodies (whether or not to clear the attached bodies
# of a moveit::core::RobotState before updating it with this message)
bool is_diff

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: sensor_msgs/MultiDOFJointState
# Representation of state for joints with multiple degrees of freedom, 
# following the structure of JointState.
#
# It is assumed that a joint in a system corresponds to a transform that gets applied 
# along the kinematic chain. For example, a planar joint (as in URDF) is 3DOF (x, y, yaw)
# and those 3DOF can be expressed as a transformation matrix, and that transformation
# matrix can be converted back to (x, y, yaw)
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# wrench associated with them, you can leave the wrench array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

Header header

string[] joint_names
geometry_msgs/Transform[] transforms
geometry_msgs/Twist[] twist
geometry_msgs/Wrench[] wrench

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: moveit_msgs/AttachedCollisionObject
# The CollisionObject will be attached with a fixed joint to this link
string link_name

#This contains the actual shapes and poses for the CollisionObject
#to be attached to the link
#If action is remove and no object.id is set, all objects
#attached to the link indicated by link_name will be removed
CollisionObject object

# The set of links that the attached objects are allowed to touch
# by default - the link_name is already considered by default
string[] touch_links

# If certain links were placed in a particular posture for this object to remain attached 
# (e.g., an end effector closing around an object), the posture necessary for releasing
# the object is stored here
trajectory_msgs/JointTrajectory detach_posture

# The weight of the attached object, if known
float64 weight

================================================================================
MSG: moveit_msgs/CollisionObject
# a header, used for interpreting the poses
Header header

# the id of the object (name used in MoveIt)
string id

# The object type in a database of known objects
object_recognition_msgs/ObjectType type

# the the collision geometries associated with the object;
# their poses are with respect to the specified header

# solid geometric primitives
shape_msgs/SolidPrimitive[] primitives
geometry_msgs/Pose[] primitive_poses

# meshes
shape_msgs/Mesh[] meshes
geometry_msgs/Pose[] mesh_poses

# bounding planes (equation is specified, but the plane can be oriented using an additional pose)
shape_msgs/Plane[] planes
geometry_msgs/Pose[] plane_poses

# Adds the object to the planning scene. If the object previously existed, it is replaced.
byte ADD=0

# Removes the object from the environment entirely (everything that matches the specified id)
byte REMOVE=1

# Append to an object that already exists in the planning scene. If the does not exist, it is added.
byte APPEND=2

# If an object already exists in the scene, new poses can be sent (the geometry arrays must be left empty)
# if solely moving the object is desired
byte MOVE=3

# Operation to be performed
byte operation

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: shape_msgs/SolidPrimitive
# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: shape_msgs/Plane
# Representation of a plane, using the plane equation ax + by + cz + d = 0

# a := coef[0]
# b := coef[1]
# c := coef[2]
# d := coef[3]

float64[4] coef

================================================================================
MSG: trajectory_msgs/JointTrajectory
Header header
string[] joint_names
JointTrajectoryPoint[] points
================================================================================
MSG: trajectory_msgs/JointTrajectoryPoint
# Each trajectory point specifies either positions[, velocities[, accelerations]]
# or positions[, effort] for the trajectory to be executed.
# All specified values are in the same order as the joint names in JointTrajectory.msg

float64[] positions
float64[] velocities
float64[] accelerations
float64[] effort
duration time_from_start

================================================================================
MSG: moveit_msgs/RobotTrajectory
trajectory_msgs/JointTrajectory joint_trajectory
trajectory_msgs/MultiDOFJointTrajectory multi_dof_joint_trajectory

================================================================================
MSG: trajectory_msgs/MultiDOFJointTrajectory
# The header is used to specify the coordinate frame and the reference time for the trajectory durations
Header header

# A representation of a multi-dof joint trajectory (each point is a transformation)
# Each point along the trajectory will include an array of positions/velocities/accelerations
# that has the same length as the array of joint names, and has the same order of joints as 
# the joint names array.

string[] joint_names
MultiDOFJointTrajectoryPoint[] points

================================================================================
MSG: trajectory_msgs/MultiDOFJointTrajectoryPoint
# Each multi-dof joint can specify a transform (up to 6 DOF)
geometry_msgs/Transform[] transforms

# There can be a velocity specified for the origin of the joint 
geometry_msgs/Twist[] velocities

# There can be an acceleration specified for the origin of the joint 
geometry_msgs/Twist[] accelerations

duration time_from_start

"
  end
  attr_accessor :header, :status, :result

  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_lL3 = ::ROS::Struct.new("lL3")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_c = ::ROS::Struct.new("c")
  @@struct_CL3 = ::ROS::Struct.new("CL3")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','actionlib_msgs/GoalStatus','moveit_msgs/MoveGroupResult']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [actionlib_msgs/GoalStatus] :status initialize value
  # @option args [moveit_msgs/MoveGroupResult] :result initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:status]
      @status = args[:status]
    else
      @status = Actionlib_msgs::GoalStatus.new
    end
    if args[:result]
      @result = args[:result]
    else
      @result = Moveit_msgs::MoveGroupResult.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@status.goal_id.stamp.secs, @status.goal_id.stamp.nsecs))
      _x = @status.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@status.status))
      _x = @status.text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_lL3.pack(@result.error_code.val, @result.trajectory_start.joint_state.header.seq, @result.trajectory_start.joint_state.header.stamp.secs, @result.trajectory_start.joint_state.header.stamp.nsecs))
      _x = @result.trajectory_start.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @result.trajectory_start.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.trajectory_start.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @result.trajectory_start.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@result.trajectory_start.joint_state.position.pack(pattern))
      length = @result.trajectory_start.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@result.trajectory_start.joint_state.velocity.pack(pattern))
      length = @result.trajectory_start.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@result.trajectory_start.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@result.trajectory_start.multi_dof_joint_state.header.seq, @result.trajectory_start.multi_dof_joint_state.header.stamp.secs, @result.trajectory_start.multi_dof_joint_state.header.stamp.nsecs))
      _x = @result.trajectory_start.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @result.trajectory_start.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.trajectory_start.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @result.trajectory_start.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.trajectory_start.multi_dof_joint_state.transforms
        _v1435 = val1.translation
        _x = _v1435
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1436 = val1.rotation
        _x = _v1436
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @result.trajectory_start.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.trajectory_start.multi_dof_joint_state.twist
        _v1437 = val1.linear
        _x = _v1437
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1438 = val1.angular
        _x = _v1438
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @result.trajectory_start.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.trajectory_start.multi_dof_joint_state.wrench
        _v1439 = val1.force
        _x = _v1439
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1440 = val1.torque
        _x = _v1440
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @result.trajectory_start.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.trajectory_start.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1441 = val1.object
        _v1442 = _v1441.header
        buff.write(@@struct_L.pack(_v1442.seq))
        _v1443 = _v1442.stamp
        _x = _v1443
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1442.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v1441.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1444 = _v1441.type
        _x = _v1444.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v1444.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v1441.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1441.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v1441.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1441.primitive_poses
          _v1445 = val3.position
          _x = _v1445
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1446 = val3.orientation
          _x = _v1446
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v1441.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1441.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v1441.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1441.mesh_poses
          _v1447 = val3.position
          _x = _v1447
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1448 = val3.orientation
          _x = _v1448
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v1441.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1441.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v1441.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1441.plane_poses
          _v1449 = val3.position
          _x = _v1449
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1450 = val3.orientation
          _x = _v1450
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v1441.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v1451 = val1.detach_posture
        _v1452 = _v1451.header
        buff.write(@@struct_L.pack(_v1452.seq))
        _v1453 = _v1452.stamp
        _x = _v1453
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1452.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v1451.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1451.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v1451.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1451.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v1454 = val3.time_from_start
          _x = _v1454
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_CL3.pack(@result.trajectory_start.is_diff, @result.planned_trajectory.joint_trajectory.header.seq, @result.planned_trajectory.joint_trajectory.header.stamp.secs, @result.planned_trajectory.joint_trajectory.header.stamp.nsecs))
      _x = @result.planned_trajectory.joint_trajectory.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @result.planned_trajectory.joint_trajectory.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.planned_trajectory.joint_trajectory.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @result.planned_trajectory.joint_trajectory.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.planned_trajectory.joint_trajectory.points
        length = val1.positions.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.positions.pack(pattern))
        length = val1.velocities.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.velocities.pack(pattern))
        length = val1.accelerations.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.accelerations.pack(pattern))
        length = val1.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.effort.pack(pattern))
        _v1455 = val1.time_from_start
        _x = _v1455
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_L3.pack(@result.planned_trajectory.multi_dof_joint_trajectory.header.seq, @result.planned_trajectory.multi_dof_joint_trajectory.header.stamp.secs, @result.planned_trajectory.multi_dof_joint_trajectory.header.stamp.nsecs))
      _x = @result.planned_trajectory.multi_dof_joint_trajectory.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @result.planned_trajectory.multi_dof_joint_trajectory.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.planned_trajectory.multi_dof_joint_trajectory.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @result.planned_trajectory.multi_dof_joint_trajectory.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.planned_trajectory.multi_dof_joint_trajectory.points
        length = val1.transforms.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.transforms
          _v1456 = val2.translation
          _x = _v1456
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1457 = val2.rotation
          _x = _v1457
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.velocities.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.velocities
          _v1458 = val2.linear
          _x = _v1458
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1459 = val2.angular
          _x = _v1459
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        length = val1.accelerations.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.accelerations
          _v1460 = val2.linear
          _x = _v1460
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1461 = val2.angular
          _x = _v1461
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        _v1462 = val1.time_from_start
        _x = _v1462
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_L3.pack(@result.executed_trajectory.joint_trajectory.header.seq, @result.executed_trajectory.joint_trajectory.header.stamp.secs, @result.executed_trajectory.joint_trajectory.header.stamp.nsecs))
      _x = @result.executed_trajectory.joint_trajectory.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @result.executed_trajectory.joint_trajectory.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.executed_trajectory.joint_trajectory.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @result.executed_trajectory.joint_trajectory.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.executed_trajectory.joint_trajectory.points
        length = val1.positions.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.positions.pack(pattern))
        length = val1.velocities.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.velocities.pack(pattern))
        length = val1.accelerations.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.accelerations.pack(pattern))
        length = val1.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.effort.pack(pattern))
        _v1463 = val1.time_from_start
        _x = _v1463
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_L3.pack(@result.executed_trajectory.multi_dof_joint_trajectory.header.seq, @result.executed_trajectory.multi_dof_joint_trajectory.header.stamp.secs, @result.executed_trajectory.multi_dof_joint_trajectory.header.stamp.nsecs))
      _x = @result.executed_trajectory.multi_dof_joint_trajectory.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @result.executed_trajectory.multi_dof_joint_trajectory.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.executed_trajectory.multi_dof_joint_trajectory.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @result.executed_trajectory.multi_dof_joint_trajectory.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.executed_trajectory.multi_dof_joint_trajectory.points
        length = val1.transforms.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.transforms
          _v1464 = val2.translation
          _x = _v1464
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1465 = val2.rotation
          _x = _v1465
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.velocities.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.velocities
          _v1466 = val2.linear
          _x = _v1466
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1467 = val2.angular
          _x = _v1467
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        length = val1.accelerations.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.accelerations
          _v1468 = val2.linear
          _x = _v1468
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1469 = val2.angular
          _x = _v1469
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        _v1470 = val1.time_from_start
        _x = _v1470
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_d.pack(@result.planning_time))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @status == nil
        @status = Actionlib_msgs::GoalStatus.new
      end
      if @result == nil
        @result = Moveit_msgs::MoveGroupResult.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@status.goal_id.stamp.secs, @status.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @status.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@status.status,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @status.text = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('lL3')
      (@result.error_code.val, @result.trajectory_start.joint_state.header.seq, @result.trajectory_start.joint_state.header.stamp.secs, @result.trajectory_start.joint_state.header.stamp.nsecs,) = @@struct_lL3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @result.trajectory_start.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.trajectory_start.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @result.trajectory_start.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @result.trajectory_start.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @result.trajectory_start.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @result.trajectory_start.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@result.trajectory_start.multi_dof_joint_state.header.seq, @result.trajectory_start.multi_dof_joint_state.header.stamp.secs, @result.trajectory_start.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @result.trajectory_start.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.trajectory_start.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @result.trajectory_start.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.trajectory_start.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v1471 = val1.translation
        _x = _v1471
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1472 = val1.rotation
        _x = _v1472
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @result.trajectory_start.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.trajectory_start.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v1473 = val1.linear
        _x = _v1473
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1474 = val1.angular
        _x = _v1474
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @result.trajectory_start.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.trajectory_start.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v1475 = val1.force
        _x = _v1475
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1476 = val1.torque
        _x = _v1476
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @result.trajectory_start.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.trajectory_start.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v1477 = val1.object
        _v1478 = _v1477.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1478.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1479 = _v1478.stamp
        _x = _v1479
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1478.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1477.id = str[start..(end_point-1)]
        _v1480 = _v1477.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1480.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1480.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1477.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v1477.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1477.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1481 = val3.position
          _x = _v1481
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1482 = val3.orientation
          _x = _v1482
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1477.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1477.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v1477.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1477.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1483 = val3.position
          _x = _v1483
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1484 = val3.orientation
          _x = _v1484
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1477.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1477.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1477.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1477.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1485 = val3.position
          _x = _v1485
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1486 = val3.orientation
          _x = _v1486
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1477.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v1477.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v1487 = val1.detach_posture
        _v1488 = _v1487.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1488.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1489 = _v1488.stamp
        _x = _v1489
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1488.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1487.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v1487.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1487.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v1490 = val3.time_from_start
          _x = _v1490
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v1487.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @result.trajectory_start.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('CL3')
      (@result.trajectory_start.is_diff, @result.planned_trajectory.joint_trajectory.header.seq, @result.planned_trajectory.joint_trajectory.header.stamp.secs, @result.planned_trajectory.joint_trajectory.header.stamp.nsecs,) = @@struct_CL3.unpack(str[start..(end_point-1)])
      @result.trajectory_start.is_diff = bool(@result.trajectory_start.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @result.planned_trajectory.joint_trajectory.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.planned_trajectory.joint_trajectory.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @result.planned_trajectory.joint_trajectory.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.planned_trajectory.joint_trajectory.points = []
      length.times do
        val1 = Trajectory_msgs::JointTrajectoryPoint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.positions = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.velocities = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.accelerations = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.effort = str[start..(end_point-1)].unpack(pattern)
        _v1491 = val1.time_from_start
        _x = _v1491
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @result.planned_trajectory.joint_trajectory.points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@result.planned_trajectory.multi_dof_joint_trajectory.header.seq, @result.planned_trajectory.multi_dof_joint_trajectory.header.stamp.secs, @result.planned_trajectory.multi_dof_joint_trajectory.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @result.planned_trajectory.multi_dof_joint_trajectory.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.planned_trajectory.multi_dof_joint_trajectory.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @result.planned_trajectory.multi_dof_joint_trajectory.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.planned_trajectory.multi_dof_joint_trajectory.points = []
      length.times do
        val1 = Trajectory_msgs::MultiDOFJointTrajectoryPoint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.transforms = []
        length.times do
          val2 = Geometry_msgs::Transform.new
          _v1492 = val2.translation
          _x = _v1492
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1493 = val2.rotation
          _x = _v1493
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.transforms.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.velocities = []
        length.times do
          val2 = Geometry_msgs::Twist.new
          _v1494 = val2.linear
          _x = _v1494
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1495 = val2.angular
          _x = _v1495
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.velocities.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.accelerations = []
        length.times do
          val2 = Geometry_msgs::Twist.new
          _v1496 = val2.linear
          _x = _v1496
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1497 = val2.angular
          _x = _v1497
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.accelerations.push(val2)
        end
        _v1498 = val1.time_from_start
        _x = _v1498
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @result.planned_trajectory.multi_dof_joint_trajectory.points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@result.executed_trajectory.joint_trajectory.header.seq, @result.executed_trajectory.joint_trajectory.header.stamp.secs, @result.executed_trajectory.joint_trajectory.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @result.executed_trajectory.joint_trajectory.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.executed_trajectory.joint_trajectory.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @result.executed_trajectory.joint_trajectory.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.executed_trajectory.joint_trajectory.points = []
      length.times do
        val1 = Trajectory_msgs::JointTrajectoryPoint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.positions = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.velocities = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.accelerations = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.effort = str[start..(end_point-1)].unpack(pattern)
        _v1499 = val1.time_from_start
        _x = _v1499
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @result.executed_trajectory.joint_trajectory.points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@result.executed_trajectory.multi_dof_joint_trajectory.header.seq, @result.executed_trajectory.multi_dof_joint_trajectory.header.stamp.secs, @result.executed_trajectory.multi_dof_joint_trajectory.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @result.executed_trajectory.multi_dof_joint_trajectory.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.executed_trajectory.multi_dof_joint_trajectory.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @result.executed_trajectory.multi_dof_joint_trajectory.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.executed_trajectory.multi_dof_joint_trajectory.points = []
      length.times do
        val1 = Trajectory_msgs::MultiDOFJointTrajectoryPoint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.transforms = []
        length.times do
          val2 = Geometry_msgs::Transform.new
          _v1500 = val2.translation
          _x = _v1500
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1501 = val2.rotation
          _x = _v1501
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.transforms.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.velocities = []
        length.times do
          val2 = Geometry_msgs::Twist.new
          _v1502 = val2.linear
          _x = _v1502
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1503 = val2.angular
          _x = _v1503
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.velocities.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.accelerations = []
        length.times do
          val2 = Geometry_msgs::Twist.new
          _v1504 = val2.linear
          _x = _v1504
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1505 = val2.angular
          _x = _v1505
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.accelerations.push(val2)
        end
        _v1506 = val1.time_from_start
        _x = _v1506
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @result.executed_trajectory.multi_dof_joint_trajectory.points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('d')
      (@result.planning_time,) = @@struct_d.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
