# autogenerated by genrb from MoveGroupGoal.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Transform"
require "moveit_msgs/PlanningSceneWorld"
require "moveit_msgs/VisibilityConstraint"
require "moveit_msgs/OrientationConstraint"
require "octomap_msgs/Octomap"
require "moveit_msgs/Constraints"
require "geometry_msgs/Point"
require "geometry_msgs/Twist"
require "shape_msgs/Mesh"
require "std_msgs/ColorRGBA"
require "moveit_msgs/LinkScale"
require "moveit_msgs/PositionConstraint"
require "shape_msgs/Plane"
require "moveit_msgs/AllowedCollisionEntry"
require "geometry_msgs/PoseStamped"
require "moveit_msgs/PlanningOptions"
require "moveit_msgs/ObjectColor"
require "ros/duration"
require "moveit_msgs/BoundingVolume"
require "moveit_msgs/JointConstraint"
require "std_msgs/Header"
require "moveit_msgs/AllowedCollisionMatrix"
require "sensor_msgs/MultiDOFJointState"
require "geometry_msgs/Pose"
require "shape_msgs/MeshTriangle"
require "moveit_msgs/TrajectoryConstraints"
require "shape_msgs/SolidPrimitive"
require "geometry_msgs/Wrench"
require "geometry_msgs/TransformStamped"
require "moveit_msgs/WorkspaceParameters"
require "moveit_msgs/RobotState"
require "moveit_msgs/PlanningScene"
require "octomap_msgs/OctomapWithPose"
require "trajectory_msgs/JointTrajectory"
require "sensor_msgs/JointState"
require "trajectory_msgs/JointTrajectoryPoint"
require "moveit_msgs/LinkPadding"
require "object_recognition_msgs/ObjectType"
require "moveit_msgs/MotionPlanRequest"
require "moveit_msgs/AttachedCollisionObject"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "moveit_msgs/CollisionObject"

module Moveit_msgs

class MoveGroupGoal <::ROS::Message
  def self.md5sum
    "6f87a65b68d345a6821303c17412a990"
  end

  def self.type
    "moveit_msgs/MoveGroupGoal"
  end

  def has_header?
    false
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Motion planning request to pass to planner
MotionPlanRequest request

# Planning options
PlanningOptions planning_options


================================================================================
MSG: moveit_msgs/MotionPlanRequest
# This service contains the definition for a request to the motion
# planner and the output it provides

# Parameters for the workspace that the planner should work inside
WorkspaceParameters workspace_parameters

# Starting state updates. If certain joints should be considered
# at positions other than the current ones, these positions should
# be set here
RobotState start_state

# The possible goal states for the model to plan for. Each element of
# the array defines a goal region. The goal is achieved
# if the constraints for a particular region are satisfied
Constraints[] goal_constraints

# No state at any point along the path in the produced motion plan will violate these constraints (this applies to all points, not just waypoints)
Constraints path_constraints

# The constraints the resulting trajectory must satisfy
TrajectoryConstraints trajectory_constraints

# The name of the motion planner to use. If no name is specified,
# a default motion planner will be used
string planner_id

# The name of the group of joints on which this planner is operating
string group_name

# The number of times this plan is to be computed. Shortest solution
# will be reported.
int32 num_planning_attempts

# The maximum amount of time the motion planner is allowed to plan for (in seconds)
float64 allowed_planning_time

================================================================================
MSG: moveit_msgs/WorkspaceParameters
# This message contains a set of parameters useful in
# setting up the volume (a box) in which the robot is allowed to move.
# This is useful only when planning for mobile parts of 
# the robot as well.

# Define the frame of reference for the box corners
Header header

# The minumum corner of the box, with respect to the robot starting pose
geometry_msgs/Vector3 min_corner

# The maximum corner of the box, with respect to the robot starting pose
geometry_msgs/Vector3 max_corner

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: moveit_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state

# Joints that may have multiple DOF are specified here
sensor_msgs/MultiDOFJointState multi_dof_joint_state

# Attached collision objects (attached to some link on the robot)
AttachedCollisionObject[] attached_collision_objects

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
# This is mostly important for handling the attached bodies (whether or not to clear the attached bodies
# of a moveit::core::RobotState before updating it with this message)
bool is_diff

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: sensor_msgs/MultiDOFJointState
# Representation of state for joints with multiple degrees of freedom, 
# following the structure of JointState.
#
# It is assumed that a joint in a system corresponds to a transform that gets applied 
# along the kinematic chain. For example, a planar joint (as in URDF) is 3DOF (x, y, yaw)
# and those 3DOF can be expressed as a transformation matrix, and that transformation
# matrix can be converted back to (x, y, yaw)
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# wrench associated with them, you can leave the wrench array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

Header header

string[] joint_names
geometry_msgs/Transform[] transforms
geometry_msgs/Twist[] twist
geometry_msgs/Wrench[] wrench

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: moveit_msgs/AttachedCollisionObject
# The CollisionObject will be attached with a fixed joint to this link
string link_name

#This contains the actual shapes and poses for the CollisionObject
#to be attached to the link
#If action is remove and no object.id is set, all objects
#attached to the link indicated by link_name will be removed
CollisionObject object

# The set of links that the attached objects are allowed to touch
# by default - the link_name is already considered by default
string[] touch_links

# If certain links were placed in a particular posture for this object to remain attached 
# (e.g., an end effector closing around an object), the posture necessary for releasing
# the object is stored here
trajectory_msgs/JointTrajectory detach_posture

# The weight of the attached object, if known
float64 weight

================================================================================
MSG: moveit_msgs/CollisionObject
# a header, used for interpreting the poses
Header header

# the id of the object (name used in MoveIt)
string id

# The object type in a database of known objects
object_recognition_msgs/ObjectType type

# the the collision geometries associated with the object;
# their poses are with respect to the specified header

# solid geometric primitives
shape_msgs/SolidPrimitive[] primitives
geometry_msgs/Pose[] primitive_poses

# meshes
shape_msgs/Mesh[] meshes
geometry_msgs/Pose[] mesh_poses

# bounding planes (equation is specified, but the plane can be oriented using an additional pose)
shape_msgs/Plane[] planes
geometry_msgs/Pose[] plane_poses

# Adds the object to the planning scene. If the object previously existed, it is replaced.
byte ADD=0

# Removes the object from the environment entirely (everything that matches the specified id)
byte REMOVE=1

# Append to an object that already exists in the planning scene. If the does not exist, it is added.
byte APPEND=2

# If an object already exists in the scene, new poses can be sent (the geometry arrays must be left empty)
# if solely moving the object is desired
byte MOVE=3

# Operation to be performed
byte operation

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: shape_msgs/SolidPrimitive
# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: shape_msgs/Plane
# Representation of a plane, using the plane equation ax + by + cz + d = 0

# a := coef[0]
# b := coef[1]
# c := coef[2]
# d := coef[3]

float64[4] coef

================================================================================
MSG: trajectory_msgs/JointTrajectory
Header header
string[] joint_names
JointTrajectoryPoint[] points
================================================================================
MSG: trajectory_msgs/JointTrajectoryPoint
# Each trajectory point specifies either positions[, velocities[, accelerations]]
# or positions[, effort] for the trajectory to be executed.
# All specified values are in the same order as the joint names in JointTrajectory.msg

float64[] positions
float64[] velocities
float64[] accelerations
float64[] effort
duration time_from_start

================================================================================
MSG: moveit_msgs/Constraints
# This message contains a list of motion planning constraints.
# All constraints must be satisfied for a goal to be considered valid

string name

JointConstraint[] joint_constraints

PositionConstraint[] position_constraints

OrientationConstraint[] orientation_constraints

VisibilityConstraint[] visibility_constraints

================================================================================
MSG: moveit_msgs/JointConstraint
# Constrain the position of a joint to be within a certain bound
string joint_name

# the bound to be achieved is [position - tolerance_below, position + tolerance_above]
float64 position
float64 tolerance_above
float64 tolerance_below

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight
================================================================================
MSG: moveit_msgs/PositionConstraint
# This message contains the definition of a position constraint.

Header header

# The robot link this constraint refers to
string link_name

# The offset (in the link frame) for the target point on the link we are planning for
geometry_msgs/Vector3 target_point_offset

# The volume this constraint refers to 
BoundingVolume constraint_region

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: moveit_msgs/BoundingVolume
# Define a volume in 3D

# A set of solid geometric primitives that make up the volume to define (as a union)
shape_msgs/SolidPrimitive[] primitives

# The poses at which the primitives are located
geometry_msgs/Pose[] primitive_poses

# In addition to primitives, meshes can be specified to add to the bounding volume (again, as union)
shape_msgs/Mesh[] meshes

# The poses at which the meshes are located
geometry_msgs/Pose[] mesh_poses

================================================================================
MSG: moveit_msgs/OrientationConstraint
# This message contains the definition of an orientation constraint.

Header header

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# The robot link this constraint refers to
string link_name

# optional axis-angle error tolerances specified
float64 absolute_x_axis_tolerance
float64 absolute_y_axis_tolerance
float64 absolute_z_axis_tolerance

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: moveit_msgs/VisibilityConstraint
# The constraint is useful to maintain visibility to a disc (the target) in a particular frame.
# This disc forms the base of a visibiliy cone whose tip is at the origin of the sensor.
# Maintaining visibility is done by ensuring the robot does not obstruct the visibility cone.
# Note:
# This constraint does NOT enforce minimum or maximum distances between the sensor
# and the target, nor does it enforce the target to be in the field of view of
# the sensor. A PositionConstraint can (and probably should) be used for such purposes.

# The radius of the disc that should be maintained visible 
float64 target_radius

# The pose of the disc; as the robot moves, the pose of the disc may change as well
# This can be in the frame of a particular robot link, for example
geometry_msgs/PoseStamped target_pose

# From the sensor origin towards the target, the disc forms a visibility cone
# This cone is approximated using many sides. For example, when using 4 sides, 
# that in fact makes the visibility region be a pyramid.
# This value should always be 3 or more.
int32 cone_sides

# The pose in which visibility is to be maintained.
# The frame id should represent the robot link to which the sensor is attached.
# It is assumed the sensor can look directly at the target, in any direction.
# This assumption is usually not true, but additional PositionConstraints
# can resolve this issue.
geometry_msgs/PoseStamped sensor_pose

# Even though the disc is maintained visible, the visibility cone can be very small
# because of the orientation of the disc with respect to the sensor. It is possible
# for example to view the disk almost from a side, in which case the visibility cone 
# can end up having close to 0 volume. The view angle is defined to be the angle between
# the normal to the visibility disc and the direction vector from the sensor origin.
# The value below represents the minimum desired view angle. For a perfect view,
# this value will be 0 (the two vectors are exact opposites). For a completely obstructed view
# this value will be Pi/2 (the vectors are perpendicular). This value defined below 
# is the maximum view angle to be maintained. This should be a value in the open interval
# (0, Pi/2). If 0 is set, the view angle is NOT enforced.
float64 max_view_angle

# This angle is used similarly to max_view_angle but limits the maximum angle
# between the sensor origin direction vector and the axis that connects the
# sensor origin to the target frame origin. The value is again in the range (0, Pi/2)
# and is NOT enforced if set to 0.
float64 max_range_angle

# The axis that is assumed to indicate the direction of view for the sensor
# X = 2, Y = 1, Z = 0
uint8 SENSOR_Z=0
uint8 SENSOR_Y=1
uint8 SENSOR_X=2
uint8 sensor_view_direction

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: moveit_msgs/TrajectoryConstraints
# The array of constraints to consider along the trajectory
Constraints[] constraints

================================================================================
MSG: moveit_msgs/PlanningOptions

# The diff to consider for the planning scene (optional)
PlanningScene planning_scene_diff

# If this flag is set to true, the action
# returns an executable plan in the response but does not attempt execution  
bool plan_only

# If this flag is set to true, the action of planning &
# executing is allowed to look around  (move sensors) if
# it seems that not enough information is available about
# the environment
bool look_around

# If this value is positive, the action of planning & executing
# is allowed to look around for a maximum number of attempts;
# If the value is left as 0, the default value is used, as set
# with dynamic_reconfigure
int32 look_around_attempts

# If set and if look_around is true, this value is used as
# the maximum cost allowed for a path to be considered executable.
# If the cost of a path is higher than this value, more sensing or 
# a new plan needed. If left as 0.0 but look_around is true, then 
# the default value set via dynamic_reconfigure is used
float64 max_safe_execution_cost

# If the plan becomes invalidated during execution, it is possible to have
# that plan recomputed and execution restarted. This flag enables this
# functionality 
bool replan

# The maximum number of replanning attempts 
int32 replan_attempts

# The amount of time to wait in between replanning attempts (in seconds)
float64 replan_delay

================================================================================
MSG: moveit_msgs/PlanningScene
# name of planning scene
string name

# full robot state
RobotState robot_state

# The name of the robot model this scene is for
string robot_model_name

#additional frames for duplicating tf (with respect to the planning frame)
geometry_msgs/TransformStamped[] fixed_frame_transforms

#full allowed collision matrix
AllowedCollisionMatrix allowed_collision_matrix

# all link paddings
LinkPadding[] link_padding

# all link scales
LinkScale[] link_scale

# Attached objects, collision objects, even the octomap or collision map can have 
# colors associated to them. This array specifies them.
ObjectColor[] object_colors

# the collision map
PlanningSceneWorld world

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
bool is_diff

================================================================================
MSG: geometry_msgs/TransformStamped
# This expresses a transform from coordinate frame header.frame_id
# to the coordinate frame child_frame_id
#
# This message is mostly used by the 
# <a href=\"http://www.ros.org/wiki/tf\">tf</a> package. 
# See its documentation for more information.

Header header
string child_frame_id # the frame id of the child frame
Transform transform

================================================================================
MSG: moveit_msgs/AllowedCollisionMatrix
# The list of entry names in the matrix
string[] entry_names

# The individual entries in the allowed collision matrix
# square, symmetric, with same order as entry_names
AllowedCollisionEntry[] entry_values

# In addition to the collision matrix itself, we also have 
# the default entry value for each entry name.

# If the allowed collision flag is queried for a pair of names (n1, n2)
# that is not found in the collision matrix itself, the value of
# the collision flag is considered to be that of the entry (n1 or n2)
# specified in the list below. If both n1 and n2 are found in the list 
# of defaults, the result is computed with an AND operation

string[] default_entry_names
bool[] default_entry_values

================================================================================
MSG: moveit_msgs/AllowedCollisionEntry
# whether or not collision checking is enabled
bool[] enabled

================================================================================
MSG: moveit_msgs/LinkPadding
#name for the link
string link_name

# padding to apply to the link
float64 padding

================================================================================
MSG: moveit_msgs/LinkScale
#name for the link
string link_name

# scaling to apply to the link
float64 scale

================================================================================
MSG: moveit_msgs/ObjectColor
# The object id for which we specify color
string id

# The value of the color
std_msgs/ColorRGBA color

================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

================================================================================
MSG: moveit_msgs/PlanningSceneWorld
# collision objects
CollisionObject[] collision_objects

# The octomap that represents additional collision data
octomap_msgs/OctomapWithPose octomap

================================================================================
MSG: octomap_msgs/OctomapWithPose
# A 3D map in binary format, as Octree
Header header

# The pose of the octree with respect to the header frame 
geometry_msgs/Pose origin

# The actual octree msg
octomap_msgs/Octomap octomap

================================================================================
MSG: octomap_msgs/Octomap
# A 3D map in binary format, as Octree
Header header

# Flag to denote a binary (only free/occupied) or full occupancy octree (.bt/.ot file)
bool binary

# Class id of the contained octree 
string id

# Resolution (in m) of the smallest octree nodes
float64 resolution

# binary serialization of octree, use conversions.h to read and write octrees
int8[] data

"
  end
  attr_accessor :request, :planning_options

  @@struct_d7L3 = ::ROS::Struct.new("d7L3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_C3ldCld = ::ROS::Struct.new("C3ldCld")
  @@struct_d6L3 = ::ROS::Struct.new("d6L3")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_l = ::ROS::Struct.new("l")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_c = ::ROS::Struct.new("c")
  @@struct_f4 = ::ROS::Struct.new("f4")
  @@struct_ld = ::ROS::Struct.new("ld")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_d2Cd = ::ROS::Struct.new("d2Cd")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['moveit_msgs/MotionPlanRequest','moveit_msgs/PlanningOptions']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [moveit_msgs/MotionPlanRequest] :request initialize value
  # @option args [moveit_msgs/PlanningOptions] :planning_options initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:request]
      @request = args[:request]
    else
      @request = Moveit_msgs::MotionPlanRequest.new
    end
    if args[:planning_options]
      @planning_options = args[:planning_options]
    else
      @planning_options = Moveit_msgs::PlanningOptions.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@request.workspace_parameters.header.seq, @request.workspace_parameters.header.stamp.secs, @request.workspace_parameters.header.stamp.nsecs))
      _x = @request.workspace_parameters.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d6L3.pack(@request.workspace_parameters.min_corner.x, @request.workspace_parameters.min_corner.y, @request.workspace_parameters.min_corner.z, @request.workspace_parameters.max_corner.x, @request.workspace_parameters.max_corner.y, @request.workspace_parameters.max_corner.z, @request.start_state.joint_state.header.seq, @request.start_state.joint_state.header.stamp.secs, @request.start_state.joint_state.header.stamp.nsecs))
      _x = @request.start_state.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @request.start_state.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @request.start_state.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @request.start_state.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@request.start_state.joint_state.position.pack(pattern))
      length = @request.start_state.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@request.start_state.joint_state.velocity.pack(pattern))
      length = @request.start_state.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@request.start_state.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@request.start_state.multi_dof_joint_state.header.seq, @request.start_state.multi_dof_joint_state.header.stamp.secs, @request.start_state.multi_dof_joint_state.header.stamp.nsecs))
      _x = @request.start_state.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @request.start_state.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @request.start_state.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @request.start_state.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @request.start_state.multi_dof_joint_state.transforms
        _v1507 = val1.translation
        _x = _v1507
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1508 = val1.rotation
        _x = _v1508
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @request.start_state.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @request.start_state.multi_dof_joint_state.twist
        _v1509 = val1.linear
        _x = _v1509
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1510 = val1.angular
        _x = _v1510
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @request.start_state.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @request.start_state.multi_dof_joint_state.wrench
        _v1511 = val1.force
        _x = _v1511
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1512 = val1.torque
        _x = _v1512
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @request.start_state.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @request.start_state.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1513 = val1.object
        _v1514 = _v1513.header
        buff.write(@@struct_L.pack(_v1514.seq))
        _v1515 = _v1514.stamp
        _x = _v1515
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1514.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v1513.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1516 = _v1513.type
        _x = _v1516.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v1516.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v1513.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1513.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v1513.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1513.primitive_poses
          _v1517 = val3.position
          _x = _v1517
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1518 = val3.orientation
          _x = _v1518
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v1513.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1513.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v1513.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1513.mesh_poses
          _v1519 = val3.position
          _x = _v1519
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1520 = val3.orientation
          _x = _v1520
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v1513.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1513.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v1513.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1513.plane_poses
          _v1521 = val3.position
          _x = _v1521
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1522 = val3.orientation
          _x = _v1522
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v1513.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v1523 = val1.detach_posture
        _v1524 = _v1523.header
        buff.write(@@struct_L.pack(_v1524.seq))
        _v1525 = _v1524.stamp
        _x = _v1525
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1524.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v1523.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1523.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v1523.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1523.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v1526 = val3.time_from_start
          _x = _v1526
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_C.pack(@request.start_state.is_diff))
      length = @request.goal_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @request.goal_constraints
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.joint_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.joint_constraints
          _x = val2.joint_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
        end
        length = val1.position_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.position_constraints
          _v1527 = val2.header
          buff.write(@@struct_L.pack(_v1527.seq))
          _v1528 = _v1527.stamp
          _x = _v1528
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1527.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1529 = val2.target_point_offset
          _x = _v1529
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1530 = val2.constraint_region
          length = _v1530.primitives.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1530.primitives
            buff.write(@@struct_C.pack(val4.type))
            length = val4.dimensions.length
            buff.write(@@struct_L.pack(length))
            pattern = "d#{length}"
            buff.write(*val4.dimensions.pack(pattern))
          end
          length = _v1530.primitive_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1530.primitive_poses
            _v1531 = val4.position
            _x = _v1531
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v1532 = val4.orientation
            _x = _v1532
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          length = _v1530.meshes.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1530.meshes
            length = val4.triangles.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.triangles
              buff.write(@@struct_L3.pack(*val5.vertex_indices))
            end
            length = val4.vertices.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.vertices
              _x = val5
              buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            end
          end
          length = _v1530.mesh_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1530.mesh_poses
            _v1533 = val4.position
            _x = _v1533
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v1534 = val4.orientation
            _x = _v1534
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          buff.write(@@struct_d.pack(val2.weight))
        end
        length = val1.orientation_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.orientation_constraints
          _v1535 = val2.header
          buff.write(@@struct_L.pack(_v1535.seq))
          _v1536 = _v1535.stamp
          _x = _v1536
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1535.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1537 = val2.orientation
          _x = _v1537
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
        end
        length = val1.visibility_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.visibility_constraints
          buff.write(@@struct_d.pack(val2.target_radius))
          _v1538 = val2.target_pose
          _v1539 = _v1538.header
          buff.write(@@struct_L.pack(_v1539.seq))
          _v1540 = _v1539.stamp
          _x = _v1540
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1539.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1541 = _v1538.pose
          _v1542 = _v1541.position
          _x = _v1542
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1543 = _v1541.orientation
          _x = _v1543
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(@@struct_l.pack(val2.cone_sides))
          _v1544 = val2.sensor_pose
          _v1545 = _v1544.header
          buff.write(@@struct_L.pack(_v1545.seq))
          _v1546 = _v1545.stamp
          _x = _v1546
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1545.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1547 = _v1544.pose
          _v1548 = _v1547.position
          _x = _v1548
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1549 = _v1547.orientation
          _x = _v1549
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2
          buff.write(@@struct_d2Cd.pack(_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight))
        end
      end
      _x = @request.path_constraints.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @request.path_constraints.joint_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @request.path_constraints.joint_constraints
        _x = val1.joint_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_d4.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
      end
      length = @request.path_constraints.position_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @request.path_constraints.position_constraints
        _v1550 = val1.header
        buff.write(@@struct_L.pack(_v1550.seq))
        _v1551 = _v1550.stamp
        _x = _v1551
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1550.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1552 = val1.target_point_offset
        _x = _v1552
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1553 = val1.constraint_region
        length = _v1553.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1553.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v1553.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1553.primitive_poses
          _v1554 = val3.position
          _x = _v1554
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1555 = val3.orientation
          _x = _v1555
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v1553.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1553.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v1553.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1553.mesh_poses
          _v1556 = val3.position
          _x = _v1556
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1557 = val3.orientation
          _x = _v1557
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      length = @request.path_constraints.orientation_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @request.path_constraints.orientation_constraints
        _v1558 = val1.header
        buff.write(@@struct_L.pack(_v1558.seq))
        _v1559 = _v1558.stamp
        _x = _v1559
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1558.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1560 = val1.orientation
        _x = _v1560
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_d4.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
      end
      length = @request.path_constraints.visibility_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @request.path_constraints.visibility_constraints
        buff.write(@@struct_d.pack(val1.target_radius))
        _v1561 = val1.target_pose
        _v1562 = _v1561.header
        buff.write(@@struct_L.pack(_v1562.seq))
        _v1563 = _v1562.stamp
        _x = _v1563
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1562.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1564 = _v1561.pose
        _v1565 = _v1564.position
        _x = _v1565
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1566 = _v1564.orientation
        _x = _v1566
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_l.pack(val1.cone_sides))
        _v1567 = val1.sensor_pose
        _v1568 = _v1567.header
        buff.write(@@struct_L.pack(_v1568.seq))
        _v1569 = _v1568.stamp
        _x = _v1569
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1568.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1570 = _v1567.pose
        _v1571 = _v1570.position
        _x = _v1571
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1572 = _v1570.orientation
        _x = _v1572
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(@@struct_d2Cd.pack(_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight))
      end
      length = @request.trajectory_constraints.constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @request.trajectory_constraints.constraints
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.joint_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.joint_constraints
          _x = val2.joint_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
        end
        length = val1.position_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.position_constraints
          _v1573 = val2.header
          buff.write(@@struct_L.pack(_v1573.seq))
          _v1574 = _v1573.stamp
          _x = _v1574
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1573.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1575 = val2.target_point_offset
          _x = _v1575
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1576 = val2.constraint_region
          length = _v1576.primitives.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1576.primitives
            buff.write(@@struct_C.pack(val4.type))
            length = val4.dimensions.length
            buff.write(@@struct_L.pack(length))
            pattern = "d#{length}"
            buff.write(*val4.dimensions.pack(pattern))
          end
          length = _v1576.primitive_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1576.primitive_poses
            _v1577 = val4.position
            _x = _v1577
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v1578 = val4.orientation
            _x = _v1578
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          length = _v1576.meshes.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1576.meshes
            length = val4.triangles.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.triangles
              buff.write(@@struct_L3.pack(*val5.vertex_indices))
            end
            length = val4.vertices.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.vertices
              _x = val5
              buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            end
          end
          length = _v1576.mesh_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v1576.mesh_poses
            _v1579 = val4.position
            _x = _v1579
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v1580 = val4.orientation
            _x = _v1580
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          buff.write(@@struct_d.pack(val2.weight))
        end
        length = val1.orientation_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.orientation_constraints
          _v1581 = val2.header
          buff.write(@@struct_L.pack(_v1581.seq))
          _v1582 = _v1581.stamp
          _x = _v1582
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1581.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1583 = val2.orientation
          _x = _v1583
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
        end
        length = val1.visibility_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.visibility_constraints
          buff.write(@@struct_d.pack(val2.target_radius))
          _v1584 = val2.target_pose
          _v1585 = _v1584.header
          buff.write(@@struct_L.pack(_v1585.seq))
          _v1586 = _v1585.stamp
          _x = _v1586
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1585.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1587 = _v1584.pose
          _v1588 = _v1587.position
          _x = _v1588
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1589 = _v1587.orientation
          _x = _v1589
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(@@struct_l.pack(val2.cone_sides))
          _v1590 = val2.sensor_pose
          _v1591 = _v1590.header
          buff.write(@@struct_L.pack(_v1591.seq))
          _v1592 = _v1591.stamp
          _x = _v1592
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v1591.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v1593 = _v1590.pose
          _v1594 = _v1593.position
          _x = _v1594
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1595 = _v1593.orientation
          _x = _v1595
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2
          buff.write(@@struct_d2Cd.pack(_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight))
        end
      end
      _x = @request.planner_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @request.group_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_ld.pack(@request.num_planning_attempts, @request.allowed_planning_time))
      _x = @planning_options.planning_scene_diff.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@planning_options.planning_scene_diff.robot_state.joint_state.header.seq, @planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.secs, @planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.nsecs))
      _x = @planning_options.planning_scene_diff.robot_state.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @planning_options.planning_scene_diff.robot_state.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_options.planning_scene_diff.robot_state.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @planning_options.planning_scene_diff.robot_state.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@planning_options.planning_scene_diff.robot_state.joint_state.position.pack(pattern))
      length = @planning_options.planning_scene_diff.robot_state.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@planning_options.planning_scene_diff.robot_state.joint_state.velocity.pack(pattern))
      length = @planning_options.planning_scene_diff.robot_state.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@planning_options.planning_scene_diff.robot_state.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.seq, @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.secs, @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.nsecs))
      _x = @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms
        _v1596 = val1.translation
        _x = _v1596
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1597 = val1.rotation
        _x = _v1597
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist
        _v1598 = val1.linear
        _x = _v1598
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1599 = val1.angular
        _x = _v1599
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench
        _v1600 = val1.force
        _x = _v1600
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1601 = val1.torque
        _x = _v1601
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @planning_options.planning_scene_diff.robot_state.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_options.planning_scene_diff.robot_state.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1602 = val1.object
        _v1603 = _v1602.header
        buff.write(@@struct_L.pack(_v1603.seq))
        _v1604 = _v1603.stamp
        _x = _v1604
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1603.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v1602.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1605 = _v1602.type
        _x = _v1605.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v1605.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v1602.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1602.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v1602.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1602.primitive_poses
          _v1606 = val3.position
          _x = _v1606
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1607 = val3.orientation
          _x = _v1607
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v1602.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1602.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v1602.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1602.mesh_poses
          _v1608 = val3.position
          _x = _v1608
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1609 = val3.orientation
          _x = _v1609
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v1602.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1602.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v1602.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1602.plane_poses
          _v1610 = val3.position
          _x = _v1610
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1611 = val3.orientation
          _x = _v1611
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v1602.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v1612 = val1.detach_posture
        _v1613 = _v1612.header
        buff.write(@@struct_L.pack(_v1613.seq))
        _v1614 = _v1613.stamp
        _x = _v1614
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1613.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v1612.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1612.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v1612.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1612.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v1615 = val3.time_from_start
          _x = _v1615
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_C.pack(@planning_options.planning_scene_diff.robot_state.is_diff))
      _x = @planning_options.planning_scene_diff.robot_model_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @planning_options.planning_scene_diff.fixed_frame_transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_options.planning_scene_diff.fixed_frame_transforms
        _v1616 = val1.header
        buff.write(@@struct_L.pack(_v1616.seq))
        _v1617 = _v1616.stamp
        _x = _v1617
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1616.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.child_frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1618 = val1.transform
        _v1619 = _v1618.translation
        _x = _v1619
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v1620 = _v1618.rotation
        _x = _v1620
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @planning_options.planning_scene_diff.allowed_collision_matrix.entry_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_options.planning_scene_diff.allowed_collision_matrix.entry_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @planning_options.planning_scene_diff.allowed_collision_matrix.entry_values.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_options.planning_scene_diff.allowed_collision_matrix.entry_values
        length = val1.enabled.length
        buff.write(@@struct_L.pack(length))
        pattern = "C#{length}"
        buff.write(*val1.enabled.pack(pattern))
      end
      length = @planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values.length
      buff.write(@@struct_L.pack(length))
      pattern = "C#{length}"
      buff.write(*@planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values.pack(pattern))
      length = @planning_options.planning_scene_diff.link_padding.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_options.planning_scene_diff.link_padding
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_d.pack(val1.padding))
      end
      length = @planning_options.planning_scene_diff.link_scale.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_options.planning_scene_diff.link_scale
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_d.pack(val1.scale))
      end
      length = @planning_options.planning_scene_diff.object_colors.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_options.planning_scene_diff.object_colors
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1621 = val1.color
        _x = _v1621
        buff.write(@@struct_f4.pack(_x.r, _x.g, _x.b, _x.a))
      end
      length = @planning_options.planning_scene_diff.world.collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_options.planning_scene_diff.world.collision_objects
        _v1622 = val1.header
        buff.write(@@struct_L.pack(_v1622.seq))
        _v1623 = _v1622.stamp
        _x = _v1623
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1622.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1624 = val1.type
        _x = _v1624.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v1624.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.primitives.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.primitives
          buff.write(@@struct_C.pack(val2.type))
          length = val2.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val2.dimensions.pack(pattern))
        end
        length = val1.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.primitive_poses
          _v1625 = val2.position
          _x = _v1625
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1626 = val2.orientation
          _x = _v1626
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.meshes.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.meshes
          length = val2.triangles.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.triangles
            buff.write(@@struct_L3.pack(*val3.vertex_indices))
          end
          length = val2.vertices.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.vertices
            _x = val3
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = val1.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.mesh_poses
          _v1627 = val2.position
          _x = _v1627
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1628 = val2.orientation
          _x = _v1628
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.planes.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.planes
          buff.write(@@struct_d4.pack(*val2.coef))
        end
        length = val1.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.plane_poses
          _v1629 = val2.position
          _x = _v1629
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1630 = val2.orientation
          _x = _v1630
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(val1.operation))
      end
      buff.write(@@struct_L3.pack(@planning_options.planning_scene_diff.world.octomap.header.seq, @planning_options.planning_scene_diff.world.octomap.header.stamp.secs, @planning_options.planning_scene_diff.world.octomap.header.stamp.nsecs))
      _x = @planning_options.planning_scene_diff.world.octomap.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7L3.pack(@planning_options.planning_scene_diff.world.octomap.origin.position.x, @planning_options.planning_scene_diff.world.octomap.origin.position.y, @planning_options.planning_scene_diff.world.octomap.origin.position.z, @planning_options.planning_scene_diff.world.octomap.origin.orientation.x, @planning_options.planning_scene_diff.world.octomap.origin.orientation.y, @planning_options.planning_scene_diff.world.octomap.origin.orientation.z, @planning_options.planning_scene_diff.world.octomap.origin.orientation.w, @planning_options.planning_scene_diff.world.octomap.octomap.header.seq, @planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.secs, @planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.nsecs))
      _x = @planning_options.planning_scene_diff.world.octomap.octomap.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@planning_options.planning_scene_diff.world.octomap.octomap.binary))
      _x = @planning_options.planning_scene_diff.world.octomap.octomap.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d.pack(@planning_options.planning_scene_diff.world.octomap.octomap.resolution))
      length = @planning_options.planning_scene_diff.world.octomap.octomap.data.length
      buff.write(@@struct_L.pack(length))
      pattern = "c#{length}"
      buff.write(*@planning_options.planning_scene_diff.world.octomap.octomap.data.pack(pattern))
      buff.write(@@struct_C3ldCld.pack(@planning_options.planning_scene_diff.is_diff, @planning_options.plan_only, @planning_options.look_around, @planning_options.look_around_attempts, @planning_options.max_safe_execution_cost, @planning_options.replan, @planning_options.replan_attempts, @planning_options.replan_delay))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @request == nil
        @request = Moveit_msgs::MotionPlanRequest.new
      end
      if @planning_options == nil
        @planning_options = Moveit_msgs::PlanningOptions.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@request.workspace_parameters.header.seq, @request.workspace_parameters.header.stamp.secs, @request.workspace_parameters.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @request.workspace_parameters.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d6L3')
      (@request.workspace_parameters.min_corner.x, @request.workspace_parameters.min_corner.y, @request.workspace_parameters.min_corner.z, @request.workspace_parameters.max_corner.x, @request.workspace_parameters.max_corner.y, @request.workspace_parameters.max_corner.z, @request.start_state.joint_state.header.seq, @request.start_state.joint_state.header.stamp.secs, @request.start_state.joint_state.header.stamp.nsecs,) = @@struct_d6L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @request.start_state.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @request.start_state.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @request.start_state.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @request.start_state.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @request.start_state.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @request.start_state.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@request.start_state.multi_dof_joint_state.header.seq, @request.start_state.multi_dof_joint_state.header.stamp.secs, @request.start_state.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @request.start_state.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @request.start_state.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @request.start_state.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @request.start_state.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v1631 = val1.translation
        _x = _v1631
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1632 = val1.rotation
        _x = _v1632
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @request.start_state.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @request.start_state.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v1633 = val1.linear
        _x = _v1633
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1634 = val1.angular
        _x = _v1634
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @request.start_state.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @request.start_state.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v1635 = val1.force
        _x = _v1635
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1636 = val1.torque
        _x = _v1636
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @request.start_state.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @request.start_state.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v1637 = val1.object
        _v1638 = _v1637.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1638.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1639 = _v1638.stamp
        _x = _v1639
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1638.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1637.id = str[start..(end_point-1)]
        _v1640 = _v1637.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1640.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1640.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1637.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v1637.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1637.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1641 = val3.position
          _x = _v1641
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1642 = val3.orientation
          _x = _v1642
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1637.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1637.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v1637.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1637.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1643 = val3.position
          _x = _v1643
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1644 = val3.orientation
          _x = _v1644
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1637.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1637.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1637.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1637.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1645 = val3.position
          _x = _v1645
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1646 = val3.orientation
          _x = _v1646
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1637.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v1637.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v1647 = val1.detach_posture
        _v1648 = _v1647.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1648.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1649 = _v1648.stamp
        _x = _v1649
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1648.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1647.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v1647.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1647.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v1650 = val3.time_from_start
          _x = _v1650
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v1647.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @request.start_state.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@request.start_state.is_diff,) = @@struct_C.unpack(str[start..(end_point-1)])
      @request.start_state.is_diff = bool(@request.start_state.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @request.goal_constraints = []
      length.times do
        val1 = Moveit_msgs::Constraints.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.joint_constraints = []
        length.times do
          val2 = Moveit_msgs::JointConstraint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.joint_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.joint_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.position_constraints = []
        length.times do
          val2 = Moveit_msgs::PositionConstraint.new
          _v1651 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1651.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1652 = _v1651.stamp
          _x = _v1652
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1651.frame_id = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _v1653 = val2.target_point_offset
          _x = _v1653
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1654 = val2.constraint_region
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1654.primitives = []
          length.times do
            val4 = Shape_msgs::SolidPrimitive.new
            start = end_point
            end_point += ROS::Struct::calc_size('C')
            (val4.type,) = @@struct_C.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            pattern = "d#{length}"
            start = end_point
            end_point += ROS::Struct::calc_size("#{pattern}")
            val4.dimensions = str[start..(end_point-1)].unpack(pattern)
            _v1654.primitives.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1654.primitive_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v1655 = val4.position
            _x = _v1655
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v1656 = val4.orientation
            _x = _v1656
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v1654.primitive_poses.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1654.meshes = []
          length.times do
            val4 = Shape_msgs::Mesh.new
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.triangles = []
            length.times do
              val5 = Shape_msgs::MeshTriangle.new
              start = end_point
              end_point += ROS::Struct::calc_size('L3')
              val5.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
              val4.triangles.push(val5)
            end
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.vertices = []
            length.times do
              val5 = Geometry_msgs::Point.new
              _x = val5
              start = end_point
              end_point += ROS::Struct::calc_size('d3')
              (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
              val4.vertices.push(val5)
            end
            _v1654.meshes.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1654.mesh_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v1657 = val4.position
            _x = _v1657
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v1658 = val4.orientation
            _x = _v1658
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v1654.mesh_poses.push(val4)
          end
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
          val1.position_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.orientation_constraints = []
        length.times do
          val2 = Moveit_msgs::OrientationConstraint.new
          _v1659 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1659.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1660 = _v1659.stamp
          _x = _v1660
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1659.frame_id = str[start..(end_point-1)]
          _v1661 = val2.orientation
          _x = _v1661
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.orientation_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.visibility_constraints = []
        length.times do
          val2 = Moveit_msgs::VisibilityConstraint.new
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.target_radius,) = @@struct_d.unpack(str[start..(end_point-1)])
          _v1662 = val2.target_pose
          _v1663 = _v1662.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1663.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1664 = _v1663.stamp
          _x = _v1664
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1663.frame_id = str[start..(end_point-1)]
          _v1665 = _v1662.pose
          _v1666 = _v1665.position
          _x = _v1666
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1667 = _v1665.orientation
          _x = _v1667
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += ROS::Struct::calc_size('l')
          (val2.cone_sides,) = @@struct_l.unpack(str[start..(end_point-1)])
          _v1668 = val2.sensor_pose
          _v1669 = _v1668.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1669.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1670 = _v1669.stamp
          _x = _v1670
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1669.frame_id = str[start..(end_point-1)]
          _v1671 = _v1668.pose
          _v1672 = _v1671.position
          _x = _v1672
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1673 = _v1671.orientation
          _x = _v1673
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d2Cd')
          (_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight,) = @@struct_d2Cd.unpack(str[start..(end_point-1)])
          val1.visibility_constraints.push(val2)
        end
        @request.goal_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @request.path_constraints.name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @request.path_constraints.joint_constraints = []
      length.times do
        val1 = Moveit_msgs::JointConstraint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.joint_name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @request.path_constraints.joint_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @request.path_constraints.position_constraints = []
      length.times do
        val1 = Moveit_msgs::PositionConstraint.new
        _v1674 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1674.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1675 = _v1674.stamp
        _x = _v1675
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1674.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v1676 = val1.target_point_offset
        _x = _v1676
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1677 = val1.constraint_region
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1677.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v1677.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1677.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1678 = val3.position
          _x = _v1678
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1679 = val3.orientation
          _x = _v1679
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1677.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1677.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v1677.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1677.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1680 = val3.position
          _x = _v1680
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1681 = val3.orientation
          _x = _v1681
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1677.mesh_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @request.path_constraints.position_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @request.path_constraints.orientation_constraints = []
      length.times do
        val1 = Moveit_msgs::OrientationConstraint.new
        _v1682 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1682.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1683 = _v1682.stamp
        _x = _v1683
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1682.frame_id = str[start..(end_point-1)]
        _v1684 = val1.orientation
        _x = _v1684
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @request.path_constraints.orientation_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @request.path_constraints.visibility_constraints = []
      length.times do
        val1 = Moveit_msgs::VisibilityConstraint.new
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.target_radius,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v1685 = val1.target_pose
        _v1686 = _v1685.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1686.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1687 = _v1686.stamp
        _x = _v1687
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1686.frame_id = str[start..(end_point-1)]
        _v1688 = _v1685.pose
        _v1689 = _v1688.position
        _x = _v1689
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1690 = _v1688.orientation
        _x = _v1690
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('l')
        (val1.cone_sides,) = @@struct_l.unpack(str[start..(end_point-1)])
        _v1691 = val1.sensor_pose
        _v1692 = _v1691.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1692.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1693 = _v1692.stamp
        _x = _v1693
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1692.frame_id = str[start..(end_point-1)]
        _v1694 = _v1691.pose
        _v1695 = _v1694.position
        _x = _v1695
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1696 = _v1694.orientation
        _x = _v1696
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d2Cd')
        (_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight,) = @@struct_d2Cd.unpack(str[start..(end_point-1)])
        @request.path_constraints.visibility_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @request.trajectory_constraints.constraints = []
      length.times do
        val1 = Moveit_msgs::Constraints.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.joint_constraints = []
        length.times do
          val2 = Moveit_msgs::JointConstraint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.joint_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.joint_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.position_constraints = []
        length.times do
          val2 = Moveit_msgs::PositionConstraint.new
          _v1697 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1697.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1698 = _v1697.stamp
          _x = _v1698
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1697.frame_id = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _v1699 = val2.target_point_offset
          _x = _v1699
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1700 = val2.constraint_region
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1700.primitives = []
          length.times do
            val4 = Shape_msgs::SolidPrimitive.new
            start = end_point
            end_point += ROS::Struct::calc_size('C')
            (val4.type,) = @@struct_C.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            pattern = "d#{length}"
            start = end_point
            end_point += ROS::Struct::calc_size("#{pattern}")
            val4.dimensions = str[start..(end_point-1)].unpack(pattern)
            _v1700.primitives.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1700.primitive_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v1701 = val4.position
            _x = _v1701
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v1702 = val4.orientation
            _x = _v1702
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v1700.primitive_poses.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1700.meshes = []
          length.times do
            val4 = Shape_msgs::Mesh.new
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.triangles = []
            length.times do
              val5 = Shape_msgs::MeshTriangle.new
              start = end_point
              end_point += ROS::Struct::calc_size('L3')
              val5.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
              val4.triangles.push(val5)
            end
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.vertices = []
            length.times do
              val5 = Geometry_msgs::Point.new
              _x = val5
              start = end_point
              end_point += ROS::Struct::calc_size('d3')
              (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
              val4.vertices.push(val5)
            end
            _v1700.meshes.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1700.mesh_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v1703 = val4.position
            _x = _v1703
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v1704 = val4.orientation
            _x = _v1704
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v1700.mesh_poses.push(val4)
          end
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
          val1.position_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.orientation_constraints = []
        length.times do
          val2 = Moveit_msgs::OrientationConstraint.new
          _v1705 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1705.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1706 = _v1705.stamp
          _x = _v1706
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1705.frame_id = str[start..(end_point-1)]
          _v1707 = val2.orientation
          _x = _v1707
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.orientation_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.visibility_constraints = []
        length.times do
          val2 = Moveit_msgs::VisibilityConstraint.new
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.target_radius,) = @@struct_d.unpack(str[start..(end_point-1)])
          _v1708 = val2.target_pose
          _v1709 = _v1708.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1709.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1710 = _v1709.stamp
          _x = _v1710
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1709.frame_id = str[start..(end_point-1)]
          _v1711 = _v1708.pose
          _v1712 = _v1711.position
          _x = _v1712
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1713 = _v1711.orientation
          _x = _v1713
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += ROS::Struct::calc_size('l')
          (val2.cone_sides,) = @@struct_l.unpack(str[start..(end_point-1)])
          _v1714 = val2.sensor_pose
          _v1715 = _v1714.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1715.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1716 = _v1715.stamp
          _x = _v1716
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1715.frame_id = str[start..(end_point-1)]
          _v1717 = _v1714.pose
          _v1718 = _v1717.position
          _x = _v1718
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1719 = _v1717.orientation
          _x = _v1719
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d2Cd')
          (_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight,) = @@struct_d2Cd.unpack(str[start..(end_point-1)])
          val1.visibility_constraints.push(val2)
        end
        @request.trajectory_constraints.constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @request.planner_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @request.group_name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('ld')
      (@request.num_planning_attempts, @request.allowed_planning_time,) = @@struct_ld.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @planning_options.planning_scene_diff.name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@planning_options.planning_scene_diff.robot_state.joint_state.header.seq, @planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.secs, @planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @planning_options.planning_scene_diff.robot_state.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.robot_state.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @planning_options.planning_scene_diff.robot_state.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @planning_options.planning_scene_diff.robot_state.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @planning_options.planning_scene_diff.robot_state.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @planning_options.planning_scene_diff.robot_state.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.seq, @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.secs, @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v1720 = val1.translation
        _x = _v1720
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1721 = val1.rotation
        _x = _v1721
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v1722 = val1.linear
        _x = _v1722
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1723 = val1.angular
        _x = _v1723
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v1724 = val1.force
        _x = _v1724
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1725 = val1.torque
        _x = _v1725
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.robot_state.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v1726 = val1.object
        _v1727 = _v1726.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1727.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1728 = _v1727.stamp
        _x = _v1728
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1727.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1726.id = str[start..(end_point-1)]
        _v1729 = _v1726.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1729.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1729.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1726.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v1726.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1726.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1730 = val3.position
          _x = _v1730
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1731 = val3.orientation
          _x = _v1731
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1726.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1726.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v1726.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1726.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1732 = val3.position
          _x = _v1732
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1733 = val3.orientation
          _x = _v1733
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1726.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1726.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1726.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1726.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1734 = val3.position
          _x = _v1734
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1735 = val3.orientation
          _x = _v1735
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1726.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v1726.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v1736 = val1.detach_posture
        _v1737 = _v1736.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1737.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1738 = _v1737.stamp
        _x = _v1738
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1737.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1736.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v1736.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1736.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v1739 = val3.time_from_start
          _x = _v1739
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v1736.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @planning_options.planning_scene_diff.robot_state.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@planning_options.planning_scene_diff.robot_state.is_diff,) = @@struct_C.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.robot_state.is_diff = bool(@planning_options.planning_scene_diff.robot_state.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @planning_options.planning_scene_diff.robot_model_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.fixed_frame_transforms = []
      length.times do
        val1 = Geometry_msgs::TransformStamped.new
        _v1740 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1740.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1741 = _v1740.stamp
        _x = _v1741
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1740.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.child_frame_id = str[start..(end_point-1)]
        _v1742 = val1.transform
        _v1743 = _v1742.translation
        _x = _v1743
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1744 = _v1742.rotation
        _x = _v1744
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @planning_options.planning_scene_diff.fixed_frame_transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.allowed_collision_matrix.entry_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @planning_options.planning_scene_diff.allowed_collision_matrix.entry_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.allowed_collision_matrix.entry_values = []
      length.times do
        val1 = Moveit_msgs::AllowedCollisionEntry.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "C#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.enabled = str[start..(end_point-1)].unpack(pattern)
        val1.enabled = map(bool, val1.enabled)
        @planning_options.planning_scene_diff.allowed_collision_matrix.entry_values.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "C#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values = str[start..(end_point-1)].unpack(pattern)
      @planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values = map(bool, @planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.link_padding = []
      length.times do
        val1 = Moveit_msgs::LinkPadding.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.padding,) = @@struct_d.unpack(str[start..(end_point-1)])
        @planning_options.planning_scene_diff.link_padding.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.link_scale = []
      length.times do
        val1 = Moveit_msgs::LinkScale.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.scale,) = @@struct_d.unpack(str[start..(end_point-1)])
        @planning_options.planning_scene_diff.link_scale.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.object_colors = []
      length.times do
        val1 = Moveit_msgs::ObjectColor.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v1745 = val1.color
        _x = _v1745
        start = end_point
        end_point += ROS::Struct::calc_size('f4')
        (_x.r, _x.g, _x.b, _x.a,) = @@struct_f4.unpack(str[start..(end_point-1)])
        @planning_options.planning_scene_diff.object_colors.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.world.collision_objects = []
      length.times do
        val1 = Moveit_msgs::CollisionObject.new
        _v1746 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1746.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1747 = _v1746.stamp
        _x = _v1747
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1746.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v1748 = val1.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1748.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1748.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.primitives = []
        length.times do
          val2 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val2.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val2.dimensions = str[start..(end_point-1)].unpack(pattern)
          val1.primitives.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.primitive_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v1749 = val2.position
          _x = _v1749
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1750 = val2.orientation
          _x = _v1750
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.primitive_poses.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.meshes = []
        length.times do
          val2 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.triangles = []
          length.times do
            val3 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val3.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val2.triangles.push(val3)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.vertices = []
          length.times do
            val3 = Geometry_msgs::Point.new
            _x = val3
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val2.vertices.push(val3)
          end
          val1.meshes.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.mesh_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v1751 = val2.position
          _x = _v1751
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1752 = val2.orientation
          _x = _v1752
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.mesh_poses.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.planes = []
        length.times do
          val2 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val2.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.planes.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.plane_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v1753 = val2.position
          _x = _v1753
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1754 = val2.orientation
          _x = _v1754
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.plane_poses.push(val2)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (val1.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        @planning_options.planning_scene_diff.world.collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@planning_options.planning_scene_diff.world.octomap.header.seq, @planning_options.planning_scene_diff.world.octomap.header.stamp.secs, @planning_options.planning_scene_diff.world.octomap.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @planning_options.planning_scene_diff.world.octomap.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7L3')
      (@planning_options.planning_scene_diff.world.octomap.origin.position.x, @planning_options.planning_scene_diff.world.octomap.origin.position.y, @planning_options.planning_scene_diff.world.octomap.origin.position.z, @planning_options.planning_scene_diff.world.octomap.origin.orientation.x, @planning_options.planning_scene_diff.world.octomap.origin.orientation.y, @planning_options.planning_scene_diff.world.octomap.origin.orientation.z, @planning_options.planning_scene_diff.world.octomap.origin.orientation.w, @planning_options.planning_scene_diff.world.octomap.octomap.header.seq, @planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.secs, @planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.nsecs,) = @@struct_d7L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @planning_options.planning_scene_diff.world.octomap.octomap.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@planning_options.planning_scene_diff.world.octomap.octomap.binary,) = @@struct_C.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.world.octomap.octomap.binary = bool(@planning_options.planning_scene_diff.world.octomap.octomap.binary)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @planning_options.planning_scene_diff.world.octomap.octomap.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d')
      (@planning_options.planning_scene_diff.world.octomap.octomap.resolution,) = @@struct_d.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "c#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @planning_options.planning_scene_diff.world.octomap.octomap.data = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('C3ldCld')
      (@planning_options.planning_scene_diff.is_diff, @planning_options.plan_only, @planning_options.look_around, @planning_options.look_around_attempts, @planning_options.max_safe_execution_cost, @planning_options.replan, @planning_options.replan_attempts, @planning_options.replan_delay,) = @@struct_C3ldCld.unpack(str[start..(end_point-1)])
      @planning_options.planning_scene_diff.is_diff = bool(@planning_options.planning_scene_diff.is_diff)
      @planning_options.plan_only = bool(@planning_options.plan_only)
      @planning_options.look_around = bool(@planning_options.look_around)
      @planning_options.replan = bool(@planning_options.replan)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
