# autogenerated by genrb from OrientationConstraint.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Quaternion"

module Moveit_msgs

class OrientationConstraint <::ROS::Message
  def self.md5sum
    "ab5cefb9bc4c0089620f5eb4caf4e59a"
  end

  def self.type
    "moveit_msgs/OrientationConstraint"
  end

  def has_header?
    true
  end

  def message_definition
    "# This message contains the definition of an orientation constraint.

Header header

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# The robot link this constraint refers to
string link_name

# optional axis-angle error tolerances specified
float64 absolute_x_axis_tolerance
float64 absolute_y_axis_tolerance
float64 absolute_z_axis_tolerance

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :header, :orientation, :link_name, :absolute_x_axis_tolerance, :absolute_y_axis_tolerance, :absolute_z_axis_tolerance, :weight

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d4 = ::ROS::Struct.new("d4")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','geometry_msgs/Quaternion','string','float64','float64','float64','float64']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [geometry_msgs/Quaternion] :orientation initialize value
  # @option args [string] :link_name initialize value
  # @option args [float64] :absolute_x_axis_tolerance initialize value
  # @option args [float64] :absolute_y_axis_tolerance initialize value
  # @option args [float64] :absolute_z_axis_tolerance initialize value
  # @option args [float64] :weight initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:orientation]
      @orientation = args[:orientation]
    else
      @orientation = Geometry_msgs::Quaternion.new
    end
    if args[:link_name]
      @link_name = args[:link_name]
    else
      @link_name = ''
    end
    if args[:absolute_x_axis_tolerance]
      @absolute_x_axis_tolerance = args[:absolute_x_axis_tolerance]
    else
      @absolute_x_axis_tolerance = 0.0
    end
    if args[:absolute_y_axis_tolerance]
      @absolute_y_axis_tolerance = args[:absolute_y_axis_tolerance]
    else
      @absolute_y_axis_tolerance = 0.0
    end
    if args[:absolute_z_axis_tolerance]
      @absolute_z_axis_tolerance = args[:absolute_z_axis_tolerance]
    else
      @absolute_z_axis_tolerance = 0.0
    end
    if args[:weight]
      @weight = args[:weight]
    else
      @weight = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d4.pack(@orientation.x, @orientation.y, @orientation.z, @orientation.w))
      _x = @link_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d4.pack(@absolute_x_axis_tolerance, @absolute_y_axis_tolerance, @absolute_z_axis_tolerance, @weight))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @orientation == nil
        @orientation = Geometry_msgs::Quaternion.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d4')
      (@orientation.x, @orientation.y, @orientation.z, @orientation.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @link_name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d4')
      (@absolute_x_axis_tolerance, @absolute_y_axis_tolerance, @absolute_z_axis_tolerance, @weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
