# autogenerated by genrb from OrientedBoundingBox.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Quaternion"
require "geometry_msgs/Point"
require "geometry_msgs/Point32"
require "geometry_msgs/Pose"

module Moveit_msgs

class OrientedBoundingBox <::ROS::Message
  def self.md5sum
    "da3bd98e7cb14efa4141367a9d886ee7"
  end

  def self.type
    "moveit_msgs/OrientedBoundingBox"
  end

  def has_header?
    false
  end

  def message_definition
    "# the pose of the box
geometry_msgs/Pose pose

# the extents of the box, assuming the center is at the origin
geometry_msgs/Point32 extents

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Point32
# This contains the position of a point in free space(with 32 bits of precision).
# It is recommeded to use Point wherever possible instead of Point32.  
# 
# This recommendation is to promote interoperability.  
#
# This message is designed to take up less space when sending
# lots of points at once, as in the case of a PointCloud.  

float32 x
float32 y
float32 z
"
  end
  attr_accessor :pose, :extents

  @@struct_d7f3 = ::ROS::Struct.new("d7f3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['geometry_msgs/Pose','geometry_msgs/Point32']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [geometry_msgs/Pose] :pose initialize value
  # @option args [geometry_msgs/Point32] :extents initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:pose]
      @pose = args[:pose]
    else
      @pose = Geometry_msgs::Pose.new
    end
    if args[:extents]
      @extents = args[:extents]
    else
      @extents = Geometry_msgs::Point32.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_d7f3.pack(@pose.position.x, @pose.position.y, @pose.position.z, @pose.orientation.x, @pose.orientation.y, @pose.orientation.z, @pose.orientation.w, @extents.x, @extents.y, @extents.z))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @pose == nil
        @pose = Geometry_msgs::Pose.new
      end
      if @extents == nil
        @extents = Geometry_msgs::Point32.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('d7f3')
      (@pose.position.x, @pose.position.y, @pose.position.z, @pose.orientation.x, @pose.orientation.y, @pose.orientation.z, @pose.orientation.w, @extents.x, @extents.y, @extents.z,) = @@struct_d7f3.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
