# autogenerated by genrb from PlaceAction.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "geometry_msgs/Vector3Stamped"
require "geometry_msgs/Transform"
require "moveit_msgs/PlanningSceneWorld"
require "moveit_msgs/VisibilityConstraint"
require "moveit_msgs/GripperTranslation"
require "octomap_msgs/Octomap"
require "moveit_msgs/Constraints"
require "geometry_msgs/Point"
require "moveit_msgs/OrientationConstraint"
require "shape_msgs/Mesh"
require "std_msgs/ColorRGBA"
require "trajectory_msgs/MultiDOFJointTrajectory"
require "actionlib_msgs/GoalStatus"
require "moveit_msgs/LinkScale"
require "moveit_msgs/PositionConstraint"
require "shape_msgs/Plane"
require "moveit_msgs/MoveItErrorCodes"
require "moveit_msgs/AllowedCollisionEntry"
require "geometry_msgs/PoseStamped"
require "moveit_msgs/PlanningOptions"
require "moveit_msgs/ObjectColor"
require "ros/duration"
require "moveit_msgs/BoundingVolume"
require "moveit_msgs/JointConstraint"
require "std_msgs/Header"
require "moveit_msgs/PlaceFeedback"
require "moveit_msgs/PlaceGoal"
require "sensor_msgs/MultiDOFJointState"
require "geometry_msgs/Pose"
require "shape_msgs/MeshTriangle"
require "moveit_msgs/RobotTrajectory"
require "shape_msgs/SolidPrimitive"
require "geometry_msgs/Wrench"
require "moveit_msgs/AllowedCollisionMatrix"
require "trajectory_msgs/MultiDOFJointTrajectoryPoint"
require "geometry_msgs/TransformStamped"
require "moveit_msgs/PlaceLocation"
require "moveit_msgs/PlaceActionFeedback"
require "octomap_msgs/OctomapWithPose"
require "moveit_msgs/RobotState"
require "moveit_msgs/PlanningScene"
require "geometry_msgs/Vector3"
require "trajectory_msgs/JointTrajectory"
require "sensor_msgs/JointState"
require "trajectory_msgs/JointTrajectoryPoint"
require "moveit_msgs/LinkPadding"
require "moveit_msgs/PlaceActionResult"
require "object_recognition_msgs/ObjectType"
require "actionlib_msgs/GoalID"
require "moveit_msgs/PlaceResult"
require "geometry_msgs/Twist"
require "moveit_msgs/AttachedCollisionObject"
require "geometry_msgs/Quaternion"
require "moveit_msgs/PlaceActionGoal"
require "moveit_msgs/CollisionObject"

module Moveit_msgs

class PlaceAction <::ROS::Message
  def self.md5sum
    "28cb4b6b7c2a211726c2c78386a9da69"
  end

  def self.type
    "moveit_msgs/PlaceAction"
  end

  def has_header?
    false
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

PlaceActionGoal action_goal
PlaceActionResult action_result
PlaceActionFeedback action_feedback

================================================================================
MSG: moveit_msgs/PlaceActionGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalID goal_id
PlaceGoal goal

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: moveit_msgs/PlaceGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# An action for placing an object

# which group to be used to plan for grasping
string group_name

# the name that the attached object to place
string attached_object_name

# a list of possible transformations for placing the object
PlaceLocation[] place_locations

# if the user prefers setting the eef pose (same as in pick) rather than 
# the location of an end effector, this flag should be set to true
bool place_eef

# the name that the support surface (e.g. table) has in the collision world
# can be left empty if no name is available
string support_surface_name

# whether collisions between the gripper and the support surface should be acceptable
# during move from pre-place to place and during retreat. Collisions when moving to the
# pre-place location are still not allowed even if this is set to true.
bool allow_gripper_support_collision

# Optional constraints to be imposed on every point in the motion plan
Constraints path_constraints

# The name of the motion planner to use. If no name is specified,
# a default motion planner will be used
string planner_id

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping;
# CAREFUL: If the object name 'all' is used, collisions with all objects are disabled during the approach & lift.
string[] allowed_touch_objects

# The maximum amount of time the motion planner is allowed to plan for
float64 allowed_planning_time

# Planning options
PlanningOptions planning_options


================================================================================
MSG: moveit_msgs/PlaceLocation
# A name for this grasp
string id

# The internal posture of the hand for the grasp
# positions and efforts are used
trajectory_msgs/JointTrajectory post_place_posture

# The position of the end-effector for the grasp relative to a reference frame 
# (that is always specified elsewhere, not in this message)
geometry_msgs/PoseStamped place_pose

# The approach motion
GripperTranslation pre_place_approach

# The retreat motion
GripperTranslation post_place_retreat

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping
string[] allowed_touch_objects

================================================================================
MSG: trajectory_msgs/JointTrajectory
Header header
string[] joint_names
JointTrajectoryPoint[] points
================================================================================
MSG: trajectory_msgs/JointTrajectoryPoint
# Each trajectory point specifies either positions[, velocities[, accelerations]]
# or positions[, effort] for the trajectory to be executed.
# All specified values are in the same order as the joint names in JointTrajectory.msg

float64[] positions
float64[] velocities
float64[] accelerations
float64[] effort
duration time_from_start

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: moveit_msgs/GripperTranslation
# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: moveit_msgs/Constraints
# This message contains a list of motion planning constraints.
# All constraints must be satisfied for a goal to be considered valid

string name

JointConstraint[] joint_constraints

PositionConstraint[] position_constraints

OrientationConstraint[] orientation_constraints

VisibilityConstraint[] visibility_constraints

================================================================================
MSG: moveit_msgs/JointConstraint
# Constrain the position of a joint to be within a certain bound
string joint_name

# the bound to be achieved is [position - tolerance_below, position + tolerance_above]
float64 position
float64 tolerance_above
float64 tolerance_below

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight
================================================================================
MSG: moveit_msgs/PositionConstraint
# This message contains the definition of a position constraint.

Header header

# The robot link this constraint refers to
string link_name

# The offset (in the link frame) for the target point on the link we are planning for
geometry_msgs/Vector3 target_point_offset

# The volume this constraint refers to 
BoundingVolume constraint_region

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: moveit_msgs/BoundingVolume
# Define a volume in 3D

# A set of solid geometric primitives that make up the volume to define (as a union)
shape_msgs/SolidPrimitive[] primitives

# The poses at which the primitives are located
geometry_msgs/Pose[] primitive_poses

# In addition to primitives, meshes can be specified to add to the bounding volume (again, as union)
shape_msgs/Mesh[] meshes

# The poses at which the meshes are located
geometry_msgs/Pose[] mesh_poses

================================================================================
MSG: shape_msgs/SolidPrimitive
# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: moveit_msgs/OrientationConstraint
# This message contains the definition of an orientation constraint.

Header header

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# The robot link this constraint refers to
string link_name

# optional axis-angle error tolerances specified
float64 absolute_x_axis_tolerance
float64 absolute_y_axis_tolerance
float64 absolute_z_axis_tolerance

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: moveit_msgs/VisibilityConstraint
# The constraint is useful to maintain visibility to a disc (the target) in a particular frame.
# This disc forms the base of a visibiliy cone whose tip is at the origin of the sensor.
# Maintaining visibility is done by ensuring the robot does not obstruct the visibility cone.
# Note:
# This constraint does NOT enforce minimum or maximum distances between the sensor
# and the target, nor does it enforce the target to be in the field of view of
# the sensor. A PositionConstraint can (and probably should) be used for such purposes.

# The radius of the disc that should be maintained visible 
float64 target_radius

# The pose of the disc; as the robot moves, the pose of the disc may change as well
# This can be in the frame of a particular robot link, for example
geometry_msgs/PoseStamped target_pose

# From the sensor origin towards the target, the disc forms a visibility cone
# This cone is approximated using many sides. For example, when using 4 sides, 
# that in fact makes the visibility region be a pyramid.
# This value should always be 3 or more.
int32 cone_sides

# The pose in which visibility is to be maintained.
# The frame id should represent the robot link to which the sensor is attached.
# It is assumed the sensor can look directly at the target, in any direction.
# This assumption is usually not true, but additional PositionConstraints
# can resolve this issue.
geometry_msgs/PoseStamped sensor_pose

# Even though the disc is maintained visible, the visibility cone can be very small
# because of the orientation of the disc with respect to the sensor. It is possible
# for example to view the disk almost from a side, in which case the visibility cone 
# can end up having close to 0 volume. The view angle is defined to be the angle between
# the normal to the visibility disc and the direction vector from the sensor origin.
# The value below represents the minimum desired view angle. For a perfect view,
# this value will be 0 (the two vectors are exact opposites). For a completely obstructed view
# this value will be Pi/2 (the vectors are perpendicular). This value defined below 
# is the maximum view angle to be maintained. This should be a value in the open interval
# (0, Pi/2). If 0 is set, the view angle is NOT enforced.
float64 max_view_angle

# This angle is used similarly to max_view_angle but limits the maximum angle
# between the sensor origin direction vector and the axis that connects the
# sensor origin to the target frame origin. The value is again in the range (0, Pi/2)
# and is NOT enforced if set to 0.
float64 max_range_angle

# The axis that is assumed to indicate the direction of view for the sensor
# X = 2, Y = 1, Z = 0
uint8 SENSOR_Z=0
uint8 SENSOR_Y=1
uint8 SENSOR_X=2
uint8 sensor_view_direction

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: moveit_msgs/PlanningOptions

# The diff to consider for the planning scene (optional)
PlanningScene planning_scene_diff

# If this flag is set to true, the action
# returns an executable plan in the response but does not attempt execution  
bool plan_only

# If this flag is set to true, the action of planning &
# executing is allowed to look around  (move sensors) if
# it seems that not enough information is available about
# the environment
bool look_around

# If this value is positive, the action of planning & executing
# is allowed to look around for a maximum number of attempts;
# If the value is left as 0, the default value is used, as set
# with dynamic_reconfigure
int32 look_around_attempts

# If set and if look_around is true, this value is used as
# the maximum cost allowed for a path to be considered executable.
# If the cost of a path is higher than this value, more sensing or 
# a new plan needed. If left as 0.0 but look_around is true, then 
# the default value set via dynamic_reconfigure is used
float64 max_safe_execution_cost

# If the plan becomes invalidated during execution, it is possible to have
# that plan recomputed and execution restarted. This flag enables this
# functionality 
bool replan

# The maximum number of replanning attempts 
int32 replan_attempts

# The amount of time to wait in between replanning attempts (in seconds)
float64 replan_delay

================================================================================
MSG: moveit_msgs/PlanningScene
# name of planning scene
string name

# full robot state
RobotState robot_state

# The name of the robot model this scene is for
string robot_model_name

#additional frames for duplicating tf (with respect to the planning frame)
geometry_msgs/TransformStamped[] fixed_frame_transforms

#full allowed collision matrix
AllowedCollisionMatrix allowed_collision_matrix

# all link paddings
LinkPadding[] link_padding

# all link scales
LinkScale[] link_scale

# Attached objects, collision objects, even the octomap or collision map can have 
# colors associated to them. This array specifies them.
ObjectColor[] object_colors

# the collision map
PlanningSceneWorld world

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
bool is_diff

================================================================================
MSG: moveit_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state

# Joints that may have multiple DOF are specified here
sensor_msgs/MultiDOFJointState multi_dof_joint_state

# Attached collision objects (attached to some link on the robot)
AttachedCollisionObject[] attached_collision_objects

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
# This is mostly important for handling the attached bodies (whether or not to clear the attached bodies
# of a moveit::core::RobotState before updating it with this message)
bool is_diff

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: sensor_msgs/MultiDOFJointState
# Representation of state for joints with multiple degrees of freedom, 
# following the structure of JointState.
#
# It is assumed that a joint in a system corresponds to a transform that gets applied 
# along the kinematic chain. For example, a planar joint (as in URDF) is 3DOF (x, y, yaw)
# and those 3DOF can be expressed as a transformation matrix, and that transformation
# matrix can be converted back to (x, y, yaw)
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# wrench associated with them, you can leave the wrench array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

Header header

string[] joint_names
geometry_msgs/Transform[] transforms
geometry_msgs/Twist[] twist
geometry_msgs/Wrench[] wrench

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: moveit_msgs/AttachedCollisionObject
# The CollisionObject will be attached with a fixed joint to this link
string link_name

#This contains the actual shapes and poses for the CollisionObject
#to be attached to the link
#If action is remove and no object.id is set, all objects
#attached to the link indicated by link_name will be removed
CollisionObject object

# The set of links that the attached objects are allowed to touch
# by default - the link_name is already considered by default
string[] touch_links

# If certain links were placed in a particular posture for this object to remain attached 
# (e.g., an end effector closing around an object), the posture necessary for releasing
# the object is stored here
trajectory_msgs/JointTrajectory detach_posture

# The weight of the attached object, if known
float64 weight

================================================================================
MSG: moveit_msgs/CollisionObject
# a header, used for interpreting the poses
Header header

# the id of the object (name used in MoveIt)
string id

# The object type in a database of known objects
object_recognition_msgs/ObjectType type

# the the collision geometries associated with the object;
# their poses are with respect to the specified header

# solid geometric primitives
shape_msgs/SolidPrimitive[] primitives
geometry_msgs/Pose[] primitive_poses

# meshes
shape_msgs/Mesh[] meshes
geometry_msgs/Pose[] mesh_poses

# bounding planes (equation is specified, but the plane can be oriented using an additional pose)
shape_msgs/Plane[] planes
geometry_msgs/Pose[] plane_poses

# Adds the object to the planning scene. If the object previously existed, it is replaced.
byte ADD=0

# Removes the object from the environment entirely (everything that matches the specified id)
byte REMOVE=1

# Append to an object that already exists in the planning scene. If the does not exist, it is added.
byte APPEND=2

# If an object already exists in the scene, new poses can be sent (the geometry arrays must be left empty)
# if solely moving the object is desired
byte MOVE=3

# Operation to be performed
byte operation

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: shape_msgs/Plane
# Representation of a plane, using the plane equation ax + by + cz + d = 0

# a := coef[0]
# b := coef[1]
# c := coef[2]
# d := coef[3]

float64[4] coef

================================================================================
MSG: geometry_msgs/TransformStamped
# This expresses a transform from coordinate frame header.frame_id
# to the coordinate frame child_frame_id
#
# This message is mostly used by the 
# <a href=\"http://www.ros.org/wiki/tf\">tf</a> package. 
# See its documentation for more information.

Header header
string child_frame_id # the frame id of the child frame
Transform transform

================================================================================
MSG: moveit_msgs/AllowedCollisionMatrix
# The list of entry names in the matrix
string[] entry_names

# The individual entries in the allowed collision matrix
# square, symmetric, with same order as entry_names
AllowedCollisionEntry[] entry_values

# In addition to the collision matrix itself, we also have 
# the default entry value for each entry name.

# If the allowed collision flag is queried for a pair of names (n1, n2)
# that is not found in the collision matrix itself, the value of
# the collision flag is considered to be that of the entry (n1 or n2)
# specified in the list below. If both n1 and n2 are found in the list 
# of defaults, the result is computed with an AND operation

string[] default_entry_names
bool[] default_entry_values

================================================================================
MSG: moveit_msgs/AllowedCollisionEntry
# whether or not collision checking is enabled
bool[] enabled

================================================================================
MSG: moveit_msgs/LinkPadding
#name for the link
string link_name

# padding to apply to the link
float64 padding

================================================================================
MSG: moveit_msgs/LinkScale
#name for the link
string link_name

# scaling to apply to the link
float64 scale

================================================================================
MSG: moveit_msgs/ObjectColor
# The object id for which we specify color
string id

# The value of the color
std_msgs/ColorRGBA color

================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

================================================================================
MSG: moveit_msgs/PlanningSceneWorld
# collision objects
CollisionObject[] collision_objects

# The octomap that represents additional collision data
octomap_msgs/OctomapWithPose octomap

================================================================================
MSG: octomap_msgs/OctomapWithPose
# A 3D map in binary format, as Octree
Header header

# The pose of the octree with respect to the header frame 
geometry_msgs/Pose origin

# The actual octree msg
octomap_msgs/Octomap octomap

================================================================================
MSG: octomap_msgs/Octomap
# A 3D map in binary format, as Octree
Header header

# Flag to denote a binary (only free/occupied) or full occupancy octree (.bt/.ot file)
bool binary

# Class id of the contained octree 
string id

# Resolution (in m) of the smallest octree nodes
float64 resolution

# binary serialization of octree, use conversions.h to read and write octrees
int8[] data

================================================================================
MSG: moveit_msgs/PlaceActionResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
PlaceResult result

================================================================================
MSG: actionlib_msgs/GoalStatus
GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: moveit_msgs/PlaceResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# The result of the pickup attempt
MoveItErrorCodes error_code

# The full starting state of the robot at the start of the trajectory
RobotState trajectory_start

# The trajectory that moved group produced for execution
RobotTrajectory[] trajectory_stages

string[] trajectory_descriptions

# The successful place location, if any
PlaceLocation place_location


================================================================================
MSG: moveit_msgs/MoveItErrorCodes
int32 val

# overall behavior
int32 SUCCESS=1
int32 FAILURE=99999

int32 PLANNING_FAILED=-1
int32 INVALID_MOTION_PLAN=-2
int32 MOTION_PLAN_INVALIDATED_BY_ENVIRONMENT_CHANGE=-3
int32 CONTROL_FAILED=-4
int32 UNABLE_TO_AQUIRE_SENSOR_DATA=-5
int32 TIMED_OUT=-6
int32 PREEMPTED=-7

# planning & kinematics request errors
int32 START_STATE_IN_COLLISION=-10
int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-11

int32 GOAL_IN_COLLISION=-12
int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-13
int32 GOAL_CONSTRAINTS_VIOLATED=-14

int32 INVALID_GROUP_NAME=-15
int32 INVALID_GOAL_CONSTRAINTS=-16
int32 INVALID_ROBOT_STATE=-17
int32 INVALID_LINK_NAME=-18
int32 INVALID_OBJECT_NAME=-19

# system errors
int32 FRAME_TRANSFORM_FAILURE=-21
int32 COLLISION_CHECKING_UNAVAILABLE=-22
int32 ROBOT_STATE_STALE=-23
int32 SENSOR_INFO_STALE=-24

# kinematics errors
int32 NO_IK_SOLUTION=-31

================================================================================
MSG: moveit_msgs/RobotTrajectory
trajectory_msgs/JointTrajectory joint_trajectory
trajectory_msgs/MultiDOFJointTrajectory multi_dof_joint_trajectory

================================================================================
MSG: trajectory_msgs/MultiDOFJointTrajectory
# The header is used to specify the coordinate frame and the reference time for the trajectory durations
Header header

# A representation of a multi-dof joint trajectory (each point is a transformation)
# Each point along the trajectory will include an array of positions/velocities/accelerations
# that has the same length as the array of joint names, and has the same order of joints as 
# the joint names array.

string[] joint_names
MultiDOFJointTrajectoryPoint[] points

================================================================================
MSG: trajectory_msgs/MultiDOFJointTrajectoryPoint
# Each multi-dof joint can specify a transform (up to 6 DOF)
geometry_msgs/Transform[] transforms

# There can be a velocity specified for the origin of the joint 
geometry_msgs/Twist[] velocities

# There can be an acceleration specified for the origin of the joint 
geometry_msgs/Twist[] accelerations

duration time_from_start

================================================================================
MSG: moveit_msgs/PlaceActionFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
PlaceFeedback feedback

================================================================================
MSG: moveit_msgs/PlaceFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# The internal state that the place action currently is in
string state


"
  end
  attr_accessor :action_goal, :action_result, :action_feedback

  @@struct_d7L3 = ::ROS::Struct.new("d7L3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_C3ldCldL3 = ::ROS::Struct.new("C3ldCldL3")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_d3f2L3 = ::ROS::Struct.new("d3f2L3")
  @@struct_f2 = ::ROS::Struct.new("f2")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_l = ::ROS::Struct.new("l")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_c = ::ROS::Struct.new("c")
  @@struct_d3f2 = ::ROS::Struct.new("d3f2")
  @@struct_lL3 = ::ROS::Struct.new("lL3")
  @@struct_f4 = ::ROS::Struct.new("f4")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_d2Cd = ::ROS::Struct.new("d2Cd")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['moveit_msgs/PlaceActionGoal','moveit_msgs/PlaceActionResult','moveit_msgs/PlaceActionFeedback']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [moveit_msgs/PlaceActionGoal] :action_goal initialize value
  # @option args [moveit_msgs/PlaceActionResult] :action_result initialize value
  # @option args [moveit_msgs/PlaceActionFeedback] :action_feedback initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:action_goal]
      @action_goal = args[:action_goal]
    else
      @action_goal = Moveit_msgs::PlaceActionGoal.new
    end
    if args[:action_result]
      @action_result = args[:action_result]
    else
      @action_result = Moveit_msgs::PlaceActionResult.new
    end
    if args[:action_feedback]
      @action_feedback = args[:action_feedback]
    else
      @action_feedback = Moveit_msgs::PlaceActionFeedback.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@action_goal.header.seq, @action_goal.header.stamp.secs, @action_goal.header.stamp.nsecs))
      _x = @action_goal.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_goal.goal_id.stamp.secs, @action_goal.goal_id.stamp.nsecs))
      _x = @action_goal.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @action_goal.goal.group_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @action_goal.goal.attached_object_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.place_locations.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.place_locations
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2565 = val1.post_place_posture
        _v2566 = _v2565.header
        buff.write(@@struct_L.pack(_v2566.seq))
        _v2567 = _v2566.stamp
        _x = _v2567
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2566.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v2565.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2565.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v2565.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2565.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v2568 = val3.time_from_start
          _x = _v2568
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        _v2569 = val1.place_pose
        _v2570 = _v2569.header
        buff.write(@@struct_L.pack(_v2570.seq))
        _v2571 = _v2570.stamp
        _x = _v2571
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2570.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2572 = _v2569.pose
        _v2573 = _v2572.position
        _x = _v2573
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2574 = _v2572.orientation
        _x = _v2574
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _v2575 = val1.pre_place_approach
        _v2576 = _v2575.direction
        _v2577 = _v2576.header
        buff.write(@@struct_L.pack(_v2577.seq))
        _v2578 = _v2577.stamp
        _x = _v2578
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2577.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2579 = _v2576.vector
        _x = _v2579
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v2575
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        _v2580 = val1.post_place_retreat
        _v2581 = _v2580.direction
        _v2582 = _v2581.header
        buff.write(@@struct_L.pack(_v2582.seq))
        _v2583 = _v2582.stamp
        _x = _v2583
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2582.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2584 = _v2581.vector
        _x = _v2584
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v2580
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        length = val1.allowed_touch_objects.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.allowed_touch_objects
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
      end
      buff.write(@@struct_C.pack(@action_goal.goal.place_eef))
      _x = @action_goal.goal.support_surface_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_goal.goal.allow_gripper_support_collision))
      _x = @action_goal.goal.path_constraints.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.path_constraints.joint_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.path_constraints.joint_constraints
        _x = val1.joint_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_d4.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
      end
      length = @action_goal.goal.path_constraints.position_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.path_constraints.position_constraints
        _v2585 = val1.header
        buff.write(@@struct_L.pack(_v2585.seq))
        _v2586 = _v2585.stamp
        _x = _v2586
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2585.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2587 = val1.target_point_offset
        _x = _v2587
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2588 = val1.constraint_region
        length = _v2588.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2588.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v2588.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2588.primitive_poses
          _v2589 = val3.position
          _x = _v2589
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2590 = val3.orientation
          _x = _v2590
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v2588.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2588.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v2588.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2588.mesh_poses
          _v2591 = val3.position
          _x = _v2591
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2592 = val3.orientation
          _x = _v2592
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      length = @action_goal.goal.path_constraints.orientation_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.path_constraints.orientation_constraints
        _v2593 = val1.header
        buff.write(@@struct_L.pack(_v2593.seq))
        _v2594 = _v2593.stamp
        _x = _v2594
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2593.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2595 = val1.orientation
        _x = _v2595
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_d4.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
      end
      length = @action_goal.goal.path_constraints.visibility_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.path_constraints.visibility_constraints
        buff.write(@@struct_d.pack(val1.target_radius))
        _v2596 = val1.target_pose
        _v2597 = _v2596.header
        buff.write(@@struct_L.pack(_v2597.seq))
        _v2598 = _v2597.stamp
        _x = _v2598
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2597.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2599 = _v2596.pose
        _v2600 = _v2599.position
        _x = _v2600
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2601 = _v2599.orientation
        _x = _v2601
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_l.pack(val1.cone_sides))
        _v2602 = val1.sensor_pose
        _v2603 = _v2602.header
        buff.write(@@struct_L.pack(_v2603.seq))
        _v2604 = _v2603.stamp
        _x = _v2604
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2603.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2605 = _v2602.pose
        _v2606 = _v2605.position
        _x = _v2606
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2607 = _v2605.orientation
        _x = _v2607
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(@@struct_d2Cd.pack(_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight))
      end
      _x = @action_goal.goal.planner_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.allowed_touch_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.allowed_touch_objects
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      buff.write(@@struct_d.pack(@action_goal.goal.allowed_planning_time))
      _x = @action_goal.goal.planning_options.planning_scene_diff.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.seq, @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.nsecs))
      _x = @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.position.pack(pattern))
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.velocity.pack(pattern))
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.seq, @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.nsecs))
      _x = @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms
        _v2608 = val1.translation
        _x = _v2608
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2609 = val1.rotation
        _x = _v2609
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist
        _v2610 = val1.linear
        _x = _v2610
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2611 = val1.angular
        _x = _v2611
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench
        _v2612 = val1.force
        _x = _v2612
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2613 = val1.torque
        _x = _v2613
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2614 = val1.object
        _v2615 = _v2614.header
        buff.write(@@struct_L.pack(_v2615.seq))
        _v2616 = _v2615.stamp
        _x = _v2616
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2615.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v2614.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2617 = _v2614.type
        _x = _v2617.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v2617.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v2614.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2614.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v2614.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2614.primitive_poses
          _v2618 = val3.position
          _x = _v2618
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2619 = val3.orientation
          _x = _v2619
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v2614.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2614.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v2614.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2614.mesh_poses
          _v2620 = val3.position
          _x = _v2620
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2621 = val3.orientation
          _x = _v2621
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v2614.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2614.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v2614.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2614.plane_poses
          _v2622 = val3.position
          _x = _v2622
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2623 = val3.orientation
          _x = _v2623
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v2614.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v2624 = val1.detach_posture
        _v2625 = _v2624.header
        buff.write(@@struct_L.pack(_v2625.seq))
        _v2626 = _v2625.stamp
        _x = _v2626
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2625.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v2624.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2624.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v2624.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2624.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v2627 = val3.time_from_start
          _x = _v2627
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_C.pack(@action_goal.goal.planning_options.planning_scene_diff.robot_state.is_diff))
      _x = @action_goal.goal.planning_options.planning_scene_diff.robot_model_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.planning_options.planning_scene_diff.fixed_frame_transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.fixed_frame_transforms
        _v2628 = val1.header
        buff.write(@@struct_L.pack(_v2628.seq))
        _v2629 = _v2628.stamp
        _x = _v2629
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2628.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.child_frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2630 = val1.transform
        _v2631 = _v2630.translation
        _x = _v2631
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2632 = _v2630.rotation
        _x = _v2632
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values
        length = val1.enabled.length
        buff.write(@@struct_L.pack(length))
        pattern = "C#{length}"
        buff.write(*val1.enabled.pack(pattern))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values.length
      buff.write(@@struct_L.pack(length))
      pattern = "C#{length}"
      buff.write(*@action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values.pack(pattern))
      length = @action_goal.goal.planning_options.planning_scene_diff.link_padding.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.link_padding
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_d.pack(val1.padding))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.link_scale.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.link_scale
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_d.pack(val1.scale))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.object_colors.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.object_colors
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2633 = val1.color
        _x = _v2633
        buff.write(@@struct_f4.pack(_x.r, _x.g, _x.b, _x.a))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.world.collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.world.collision_objects
        _v2634 = val1.header
        buff.write(@@struct_L.pack(_v2634.seq))
        _v2635 = _v2634.stamp
        _x = _v2635
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2634.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2636 = val1.type
        _x = _v2636.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v2636.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.primitives.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.primitives
          buff.write(@@struct_C.pack(val2.type))
          length = val2.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val2.dimensions.pack(pattern))
        end
        length = val1.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.primitive_poses
          _v2637 = val2.position
          _x = _v2637
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2638 = val2.orientation
          _x = _v2638
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.meshes.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.meshes
          length = val2.triangles.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.triangles
            buff.write(@@struct_L3.pack(*val3.vertex_indices))
          end
          length = val2.vertices.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.vertices
            _x = val3
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = val1.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.mesh_poses
          _v2639 = val2.position
          _x = _v2639
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2640 = val2.orientation
          _x = _v2640
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.planes.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.planes
          buff.write(@@struct_d4.pack(*val2.coef))
        end
        length = val1.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.plane_poses
          _v2641 = val2.position
          _x = _v2641
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2642 = val2.orientation
          _x = _v2642
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(val1.operation))
      end
      buff.write(@@struct_L3.pack(@action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.seq, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.stamp.nsecs))
      _x = @action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7L3.pack(@action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.position.x, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.position.y, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.position.z, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.x, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.y, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.z, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.w, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.seq, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.nsecs))
      _x = @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.binary))
      _x = @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d.pack(@action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.resolution))
      length = @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.data.length
      buff.write(@@struct_L.pack(length))
      pattern = "c#{length}"
      buff.write(*@action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.data.pack(pattern))
      buff.write(@@struct_C3ldCldL3.pack(@action_goal.goal.planning_options.planning_scene_diff.is_diff, @action_goal.goal.planning_options.plan_only, @action_goal.goal.planning_options.look_around, @action_goal.goal.planning_options.look_around_attempts, @action_goal.goal.planning_options.max_safe_execution_cost, @action_goal.goal.planning_options.replan, @action_goal.goal.planning_options.replan_attempts, @action_goal.goal.planning_options.replan_delay, @action_result.header.seq, @action_result.header.stamp.secs, @action_result.header.stamp.nsecs))
      _x = @action_result.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_result.status.goal_id.stamp.secs, @action_result.status.goal_id.stamp.nsecs))
      _x = @action_result.status.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_result.status.status))
      _x = @action_result.status.text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_lL3.pack(@action_result.result.error_code.val, @action_result.result.trajectory_start.joint_state.header.seq, @action_result.result.trajectory_start.joint_state.header.stamp.secs, @action_result.result.trajectory_start.joint_state.header.stamp.nsecs))
      _x = @action_result.result.trajectory_start.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_result.result.trajectory_start.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.trajectory_start.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_result.result.trajectory_start.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_result.result.trajectory_start.joint_state.position.pack(pattern))
      length = @action_result.result.trajectory_start.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_result.result.trajectory_start.joint_state.velocity.pack(pattern))
      length = @action_result.result.trajectory_start.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_result.result.trajectory_start.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@action_result.result.trajectory_start.multi_dof_joint_state.header.seq, @action_result.result.trajectory_start.multi_dof_joint_state.header.stamp.secs, @action_result.result.trajectory_start.multi_dof_joint_state.header.stamp.nsecs))
      _x = @action_result.result.trajectory_start.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_result.result.trajectory_start.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.trajectory_start.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_result.result.trajectory_start.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.trajectory_start.multi_dof_joint_state.transforms
        _v2643 = val1.translation
        _x = _v2643
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2644 = val1.rotation
        _x = _v2644
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @action_result.result.trajectory_start.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.trajectory_start.multi_dof_joint_state.twist
        _v2645 = val1.linear
        _x = _v2645
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2646 = val1.angular
        _x = _v2646
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @action_result.result.trajectory_start.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.trajectory_start.multi_dof_joint_state.wrench
        _v2647 = val1.force
        _x = _v2647
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2648 = val1.torque
        _x = _v2648
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @action_result.result.trajectory_start.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.trajectory_start.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2649 = val1.object
        _v2650 = _v2649.header
        buff.write(@@struct_L.pack(_v2650.seq))
        _v2651 = _v2650.stamp
        _x = _v2651
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2650.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v2649.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2652 = _v2649.type
        _x = _v2652.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v2652.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v2649.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2649.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v2649.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2649.primitive_poses
          _v2653 = val3.position
          _x = _v2653
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2654 = val3.orientation
          _x = _v2654
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v2649.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2649.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v2649.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2649.mesh_poses
          _v2655 = val3.position
          _x = _v2655
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2656 = val3.orientation
          _x = _v2656
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v2649.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2649.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v2649.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2649.plane_poses
          _v2657 = val3.position
          _x = _v2657
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2658 = val3.orientation
          _x = _v2658
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v2649.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v2659 = val1.detach_posture
        _v2660 = _v2659.header
        buff.write(@@struct_L.pack(_v2660.seq))
        _v2661 = _v2660.stamp
        _x = _v2661
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2660.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v2659.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2659.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v2659.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2659.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v2662 = val3.time_from_start
          _x = _v2662
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_C.pack(@action_result.result.trajectory_start.is_diff))
      length = @action_result.result.trajectory_stages.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.trajectory_stages
        _v2663 = val1.joint_trajectory
        _v2664 = _v2663.header
        buff.write(@@struct_L.pack(_v2664.seq))
        _v2665 = _v2664.stamp
        _x = _v2665
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2664.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v2663.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2663.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v2663.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2663.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v2666 = val3.time_from_start
          _x = _v2666
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        _v2667 = val1.multi_dof_joint_trajectory
        _v2668 = _v2667.header
        buff.write(@@struct_L.pack(_v2668.seq))
        _v2669 = _v2668.stamp
        _x = _v2669
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2668.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v2667.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2667.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v2667.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2667.points
          length = val3.transforms.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.transforms
            _v2670 = val4.translation
            _x = _v2670
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v2671 = val4.rotation
            _x = _v2671
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.velocities
            _v2672 = val4.linear
            _x = _v2672
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v2673 = val4.angular
            _x = _v2673
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.accelerations
            _v2674 = val4.linear
            _x = _v2674
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v2675 = val4.angular
            _x = _v2675
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
          _v2676 = val3.time_from_start
          _x = _v2676
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
      end
      length = @action_result.result.trajectory_descriptions.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.trajectory_descriptions
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      _x = @action_result.result.place_location.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@action_result.result.place_location.post_place_posture.header.seq, @action_result.result.place_location.post_place_posture.header.stamp.secs, @action_result.result.place_location.post_place_posture.header.stamp.nsecs))
      _x = @action_result.result.place_location.post_place_posture.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_result.result.place_location.post_place_posture.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.place_location.post_place_posture.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_result.result.place_location.post_place_posture.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.place_location.post_place_posture.points
        length = val1.positions.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.positions.pack(pattern))
        length = val1.velocities.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.velocities.pack(pattern))
        length = val1.accelerations.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.accelerations.pack(pattern))
        length = val1.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.effort.pack(pattern))
        _v2677 = val1.time_from_start
        _x = _v2677
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_L3.pack(@action_result.result.place_location.place_pose.header.seq, @action_result.result.place_location.place_pose.header.stamp.secs, @action_result.result.place_location.place_pose.header.stamp.nsecs))
      _x = @action_result.result.place_location.place_pose.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7L3.pack(@action_result.result.place_location.place_pose.pose.position.x, @action_result.result.place_location.place_pose.pose.position.y, @action_result.result.place_location.place_pose.pose.position.z, @action_result.result.place_location.place_pose.pose.orientation.x, @action_result.result.place_location.place_pose.pose.orientation.y, @action_result.result.place_location.place_pose.pose.orientation.z, @action_result.result.place_location.place_pose.pose.orientation.w, @action_result.result.place_location.pre_place_approach.direction.header.seq, @action_result.result.place_location.pre_place_approach.direction.header.stamp.secs, @action_result.result.place_location.pre_place_approach.direction.header.stamp.nsecs))
      _x = @action_result.result.place_location.pre_place_approach.direction.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3f2L3.pack(@action_result.result.place_location.pre_place_approach.direction.vector.x, @action_result.result.place_location.pre_place_approach.direction.vector.y, @action_result.result.place_location.pre_place_approach.direction.vector.z, @action_result.result.place_location.pre_place_approach.desired_distance, @action_result.result.place_location.pre_place_approach.min_distance, @action_result.result.place_location.post_place_retreat.direction.header.seq, @action_result.result.place_location.post_place_retreat.direction.header.stamp.secs, @action_result.result.place_location.post_place_retreat.direction.header.stamp.nsecs))
      _x = @action_result.result.place_location.post_place_retreat.direction.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3f2.pack(@action_result.result.place_location.post_place_retreat.direction.vector.x, @action_result.result.place_location.post_place_retreat.direction.vector.y, @action_result.result.place_location.post_place_retreat.direction.vector.z, @action_result.result.place_location.post_place_retreat.desired_distance, @action_result.result.place_location.post_place_retreat.min_distance))
      length = @action_result.result.place_location.allowed_touch_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.place_location.allowed_touch_objects
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      buff.write(@@struct_L3.pack(@action_feedback.header.seq, @action_feedback.header.stamp.secs, @action_feedback.header.stamp.nsecs))
      _x = @action_feedback.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_feedback.status.goal_id.stamp.secs, @action_feedback.status.goal_id.stamp.nsecs))
      _x = @action_feedback.status.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_feedback.status.status))
      _x = @action_feedback.status.text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @action_feedback.feedback.state
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @action_goal == nil
        @action_goal = Moveit_msgs::PlaceActionGoal.new
      end
      if @action_result == nil
        @action_result = Moveit_msgs::PlaceActionResult.new
      end
      if @action_feedback == nil
        @action_feedback = Moveit_msgs::PlaceActionFeedback.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.header.seq, @action_goal.header.stamp.secs, @action_goal.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_goal.goal_id.stamp.secs, @action_goal.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.group_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.attached_object_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.place_locations = []
      length.times do
        val1 = Moveit_msgs::PlaceLocation.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v2678 = val1.post_place_posture
        _v2679 = _v2678.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2679.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2680 = _v2679.stamp
        _x = _v2680
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2679.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2678.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v2678.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2678.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v2681 = val3.time_from_start
          _x = _v2681
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v2678.points.push(val3)
        end
        _v2682 = val1.place_pose
        _v2683 = _v2682.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2683.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2684 = _v2683.stamp
        _x = _v2684
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2683.frame_id = str[start..(end_point-1)]
        _v2685 = _v2682.pose
        _v2686 = _v2685.position
        _x = _v2686
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2687 = _v2685.orientation
        _x = _v2687
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        _v2688 = val1.pre_place_approach
        _v2689 = _v2688.direction
        _v2690 = _v2689.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2690.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2691 = _v2690.stamp
        _x = _v2691
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2690.frame_id = str[start..(end_point-1)]
        _v2692 = _v2689.vector
        _x = _v2692
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v2688
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        _v2693 = val1.post_place_retreat
        _v2694 = _v2693.direction
        _v2695 = _v2694.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2695.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2696 = _v2695.stamp
        _x = _v2696
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2695.frame_id = str[start..(end_point-1)]
        _v2697 = _v2694.vector
        _x = _v2697
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v2693
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.allowed_touch_objects = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.allowed_touch_objects.push(val2)
        end
        @action_goal.goal.place_locations.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_goal.goal.place_eef,) = @@struct_C.unpack(str[start..(end_point-1)])
      @action_goal.goal.place_eef = bool(@action_goal.goal.place_eef)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.support_surface_name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_goal.goal.allow_gripper_support_collision,) = @@struct_C.unpack(str[start..(end_point-1)])
      @action_goal.goal.allow_gripper_support_collision = bool(@action_goal.goal.allow_gripper_support_collision)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.path_constraints.name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.path_constraints.joint_constraints = []
      length.times do
        val1 = Moveit_msgs::JointConstraint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.joint_name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @action_goal.goal.path_constraints.joint_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.path_constraints.position_constraints = []
      length.times do
        val1 = Moveit_msgs::PositionConstraint.new
        _v2698 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2698.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2699 = _v2698.stamp
        _x = _v2699
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2698.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v2700 = val1.target_point_offset
        _x = _v2700
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2701 = val1.constraint_region
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2701.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v2701.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2701.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v2702 = val3.position
          _x = _v2702
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2703 = val3.orientation
          _x = _v2703
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2701.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2701.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v2701.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2701.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v2704 = val3.position
          _x = _v2704
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2705 = val3.orientation
          _x = _v2705
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2701.mesh_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @action_goal.goal.path_constraints.position_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.path_constraints.orientation_constraints = []
      length.times do
        val1 = Moveit_msgs::OrientationConstraint.new
        _v2706 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2706.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2707 = _v2706.stamp
        _x = _v2707
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2706.frame_id = str[start..(end_point-1)]
        _v2708 = val1.orientation
        _x = _v2708
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @action_goal.goal.path_constraints.orientation_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.path_constraints.visibility_constraints = []
      length.times do
        val1 = Moveit_msgs::VisibilityConstraint.new
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.target_radius,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v2709 = val1.target_pose
        _v2710 = _v2709.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2710.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2711 = _v2710.stamp
        _x = _v2711
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2710.frame_id = str[start..(end_point-1)]
        _v2712 = _v2709.pose
        _v2713 = _v2712.position
        _x = _v2713
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2714 = _v2712.orientation
        _x = _v2714
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('l')
        (val1.cone_sides,) = @@struct_l.unpack(str[start..(end_point-1)])
        _v2715 = val1.sensor_pose
        _v2716 = _v2715.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2716.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2717 = _v2716.stamp
        _x = _v2717
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2716.frame_id = str[start..(end_point-1)]
        _v2718 = _v2715.pose
        _v2719 = _v2718.position
        _x = _v2719
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2720 = _v2718.orientation
        _x = _v2720
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d2Cd')
        (_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight,) = @@struct_d2Cd.unpack(str[start..(end_point-1)])
        @action_goal.goal.path_constraints.visibility_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planner_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.allowed_touch_objects = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_goal.goal.allowed_touch_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('d')
      (@action_goal.goal.allowed_planning_time,) = @@struct_d.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planning_options.planning_scene_diff.name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.seq, @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.seq, @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v2721 = val1.translation
        _x = _v2721
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2722 = val1.rotation
        _x = _v2722
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v2723 = val1.linear
        _x = _v2723
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2724 = val1.angular
        _x = _v2724
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v2725 = val1.force
        _x = _v2725
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2726 = val1.torque
        _x = _v2726
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v2727 = val1.object
        _v2728 = _v2727.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2728.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2729 = _v2728.stamp
        _x = _v2729
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2728.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2727.id = str[start..(end_point-1)]
        _v2730 = _v2727.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2730.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2730.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2727.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v2727.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2727.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v2731 = val3.position
          _x = _v2731
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2732 = val3.orientation
          _x = _v2732
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2727.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2727.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v2727.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2727.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v2733 = val3.position
          _x = _v2733
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2734 = val3.orientation
          _x = _v2734
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2727.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2727.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2727.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2727.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v2735 = val3.position
          _x = _v2735
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2736 = val3.orientation
          _x = _v2736
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2727.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v2727.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v2737 = val1.detach_posture
        _v2738 = _v2737.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2738.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2739 = _v2738.stamp
        _x = _v2739
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2738.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2737.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v2737.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2737.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v2740 = val3.time_from_start
          _x = _v2740
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v2737.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_goal.goal.planning_options.planning_scene_diff.robot_state.is_diff,) = @@struct_C.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.is_diff = bool(@action_goal.goal.planning_options.planning_scene_diff.robot_state.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planning_options.planning_scene_diff.robot_model_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.fixed_frame_transforms = []
      length.times do
        val1 = Geometry_msgs::TransformStamped.new
        _v2741 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2741.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2742 = _v2741.stamp
        _x = _v2742
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2741.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.child_frame_id = str[start..(end_point-1)]
        _v2743 = val1.transform
        _v2744 = _v2743.translation
        _x = _v2744
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2745 = _v2743.rotation
        _x = _v2745
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.fixed_frame_transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values = []
      length.times do
        val1 = Moveit_msgs::AllowedCollisionEntry.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "C#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.enabled = str[start..(end_point-1)].unpack(pattern)
        val1.enabled = map(bool, val1.enabled)
        @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "C#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values = str[start..(end_point-1)].unpack(pattern)
      @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values = map(bool, @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.link_padding = []
      length.times do
        val1 = Moveit_msgs::LinkPadding.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.padding,) = @@struct_d.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.link_padding.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.link_scale = []
      length.times do
        val1 = Moveit_msgs::LinkScale.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.scale,) = @@struct_d.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.link_scale.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.object_colors = []
      length.times do
        val1 = Moveit_msgs::ObjectColor.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v2746 = val1.color
        _x = _v2746
        start = end_point
        end_point += ROS::Struct::calc_size('f4')
        (_x.r, _x.g, _x.b, _x.a,) = @@struct_f4.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.object_colors.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.world.collision_objects = []
      length.times do
        val1 = Moveit_msgs::CollisionObject.new
        _v2747 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2747.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2748 = _v2747.stamp
        _x = _v2748
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2747.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v2749 = val1.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2749.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2749.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.primitives = []
        length.times do
          val2 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val2.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val2.dimensions = str[start..(end_point-1)].unpack(pattern)
          val1.primitives.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.primitive_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v2750 = val2.position
          _x = _v2750
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2751 = val2.orientation
          _x = _v2751
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.primitive_poses.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.meshes = []
        length.times do
          val2 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.triangles = []
          length.times do
            val3 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val3.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val2.triangles.push(val3)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.vertices = []
          length.times do
            val3 = Geometry_msgs::Point.new
            _x = val3
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val2.vertices.push(val3)
          end
          val1.meshes.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.mesh_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v2752 = val2.position
          _x = _v2752
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2753 = val2.orientation
          _x = _v2753
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.mesh_poses.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.planes = []
        length.times do
          val2 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val2.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.planes.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.plane_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v2754 = val2.position
          _x = _v2754
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2755 = val2.orientation
          _x = _v2755
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.plane_poses.push(val2)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (val1.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.world.collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.seq, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7L3')
      (@action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.position.x, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.position.y, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.position.z, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.x, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.y, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.z, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.w, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.seq, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.nsecs,) = @@struct_d7L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.binary,) = @@struct_C.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.binary = bool(@action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.binary)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d')
      (@action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.resolution,) = @@struct_d.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "c#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.data = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('C3ldCldL3')
      (@action_goal.goal.planning_options.planning_scene_diff.is_diff, @action_goal.goal.planning_options.plan_only, @action_goal.goal.planning_options.look_around, @action_goal.goal.planning_options.look_around_attempts, @action_goal.goal.planning_options.max_safe_execution_cost, @action_goal.goal.planning_options.replan, @action_goal.goal.planning_options.replan_attempts, @action_goal.goal.planning_options.replan_delay, @action_result.header.seq, @action_result.header.stamp.secs, @action_result.header.stamp.nsecs,) = @@struct_C3ldCldL3.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.is_diff = bool(@action_goal.goal.planning_options.planning_scene_diff.is_diff)
      @action_goal.goal.planning_options.plan_only = bool(@action_goal.goal.planning_options.plan_only)
      @action_goal.goal.planning_options.look_around = bool(@action_goal.goal.planning_options.look_around)
      @action_goal.goal.planning_options.replan = bool(@action_goal.goal.planning_options.replan)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_result.status.goal_id.stamp.secs, @action_result.status.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.status.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_result.status.status,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.status.text = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('lL3')
      (@action_result.result.error_code.val, @action_result.result.trajectory_start.joint_state.header.seq, @action_result.result.trajectory_start.joint_state.header.stamp.secs, @action_result.result.trajectory_start.joint_state.header.stamp.nsecs,) = @@struct_lL3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.trajectory_start.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_start.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_result.result.trajectory_start.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_result.result.trajectory_start.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_result.result.trajectory_start.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_result.result.trajectory_start.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_result.result.trajectory_start.multi_dof_joint_state.header.seq, @action_result.result.trajectory_start.multi_dof_joint_state.header.stamp.secs, @action_result.result.trajectory_start.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.trajectory_start.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_start.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_result.result.trajectory_start.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_start.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v2756 = val1.translation
        _x = _v2756
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2757 = val1.rotation
        _x = _v2757
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @action_result.result.trajectory_start.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_start.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v2758 = val1.linear
        _x = _v2758
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2759 = val1.angular
        _x = _v2759
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @action_result.result.trajectory_start.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_start.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v2760 = val1.force
        _x = _v2760
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2761 = val1.torque
        _x = _v2761
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @action_result.result.trajectory_start.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_start.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v2762 = val1.object
        _v2763 = _v2762.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2763.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2764 = _v2763.stamp
        _x = _v2764
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2763.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2762.id = str[start..(end_point-1)]
        _v2765 = _v2762.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2765.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2765.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2762.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v2762.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2762.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v2766 = val3.position
          _x = _v2766
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2767 = val3.orientation
          _x = _v2767
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2762.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2762.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v2762.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2762.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v2768 = val3.position
          _x = _v2768
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2769 = val3.orientation
          _x = _v2769
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2762.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2762.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2762.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2762.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v2770 = val3.position
          _x = _v2770
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2771 = val3.orientation
          _x = _v2771
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2762.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v2762.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v2772 = val1.detach_posture
        _v2773 = _v2772.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2773.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2774 = _v2773.stamp
        _x = _v2774
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2773.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2772.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v2772.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2772.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v2775 = val3.time_from_start
          _x = _v2775
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v2772.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @action_result.result.trajectory_start.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_result.result.trajectory_start.is_diff,) = @@struct_C.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_start.is_diff = bool(@action_result.result.trajectory_start.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_stages = []
      length.times do
        val1 = Moveit_msgs::RobotTrajectory.new
        _v2776 = val1.joint_trajectory
        _v2777 = _v2776.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2777.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2778 = _v2777.stamp
        _x = _v2778
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2777.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2776.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v2776.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2776.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v2779 = val3.time_from_start
          _x = _v2779
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v2776.points.push(val3)
        end
        _v2780 = val1.multi_dof_joint_trajectory
        _v2781 = _v2780.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2781.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2782 = _v2781.stamp
        _x = _v2782
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2781.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2780.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v2780.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2780.points = []
        length.times do
          val3 = Trajectory_msgs::MultiDOFJointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.transforms = []
          length.times do
            val4 = Geometry_msgs::Transform.new
            _v2783 = val4.translation
            _x = _v2783
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v2784 = val4.rotation
            _x = _v2784
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            val3.transforms.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.velocities = []
          length.times do
            val4 = Geometry_msgs::Twist.new
            _v2785 = val4.linear
            _x = _v2785
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v2786 = val4.angular
            _x = _v2786
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.velocities.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.accelerations = []
          length.times do
            val4 = Geometry_msgs::Twist.new
            _v2787 = val4.linear
            _x = _v2787
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v2788 = val4.angular
            _x = _v2788
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.accelerations.push(val4)
          end
          _v2789 = val3.time_from_start
          _x = _v2789
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v2780.points.push(val3)
        end
        @action_result.result.trajectory_stages.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_descriptions = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_result.result.trajectory_descriptions.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.place_location.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_result.result.place_location.post_place_posture.header.seq, @action_result.result.place_location.post_place_posture.header.stamp.secs, @action_result.result.place_location.post_place_posture.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.place_location.post_place_posture.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.place_location.post_place_posture.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_result.result.place_location.post_place_posture.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.place_location.post_place_posture.points = []
      length.times do
        val1 = Trajectory_msgs::JointTrajectoryPoint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.positions = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.velocities = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.accelerations = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.effort = str[start..(end_point-1)].unpack(pattern)
        _v2790 = val1.time_from_start
        _x = _v2790
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @action_result.result.place_location.post_place_posture.points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_result.result.place_location.place_pose.header.seq, @action_result.result.place_location.place_pose.header.stamp.secs, @action_result.result.place_location.place_pose.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.place_location.place_pose.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7L3')
      (@action_result.result.place_location.place_pose.pose.position.x, @action_result.result.place_location.place_pose.pose.position.y, @action_result.result.place_location.place_pose.pose.position.z, @action_result.result.place_location.place_pose.pose.orientation.x, @action_result.result.place_location.place_pose.pose.orientation.y, @action_result.result.place_location.place_pose.pose.orientation.z, @action_result.result.place_location.place_pose.pose.orientation.w, @action_result.result.place_location.pre_place_approach.direction.header.seq, @action_result.result.place_location.pre_place_approach.direction.header.stamp.secs, @action_result.result.place_location.pre_place_approach.direction.header.stamp.nsecs,) = @@struct_d7L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.place_location.pre_place_approach.direction.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3f2L3')
      (@action_result.result.place_location.pre_place_approach.direction.vector.x, @action_result.result.place_location.pre_place_approach.direction.vector.y, @action_result.result.place_location.pre_place_approach.direction.vector.z, @action_result.result.place_location.pre_place_approach.desired_distance, @action_result.result.place_location.pre_place_approach.min_distance, @action_result.result.place_location.post_place_retreat.direction.header.seq, @action_result.result.place_location.post_place_retreat.direction.header.stamp.secs, @action_result.result.place_location.post_place_retreat.direction.header.stamp.nsecs,) = @@struct_d3f2L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.place_location.post_place_retreat.direction.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3f2')
      (@action_result.result.place_location.post_place_retreat.direction.vector.x, @action_result.result.place_location.post_place_retreat.direction.vector.y, @action_result.result.place_location.post_place_retreat.direction.vector.z, @action_result.result.place_location.post_place_retreat.desired_distance, @action_result.result.place_location.post_place_retreat.min_distance,) = @@struct_d3f2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.place_location.allowed_touch_objects = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_result.result.place_location.allowed_touch_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_feedback.header.seq, @action_feedback.header.stamp.secs, @action_feedback.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_feedback.status.goal_id.stamp.secs, @action_feedback.status.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.status.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_feedback.status.status,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.status.text = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.feedback.state = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
