# autogenerated by genrb from PlaceActionGoal.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "geometry_msgs/Vector3Stamped"
require "geometry_msgs/Transform"
require "moveit_msgs/PlanningSceneWorld"
require "moveit_msgs/VisibilityConstraint"
require "moveit_msgs/GripperTranslation"
require "octomap_msgs/Octomap"
require "moveit_msgs/Constraints"
require "geometry_msgs/Point"
require "moveit_msgs/OrientationConstraint"
require "shape_msgs/Mesh"
require "std_msgs/ColorRGBA"
require "moveit_msgs/LinkScale"
require "moveit_msgs/PositionConstraint"
require "shape_msgs/Plane"
require "moveit_msgs/AllowedCollisionEntry"
require "geometry_msgs/PoseStamped"
require "moveit_msgs/PlanningOptions"
require "moveit_msgs/ObjectColor"
require "ros/duration"
require "moveit_msgs/BoundingVolume"
require "moveit_msgs/JointConstraint"
require "std_msgs/Header"
require "moveit_msgs/PlaceGoal"
require "sensor_msgs/MultiDOFJointState"
require "geometry_msgs/Pose"
require "shape_msgs/MeshTriangle"
require "shape_msgs/SolidPrimitive"
require "geometry_msgs/Wrench"
require "moveit_msgs/AllowedCollisionMatrix"
require "geometry_msgs/TransformStamped"
require "moveit_msgs/PlaceLocation"
require "moveit_msgs/RobotState"
require "moveit_msgs/PlanningScene"
require "octomap_msgs/OctomapWithPose"
require "trajectory_msgs/JointTrajectory"
require "sensor_msgs/JointState"
require "trajectory_msgs/JointTrajectoryPoint"
require "moveit_msgs/LinkPadding"
require "object_recognition_msgs/ObjectType"
require "actionlib_msgs/GoalID"
require "geometry_msgs/Twist"
require "moveit_msgs/AttachedCollisionObject"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "moveit_msgs/CollisionObject"

module Moveit_msgs

class PlaceActionGoal <::ROS::Message
  def self.md5sum
    "facadaee390f685ed5e693ac12f5aa3d"
  end

  def self.type
    "moveit_msgs/PlaceActionGoal"
  end

  def has_header?
    true
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalID goal_id
PlaceGoal goal

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: moveit_msgs/PlaceGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# An action for placing an object

# which group to be used to plan for grasping
string group_name

# the name that the attached object to place
string attached_object_name

# a list of possible transformations for placing the object
PlaceLocation[] place_locations

# if the user prefers setting the eef pose (same as in pick) rather than 
# the location of an end effector, this flag should be set to true
bool place_eef

# the name that the support surface (e.g. table) has in the collision world
# can be left empty if no name is available
string support_surface_name

# whether collisions between the gripper and the support surface should be acceptable
# during move from pre-place to place and during retreat. Collisions when moving to the
# pre-place location are still not allowed even if this is set to true.
bool allow_gripper_support_collision

# Optional constraints to be imposed on every point in the motion plan
Constraints path_constraints

# The name of the motion planner to use. If no name is specified,
# a default motion planner will be used
string planner_id

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping;
# CAREFUL: If the object name 'all' is used, collisions with all objects are disabled during the approach & lift.
string[] allowed_touch_objects

# The maximum amount of time the motion planner is allowed to plan for
float64 allowed_planning_time

# Planning options
PlanningOptions planning_options


================================================================================
MSG: moveit_msgs/PlaceLocation
# A name for this grasp
string id

# The internal posture of the hand for the grasp
# positions and efforts are used
trajectory_msgs/JointTrajectory post_place_posture

# The position of the end-effector for the grasp relative to a reference frame 
# (that is always specified elsewhere, not in this message)
geometry_msgs/PoseStamped place_pose

# The approach motion
GripperTranslation pre_place_approach

# The retreat motion
GripperTranslation post_place_retreat

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping
string[] allowed_touch_objects

================================================================================
MSG: trajectory_msgs/JointTrajectory
Header header
string[] joint_names
JointTrajectoryPoint[] points
================================================================================
MSG: trajectory_msgs/JointTrajectoryPoint
# Each trajectory point specifies either positions[, velocities[, accelerations]]
# or positions[, effort] for the trajectory to be executed.
# All specified values are in the same order as the joint names in JointTrajectory.msg

float64[] positions
float64[] velocities
float64[] accelerations
float64[] effort
duration time_from_start

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: moveit_msgs/GripperTranslation
# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: moveit_msgs/Constraints
# This message contains a list of motion planning constraints.
# All constraints must be satisfied for a goal to be considered valid

string name

JointConstraint[] joint_constraints

PositionConstraint[] position_constraints

OrientationConstraint[] orientation_constraints

VisibilityConstraint[] visibility_constraints

================================================================================
MSG: moveit_msgs/JointConstraint
# Constrain the position of a joint to be within a certain bound
string joint_name

# the bound to be achieved is [position - tolerance_below, position + tolerance_above]
float64 position
float64 tolerance_above
float64 tolerance_below

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight
================================================================================
MSG: moveit_msgs/PositionConstraint
# This message contains the definition of a position constraint.

Header header

# The robot link this constraint refers to
string link_name

# The offset (in the link frame) for the target point on the link we are planning for
geometry_msgs/Vector3 target_point_offset

# The volume this constraint refers to 
BoundingVolume constraint_region

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: moveit_msgs/BoundingVolume
# Define a volume in 3D

# A set of solid geometric primitives that make up the volume to define (as a union)
shape_msgs/SolidPrimitive[] primitives

# The poses at which the primitives are located
geometry_msgs/Pose[] primitive_poses

# In addition to primitives, meshes can be specified to add to the bounding volume (again, as union)
shape_msgs/Mesh[] meshes

# The poses at which the meshes are located
geometry_msgs/Pose[] mesh_poses

================================================================================
MSG: shape_msgs/SolidPrimitive
# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: moveit_msgs/OrientationConstraint
# This message contains the definition of an orientation constraint.

Header header

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# The robot link this constraint refers to
string link_name

# optional axis-angle error tolerances specified
float64 absolute_x_axis_tolerance
float64 absolute_y_axis_tolerance
float64 absolute_z_axis_tolerance

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: moveit_msgs/VisibilityConstraint
# The constraint is useful to maintain visibility to a disc (the target) in a particular frame.
# This disc forms the base of a visibiliy cone whose tip is at the origin of the sensor.
# Maintaining visibility is done by ensuring the robot does not obstruct the visibility cone.
# Note:
# This constraint does NOT enforce minimum or maximum distances between the sensor
# and the target, nor does it enforce the target to be in the field of view of
# the sensor. A PositionConstraint can (and probably should) be used for such purposes.

# The radius of the disc that should be maintained visible 
float64 target_radius

# The pose of the disc; as the robot moves, the pose of the disc may change as well
# This can be in the frame of a particular robot link, for example
geometry_msgs/PoseStamped target_pose

# From the sensor origin towards the target, the disc forms a visibility cone
# This cone is approximated using many sides. For example, when using 4 sides, 
# that in fact makes the visibility region be a pyramid.
# This value should always be 3 or more.
int32 cone_sides

# The pose in which visibility is to be maintained.
# The frame id should represent the robot link to which the sensor is attached.
# It is assumed the sensor can look directly at the target, in any direction.
# This assumption is usually not true, but additional PositionConstraints
# can resolve this issue.
geometry_msgs/PoseStamped sensor_pose

# Even though the disc is maintained visible, the visibility cone can be very small
# because of the orientation of the disc with respect to the sensor. It is possible
# for example to view the disk almost from a side, in which case the visibility cone 
# can end up having close to 0 volume. The view angle is defined to be the angle between
# the normal to the visibility disc and the direction vector from the sensor origin.
# The value below represents the minimum desired view angle. For a perfect view,
# this value will be 0 (the two vectors are exact opposites). For a completely obstructed view
# this value will be Pi/2 (the vectors are perpendicular). This value defined below 
# is the maximum view angle to be maintained. This should be a value in the open interval
# (0, Pi/2). If 0 is set, the view angle is NOT enforced.
float64 max_view_angle

# This angle is used similarly to max_view_angle but limits the maximum angle
# between the sensor origin direction vector and the axis that connects the
# sensor origin to the target frame origin. The value is again in the range (0, Pi/2)
# and is NOT enforced if set to 0.
float64 max_range_angle

# The axis that is assumed to indicate the direction of view for the sensor
# X = 2, Y = 1, Z = 0
uint8 SENSOR_Z=0
uint8 SENSOR_Y=1
uint8 SENSOR_X=2
uint8 sensor_view_direction

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: moveit_msgs/PlanningOptions

# The diff to consider for the planning scene (optional)
PlanningScene planning_scene_diff

# If this flag is set to true, the action
# returns an executable plan in the response but does not attempt execution  
bool plan_only

# If this flag is set to true, the action of planning &
# executing is allowed to look around  (move sensors) if
# it seems that not enough information is available about
# the environment
bool look_around

# If this value is positive, the action of planning & executing
# is allowed to look around for a maximum number of attempts;
# If the value is left as 0, the default value is used, as set
# with dynamic_reconfigure
int32 look_around_attempts

# If set and if look_around is true, this value is used as
# the maximum cost allowed for a path to be considered executable.
# If the cost of a path is higher than this value, more sensing or 
# a new plan needed. If left as 0.0 but look_around is true, then 
# the default value set via dynamic_reconfigure is used
float64 max_safe_execution_cost

# If the plan becomes invalidated during execution, it is possible to have
# that plan recomputed and execution restarted. This flag enables this
# functionality 
bool replan

# The maximum number of replanning attempts 
int32 replan_attempts

# The amount of time to wait in between replanning attempts (in seconds)
float64 replan_delay

================================================================================
MSG: moveit_msgs/PlanningScene
# name of planning scene
string name

# full robot state
RobotState robot_state

# The name of the robot model this scene is for
string robot_model_name

#additional frames for duplicating tf (with respect to the planning frame)
geometry_msgs/TransformStamped[] fixed_frame_transforms

#full allowed collision matrix
AllowedCollisionMatrix allowed_collision_matrix

# all link paddings
LinkPadding[] link_padding

# all link scales
LinkScale[] link_scale

# Attached objects, collision objects, even the octomap or collision map can have 
# colors associated to them. This array specifies them.
ObjectColor[] object_colors

# the collision map
PlanningSceneWorld world

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
bool is_diff

================================================================================
MSG: moveit_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state

# Joints that may have multiple DOF are specified here
sensor_msgs/MultiDOFJointState multi_dof_joint_state

# Attached collision objects (attached to some link on the robot)
AttachedCollisionObject[] attached_collision_objects

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
# This is mostly important for handling the attached bodies (whether or not to clear the attached bodies
# of a moveit::core::RobotState before updating it with this message)
bool is_diff

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: sensor_msgs/MultiDOFJointState
# Representation of state for joints with multiple degrees of freedom, 
# following the structure of JointState.
#
# It is assumed that a joint in a system corresponds to a transform that gets applied 
# along the kinematic chain. For example, a planar joint (as in URDF) is 3DOF (x, y, yaw)
# and those 3DOF can be expressed as a transformation matrix, and that transformation
# matrix can be converted back to (x, y, yaw)
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# wrench associated with them, you can leave the wrench array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

Header header

string[] joint_names
geometry_msgs/Transform[] transforms
geometry_msgs/Twist[] twist
geometry_msgs/Wrench[] wrench

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: moveit_msgs/AttachedCollisionObject
# The CollisionObject will be attached with a fixed joint to this link
string link_name

#This contains the actual shapes and poses for the CollisionObject
#to be attached to the link
#If action is remove and no object.id is set, all objects
#attached to the link indicated by link_name will be removed
CollisionObject object

# The set of links that the attached objects are allowed to touch
# by default - the link_name is already considered by default
string[] touch_links

# If certain links were placed in a particular posture for this object to remain attached 
# (e.g., an end effector closing around an object), the posture necessary for releasing
# the object is stored here
trajectory_msgs/JointTrajectory detach_posture

# The weight of the attached object, if known
float64 weight

================================================================================
MSG: moveit_msgs/CollisionObject
# a header, used for interpreting the poses
Header header

# the id of the object (name used in MoveIt)
string id

# The object type in a database of known objects
object_recognition_msgs/ObjectType type

# the the collision geometries associated with the object;
# their poses are with respect to the specified header

# solid geometric primitives
shape_msgs/SolidPrimitive[] primitives
geometry_msgs/Pose[] primitive_poses

# meshes
shape_msgs/Mesh[] meshes
geometry_msgs/Pose[] mesh_poses

# bounding planes (equation is specified, but the plane can be oriented using an additional pose)
shape_msgs/Plane[] planes
geometry_msgs/Pose[] plane_poses

# Adds the object to the planning scene. If the object previously existed, it is replaced.
byte ADD=0

# Removes the object from the environment entirely (everything that matches the specified id)
byte REMOVE=1

# Append to an object that already exists in the planning scene. If the does not exist, it is added.
byte APPEND=2

# If an object already exists in the scene, new poses can be sent (the geometry arrays must be left empty)
# if solely moving the object is desired
byte MOVE=3

# Operation to be performed
byte operation

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: shape_msgs/Plane
# Representation of a plane, using the plane equation ax + by + cz + d = 0

# a := coef[0]
# b := coef[1]
# c := coef[2]
# d := coef[3]

float64[4] coef

================================================================================
MSG: geometry_msgs/TransformStamped
# This expresses a transform from coordinate frame header.frame_id
# to the coordinate frame child_frame_id
#
# This message is mostly used by the 
# <a href=\"http://www.ros.org/wiki/tf\">tf</a> package. 
# See its documentation for more information.

Header header
string child_frame_id # the frame id of the child frame
Transform transform

================================================================================
MSG: moveit_msgs/AllowedCollisionMatrix
# The list of entry names in the matrix
string[] entry_names

# The individual entries in the allowed collision matrix
# square, symmetric, with same order as entry_names
AllowedCollisionEntry[] entry_values

# In addition to the collision matrix itself, we also have 
# the default entry value for each entry name.

# If the allowed collision flag is queried for a pair of names (n1, n2)
# that is not found in the collision matrix itself, the value of
# the collision flag is considered to be that of the entry (n1 or n2)
# specified in the list below. If both n1 and n2 are found in the list 
# of defaults, the result is computed with an AND operation

string[] default_entry_names
bool[] default_entry_values

================================================================================
MSG: moveit_msgs/AllowedCollisionEntry
# whether or not collision checking is enabled
bool[] enabled

================================================================================
MSG: moveit_msgs/LinkPadding
#name for the link
string link_name

# padding to apply to the link
float64 padding

================================================================================
MSG: moveit_msgs/LinkScale
#name for the link
string link_name

# scaling to apply to the link
float64 scale

================================================================================
MSG: moveit_msgs/ObjectColor
# The object id for which we specify color
string id

# The value of the color
std_msgs/ColorRGBA color

================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

================================================================================
MSG: moveit_msgs/PlanningSceneWorld
# collision objects
CollisionObject[] collision_objects

# The octomap that represents additional collision data
octomap_msgs/OctomapWithPose octomap

================================================================================
MSG: octomap_msgs/OctomapWithPose
# A 3D map in binary format, as Octree
Header header

# The pose of the octree with respect to the header frame 
geometry_msgs/Pose origin

# The actual octree msg
octomap_msgs/Octomap octomap

================================================================================
MSG: octomap_msgs/Octomap
# A 3D map in binary format, as Octree
Header header

# Flag to denote a binary (only free/occupied) or full occupancy octree (.bt/.ot file)
bool binary

# Class id of the contained octree 
string id

# Resolution (in m) of the smallest octree nodes
float64 resolution

# binary serialization of octree, use conversions.h to read and write octrees
int8[] data

"
  end
  attr_accessor :header, :goal_id, :goal

  @@struct_d7L3 = ::ROS::Struct.new("d7L3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_C3ldCld = ::ROS::Struct.new("C3ldCld")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_f2 = ::ROS::Struct.new("f2")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_l = ::ROS::Struct.new("l")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_c = ::ROS::Struct.new("c")
  @@struct_f4 = ::ROS::Struct.new("f4")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_d2Cd = ::ROS::Struct.new("d2Cd")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','actionlib_msgs/GoalID','moveit_msgs/PlaceGoal']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [actionlib_msgs/GoalID] :goal_id initialize value
  # @option args [moveit_msgs/PlaceGoal] :goal initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:goal_id]
      @goal_id = args[:goal_id]
    else
      @goal_id = Actionlib_msgs::GoalID.new
    end
    if args[:goal]
      @goal = args[:goal]
    else
      @goal = Moveit_msgs::PlaceGoal.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@goal_id.stamp.secs, @goal_id.stamp.nsecs))
      _x = @goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @goal.group_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @goal.attached_object_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.place_locations.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.place_locations
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2791 = val1.post_place_posture
        _v2792 = _v2791.header
        buff.write(@@struct_L.pack(_v2792.seq))
        _v2793 = _v2792.stamp
        _x = _v2793
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2792.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v2791.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2791.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v2791.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2791.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v2794 = val3.time_from_start
          _x = _v2794
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        _v2795 = val1.place_pose
        _v2796 = _v2795.header
        buff.write(@@struct_L.pack(_v2796.seq))
        _v2797 = _v2796.stamp
        _x = _v2797
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2796.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2798 = _v2795.pose
        _v2799 = _v2798.position
        _x = _v2799
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2800 = _v2798.orientation
        _x = _v2800
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _v2801 = val1.pre_place_approach
        _v2802 = _v2801.direction
        _v2803 = _v2802.header
        buff.write(@@struct_L.pack(_v2803.seq))
        _v2804 = _v2803.stamp
        _x = _v2804
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2803.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2805 = _v2802.vector
        _x = _v2805
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v2801
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        _v2806 = val1.post_place_retreat
        _v2807 = _v2806.direction
        _v2808 = _v2807.header
        buff.write(@@struct_L.pack(_v2808.seq))
        _v2809 = _v2808.stamp
        _x = _v2809
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2808.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2810 = _v2807.vector
        _x = _v2810
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _x = _v2806
        buff.write(@@struct_f2.pack(_x.desired_distance, _x.min_distance))
        length = val1.allowed_touch_objects.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.allowed_touch_objects
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
      end
      buff.write(@@struct_C.pack(@goal.place_eef))
      _x = @goal.support_surface_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@goal.allow_gripper_support_collision))
      _x = @goal.path_constraints.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.path_constraints.joint_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.path_constraints.joint_constraints
        _x = val1.joint_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_d4.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
      end
      length = @goal.path_constraints.position_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.path_constraints.position_constraints
        _v2811 = val1.header
        buff.write(@@struct_L.pack(_v2811.seq))
        _v2812 = _v2811.stamp
        _x = _v2812
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2811.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2813 = val1.target_point_offset
        _x = _v2813
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2814 = val1.constraint_region
        length = _v2814.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2814.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v2814.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2814.primitive_poses
          _v2815 = val3.position
          _x = _v2815
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2816 = val3.orientation
          _x = _v2816
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v2814.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2814.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v2814.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2814.mesh_poses
          _v2817 = val3.position
          _x = _v2817
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2818 = val3.orientation
          _x = _v2818
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      length = @goal.path_constraints.orientation_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.path_constraints.orientation_constraints
        _v2819 = val1.header
        buff.write(@@struct_L.pack(_v2819.seq))
        _v2820 = _v2819.stamp
        _x = _v2820
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2819.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2821 = val1.orientation
        _x = _v2821
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_d4.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
      end
      length = @goal.path_constraints.visibility_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.path_constraints.visibility_constraints
        buff.write(@@struct_d.pack(val1.target_radius))
        _v2822 = val1.target_pose
        _v2823 = _v2822.header
        buff.write(@@struct_L.pack(_v2823.seq))
        _v2824 = _v2823.stamp
        _x = _v2824
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2823.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2825 = _v2822.pose
        _v2826 = _v2825.position
        _x = _v2826
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2827 = _v2825.orientation
        _x = _v2827
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_l.pack(val1.cone_sides))
        _v2828 = val1.sensor_pose
        _v2829 = _v2828.header
        buff.write(@@struct_L.pack(_v2829.seq))
        _v2830 = _v2829.stamp
        _x = _v2830
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2829.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2831 = _v2828.pose
        _v2832 = _v2831.position
        _x = _v2832
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2833 = _v2831.orientation
        _x = _v2833
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(@@struct_d2Cd.pack(_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight))
      end
      _x = @goal.planner_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.allowed_touch_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.allowed_touch_objects
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      buff.write(@@struct_d.pack(@goal.allowed_planning_time))
      _x = @goal.planning_options.planning_scene_diff.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@goal.planning_options.planning_scene_diff.robot_state.joint_state.header.seq, @goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.secs, @goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.nsecs))
      _x = @goal.planning_options.planning_scene_diff.robot_state.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.planning_options.planning_scene_diff.robot_state.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.robot_state.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @goal.planning_options.planning_scene_diff.robot_state.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@goal.planning_options.planning_scene_diff.robot_state.joint_state.position.pack(pattern))
      length = @goal.planning_options.planning_scene_diff.robot_state.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@goal.planning_options.planning_scene_diff.robot_state.joint_state.velocity.pack(pattern))
      length = @goal.planning_options.planning_scene_diff.robot_state.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@goal.planning_options.planning_scene_diff.robot_state.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.seq, @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.secs, @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.nsecs))
      _x = @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms
        _v2834 = val1.translation
        _x = _v2834
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2835 = val1.rotation
        _x = _v2835
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist
        _v2836 = val1.linear
        _x = _v2836
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2837 = val1.angular
        _x = _v2837
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench
        _v2838 = val1.force
        _x = _v2838
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2839 = val1.torque
        _x = _v2839
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2840 = val1.object
        _v2841 = _v2840.header
        buff.write(@@struct_L.pack(_v2841.seq))
        _v2842 = _v2841.stamp
        _x = _v2842
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2841.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v2840.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2843 = _v2840.type
        _x = _v2843.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v2843.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v2840.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2840.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v2840.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2840.primitive_poses
          _v2844 = val3.position
          _x = _v2844
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2845 = val3.orientation
          _x = _v2845
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v2840.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2840.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v2840.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2840.mesh_poses
          _v2846 = val3.position
          _x = _v2846
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2847 = val3.orientation
          _x = _v2847
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v2840.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2840.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v2840.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2840.plane_poses
          _v2848 = val3.position
          _x = _v2848
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2849 = val3.orientation
          _x = _v2849
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v2840.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v2850 = val1.detach_posture
        _v2851 = _v2850.header
        buff.write(@@struct_L.pack(_v2851.seq))
        _v2852 = _v2851.stamp
        _x = _v2852
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2851.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v2850.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2850.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v2850.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v2850.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v2853 = val3.time_from_start
          _x = _v2853
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_C.pack(@goal.planning_options.planning_scene_diff.robot_state.is_diff))
      _x = @goal.planning_options.planning_scene_diff.robot_model_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @goal.planning_options.planning_scene_diff.fixed_frame_transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.fixed_frame_transforms
        _v2854 = val1.header
        buff.write(@@struct_L.pack(_v2854.seq))
        _v2855 = _v2854.stamp
        _x = _v2855
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2854.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.child_frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2856 = val1.transform
        _v2857 = _v2856.translation
        _x = _v2857
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v2858 = _v2856.rotation
        _x = _v2858
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values
        length = val1.enabled.length
        buff.write(@@struct_L.pack(length))
        pattern = "C#{length}"
        buff.write(*val1.enabled.pack(pattern))
      end
      length = @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values.length
      buff.write(@@struct_L.pack(length))
      pattern = "C#{length}"
      buff.write(*@goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values.pack(pattern))
      length = @goal.planning_options.planning_scene_diff.link_padding.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.link_padding
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_d.pack(val1.padding))
      end
      length = @goal.planning_options.planning_scene_diff.link_scale.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.link_scale
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_d.pack(val1.scale))
      end
      length = @goal.planning_options.planning_scene_diff.object_colors.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.object_colors
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2859 = val1.color
        _x = _v2859
        buff.write(@@struct_f4.pack(_x.r, _x.g, _x.b, _x.a))
      end
      length = @goal.planning_options.planning_scene_diff.world.collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @goal.planning_options.planning_scene_diff.world.collision_objects
        _v2860 = val1.header
        buff.write(@@struct_L.pack(_v2860.seq))
        _v2861 = _v2860.stamp
        _x = _v2861
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v2860.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v2862 = val1.type
        _x = _v2862.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v2862.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.primitives.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.primitives
          buff.write(@@struct_C.pack(val2.type))
          length = val2.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val2.dimensions.pack(pattern))
        end
        length = val1.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.primitive_poses
          _v2863 = val2.position
          _x = _v2863
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2864 = val2.orientation
          _x = _v2864
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.meshes.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.meshes
          length = val2.triangles.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.triangles
            buff.write(@@struct_L3.pack(*val3.vertex_indices))
          end
          length = val2.vertices.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.vertices
            _x = val3
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = val1.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.mesh_poses
          _v2865 = val2.position
          _x = _v2865
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2866 = val2.orientation
          _x = _v2866
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.planes.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.planes
          buff.write(@@struct_d4.pack(*val2.coef))
        end
        length = val1.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.plane_poses
          _v2867 = val2.position
          _x = _v2867
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v2868 = val2.orientation
          _x = _v2868
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(val1.operation))
      end
      buff.write(@@struct_L3.pack(@goal.planning_options.planning_scene_diff.world.octomap.header.seq, @goal.planning_options.planning_scene_diff.world.octomap.header.stamp.secs, @goal.planning_options.planning_scene_diff.world.octomap.header.stamp.nsecs))
      _x = @goal.planning_options.planning_scene_diff.world.octomap.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7L3.pack(@goal.planning_options.planning_scene_diff.world.octomap.origin.position.x, @goal.planning_options.planning_scene_diff.world.octomap.origin.position.y, @goal.planning_options.planning_scene_diff.world.octomap.origin.position.z, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.x, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.y, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.z, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.w, @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.seq, @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.secs, @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.nsecs))
      _x = @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@goal.planning_options.planning_scene_diff.world.octomap.octomap.binary))
      _x = @goal.planning_options.planning_scene_diff.world.octomap.octomap.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d.pack(@goal.planning_options.planning_scene_diff.world.octomap.octomap.resolution))
      length = @goal.planning_options.planning_scene_diff.world.octomap.octomap.data.length
      buff.write(@@struct_L.pack(length))
      pattern = "c#{length}"
      buff.write(*@goal.planning_options.planning_scene_diff.world.octomap.octomap.data.pack(pattern))
      buff.write(@@struct_C3ldCld.pack(@goal.planning_options.planning_scene_diff.is_diff, @goal.planning_options.plan_only, @goal.planning_options.look_around, @goal.planning_options.look_around_attempts, @goal.planning_options.max_safe_execution_cost, @goal.planning_options.replan, @goal.planning_options.replan_attempts, @goal.planning_options.replan_delay))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @goal_id == nil
        @goal_id = Actionlib_msgs::GoalID.new
      end
      if @goal == nil
        @goal = Moveit_msgs::PlaceGoal.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@goal_id.stamp.secs, @goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.group_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.attached_object_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.place_locations = []
      length.times do
        val1 = Moveit_msgs::PlaceLocation.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v2869 = val1.post_place_posture
        _v2870 = _v2869.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2870.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2871 = _v2870.stamp
        _x = _v2871
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2870.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2869.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v2869.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2869.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v2872 = val3.time_from_start
          _x = _v2872
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v2869.points.push(val3)
        end
        _v2873 = val1.place_pose
        _v2874 = _v2873.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2874.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2875 = _v2874.stamp
        _x = _v2875
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2874.frame_id = str[start..(end_point-1)]
        _v2876 = _v2873.pose
        _v2877 = _v2876.position
        _x = _v2877
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2878 = _v2876.orientation
        _x = _v2878
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        _v2879 = val1.pre_place_approach
        _v2880 = _v2879.direction
        _v2881 = _v2880.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2881.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2882 = _v2881.stamp
        _x = _v2882
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2881.frame_id = str[start..(end_point-1)]
        _v2883 = _v2880.vector
        _x = _v2883
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v2879
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        _v2884 = val1.post_place_retreat
        _v2885 = _v2884.direction
        _v2886 = _v2885.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2886.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2887 = _v2886.stamp
        _x = _v2887
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2886.frame_id = str[start..(end_point-1)]
        _v2888 = _v2885.vector
        _x = _v2888
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _x = _v2884
        start = end_point
        end_point += ROS::Struct::calc_size('f2')
        (_x.desired_distance, _x.min_distance,) = @@struct_f2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.allowed_touch_objects = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.allowed_touch_objects.push(val2)
        end
        @goal.place_locations.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@goal.place_eef,) = @@struct_C.unpack(str[start..(end_point-1)])
      @goal.place_eef = bool(@goal.place_eef)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.support_surface_name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@goal.allow_gripper_support_collision,) = @@struct_C.unpack(str[start..(end_point-1)])
      @goal.allow_gripper_support_collision = bool(@goal.allow_gripper_support_collision)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.path_constraints.name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.path_constraints.joint_constraints = []
      length.times do
        val1 = Moveit_msgs::JointConstraint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.joint_name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @goal.path_constraints.joint_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.path_constraints.position_constraints = []
      length.times do
        val1 = Moveit_msgs::PositionConstraint.new
        _v2889 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2889.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2890 = _v2889.stamp
        _x = _v2890
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2889.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v2891 = val1.target_point_offset
        _x = _v2891
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2892 = val1.constraint_region
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2892.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v2892.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2892.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v2893 = val3.position
          _x = _v2893
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2894 = val3.orientation
          _x = _v2894
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2892.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2892.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v2892.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2892.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v2895 = val3.position
          _x = _v2895
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2896 = val3.orientation
          _x = _v2896
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2892.mesh_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @goal.path_constraints.position_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.path_constraints.orientation_constraints = []
      length.times do
        val1 = Moveit_msgs::OrientationConstraint.new
        _v2897 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2897.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2898 = _v2897.stamp
        _x = _v2898
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2897.frame_id = str[start..(end_point-1)]
        _v2899 = val1.orientation
        _x = _v2899
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @goal.path_constraints.orientation_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.path_constraints.visibility_constraints = []
      length.times do
        val1 = Moveit_msgs::VisibilityConstraint.new
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.target_radius,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v2900 = val1.target_pose
        _v2901 = _v2900.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2901.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2902 = _v2901.stamp
        _x = _v2902
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2901.frame_id = str[start..(end_point-1)]
        _v2903 = _v2900.pose
        _v2904 = _v2903.position
        _x = _v2904
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2905 = _v2903.orientation
        _x = _v2905
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('l')
        (val1.cone_sides,) = @@struct_l.unpack(str[start..(end_point-1)])
        _v2906 = val1.sensor_pose
        _v2907 = _v2906.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2907.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2908 = _v2907.stamp
        _x = _v2908
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2907.frame_id = str[start..(end_point-1)]
        _v2909 = _v2906.pose
        _v2910 = _v2909.position
        _x = _v2910
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2911 = _v2909.orientation
        _x = _v2911
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d2Cd')
        (_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight,) = @@struct_d2Cd.unpack(str[start..(end_point-1)])
        @goal.path_constraints.visibility_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planner_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.allowed_touch_objects = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @goal.allowed_touch_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('d')
      (@goal.allowed_planning_time,) = @@struct_d.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planning_options.planning_scene_diff.name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@goal.planning_options.planning_scene_diff.robot_state.joint_state.header.seq, @goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.secs, @goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planning_options.planning_scene_diff.robot_state.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.robot_state.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @goal.planning_options.planning_scene_diff.robot_state.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.planning_options.planning_scene_diff.robot_state.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.planning_options.planning_scene_diff.robot_state.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.planning_options.planning_scene_diff.robot_state.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.seq, @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.secs, @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v2912 = val1.translation
        _x = _v2912
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2913 = val1.rotation
        _x = _v2913
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v2914 = val1.linear
        _x = _v2914
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2915 = val1.angular
        _x = _v2915
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v2916 = val1.force
        _x = _v2916
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2917 = val1.torque
        _x = _v2917
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v2918 = val1.object
        _v2919 = _v2918.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2919.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2920 = _v2919.stamp
        _x = _v2920
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2919.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2918.id = str[start..(end_point-1)]
        _v2921 = _v2918.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2921.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2921.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2918.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v2918.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2918.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v2922 = val3.position
          _x = _v2922
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2923 = val3.orientation
          _x = _v2923
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2918.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2918.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v2918.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2918.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v2924 = val3.position
          _x = _v2924
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2925 = val3.orientation
          _x = _v2925
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2918.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2918.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2918.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2918.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v2926 = val3.position
          _x = _v2926
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2927 = val3.orientation
          _x = _v2927
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v2918.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v2918.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v2928 = val1.detach_posture
        _v2929 = _v2928.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2929.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2930 = _v2929.stamp
        _x = _v2930
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2929.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2928.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v2928.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2928.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v2931 = val3.time_from_start
          _x = _v2931
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v2928.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@goal.planning_options.planning_scene_diff.robot_state.is_diff,) = @@struct_C.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.robot_state.is_diff = bool(@goal.planning_options.planning_scene_diff.robot_state.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planning_options.planning_scene_diff.robot_model_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.fixed_frame_transforms = []
      length.times do
        val1 = Geometry_msgs::TransformStamped.new
        _v2932 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2932.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2933 = _v2932.stamp
        _x = _v2933
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2932.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.child_frame_id = str[start..(end_point-1)]
        _v2934 = val1.transform
        _v2935 = _v2934.translation
        _x = _v2935
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v2936 = _v2934.rotation
        _x = _v2936
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.fixed_frame_transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values = []
      length.times do
        val1 = Moveit_msgs::AllowedCollisionEntry.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "C#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.enabled = str[start..(end_point-1)].unpack(pattern)
        val1.enabled = map(bool, val1.enabled)
        @goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "C#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values = str[start..(end_point-1)].unpack(pattern)
      @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values = map(bool, @goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.link_padding = []
      length.times do
        val1 = Moveit_msgs::LinkPadding.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.padding,) = @@struct_d.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.link_padding.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.link_scale = []
      length.times do
        val1 = Moveit_msgs::LinkScale.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.scale,) = @@struct_d.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.link_scale.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.object_colors = []
      length.times do
        val1 = Moveit_msgs::ObjectColor.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v2937 = val1.color
        _x = _v2937
        start = end_point
        end_point += ROS::Struct::calc_size('f4')
        (_x.r, _x.g, _x.b, _x.a,) = @@struct_f4.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.object_colors.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.world.collision_objects = []
      length.times do
        val1 = Moveit_msgs::CollisionObject.new
        _v2938 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v2938.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v2939 = _v2938.stamp
        _x = _v2939
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2938.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v2940 = val1.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2940.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v2940.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.primitives = []
        length.times do
          val2 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val2.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val2.dimensions = str[start..(end_point-1)].unpack(pattern)
          val1.primitives.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.primitive_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v2941 = val2.position
          _x = _v2941
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2942 = val2.orientation
          _x = _v2942
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.primitive_poses.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.meshes = []
        length.times do
          val2 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.triangles = []
          length.times do
            val3 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val3.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val2.triangles.push(val3)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.vertices = []
          length.times do
            val3 = Geometry_msgs::Point.new
            _x = val3
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val2.vertices.push(val3)
          end
          val1.meshes.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.mesh_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v2943 = val2.position
          _x = _v2943
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2944 = val2.orientation
          _x = _v2944
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.mesh_poses.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.planes = []
        length.times do
          val2 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val2.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.planes.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.plane_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v2945 = val2.position
          _x = _v2945
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v2946 = val2.orientation
          _x = _v2946
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.plane_poses.push(val2)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (val1.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        @goal.planning_options.planning_scene_diff.world.collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@goal.planning_options.planning_scene_diff.world.octomap.header.seq, @goal.planning_options.planning_scene_diff.world.octomap.header.stamp.secs, @goal.planning_options.planning_scene_diff.world.octomap.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planning_options.planning_scene_diff.world.octomap.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7L3')
      (@goal.planning_options.planning_scene_diff.world.octomap.origin.position.x, @goal.planning_options.planning_scene_diff.world.octomap.origin.position.y, @goal.planning_options.planning_scene_diff.world.octomap.origin.position.z, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.x, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.y, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.z, @goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.w, @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.seq, @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.secs, @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.nsecs,) = @@struct_d7L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planning_options.planning_scene_diff.world.octomap.octomap.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@goal.planning_options.planning_scene_diff.world.octomap.octomap.binary,) = @@struct_C.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.world.octomap.octomap.binary = bool(@goal.planning_options.planning_scene_diff.world.octomap.octomap.binary)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.planning_options.planning_scene_diff.world.octomap.octomap.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d')
      (@goal.planning_options.planning_scene_diff.world.octomap.octomap.resolution,) = @@struct_d.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "c#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @goal.planning_options.planning_scene_diff.world.octomap.octomap.data = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('C3ldCld')
      (@goal.planning_options.planning_scene_diff.is_diff, @goal.planning_options.plan_only, @goal.planning_options.look_around, @goal.planning_options.look_around_attempts, @goal.planning_options.max_safe_execution_cost, @goal.planning_options.replan, @goal.planning_options.replan_attempts, @goal.planning_options.replan_delay,) = @@struct_C3ldCld.unpack(str[start..(end_point-1)])
      @goal.planning_options.planning_scene_diff.is_diff = bool(@goal.planning_options.planning_scene_diff.is_diff)
      @goal.planning_options.plan_only = bool(@goal.planning_options.plan_only)
      @goal.planning_options.look_around = bool(@goal.planning_options.look_around)
      @goal.planning_options.replan = bool(@goal.planning_options.replan)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
