# autogenerated by genrb from PlaceLocation.msg. Do not edit.
require 'ros/message'

require "moveit_msgs/GripperTranslation"
require "trajectory_msgs/JointTrajectory"
require "geometry_msgs/Vector3Stamped"
require "geometry_msgs/PoseStamped"
require "trajectory_msgs/JointTrajectoryPoint"
require "ros/duration"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "geometry_msgs/Pose"

module Moveit_msgs

class PlaceLocation <::ROS::Message
  def self.md5sum
    "f3dbcaca40fb29ede2af78b3e1831128"
  end

  def self.type
    "moveit_msgs/PlaceLocation"
  end

  def has_header?
    false
  end

  def message_definition
    "# A name for this grasp
string id

# The internal posture of the hand for the grasp
# positions and efforts are used
trajectory_msgs/JointTrajectory post_place_posture

# The position of the end-effector for the grasp relative to a reference frame 
# (that is always specified elsewhere, not in this message)
geometry_msgs/PoseStamped place_pose

# The approach motion
GripperTranslation pre_place_approach

# The retreat motion
GripperTranslation post_place_retreat

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping
string[] allowed_touch_objects

================================================================================
MSG: trajectory_msgs/JointTrajectory
Header header
string[] joint_names
JointTrajectoryPoint[] points
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: trajectory_msgs/JointTrajectoryPoint
# Each trajectory point specifies either positions[, velocities[, accelerations]]
# or positions[, effort] for the trajectory to be executed.
# All specified values are in the same order as the joint names in JointTrajectory.msg

float64[] positions
float64[] velocities
float64[] accelerations
float64[] effort
duration time_from_start

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: moveit_msgs/GripperTranslation
# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :id, :post_place_posture, :place_pose, :pre_place_approach, :post_place_retreat, :allowed_touch_objects

  @@struct_d3f2 = ::ROS::Struct.new("d3f2")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d3f2L3 = ::ROS::Struct.new("d3f2L3")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_d7L3 = ::ROS::Struct.new("d7L3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','trajectory_msgs/JointTrajectory','geometry_msgs/PoseStamped','moveit_msgs/GripperTranslation','moveit_msgs/GripperTranslation','string[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :id initialize value
  # @option args [trajectory_msgs/JointTrajectory] :post_place_posture initialize value
  # @option args [geometry_msgs/PoseStamped] :place_pose initialize value
  # @option args [moveit_msgs/GripperTranslation] :pre_place_approach initialize value
  # @option args [moveit_msgs/GripperTranslation] :post_place_retreat initialize value
  # @option args [string[]] :allowed_touch_objects initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:id]
      @id = args[:id]
    else
      @id = ''
    end
    if args[:post_place_posture]
      @post_place_posture = args[:post_place_posture]
    else
      @post_place_posture = Trajectory_msgs::JointTrajectory.new
    end
    if args[:place_pose]
      @place_pose = args[:place_pose]
    else
      @place_pose = Geometry_msgs::PoseStamped.new
    end
    if args[:pre_place_approach]
      @pre_place_approach = args[:pre_place_approach]
    else
      @pre_place_approach = Moveit_msgs::GripperTranslation.new
    end
    if args[:post_place_retreat]
      @post_place_retreat = args[:post_place_retreat]
    else
      @post_place_retreat = Moveit_msgs::GripperTranslation.new
    end
    if args[:allowed_touch_objects]
      @allowed_touch_objects = args[:allowed_touch_objects]
    else
      @allowed_touch_objects = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@post_place_posture.header.seq, @post_place_posture.header.stamp.secs, @post_place_posture.header.stamp.nsecs))
      _x = @post_place_posture.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @post_place_posture.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @post_place_posture.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @post_place_posture.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @post_place_posture.points
        length = val1.positions.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.positions.pack(pattern))
        length = val1.velocities.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.velocities.pack(pattern))
        length = val1.accelerations.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.accelerations.pack(pattern))
        length = val1.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.effort.pack(pattern))
        _v3173 = val1.time_from_start
        _x = _v3173
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_L3.pack(@place_pose.header.seq, @place_pose.header.stamp.secs, @place_pose.header.stamp.nsecs))
      _x = @place_pose.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7L3.pack(@place_pose.pose.position.x, @place_pose.pose.position.y, @place_pose.pose.position.z, @place_pose.pose.orientation.x, @place_pose.pose.orientation.y, @place_pose.pose.orientation.z, @place_pose.pose.orientation.w, @pre_place_approach.direction.header.seq, @pre_place_approach.direction.header.stamp.secs, @pre_place_approach.direction.header.stamp.nsecs))
      _x = @pre_place_approach.direction.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3f2L3.pack(@pre_place_approach.direction.vector.x, @pre_place_approach.direction.vector.y, @pre_place_approach.direction.vector.z, @pre_place_approach.desired_distance, @pre_place_approach.min_distance, @post_place_retreat.direction.header.seq, @post_place_retreat.direction.header.stamp.secs, @post_place_retreat.direction.header.stamp.nsecs))
      _x = @post_place_retreat.direction.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3f2.pack(@post_place_retreat.direction.vector.x, @post_place_retreat.direction.vector.y, @post_place_retreat.direction.vector.z, @post_place_retreat.desired_distance, @post_place_retreat.min_distance))
      length = @allowed_touch_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @allowed_touch_objects
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @post_place_posture == nil
        @post_place_posture = Trajectory_msgs::JointTrajectory.new
      end
      if @place_pose == nil
        @place_pose = Geometry_msgs::PoseStamped.new
      end
      if @pre_place_approach == nil
        @pre_place_approach = Moveit_msgs::GripperTranslation.new
      end
      if @post_place_retreat == nil
        @post_place_retreat = Moveit_msgs::GripperTranslation.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@post_place_posture.header.seq, @post_place_posture.header.stamp.secs, @post_place_posture.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @post_place_posture.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @post_place_posture.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @post_place_posture.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @post_place_posture.points = []
      length.times do
        val1 = Trajectory_msgs::JointTrajectoryPoint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.positions = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.velocities = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.accelerations = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.effort = str[start..(end_point-1)].unpack(pattern)
        _v3174 = val1.time_from_start
        _x = _v3174
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @post_place_posture.points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@place_pose.header.seq, @place_pose.header.stamp.secs, @place_pose.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @place_pose.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7L3')
      (@place_pose.pose.position.x, @place_pose.pose.position.y, @place_pose.pose.position.z, @place_pose.pose.orientation.x, @place_pose.pose.orientation.y, @place_pose.pose.orientation.z, @place_pose.pose.orientation.w, @pre_place_approach.direction.header.seq, @pre_place_approach.direction.header.stamp.secs, @pre_place_approach.direction.header.stamp.nsecs,) = @@struct_d7L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @pre_place_approach.direction.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3f2L3')
      (@pre_place_approach.direction.vector.x, @pre_place_approach.direction.vector.y, @pre_place_approach.direction.vector.z, @pre_place_approach.desired_distance, @pre_place_approach.min_distance, @post_place_retreat.direction.header.seq, @post_place_retreat.direction.header.stamp.secs, @post_place_retreat.direction.header.stamp.nsecs,) = @@struct_d3f2L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @post_place_retreat.direction.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3f2')
      (@post_place_retreat.direction.vector.x, @post_place_retreat.direction.vector.y, @post_place_retreat.direction.vector.z, @post_place_retreat.desired_distance, @post_place_retreat.min_distance,) = @@struct_d3f2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @allowed_touch_objects = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @allowed_touch_objects.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
