# autogenerated by genrb from PlaceResult.msg. Do not edit.
require 'ros/message'

require "moveit_msgs/GripperTranslation"
require "geometry_msgs/Vector3Stamped"
require "geometry_msgs/Transform"
require "geometry_msgs/Point"
require "geometry_msgs/Twist"
require "shape_msgs/Mesh"
require "trajectory_msgs/MultiDOFJointTrajectory"
require "std_msgs/Header"
require "moveit_msgs/MoveItErrorCodes"
require "geometry_msgs/PoseStamped"
require "ros/duration"
require "shape_msgs/Plane"
require "sensor_msgs/MultiDOFJointState"
require "geometry_msgs/Pose"
require "shape_msgs/MeshTriangle"
require "shape_msgs/SolidPrimitive"
require "geometry_msgs/Wrench"
require "moveit_msgs/RobotTrajectory"
require "trajectory_msgs/MultiDOFJointTrajectoryPoint"
require "moveit_msgs/PlaceLocation"
require "moveit_msgs/RobotState"
require "trajectory_msgs/JointTrajectory"
require "sensor_msgs/JointState"
require "trajectory_msgs/JointTrajectoryPoint"
require "object_recognition_msgs/ObjectType"
require "moveit_msgs/AttachedCollisionObject"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "moveit_msgs/CollisionObject"

module Moveit_msgs

class PlaceResult <::ROS::Message
  def self.md5sum
    "da2eea14de05cf0aa280f150a84ded50"
  end

  def self.type
    "moveit_msgs/PlaceResult"
  end

  def has_header?
    false
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# The result of the pickup attempt
MoveItErrorCodes error_code

# The full starting state of the robot at the start of the trajectory
RobotState trajectory_start

# The trajectory that moved group produced for execution
RobotTrajectory[] trajectory_stages

string[] trajectory_descriptions

# The successful place location, if any
PlaceLocation place_location


================================================================================
MSG: moveit_msgs/MoveItErrorCodes
int32 val

# overall behavior
int32 SUCCESS=1
int32 FAILURE=99999

int32 PLANNING_FAILED=-1
int32 INVALID_MOTION_PLAN=-2
int32 MOTION_PLAN_INVALIDATED_BY_ENVIRONMENT_CHANGE=-3
int32 CONTROL_FAILED=-4
int32 UNABLE_TO_AQUIRE_SENSOR_DATA=-5
int32 TIMED_OUT=-6
int32 PREEMPTED=-7

# planning & kinematics request errors
int32 START_STATE_IN_COLLISION=-10
int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-11

int32 GOAL_IN_COLLISION=-12
int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-13
int32 GOAL_CONSTRAINTS_VIOLATED=-14

int32 INVALID_GROUP_NAME=-15
int32 INVALID_GOAL_CONSTRAINTS=-16
int32 INVALID_ROBOT_STATE=-17
int32 INVALID_LINK_NAME=-18
int32 INVALID_OBJECT_NAME=-19

# system errors
int32 FRAME_TRANSFORM_FAILURE=-21
int32 COLLISION_CHECKING_UNAVAILABLE=-22
int32 ROBOT_STATE_STALE=-23
int32 SENSOR_INFO_STALE=-24

# kinematics errors
int32 NO_IK_SOLUTION=-31

================================================================================
MSG: moveit_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state

# Joints that may have multiple DOF are specified here
sensor_msgs/MultiDOFJointState multi_dof_joint_state

# Attached collision objects (attached to some link on the robot)
AttachedCollisionObject[] attached_collision_objects

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
# This is mostly important for handling the attached bodies (whether or not to clear the attached bodies
# of a moveit::core::RobotState before updating it with this message)
bool is_diff

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/MultiDOFJointState
# Representation of state for joints with multiple degrees of freedom, 
# following the structure of JointState.
#
# It is assumed that a joint in a system corresponds to a transform that gets applied 
# along the kinematic chain. For example, a planar joint (as in URDF) is 3DOF (x, y, yaw)
# and those 3DOF can be expressed as a transformation matrix, and that transformation
# matrix can be converted back to (x, y, yaw)
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# wrench associated with them, you can leave the wrench array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

Header header

string[] joint_names
geometry_msgs/Transform[] transforms
geometry_msgs/Twist[] twist
geometry_msgs/Wrench[] wrench

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: moveit_msgs/AttachedCollisionObject
# The CollisionObject will be attached with a fixed joint to this link
string link_name

#This contains the actual shapes and poses for the CollisionObject
#to be attached to the link
#If action is remove and no object.id is set, all objects
#attached to the link indicated by link_name will be removed
CollisionObject object

# The set of links that the attached objects are allowed to touch
# by default - the link_name is already considered by default
string[] touch_links

# If certain links were placed in a particular posture for this object to remain attached 
# (e.g., an end effector closing around an object), the posture necessary for releasing
# the object is stored here
trajectory_msgs/JointTrajectory detach_posture

# The weight of the attached object, if known
float64 weight

================================================================================
MSG: moveit_msgs/CollisionObject
# a header, used for interpreting the poses
Header header

# the id of the object (name used in MoveIt)
string id

# The object type in a database of known objects
object_recognition_msgs/ObjectType type

# the the collision geometries associated with the object;
# their poses are with respect to the specified header

# solid geometric primitives
shape_msgs/SolidPrimitive[] primitives
geometry_msgs/Pose[] primitive_poses

# meshes
shape_msgs/Mesh[] meshes
geometry_msgs/Pose[] mesh_poses

# bounding planes (equation is specified, but the plane can be oriented using an additional pose)
shape_msgs/Plane[] planes
geometry_msgs/Pose[] plane_poses

# Adds the object to the planning scene. If the object previously existed, it is replaced.
byte ADD=0

# Removes the object from the environment entirely (everything that matches the specified id)
byte REMOVE=1

# Append to an object that already exists in the planning scene. If the does not exist, it is added.
byte APPEND=2

# If an object already exists in the scene, new poses can be sent (the geometry arrays must be left empty)
# if solely moving the object is desired
byte MOVE=3

# Operation to be performed
byte operation

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: shape_msgs/SolidPrimitive
# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: shape_msgs/Plane
# Representation of a plane, using the plane equation ax + by + cz + d = 0

# a := coef[0]
# b := coef[1]
# c := coef[2]
# d := coef[3]

float64[4] coef

================================================================================
MSG: trajectory_msgs/JointTrajectory
Header header
string[] joint_names
JointTrajectoryPoint[] points
================================================================================
MSG: trajectory_msgs/JointTrajectoryPoint
# Each trajectory point specifies either positions[, velocities[, accelerations]]
# or positions[, effort] for the trajectory to be executed.
# All specified values are in the same order as the joint names in JointTrajectory.msg

float64[] positions
float64[] velocities
float64[] accelerations
float64[] effort
duration time_from_start

================================================================================
MSG: moveit_msgs/RobotTrajectory
trajectory_msgs/JointTrajectory joint_trajectory
trajectory_msgs/MultiDOFJointTrajectory multi_dof_joint_trajectory

================================================================================
MSG: trajectory_msgs/MultiDOFJointTrajectory
# The header is used to specify the coordinate frame and the reference time for the trajectory durations
Header header

# A representation of a multi-dof joint trajectory (each point is a transformation)
# Each point along the trajectory will include an array of positions/velocities/accelerations
# that has the same length as the array of joint names, and has the same order of joints as 
# the joint names array.

string[] joint_names
MultiDOFJointTrajectoryPoint[] points

================================================================================
MSG: trajectory_msgs/MultiDOFJointTrajectoryPoint
# Each multi-dof joint can specify a transform (up to 6 DOF)
geometry_msgs/Transform[] transforms

# There can be a velocity specified for the origin of the joint 
geometry_msgs/Twist[] velocities

# There can be an acceleration specified for the origin of the joint 
geometry_msgs/Twist[] accelerations

duration time_from_start

================================================================================
MSG: moveit_msgs/PlaceLocation
# A name for this grasp
string id

# The internal posture of the hand for the grasp
# positions and efforts are used
trajectory_msgs/JointTrajectory post_place_posture

# The position of the end-effector for the grasp relative to a reference frame 
# (that is always specified elsewhere, not in this message)
geometry_msgs/PoseStamped place_pose

# The approach motion
GripperTranslation pre_place_approach

# The retreat motion
GripperTranslation post_place_retreat

# an optional list of obstacles that we have semantic information about
# and that can be touched/pushed/moved in the course of grasping
string[] allowed_touch_objects

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: moveit_msgs/GripperTranslation
# defines a translation for the gripper, used in pickup or place tasks
# for example for lifting an object off a table or approaching the table for placing

# the direction of the translation
geometry_msgs/Vector3Stamped direction

# the desired translation distance
float32 desired_distance

# the min distance that must be considered feasible before the
# grasp is even attempted
float32 min_distance

================================================================================
MSG: geometry_msgs/Vector3Stamped
# This represents a Vector3 with reference coordinate frame and timestamp
Header header
Vector3 vector

"
  end
  attr_accessor :error_code, :trajectory_start, :trajectory_stages, :trajectory_descriptions, :place_location

  @@struct_d7L3 = ::ROS::Struct.new("d7L3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_d3f2 = ::ROS::Struct.new("d3f2")
  @@struct_lL3 = ::ROS::Struct.new("lL3")
  @@struct_c = ::ROS::Struct.new("c")
  @@struct_d3f2L3 = ::ROS::Struct.new("d3f2L3")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['moveit_msgs/MoveItErrorCodes','moveit_msgs/RobotState','moveit_msgs/RobotTrajectory[]','string[]','moveit_msgs/PlaceLocation']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [moveit_msgs/MoveItErrorCodes] :error_code initialize value
  # @option args [moveit_msgs/RobotState] :trajectory_start initialize value
  # @option args [moveit_msgs/RobotTrajectory[]] :trajectory_stages initialize value
  # @option args [string[]] :trajectory_descriptions initialize value
  # @option args [moveit_msgs/PlaceLocation] :place_location initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:error_code]
      @error_code = args[:error_code]
    else
      @error_code = Moveit_msgs::MoveItErrorCodes.new
    end
    if args[:trajectory_start]
      @trajectory_start = args[:trajectory_start]
    else
      @trajectory_start = Moveit_msgs::RobotState.new
    end
    if args[:trajectory_stages]
      @trajectory_stages = args[:trajectory_stages]
    else
      @trajectory_stages = []
    end
    if args[:trajectory_descriptions]
      @trajectory_descriptions = args[:trajectory_descriptions]
    else
      @trajectory_descriptions = []
    end
    if args[:place_location]
      @place_location = args[:place_location]
    else
      @place_location = Moveit_msgs::PlaceLocation.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_lL3.pack(@error_code.val, @trajectory_start.joint_state.header.seq, @trajectory_start.joint_state.header.stamp.secs, @trajectory_start.joint_state.header.stamp.nsecs))
      _x = @trajectory_start.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @trajectory_start.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @trajectory_start.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @trajectory_start.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@trajectory_start.joint_state.position.pack(pattern))
      length = @trajectory_start.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@trajectory_start.joint_state.velocity.pack(pattern))
      length = @trajectory_start.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@trajectory_start.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@trajectory_start.multi_dof_joint_state.header.seq, @trajectory_start.multi_dof_joint_state.header.stamp.secs, @trajectory_start.multi_dof_joint_state.header.stamp.nsecs))
      _x = @trajectory_start.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @trajectory_start.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @trajectory_start.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @trajectory_start.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @trajectory_start.multi_dof_joint_state.transforms
        _v3175 = val1.translation
        _x = _v3175
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3176 = val1.rotation
        _x = _v3176
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @trajectory_start.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @trajectory_start.multi_dof_joint_state.twist
        _v3177 = val1.linear
        _x = _v3177
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3178 = val1.angular
        _x = _v3178
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @trajectory_start.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @trajectory_start.multi_dof_joint_state.wrench
        _v3179 = val1.force
        _x = _v3179
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3180 = val1.torque
        _x = _v3180
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @trajectory_start.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @trajectory_start.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3181 = val1.object
        _v3182 = _v3181.header
        buff.write(@@struct_L.pack(_v3182.seq))
        _v3183 = _v3182.stamp
        _x = _v3183
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3182.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v3181.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3184 = _v3181.type
        _x = _v3184.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v3184.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3181.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3181.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v3181.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3181.primitive_poses
          _v3185 = val3.position
          _x = _v3185
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v3186 = val3.orientation
          _x = _v3186
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v3181.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3181.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v3181.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3181.mesh_poses
          _v3187 = val3.position
          _x = _v3187
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v3188 = val3.orientation
          _x = _v3188
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v3181.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3181.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v3181.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3181.plane_poses
          _v3189 = val3.position
          _x = _v3189
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v3190 = val3.orientation
          _x = _v3190
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v3181.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v3191 = val1.detach_posture
        _v3192 = _v3191.header
        buff.write(@@struct_L.pack(_v3192.seq))
        _v3193 = _v3192.stamp
        _x = _v3193
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3192.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3191.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3191.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v3191.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3191.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v3194 = val3.time_from_start
          _x = _v3194
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_C.pack(@trajectory_start.is_diff))
      length = @trajectory_stages.length
      buff.write(@@struct_L.pack(length))
      for val1 in @trajectory_stages
        _v3195 = val1.joint_trajectory
        _v3196 = _v3195.header
        buff.write(@@struct_L.pack(_v3196.seq))
        _v3197 = _v3196.stamp
        _x = _v3197
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3196.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3195.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3195.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v3195.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3195.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v3198 = val3.time_from_start
          _x = _v3198
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        _v3199 = val1.multi_dof_joint_trajectory
        _v3200 = _v3199.header
        buff.write(@@struct_L.pack(_v3200.seq))
        _v3201 = _v3200.stamp
        _x = _v3201
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3200.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3199.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3199.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v3199.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3199.points
          length = val3.transforms.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.transforms
            _v3202 = val4.translation
            _x = _v3202
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v3203 = val4.rotation
            _x = _v3203
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.velocities
            _v3204 = val4.linear
            _x = _v3204
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v3205 = val4.angular
            _x = _v3205
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.accelerations
            _v3206 = val4.linear
            _x = _v3206
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v3207 = val4.angular
            _x = _v3207
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
          _v3208 = val3.time_from_start
          _x = _v3208
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
      end
      length = @trajectory_descriptions.length
      buff.write(@@struct_L.pack(length))
      for val1 in @trajectory_descriptions
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      _x = @place_location.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@place_location.post_place_posture.header.seq, @place_location.post_place_posture.header.stamp.secs, @place_location.post_place_posture.header.stamp.nsecs))
      _x = @place_location.post_place_posture.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @place_location.post_place_posture.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @place_location.post_place_posture.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @place_location.post_place_posture.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @place_location.post_place_posture.points
        length = val1.positions.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.positions.pack(pattern))
        length = val1.velocities.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.velocities.pack(pattern))
        length = val1.accelerations.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.accelerations.pack(pattern))
        length = val1.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.effort.pack(pattern))
        _v3209 = val1.time_from_start
        _x = _v3209
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_L3.pack(@place_location.place_pose.header.seq, @place_location.place_pose.header.stamp.secs, @place_location.place_pose.header.stamp.nsecs))
      _x = @place_location.place_pose.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7L3.pack(@place_location.place_pose.pose.position.x, @place_location.place_pose.pose.position.y, @place_location.place_pose.pose.position.z, @place_location.place_pose.pose.orientation.x, @place_location.place_pose.pose.orientation.y, @place_location.place_pose.pose.orientation.z, @place_location.place_pose.pose.orientation.w, @place_location.pre_place_approach.direction.header.seq, @place_location.pre_place_approach.direction.header.stamp.secs, @place_location.pre_place_approach.direction.header.stamp.nsecs))
      _x = @place_location.pre_place_approach.direction.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3f2L3.pack(@place_location.pre_place_approach.direction.vector.x, @place_location.pre_place_approach.direction.vector.y, @place_location.pre_place_approach.direction.vector.z, @place_location.pre_place_approach.desired_distance, @place_location.pre_place_approach.min_distance, @place_location.post_place_retreat.direction.header.seq, @place_location.post_place_retreat.direction.header.stamp.secs, @place_location.post_place_retreat.direction.header.stamp.nsecs))
      _x = @place_location.post_place_retreat.direction.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3f2.pack(@place_location.post_place_retreat.direction.vector.x, @place_location.post_place_retreat.direction.vector.y, @place_location.post_place_retreat.direction.vector.z, @place_location.post_place_retreat.desired_distance, @place_location.post_place_retreat.min_distance))
      length = @place_location.allowed_touch_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @place_location.allowed_touch_objects
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @error_code == nil
        @error_code = Moveit_msgs::MoveItErrorCodes.new
      end
      if @trajectory_start == nil
        @trajectory_start = Moveit_msgs::RobotState.new
      end
      if @trajectory_stages == nil
        @trajectory_stages = Moveit_msgs::RobotTrajectory[].new
      end
      if @place_location == nil
        @place_location = Moveit_msgs::PlaceLocation.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('lL3')
      (@error_code.val, @trajectory_start.joint_state.header.seq, @trajectory_start.joint_state.header.stamp.secs, @trajectory_start.joint_state.header.stamp.nsecs,) = @@struct_lL3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @trajectory_start.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @trajectory_start.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @trajectory_start.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @trajectory_start.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @trajectory_start.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @trajectory_start.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@trajectory_start.multi_dof_joint_state.header.seq, @trajectory_start.multi_dof_joint_state.header.stamp.secs, @trajectory_start.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @trajectory_start.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @trajectory_start.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @trajectory_start.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @trajectory_start.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v3210 = val1.translation
        _x = _v3210
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3211 = val1.rotation
        _x = _v3211
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @trajectory_start.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @trajectory_start.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v3212 = val1.linear
        _x = _v3212
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3213 = val1.angular
        _x = _v3213
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @trajectory_start.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @trajectory_start.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v3214 = val1.force
        _x = _v3214
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3215 = val1.torque
        _x = _v3215
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @trajectory_start.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @trajectory_start.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v3216 = val1.object
        _v3217 = _v3216.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3217.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3218 = _v3217.stamp
        _x = _v3218
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3217.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3216.id = str[start..(end_point-1)]
        _v3219 = _v3216.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3219.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3219.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3216.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v3216.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3216.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v3220 = val3.position
          _x = _v3220
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v3221 = val3.orientation
          _x = _v3221
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v3216.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3216.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v3216.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3216.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v3222 = val3.position
          _x = _v3222
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v3223 = val3.orientation
          _x = _v3223
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v3216.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3216.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v3216.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3216.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v3224 = val3.position
          _x = _v3224
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v3225 = val3.orientation
          _x = _v3225
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v3216.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v3216.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v3226 = val1.detach_posture
        _v3227 = _v3226.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3227.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3228 = _v3227.stamp
        _x = _v3228
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3227.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3226.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v3226.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3226.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v3229 = val3.time_from_start
          _x = _v3229
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v3226.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @trajectory_start.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@trajectory_start.is_diff,) = @@struct_C.unpack(str[start..(end_point-1)])
      @trajectory_start.is_diff = bool(@trajectory_start.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @trajectory_stages = []
      length.times do
        val1 = Moveit_msgs::RobotTrajectory.new
        _v3230 = val1.joint_trajectory
        _v3231 = _v3230.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3231.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3232 = _v3231.stamp
        _x = _v3232
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3231.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3230.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v3230.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3230.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v3233 = val3.time_from_start
          _x = _v3233
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v3230.points.push(val3)
        end
        _v3234 = val1.multi_dof_joint_trajectory
        _v3235 = _v3234.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3235.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3236 = _v3235.stamp
        _x = _v3236
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3235.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3234.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v3234.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3234.points = []
        length.times do
          val3 = Trajectory_msgs::MultiDOFJointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.transforms = []
          length.times do
            val4 = Geometry_msgs::Transform.new
            _v3237 = val4.translation
            _x = _v3237
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v3238 = val4.rotation
            _x = _v3238
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            val3.transforms.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.velocities = []
          length.times do
            val4 = Geometry_msgs::Twist.new
            _v3239 = val4.linear
            _x = _v3239
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v3240 = val4.angular
            _x = _v3240
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.velocities.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.accelerations = []
          length.times do
            val4 = Geometry_msgs::Twist.new
            _v3241 = val4.linear
            _x = _v3241
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v3242 = val4.angular
            _x = _v3242
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.accelerations.push(val4)
          end
          _v3243 = val3.time_from_start
          _x = _v3243
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v3234.points.push(val3)
        end
        @trajectory_stages.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @trajectory_descriptions = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @trajectory_descriptions.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @place_location.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@place_location.post_place_posture.header.seq, @place_location.post_place_posture.header.stamp.secs, @place_location.post_place_posture.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @place_location.post_place_posture.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @place_location.post_place_posture.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @place_location.post_place_posture.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @place_location.post_place_posture.points = []
      length.times do
        val1 = Trajectory_msgs::JointTrajectoryPoint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.positions = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.velocities = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.accelerations = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.effort = str[start..(end_point-1)].unpack(pattern)
        _v3244 = val1.time_from_start
        _x = _v3244
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @place_location.post_place_posture.points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@place_location.place_pose.header.seq, @place_location.place_pose.header.stamp.secs, @place_location.place_pose.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @place_location.place_pose.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7L3')
      (@place_location.place_pose.pose.position.x, @place_location.place_pose.pose.position.y, @place_location.place_pose.pose.position.z, @place_location.place_pose.pose.orientation.x, @place_location.place_pose.pose.orientation.y, @place_location.place_pose.pose.orientation.z, @place_location.place_pose.pose.orientation.w, @place_location.pre_place_approach.direction.header.seq, @place_location.pre_place_approach.direction.header.stamp.secs, @place_location.pre_place_approach.direction.header.stamp.nsecs,) = @@struct_d7L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @place_location.pre_place_approach.direction.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3f2L3')
      (@place_location.pre_place_approach.direction.vector.x, @place_location.pre_place_approach.direction.vector.y, @place_location.pre_place_approach.direction.vector.z, @place_location.pre_place_approach.desired_distance, @place_location.pre_place_approach.min_distance, @place_location.post_place_retreat.direction.header.seq, @place_location.post_place_retreat.direction.header.stamp.secs, @place_location.post_place_retreat.direction.header.stamp.nsecs,) = @@struct_d3f2L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @place_location.post_place_retreat.direction.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3f2')
      (@place_location.post_place_retreat.direction.vector.x, @place_location.post_place_retreat.direction.vector.y, @place_location.post_place_retreat.direction.vector.z, @place_location.post_place_retreat.desired_distance, @place_location.post_place_retreat.min_distance,) = @@struct_d3f2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @place_location.allowed_touch_objects = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @place_location.allowed_touch_objects.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
