# autogenerated by genrb from PlanningOptions.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Transform"
require "moveit_msgs/PlanningSceneWorld"
require "octomap_msgs/Octomap"
require "geometry_msgs/Point"
require "geometry_msgs/Twist"
require "shape_msgs/Mesh"
require "std_msgs/ColorRGBA"
require "moveit_msgs/LinkScale"
require "std_msgs/Header"
require "moveit_msgs/AllowedCollisionEntry"
require "moveit_msgs/ObjectColor"
require "ros/duration"
require "shape_msgs/Plane"
require "moveit_msgs/AllowedCollisionMatrix"
require "sensor_msgs/MultiDOFJointState"
require "geometry_msgs/Pose"
require "shape_msgs/MeshTriangle"
require "shape_msgs/SolidPrimitive"
require "geometry_msgs/Wrench"
require "geometry_msgs/TransformStamped"
require "moveit_msgs/RobotState"
require "moveit_msgs/PlanningScene"
require "octomap_msgs/OctomapWithPose"
require "trajectory_msgs/JointTrajectory"
require "sensor_msgs/JointState"
require "trajectory_msgs/JointTrajectoryPoint"
require "moveit_msgs/LinkPadding"
require "object_recognition_msgs/ObjectType"
require "moveit_msgs/AttachedCollisionObject"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "moveit_msgs/CollisionObject"

module Moveit_msgs

class PlanningOptions <::ROS::Message
  def self.md5sum
    "3934e50ede2ecea03e532aade900ab50"
  end

  def self.type
    "moveit_msgs/PlanningOptions"
  end

  def has_header?
    false
  end

  def message_definition
    "
# The diff to consider for the planning scene (optional)
PlanningScene planning_scene_diff

# If this flag is set to true, the action
# returns an executable plan in the response but does not attempt execution  
bool plan_only

# If this flag is set to true, the action of planning &
# executing is allowed to look around  (move sensors) if
# it seems that not enough information is available about
# the environment
bool look_around

# If this value is positive, the action of planning & executing
# is allowed to look around for a maximum number of attempts;
# If the value is left as 0, the default value is used, as set
# with dynamic_reconfigure
int32 look_around_attempts

# If set and if look_around is true, this value is used as
# the maximum cost allowed for a path to be considered executable.
# If the cost of a path is higher than this value, more sensing or 
# a new plan needed. If left as 0.0 but look_around is true, then 
# the default value set via dynamic_reconfigure is used
float64 max_safe_execution_cost

# If the plan becomes invalidated during execution, it is possible to have
# that plan recomputed and execution restarted. This flag enables this
# functionality 
bool replan

# The maximum number of replanning attempts 
int32 replan_attempts

# The amount of time to wait in between replanning attempts (in seconds)
float64 replan_delay

================================================================================
MSG: moveit_msgs/PlanningScene
# name of planning scene
string name

# full robot state
RobotState robot_state

# The name of the robot model this scene is for
string robot_model_name

#additional frames for duplicating tf (with respect to the planning frame)
geometry_msgs/TransformStamped[] fixed_frame_transforms

#full allowed collision matrix
AllowedCollisionMatrix allowed_collision_matrix

# all link paddings
LinkPadding[] link_padding

# all link scales
LinkScale[] link_scale

# Attached objects, collision objects, even the octomap or collision map can have 
# colors associated to them. This array specifies them.
ObjectColor[] object_colors

# the collision map
PlanningSceneWorld world

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
bool is_diff

================================================================================
MSG: moveit_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state

# Joints that may have multiple DOF are specified here
sensor_msgs/MultiDOFJointState multi_dof_joint_state

# Attached collision objects (attached to some link on the robot)
AttachedCollisionObject[] attached_collision_objects

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
# This is mostly important for handling the attached bodies (whether or not to clear the attached bodies
# of a moveit::core::RobotState before updating it with this message)
bool is_diff

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/MultiDOFJointState
# Representation of state for joints with multiple degrees of freedom, 
# following the structure of JointState.
#
# It is assumed that a joint in a system corresponds to a transform that gets applied 
# along the kinematic chain. For example, a planar joint (as in URDF) is 3DOF (x, y, yaw)
# and those 3DOF can be expressed as a transformation matrix, and that transformation
# matrix can be converted back to (x, y, yaw)
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# wrench associated with them, you can leave the wrench array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

Header header

string[] joint_names
geometry_msgs/Transform[] transforms
geometry_msgs/Twist[] twist
geometry_msgs/Wrench[] wrench

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: moveit_msgs/AttachedCollisionObject
# The CollisionObject will be attached with a fixed joint to this link
string link_name

#This contains the actual shapes and poses for the CollisionObject
#to be attached to the link
#If action is remove and no object.id is set, all objects
#attached to the link indicated by link_name will be removed
CollisionObject object

# The set of links that the attached objects are allowed to touch
# by default - the link_name is already considered by default
string[] touch_links

# If certain links were placed in a particular posture for this object to remain attached 
# (e.g., an end effector closing around an object), the posture necessary for releasing
# the object is stored here
trajectory_msgs/JointTrajectory detach_posture

# The weight of the attached object, if known
float64 weight

================================================================================
MSG: moveit_msgs/CollisionObject
# a header, used for interpreting the poses
Header header

# the id of the object (name used in MoveIt)
string id

# The object type in a database of known objects
object_recognition_msgs/ObjectType type

# the the collision geometries associated with the object;
# their poses are with respect to the specified header

# solid geometric primitives
shape_msgs/SolidPrimitive[] primitives
geometry_msgs/Pose[] primitive_poses

# meshes
shape_msgs/Mesh[] meshes
geometry_msgs/Pose[] mesh_poses

# bounding planes (equation is specified, but the plane can be oriented using an additional pose)
shape_msgs/Plane[] planes
geometry_msgs/Pose[] plane_poses

# Adds the object to the planning scene. If the object previously existed, it is replaced.
byte ADD=0

# Removes the object from the environment entirely (everything that matches the specified id)
byte REMOVE=1

# Append to an object that already exists in the planning scene. If the does not exist, it is added.
byte APPEND=2

# If an object already exists in the scene, new poses can be sent (the geometry arrays must be left empty)
# if solely moving the object is desired
byte MOVE=3

# Operation to be performed
byte operation

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: shape_msgs/SolidPrimitive
# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: shape_msgs/Plane
# Representation of a plane, using the plane equation ax + by + cz + d = 0

# a := coef[0]
# b := coef[1]
# c := coef[2]
# d := coef[3]

float64[4] coef

================================================================================
MSG: trajectory_msgs/JointTrajectory
Header header
string[] joint_names
JointTrajectoryPoint[] points
================================================================================
MSG: trajectory_msgs/JointTrajectoryPoint
# Each trajectory point specifies either positions[, velocities[, accelerations]]
# or positions[, effort] for the trajectory to be executed.
# All specified values are in the same order as the joint names in JointTrajectory.msg

float64[] positions
float64[] velocities
float64[] accelerations
float64[] effort
duration time_from_start

================================================================================
MSG: geometry_msgs/TransformStamped
# This expresses a transform from coordinate frame header.frame_id
# to the coordinate frame child_frame_id
#
# This message is mostly used by the 
# <a href=\"http://www.ros.org/wiki/tf\">tf</a> package. 
# See its documentation for more information.

Header header
string child_frame_id # the frame id of the child frame
Transform transform

================================================================================
MSG: moveit_msgs/AllowedCollisionMatrix
# The list of entry names in the matrix
string[] entry_names

# The individual entries in the allowed collision matrix
# square, symmetric, with same order as entry_names
AllowedCollisionEntry[] entry_values

# In addition to the collision matrix itself, we also have 
# the default entry value for each entry name.

# If the allowed collision flag is queried for a pair of names (n1, n2)
# that is not found in the collision matrix itself, the value of
# the collision flag is considered to be that of the entry (n1 or n2)
# specified in the list below. If both n1 and n2 are found in the list 
# of defaults, the result is computed with an AND operation

string[] default_entry_names
bool[] default_entry_values

================================================================================
MSG: moveit_msgs/AllowedCollisionEntry
# whether or not collision checking is enabled
bool[] enabled

================================================================================
MSG: moveit_msgs/LinkPadding
#name for the link
string link_name

# padding to apply to the link
float64 padding

================================================================================
MSG: moveit_msgs/LinkScale
#name for the link
string link_name

# scaling to apply to the link
float64 scale

================================================================================
MSG: moveit_msgs/ObjectColor
# The object id for which we specify color
string id

# The value of the color
std_msgs/ColorRGBA color

================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

================================================================================
MSG: moveit_msgs/PlanningSceneWorld
# collision objects
CollisionObject[] collision_objects

# The octomap that represents additional collision data
octomap_msgs/OctomapWithPose octomap

================================================================================
MSG: octomap_msgs/OctomapWithPose
# A 3D map in binary format, as Octree
Header header

# The pose of the octree with respect to the header frame 
geometry_msgs/Pose origin

# The actual octree msg
octomap_msgs/Octomap octomap

================================================================================
MSG: octomap_msgs/Octomap
# A 3D map in binary format, as Octree
Header header

# Flag to denote a binary (only free/occupied) or full occupancy octree (.bt/.ot file)
bool binary

# Class id of the contained octree 
string id

# Resolution (in m) of the smallest octree nodes
float64 resolution

# binary serialization of octree, use conversions.h to read and write octrees
int8[] data

"
  end
  attr_accessor :planning_scene_diff, :plan_only, :look_around, :look_around_attempts, :max_safe_execution_cost, :replan, :replan_attempts, :replan_delay

  @@struct_d7L3 = ::ROS::Struct.new("d7L3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_C3ldCld = ::ROS::Struct.new("C3ldCld")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_c = ::ROS::Struct.new("c")
  @@struct_f4 = ::ROS::Struct.new("f4")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['moveit_msgs/PlanningScene','bool','bool','int32','float64','bool','int32','float64']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [moveit_msgs/PlanningScene] :planning_scene_diff initialize value
  # @option args [bool] :plan_only initialize value
  # @option args [bool] :look_around initialize value
  # @option args [int32] :look_around_attempts initialize value
  # @option args [float64] :max_safe_execution_cost initialize value
  # @option args [bool] :replan initialize value
  # @option args [int32] :replan_attempts initialize value
  # @option args [float64] :replan_delay initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:planning_scene_diff]
      @planning_scene_diff = args[:planning_scene_diff]
    else
      @planning_scene_diff = Moveit_msgs::PlanningScene.new
    end
    if args[:plan_only]
      @plan_only = args[:plan_only]
    else
      @plan_only = false
    end
    if args[:look_around]
      @look_around = args[:look_around]
    else
      @look_around = false
    end
    if args[:look_around_attempts]
      @look_around_attempts = args[:look_around_attempts]
    else
      @look_around_attempts = 0
    end
    if args[:max_safe_execution_cost]
      @max_safe_execution_cost = args[:max_safe_execution_cost]
    else
      @max_safe_execution_cost = 0.0
    end
    if args[:replan]
      @replan = args[:replan]
    else
      @replan = false
    end
    if args[:replan_attempts]
      @replan_attempts = args[:replan_attempts]
    else
      @replan_attempts = 0
    end
    if args[:replan_delay]
      @replan_delay = args[:replan_delay]
    else
      @replan_delay = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @planning_scene_diff.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@planning_scene_diff.robot_state.joint_state.header.seq, @planning_scene_diff.robot_state.joint_state.header.stamp.secs, @planning_scene_diff.robot_state.joint_state.header.stamp.nsecs))
      _x = @planning_scene_diff.robot_state.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @planning_scene_diff.robot_state.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_scene_diff.robot_state.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @planning_scene_diff.robot_state.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@planning_scene_diff.robot_state.joint_state.position.pack(pattern))
      length = @planning_scene_diff.robot_state.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@planning_scene_diff.robot_state.joint_state.velocity.pack(pattern))
      length = @planning_scene_diff.robot_state.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@planning_scene_diff.robot_state.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@planning_scene_diff.robot_state.multi_dof_joint_state.header.seq, @planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.secs, @planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.nsecs))
      _x = @planning_scene_diff.robot_state.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @planning_scene_diff.robot_state.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_scene_diff.robot_state.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @planning_scene_diff.robot_state.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_scene_diff.robot_state.multi_dof_joint_state.transforms
        _v3245 = val1.translation
        _x = _v3245
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3246 = val1.rotation
        _x = _v3246
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @planning_scene_diff.robot_state.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_scene_diff.robot_state.multi_dof_joint_state.twist
        _v3247 = val1.linear
        _x = _v3247
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3248 = val1.angular
        _x = _v3248
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @planning_scene_diff.robot_state.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_scene_diff.robot_state.multi_dof_joint_state.wrench
        _v3249 = val1.force
        _x = _v3249
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3250 = val1.torque
        _x = _v3250
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @planning_scene_diff.robot_state.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_scene_diff.robot_state.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3251 = val1.object
        _v3252 = _v3251.header
        buff.write(@@struct_L.pack(_v3252.seq))
        _v3253 = _v3252.stamp
        _x = _v3253
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3252.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v3251.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3254 = _v3251.type
        _x = _v3254.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v3254.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3251.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3251.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v3251.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3251.primitive_poses
          _v3255 = val3.position
          _x = _v3255
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v3256 = val3.orientation
          _x = _v3256
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v3251.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3251.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v3251.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3251.mesh_poses
          _v3257 = val3.position
          _x = _v3257
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v3258 = val3.orientation
          _x = _v3258
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v3251.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3251.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v3251.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3251.plane_poses
          _v3259 = val3.position
          _x = _v3259
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v3260 = val3.orientation
          _x = _v3260
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v3251.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v3261 = val1.detach_posture
        _v3262 = _v3261.header
        buff.write(@@struct_L.pack(_v3262.seq))
        _v3263 = _v3262.stamp
        _x = _v3263
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3262.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v3261.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3261.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v3261.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v3261.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v3264 = val3.time_from_start
          _x = _v3264
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_C.pack(@planning_scene_diff.robot_state.is_diff))
      _x = @planning_scene_diff.robot_model_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @planning_scene_diff.fixed_frame_transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_scene_diff.fixed_frame_transforms
        _v3265 = val1.header
        buff.write(@@struct_L.pack(_v3265.seq))
        _v3266 = _v3265.stamp
        _x = _v3266
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3265.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.child_frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3267 = val1.transform
        _v3268 = _v3267.translation
        _x = _v3268
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3269 = _v3267.rotation
        _x = _v3269
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @planning_scene_diff.allowed_collision_matrix.entry_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_scene_diff.allowed_collision_matrix.entry_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @planning_scene_diff.allowed_collision_matrix.entry_values.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_scene_diff.allowed_collision_matrix.entry_values
        length = val1.enabled.length
        buff.write(@@struct_L.pack(length))
        pattern = "C#{length}"
        buff.write(*val1.enabled.pack(pattern))
      end
      length = @planning_scene_diff.allowed_collision_matrix.default_entry_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_scene_diff.allowed_collision_matrix.default_entry_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @planning_scene_diff.allowed_collision_matrix.default_entry_values.length
      buff.write(@@struct_L.pack(length))
      pattern = "C#{length}"
      buff.write(*@planning_scene_diff.allowed_collision_matrix.default_entry_values.pack(pattern))
      length = @planning_scene_diff.link_padding.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_scene_diff.link_padding
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_d.pack(val1.padding))
      end
      length = @planning_scene_diff.link_scale.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_scene_diff.link_scale
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_d.pack(val1.scale))
      end
      length = @planning_scene_diff.object_colors.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_scene_diff.object_colors
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3270 = val1.color
        _x = _v3270
        buff.write(@@struct_f4.pack(_x.r, _x.g, _x.b, _x.a))
      end
      length = @planning_scene_diff.world.collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @planning_scene_diff.world.collision_objects
        _v3271 = val1.header
        buff.write(@@struct_L.pack(_v3271.seq))
        _v3272 = _v3271.stamp
        _x = _v3272
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3271.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v3273 = val1.type
        _x = _v3273.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v3273.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.primitives.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.primitives
          buff.write(@@struct_C.pack(val2.type))
          length = val2.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val2.dimensions.pack(pattern))
        end
        length = val1.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.primitive_poses
          _v3274 = val2.position
          _x = _v3274
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v3275 = val2.orientation
          _x = _v3275
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.meshes.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.meshes
          length = val2.triangles.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.triangles
            buff.write(@@struct_L3.pack(*val3.vertex_indices))
          end
          length = val2.vertices.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.vertices
            _x = val3
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = val1.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.mesh_poses
          _v3276 = val2.position
          _x = _v3276
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v3277 = val2.orientation
          _x = _v3277
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.planes.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.planes
          buff.write(@@struct_d4.pack(*val2.coef))
        end
        length = val1.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.plane_poses
          _v3278 = val2.position
          _x = _v3278
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v3279 = val2.orientation
          _x = _v3279
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(val1.operation))
      end
      buff.write(@@struct_L3.pack(@planning_scene_diff.world.octomap.header.seq, @planning_scene_diff.world.octomap.header.stamp.secs, @planning_scene_diff.world.octomap.header.stamp.nsecs))
      _x = @planning_scene_diff.world.octomap.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7L3.pack(@planning_scene_diff.world.octomap.origin.position.x, @planning_scene_diff.world.octomap.origin.position.y, @planning_scene_diff.world.octomap.origin.position.z, @planning_scene_diff.world.octomap.origin.orientation.x, @planning_scene_diff.world.octomap.origin.orientation.y, @planning_scene_diff.world.octomap.origin.orientation.z, @planning_scene_diff.world.octomap.origin.orientation.w, @planning_scene_diff.world.octomap.octomap.header.seq, @planning_scene_diff.world.octomap.octomap.header.stamp.secs, @planning_scene_diff.world.octomap.octomap.header.stamp.nsecs))
      _x = @planning_scene_diff.world.octomap.octomap.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@planning_scene_diff.world.octomap.octomap.binary))
      _x = @planning_scene_diff.world.octomap.octomap.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d.pack(@planning_scene_diff.world.octomap.octomap.resolution))
      length = @planning_scene_diff.world.octomap.octomap.data.length
      buff.write(@@struct_L.pack(length))
      pattern = "c#{length}"
      buff.write(*@planning_scene_diff.world.octomap.octomap.data.pack(pattern))
      buff.write(@@struct_C3ldCld.pack(@planning_scene_diff.is_diff, @plan_only, @look_around, @look_around_attempts, @max_safe_execution_cost, @replan, @replan_attempts, @replan_delay))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @planning_scene_diff == nil
        @planning_scene_diff = Moveit_msgs::PlanningScene.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @planning_scene_diff.name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@planning_scene_diff.robot_state.joint_state.header.seq, @planning_scene_diff.robot_state.joint_state.header.stamp.secs, @planning_scene_diff.robot_state.joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @planning_scene_diff.robot_state.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_scene_diff.robot_state.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @planning_scene_diff.robot_state.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @planning_scene_diff.robot_state.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @planning_scene_diff.robot_state.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @planning_scene_diff.robot_state.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@planning_scene_diff.robot_state.multi_dof_joint_state.header.seq, @planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.secs, @planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @planning_scene_diff.robot_state.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_scene_diff.robot_state.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @planning_scene_diff.robot_state.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_scene_diff.robot_state.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v3280 = val1.translation
        _x = _v3280
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3281 = val1.rotation
        _x = _v3281
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @planning_scene_diff.robot_state.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_scene_diff.robot_state.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v3282 = val1.linear
        _x = _v3282
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3283 = val1.angular
        _x = _v3283
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @planning_scene_diff.robot_state.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_scene_diff.robot_state.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v3284 = val1.force
        _x = _v3284
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3285 = val1.torque
        _x = _v3285
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @planning_scene_diff.robot_state.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_scene_diff.robot_state.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v3286 = val1.object
        _v3287 = _v3286.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3287.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3288 = _v3287.stamp
        _x = _v3288
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3287.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3286.id = str[start..(end_point-1)]
        _v3289 = _v3286.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3289.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3289.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3286.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v3286.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3286.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v3290 = val3.position
          _x = _v3290
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v3291 = val3.orientation
          _x = _v3291
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v3286.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3286.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v3286.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3286.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v3292 = val3.position
          _x = _v3292
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v3293 = val3.orientation
          _x = _v3293
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v3286.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3286.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v3286.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3286.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v3294 = val3.position
          _x = _v3294
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v3295 = val3.orientation
          _x = _v3295
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v3286.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v3286.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v3296 = val1.detach_posture
        _v3297 = _v3296.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3297.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3298 = _v3297.stamp
        _x = _v3298
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3297.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3296.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v3296.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3296.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v3299 = val3.time_from_start
          _x = _v3299
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v3296.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @planning_scene_diff.robot_state.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@planning_scene_diff.robot_state.is_diff,) = @@struct_C.unpack(str[start..(end_point-1)])
      @planning_scene_diff.robot_state.is_diff = bool(@planning_scene_diff.robot_state.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @planning_scene_diff.robot_model_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_scene_diff.fixed_frame_transforms = []
      length.times do
        val1 = Geometry_msgs::TransformStamped.new
        _v3300 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3300.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3301 = _v3300.stamp
        _x = _v3301
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3300.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.child_frame_id = str[start..(end_point-1)]
        _v3302 = val1.transform
        _v3303 = _v3302.translation
        _x = _v3303
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3304 = _v3302.rotation
        _x = _v3304
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @planning_scene_diff.fixed_frame_transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_scene_diff.allowed_collision_matrix.entry_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @planning_scene_diff.allowed_collision_matrix.entry_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_scene_diff.allowed_collision_matrix.entry_values = []
      length.times do
        val1 = Moveit_msgs::AllowedCollisionEntry.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "C#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.enabled = str[start..(end_point-1)].unpack(pattern)
        val1.enabled = map(bool, val1.enabled)
        @planning_scene_diff.allowed_collision_matrix.entry_values.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_scene_diff.allowed_collision_matrix.default_entry_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @planning_scene_diff.allowed_collision_matrix.default_entry_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "C#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @planning_scene_diff.allowed_collision_matrix.default_entry_values = str[start..(end_point-1)].unpack(pattern)
      @planning_scene_diff.allowed_collision_matrix.default_entry_values = map(bool, @planning_scene_diff.allowed_collision_matrix.default_entry_values)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_scene_diff.link_padding = []
      length.times do
        val1 = Moveit_msgs::LinkPadding.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.padding,) = @@struct_d.unpack(str[start..(end_point-1)])
        @planning_scene_diff.link_padding.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_scene_diff.link_scale = []
      length.times do
        val1 = Moveit_msgs::LinkScale.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.scale,) = @@struct_d.unpack(str[start..(end_point-1)])
        @planning_scene_diff.link_scale.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_scene_diff.object_colors = []
      length.times do
        val1 = Moveit_msgs::ObjectColor.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v3305 = val1.color
        _x = _v3305
        start = end_point
        end_point += ROS::Struct::calc_size('f4')
        (_x.r, _x.g, _x.b, _x.a,) = @@struct_f4.unpack(str[start..(end_point-1)])
        @planning_scene_diff.object_colors.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @planning_scene_diff.world.collision_objects = []
      length.times do
        val1 = Moveit_msgs::CollisionObject.new
        _v3306 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3306.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3307 = _v3306.stamp
        _x = _v3307
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3306.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v3308 = val1.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3308.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3308.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.primitives = []
        length.times do
          val2 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val2.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val2.dimensions = str[start..(end_point-1)].unpack(pattern)
          val1.primitives.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.primitive_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v3309 = val2.position
          _x = _v3309
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v3310 = val2.orientation
          _x = _v3310
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.primitive_poses.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.meshes = []
        length.times do
          val2 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.triangles = []
          length.times do
            val3 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val3.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val2.triangles.push(val3)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.vertices = []
          length.times do
            val3 = Geometry_msgs::Point.new
            _x = val3
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val2.vertices.push(val3)
          end
          val1.meshes.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.mesh_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v3311 = val2.position
          _x = _v3311
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v3312 = val2.orientation
          _x = _v3312
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.mesh_poses.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.planes = []
        length.times do
          val2 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val2.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.planes.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.plane_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v3313 = val2.position
          _x = _v3313
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v3314 = val2.orientation
          _x = _v3314
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.plane_poses.push(val2)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (val1.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        @planning_scene_diff.world.collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@planning_scene_diff.world.octomap.header.seq, @planning_scene_diff.world.octomap.header.stamp.secs, @planning_scene_diff.world.octomap.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @planning_scene_diff.world.octomap.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7L3')
      (@planning_scene_diff.world.octomap.origin.position.x, @planning_scene_diff.world.octomap.origin.position.y, @planning_scene_diff.world.octomap.origin.position.z, @planning_scene_diff.world.octomap.origin.orientation.x, @planning_scene_diff.world.octomap.origin.orientation.y, @planning_scene_diff.world.octomap.origin.orientation.z, @planning_scene_diff.world.octomap.origin.orientation.w, @planning_scene_diff.world.octomap.octomap.header.seq, @planning_scene_diff.world.octomap.octomap.header.stamp.secs, @planning_scene_diff.world.octomap.octomap.header.stamp.nsecs,) = @@struct_d7L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @planning_scene_diff.world.octomap.octomap.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@planning_scene_diff.world.octomap.octomap.binary,) = @@struct_C.unpack(str[start..(end_point-1)])
      @planning_scene_diff.world.octomap.octomap.binary = bool(@planning_scene_diff.world.octomap.octomap.binary)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @planning_scene_diff.world.octomap.octomap.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d')
      (@planning_scene_diff.world.octomap.octomap.resolution,) = @@struct_d.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "c#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @planning_scene_diff.world.octomap.octomap.data = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('C3ldCld')
      (@planning_scene_diff.is_diff, @plan_only, @look_around, @look_around_attempts, @max_safe_execution_cost, @replan, @replan_attempts, @replan_delay,) = @@struct_C3ldCld.unpack(str[start..(end_point-1)])
      @planning_scene_diff.is_diff = bool(@planning_scene_diff.is_diff)
      @plan_only = bool(@plan_only)
      @look_around = bool(@look_around)
      @replan = bool(@replan)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
