# autogenerated by genrb from PositionConstraint.msg. Do not edit.
require 'ros/message'

require "shape_msgs/MeshTriangle"
require "shape_msgs/SolidPrimitive"
require "moveit_msgs/BoundingVolume"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "shape_msgs/Mesh"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "geometry_msgs/Pose"

module Moveit_msgs

class PositionConstraint <::ROS::Message
  def self.md5sum
    "c83edf208d87d3aa3169f47775a58e6a"
  end

  def self.type
    "moveit_msgs/PositionConstraint"
  end

  def has_header?
    true
  end

  def message_definition
    "# This message contains the definition of a position constraint.

Header header

# The robot link this constraint refers to
string link_name

# The offset (in the link frame) for the target point on the link we are planning for
geometry_msgs/Vector3 target_point_offset

# The volume this constraint refers to 
BoundingVolume constraint_region

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: moveit_msgs/BoundingVolume
# Define a volume in 3D

# A set of solid geometric primitives that make up the volume to define (as a union)
shape_msgs/SolidPrimitive[] primitives

# The poses at which the primitives are located
geometry_msgs/Pose[] primitive_poses

# In addition to primitives, meshes can be specified to add to the bounding volume (again, as union)
shape_msgs/Mesh[] meshes

# The poses at which the meshes are located
geometry_msgs/Pose[] mesh_poses

================================================================================
MSG: shape_msgs/SolidPrimitive
# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

"
  end
  attr_accessor :header, :link_name, :target_point_offset, :constraint_region, :weight

  @@struct_d = ::ROS::Struct.new("d")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','string','geometry_msgs/Vector3','moveit_msgs/BoundingVolume','float64']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [string] :link_name initialize value
  # @option args [geometry_msgs/Vector3] :target_point_offset initialize value
  # @option args [moveit_msgs/BoundingVolume] :constraint_region initialize value
  # @option args [float64] :weight initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:link_name]
      @link_name = args[:link_name]
    else
      @link_name = ''
    end
    if args[:target_point_offset]
      @target_point_offset = args[:target_point_offset]
    else
      @target_point_offset = Geometry_msgs::Vector3.new
    end
    if args[:constraint_region]
      @constraint_region = args[:constraint_region]
    else
      @constraint_region = Moveit_msgs::BoundingVolume.new
    end
    if args[:weight]
      @weight = args[:weight]
    else
      @weight = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @link_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3.pack(@target_point_offset.x, @target_point_offset.y, @target_point_offset.z))
      length = @constraint_region.primitives.length
      buff.write(@@struct_L.pack(length))
      for val1 in @constraint_region.primitives
        buff.write(@@struct_C.pack(val1.type))
        length = val1.dimensions.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.dimensions.pack(pattern))
      end
      length = @constraint_region.primitive_poses.length
      buff.write(@@struct_L.pack(length))
      for val1 in @constraint_region.primitive_poses
        _v3403 = val1.position
        _x = _v3403
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3404 = val1.orientation
        _x = _v3404
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @constraint_region.meshes.length
      buff.write(@@struct_L.pack(length))
      for val1 in @constraint_region.meshes
        length = val1.triangles.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.triangles
          buff.write(@@struct_L3.pack(*val2.vertex_indices))
        end
        length = val1.vertices.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.vertices
          _x = val2
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
      end
      length = @constraint_region.mesh_poses.length
      buff.write(@@struct_L.pack(length))
      for val1 in @constraint_region.mesh_poses
        _v3405 = val1.position
        _x = _v3405
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3406 = val1.orientation
        _x = _v3406
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      buff.write(@@struct_d.pack(@weight))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @target_point_offset == nil
        @target_point_offset = Geometry_msgs::Vector3.new
      end
      if @constraint_region == nil
        @constraint_region = Moveit_msgs::BoundingVolume.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @link_name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3')
      (@target_point_offset.x, @target_point_offset.y, @target_point_offset.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @constraint_region.primitives = []
      length.times do
        val1 = Shape_msgs::SolidPrimitive.new
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (val1.type,) = @@struct_C.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.dimensions = str[start..(end_point-1)].unpack(pattern)
        @constraint_region.primitives.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @constraint_region.primitive_poses = []
      length.times do
        val1 = Geometry_msgs::Pose.new
        _v3407 = val1.position
        _x = _v3407
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3408 = val1.orientation
        _x = _v3408
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @constraint_region.primitive_poses.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @constraint_region.meshes = []
      length.times do
        val1 = Shape_msgs::Mesh.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.triangles = []
        length.times do
          val2 = Shape_msgs::MeshTriangle.new
          start = end_point
          end_point += ROS::Struct::calc_size('L3')
          val2.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
          val1.triangles.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.vertices = []
        length.times do
          val2 = Geometry_msgs::Point.new
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.vertices.push(val2)
        end
        @constraint_region.meshes.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @constraint_region.mesh_poses = []
      length.times do
        val1 = Geometry_msgs::Pose.new
        _v3409 = val1.position
        _x = _v3409
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3410 = val1.orientation
        _x = _v3410
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @constraint_region.mesh_poses.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('d')
      (@weight,) = @@struct_d.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
