# autogenerated by genrb from WorkspaceParameters.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Vector3"

module Moveit_msgs

class WorkspaceParameters <::ROS::Message
  def self.md5sum
    "d639a834e7b1f927e9f1d6c30e920016"
  end

  def self.type
    "moveit_msgs/WorkspaceParameters"
  end

  def has_header?
    true
  end

  def message_definition
    "# This message contains a set of parameters useful in
# setting up the volume (a box) in which the robot is allowed to move.
# This is useful only when planning for mobile parts of 
# the robot as well.

# Define the frame of reference for the box corners
Header header

# The minumum corner of the box, with respect to the robot starting pose
geometry_msgs/Vector3 min_corner

# The maximum corner of the box, with respect to the robot starting pose
geometry_msgs/Vector3 max_corner

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :header, :min_corner, :max_corner

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d6 = ::ROS::Struct.new("d6")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','geometry_msgs/Vector3','geometry_msgs/Vector3']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [geometry_msgs/Vector3] :min_corner initialize value
  # @option args [geometry_msgs/Vector3] :max_corner initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:min_corner]
      @min_corner = args[:min_corner]
    else
      @min_corner = Geometry_msgs::Vector3.new
    end
    if args[:max_corner]
      @max_corner = args[:max_corner]
    else
      @max_corner = Geometry_msgs::Vector3.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d6.pack(@min_corner.x, @min_corner.y, @min_corner.z, @max_corner.x, @max_corner.y, @max_corner.z))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @min_corner == nil
        @min_corner = Geometry_msgs::Vector3.new
      end
      if @max_corner == nil
        @max_corner = Geometry_msgs::Vector3.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d6')
      (@min_corner.x, @min_corner.y, @min_corner.z, @max_corner.x, @max_corner.y, @max_corner.z,) = @@struct_d6.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
