# autogenerated by genrb from GetPlanRequest.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Point"
require "geometry_msgs/Pose"
require "geometry_msgs/PoseStamped"

module Nav_msgs

class GetPlanRequest <::ROS::Message
  def self.md5sum
    "e25a43e0752bcca599a8c2eef8282df8"
  end

  def self.type
    "nav_msgs/GetPlanRequest"
  end

  def has_header?
    false
  end

  def message_definition
    "


geometry_msgs/PoseStamped start


geometry_msgs/PoseStamped goal



float32 tolerance

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :start, :goal, :tolerance

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d7L3 = ::ROS::Struct.new("d7L3")
  @@struct_d7f = ::ROS::Struct.new("d7f")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['geometry_msgs/PoseStamped','geometry_msgs/PoseStamped','float32']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [geometry_msgs/PoseStamped] :start initialize value
  # @option args [geometry_msgs/PoseStamped] :goal initialize value
  # @option args [float32] :tolerance initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:start]
      @start = args[:start]
    else
      @start = Geometry_msgs::PoseStamped.new
    end
    if args[:goal]
      @goal = args[:goal]
    else
      @goal = Geometry_msgs::PoseStamped.new
    end
    if args[:tolerance]
      @tolerance = args[:tolerance]
    else
      @tolerance = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@start.header.seq, @start.header.stamp.secs, @start.header.stamp.nsecs))
      _x = @start.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7L3.pack(@start.pose.position.x, @start.pose.position.y, @start.pose.position.z, @start.pose.orientation.x, @start.pose.orientation.y, @start.pose.orientation.z, @start.pose.orientation.w, @goal.header.seq, @goal.header.stamp.secs, @goal.header.stamp.nsecs))
      _x = @goal.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7f.pack(@goal.pose.position.x, @goal.pose.position.y, @goal.pose.position.z, @goal.pose.orientation.x, @goal.pose.orientation.y, @goal.pose.orientation.z, @goal.pose.orientation.w, @tolerance))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @start == nil
        @start = Geometry_msgs::PoseStamped.new
      end
      if @goal == nil
        @goal = Geometry_msgs::PoseStamped.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@start.header.seq, @start.header.stamp.secs, @start.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @start.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7L3')
      (@start.pose.position.x, @start.pose.position.y, @start.pose.position.z, @start.pose.orientation.x, @start.pose.orientation.y, @start.pose.orientation.z, @start.pose.orientation.w, @goal.header.seq, @goal.header.stamp.secs, @goal.header.stamp.nsecs,) = @@struct_d7L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @goal.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7f')
      (@goal.pose.position.x, @goal.pose.position.y, @goal.pose.position.z, @goal.pose.orientation.x, @goal.pose.orientation.y, @goal.pose.orientation.z, @goal.pose.orientation.w, @tolerance,) = @@struct_d7f.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
# autogenerated by genrb from GetPlanResponse.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/PoseStamped"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "nav_msgs/Path"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Pose"

module Nav_msgs

class GetPlanResponse <::ROS::Message
  def self.md5sum
    "0002bc113c0259d71f6cf8cbc9430e18"
  end

  def self.type
    "nav_msgs/GetPlanResponse"
  end

  def has_header?
    false
  end

  def message_definition
    "nav_msgs/Path plan


================================================================================
MSG: nav_msgs/Path
#An array of poses that represents a Path for a robot to follow
Header header
geometry_msgs/PoseStamped[] poses

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :plan

  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['nav_msgs/Path']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [nav_msgs/Path] :plan initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:plan]
      @plan = args[:plan]
    else
      @plan = Nav_msgs::Path.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@plan.header.seq, @plan.header.stamp.secs, @plan.header.stamp.nsecs))
      _x = @plan.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @plan.poses.length
      buff.write(@@struct_L.pack(length))
      for val1 in @plan.poses
        _v4529 = val1.header
        buff.write(@@struct_L.pack(_v4529.seq))
        _v4530 = _v4529.stamp
        _x = _v4530
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v4529.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v4531 = val1.pose
        _v4532 = _v4531.position
        _x = _v4532
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v4533 = _v4531.orientation
        _x = _v4533
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @plan == nil
        @plan = Nav_msgs::Path.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@plan.header.seq, @plan.header.stamp.secs, @plan.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @plan.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @plan.poses = []
      length.times do
        val1 = Geometry_msgs::PoseStamped.new
        _v4534 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v4534.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v4535 = _v4534.stamp
        _x = _v4535
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v4534.frame_id = str[start..(end_point-1)]
        _v4536 = val1.pose
        _v4537 = _v4536.position
        _x = _v4537
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v4538 = _v4536.orientation
        _x = _v4538
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @plan.poses.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
module Nav_msgs
class GetPlan
  def self.type
    'nav_msgs/GetPlan'
  end
  def self.md5sum
    '421c8ea4d21c6c9db7054b4bbdf1e024'
  end
  def self.request_class
    GetPlanRequest
  end
  def self.response_class
    GetPlanResponse
  end
end
end