# autogenerated by genrb from MapMetaData.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "geometry_msgs/Point"
require "geometry_msgs/Pose"
require "geometry_msgs/Quaternion"

module Nav_msgs

class MapMetaData <::ROS::Message
  def self.md5sum
    "10cfc8a2818024d3248802c00c95f11b"
  end

  def self.type
    "nav_msgs/MapMetaData"
  end

  def has_header?
    false
  end

  def message_definition
    "# This hold basic information about the characterists of the OccupancyGrid

# The time at which the map was loaded
time map_load_time
# The map resolution [m/cell]
float32 resolution
# Map width [cells]
uint32 width
# Map height [cells]
uint32 height
# The origin of the map [m, m, rad].  This is the real-world pose of the
# cell (0,0) in the map.
geometry_msgs/Pose origin
================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :map_load_time, :resolution, :width, :height, :origin

  @@struct_L2fL2d7 = ::ROS::Struct.new("L2fL2d7")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['time','float32','uint32','uint32','geometry_msgs/Pose']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [time] :map_load_time initialize value
  # @option args [float32] :resolution initialize value
  # @option args [uint32] :width initialize value
  # @option args [uint32] :height initialize value
  # @option args [geometry_msgs/Pose] :origin initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:map_load_time]
      @map_load_time = args[:map_load_time]
    else
      @map_load_time = ROS::Time.new
    end
    if args[:resolution]
      @resolution = args[:resolution]
    else
      @resolution = 0.0
    end
    if args[:width]
      @width = args[:width]
    else
      @width = 0
    end
    if args[:height]
      @height = args[:height]
    else
      @height = 0
    end
    if args[:origin]
      @origin = args[:origin]
    else
      @origin = Geometry_msgs::Pose.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L2fL2d7.pack(@map_load_time.secs, @map_load_time.nsecs, @resolution, @width, @height, @origin.position.x, @origin.position.y, @origin.position.z, @origin.orientation.x, @origin.orientation.y, @origin.orientation.z, @origin.orientation.w))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @map_load_time == nil
        @map_load_time = ROS::Time.new
      end
      if @origin == nil
        @origin = Geometry_msgs::Pose.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L2fL2d7')
      (@map_load_time.secs, @map_load_time.nsecs, @resolution, @width, @height, @origin.position.x, @origin.position.y, @origin.position.z, @origin.orientation.x, @origin.orientation.y, @origin.orientation.z, @origin.orientation.w,) = @@struct_L2fL2d7.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
