# autogenerated by genrb from OccupancyGrid.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "nav_msgs/MapMetaData"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Pose"

module Nav_msgs

class OccupancyGrid <::ROS::Message
  def self.md5sum
    "3381f2d731d4076ec5c71b0759edbe4e"
  end

  def self.type
    "nav_msgs/OccupancyGrid"
  end

  def has_header?
    true
  end

  def message_definition
    "# This represents a 2-D grid map, in which each cell represents the probability of
# occupancy.

Header header 

#MetaData for the map
MapMetaData info

# The map data, in row-major order, starting with (0,0).  Occupancy
# probabilities are in the range [0,100].  Unknown is -1.
int8[] data

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: nav_msgs/MapMetaData
# This hold basic information about the characterists of the OccupancyGrid

# The time at which the map was loaded
time map_load_time
# The map resolution [m/cell]
float32 resolution
# Map width [cells]
uint32 width
# Map height [cells]
uint32 height
# The origin of the map [m, m, rad].  This is the real-world pose of the
# cell (0,0) in the map.
geometry_msgs/Pose origin
================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :header, :info, :data

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_L2fL2d7 = ::ROS::Struct.new("L2fL2d7")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','nav_msgs/MapMetaData','int8[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [nav_msgs/MapMetaData] :info initialize value
  # @option args [int8[]] :data initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:info]
      @info = args[:info]
    else
      @info = Nav_msgs::MapMetaData.new
    end
    if args[:data]
      @data = args[:data]
    else
      @data = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2fL2d7.pack(@info.map_load_time.secs, @info.map_load_time.nsecs, @info.resolution, @info.width, @info.height, @info.origin.position.x, @info.origin.position.y, @info.origin.position.z, @info.origin.orientation.x, @info.origin.orientation.y, @info.origin.orientation.z, @info.origin.orientation.w))
      length = @data.length
      buff.write(@@struct_L.pack(length))
      pattern = "c#{length}"
      buff.write(*@data.pack(pattern))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @info == nil
        @info = Nav_msgs::MapMetaData.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2fL2d7')
      (@info.map_load_time.secs, @info.map_load_time.nsecs, @info.resolution, @info.width, @info.height, @info.origin.position.x, @info.origin.position.y, @info.origin.position.z, @info.origin.orientation.x, @info.origin.orientation.y, @info.origin.orientation.z, @info.origin.orientation.w,) = @@struct_L2fL2d7.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "c#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @data = str[start..(end_point-1)].unpack(pattern)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
