# autogenerated by genrb from GetObjectInformationRequest.msg. Do not edit.
require 'ros/message'

require "object_recognition_msgs/ObjectType"

module Object_recognition_msgs

class GetObjectInformationRequest <::ROS::Message
  def self.md5sum
    "0d72b69e80da0fe473b0bdcdd7a28d4d"
  end

  def self.type
    "object_recognition_msgs/GetObjectInformationRequest"
  end

  def has_header?
    false
  end

  def message_definition
    "


object_recognition_msgs/ObjectType type


================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

"
  end
  attr_accessor :type


  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['object_recognition_msgs/ObjectType']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [object_recognition_msgs/ObjectType] :type initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:type]
      @type = args[:type]
    else
      @type = Object_recognition_msgs::ObjectType.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @type.key
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @type.db
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @type == nil
        @type = Object_recognition_msgs::ObjectType.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @type.key = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @type.db = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
# autogenerated by genrb from GetObjectInformationResponse.msg. Do not edit.
require 'ros/message'

require "shape_msgs/MeshTriangle"
require "sensor_msgs/PointField"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "shape_msgs/Mesh"
require "object_recognition_msgs/ObjectInformation"
require "sensor_msgs/PointCloud2"

module Object_recognition_msgs

class GetObjectInformationResponse <::ROS::Message
  def self.md5sum
    "a62c5d1c41e250373b3e8e912a13a9cb"
  end

  def self.type
    "object_recognition_msgs/GetObjectInformationResponse"
  end

  def has_header?
    false
  end

  def message_definition
    "

object_recognition_msgs/ObjectInformation information


================================================================================
MSG: object_recognition_msgs/ObjectInformation
############################################## VISUALIZATION INFO ######################################################
################### THIS INFO SHOULD BE OBTAINED INDEPENDENTLY FROM THE CORE, LIKE IN AN RVIZ PLUGIN ###################

# The human readable name of the object
string name

# The full mesh of the object: this can be useful for display purposes, augmented reality ... but it can be big
# Make sure the type is MESH
shape_msgs/Mesh ground_truth_mesh

# Sometimes, you only have a cloud in the DB
# Make sure the type is POINTS
sensor_msgs/PointCloud2 ground_truth_point_cloud

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the \"fields\" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field

"
  end
  attr_accessor :information

  @@struct_LCL = ::ROS::Struct.new("LCL")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_CL2 = ::ROS::Struct.new("CL2")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['object_recognition_msgs/ObjectInformation']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [object_recognition_msgs/ObjectInformation] :information initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:information]
      @information = args[:information]
    else
      @information = Object_recognition_msgs::ObjectInformation.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @information.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @information.ground_truth_mesh.triangles.length
      buff.write(@@struct_L.pack(length))
      for val1 in @information.ground_truth_mesh.triangles
        buff.write(@@struct_L3.pack(*val1.vertex_indices))
      end
      length = @information.ground_truth_mesh.vertices.length
      buff.write(@@struct_L.pack(length))
      for val1 in @information.ground_truth_mesh.vertices
        _x = val1
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      buff.write(@@struct_L3.pack(@information.ground_truth_point_cloud.header.seq, @information.ground_truth_point_cloud.header.stamp.secs, @information.ground_truth_point_cloud.header.stamp.nsecs))
      _x = @information.ground_truth_point_cloud.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@information.ground_truth_point_cloud.height, @information.ground_truth_point_cloud.width))
      length = @information.ground_truth_point_cloud.fields.length
      buff.write(@@struct_L.pack(length))
      for val1 in @information.ground_truth_point_cloud.fields
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_LCL.pack(_x.offset, _x.datatype, _x.count))
      end
      buff.write(@@struct_CL2.pack(@information.ground_truth_point_cloud.is_bigendian, @information.ground_truth_point_cloud.point_step, @information.ground_truth_point_cloud.row_step))
      _x = @information.ground_truth_point_cloud.data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@information.ground_truth_point_cloud.is_dense))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @information == nil
        @information = Object_recognition_msgs::ObjectInformation.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @information.name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @information.ground_truth_mesh.triangles = []
      length.times do
        val1 = Shape_msgs::MeshTriangle.new
        start = end_point
        end_point += ROS::Struct::calc_size('L3')
        val1.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
        @information.ground_truth_mesh.triangles.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @information.ground_truth_mesh.vertices = []
      length.times do
        val1 = Geometry_msgs::Point.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @information.ground_truth_mesh.vertices.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@information.ground_truth_point_cloud.header.seq, @information.ground_truth_point_cloud.header.stamp.secs, @information.ground_truth_point_cloud.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @information.ground_truth_point_cloud.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@information.ground_truth_point_cloud.height, @information.ground_truth_point_cloud.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @information.ground_truth_point_cloud.fields = []
      length.times do
        val1 = Sensor_msgs::PointField.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('LCL')
        (_x.offset, _x.datatype, _x.count,) = @@struct_LCL.unpack(str[start..(end_point-1)])
        @information.ground_truth_point_cloud.fields.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('CL2')
      (@information.ground_truth_point_cloud.is_bigendian, @information.ground_truth_point_cloud.point_step, @information.ground_truth_point_cloud.row_step,) = @@struct_CL2.unpack(str[start..(end_point-1)])
      @information.ground_truth_point_cloud.is_bigendian = bool(@information.ground_truth_point_cloud.is_bigendian)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @information.ground_truth_point_cloud.data = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@information.ground_truth_point_cloud.is_dense,) = @@struct_C.unpack(str[start..(end_point-1)])
      @information.ground_truth_point_cloud.is_dense = bool(@information.ground_truth_point_cloud.is_dense)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
module Object_recognition_msgs
class GetObjectInformation
  def self.type
    'object_recognition_msgs/GetObjectInformation'
  end
  def self.md5sum
    'dd7d344324fd86c32836f4fe1bc7b322'
  end
  def self.request_class
    GetObjectInformationRequest
  end
  def self.response_class
    GetObjectInformationResponse
  end
end
end