# autogenerated by genrb from ObjectRecognitionAction.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "sensor_msgs/PointField"
require "object_recognition_msgs/ObjectRecognitionActionGoal"
require "geometry_msgs/Point"
require "shape_msgs/Mesh"
require "sensor_msgs/PointCloud2"
require "actionlib_msgs/GoalStatus"
require "geometry_msgs/PoseWithCovariance"
require "std_msgs/Header"
require "object_recognition_msgs/ObjectRecognitionFeedback"
require "object_recognition_msgs/ObjectRecognitionActionFeedback"
require "shape_msgs/MeshTriangle"
require "object_recognition_msgs/ObjectRecognitionActionResult"
require "object_recognition_msgs/RecognizedObjectArray"
require "object_recognition_msgs/ObjectRecognitionResult"
require "object_recognition_msgs/ObjectRecognitionGoal"
require "geometry_msgs/PoseWithCovarianceStamped"
require "geometry_msgs/Pose"
require "object_recognition_msgs/ObjectType"
require "actionlib_msgs/GoalID"
require "object_recognition_msgs/RecognizedObject"
require "geometry_msgs/Quaternion"

module Object_recognition_msgs

class ObjectRecognitionAction <::ROS::Message
  def self.md5sum
    "7d8979a0cf97e5078553ee3efee047d2"
  end

  def self.type
    "object_recognition_msgs/ObjectRecognitionAction"
  end

  def has_header?
    false
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

ObjectRecognitionActionGoal action_goal
ObjectRecognitionActionResult action_result
ObjectRecognitionActionFeedback action_feedback

================================================================================
MSG: object_recognition_msgs/ObjectRecognitionActionGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalID goal_id
ObjectRecognitionGoal goal

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: object_recognition_msgs/ObjectRecognitionGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Optional ROI to use for the object detection
bool use_roi
float32[] filter_limits

================================================================================
MSG: object_recognition_msgs/ObjectRecognitionActionResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
ObjectRecognitionResult result

================================================================================
MSG: actionlib_msgs/GoalStatus
GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: object_recognition_msgs/ObjectRecognitionResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Send the found objects, see the msg files for docs
object_recognition_msgs/RecognizedObjectArray recognized_objects

================================================================================
MSG: object_recognition_msgs/RecognizedObjectArray
##################################################### HEADER ###########################################################
Header header

# This message type describes a potential scene configuration: a set of objects that can explain the scene
object_recognition_msgs/RecognizedObject[] objects

##################################################### SEARCH ###########################################################

# The co-occurrence matrix between the recognized objects
float32[] cooccurrence

================================================================================
MSG: object_recognition_msgs/RecognizedObject
##################################################### HEADER ###########################################################

# The header frame corresponds to the pose frame, NOT the point_cloud frame.
Header header

################################################## OBJECT INFO #########################################################

# Contains information about the type and the position of a found object
# Some of those fields might not be filled because the used techniques do not fill them or because the user does not
# request them

# The type of the found object
object_recognition_msgs/ObjectType type

#confidence: how sure you are it is that object and not another one.
# It is between 0 and 1 and the closer to one it is the better
float32 confidence

################################################ OBJECT CLUSTERS #######################################################

# Sometimes you can extract the 3d points that belong to the object, in the frames of the original sensors
# (it is an array as you might have several sensors)
sensor_msgs/PointCloud2[] point_clouds

# Sometimes, you can only provide a bounding box/shape, even in 3d
# This is in the pose frame
shape_msgs/Mesh bounding_mesh

# Sometimes, you only have 2d input so you can't really give a pose, you just get a contour, or a box
# The last point will be linked to the first one automatically
geometry_msgs/Point[] bounding_contours

#################################################### POSE INFO #########################################################

# This is the result that everybody expects : the pose in some frame given with the input. The units are radian/meters
# as usual
geometry_msgs/PoseWithCovarianceStamped pose

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the \"fields\" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/PoseWithCovarianceStamped
# This expresses an estimated pose with a reference coordinate frame and timestamp

Header header
PoseWithCovariance pose

================================================================================
MSG: geometry_msgs/PoseWithCovariance
# This represents a pose in free space with uncertainty.

Pose pose

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: object_recognition_msgs/ObjectRecognitionActionFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
ObjectRecognitionFeedback feedback

================================================================================
MSG: object_recognition_msgs/ObjectRecognitionFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
#no feedback


"
  end
  attr_accessor :action_goal, :action_result, :action_feedback

  @@struct_LCL = ::ROS::Struct.new("LCL")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_f = ::ROS::Struct.new("f")
  @@struct_d36 = ::ROS::Struct.new("d36")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_CL2 = ::ROS::Struct.new("CL2")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['object_recognition_msgs/ObjectRecognitionActionGoal','object_recognition_msgs/ObjectRecognitionActionResult','object_recognition_msgs/ObjectRecognitionActionFeedback']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [object_recognition_msgs/ObjectRecognitionActionGoal] :action_goal initialize value
  # @option args [object_recognition_msgs/ObjectRecognitionActionResult] :action_result initialize value
  # @option args [object_recognition_msgs/ObjectRecognitionActionFeedback] :action_feedback initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:action_goal]
      @action_goal = args[:action_goal]
    else
      @action_goal = Object_recognition_msgs::ObjectRecognitionActionGoal.new
    end
    if args[:action_result]
      @action_result = args[:action_result]
    else
      @action_result = Object_recognition_msgs::ObjectRecognitionActionResult.new
    end
    if args[:action_feedback]
      @action_feedback = args[:action_feedback]
    else
      @action_feedback = Object_recognition_msgs::ObjectRecognitionActionFeedback.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@action_goal.header.seq, @action_goal.header.stamp.secs, @action_goal.header.stamp.nsecs))
      _x = @action_goal.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_goal.goal_id.stamp.secs, @action_goal.goal_id.stamp.nsecs))
      _x = @action_goal.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_goal.goal.use_roi))
      length = @action_goal.goal.filter_limits.length
      buff.write(@@struct_L.pack(length))
      pattern = "f#{length}"
      buff.write(*@action_goal.goal.filter_limits.pack(pattern))
      buff.write(@@struct_L3.pack(@action_result.header.seq, @action_result.header.stamp.secs, @action_result.header.stamp.nsecs))
      _x = @action_result.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_result.status.goal_id.stamp.secs, @action_result.status.goal_id.stamp.nsecs))
      _x = @action_result.status.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_result.status.status))
      _x = @action_result.status.text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@action_result.result.recognized_objects.header.seq, @action_result.result.recognized_objects.header.stamp.secs, @action_result.result.recognized_objects.header.stamp.nsecs))
      _x = @action_result.result.recognized_objects.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_result.result.recognized_objects.objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.recognized_objects.objects
        _v29 = val1.header
        buff.write(@@struct_L.pack(_v29.seq))
        _v30 = _v29.stamp
        _x = _v30
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v29.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v31 = val1.type
        _x = _v31.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v31.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_f.pack(val1.confidence))
        length = val1.point_clouds.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.point_clouds
          _v32 = val2.header
          buff.write(@@struct_L.pack(_v32.seq))
          _v33 = _v32.stamp
          _x = _v33
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v32.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_L2.pack(_x.height, _x.width))
          length = val2.fields.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.fields
            _x = val3.name
            length = _x.length
            buff.write([length, _x].pack("La#{length}"))
            _x = val3
            buff.write(@@struct_LCL.pack(_x.offset, _x.datatype, _x.count))
          end
          _x = val2
          buff.write(@@struct_CL2.pack(_x.is_bigendian, _x.point_step, _x.row_step))
          _x = val2.data
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          buff.write(@@struct_C.pack(val2.is_dense))
        end
        _v34 = val1.bounding_mesh
        length = _v34.triangles.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v34.triangles
          buff.write(@@struct_L3.pack(*val3.vertex_indices))
        end
        length = _v34.vertices.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v34.vertices
          _x = val3
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        length = val1.bounding_contours.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.bounding_contours
          _x = val2
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        _v35 = val1.pose
        _v36 = _v35.header
        buff.write(@@struct_L.pack(_v36.seq))
        _v37 = _v36.stamp
        _x = _v37
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v36.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v38 = _v35.pose
        _v39 = _v38.pose
        _v40 = _v39.position
        _x = _v40
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v41 = _v39.orientation
        _x = _v41
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_d36.pack(*_v38.covariance))
      end
      length = @action_result.result.recognized_objects.cooccurrence.length
      buff.write(@@struct_L.pack(length))
      pattern = "f#{length}"
      buff.write(*@action_result.result.recognized_objects.cooccurrence.pack(pattern))
      buff.write(@@struct_L3.pack(@action_feedback.header.seq, @action_feedback.header.stamp.secs, @action_feedback.header.stamp.nsecs))
      _x = @action_feedback.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_feedback.status.goal_id.stamp.secs, @action_feedback.status.goal_id.stamp.nsecs))
      _x = @action_feedback.status.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_feedback.status.status))
      _x = @action_feedback.status.text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @action_goal == nil
        @action_goal = Object_recognition_msgs::ObjectRecognitionActionGoal.new
      end
      if @action_result == nil
        @action_result = Object_recognition_msgs::ObjectRecognitionActionResult.new
      end
      if @action_feedback == nil
        @action_feedback = Object_recognition_msgs::ObjectRecognitionActionFeedback.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.header.seq, @action_goal.header.stamp.secs, @action_goal.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_goal.goal_id.stamp.secs, @action_goal.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_goal.goal.use_roi,) = @@struct_C.unpack(str[start..(end_point-1)])
      @action_goal.goal.use_roi = bool(@action_goal.goal.use_roi)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "f#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.filter_limits = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_result.header.seq, @action_result.header.stamp.secs, @action_result.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_result.status.goal_id.stamp.secs, @action_result.status.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.status.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_result.status.status,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.status.text = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_result.result.recognized_objects.header.seq, @action_result.result.recognized_objects.header.stamp.secs, @action_result.result.recognized_objects.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.recognized_objects.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.recognized_objects.objects = []
      length.times do
        val1 = Object_recognition_msgs::RecognizedObject.new
        _v42 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v42.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v43 = _v42.stamp
        _x = _v43
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v42.frame_id = str[start..(end_point-1)]
        _v44 = val1.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v44.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v44.db = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.confidence,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.point_clouds = []
        length.times do
          val2 = Sensor_msgs::PointCloud2.new
          _v45 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v45.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v46 = _v45.stamp
          _x = _v46
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v45.frame_id = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.fields = []
          length.times do
            val3 = Sensor_msgs::PointField.new
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += length
            val3.name = str[start..(end_point-1)]
            _x = val3
            start = end_point
            end_point += ROS::Struct::calc_size('LCL')
            (_x.offset, _x.datatype, _x.count,) = @@struct_LCL.unpack(str[start..(end_point-1)])
            val2.fields.push(val3)
          end
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('CL2')
          (_x.is_bigendian, _x.point_step, _x.row_step,) = @@struct_CL2.unpack(str[start..(end_point-1)])
          val2.is_bigendian = bool(val2.is_bigendian)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.data = str[start..(end_point-1)]
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val2.is_dense,) = @@struct_C.unpack(str[start..(end_point-1)])
          val2.is_dense = bool(val2.is_dense)
          val1.point_clouds.push(val2)
        end
        _v47 = val1.bounding_mesh
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v47.triangles = []
        length.times do
          val3 = Shape_msgs::MeshTriangle.new
          start = end_point
          end_point += ROS::Struct::calc_size('L3')
          val3.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
          _v47.triangles.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v47.vertices = []
        length.times do
          val3 = Geometry_msgs::Point.new
          _x = val3
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v47.vertices.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.bounding_contours = []
        length.times do
          val2 = Geometry_msgs::Point.new
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.bounding_contours.push(val2)
        end
        _v48 = val1.pose
        _v49 = _v48.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v49.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v50 = _v49.stamp
        _x = _v50
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v49.frame_id = str[start..(end_point-1)]
        _v51 = _v48.pose
        _v52 = _v51.pose
        _v53 = _v52.position
        _x = _v53
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v54 = _v52.orientation
        _x = _v54
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d36')
        _v51.covariance = @@struct_d36.unpack(str[start..(end_point-1)])
        @action_result.result.recognized_objects.objects.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "f#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_result.result.recognized_objects.cooccurrence = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_feedback.header.seq, @action_feedback.header.stamp.secs, @action_feedback.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_feedback.status.goal_id.stamp.secs, @action_feedback.status.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.status.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_feedback.status.status,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.status.text = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
