# autogenerated by genrb from ObjectRecognitionActionResult.msg. Do not edit.
require 'ros/message'

require "shape_msgs/MeshTriangle"
require "ros/time"
require "object_recognition_msgs/RecognizedObjectArray"
require "geometry_msgs/PoseWithCovariance"
require "object_recognition_msgs/ObjectType"
require "std_msgs/Header"
require "actionlib_msgs/GoalID"
require "geometry_msgs/Point"
require "sensor_msgs/PointField"
require "shape_msgs/Mesh"
require "object_recognition_msgs/RecognizedObject"
require "object_recognition_msgs/ObjectRecognitionResult"
require "geometry_msgs/Quaternion"
require "sensor_msgs/PointCloud2"
require "actionlib_msgs/GoalStatus"
require "geometry_msgs/PoseWithCovarianceStamped"
require "geometry_msgs/Pose"

module Object_recognition_msgs

class ObjectRecognitionActionResult <::ROS::Message
  def self.md5sum
    "1ef766aeca50bc1bb70773fc73d4471d"
  end

  def self.type
    "object_recognition_msgs/ObjectRecognitionActionResult"
  end

  def has_header?
    true
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
ObjectRecognitionResult result

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalStatus
GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: object_recognition_msgs/ObjectRecognitionResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Send the found objects, see the msg files for docs
object_recognition_msgs/RecognizedObjectArray recognized_objects

================================================================================
MSG: object_recognition_msgs/RecognizedObjectArray
##################################################### HEADER ###########################################################
Header header

# This message type describes a potential scene configuration: a set of objects that can explain the scene
object_recognition_msgs/RecognizedObject[] objects

##################################################### SEARCH ###########################################################

# The co-occurrence matrix between the recognized objects
float32[] cooccurrence

================================================================================
MSG: object_recognition_msgs/RecognizedObject
##################################################### HEADER ###########################################################

# The header frame corresponds to the pose frame, NOT the point_cloud frame.
Header header

################################################## OBJECT INFO #########################################################

# Contains information about the type and the position of a found object
# Some of those fields might not be filled because the used techniques do not fill them or because the user does not
# request them

# The type of the found object
object_recognition_msgs/ObjectType type

#confidence: how sure you are it is that object and not another one.
# It is between 0 and 1 and the closer to one it is the better
float32 confidence

################################################ OBJECT CLUSTERS #######################################################

# Sometimes you can extract the 3d points that belong to the object, in the frames of the original sensors
# (it is an array as you might have several sensors)
sensor_msgs/PointCloud2[] point_clouds

# Sometimes, you can only provide a bounding box/shape, even in 3d
# This is in the pose frame
shape_msgs/Mesh bounding_mesh

# Sometimes, you only have 2d input so you can't really give a pose, you just get a contour, or a box
# The last point will be linked to the first one automatically
geometry_msgs/Point[] bounding_contours

#################################################### POSE INFO #########################################################

# This is the result that everybody expects : the pose in some frame given with the input. The units are radian/meters
# as usual
geometry_msgs/PoseWithCovarianceStamped pose

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the \"fields\" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/PoseWithCovarianceStamped
# This expresses an estimated pose with a reference coordinate frame and timestamp

Header header
PoseWithCovariance pose

================================================================================
MSG: geometry_msgs/PoseWithCovariance
# This represents a pose in free space with uncertainty.

Pose pose

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :header, :status, :result

  @@struct_LCL = ::ROS::Struct.new("LCL")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_f = ::ROS::Struct.new("f")
  @@struct_d36 = ::ROS::Struct.new("d36")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_CL2 = ::ROS::Struct.new("CL2")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','actionlib_msgs/GoalStatus','object_recognition_msgs/ObjectRecognitionResult']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [actionlib_msgs/GoalStatus] :status initialize value
  # @option args [object_recognition_msgs/ObjectRecognitionResult] :result initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:status]
      @status = args[:status]
    else
      @status = Actionlib_msgs::GoalStatus.new
    end
    if args[:result]
      @result = args[:result]
    else
      @result = Object_recognition_msgs::ObjectRecognitionResult.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@status.goal_id.stamp.secs, @status.goal_id.stamp.nsecs))
      _x = @status.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@status.status))
      _x = @status.text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@result.recognized_objects.header.seq, @result.recognized_objects.header.stamp.secs, @result.recognized_objects.header.stamp.nsecs))
      _x = @result.recognized_objects.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @result.recognized_objects.objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @result.recognized_objects.objects
        _v55 = val1.header
        buff.write(@@struct_L.pack(_v55.seq))
        _v56 = _v55.stamp
        _x = _v56
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v55.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v57 = val1.type
        _x = _v57.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v57.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_f.pack(val1.confidence))
        length = val1.point_clouds.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.point_clouds
          _v58 = val2.header
          buff.write(@@struct_L.pack(_v58.seq))
          _v59 = _v58.stamp
          _x = _v59
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v58.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_L2.pack(_x.height, _x.width))
          length = val2.fields.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.fields
            _x = val3.name
            length = _x.length
            buff.write([length, _x].pack("La#{length}"))
            _x = val3
            buff.write(@@struct_LCL.pack(_x.offset, _x.datatype, _x.count))
          end
          _x = val2
          buff.write(@@struct_CL2.pack(_x.is_bigendian, _x.point_step, _x.row_step))
          _x = val2.data
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          buff.write(@@struct_C.pack(val2.is_dense))
        end
        _v60 = val1.bounding_mesh
        length = _v60.triangles.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v60.triangles
          buff.write(@@struct_L3.pack(*val3.vertex_indices))
        end
        length = _v60.vertices.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v60.vertices
          _x = val3
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        length = val1.bounding_contours.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.bounding_contours
          _x = val2
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        _v61 = val1.pose
        _v62 = _v61.header
        buff.write(@@struct_L.pack(_v62.seq))
        _v63 = _v62.stamp
        _x = _v63
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v62.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v64 = _v61.pose
        _v65 = _v64.pose
        _v66 = _v65.position
        _x = _v66
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v67 = _v65.orientation
        _x = _v67
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_d36.pack(*_v64.covariance))
      end
      length = @result.recognized_objects.cooccurrence.length
      buff.write(@@struct_L.pack(length))
      pattern = "f#{length}"
      buff.write(*@result.recognized_objects.cooccurrence.pack(pattern))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @status == nil
        @status = Actionlib_msgs::GoalStatus.new
      end
      if @result == nil
        @result = Object_recognition_msgs::ObjectRecognitionResult.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@status.goal_id.stamp.secs, @status.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @status.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@status.status,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @status.text = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@result.recognized_objects.header.seq, @result.recognized_objects.header.stamp.secs, @result.recognized_objects.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @result.recognized_objects.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @result.recognized_objects.objects = []
      length.times do
        val1 = Object_recognition_msgs::RecognizedObject.new
        _v68 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v68.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v69 = _v68.stamp
        _x = _v69
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v68.frame_id = str[start..(end_point-1)]
        _v70 = val1.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v70.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v70.db = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('f')
        (val1.confidence,) = @@struct_f.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.point_clouds = []
        length.times do
          val2 = Sensor_msgs::PointCloud2.new
          _v71 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v71.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v72 = _v71.stamp
          _x = _v72
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v71.frame_id = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.height, _x.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.fields = []
          length.times do
            val3 = Sensor_msgs::PointField.new
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += length
            val3.name = str[start..(end_point-1)]
            _x = val3
            start = end_point
            end_point += ROS::Struct::calc_size('LCL')
            (_x.offset, _x.datatype, _x.count,) = @@struct_LCL.unpack(str[start..(end_point-1)])
            val2.fields.push(val3)
          end
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('CL2')
          (_x.is_bigendian, _x.point_step, _x.row_step,) = @@struct_CL2.unpack(str[start..(end_point-1)])
          val2.is_bigendian = bool(val2.is_bigendian)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.data = str[start..(end_point-1)]
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val2.is_dense,) = @@struct_C.unpack(str[start..(end_point-1)])
          val2.is_dense = bool(val2.is_dense)
          val1.point_clouds.push(val2)
        end
        _v73 = val1.bounding_mesh
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v73.triangles = []
        length.times do
          val3 = Shape_msgs::MeshTriangle.new
          start = end_point
          end_point += ROS::Struct::calc_size('L3')
          val3.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
          _v73.triangles.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v73.vertices = []
        length.times do
          val3 = Geometry_msgs::Point.new
          _x = val3
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v73.vertices.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.bounding_contours = []
        length.times do
          val2 = Geometry_msgs::Point.new
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.bounding_contours.push(val2)
        end
        _v74 = val1.pose
        _v75 = _v74.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v75.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v76 = _v75.stamp
        _x = _v76
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v75.frame_id = str[start..(end_point-1)]
        _v77 = _v74.pose
        _v78 = _v77.pose
        _v79 = _v78.position
        _x = _v79
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v80 = _v78.orientation
        _x = _v80
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d36')
        _v77.covariance = @@struct_d36.unpack(str[start..(end_point-1)])
        @result.recognized_objects.objects.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "f#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @result.recognized_objects.cooccurrence = str[start..(end_point-1)].unpack(pattern)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
