# autogenerated by genrb from Octomap.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"

module Octomap_msgs

class Octomap <::ROS::Message
  def self.md5sum
    "9a45536b45c5e409cd49f04bb2d9999f"
  end

  def self.type
    "octomap_msgs/Octomap"
  end

  def has_header?
    true
  end

  def message_definition
    "# A 3D map in binary format, as Octree
Header header

# Flag to denote a binary (only free/occupied) or full occupancy octree (.bt/.ot file)
bool binary

# Class id of the contained octree 
string id

# Resolution (in m) of the smallest octree nodes
float64 resolution

# binary serialization of octree, use conversions.h to read and write octrees
int8[] data

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  attr_accessor :header, :binary, :id, :resolution, :data

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_d = ::ROS::Struct.new("d")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','bool','string','float64','int8[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [bool] :binary initialize value
  # @option args [string] :id initialize value
  # @option args [float64] :resolution initialize value
  # @option args [int8[]] :data initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:binary]
      @binary = args[:binary]
    else
      @binary = false
    end
    if args[:id]
      @id = args[:id]
    else
      @id = ''
    end
    if args[:resolution]
      @resolution = args[:resolution]
    else
      @resolution = 0.0
    end
    if args[:data]
      @data = args[:data]
    else
      @data = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@binary))
      _x = @id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d.pack(@resolution))
      length = @data.length
      buff.write(@@struct_L.pack(length))
      pattern = "c#{length}"
      buff.write(*@data.pack(pattern))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@binary,) = @@struct_C.unpack(str[start..(end_point-1)])
      @binary = bool(@binary)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d')
      (@resolution,) = @@struct_d.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "c#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @data = str[start..(end_point-1)].unpack(pattern)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
