# autogenerated by genrb from PolygonMesh.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "sensor_msgs/PointCloud2"
require "pcl_msgs/Vertices"
require "sensor_msgs/PointField"

module Pcl_msgs

class PolygonMesh <::ROS::Message
  def self.md5sum
    "45a5fc6ad2cde8489600a790acc9a38a"
  end

  def self.type
    "pcl_msgs/PolygonMesh"
  end

  def has_header?
    true
  end

  def message_definition
    "# Separate header for the polygonal surface
Header header
# Vertices of the mesh as a point cloud
sensor_msgs/PointCloud2 cloud
# List of polygons
Vertices[] polygons

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/PointCloud2
# This message holds a collection of N-dimensional points, which may
# contain additional information such as normals, intensity, etc. The
# point data is stored as a binary blob, its layout described by the
# contents of the \"fields\" array.

# The point cloud data may be organized 2d (image-like) or 1d
# (unordered). Point clouds organized as 2d images may be produced by
# camera depth sensors such as stereo or time-of-flight.

# Time of sensor data acquisition, and the coordinate frame ID (for 3d
# points).
Header header

# 2D structure of the point cloud. If the cloud is unordered, height is
# 1 and width is the length of the point cloud.
uint32 height
uint32 width

# Describes the channels and their layout in the binary data blob.
PointField[] fields

bool    is_bigendian # Is this data bigendian?
uint32  point_step   # Length of a point in bytes
uint32  row_step     # Length of a row in bytes
uint8[] data         # Actual point data, size is (row_step*height)

bool is_dense        # True if there are no invalid points

================================================================================
MSG: sensor_msgs/PointField
# This message holds the description of one point entry in the
# PointCloud2 message format.
uint8 INT8    = 1
uint8 UINT8   = 2
uint8 INT16   = 3
uint8 UINT16  = 4
uint8 INT32   = 5
uint8 UINT32  = 6
uint8 FLOAT32 = 7
uint8 FLOAT64 = 8

string name      # Name of field
uint32 offset    # Offset from start of point struct
uint8  datatype  # Datatype enumeration, see above
uint32 count     # How many elements in the field

================================================================================
MSG: pcl_msgs/Vertices
# List of point indices
uint32[] vertices

"
  end
  attr_accessor :header, :cloud, :polygons

  @@struct_LCL = ::ROS::Struct.new("LCL")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_CL2 = ::ROS::Struct.new("CL2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','sensor_msgs/PointCloud2','pcl_msgs/Vertices[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [sensor_msgs/PointCloud2] :cloud initialize value
  # @option args [pcl_msgs/Vertices[]] :polygons initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:cloud]
      @cloud = args[:cloud]
    else
      @cloud = Sensor_msgs::PointCloud2.new
    end
    if args[:polygons]
      @polygons = args[:polygons]
    else
      @polygons = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@cloud.header.seq, @cloud.header.stamp.secs, @cloud.header.stamp.nsecs))
      _x = @cloud.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@cloud.height, @cloud.width))
      length = @cloud.fields.length
      buff.write(@@struct_L.pack(length))
      for val1 in @cloud.fields
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_LCL.pack(_x.offset, _x.datatype, _x.count))
      end
      buff.write(@@struct_CL2.pack(@cloud.is_bigendian, @cloud.point_step, @cloud.row_step))
      _x = @cloud.data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@cloud.is_dense))
      length = @polygons.length
      buff.write(@@struct_L.pack(length))
      for val1 in @polygons
        length = val1.vertices.length
        buff.write(@@struct_L.pack(length))
        pattern = "L#{length}"
        buff.write(*val1.vertices.pack(pattern))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @cloud == nil
        @cloud = Sensor_msgs::PointCloud2.new
      end
      if @polygons == nil
        @polygons = Pcl_msgs::Vertices[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@cloud.header.seq, @cloud.header.stamp.secs, @cloud.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @cloud.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@cloud.height, @cloud.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @cloud.fields = []
      length.times do
        val1 = Sensor_msgs::PointField.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('LCL')
        (_x.offset, _x.datatype, _x.count,) = @@struct_LCL.unpack(str[start..(end_point-1)])
        @cloud.fields.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('CL2')
      (@cloud.is_bigendian, @cloud.point_step, @cloud.row_step,) = @@struct_CL2.unpack(str[start..(end_point-1)])
      @cloud.is_bigendian = bool(@cloud.is_bigendian)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @cloud.data = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@cloud.is_dense,) = @@struct_C.unpack(str[start..(end_point-1)])
      @cloud.is_dense = bool(@cloud.is_dense)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @polygons = []
      length.times do
        val1 = Pcl_msgs::Vertices.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "L#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.vertices = str[start..(end_point-1)].unpack(pattern)
        @polygons.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
