# autogenerated by genrb from PointHeadGoal.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Point"
require "geometry_msgs/PointStamped"
require "ros/duration"
require "geometry_msgs/Vector3"

module Pr2_controllers_msgs

class PointHeadGoal <::ROS::Message
  def self.md5sum
    "8b92b1cd5e06c8a94c917dc3209a4c1d"
  end

  def self.type
    "pr2_controllers_msgs/PointHeadGoal"
  end

  def has_header?
    false
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
geometry_msgs/PointStamped target
geometry_msgs/Vector3 pointing_axis
string pointing_frame
duration min_duration
float64 max_velocity

================================================================================
MSG: geometry_msgs/PointStamped
# This represents a Point with reference coordinate frame and timestamp
Header header
Point point

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :target, :pointing_axis, :pointing_frame, :min_duration, :max_velocity

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d6 = ::ROS::Struct.new("d6")
  @@struct_l2d = ::ROS::Struct.new("l2d")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['geometry_msgs/PointStamped','geometry_msgs/Vector3','string','duration','float64']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [geometry_msgs/PointStamped] :target initialize value
  # @option args [geometry_msgs/Vector3] :pointing_axis initialize value
  # @option args [string] :pointing_frame initialize value
  # @option args [duration] :min_duration initialize value
  # @option args [float64] :max_velocity initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:target]
      @target = args[:target]
    else
      @target = Geometry_msgs::PointStamped.new
    end
    if args[:pointing_axis]
      @pointing_axis = args[:pointing_axis]
    else
      @pointing_axis = Geometry_msgs::Vector3.new
    end
    if args[:pointing_frame]
      @pointing_frame = args[:pointing_frame]
    else
      @pointing_frame = ''
    end
    if args[:min_duration]
      @min_duration = args[:min_duration]
    else
      @min_duration = ROS::Duration.new
    end
    if args[:max_velocity]
      @max_velocity = args[:max_velocity]
    else
      @max_velocity = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@target.header.seq, @target.header.stamp.secs, @target.header.stamp.nsecs))
      _x = @target.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d6.pack(@target.point.x, @target.point.y, @target.point.z, @pointing_axis.x, @pointing_axis.y, @pointing_axis.z))
      _x = @pointing_frame
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_l2d.pack(@min_duration.secs, @min_duration.nsecs, @max_velocity))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @target == nil
        @target = Geometry_msgs::PointStamped.new
      end
      if @pointing_axis == nil
        @pointing_axis = Geometry_msgs::Vector3.new
      end
      if @min_duration == nil
        @min_duration = ROS::Duration.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@target.header.seq, @target.header.stamp.secs, @target.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @target.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d6')
      (@target.point.x, @target.point.y, @target.point.z, @pointing_axis.x, @pointing_axis.y, @pointing_axis.z,) = @@struct_d6.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @pointing_frame = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('l2d')
      (@min_duration.secs, @min_duration.nsecs, @max_velocity,) = @@struct_l2d.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
