# autogenerated by genrb from ActuatorStatistics.msg. Do not edit.
require 'ros/message'

require "ros/time"

module Pr2_mechanism_msgs

class ActuatorStatistics <::ROS::Message
  def self.md5sum
    "c37184273b29627de29382f1d3670175"
  end

  def self.type
    "pr2_mechanism_msgs/ActuatorStatistics"
  end

  def has_header?
    false
  end

  def message_definition
    "# This message contains the state of an actuator on the pr2 robot.
# An actuator contains a motor and an encoder, and is connected
# to a joint by a transmission

# the name of the actuator
string name

# the sequence number of the MCB in the ethercat chain. 
# the first device in the chain gets deviced_id zero
int32 device_id

# the time at which this actuator state was measured
time timestamp

# the encoder position, represented by the number of encoder ticks
int32 encoder_count

# The angular offset (in radians) that is added to the encoder reading, 
# to get to the position of the actuator. This number is computed when the referece
# sensor is triggered during the calibration phase
float64 encoder_offset

# the encoder position in radians
float64 position

# the encoder velocity in encoder ticks per second
float64 encoder_velocity

# the encoder velocity in radians per second
float64 velocity

# the value of the calibration reading: low (false) or high (true)
bool calibration_reading

# bool to indicate if the joint already triggered the rising/falling edge of the reference sensor
bool calibration_rising_edge_valid
bool calibration_falling_edge_valid

# the encoder position when the last rising/falling edge was observed. 
# only read this value when the calibration_rising/falling_edge_valid is true
float64 last_calibration_rising_edge
float64 last_calibration_falling_edge

# flag to indicate if this actuator is enabled or not. 
# An actuator can only be commanded when it is enabled.
bool is_enabled

# indicates if the motor is halted. A motor can be halted because of a voltage or communication problem
bool halted

# the last current/effort command that was requested
float64 last_commanded_current
float64 last_commanded_effort

# the last current/effort command that was executed by the actuator
float64 last_executed_current
float64 last_executed_effort

# the last current/effort that was measured by the actuator
float64 last_measured_current
float64 last_measured_effort

# the motor voltate
float64 motor_voltage

# the number of detected encoder problems 
int32 num_encoder_errors


"
  end
  attr_accessor :name, :device_id, :timestamp, :encoder_count, :encoder_offset, :position, :encoder_velocity, :velocity, :calibration_reading, :calibration_rising_edge_valid, :calibration_falling_edge_valid, :last_calibration_rising_edge, :last_calibration_falling_edge, :is_enabled, :halted, :last_commanded_current, :last_commanded_effort, :last_executed_current, :last_executed_effort, :last_measured_current, :last_measured_effort, :motor_voltage, :num_encoder_errors

  @@struct_lL2ld4C3d2C2d7l = ::ROS::Struct.new("lL2ld4C3d2C2d7l")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','int32','time','int32','float64','float64','float64','float64','bool','bool','bool','float64','float64','bool','bool','float64','float64','float64','float64','float64','float64','float64','int32']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :name initialize value
  # @option args [int32] :device_id initialize value
  # @option args [time] :timestamp initialize value
  # @option args [int32] :encoder_count initialize value
  # @option args [float64] :encoder_offset initialize value
  # @option args [float64] :position initialize value
  # @option args [float64] :encoder_velocity initialize value
  # @option args [float64] :velocity initialize value
  # @option args [bool] :calibration_reading initialize value
  # @option args [bool] :calibration_rising_edge_valid initialize value
  # @option args [bool] :calibration_falling_edge_valid initialize value
  # @option args [float64] :last_calibration_rising_edge initialize value
  # @option args [float64] :last_calibration_falling_edge initialize value
  # @option args [bool] :is_enabled initialize value
  # @option args [bool] :halted initialize value
  # @option args [float64] :last_commanded_current initialize value
  # @option args [float64] :last_commanded_effort initialize value
  # @option args [float64] :last_executed_current initialize value
  # @option args [float64] :last_executed_effort initialize value
  # @option args [float64] :last_measured_current initialize value
  # @option args [float64] :last_measured_effort initialize value
  # @option args [float64] :motor_voltage initialize value
  # @option args [int32] :num_encoder_errors initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
    if args[:device_id]
      @device_id = args[:device_id]
    else
      @device_id = 0
    end
    if args[:timestamp]
      @timestamp = args[:timestamp]
    else
      @timestamp = ROS::Time.new
    end
    if args[:encoder_count]
      @encoder_count = args[:encoder_count]
    else
      @encoder_count = 0
    end
    if args[:encoder_offset]
      @encoder_offset = args[:encoder_offset]
    else
      @encoder_offset = 0.0
    end
    if args[:position]
      @position = args[:position]
    else
      @position = 0.0
    end
    if args[:encoder_velocity]
      @encoder_velocity = args[:encoder_velocity]
    else
      @encoder_velocity = 0.0
    end
    if args[:velocity]
      @velocity = args[:velocity]
    else
      @velocity = 0.0
    end
    if args[:calibration_reading]
      @calibration_reading = args[:calibration_reading]
    else
      @calibration_reading = false
    end
    if args[:calibration_rising_edge_valid]
      @calibration_rising_edge_valid = args[:calibration_rising_edge_valid]
    else
      @calibration_rising_edge_valid = false
    end
    if args[:calibration_falling_edge_valid]
      @calibration_falling_edge_valid = args[:calibration_falling_edge_valid]
    else
      @calibration_falling_edge_valid = false
    end
    if args[:last_calibration_rising_edge]
      @last_calibration_rising_edge = args[:last_calibration_rising_edge]
    else
      @last_calibration_rising_edge = 0.0
    end
    if args[:last_calibration_falling_edge]
      @last_calibration_falling_edge = args[:last_calibration_falling_edge]
    else
      @last_calibration_falling_edge = 0.0
    end
    if args[:is_enabled]
      @is_enabled = args[:is_enabled]
    else
      @is_enabled = false
    end
    if args[:halted]
      @halted = args[:halted]
    else
      @halted = false
    end
    if args[:last_commanded_current]
      @last_commanded_current = args[:last_commanded_current]
    else
      @last_commanded_current = 0.0
    end
    if args[:last_commanded_effort]
      @last_commanded_effort = args[:last_commanded_effort]
    else
      @last_commanded_effort = 0.0
    end
    if args[:last_executed_current]
      @last_executed_current = args[:last_executed_current]
    else
      @last_executed_current = 0.0
    end
    if args[:last_executed_effort]
      @last_executed_effort = args[:last_executed_effort]
    else
      @last_executed_effort = 0.0
    end
    if args[:last_measured_current]
      @last_measured_current = args[:last_measured_current]
    else
      @last_measured_current = 0.0
    end
    if args[:last_measured_effort]
      @last_measured_effort = args[:last_measured_effort]
    else
      @last_measured_effort = 0.0
    end
    if args[:motor_voltage]
      @motor_voltage = args[:motor_voltage]
    else
      @motor_voltage = 0.0
    end
    if args[:num_encoder_errors]
      @num_encoder_errors = args[:num_encoder_errors]
    else
      @num_encoder_errors = 0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_lL2ld4C3d2C2d7l.pack(@device_id, @timestamp.secs, @timestamp.nsecs, @encoder_count, @encoder_offset, @position, @encoder_velocity, @velocity, @calibration_reading, @calibration_rising_edge_valid, @calibration_falling_edge_valid, @last_calibration_rising_edge, @last_calibration_falling_edge, @is_enabled, @halted, @last_commanded_current, @last_commanded_effort, @last_executed_current, @last_executed_effort, @last_measured_current, @last_measured_effort, @motor_voltage, @num_encoder_errors))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @timestamp == nil
        @timestamp = ROS::Time.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('lL2ld4C3d2C2d7l')
      (@device_id, @timestamp.secs, @timestamp.nsecs, @encoder_count, @encoder_offset, @position, @encoder_velocity, @velocity, @calibration_reading, @calibration_rising_edge_valid, @calibration_falling_edge_valid, @last_calibration_rising_edge, @last_calibration_falling_edge, @is_enabled, @halted, @last_commanded_current, @last_commanded_effort, @last_executed_current, @last_executed_effort, @last_measured_current, @last_measured_effort, @motor_voltage, @num_encoder_errors,) = @@struct_lL2ld4C3d2C2d7l.unpack(str[start..(end_point-1)])
      @calibration_reading = bool(@calibration_reading)
      @calibration_rising_edge_valid = bool(@calibration_rising_edge_valid)
      @calibration_falling_edge_valid = bool(@calibration_falling_edge_valid)
      @is_enabled = bool(@is_enabled)
      @halted = bool(@halted)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
