# autogenerated by genrb from ControllerStatistics.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "ros/duration"

module Pr2_mechanism_msgs

class ControllerStatistics <::ROS::Message
  def self.md5sum
    "6d15d137eea402018e3c7c8dbecd4b95"
  end

  def self.type
    "pr2_mechanism_msgs/ControllerStatistics"
  end

  def has_header?
    false
  end

  def message_definition
    "# This message contains the state of one realtime controller
# that was spawned in pr2_mechanism_control

# the name of the controller
string name

# the time at which these controller statistics were measured
time timestamp

# bool that indicates if the controller is currently
# in a running or a stopped state
bool running

# the maximum time the update loop of the controller ever needed to complete
duration max_time

# the average time the update loop of the controller needs to complete. 
# the average is computed in a sliding time window.
duration mean_time

# the variance on the time the update loop of the controller needs to complete.
# the variance applies to a sliding time window.
duration variance_time

# the number of times this controller broke the realtime loop
int32 num_control_loop_overruns

# the timestamp of the last time this controller broke the realtime loop
time time_last_control_loop_overrun
"
  end
  attr_accessor :name, :timestamp, :running, :max_time, :mean_time, :variance_time, :num_control_loop_overruns, :time_last_control_loop_overrun

  @@struct_L2Cl7L2 = ::ROS::Struct.new("L2Cl7L2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','time','bool','duration','duration','duration','int32','time']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :name initialize value
  # @option args [time] :timestamp initialize value
  # @option args [bool] :running initialize value
  # @option args [duration] :max_time initialize value
  # @option args [duration] :mean_time initialize value
  # @option args [duration] :variance_time initialize value
  # @option args [int32] :num_control_loop_overruns initialize value
  # @option args [time] :time_last_control_loop_overrun initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
    if args[:timestamp]
      @timestamp = args[:timestamp]
    else
      @timestamp = ROS::Time.new
    end
    if args[:running]
      @running = args[:running]
    else
      @running = false
    end
    if args[:max_time]
      @max_time = args[:max_time]
    else
      @max_time = ROS::Duration.new
    end
    if args[:mean_time]
      @mean_time = args[:mean_time]
    else
      @mean_time = ROS::Duration.new
    end
    if args[:variance_time]
      @variance_time = args[:variance_time]
    else
      @variance_time = ROS::Duration.new
    end
    if args[:num_control_loop_overruns]
      @num_control_loop_overruns = args[:num_control_loop_overruns]
    else
      @num_control_loop_overruns = 0
    end
    if args[:time_last_control_loop_overrun]
      @time_last_control_loop_overrun = args[:time_last_control_loop_overrun]
    else
      @time_last_control_loop_overrun = ROS::Time.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2Cl7L2.pack(@timestamp.secs, @timestamp.nsecs, @running, @max_time.secs, @max_time.nsecs, @mean_time.secs, @mean_time.nsecs, @variance_time.secs, @variance_time.nsecs, @num_control_loop_overruns, @time_last_control_loop_overrun.secs, @time_last_control_loop_overrun.nsecs))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @timestamp == nil
        @timestamp = ROS::Time.new
      end
      if @max_time == nil
        @max_time = ROS::Duration.new
      end
      if @mean_time == nil
        @mean_time = ROS::Duration.new
      end
      if @variance_time == nil
        @variance_time = ROS::Duration.new
      end
      if @time_last_control_loop_overrun == nil
        @time_last_control_loop_overrun = ROS::Time.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2Cl7L2')
      (@timestamp.secs, @timestamp.nsecs, @running, @max_time.secs, @max_time.nsecs, @mean_time.secs, @mean_time.nsecs, @variance_time.secs, @variance_time.nsecs, @num_control_loop_overruns, @time_last_control_loop_overrun.secs, @time_last_control_loop_overrun.nsecs,) = @@struct_L2Cl7L2.unpack(str[start..(end_point-1)])
      @running = bool(@running)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
