# autogenerated by genrb from JointStatistics.msg. Do not edit.
require 'ros/message'

require "ros/time"

module Pr2_mechanism_msgs

class JointStatistics <::ROS::Message
  def self.md5sum
    "90fdc8acbce5bc783d8b4aec49af6590"
  end

  def self.type
    "pr2_mechanism_msgs/JointStatistics"
  end

  def has_header?
    false
  end

  def message_definition
    "# This message contains the state of one joint of the pr2 robot.
# This message is specificly designed for the pr2 robot. 
# A generic joint state message can be found in sensor_msgs::JointState

# the name of the joint
string name

# the time at which these joint statistics were measured
time timestamp

# the position of the joint in radians
float64 position

# the velocity of the joint in radians per second
float64 velocity

# the measured joint effort 
float64 measured_effort

# the effort that was commanded to the joint.
# the actual applied effort might be different
# because the safety code can limit the effort
# a joint can apply
float64 commanded_effort

# a flag indicating if the joint is calibrated or not
bool is_calibrated

# a flag inidcating if the joint violated one of its position/velocity/effort limits
# in the last publish cycle
bool violated_limits

# the total distance travelled by the joint, measured in radians.
float64 odometer

# the lowest position reached by the joint in the last publish cycle
float64 min_position

# the highest position reached by the joint in the last publish cycle
float64 max_position

# the maximum absolute velocity reached by the joint in the last publish cycle
float64 max_abs_velocity

# the maximum absolute effort applied by the joint in the last publish cycle
float64 max_abs_effort

"
  end
  attr_accessor :name, :timestamp, :position, :velocity, :measured_effort, :commanded_effort, :is_calibrated, :violated_limits, :odometer, :min_position, :max_position, :max_abs_velocity, :max_abs_effort

  @@struct_L2d4C2d5 = ::ROS::Struct.new("L2d4C2d5")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','time','float64','float64','float64','float64','bool','bool','float64','float64','float64','float64','float64']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :name initialize value
  # @option args [time] :timestamp initialize value
  # @option args [float64] :position initialize value
  # @option args [float64] :velocity initialize value
  # @option args [float64] :measured_effort initialize value
  # @option args [float64] :commanded_effort initialize value
  # @option args [bool] :is_calibrated initialize value
  # @option args [bool] :violated_limits initialize value
  # @option args [float64] :odometer initialize value
  # @option args [float64] :min_position initialize value
  # @option args [float64] :max_position initialize value
  # @option args [float64] :max_abs_velocity initialize value
  # @option args [float64] :max_abs_effort initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
    if args[:timestamp]
      @timestamp = args[:timestamp]
    else
      @timestamp = ROS::Time.new
    end
    if args[:position]
      @position = args[:position]
    else
      @position = 0.0
    end
    if args[:velocity]
      @velocity = args[:velocity]
    else
      @velocity = 0.0
    end
    if args[:measured_effort]
      @measured_effort = args[:measured_effort]
    else
      @measured_effort = 0.0
    end
    if args[:commanded_effort]
      @commanded_effort = args[:commanded_effort]
    else
      @commanded_effort = 0.0
    end
    if args[:is_calibrated]
      @is_calibrated = args[:is_calibrated]
    else
      @is_calibrated = false
    end
    if args[:violated_limits]
      @violated_limits = args[:violated_limits]
    else
      @violated_limits = false
    end
    if args[:odometer]
      @odometer = args[:odometer]
    else
      @odometer = 0.0
    end
    if args[:min_position]
      @min_position = args[:min_position]
    else
      @min_position = 0.0
    end
    if args[:max_position]
      @max_position = args[:max_position]
    else
      @max_position = 0.0
    end
    if args[:max_abs_velocity]
      @max_abs_velocity = args[:max_abs_velocity]
    else
      @max_abs_velocity = 0.0
    end
    if args[:max_abs_effort]
      @max_abs_effort = args[:max_abs_effort]
    else
      @max_abs_effort = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2d4C2d5.pack(@timestamp.secs, @timestamp.nsecs, @position, @velocity, @measured_effort, @commanded_effort, @is_calibrated, @violated_limits, @odometer, @min_position, @max_position, @max_abs_velocity, @max_abs_effort))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @timestamp == nil
        @timestamp = ROS::Time.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2d4C2d5')
      (@timestamp.secs, @timestamp.nsecs, @position, @velocity, @measured_effort, @commanded_effort, @is_calibrated, @violated_limits, @odometer, @min_position, @max_position, @max_abs_velocity, @max_abs_effort,) = @@struct_L2d4C2d5.unpack(str[start..(end_point-1)])
      @is_calibrated = bool(@is_calibrated)
      @violated_limits = bool(@violated_limits)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
