# autogenerated by genrb from MechanismStatistics.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "ros/duration"
require "pr2_mechanism_msgs/ActuatorStatistics"
require "std_msgs/Header"
require "pr2_mechanism_msgs/JointStatistics"
require "pr2_mechanism_msgs/ControllerStatistics"

module Pr2_mechanism_msgs

class MechanismStatistics <::ROS::Message
  def self.md5sum
    "b4a99069393681672c01f8c823458e04"
  end

  def self.type
    "pr2_mechanism_msgs/MechanismStatistics"
  end

  def has_header?
    true
  end

  def message_definition
    "# This message describes the state of the pr2 mechanism. It contains the state of
# each actuator, each joint, and each controller that is spawned in pr2_mechanism_control.

Header header
ActuatorStatistics[] actuator_statistics
JointStatistics[] joint_statistics
ControllerStatistics[] controller_statistics

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: pr2_mechanism_msgs/ActuatorStatistics
# This message contains the state of an actuator on the pr2 robot.
# An actuator contains a motor and an encoder, and is connected
# to a joint by a transmission

# the name of the actuator
string name

# the sequence number of the MCB in the ethercat chain. 
# the first device in the chain gets deviced_id zero
int32 device_id

# the time at which this actuator state was measured
time timestamp

# the encoder position, represented by the number of encoder ticks
int32 encoder_count

# The angular offset (in radians) that is added to the encoder reading, 
# to get to the position of the actuator. This number is computed when the referece
# sensor is triggered during the calibration phase
float64 encoder_offset

# the encoder position in radians
float64 position

# the encoder velocity in encoder ticks per second
float64 encoder_velocity

# the encoder velocity in radians per second
float64 velocity

# the value of the calibration reading: low (false) or high (true)
bool calibration_reading

# bool to indicate if the joint already triggered the rising/falling edge of the reference sensor
bool calibration_rising_edge_valid
bool calibration_falling_edge_valid

# the encoder position when the last rising/falling edge was observed. 
# only read this value when the calibration_rising/falling_edge_valid is true
float64 last_calibration_rising_edge
float64 last_calibration_falling_edge

# flag to indicate if this actuator is enabled or not. 
# An actuator can only be commanded when it is enabled.
bool is_enabled

# indicates if the motor is halted. A motor can be halted because of a voltage or communication problem
bool halted

# the last current/effort command that was requested
float64 last_commanded_current
float64 last_commanded_effort

# the last current/effort command that was executed by the actuator
float64 last_executed_current
float64 last_executed_effort

# the last current/effort that was measured by the actuator
float64 last_measured_current
float64 last_measured_effort

# the motor voltate
float64 motor_voltage

# the number of detected encoder problems 
int32 num_encoder_errors


================================================================================
MSG: pr2_mechanism_msgs/JointStatistics
# This message contains the state of one joint of the pr2 robot.
# This message is specificly designed for the pr2 robot. 
# A generic joint state message can be found in sensor_msgs::JointState

# the name of the joint
string name

# the time at which these joint statistics were measured
time timestamp

# the position of the joint in radians
float64 position

# the velocity of the joint in radians per second
float64 velocity

# the measured joint effort 
float64 measured_effort

# the effort that was commanded to the joint.
# the actual applied effort might be different
# because the safety code can limit the effort
# a joint can apply
float64 commanded_effort

# a flag indicating if the joint is calibrated or not
bool is_calibrated

# a flag inidcating if the joint violated one of its position/velocity/effort limits
# in the last publish cycle
bool violated_limits

# the total distance travelled by the joint, measured in radians.
float64 odometer

# the lowest position reached by the joint in the last publish cycle
float64 min_position

# the highest position reached by the joint in the last publish cycle
float64 max_position

# the maximum absolute velocity reached by the joint in the last publish cycle
float64 max_abs_velocity

# the maximum absolute effort applied by the joint in the last publish cycle
float64 max_abs_effort

================================================================================
MSG: pr2_mechanism_msgs/ControllerStatistics
# This message contains the state of one realtime controller
# that was spawned in pr2_mechanism_control

# the name of the controller
string name

# the time at which these controller statistics were measured
time timestamp

# bool that indicates if the controller is currently
# in a running or a stopped state
bool running

# the maximum time the update loop of the controller ever needed to complete
duration max_time

# the average time the update loop of the controller needs to complete. 
# the average is computed in a sliding time window.
duration mean_time

# the variance on the time the update loop of the controller needs to complete.
# the variance applies to a sliding time window.
duration variance_time

# the number of times this controller broke the realtime loop
int32 num_control_loop_overruns

# the timestamp of the last time this controller broke the realtime loop
time time_last_control_loop_overrun
"
  end
  attr_accessor :header, :actuator_statistics, :joint_statistics, :controller_statistics

  @@struct_C = ::ROS::Struct.new("C")
  @@struct_l = ::ROS::Struct.new("l")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_d4C2d5 = ::ROS::Struct.new("d4C2d5")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_ld4C3d2C2d7l = ::ROS::Struct.new("ld4C3d2C2d7l")
  @@struct_L2 = ::ROS::Struct.new("L2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','pr2_mechanism_msgs/ActuatorStatistics[]','pr2_mechanism_msgs/JointStatistics[]','pr2_mechanism_msgs/ControllerStatistics[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [pr2_mechanism_msgs/ActuatorStatistics[]] :actuator_statistics initialize value
  # @option args [pr2_mechanism_msgs/JointStatistics[]] :joint_statistics initialize value
  # @option args [pr2_mechanism_msgs/ControllerStatistics[]] :controller_statistics initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:actuator_statistics]
      @actuator_statistics = args[:actuator_statistics]
    else
      @actuator_statistics = []
    end
    if args[:joint_statistics]
      @joint_statistics = args[:joint_statistics]
    else
      @joint_statistics = []
    end
    if args[:controller_statistics]
      @controller_statistics = args[:controller_statistics]
    else
      @controller_statistics = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @actuator_statistics.length
      buff.write(@@struct_L.pack(length))
      for val1 in @actuator_statistics
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_l.pack(val1.device_id))
        _v15 = val1.timestamp
        _x = _v15
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(@@struct_ld4C3d2C2d7l.pack(_x.encoder_count, _x.encoder_offset, _x.position, _x.encoder_velocity, _x.velocity, _x.calibration_reading, _x.calibration_rising_edge_valid, _x.calibration_falling_edge_valid, _x.last_calibration_rising_edge, _x.last_calibration_falling_edge, _x.is_enabled, _x.halted, _x.last_commanded_current, _x.last_commanded_effort, _x.last_executed_current, _x.last_executed_effort, _x.last_measured_current, _x.last_measured_effort, _x.motor_voltage, _x.num_encoder_errors))
      end
      length = @joint_statistics.length
      buff.write(@@struct_L.pack(length))
      for val1 in @joint_statistics
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v16 = val1.timestamp
        _x = _v16
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = val1
        buff.write(@@struct_d4C2d5.pack(_x.position, _x.velocity, _x.measured_effort, _x.commanded_effort, _x.is_calibrated, _x.violated_limits, _x.odometer, _x.min_position, _x.max_position, _x.max_abs_velocity, _x.max_abs_effort))
      end
      length = @controller_statistics.length
      buff.write(@@struct_L.pack(length))
      for val1 in @controller_statistics
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v17 = val1.timestamp
        _x = _v17
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        buff.write(@@struct_C.pack(val1.running))
        _v18 = val1.max_time
        _x = _v18
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        _v19 = val1.mean_time
        _x = _v19
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        _v20 = val1.variance_time
        _x = _v20
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        buff.write(@@struct_l.pack(val1.num_control_loop_overruns))
        _v21 = val1.time_last_control_loop_overrun
        _x = _v21
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @actuator_statistics == nil
        @actuator_statistics = Pr2_mechanism_msgs::ActuatorStatistics[].new
      end
      if @joint_statistics == nil
        @joint_statistics = Pr2_mechanism_msgs::JointStatistics[].new
      end
      if @controller_statistics == nil
        @controller_statistics = Pr2_mechanism_msgs::ControllerStatistics[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @actuator_statistics = []
      length.times do
        val1 = Pr2_mechanism_msgs::ActuatorStatistics.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('l')
        (val1.device_id,) = @@struct_l.unpack(str[start..(end_point-1)])
        _v22 = val1.timestamp
        _x = _v22
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('ld4C3d2C2d7l')
        (_x.encoder_count, _x.encoder_offset, _x.position, _x.encoder_velocity, _x.velocity, _x.calibration_reading, _x.calibration_rising_edge_valid, _x.calibration_falling_edge_valid, _x.last_calibration_rising_edge, _x.last_calibration_falling_edge, _x.is_enabled, _x.halted, _x.last_commanded_current, _x.last_commanded_effort, _x.last_executed_current, _x.last_executed_effort, _x.last_measured_current, _x.last_measured_effort, _x.motor_voltage, _x.num_encoder_errors,) = @@struct_ld4C3d2C2d7l.unpack(str[start..(end_point-1)])
        val1.calibration_reading = bool(val1.calibration_reading)
        val1.calibration_rising_edge_valid = bool(val1.calibration_rising_edge_valid)
        val1.calibration_falling_edge_valid = bool(val1.calibration_falling_edge_valid)
        val1.is_enabled = bool(val1.is_enabled)
        val1.halted = bool(val1.halted)
        @actuator_statistics.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @joint_statistics = []
      length.times do
        val1 = Pr2_mechanism_msgs::JointStatistics.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        _v23 = val1.timestamp
        _x = _v23
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d4C2d5')
        (_x.position, _x.velocity, _x.measured_effort, _x.commanded_effort, _x.is_calibrated, _x.violated_limits, _x.odometer, _x.min_position, _x.max_position, _x.max_abs_velocity, _x.max_abs_effort,) = @@struct_d4C2d5.unpack(str[start..(end_point-1)])
        val1.is_calibrated = bool(val1.is_calibrated)
        val1.violated_limits = bool(val1.violated_limits)
        @joint_statistics.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @controller_statistics = []
      length.times do
        val1 = Pr2_mechanism_msgs::ControllerStatistics.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        _v24 = val1.timestamp
        _x = _v24
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (val1.running,) = @@struct_C.unpack(str[start..(end_point-1)])
        val1.running = bool(val1.running)
        _v25 = val1.max_time
        _x = _v25
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        _v26 = val1.mean_time
        _x = _v26
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        _v27 = val1.variance_time
        _x = _v27
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('l')
        (val1.num_control_loop_overruns,) = @@struct_l.unpack(str[start..(end_point-1)])
        _v28 = val1.time_last_control_loop_overrun
        _x = _v28
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        @controller_statistics.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
