# autogenerated by genrb from AccelerometerState.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Vector3"

module Pr2_msgs

class AccelerometerState <::ROS::Message
  def self.md5sum
    "26492e97ed8c13252c4a85592d3e93fd"
  end

  def self.type
    "pr2_msgs/AccelerometerState"
  end

  def has_header?
    true
  end

  def message_definition
    "#This captures acceleration measurements from the 3-dof accelerometer in the hand of the PR2
#Units are meters / second / second
#Vectors should be <X, Y, Z> in the frame of the gripper

#The communication with the accelerometer is at approximately 3khz, but there is only good timestamping every 1ms
#This means the samples should be interpreted as all having come from the 1 ms before the time in the header

Header header
geometry_msgs/Vector3[] samples

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :header, :samples

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','geometry_msgs/Vector3[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [geometry_msgs/Vector3[]] :samples initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:samples]
      @samples = args[:samples]
    else
      @samples = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @samples.length
      buff.write(@@struct_L.pack(length))
      for val1 in @samples
        _x = val1
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @samples == nil
        @samples = Geometry_msgs::Vector3[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @samples = []
      length.times do
        val1 = Geometry_msgs::Vector3.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @samples.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
