# autogenerated by genrb from BatteryServer.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "pr2_msgs/BatteryState"

module Pr2_msgs

class BatteryServer <::ROS::Message
  def self.md5sum
    "4f6d6e54c9581beb1df7ea408c0727be"
  end

  def self.type
    "pr2_msgs/BatteryServer"
  end

  def has_header?
    true
  end

  def message_definition
    "# DEPRECATED. Use pr2_msgs/BatteryServer2 instead.
Header header
uint32 MAX_BAT_COUNT=4
uint32 MAX_BAT_REG=48
int32 id  # unique ID for each battery server
# Battery System Stats
int32 lastTimeSystem #epoch time
uint16 timeLeft      # in minutes
uint16 averageCharge # in percent
string message
# Battery Controller Flags
int32 lastTimeController #epoch time
uint16 present
uint16 charging
uint16 discharging
uint16 reserved
uint16 powerPresent
uint16 powerNG
uint16 inhibited
# for each battery
pr2_msgs/BatteryState[] battery

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: pr2_msgs/BatteryState
# DEPRECATED.  Use pr2_msgs/BatteryState2 instead.
# Each batteries registers
int32 lastTimeBattery #epoch time
uint16[48] batReg
uint16[48] batRegFlag
int32[48] batRegTime

"
  end
  # Pseudo-constants
  MAX_BAT_COUNT = 4
  MAX_BAT_REG = 48

  attr_accessor :header, :id, :lastTimeSystem, :timeLeft, :averageCharge, :message, :lastTimeController, :present, :charging, :discharging, :reserved, :powerPresent, :powerNG, :inhibited, :battery

  @@struct_l2S2 = ::ROS::Struct.new("l2S2")
  @@struct_l48 = ::ROS::Struct.new("l48")
  @@struct_S48 = ::ROS::Struct.new("S48")
  @@struct_l = ::ROS::Struct.new("l")
  @@struct_lS7 = ::ROS::Struct.new("lS7")
  @@struct_L3 = ::ROS::Struct.new("L3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','int32','int32','uint16','uint16','string','int32','uint16','uint16','uint16','uint16','uint16','uint16','uint16','pr2_msgs/BatteryState[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [int32] :id initialize value
  # @option args [int32] :lastTimeSystem initialize value
  # @option args [uint16] :timeLeft initialize value
  # @option args [uint16] :averageCharge initialize value
  # @option args [string] :message initialize value
  # @option args [int32] :lastTimeController initialize value
  # @option args [uint16] :present initialize value
  # @option args [uint16] :charging initialize value
  # @option args [uint16] :discharging initialize value
  # @option args [uint16] :reserved initialize value
  # @option args [uint16] :powerPresent initialize value
  # @option args [uint16] :powerNG initialize value
  # @option args [uint16] :inhibited initialize value
  # @option args [pr2_msgs/BatteryState[]] :battery initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:id]
      @id = args[:id]
    else
      @id = 0
    end
    if args[:lastTimeSystem]
      @lastTimeSystem = args[:lastTimeSystem]
    else
      @lastTimeSystem = 0
    end
    if args[:timeLeft]
      @timeLeft = args[:timeLeft]
    else
      @timeLeft = 0
    end
    if args[:averageCharge]
      @averageCharge = args[:averageCharge]
    else
      @averageCharge = 0
    end
    if args[:message]
      @message = args[:message]
    else
      @message = ''
    end
    if args[:lastTimeController]
      @lastTimeController = args[:lastTimeController]
    else
      @lastTimeController = 0
    end
    if args[:present]
      @present = args[:present]
    else
      @present = 0
    end
    if args[:charging]
      @charging = args[:charging]
    else
      @charging = 0
    end
    if args[:discharging]
      @discharging = args[:discharging]
    else
      @discharging = 0
    end
    if args[:reserved]
      @reserved = args[:reserved]
    else
      @reserved = 0
    end
    if args[:powerPresent]
      @powerPresent = args[:powerPresent]
    else
      @powerPresent = 0
    end
    if args[:powerNG]
      @powerNG = args[:powerNG]
    else
      @powerNG = 0
    end
    if args[:inhibited]
      @inhibited = args[:inhibited]
    else
      @inhibited = 0
    end
    if args[:battery]
      @battery = args[:battery]
    else
      @battery = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_l2S2.pack(@id, @lastTimeSystem, @timeLeft, @averageCharge))
      _x = @message
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_lS7.pack(@lastTimeController, @present, @charging, @discharging, @reserved, @powerPresent, @powerNG, @inhibited))
      length = @battery.length
      buff.write(@@struct_L.pack(length))
      for val1 in @battery
        buff.write(@@struct_l.pack(val1.lastTimeBattery))
        buff.write(@@struct_S48.pack(*val1.batReg))
        buff.write(@@struct_S48.pack(*val1.batRegFlag))
        buff.write(@@struct_l48.pack(*val1.batRegTime))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @battery == nil
        @battery = Pr2_msgs::BatteryState[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('l2S2')
      (@id, @lastTimeSystem, @timeLeft, @averageCharge,) = @@struct_l2S2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @message = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('lS7')
      (@lastTimeController, @present, @charging, @discharging, @reserved, @powerPresent, @powerNG, @inhibited,) = @@struct_lS7.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @battery = []
      length.times do
        val1 = Pr2_msgs::BatteryState.new
        start = end_point
        end_point += ROS::Struct::calc_size('l')
        (val1.lastTimeBattery,) = @@struct_l.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('S48')
        val1.batReg = @@struct_S48.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('S48')
        val1.batRegFlag = @@struct_S48.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('l48')
        val1.batRegTime = @@struct_l48.unpack(str[start..(end_point-1)])
        @battery.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
