# autogenerated by genrb from BatteryServer2.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "ros/time"
require "ros/duration"
require "pr2_msgs/BatteryState2"

module Pr2_msgs

class BatteryServer2 <::ROS::Message
  def self.md5sum
    "5f2cec7d06c312d756189db96c1f3819"
  end

  def self.type
    "pr2_msgs/BatteryServer2"
  end

  def has_header?
    true
  end

  def message_definition
    "# This message communicates the state of a battery server, which controls
# multiple batteries.
Header header
int32 MAX_BAT_COUNT=4
int32 MAX_BAT_REG=48
int32 id  # unique ID for each battery server
# Battery System Stats
time last_system_update  # last time the system stats where updated
duration time_left       # in seconds (hardware resolution is 1 minute)
int32 average_charge     # in percent
string message           # message from the ocean server
time last_controller_update # last time a battery status flag was updated
# for each battery
pr2_msgs/BatteryState2[] battery

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: pr2_msgs/BatteryState2
# This message communicates the state of a single battery.
# Battery Controller Flags, one per battery
bool present       # is this pack present
bool charging      # is this pack charging
bool discharging   # is this pack discharging
bool power_present # is there an input voltage
bool power_no_good # is there a fault (No Good)
bool inhibited     # is this pack disabled for some reason
# These registers are per battery
time      last_battery_update     # last time any battery update occurred
int16[48] battery_register        # value of this register in the battery
bool[48]  battery_update_flag     # Has this register ever been updated
time[48]  battery_register_update # last time this specific register was updated

"
  end
  # Pseudo-constants
  MAX_BAT_COUNT = 4
  MAX_BAT_REG = 48

  attr_accessor :header, :id, :last_system_update, :time_left, :average_charge, :message, :last_controller_update, :battery

  @@struct_C6 = ::ROS::Struct.new("C6")
  @@struct_lL2l3 = ::ROS::Struct.new("lL2l3")
  @@struct_s48 = ::ROS::Struct.new("s48")
  @@struct_C48 = ::ROS::Struct.new("C48")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_L2 = ::ROS::Struct.new("L2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','int32','time','duration','int32','string','time','pr2_msgs/BatteryState2[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [int32] :id initialize value
  # @option args [time] :last_system_update initialize value
  # @option args [duration] :time_left initialize value
  # @option args [int32] :average_charge initialize value
  # @option args [string] :message initialize value
  # @option args [time] :last_controller_update initialize value
  # @option args [pr2_msgs/BatteryState2[]] :battery initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:id]
      @id = args[:id]
    else
      @id = 0
    end
    if args[:last_system_update]
      @last_system_update = args[:last_system_update]
    else
      @last_system_update = ROS::Time.new
    end
    if args[:time_left]
      @time_left = args[:time_left]
    else
      @time_left = ROS::Duration.new
    end
    if args[:average_charge]
      @average_charge = args[:average_charge]
    else
      @average_charge = 0
    end
    if args[:message]
      @message = args[:message]
    else
      @message = ''
    end
    if args[:last_controller_update]
      @last_controller_update = args[:last_controller_update]
    else
      @last_controller_update = ROS::Time.new
    end
    if args[:battery]
      @battery = args[:battery]
    else
      @battery = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_lL2l3.pack(@id, @last_system_update.secs, @last_system_update.nsecs, @time_left.secs, @time_left.nsecs, @average_charge))
      _x = @message
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@last_controller_update.secs, @last_controller_update.nsecs))
      length = @battery.length
      buff.write(@@struct_L.pack(length))
      for val1 in @battery
        _x = val1
        buff.write(@@struct_C6.pack(_x.present, _x.charging, _x.discharging, _x.power_present, _x.power_no_good, _x.inhibited))
        _v329 = val1.last_battery_update
        _x = _v329
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        buff.write(@@struct_s48.pack(*val1.battery_register))
        buff.write(@@struct_C48.pack(*val1.battery_update_flag))
        for val2 in val1.battery_register_update
          _x = val2
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        end
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @last_system_update == nil
        @last_system_update = ROS::Time.new
      end
      if @time_left == nil
        @time_left = ROS::Duration.new
      end
      if @last_controller_update == nil
        @last_controller_update = ROS::Time.new
      end
      if @battery == nil
        @battery = Pr2_msgs::BatteryState2[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('lL2l3')
      (@id, @last_system_update.secs, @last_system_update.nsecs, @time_left.secs, @time_left.nsecs, @average_charge,) = @@struct_lL2l3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @message = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@last_controller_update.secs, @last_controller_update.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @battery = []
      length.times do
        val1 = Pr2_msgs::BatteryState2.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('C6')
        (_x.present, _x.charging, _x.discharging, _x.power_present, _x.power_no_good, _x.inhibited,) = @@struct_C6.unpack(str[start..(end_point-1)])
        val1.present = bool(val1.present)
        val1.charging = bool(val1.charging)
        val1.discharging = bool(val1.discharging)
        val1.power_present = bool(val1.power_present)
        val1.power_no_good = bool(val1.power_no_good)
        val1.inhibited = bool(val1.inhibited)
        _v330 = val1.last_battery_update
        _x = _v330
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('s48')
        val1.battery_register = @@struct_s48.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('C48')
        val1.battery_update_flag = @@struct_C48.unpack(str[start..(end_point-1)])
        val1.battery_update_flag = map(bool, val1.battery_update_flag)
        val1.battery_register_update = []
        48.times do
          val2 = ROS::Time.new
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          val1.battery_register_update.push(val2)
        end
        @battery.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
