# autogenerated by genrb from BatteryState2.msg. Do not edit.
require 'ros/message'

require "ros/time"

module Pr2_msgs

class BatteryState2 <::ROS::Message
  def self.md5sum
    "91b4acb000aa990ac3006834f9a99669"
  end

  def self.type
    "pr2_msgs/BatteryState2"
  end

  def has_header?
    false
  end

  def message_definition
    "# This message communicates the state of a single battery.
# Battery Controller Flags, one per battery
bool present       # is this pack present
bool charging      # is this pack charging
bool discharging   # is this pack discharging
bool power_present # is there an input voltage
bool power_no_good # is there a fault (No Good)
bool inhibited     # is this pack disabled for some reason
# These registers are per battery
time      last_battery_update     # last time any battery update occurred
int16[48] battery_register        # value of this register in the battery
bool[48]  battery_update_flag     # Has this register ever been updated
time[48]  battery_register_update # last time this specific register was updated

"
  end
  attr_accessor :present, :charging, :discharging, :power_present, :power_no_good, :inhibited, :last_battery_update, :battery_register, :battery_update_flag, :battery_register_update

  @@struct_C6L2 = ::ROS::Struct.new("C6L2")
  @@struct_C48 = ::ROS::Struct.new("C48")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_s48 = ::ROS::Struct.new("s48")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['bool','bool','bool','bool','bool','bool','time','int16[48]','bool[48]','time[48]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [bool] :present initialize value
  # @option args [bool] :charging initialize value
  # @option args [bool] :discharging initialize value
  # @option args [bool] :power_present initialize value
  # @option args [bool] :power_no_good initialize value
  # @option args [bool] :inhibited initialize value
  # @option args [time] :last_battery_update initialize value
  # @option args [int16[48]] :battery_register initialize value
  # @option args [bool[48]] :battery_update_flag initialize value
  # @option args [time[48]] :battery_register_update initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:present]
      @present = args[:present]
    else
      @present = false
    end
    if args[:charging]
      @charging = args[:charging]
    else
      @charging = false
    end
    if args[:discharging]
      @discharging = args[:discharging]
    else
      @discharging = false
    end
    if args[:power_present]
      @power_present = args[:power_present]
    else
      @power_present = false
    end
    if args[:power_no_good]
      @power_no_good = args[:power_no_good]
    else
      @power_no_good = false
    end
    if args[:inhibited]
      @inhibited = args[:inhibited]
    else
      @inhibited = false
    end
    if args[:last_battery_update]
      @last_battery_update = args[:last_battery_update]
    else
      @last_battery_update = ROS::Time.new
    end
    if args[:battery_register]
      @battery_register = args[:battery_register]
    else
      @battery_register = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
    end
    if args[:battery_update_flag]
      @battery_update_flag = args[:battery_update_flag]
    else
      @battery_update_flag = [false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false]
    end
    if args[:battery_register_update]
      @battery_register_update = args[:battery_register_update]
    else
      @battery_register_update = [ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new,ROS::Time.new]
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_C6L2.pack(@present, @charging, @discharging, @power_present, @power_no_good, @inhibited, @last_battery_update.secs, @last_battery_update.nsecs))
      buff.write(@@struct_s48.pack(*@battery_register))
      buff.write(@@struct_C48.pack(*@battery_update_flag))
      for val1 in @battery_register_update
        _x = val1
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @last_battery_update == nil
        @last_battery_update = ROS::Time.new
      end
      if @battery_register_update == nil
        @battery_register_update = None
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('C6L2')
      (@present, @charging, @discharging, @power_present, @power_no_good, @inhibited, @last_battery_update.secs, @last_battery_update.nsecs,) = @@struct_C6L2.unpack(str[start..(end_point-1)])
      @present = bool(@present)
      @charging = bool(@charging)
      @discharging = bool(@discharging)
      @power_present = bool(@power_present)
      @power_no_good = bool(@power_no_good)
      @inhibited = bool(@inhibited)
      start = end_point
      end_point += ROS::Struct::calc_size('s48')
      @battery_register = @@struct_s48.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('C48')
      @battery_update_flag = @@struct_C48.unpack(str[start..(end_point-1)])
      @battery_update_flag = map(bool, @battery_update_flag)
      @battery_register_update = []
      48.times do
        val1 = ROS::Time.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        @battery_register_update.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
