# autogenerated by genrb from DashboardState.msg. Do not edit.
require 'ros/message'

require "pr2_msgs/AccessPoint"
require "pr2_msgs/PowerBoardState"
require "std_msgs/Bool"
require "ros/duration"
require "std_msgs/Header"
require "pr2_msgs/PowerState"

module Pr2_msgs

class DashboardState <::ROS::Message
  def self.md5sum
    "db0cd0d535d75e0f6257b20c403e87f5"
  end

  def self.type
    "pr2_msgs/DashboardState"
  end

  def has_header?
    false
  end

  def message_definition
    "# This message communicates state information that might be used by a
# dashboard application.
std_msgs/Bool motors_halted
bool motors_halted_valid

pr2_msgs/PowerBoardState power_board_state
bool power_board_state_valid

pr2_msgs/PowerState power_state
bool power_state_valid

pr2_msgs/AccessPoint access_point
bool access_point_valid

================================================================================
MSG: std_msgs/Bool
bool data
================================================================================
MSG: pr2_msgs/PowerBoardState
# This message communicates the state of the PR2's power board.
int8 STATE_NOPOWER=0
int8 STATE_STANDBY=1
int8 STATE_PUMPING=2
int8 STATE_ON=3
int8 STATE_ENABLED=3  # Preferred over STATE_ON, keeping STATE_ON for backcompat
int8 STATE_DISABLED=4

int8 MASTER_NOPOWER=0
int8 MASTER_STANDBY=1
int8 MASTER_ON=2
int8 MASTER_OFF=3
int8 MASTER_SHUTDOWN=4

Header header
string name # Name with serial number
uint32 serial_num # Serial number for this board's message
float64 input_voltage # Input voltage to power board

# Master States:
#  MASTER_NOPOWER, MASTER_STANDBY, MASTER_ON, MASTER_OFF, MASTER_SHUTDOWN 
int8 master_state  # The master state machine's state in the powerboard

# Circuit States:
#  STATE_NOPOWER, STATE_STANDBY, STATE_PUMPING, STATE_ON, STATE_DISABLED
int8[3] circuit_state # One of the above states
float64[3] circuit_voltage  # Output voltage of each circuit

# True if robot should be enabled
bool run_stop           #Note - if the wireless run-stop is hit, this will be unobservable
bool wireless_stop 

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: pr2_msgs/PowerState
# This message communicates the state of the PR2's power system.
Header header
float64 power_consumption ## Watts
duration time_remaining ## estimated time to empty or full
string prediction_method ## how time_remaining is being calculated
int8  relative_capacity ## percent of capacity
int8  AC_present ## number of packs detecting AC power, > 0 means plugged in

================================================================================
MSG: pr2_msgs/AccessPoint
# This message communicates the state of the PR2's wifi access point.
Header header
string essid
string macaddr
int32 signal
int32 noise
int32 snr
int32 channel
string rate
string tx_power
int32 quality

"
  end
  attr_accessor :motors_halted, :motors_halted_valid, :power_board_state, :power_board_state_valid, :power_state, :power_state_valid, :access_point, :access_point_valid

  @@struct_C2L3 = ::ROS::Struct.new("C2L3")
  @@struct_l4 = ::ROS::Struct.new("l4")
  @@struct_C3L3 = ::ROS::Struct.new("C3L3")
  @@struct_dl2 = ::ROS::Struct.new("dl2")
  @@struct_c2CL3 = ::ROS::Struct.new("c2CL3")
  @@struct_c3 = ::ROS::Struct.new("c3")
  @@struct_lC = ::ROS::Struct.new("lC")
  @@struct_Ldc = ::ROS::Struct.new("Ldc")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Bool','bool','pr2_msgs/PowerBoardState','bool','pr2_msgs/PowerState','bool','pr2_msgs/AccessPoint','bool']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Bool] :motors_halted initialize value
  # @option args [bool] :motors_halted_valid initialize value
  # @option args [pr2_msgs/PowerBoardState] :power_board_state initialize value
  # @option args [bool] :power_board_state_valid initialize value
  # @option args [pr2_msgs/PowerState] :power_state initialize value
  # @option args [bool] :power_state_valid initialize value
  # @option args [pr2_msgs/AccessPoint] :access_point initialize value
  # @option args [bool] :access_point_valid initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:motors_halted]
      @motors_halted = args[:motors_halted]
    else
      @motors_halted = Std_msgs::Bool.new
    end
    if args[:motors_halted_valid]
      @motors_halted_valid = args[:motors_halted_valid]
    else
      @motors_halted_valid = false
    end
    if args[:power_board_state]
      @power_board_state = args[:power_board_state]
    else
      @power_board_state = Pr2_msgs::PowerBoardState.new
    end
    if args[:power_board_state_valid]
      @power_board_state_valid = args[:power_board_state_valid]
    else
      @power_board_state_valid = false
    end
    if args[:power_state]
      @power_state = args[:power_state]
    else
      @power_state = Pr2_msgs::PowerState.new
    end
    if args[:power_state_valid]
      @power_state_valid = args[:power_state_valid]
    else
      @power_state_valid = false
    end
    if args[:access_point]
      @access_point = args[:access_point]
    else
      @access_point = Pr2_msgs::AccessPoint.new
    end
    if args[:access_point_valid]
      @access_point_valid = args[:access_point_valid]
    else
      @access_point_valid = false
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_C2L3.pack(@motors_halted.data, @motors_halted_valid, @power_board_state.header.seq, @power_board_state.header.stamp.secs, @power_board_state.header.stamp.nsecs))
      _x = @power_board_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @power_board_state.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_Ldc.pack(@power_board_state.serial_num, @power_board_state.input_voltage, @power_board_state.master_state))
      buff.write(@@struct_c3.pack(*@power_board_state.circuit_state))
      buff.write(@@struct_d3.pack(*@power_board_state.circuit_voltage))
      buff.write(@@struct_C3L3.pack(@power_board_state.run_stop, @power_board_state.wireless_stop, @power_board_state_valid, @power_state.header.seq, @power_state.header.stamp.secs, @power_state.header.stamp.nsecs))
      _x = @power_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_dl2.pack(@power_state.power_consumption, @power_state.time_remaining.secs, @power_state.time_remaining.nsecs))
      _x = @power_state.prediction_method
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_c2CL3.pack(@power_state.relative_capacity, @power_state.AC_present, @power_state_valid, @access_point.header.seq, @access_point.header.stamp.secs, @access_point.header.stamp.nsecs))
      _x = @access_point.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @access_point.essid
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @access_point.macaddr
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_l4.pack(@access_point.signal, @access_point.noise, @access_point.snr, @access_point.channel))
      _x = @access_point.rate
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @access_point.tx_power
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_lC.pack(@access_point.quality, @access_point_valid))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @motors_halted == nil
        @motors_halted = Std_msgs::Bool.new
      end
      if @power_board_state == nil
        @power_board_state = Pr2_msgs::PowerBoardState.new
      end
      if @power_state == nil
        @power_state = Pr2_msgs::PowerState.new
      end
      if @access_point == nil
        @access_point = Pr2_msgs::AccessPoint.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('C2L3')
      (@motors_halted.data, @motors_halted_valid, @power_board_state.header.seq, @power_board_state.header.stamp.secs, @power_board_state.header.stamp.nsecs,) = @@struct_C2L3.unpack(str[start..(end_point-1)])
      @motors_halted.data = bool(@motors_halted.data)
      @motors_halted_valid = bool(@motors_halted_valid)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @power_board_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @power_board_state.name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('Ldc')
      (@power_board_state.serial_num, @power_board_state.input_voltage, @power_board_state.master_state,) = @@struct_Ldc.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('c3')
      @power_board_state.circuit_state = @@struct_c3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d3')
      @power_board_state.circuit_voltage = @@struct_d3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('C3L3')
      (@power_board_state.run_stop, @power_board_state.wireless_stop, @power_board_state_valid, @power_state.header.seq, @power_state.header.stamp.secs, @power_state.header.stamp.nsecs,) = @@struct_C3L3.unpack(str[start..(end_point-1)])
      @power_board_state.run_stop = bool(@power_board_state.run_stop)
      @power_board_state.wireless_stop = bool(@power_board_state.wireless_stop)
      @power_board_state_valid = bool(@power_board_state_valid)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @power_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('dl2')
      (@power_state.power_consumption, @power_state.time_remaining.secs, @power_state.time_remaining.nsecs,) = @@struct_dl2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @power_state.prediction_method = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('c2CL3')
      (@power_state.relative_capacity, @power_state.AC_present, @power_state_valid, @access_point.header.seq, @access_point.header.stamp.secs, @access_point.header.stamp.nsecs,) = @@struct_c2CL3.unpack(str[start..(end_point-1)])
      @power_state_valid = bool(@power_state_valid)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @access_point.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @access_point.essid = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @access_point.macaddr = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('l4')
      (@access_point.signal, @access_point.noise, @access_point.snr, @access_point.channel,) = @@struct_l4.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @access_point.rate = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @access_point.tx_power = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('lC')
      (@access_point.quality, @access_point_valid,) = @@struct_lC.unpack(str[start..(end_point-1)])
      @access_point_valid = bool(@access_point_valid)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
