# autogenerated by genrb from GPUStatus.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"

module Pr2_msgs

class GPUStatus <::ROS::Message
  def self.md5sum
    "4c74e5474b8aade04e56108262099c6e"
  end

  def self.type
    "pr2_msgs/GPUStatus"
  end

  def has_header?
    true
  end

  def message_definition
    "Header header
string product_name
string pci_device_id
string pci_location
string display
string driver_version
float32 temperature # Temperature in Celcius
float32 fan_speed # Fan speed in rad/s
float32 gpu_usage # Usage in percent
float32 memory_usage # Usage in percent
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  attr_accessor :header, :product_name, :pci_device_id, :pci_location, :display, :driver_version, :temperature, :fan_speed, :gpu_usage, :memory_usage

  @@struct_f4 = ::ROS::Struct.new("f4")
  @@struct_L3 = ::ROS::Struct.new("L3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','string','string','string','string','string','float32','float32','float32','float32']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [string] :product_name initialize value
  # @option args [string] :pci_device_id initialize value
  # @option args [string] :pci_location initialize value
  # @option args [string] :display initialize value
  # @option args [string] :driver_version initialize value
  # @option args [float32] :temperature initialize value
  # @option args [float32] :fan_speed initialize value
  # @option args [float32] :gpu_usage initialize value
  # @option args [float32] :memory_usage initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:product_name]
      @product_name = args[:product_name]
    else
      @product_name = ''
    end
    if args[:pci_device_id]
      @pci_device_id = args[:pci_device_id]
    else
      @pci_device_id = ''
    end
    if args[:pci_location]
      @pci_location = args[:pci_location]
    else
      @pci_location = ''
    end
    if args[:display]
      @display = args[:display]
    else
      @display = ''
    end
    if args[:driver_version]
      @driver_version = args[:driver_version]
    else
      @driver_version = ''
    end
    if args[:temperature]
      @temperature = args[:temperature]
    else
      @temperature = 0.0
    end
    if args[:fan_speed]
      @fan_speed = args[:fan_speed]
    else
      @fan_speed = 0.0
    end
    if args[:gpu_usage]
      @gpu_usage = args[:gpu_usage]
    else
      @gpu_usage = 0.0
    end
    if args[:memory_usage]
      @memory_usage = args[:memory_usage]
    else
      @memory_usage = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @product_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @pci_device_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @pci_location
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @display
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @driver_version
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_f4.pack(@temperature, @fan_speed, @gpu_usage, @memory_usage))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @product_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @pci_device_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @pci_location = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @display = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @driver_version = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('f4')
      (@temperature, @fan_speed, @gpu_usage, @memory_usage,) = @@struct_f4.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
