# autogenerated by genrb from LaserTrajCmd.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "ros/duration"

module Pr2_msgs

class LaserTrajCmd <::ROS::Message
  def self.md5sum
    "68a1665e9079049dce55a0384cb2e9b5"
  end

  def self.type
    "pr2_msgs/LaserTrajCmd"
  end

  def has_header?
    true
  end

  def message_definition
    "# This message is used to set the profile that the tilt laser controller
# executes.
Header header
string profile              # options are currently \"linear\" or \"linear_blended\"
float64[] position          # Laser positions
duration[] time_from_start  # Times to reach laser positions in seconds
float64 max_velocity        # Set <= 0 to use default
float64 max_acceleration    # Set <= 0 to use default

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  attr_accessor :header, :profile, :position, :time_from_start, :max_velocity, :max_acceleration

  @@struct_d2 = ::ROS::Struct.new("d2")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_l2 = ::ROS::Struct.new("l2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','string','float64[]','duration[]','float64','float64']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [string] :profile initialize value
  # @option args [float64[]] :position initialize value
  # @option args [duration[]] :time_from_start initialize value
  # @option args [float64] :max_velocity initialize value
  # @option args [float64] :max_acceleration initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:profile]
      @profile = args[:profile]
    else
      @profile = ''
    end
    if args[:position]
      @position = args[:position]
    else
      @position = []
    end
    if args[:time_from_start]
      @time_from_start = args[:time_from_start]
    else
      @time_from_start = []
    end
    if args[:max_velocity]
      @max_velocity = args[:max_velocity]
    else
      @max_velocity = 0.0
    end
    if args[:max_acceleration]
      @max_acceleration = args[:max_acceleration]
    else
      @max_acceleration = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @profile
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@position.pack(pattern))
      length = @time_from_start.length
      buff.write(@@struct_L.pack(length))
      for val1 in @time_from_start
        _x = val1
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_d2.pack(@max_velocity, @max_acceleration))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @time_from_start == nil
        @time_from_start = None
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @profile = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @time_from_start = []
      length.times do
        val1 = ROS::Duration.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @time_from_start.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('d2')
      (@max_velocity, @max_acceleration,) = @@struct_d2.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
