# autogenerated by genrb from PowerBoardState.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"

module Pr2_msgs

class PowerBoardState <::ROS::Message
  def self.md5sum
    "08899b671e6a1a449e7ce0000da8ae7b"
  end

  def self.type
    "pr2_msgs/PowerBoardState"
  end

  def has_header?
    true
  end

  def message_definition
    "# This message communicates the state of the PR2's power board.
int8 STATE_NOPOWER=0
int8 STATE_STANDBY=1
int8 STATE_PUMPING=2
int8 STATE_ON=3
int8 STATE_ENABLED=3  # Preferred over STATE_ON, keeping STATE_ON for backcompat
int8 STATE_DISABLED=4

int8 MASTER_NOPOWER=0
int8 MASTER_STANDBY=1
int8 MASTER_ON=2
int8 MASTER_OFF=3
int8 MASTER_SHUTDOWN=4

Header header
string name # Name with serial number
uint32 serial_num # Serial number for this board's message
float64 input_voltage # Input voltage to power board

# Master States:
#  MASTER_NOPOWER, MASTER_STANDBY, MASTER_ON, MASTER_OFF, MASTER_SHUTDOWN 
int8 master_state  # The master state machine's state in the powerboard

# Circuit States:
#  STATE_NOPOWER, STATE_STANDBY, STATE_PUMPING, STATE_ON, STATE_DISABLED
int8[3] circuit_state # One of the above states
float64[3] circuit_voltage  # Output voltage of each circuit

# True if robot should be enabled
bool run_stop           #Note - if the wireless run-stop is hit, this will be unobservable
bool wireless_stop 

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  # Pseudo-constants
  STATE_NOPOWER = 0
  STATE_STANDBY = 1
  STATE_PUMPING = 2
  STATE_ON = 3
  STATE_ENABLED = 3
  STATE_DISABLED = 4
  MASTER_NOPOWER = 0
  MASTER_STANDBY = 1
  MASTER_ON = 2
  MASTER_OFF = 3
  MASTER_SHUTDOWN = 4

  attr_accessor :header, :name, :serial_num, :input_voltage, :master_state, :circuit_state, :circuit_voltage, :run_stop, :wireless_stop

  @@struct_c3 = ::ROS::Struct.new("c3")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_Ldc = ::ROS::Struct.new("Ldc")
  @@struct_C2 = ::ROS::Struct.new("C2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','string','uint32','float64','int8','int8[3]','float64[3]','bool','bool']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [string] :name initialize value
  # @option args [uint32] :serial_num initialize value
  # @option args [float64] :input_voltage initialize value
  # @option args [int8] :master_state initialize value
  # @option args [int8[3]] :circuit_state initialize value
  # @option args [float64[3]] :circuit_voltage initialize value
  # @option args [bool] :run_stop initialize value
  # @option args [bool] :wireless_stop initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
    if args[:serial_num]
      @serial_num = args[:serial_num]
    else
      @serial_num = 0
    end
    if args[:input_voltage]
      @input_voltage = args[:input_voltage]
    else
      @input_voltage = 0.0
    end
    if args[:master_state]
      @master_state = args[:master_state]
    else
      @master_state = 0
    end
    if args[:circuit_state]
      @circuit_state = args[:circuit_state]
    else
      @circuit_state = [0,0,0]
    end
    if args[:circuit_voltage]
      @circuit_voltage = args[:circuit_voltage]
    else
      @circuit_voltage = [0.0,0.0,0.0]
    end
    if args[:run_stop]
      @run_stop = args[:run_stop]
    else
      @run_stop = false
    end
    if args[:wireless_stop]
      @wireless_stop = args[:wireless_stop]
    else
      @wireless_stop = false
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_Ldc.pack(@serial_num, @input_voltage, @master_state))
      buff.write(@@struct_c3.pack(*@circuit_state))
      buff.write(@@struct_d3.pack(*@circuit_voltage))
      buff.write(@@struct_C2.pack(@run_stop, @wireless_stop))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('Ldc')
      (@serial_num, @input_voltage, @master_state,) = @@struct_Ldc.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('c3')
      @circuit_state = @@struct_c3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d3')
      @circuit_voltage = @@struct_d3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('C2')
      (@run_stop, @wireless_stop,) = @@struct_C2.unpack(str[start..(end_point-1)])
      @run_stop = bool(@run_stop)
      @wireless_stop = bool(@wireless_stop)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
