# autogenerated by genrb from PowerState.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "ros/duration"

module Pr2_msgs

class PowerState <::ROS::Message
  def self.md5sum
    "e6fa46a387cad0b7a80959a21587a6c9"
  end

  def self.type
    "pr2_msgs/PowerState"
  end

  def has_header?
    true
  end

  def message_definition
    "# This message communicates the state of the PR2's power system.
Header header
float64 power_consumption ## Watts
duration time_remaining ## estimated time to empty or full
string prediction_method ## how time_remaining is being calculated
int8  relative_capacity ## percent of capacity
int8  AC_present ## number of packs detecting AC power, > 0 means plugged in

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  attr_accessor :header, :power_consumption, :time_remaining, :prediction_method, :relative_capacity, :AC_present

  @@struct_dl2 = ::ROS::Struct.new("dl2")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_c2 = ::ROS::Struct.new("c2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','float64','duration','string','int8','int8']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [float64] :power_consumption initialize value
  # @option args [duration] :time_remaining initialize value
  # @option args [string] :prediction_method initialize value
  # @option args [int8] :relative_capacity initialize value
  # @option args [int8] :AC_present initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:power_consumption]
      @power_consumption = args[:power_consumption]
    else
      @power_consumption = 0.0
    end
    if args[:time_remaining]
      @time_remaining = args[:time_remaining]
    else
      @time_remaining = ROS::Duration.new
    end
    if args[:prediction_method]
      @prediction_method = args[:prediction_method]
    else
      @prediction_method = ''
    end
    if args[:relative_capacity]
      @relative_capacity = args[:relative_capacity]
    else
      @relative_capacity = 0
    end
    if args[:AC_present]
      @AC_present = args[:AC_present]
    else
      @AC_present = 0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_dl2.pack(@power_consumption, @time_remaining.secs, @time_remaining.nsecs))
      _x = @prediction_method
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_c2.pack(@relative_capacity, @AC_present))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @time_remaining == nil
        @time_remaining = ROS::Duration.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('dl2')
      (@power_consumption, @time_remaining.secs, @time_remaining.nsecs,) = @@struct_dl2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @prediction_method = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('c2')
      (@relative_capacity, @AC_present,) = @@struct_c2.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
