# autogenerated by genrb from PressureState.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"

module Pr2_msgs

class PressureState <::ROS::Message
  def self.md5sum
    "756fb3b75fa8884524fd0789a78eb04b"
  end

  def self.type
    "pr2_msgs/PressureState"
  end

  def has_header?
    true
  end

  def message_definition
    "#Output from finger-tip pressure sensors on PR2
#Higher number correspond to more pressure, but there is no explicit unit and you will have to calibrate for offset
#The numbers reported are the raw values from the I2C hardware

Header header
int16[] l_finger_tip
int16[] r_finger_tip

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  attr_accessor :header, :l_finger_tip, :r_finger_tip

  @@struct_L3 = ::ROS::Struct.new("L3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','int16[]','int16[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [int16[]] :l_finger_tip initialize value
  # @option args [int16[]] :r_finger_tip initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:l_finger_tip]
      @l_finger_tip = args[:l_finger_tip]
    else
      @l_finger_tip = []
    end
    if args[:r_finger_tip]
      @r_finger_tip = args[:r_finger_tip]
    else
      @r_finger_tip = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @l_finger_tip.length
      buff.write(@@struct_L.pack(length))
      pattern = "s#{length}"
      buff.write(*@l_finger_tip.pack(pattern))
      length = @r_finger_tip.length
      buff.write(@@struct_L.pack(length))
      pattern = "s#{length}"
      buff.write(*@r_finger_tip.pack(pattern))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "s#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @l_finger_tip = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "s#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @r_finger_tip = str[start..(end_point-1)].unpack(pattern)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
