# autogenerated by genrb from SetLaserTrajCmdRequest.msg. Do not edit.
require 'ros/message'

require "pr2_msgs/LaserTrajCmd"
require "std_msgs/Header"
require "ros/duration"

module Pr2_msgs

class SetLaserTrajCmdRequest <::ROS::Message
  def self.md5sum
    "83f915c37d36f61442c752779261e7d4"
  end

  def self.type
    "pr2_msgs/SetLaserTrajCmdRequest"
  end

  def has_header?
    false
  end

  def message_definition
    "pr2_msgs/LaserTrajCmd command

================================================================================
MSG: pr2_msgs/LaserTrajCmd
# This message is used to set the profile that the tilt laser controller
# executes.
Header header
string profile              # options are currently \"linear\" or \"linear_blended\"
float64[] position          # Laser positions
duration[] time_from_start  # Times to reach laser positions in seconds
float64 max_velocity        # Set <= 0 to use default
float64 max_acceleration    # Set <= 0 to use default

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  attr_accessor :command

  @@struct_d2 = ::ROS::Struct.new("d2")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_l2 = ::ROS::Struct.new("l2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['pr2_msgs/LaserTrajCmd']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [pr2_msgs/LaserTrajCmd] :command initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:command]
      @command = args[:command]
    else
      @command = Pr2_msgs::LaserTrajCmd.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@command.header.seq, @command.header.stamp.secs, @command.header.stamp.nsecs))
      _x = @command.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @command.profile
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @command.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@command.position.pack(pattern))
      length = @command.time_from_start.length
      buff.write(@@struct_L.pack(length))
      for val1 in @command.time_from_start
        _x = val1
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_d2.pack(@command.max_velocity, @command.max_acceleration))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @command == nil
        @command = Pr2_msgs::LaserTrajCmd.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@command.header.seq, @command.header.stamp.secs, @command.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @command.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @command.profile = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @command.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @command.time_from_start = []
      length.times do
        val1 = ROS::Duration.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @command.time_from_start.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('d2')
      (@command.max_velocity, @command.max_acceleration,) = @@struct_d2.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
# autogenerated by genrb from SetLaserTrajCmdResponse.msg. Do not edit.
require 'ros/message'

require "ros/time"

module Pr2_msgs

class SetLaserTrajCmdResponse <::ROS::Message
  def self.md5sum
    "3888666920054f1ef39d2df7a5d94b02"
  end

  def self.type
    "pr2_msgs/SetLaserTrajCmdResponse"
  end

  def has_header?
    false
  end

  def message_definition
    "time start_time

"
  end
  attr_accessor :start_time

  @@struct_L2 = ::ROS::Struct.new("L2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['time']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [time] :start_time initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:start_time]
      @start_time = args[:start_time]
    else
      @start_time = ROS::Time.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L2.pack(@start_time.secs, @start_time.nsecs))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @start_time == nil
        @start_time = ROS::Time.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@start_time.secs, @start_time.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
module Pr2_msgs
class SetLaserTrajCmd
  def self.type
    'pr2_msgs/SetLaserTrajCmd'
  end
  def self.md5sum
    '28fe2ce397611c999952c74a1ea882aa'
  end
  def self.request_class
    SetLaserTrajCmdRequest
  end
  def self.response_class
    SetLaserTrajCmdResponse
  end
end
end