# autogenerated by genrb from SetPeriodicCmdRequest.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "pr2_msgs/PeriodicCmd"

module Pr2_msgs

class SetPeriodicCmdRequest <::ROS::Message
  def self.md5sum
    "d4deedcc194c4a77110f7228904ee733"
  end

  def self.type
    "pr2_msgs/SetPeriodicCmdRequest"
  end

  def has_header?
    false
  end

  def message_definition
    "pr2_msgs/PeriodicCmd command

================================================================================
MSG: pr2_msgs/PeriodicCmd
# This message is used to set the parameters of a profile executed by the
# laser tilt controller.
Header header
string profile
float64 period
float64 amplitude
float64 offset

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  attr_accessor :command

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['pr2_msgs/PeriodicCmd']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [pr2_msgs/PeriodicCmd] :command initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:command]
      @command = args[:command]
    else
      @command = Pr2_msgs::PeriodicCmd.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@command.header.seq, @command.header.stamp.secs, @command.header.stamp.nsecs))
      _x = @command.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @command.profile
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d3.pack(@command.period, @command.amplitude, @command.offset))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @command == nil
        @command = Pr2_msgs::PeriodicCmd.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@command.header.seq, @command.header.stamp.secs, @command.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @command.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @command.profile = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d3')
      (@command.period, @command.amplitude, @command.offset,) = @@struct_d3.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
# autogenerated by genrb from SetPeriodicCmdResponse.msg. Do not edit.
require 'ros/message'

require "ros/time"

module Pr2_msgs

class SetPeriodicCmdResponse <::ROS::Message
  def self.md5sum
    "3888666920054f1ef39d2df7a5d94b02"
  end

  def self.type
    "pr2_msgs/SetPeriodicCmdResponse"
  end

  def has_header?
    false
  end

  def message_definition
    "time start_time

"
  end
  attr_accessor :start_time

  @@struct_L2 = ::ROS::Struct.new("L2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['time']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [time] :start_time initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:start_time]
      @start_time = args[:start_time]
    else
      @start_time = ROS::Time.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L2.pack(@start_time.secs, @start_time.nsecs))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @start_time == nil
        @start_time = ROS::Time.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@start_time.secs, @start_time.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
module Pr2_msgs
class SetPeriodicCmd
  def self.type
    'pr2_msgs/SetPeriodicCmd'
  end
  def self.md5sum
    'daeb6e862b732192bc82a7ea52bb7975'
  end
  def self.request_class
    SetPeriodicCmdRequest
  end
  def self.response_class
    SetPeriodicCmdResponse
  end
end
end