# autogenerated by genrb from App.msg. Do not edit.
require 'ros/message'

require "rocon_app_manager_msgs/KeyValue"
require "rocon_app_manager_msgs/Icon"
require "rocon_app_manager_msgs/PairingClient"

module Rocon_app_manager_msgs

class App <::ROS::Message
  def self.md5sum
    "f7c3d8107b83b0a0871d32ad56957836"
  end

  def self.type
    "rocon_app_manager_msgs/App"
  end

  def has_header?
    false
  end

  def message_definition
    "# app name
string name
# user-friendly display name
string display_name
string description
string platform
string status

# icon for showing the app
Icon icon
#  ordered list (by preference) of pairing clients to interact with this robot app.
PairingClient[] pairing_clients
================================================================================
MSG: rocon_app_manager_msgs/Icon
# Image data format.  \"jpeg\" or \"png\"
string format

# Image data.
uint8[] data
================================================================================
MSG: rocon_app_manager_msgs/PairingClient
# like \"android\" or \"web\" or \"linux\"
string client_type

# like \"intent = ros.android.teleop\" and \"accelerometer = true\", used to choose which ClientApp to use
KeyValue[] manager_data

# parameters which just get passed through to the client app.
KeyValue[] app_data
================================================================================
MSG: rocon_app_manager_msgs/KeyValue
string key
string value
"
  end
  attr_accessor :name, :display_name, :description, :platform, :status, :icon, :pairing_clients


  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','string','string','string','string','rocon_app_manager_msgs/Icon','rocon_app_manager_msgs/PairingClient[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :name initialize value
  # @option args [string] :display_name initialize value
  # @option args [string] :description initialize value
  # @option args [string] :platform initialize value
  # @option args [string] :status initialize value
  # @option args [rocon_app_manager_msgs/Icon] :icon initialize value
  # @option args [rocon_app_manager_msgs/PairingClient[]] :pairing_clients initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
    if args[:display_name]
      @display_name = args[:display_name]
    else
      @display_name = ''
    end
    if args[:description]
      @description = args[:description]
    else
      @description = ''
    end
    if args[:platform]
      @platform = args[:platform]
    else
      @platform = ''
    end
    if args[:status]
      @status = args[:status]
    else
      @status = ''
    end
    if args[:icon]
      @icon = args[:icon]
    else
      @icon = Rocon_app_manager_msgs::Icon.new
    end
    if args[:pairing_clients]
      @pairing_clients = args[:pairing_clients]
    else
      @pairing_clients = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @display_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @description
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @platform
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @status
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @icon.format
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @icon.data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @pairing_clients.length
      buff.write(@@struct_L.pack(length))
      for val1 in @pairing_clients
        _x = val1.client_type
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.manager_data.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.manager_data
          _x = val2.key
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.value
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
        end
        length = val1.app_data.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.app_data
          _x = val2.key
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.value
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
        end
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @icon == nil
        @icon = Rocon_app_manager_msgs::Icon.new
      end
      if @pairing_clients == nil
        @pairing_clients = Rocon_app_manager_msgs::PairingClient[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @display_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @description = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @platform = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @status = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @icon.format = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @icon.data = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @pairing_clients = []
      length.times do
        val1 = Rocon_app_manager_msgs::PairingClient.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.client_type = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.manager_data = []
        length.times do
          val2 = Rocon_app_manager_msgs::KeyValue.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.key = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.value = str[start..(end_point-1)]
          val1.manager_data.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.app_data = []
        length.times do
          val2 = Rocon_app_manager_msgs::KeyValue.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.key = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.value = str[start..(end_point-1)]
          val1.app_data.push(val2)
        end
        @pairing_clients.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
