# autogenerated by genrb from Image.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"

module Sensor_msgs

class Image <::ROS::Message
  def self.md5sum
    "060021388200f6f0f447d0fcd9c64743"
  end

  def self.type
    "sensor_msgs/Image"
  end

  def has_header?
    true
  end

  def message_definition
    "# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in include/sensor_msgs/image_encodings.h

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  attr_accessor :header, :height, :width, :encoding, :is_bigendian, :step, :data

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_CL = ::ROS::Struct.new("CL")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','uint32','uint32','string','uint8','uint32','uint8[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [uint32] :height initialize value
  # @option args [uint32] :width initialize value
  # @option args [string] :encoding initialize value
  # @option args [uint8] :is_bigendian initialize value
  # @option args [uint32] :step initialize value
  # @option args [uint8[]] :data initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:height]
      @height = args[:height]
    else
      @height = 0
    end
    if args[:width]
      @width = args[:width]
    else
      @width = 0
    end
    if args[:encoding]
      @encoding = args[:encoding]
    else
      @encoding = ''
    end
    if args[:is_bigendian]
      @is_bigendian = args[:is_bigendian]
    else
      @is_bigendian = 0
    end
    if args[:step]
      @step = args[:step]
    else
      @step = 0
    end
    if args[:data]
      @data = args[:data]
    else
      @data = ''
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@height, @width))
      _x = @encoding
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_CL.pack(@is_bigendian, @step))
      _x = @data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@height, @width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @encoding = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('CL')
      (@is_bigendian, @step,) = @@struct_CL.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @data = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
