# autogenerated by genrb from Imu.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"

module Sensor_msgs

class Imu <::ROS::Message
  def self.md5sum
    "6a62c6daae103f4ff57a132d6f95cec2"
  end

  def self.type
    "sensor_msgs/Imu"
  end

  def has_header?
    true
  end

  def message_definition
    "# This is a message to hold data from an IMU (Inertial Measurement Unit)
#
# Accelerations should be in m/s^2 (not in g's), and rotational velocity should be in rad/sec
#
# If the covariance of the measurement is known, it should be filled in (if all you know is the 
# variance of each measurement, e.g. from the datasheet, just put those along the diagonal)
# A covariance matrix of all zeros will be interpreted as \"covariance unknown\", and to use the
# data a covariance will have to be assumed or gotten from some other source
#
# If you have no estimate for one of the data elements (e.g. your IMU doesn't produce an orientation 
# estimate), please set element 0 of the associated covariance matrix to -1
# If you are interpreting this message, please check for a value of -1 in the first element of each 
# covariance matrix, and disregard the associated estimate.

Header header

geometry_msgs/Quaternion orientation
float64[9] orientation_covariance # Row major about x, y, z axes

geometry_msgs/Vector3 angular_velocity
float64[9] angular_velocity_covariance # Row major about x, y, z axes

geometry_msgs/Vector3 linear_acceleration
float64[9] linear_acceleration_covariance # Row major x, y z 

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
"
  end
  attr_accessor :header, :orientation, :orientation_covariance, :angular_velocity, :angular_velocity_covariance, :linear_acceleration, :linear_acceleration_covariance

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d3 = ::ROS::Struct.new("d3")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_d9 = ::ROS::Struct.new("d9")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','geometry_msgs/Quaternion','float64[9]','geometry_msgs/Vector3','float64[9]','geometry_msgs/Vector3','float64[9]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [geometry_msgs/Quaternion] :orientation initialize value
  # @option args [float64[9]] :orientation_covariance initialize value
  # @option args [geometry_msgs/Vector3] :angular_velocity initialize value
  # @option args [float64[9]] :angular_velocity_covariance initialize value
  # @option args [geometry_msgs/Vector3] :linear_acceleration initialize value
  # @option args [float64[9]] :linear_acceleration_covariance initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:orientation]
      @orientation = args[:orientation]
    else
      @orientation = Geometry_msgs::Quaternion.new
    end
    if args[:orientation_covariance]
      @orientation_covariance = args[:orientation_covariance]
    else
      @orientation_covariance = [0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]
    end
    if args[:angular_velocity]
      @angular_velocity = args[:angular_velocity]
    else
      @angular_velocity = Geometry_msgs::Vector3.new
    end
    if args[:angular_velocity_covariance]
      @angular_velocity_covariance = args[:angular_velocity_covariance]
    else
      @angular_velocity_covariance = [0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]
    end
    if args[:linear_acceleration]
      @linear_acceleration = args[:linear_acceleration]
    else
      @linear_acceleration = Geometry_msgs::Vector3.new
    end
    if args[:linear_acceleration_covariance]
      @linear_acceleration_covariance = args[:linear_acceleration_covariance]
    else
      @linear_acceleration_covariance = [0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d4.pack(@orientation.x, @orientation.y, @orientation.z, @orientation.w))
      buff.write(@@struct_d9.pack(*@orientation_covariance))
      buff.write(@@struct_d3.pack(@angular_velocity.x, @angular_velocity.y, @angular_velocity.z))
      buff.write(@@struct_d9.pack(*@angular_velocity_covariance))
      buff.write(@@struct_d3.pack(@linear_acceleration.x, @linear_acceleration.y, @linear_acceleration.z))
      buff.write(@@struct_d9.pack(*@linear_acceleration_covariance))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @orientation == nil
        @orientation = Geometry_msgs::Quaternion.new
      end
      if @angular_velocity == nil
        @angular_velocity = Geometry_msgs::Vector3.new
      end
      if @linear_acceleration == nil
        @linear_acceleration = Geometry_msgs::Vector3.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d4')
      (@orientation.x, @orientation.y, @orientation.z, @orientation.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d9')
      @orientation_covariance = @@struct_d9.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d3')
      (@angular_velocity.x, @angular_velocity.y, @angular_velocity.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d9')
      @angular_velocity_covariance = @@struct_d9.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d3')
      (@linear_acceleration.x, @linear_acceleration.y, @linear_acceleration.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d9')
      @linear_acceleration_covariance = @@struct_d9.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
