# autogenerated by genrb from MultiDOFJointState.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Transform"
require "std_msgs/Header"
require "geometry_msgs/Twist"
require "geometry_msgs/Wrench"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"

module Sensor_msgs

class MultiDOFJointState <::ROS::Message
  def self.md5sum
    "690f272f0640d2631c305eeb8301e59d"
  end

  def self.type
    "sensor_msgs/MultiDOFJointState"
  end

  def has_header?
    true
  end

  def message_definition
    "# Representation of state for joints with multiple degrees of freedom, 
# following the structure of JointState.
#
# It is assumed that a joint in a system corresponds to a transform that gets applied 
# along the kinematic chain. For example, a planar joint (as in URDF) is 3DOF (x, y, yaw)
# and those 3DOF can be expressed as a transformation matrix, and that transformation
# matrix can be converted back to (x, y, yaw)
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# wrench associated with them, you can leave the wrench array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

Header header

string[] joint_names
geometry_msgs/Transform[] transforms
geometry_msgs/Twist[] twist
geometry_msgs/Wrench[] wrench

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

"
  end
  attr_accessor :header, :joint_names, :transforms, :twist, :wrench

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','string[]','geometry_msgs/Transform[]','geometry_msgs/Twist[]','geometry_msgs/Wrench[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [string[]] :joint_names initialize value
  # @option args [geometry_msgs/Transform[]] :transforms initialize value
  # @option args [geometry_msgs/Twist[]] :twist initialize value
  # @option args [geometry_msgs/Wrench[]] :wrench initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:joint_names]
      @joint_names = args[:joint_names]
    else
      @joint_names = []
    end
    if args[:transforms]
      @transforms = args[:transforms]
    else
      @transforms = []
    end
    if args[:twist]
      @twist = args[:twist]
    else
      @twist = []
    end
    if args[:wrench]
      @wrench = args[:wrench]
    else
      @wrench = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @transforms
        _v359 = val1.translation
        _x = _v359
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v360 = val1.rotation
        _x = _v360
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @twist
        _v361 = val1.linear
        _x = _v361
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v362 = val1.angular
        _x = _v362
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @wrench
        _v363 = val1.force
        _x = _v363
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v364 = val1.torque
        _x = _v364
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @transforms == nil
        @transforms = Geometry_msgs::Transform[].new
      end
      if @twist == nil
        @twist = Geometry_msgs::Twist[].new
      end
      if @wrench == nil
        @wrench = Geometry_msgs::Wrench[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v365 = val1.translation
        _x = _v365
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v366 = val1.rotation
        _x = _v366
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v367 = val1.linear
        _x = _v367
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v368 = val1.angular
        _x = _v368
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v369 = val1.force
        _x = _v369
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v370 = val1.torque
        _x = _v370
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @wrench.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
