# autogenerated by genrb from MultiEchoLaserScan.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "sensor_msgs/LaserEcho"

module Sensor_msgs

class MultiEchoLaserScan <::ROS::Message
  def self.md5sum
    "6fefb0c6da89d7c8abe4b339f5c2f8fb"
  end

  def self.type
    "sensor_msgs/MultiEchoLaserScan"
  end

  def has_header?
    true
  end

  def message_definition
    "# Single scan from a multi-echo planar laser range-finder
#
# If you have another ranging device with different behavior (e.g. a sonar
# array), please find or create a different message, since applications
# will make fairly laser-specific assumptions about this data

Header header            # timestamp in the header is the acquisition time of 
                         # the first ray in the scan.
                         #
                         # in frame frame_id, angles are measured around 
                         # the positive Z axis (counterclockwise, if Z is up)
                         # with zero angle being forward along the x axis
                         
float32 angle_min        # start angle of the scan [rad]
float32 angle_max        # end angle of the scan [rad]
float32 angle_increment  # angular distance between measurements [rad]

float32 time_increment   # time between measurements [seconds] - if your scanner
                         # is moving, this will be used in interpolating position
                         # of 3d points
float32 scan_time        # time between scans [seconds]

float32 range_min        # minimum range value [m]
float32 range_max        # maximum range value [m]

LaserEcho[] ranges       # range data [m] (Note: NaNs, values < range_min or > range_max should be discarded)
                         # +Inf measurements are out of range
                         # -Inf measurements are too close to determine exact distance.
LaserEcho[] intensities  # intensity data [device-specific units].  If your
                         # device does not provide intensities, please leave
                         # the array empty.
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/LaserEcho
# This message is a submessage of MultiEchoLaserScan and is not intended
# to be used separately.

float32[] echoes  # Multiple values of ranges or intensities.
                  # Each array represents data from the same angle increment.
"
  end
  attr_accessor :header, :angle_min, :angle_max, :angle_increment, :time_increment, :scan_time, :range_min, :range_max, :ranges, :intensities

  @@struct_f7 = ::ROS::Struct.new("f7")
  @@struct_L3 = ::ROS::Struct.new("L3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','float32','float32','float32','float32','float32','float32','float32','sensor_msgs/LaserEcho[]','sensor_msgs/LaserEcho[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [float32] :angle_min initialize value
  # @option args [float32] :angle_max initialize value
  # @option args [float32] :angle_increment initialize value
  # @option args [float32] :time_increment initialize value
  # @option args [float32] :scan_time initialize value
  # @option args [float32] :range_min initialize value
  # @option args [float32] :range_max initialize value
  # @option args [sensor_msgs/LaserEcho[]] :ranges initialize value
  # @option args [sensor_msgs/LaserEcho[]] :intensities initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:angle_min]
      @angle_min = args[:angle_min]
    else
      @angle_min = 0.0
    end
    if args[:angle_max]
      @angle_max = args[:angle_max]
    else
      @angle_max = 0.0
    end
    if args[:angle_increment]
      @angle_increment = args[:angle_increment]
    else
      @angle_increment = 0.0
    end
    if args[:time_increment]
      @time_increment = args[:time_increment]
    else
      @time_increment = 0.0
    end
    if args[:scan_time]
      @scan_time = args[:scan_time]
    else
      @scan_time = 0.0
    end
    if args[:range_min]
      @range_min = args[:range_min]
    else
      @range_min = 0.0
    end
    if args[:range_max]
      @range_max = args[:range_max]
    else
      @range_max = 0.0
    end
    if args[:ranges]
      @ranges = args[:ranges]
    else
      @ranges = []
    end
    if args[:intensities]
      @intensities = args[:intensities]
    else
      @intensities = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_f7.pack(@angle_min, @angle_max, @angle_increment, @time_increment, @scan_time, @range_min, @range_max))
      length = @ranges.length
      buff.write(@@struct_L.pack(length))
      for val1 in @ranges
        length = val1.echoes.length
        buff.write(@@struct_L.pack(length))
        pattern = "f#{length}"
        buff.write(*val1.echoes.pack(pattern))
      end
      length = @intensities.length
      buff.write(@@struct_L.pack(length))
      for val1 in @intensities
        length = val1.echoes.length
        buff.write(@@struct_L.pack(length))
        pattern = "f#{length}"
        buff.write(*val1.echoes.pack(pattern))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @ranges == nil
        @ranges = Sensor_msgs::LaserEcho[].new
      end
      if @intensities == nil
        @intensities = Sensor_msgs::LaserEcho[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('f7')
      (@angle_min, @angle_max, @angle_increment, @time_increment, @scan_time, @range_min, @range_max,) = @@struct_f7.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @ranges = []
      length.times do
        val1 = Sensor_msgs::LaserEcho.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "f#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.echoes = str[start..(end_point-1)].unpack(pattern)
        @ranges.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @intensities = []
      length.times do
        val1 = Sensor_msgs::LaserEcho.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "f#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.echoes = str[start..(end_point-1)].unpack(pattern)
        @intensities.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
