# autogenerated by genrb from NavSatFix.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "sensor_msgs/NavSatStatus"

module Sensor_msgs

class NavSatFix <::ROS::Message
  def self.md5sum
    "2d3a8cd499b9b4a0249fb98fd05cfa48"
  end

  def self.type
    "sensor_msgs/NavSatFix"
  end

  def has_header?
    true
  end

  def message_definition
    "# Navigation Satellite fix for any Global Navigation Satellite System
#
# Specified using the WGS 84 reference ellipsoid

# header.stamp specifies the ROS time for this measurement (the
#        corresponding satellite time may be reported using the
#        sensor_msgs/TimeReference message).
#
# header.frame_id is the frame of reference reported by the satellite
#        receiver, usually the location of the antenna.  This is a
#        Euclidean frame relative to the vehicle, not a reference
#        ellipsoid.
Header header

# satellite fix status information
NavSatStatus status

# Latitude [degrees]. Positive is north of equator; negative is south.
float64 latitude

# Longitude [degrees]. Positive is east of prime meridian; negative is west.
float64 longitude

# Altitude [m]. Positive is above the WGS 84 ellipsoid
# (quiet NaN if no altitude is available).
float64 altitude

# Position covariance [m^2] defined relative to a tangential plane
# through the reported position. The components are East, North, and
# Up (ENU), in row-major order.
#
# Beware: this coordinate system exhibits singularities at the poles.

float64[9] position_covariance

# If the covariance of the fix is known, fill it in completely. If the
# GPS receiver provides the variance of each measurement, put them
# along the diagonal. If only Dilution of Precision is available,
# estimate an approximate covariance from that.

uint8 COVARIANCE_TYPE_UNKNOWN = 0
uint8 COVARIANCE_TYPE_APPROXIMATED = 1
uint8 COVARIANCE_TYPE_DIAGONAL_KNOWN = 2
uint8 COVARIANCE_TYPE_KNOWN = 3

uint8 position_covariance_type

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/NavSatStatus
# Navigation Satellite fix status for any Global Navigation Satellite System

# Whether to output an augmented fix is determined by both the fix
# type and the last time differential corrections were received.  A
# fix is valid when status >= STATUS_FIX.

int8 STATUS_NO_FIX =  -1        # unable to fix position
int8 STATUS_FIX =      0        # unaugmented fix
int8 STATUS_SBAS_FIX = 1        # with satellite-based augmentation
int8 STATUS_GBAS_FIX = 2        # with ground-based augmentation

int8 status

# Bits defining which Global Navigation Satellite System signals were
# used by the receiver.

uint16 SERVICE_GPS =     1
uint16 SERVICE_GLONASS = 2
uint16 SERVICE_COMPASS = 4      # includes BeiDou.
uint16 SERVICE_GALILEO = 8

uint16 service

"
  end
  # Pseudo-constants
  COVARIANCE_TYPE_UNKNOWN = 0
  COVARIANCE_TYPE_APPROXIMATED = 1
  COVARIANCE_TYPE_DIAGONAL_KNOWN = 2
  COVARIANCE_TYPE_KNOWN = 3

  attr_accessor :header, :status, :latitude, :longitude, :altitude, :position_covariance, :position_covariance_type

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_cSd3 = ::ROS::Struct.new("cSd3")
  @@struct_d9 = ::ROS::Struct.new("d9")
  @@struct_C = ::ROS::Struct.new("C")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','sensor_msgs/NavSatStatus','float64','float64','float64','float64[9]','uint8']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [sensor_msgs/NavSatStatus] :status initialize value
  # @option args [float64] :latitude initialize value
  # @option args [float64] :longitude initialize value
  # @option args [float64] :altitude initialize value
  # @option args [float64[9]] :position_covariance initialize value
  # @option args [uint8] :position_covariance_type initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:status]
      @status = args[:status]
    else
      @status = Sensor_msgs::NavSatStatus.new
    end
    if args[:latitude]
      @latitude = args[:latitude]
    else
      @latitude = 0.0
    end
    if args[:longitude]
      @longitude = args[:longitude]
    else
      @longitude = 0.0
    end
    if args[:altitude]
      @altitude = args[:altitude]
    else
      @altitude = 0.0
    end
    if args[:position_covariance]
      @position_covariance = args[:position_covariance]
    else
      @position_covariance = [0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0]
    end
    if args[:position_covariance_type]
      @position_covariance_type = args[:position_covariance_type]
    else
      @position_covariance_type = 0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_cSd3.pack(@status.status, @status.service, @latitude, @longitude, @altitude))
      buff.write(@@struct_d9.pack(*@position_covariance))
      buff.write(@@struct_C.pack(@position_covariance_type))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @status == nil
        @status = Sensor_msgs::NavSatStatus.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('cSd3')
      (@status.status, @status.service, @latitude, @longitude, @altitude,) = @@struct_cSd3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d9')
      @position_covariance = @@struct_d9.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@position_covariance_type,) = @@struct_C.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
