# autogenerated by genrb from NavSatStatus.msg. Do not edit.
require 'ros/message'


module Sensor_msgs

class NavSatStatus <::ROS::Message
  def self.md5sum
    "331cdbddfa4bc96ffc3b9ad98900a54c"
  end

  def self.type
    "sensor_msgs/NavSatStatus"
  end

  def has_header?
    false
  end

  def message_definition
    "# Navigation Satellite fix status for any Global Navigation Satellite System

# Whether to output an augmented fix is determined by both the fix
# type and the last time differential corrections were received.  A
# fix is valid when status >= STATUS_FIX.

int8 STATUS_NO_FIX =  -1        # unable to fix position
int8 STATUS_FIX =      0        # unaugmented fix
int8 STATUS_SBAS_FIX = 1        # with satellite-based augmentation
int8 STATUS_GBAS_FIX = 2        # with ground-based augmentation

int8 status

# Bits defining which Global Navigation Satellite System signals were
# used by the receiver.

uint16 SERVICE_GPS =     1
uint16 SERVICE_GLONASS = 2
uint16 SERVICE_COMPASS = 4      # includes BeiDou.
uint16 SERVICE_GALILEO = 8

uint16 service

"
  end
  # Pseudo-constants
  STATUS_NO_FIX = -1
  STATUS_FIX = 0
  STATUS_SBAS_FIX = 1
  STATUS_GBAS_FIX = 2
  SERVICE_GPS = 1
  SERVICE_GLONASS = 2
  SERVICE_COMPASS = 4
  SERVICE_GALILEO = 8

  attr_accessor :status, :service

  @@struct_cS = ::ROS::Struct.new("cS")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['int8','uint16']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [int8] :status initialize value
  # @option args [uint16] :service initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:status]
      @status = args[:status]
    else
      @status = 0
    end
    if args[:service]
      @service = args[:service]
    else
      @service = 0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_cS.pack(@status, @service))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('cS')
      (@status, @service,) = @@struct_cS.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
