# autogenerated by genrb from Range.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"

module Sensor_msgs

class Range <::ROS::Message
  def self.md5sum
    "c005c34273dc426c67a020a87bc24148"
  end

  def self.type
    "sensor_msgs/Range"
  end

  def has_header?
    true
  end

  def message_definition
    "# Single range reading from an active ranger that emits energy and reports
# one range reading that is valid along an arc at the distance measured. 
# This message is  not appropriate for laser scanners. See the LaserScan
# message if you are working with a laser scanner.

# This message also can represent a fixed-distance (binary) ranger.  This
# sensor will have min_range===max_range===distance of detection.
# These sensors follow REP 117 and will output -Inf if the object is detected
# and +Inf if the object is outside of the detection range.

Header header           # timestamp in the header is the time the ranger
                        # returned the distance reading

# Radiation type enums
# If you want a value added to this list, send an email to the ros-users list
uint8 ULTRASOUND=0
uint8 INFRARED=1

uint8 radiation_type    # the type of radiation used by the sensor
                        # (sound, IR, etc) [enum]

float32 field_of_view   # the size of the arc that the distance reading is
                        # valid for [rad]
                        # the object causing the range reading may have
                        # been anywhere within -field_of_view/2 and
                        # field_of_view/2 at the measured range. 
                        # 0 angle corresponds to the x-axis of the sensor.

float32 min_range       # minimum range value [m]
float32 max_range       # maximum range value [m]
                        # Fixed distance rangers require min_range==max_range

float32 range           # range data [m]
                        # (Note: values < range_min or > range_max
                        # should be discarded)
                        # Fixed distance rangers only output -Inf or +Inf.
                        # -Inf represents a detection within fixed distance.
                        # (Detection too close to the sensor to quantify)
                        # +Inf represents no detection within the fixed distance.
                        # (Object out of range)
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  # Pseudo-constants
  ULTRASOUND = 0
  INFRARED = 1

  attr_accessor :header, :radiation_type, :field_of_view, :min_range, :max_range, :range

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_Cf4 = ::ROS::Struct.new("Cf4")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','uint8','float32','float32','float32','float32']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [uint8] :radiation_type initialize value
  # @option args [float32] :field_of_view initialize value
  # @option args [float32] :min_range initialize value
  # @option args [float32] :max_range initialize value
  # @option args [float32] :range initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:radiation_type]
      @radiation_type = args[:radiation_type]
    else
      @radiation_type = 0
    end
    if args[:field_of_view]
      @field_of_view = args[:field_of_view]
    else
      @field_of_view = 0.0
    end
    if args[:min_range]
      @min_range = args[:min_range]
    else
      @min_range = 0.0
    end
    if args[:max_range]
      @max_range = args[:max_range]
    else
      @max_range = 0.0
    end
    if args[:range]
      @range = args[:range]
    else
      @range = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_Cf4.pack(@radiation_type, @field_of_view, @min_range, @max_range, @range))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('Cf4')
      (@radiation_type, @field_of_view, @min_range, @max_range, @range,) = @@struct_Cf4.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
