# autogenerated by genrb from RegionOfInterest.msg. Do not edit.
require 'ros/message'


module Sensor_msgs

class RegionOfInterest <::ROS::Message
  def self.md5sum
    "bdb633039d588fcccb441a4d43ccfe09"
  end

  def self.type
    "sensor_msgs/RegionOfInterest"
  end

  def has_header?
    false
  end

  def message_definition
    "# This message is used to specify a region of interest within an image.
#
# When used to specify the ROI setting of the camera when the image was
# taken, the height and width fields should either match the height and
# width fields for the associated image; or height = width = 0
# indicates that the full resolution image was captured.

uint32 x_offset  # Leftmost pixel of the ROI
                 # (0 if the ROI includes the left edge of the image)
uint32 y_offset  # Topmost pixel of the ROI
                 # (0 if the ROI includes the top edge of the image)
uint32 height    # Height of ROI
uint32 width     # Width of ROI

# True if a distinct rectified ROI should be calculated from the \"raw\"
# ROI in this message. Typically this should be False if the full image
# is captured (ROI not used), and True if a subwindow is captured (ROI
# used).
bool do_rectify

"
  end
  attr_accessor :x_offset, :y_offset, :height, :width, :do_rectify

  @@struct_L4C = ::ROS::Struct.new("L4C")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['uint32','uint32','uint32','uint32','bool']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [uint32] :x_offset initialize value
  # @option args [uint32] :y_offset initialize value
  # @option args [uint32] :height initialize value
  # @option args [uint32] :width initialize value
  # @option args [bool] :do_rectify initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:x_offset]
      @x_offset = args[:x_offset]
    else
      @x_offset = 0
    end
    if args[:y_offset]
      @y_offset = args[:y_offset]
    else
      @y_offset = 0
    end
    if args[:height]
      @height = args[:height]
    else
      @height = 0
    end
    if args[:width]
      @width = args[:width]
    else
      @width = 0
    end
    if args[:do_rectify]
      @do_rectify = args[:do_rectify]
    else
      @do_rectify = false
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L4C.pack(@x_offset, @y_offset, @height, @width, @do_rectify))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L4C')
      (@x_offset, @y_offset, @height, @width, @do_rectify,) = @@struct_L4C.unpack(str[start..(end_point-1)])
      @do_rectify = bool(@do_rectify)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
