# autogenerated by genrb from TimeReference.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "ros/time"

module Sensor_msgs

class TimeReference <::ROS::Message
  def self.md5sum
    "fded64a0265108ba86c3d38fb11c0c16"
  end

  def self.type
    "sensor_msgs/TimeReference"
  end

  def has_header?
    true
  end

  def message_definition
    "# Measurement from an external time source not actively synchronized with the system clock.

Header header    # stamp is system time for which measurement was valid
                 # frame_id is not used 

time   time_ref  # corresponding time from this external source
string source    # (optional) name of time source

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  attr_accessor :header, :time_ref, :source

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_L2 = ::ROS::Struct.new("L2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','time','string']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [time] :time_ref initialize value
  # @option args [string] :source initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:time_ref]
      @time_ref = args[:time_ref]
    else
      @time_ref = ROS::Time.new
    end
    if args[:source]
      @source = args[:source]
    else
      @source = ''
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@time_ref.secs, @time_ref.nsecs))
      _x = @source
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @time_ref == nil
        @time_ref = ROS::Time.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@time_ref.secs, @time_ref.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @source = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
