# autogenerated by genrb from SolidPrimitive.msg. Do not edit.
require 'ros/message'


module Shape_msgs

class SolidPrimitive <::ROS::Message
  def self.md5sum
    "d8f8cbc74c5ff283fca29569ccefb45d"
  end

  def self.type
    "shape_msgs/SolidPrimitive"
  end

  def has_header?
    false
  end

  def message_definition
    "# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1

"
  end
  # Pseudo-constants
  BOX = 1
  SPHERE = 2
  CYLINDER = 3
  CONE = 4
  BOX_X = 0
  BOX_Y = 1
  BOX_Z = 2
  SPHERE_RADIUS = 0
  CYLINDER_HEIGHT = 0
  CYLINDER_RADIUS = 1
  CONE_HEIGHT = 0
  CONE_RADIUS = 1

  attr_accessor :type, :dimensions

  @@struct_C = ::ROS::Struct.new("C")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['uint8','float64[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [uint8] :type initialize value
  # @option args [float64[]] :dimensions initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:type]
      @type = args[:type]
    else
      @type = 0
    end
    if args[:dimensions]
      @dimensions = args[:dimensions]
    else
      @dimensions = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_C.pack(@type))
      length = @dimensions.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@dimensions.pack(pattern))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@type,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @dimensions = str[start..(end_point-1)].unpack(pattern)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
