# autogenerated by genrb from SmachContainerStatus.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"

module Smach_msgs

class SmachContainerStatus <::ROS::Message
  def self.md5sum
    "5ba2bb79ac19e3842d562a191f2a675b"
  end

  def self.type
    "smach_msgs/SmachContainerStatus"
  end

  def has_header?
    true
  end

  def message_definition
    "Header header

# The path to this node in the server
string path

# The initial state description
string[] initial_states

# The current state description
string[] active_states

# A pickled user data structure
string local_data

# Debugging info string
string info

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

"
  end
  attr_accessor :header, :path, :initial_states, :active_states, :local_data, :info

  @@struct_L3 = ::ROS::Struct.new("L3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','string','string[]','string[]','string','string']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [string] :path initialize value
  # @option args [string[]] :initial_states initialize value
  # @option args [string[]] :active_states initialize value
  # @option args [string] :local_data initialize value
  # @option args [string] :info initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:path]
      @path = args[:path]
    else
      @path = ''
    end
    if args[:initial_states]
      @initial_states = args[:initial_states]
    else
      @initial_states = []
    end
    if args[:active_states]
      @active_states = args[:active_states]
    else
      @active_states = []
    end
    if args[:local_data]
      @local_data = args[:local_data]
    else
      @local_data = ''
    end
    if args[:info]
      @info = args[:info]
    else
      @info = ''
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @path
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @initial_states.length
      buff.write(@@struct_L.pack(length))
      for val1 in @initial_states
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @active_states.length
      buff.write(@@struct_L.pack(length))
      for val1 in @active_states
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      _x = @local_data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @info
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @path = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @initial_states = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @initial_states.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @active_states = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @active_states.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @local_data = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @info = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
