# autogenerated by genrb from TCATState.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "sr_ronex_msgs/ImpulseSample"
require "sr_ronex_msgs/ReceiverData"

module Sr_ronex_msgs

class TCATState <::ROS::Message
  def self.md5sum
    "111c06a71da4f225240b922d7dd93b63"
  end

  def self.type
    "sr_ronex_msgs/TCATState"
  end

  def has_header?
    true
  end

  def message_definition
    "Header header

#digital and analogue contain either 6 or 12 elements depending on whether
# a stacker board is attached to the RoNeX or not.
uint16 sequence_number
sr_ronex_msgs/ReceiverData[4] received_data

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sr_ronex_msgs/ReceiverData
bool data_received
uint16[] reserved
sr_ronex_msgs/ImpulseSample[] impulse_response
uint16 first_sample_number
uint16[] payload
uint32 rx_frame_information
uint16 std_noise
uint32 flags
float32 FPI
float64 timestamp_ns

================================================================================
MSG: sr_ronex_msgs/ImpulseSample
int16 real
int16 imaginary

"
  end
  attr_accessor :header, :sequence_number, :received_data

  @@struct_LSLfd = ::ROS::Struct.new("LSLfd")
  @@struct_S = ::ROS::Struct.new("S")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_s2 = ::ROS::Struct.new("s2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','uint16','sr_ronex_msgs/ReceiverData[4]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [uint16] :sequence_number initialize value
  # @option args [sr_ronex_msgs/ReceiverData[4]] :received_data initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:sequence_number]
      @sequence_number = args[:sequence_number]
    else
      @sequence_number = 0
    end
    if args[:received_data]
      @received_data = args[:received_data]
    else
      @received_data = [Sr_ronex_msgs::ReceiverData.new,Sr_ronex_msgs::ReceiverData.new,Sr_ronex_msgs::ReceiverData.new,Sr_ronex_msgs::ReceiverData.new]
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_S.pack(@sequence_number))
      for val1 in @received_data
        buff.write(@@struct_C.pack(val1.data_received))
        length = val1.reserved.length
        buff.write(@@struct_L.pack(length))
        pattern = "S#{length}"
        buff.write(*val1.reserved.pack(pattern))
        length = val1.impulse_response.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.impulse_response
          _x = val2
          buff.write(@@struct_s2.pack(_x.real, _x.imaginary))
        end
        buff.write(@@struct_S.pack(val1.first_sample_number))
        length = val1.payload.length
        buff.write(@@struct_L.pack(length))
        pattern = "S#{length}"
        buff.write(*val1.payload.pack(pattern))
        _x = val1
        buff.write(@@struct_LSLfd.pack(_x.rx_frame_information, _x.std_noise, _x.flags, _x.FPI, _x.timestamp_ns))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @received_data == nil
        @received_data = Sr_ronex_msgs::ReceiverData[4].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('S')
      (@sequence_number,) = @@struct_S.unpack(str[start..(end_point-1)])
      @received_data = []
      4.times do
        val1 = Sr_ronex_msgs::ReceiverData.new
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (val1.data_received,) = @@struct_C.unpack(str[start..(end_point-1)])
        val1.data_received = bool(val1.data_received)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "S#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.reserved = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.impulse_response = []
        length.times do
          val2 = Sr_ronex_msgs::ImpulseSample.new
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('s2')
          (_x.real, _x.imaginary,) = @@struct_s2.unpack(str[start..(end_point-1)])
          val1.impulse_response.push(val2)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('S')
        (val1.first_sample_number,) = @@struct_S.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "S#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.payload = str[start..(end_point-1)].unpack(pattern)
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('LSLfd')
        (_x.rx_frame_information, _x.std_noise, _x.flags, _x.FPI, _x.timestamp_ns,) = @@struct_LSLfd.unpack(str[start..(end_point-1)])
        @received_data.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
