# autogenerated by genrb from DisparityImage.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "sensor_msgs/RegionOfInterest"
require "sensor_msgs/Image"

module Stereo_msgs

class DisparityImage <::ROS::Message
  def self.md5sum
    "04a177815f75271039fa21f16acad8c9"
  end

  def self.type
    "stereo_msgs/DisparityImage"
  end

  def has_header?
    true
  end

  def message_definition
    "# Separate header for compatibility with current TimeSynchronizer.
# Likely to be removed in a later release, use image.header instead.
Header header

# Floating point disparity image. The disparities are pre-adjusted for any
# x-offset between the principal points of the two cameras (in the case
# that they are verged). That is: d = x_l - x_r - (cx_l - cx_r)
sensor_msgs/Image image

# Stereo geometry. For disparity d, the depth from the camera is Z = fT/d.
float32 f # Focal length, pixels
float32 T # Baseline, world units

# Subwindow of (potentially) valid disparity values.
sensor_msgs/RegionOfInterest valid_window

# The range of disparities searched.
# In the disparity image, any disparity less than min_disparity is invalid.
# The disparity search range defines the horopter, or 3D volume that the
# stereo algorithm can \"see\". Points with Z outside of:
#     Z_min = fT / max_disparity
#     Z_max = fT / min_disparity
# could not be found.
float32 min_disparity
float32 max_disparity

# Smallest allowed disparity increment. The smallest achievable depth range
# resolution is delta_Z = (Z^2/fT)*delta_d.
float32 delta_d

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/Image
# This message contains an uncompressed image
# (0, 0) is at top-left corner of image
#

Header header        # Header timestamp should be acquisition time of image
                     # Header frame_id should be optical frame of camera
                     # origin of frame should be optical center of cameara
                     # +x should point to the right in the image
                     # +y should point down in the image
                     # +z should point into to plane of the image
                     # If the frame_id here and the frame_id of the CameraInfo
                     # message associated with the image conflict
                     # the behavior is undefined

uint32 height         # image height, that is, number of rows
uint32 width          # image width, that is, number of columns

# The legal values for encoding are in file src/image_encodings.cpp
# If you want to standardize a new string format, join
# ros-users@lists.sourceforge.net and send an email proposing a new encoding.

string encoding       # Encoding of pixels -- channel meaning, ordering, size
                      # taken from the list of strings in include/sensor_msgs/image_encodings.h

uint8 is_bigendian    # is this data bigendian?
uint32 step           # Full row length in bytes
uint8[] data          # actual matrix data, size is (step * rows)

================================================================================
MSG: sensor_msgs/RegionOfInterest
# This message is used to specify a region of interest within an image.
#
# When used to specify the ROI setting of the camera when the image was
# taken, the height and width fields should either match the height and
# width fields for the associated image; or height = width = 0
# indicates that the full resolution image was captured.

uint32 x_offset  # Leftmost pixel of the ROI
                 # (0 if the ROI includes the left edge of the image)
uint32 y_offset  # Topmost pixel of the ROI
                 # (0 if the ROI includes the top edge of the image)
uint32 height    # Height of ROI
uint32 width     # Width of ROI

# True if a distinct rectified ROI should be calculated from the \"raw\"
# ROI in this message. Typically this should be False if the full image
# is captured (ROI not used), and True if a subwindow is captured (ROI
# used).
bool do_rectify

"
  end
  attr_accessor :header, :image, :f, :T, :valid_window, :min_disparity, :max_disparity, :delta_d

  @@struct_f2L4Cf3 = ::ROS::Struct.new("f2L4Cf3")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_CL = ::ROS::Struct.new("CL")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','sensor_msgs/Image','float32','float32','sensor_msgs/RegionOfInterest','float32','float32','float32']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [sensor_msgs/Image] :image initialize value
  # @option args [float32] :f initialize value
  # @option args [float32] :T initialize value
  # @option args [sensor_msgs/RegionOfInterest] :valid_window initialize value
  # @option args [float32] :min_disparity initialize value
  # @option args [float32] :max_disparity initialize value
  # @option args [float32] :delta_d initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:image]
      @image = args[:image]
    else
      @image = Sensor_msgs::Image.new
    end
    if args[:f]
      @f = args[:f]
    else
      @f = 0.0
    end
    if args[:T]
      @T = args[:T]
    else
      @T = 0.0
    end
    if args[:valid_window]
      @valid_window = args[:valid_window]
    else
      @valid_window = Sensor_msgs::RegionOfInterest.new
    end
    if args[:min_disparity]
      @min_disparity = args[:min_disparity]
    else
      @min_disparity = 0.0
    end
    if args[:max_disparity]
      @max_disparity = args[:max_disparity]
    else
      @max_disparity = 0.0
    end
    if args[:delta_d]
      @delta_d = args[:delta_d]
    else
      @delta_d = 0.0
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@image.header.seq, @image.header.stamp.secs, @image.header.stamp.nsecs))
      _x = @image.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@image.height, @image.width))
      _x = @image.encoding
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_CL.pack(@image.is_bigendian, @image.step))
      _x = @image.data
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_f2L4Cf3.pack(@f, @T, @valid_window.x_offset, @valid_window.y_offset, @valid_window.height, @valid_window.width, @valid_window.do_rectify, @min_disparity, @max_disparity, @delta_d))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @image == nil
        @image = Sensor_msgs::Image.new
      end
      if @valid_window == nil
        @valid_window = Sensor_msgs::RegionOfInterest.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@image.header.seq, @image.header.stamp.secs, @image.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @image.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@image.height, @image.width,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @image.encoding = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('CL')
      (@image.is_bigendian, @image.step,) = @@struct_CL.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @image.data = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('f2L4Cf3')
      (@f, @T, @valid_window.x_offset, @valid_window.y_offset, @valid_window.height, @valid_window.width, @valid_window.do_rectify, @min_disparity, @max_disparity, @delta_d,) = @@struct_f2L4Cf3.unpack(str[start..(end_point-1)])
      @valid_window.do_rectify = bool(@valid_window.do_rectify)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
