# autogenerated by genrb from LookupTransformAction.msg. Do not edit.
require 'ros/message'

require "tf2_msgs/LookupTransformFeedback"
require "ros/time"
require "tf2_msgs/LookupTransformActionFeedback"
require "tf2_msgs/LookupTransformActionGoal"
require "tf2_msgs/LookupTransformGoal"
require "tf2_msgs/TF2Error"
require "ros/duration"
require "tf2_msgs/LookupTransformResult"
require "geometry_msgs/TransformStamped"
require "std_msgs/Header"
require "actionlib_msgs/GoalID"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Transform"
require "actionlib_msgs/GoalStatus"
require "tf2_msgs/LookupTransformActionResult"
require "geometry_msgs/Vector3"

module Tf2_msgs

class LookupTransformAction <::ROS::Message
  def self.md5sum
    "7ee01ba91a56c2245c610992dbaa3c37"
  end

  def self.type
    "tf2_msgs/LookupTransformAction"
  end

  def has_header?
    false
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

LookupTransformActionGoal action_goal
LookupTransformActionResult action_result
LookupTransformActionFeedback action_feedback

================================================================================
MSG: tf2_msgs/LookupTransformActionGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalID goal_id
LookupTransformGoal goal

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: tf2_msgs/LookupTransformGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
#Simple API
string target_frame
string source_frame
time source_time
duration timeout

#Advanced API
time target_time
string fixed_frame

#Whether or not to use the advanced API
bool advanced


================================================================================
MSG: tf2_msgs/LookupTransformActionResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
LookupTransformResult result

================================================================================
MSG: actionlib_msgs/GoalStatus
GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: tf2_msgs/LookupTransformResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
geometry_msgs/TransformStamped transform
tf2_msgs/TF2Error error

================================================================================
MSG: geometry_msgs/TransformStamped
# This expresses a transform from coordinate frame header.frame_id
# to the coordinate frame child_frame_id
#
# This message is mostly used by the 
# <a href=\"http://www.ros.org/wiki/tf\">tf</a> package. 
# See its documentation for more information.

Header header
string child_frame_id # the frame id of the child frame
Transform transform

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: tf2_msgs/TF2Error
uint8 NO_ERROR = 0
uint8 LOOKUP_ERROR = 1
uint8 CONNECTIVITY_ERROR = 2
uint8 EXTRAPOLATION_ERROR = 3
uint8 INVALID_ARGUMENT_ERROR = 4
uint8 TIMEOUT_ERROR = 5
uint8 TRANSFORM_ERROR = 6

uint8 error
string error_string

================================================================================
MSG: tf2_msgs/LookupTransformActionFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
LookupTransformFeedback feedback

================================================================================
MSG: tf2_msgs/LookupTransformFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======


"
  end
  attr_accessor :action_goal, :action_result, :action_feedback

  @@struct_d7C = ::ROS::Struct.new("d7C")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_CL3 = ::ROS::Struct.new("CL3")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_L2l2L2 = ::ROS::Struct.new("L2l2L2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['tf2_msgs/LookupTransformActionGoal','tf2_msgs/LookupTransformActionResult','tf2_msgs/LookupTransformActionFeedback']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [tf2_msgs/LookupTransformActionGoal] :action_goal initialize value
  # @option args [tf2_msgs/LookupTransformActionResult] :action_result initialize value
  # @option args [tf2_msgs/LookupTransformActionFeedback] :action_feedback initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:action_goal]
      @action_goal = args[:action_goal]
    else
      @action_goal = Tf2_msgs::LookupTransformActionGoal.new
    end
    if args[:action_result]
      @action_result = args[:action_result]
    else
      @action_result = Tf2_msgs::LookupTransformActionResult.new
    end
    if args[:action_feedback]
      @action_feedback = args[:action_feedback]
    else
      @action_feedback = Tf2_msgs::LookupTransformActionFeedback.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@action_goal.header.seq, @action_goal.header.stamp.secs, @action_goal.header.stamp.nsecs))
      _x = @action_goal.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_goal.goal_id.stamp.secs, @action_goal.goal_id.stamp.nsecs))
      _x = @action_goal.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @action_goal.goal.target_frame
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @action_goal.goal.source_frame
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2l2L2.pack(@action_goal.goal.source_time.secs, @action_goal.goal.source_time.nsecs, @action_goal.goal.timeout.secs, @action_goal.goal.timeout.nsecs, @action_goal.goal.target_time.secs, @action_goal.goal.target_time.nsecs))
      _x = @action_goal.goal.fixed_frame
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_CL3.pack(@action_goal.goal.advanced, @action_result.header.seq, @action_result.header.stamp.secs, @action_result.header.stamp.nsecs))
      _x = @action_result.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_result.status.goal_id.stamp.secs, @action_result.status.goal_id.stamp.nsecs))
      _x = @action_result.status.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_result.status.status))
      _x = @action_result.status.text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@action_result.result.transform.header.seq, @action_result.result.transform.header.stamp.secs, @action_result.result.transform.header.stamp.nsecs))
      _x = @action_result.result.transform.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @action_result.result.transform.child_frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7C.pack(@action_result.result.transform.transform.translation.x, @action_result.result.transform.transform.translation.y, @action_result.result.transform.transform.translation.z, @action_result.result.transform.transform.rotation.x, @action_result.result.transform.transform.rotation.y, @action_result.result.transform.transform.rotation.z, @action_result.result.transform.transform.rotation.w, @action_result.result.error.error))
      _x = @action_result.result.error.error_string
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@action_feedback.header.seq, @action_feedback.header.stamp.secs, @action_feedback.header.stamp.nsecs))
      _x = @action_feedback.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_feedback.status.goal_id.stamp.secs, @action_feedback.status.goal_id.stamp.nsecs))
      _x = @action_feedback.status.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_feedback.status.status))
      _x = @action_feedback.status.text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @action_goal == nil
        @action_goal = Tf2_msgs::LookupTransformActionGoal.new
      end
      if @action_result == nil
        @action_result = Tf2_msgs::LookupTransformActionResult.new
      end
      if @action_feedback == nil
        @action_feedback = Tf2_msgs::LookupTransformActionFeedback.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.header.seq, @action_goal.header.stamp.secs, @action_goal.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_goal.goal_id.stamp.secs, @action_goal.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.target_frame = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.source_frame = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2l2L2')
      (@action_goal.goal.source_time.secs, @action_goal.goal.source_time.nsecs, @action_goal.goal.timeout.secs, @action_goal.goal.timeout.nsecs, @action_goal.goal.target_time.secs, @action_goal.goal.target_time.nsecs,) = @@struct_L2l2L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.fixed_frame = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('CL3')
      (@action_goal.goal.advanced, @action_result.header.seq, @action_result.header.stamp.secs, @action_result.header.stamp.nsecs,) = @@struct_CL3.unpack(str[start..(end_point-1)])
      @action_goal.goal.advanced = bool(@action_goal.goal.advanced)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_result.status.goal_id.stamp.secs, @action_result.status.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.status.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_result.status.status,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.status.text = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_result.result.transform.header.seq, @action_result.result.transform.header.stamp.secs, @action_result.result.transform.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.transform.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.transform.child_frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7C')
      (@action_result.result.transform.transform.translation.x, @action_result.result.transform.transform.translation.y, @action_result.result.transform.transform.translation.z, @action_result.result.transform.transform.rotation.x, @action_result.result.transform.transform.rotation.y, @action_result.result.transform.transform.rotation.z, @action_result.result.transform.transform.rotation.w, @action_result.result.error.error,) = @@struct_d7C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.error.error_string = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_feedback.header.seq, @action_feedback.header.stamp.secs, @action_feedback.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_feedback.status.goal_id.stamp.secs, @action_feedback.status.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.status.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_feedback.status.status,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.status.text = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
