# autogenerated by genrb from LookupTransformResult.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/Transform"
require "geometry_msgs/TransformStamped"
require "std_msgs/Header"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "tf2_msgs/TF2Error"

module Tf2_msgs

class LookupTransformResult <::ROS::Message
  def self.md5sum
    "3fe5db6a19ca9cfb675418c5ad875c36"
  end

  def self.type
    "tf2_msgs/LookupTransformResult"
  end

  def has_header?
    false
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
geometry_msgs/TransformStamped transform
tf2_msgs/TF2Error error

================================================================================
MSG: geometry_msgs/TransformStamped
# This expresses a transform from coordinate frame header.frame_id
# to the coordinate frame child_frame_id
#
# This message is mostly used by the 
# <a href=\"http://www.ros.org/wiki/tf\">tf</a> package. 
# See its documentation for more information.

Header header
string child_frame_id # the frame id of the child frame
Transform transform

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: tf2_msgs/TF2Error
uint8 NO_ERROR = 0
uint8 LOOKUP_ERROR = 1
uint8 CONNECTIVITY_ERROR = 2
uint8 EXTRAPOLATION_ERROR = 3
uint8 INVALID_ARGUMENT_ERROR = 4
uint8 TIMEOUT_ERROR = 5
uint8 TRANSFORM_ERROR = 6

uint8 error
string error_string

"
  end
  attr_accessor :transform, :error

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_d7C = ::ROS::Struct.new("d7C")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['geometry_msgs/TransformStamped','tf2_msgs/TF2Error']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [geometry_msgs/TransformStamped] :transform initialize value
  # @option args [tf2_msgs/TF2Error] :error initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:transform]
      @transform = args[:transform]
    else
      @transform = Geometry_msgs::TransformStamped.new
    end
    if args[:error]
      @error = args[:error]
    else
      @error = Tf2_msgs::TF2Error.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@transform.header.seq, @transform.header.stamp.secs, @transform.header.stamp.nsecs))
      _x = @transform.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @transform.child_frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7C.pack(@transform.transform.translation.x, @transform.transform.translation.y, @transform.transform.translation.z, @transform.transform.rotation.x, @transform.transform.rotation.y, @transform.transform.rotation.z, @transform.transform.rotation.w, @error.error))
      _x = @error.error_string
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @transform == nil
        @transform = Geometry_msgs::TransformStamped.new
      end
      if @error == nil
        @error = Tf2_msgs::TF2Error.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@transform.header.seq, @transform.header.stamp.secs, @transform.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @transform.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @transform.child_frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7C')
      (@transform.transform.translation.x, @transform.transform.translation.y, @transform.transform.translation.z, @transform.transform.rotation.x, @transform.transform.rotation.y, @transform.transform.rotation.z, @transform.transform.rotation.w, @error.error,) = @@struct_d7C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @error.error_string = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
