# autogenerated by genrb from TFMessage.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "geometry_msgs/Transform"
require "geometry_msgs/TransformStamped"

module Tf2_msgs

class TFMessage <::ROS::Message
  def self.md5sum
    "94810edda583a504dfda3829e70d7eec"
  end

  def self.type
    "tf2_msgs/TFMessage"
  end

  def has_header?
    false
  end

  def message_definition
    "geometry_msgs/TransformStamped[] transforms

================================================================================
MSG: geometry_msgs/TransformStamped
# This expresses a transform from coordinate frame header.frame_id
# to the coordinate frame child_frame_id
#
# This message is mostly used by the 
# <a href=\"http://www.ros.org/wiki/tf\">tf</a> package. 
# See its documentation for more information.

Header header
string child_frame_id # the frame id of the child frame
Transform transform

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :transforms

  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['geometry_msgs/TransformStamped[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [geometry_msgs/TransformStamped[]] :transforms initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:transforms]
      @transforms = args[:transforms]
    else
      @transforms = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      length = @transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @transforms
        _v181 = val1.header
        buff.write(@@struct_L.pack(_v181.seq))
        _v182 = _v181.stamp
        _x = _v182
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v181.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.child_frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v183 = val1.transform
        _v184 = _v183.translation
        _x = _v184
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v185 = _v183.rotation
        _x = _v185
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @transforms == nil
        @transforms = Geometry_msgs::TransformStamped[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @transforms = []
      length.times do
        val1 = Geometry_msgs::TransformStamped.new
        _v186 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v186.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v187 = _v186.stamp
        _x = _v187
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v186.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.child_frame_id = str[start..(end_point-1)]
        _v188 = val1.transform
        _v189 = _v188.translation
        _x = _v189
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v190 = _v188.rotation
        _x = _v190
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @transforms.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
