# autogenerated by genrb from VelodyneScan.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "velodyne_msgs/VelodynePacket"
require "ros/time"

module Velodyne_msgs

class VelodyneScan <::ROS::Message
  def self.md5sum
    "50804fc9533a0e579e6322c04ae70566"
  end

  def self.type
    "velodyne_msgs/VelodyneScan"
  end

  def has_header?
    true
  end

  def message_definition
    "# Velodyne LIDAR scan packets.

Header           header         # standard ROS message header
VelodynePacket[] packets        # vector of raw packets

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: velodyne_msgs/VelodynePacket
# Raw Velodyne LIDAR packet.

time stamp              # packet timestamp
uint8[1206] data        # packet contents


"
  end
  attr_accessor :header, :packets

  @@struct_C1206 = ::ROS::Struct.new("C1206")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_L2 = ::ROS::Struct.new("L2")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','velodyne_msgs/VelodynePacket[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [velodyne_msgs/VelodynePacket[]] :packets initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:packets]
      @packets = args[:packets]
    else
      @packets = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @packets.length
      buff.write(@@struct_L.pack(length))
      for val1 in @packets
        _v201 = val1.stamp
        _x = _v201
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = val1.data
        buff.write(@@struct_C1206.pack(_x))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @packets == nil
        @packets = Velodyne_msgs::VelodynePacket[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @packets = []
      length.times do
        val1 = Velodyne_msgs::VelodynePacket.new
        _v202 = val1.stamp
        _x = _v202
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 1206
        val1.data = str[start..(end_point-1)]
        @packets.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
