# autogenerated by genrb from ImageMarker.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "std_msgs/ColorRGBA"
require "geometry_msgs/Point"
require "ros/duration"

module Visualization_msgs

class ImageMarker <::ROS::Message
  def self.md5sum
    "1de93c67ec8858b831025a08fbf1b35c"
  end

  def self.type
    "visualization_msgs/ImageMarker"
  end

  def has_header?
    true
  end

  def message_definition
    "uint8 CIRCLE=0
uint8 LINE_STRIP=1
uint8 LINE_LIST=2
uint8 POLYGON=3
uint8 POINTS=4

uint8 ADD=0
uint8 REMOVE=1

Header header
string ns		# namespace, used with id to form a unique id
int32 id          	# unique id within the namespace
int32 type        	# CIRCLE/LINE_STRIP/etc.
int32 action      	# ADD/REMOVE
geometry_msgs/Point position # 2D, in pixel-coords
float32 scale	 	# the diameter for a circle, etc.
std_msgs/ColorRGBA outline_color
uint8 filled		# whether to fill in the shape with color
std_msgs/ColorRGBA fill_color # color [0.0-1.0]
duration lifetime       # How long the object should last before being automatically deleted.  0 means forever


geometry_msgs/Point[] points # used for LINE_STRIP/LINE_LIST/POINTS/etc., 2D in pixel coords
std_msgs/ColorRGBA[] outline_colors # a color for each line, point, etc.
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

"
  end
  # Pseudo-constants
  CIRCLE = 0
  LINE_STRIP = 1
  LINE_LIST = 2
  POLYGON = 3
  POINTS = 4
  ADD = 0
  REMOVE = 1

  attr_accessor :header, :ns, :id, :type, :action, :position, :scale, :outline_color, :filled, :fill_color, :lifetime, :points, :outline_colors

  @@struct_f4 = ::ROS::Struct.new("f4")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_l3d3f5Cf4l2 = ::ROS::Struct.new("l3d3f5Cf4l2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','string','int32','int32','int32','geometry_msgs/Point','float32','std_msgs/ColorRGBA','uint8','std_msgs/ColorRGBA','duration','geometry_msgs/Point[]','std_msgs/ColorRGBA[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [string] :ns initialize value
  # @option args [int32] :id initialize value
  # @option args [int32] :type initialize value
  # @option args [int32] :action initialize value
  # @option args [geometry_msgs/Point] :position initialize value
  # @option args [float32] :scale initialize value
  # @option args [std_msgs/ColorRGBA] :outline_color initialize value
  # @option args [uint8] :filled initialize value
  # @option args [std_msgs/ColorRGBA] :fill_color initialize value
  # @option args [duration] :lifetime initialize value
  # @option args [geometry_msgs/Point[]] :points initialize value
  # @option args [std_msgs/ColorRGBA[]] :outline_colors initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:ns]
      @ns = args[:ns]
    else
      @ns = ''
    end
    if args[:id]
      @id = args[:id]
    else
      @id = 0
    end
    if args[:type]
      @type = args[:type]
    else
      @type = 0
    end
    if args[:action]
      @action = args[:action]
    else
      @action = 0
    end
    if args[:position]
      @position = args[:position]
    else
      @position = Geometry_msgs::Point.new
    end
    if args[:scale]
      @scale = args[:scale]
    else
      @scale = 0.0
    end
    if args[:outline_color]
      @outline_color = args[:outline_color]
    else
      @outline_color = Std_msgs::ColorRGBA.new
    end
    if args[:filled]
      @filled = args[:filled]
    else
      @filled = 0
    end
    if args[:fill_color]
      @fill_color = args[:fill_color]
    else
      @fill_color = Std_msgs::ColorRGBA.new
    end
    if args[:lifetime]
      @lifetime = args[:lifetime]
    else
      @lifetime = ROS::Duration.new
    end
    if args[:points]
      @points = args[:points]
    else
      @points = []
    end
    if args[:outline_colors]
      @outline_colors = args[:outline_colors]
    else
      @outline_colors = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @ns
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_l3d3f5Cf4l2.pack(@id, @type, @action, @position.x, @position.y, @position.z, @scale, @outline_color.r, @outline_color.g, @outline_color.b, @outline_color.a, @filled, @fill_color.r, @fill_color.g, @fill_color.b, @fill_color.a, @lifetime.secs, @lifetime.nsecs))
      length = @points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @points
        _x = val1
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @outline_colors.length
      buff.write(@@struct_L.pack(length))
      for val1 in @outline_colors
        _x = val1
        buff.write(@@struct_f4.pack(_x.r, _x.g, _x.b, _x.a))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @position == nil
        @position = Geometry_msgs::Point.new
      end
      if @outline_color == nil
        @outline_color = Std_msgs::ColorRGBA.new
      end
      if @fill_color == nil
        @fill_color = Std_msgs::ColorRGBA.new
      end
      if @lifetime == nil
        @lifetime = ROS::Duration.new
      end
      if @points == nil
        @points = Geometry_msgs::Point[].new
      end
      if @outline_colors == nil
        @outline_colors = Std_msgs::ColorRGBA[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @ns = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('l3d3f5Cf4l2')
      (@id, @type, @action, @position.x, @position.y, @position.z, @scale, @outline_color.r, @outline_color.g, @outline_color.b, @outline_color.a, @filled, @fill_color.r, @fill_color.g, @fill_color.b, @fill_color.a, @lifetime.secs, @lifetime.nsecs,) = @@struct_l3d3f5Cf4l2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @points = []
      length.times do
        val1 = Geometry_msgs::Point.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @points.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @outline_colors = []
      length.times do
        val1 = Std_msgs::ColorRGBA.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('f4')
        (_x.r, _x.g, _x.b, _x.a,) = @@struct_f4.unpack(str[start..(end_point-1)])
        @outline_colors.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
