# autogenerated by genrb from InteractiveMarkerControl.msg. Do not edit.
require 'ros/message'

require "visualization_msgs/Marker"
require "ros/duration"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "std_msgs/ColorRGBA"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "geometry_msgs/Pose"

module Visualization_msgs

class InteractiveMarkerControl <::ROS::Message
  def self.md5sum
    "e3a939c98cdd4f709d8e1dec2a9c3f37"
  end

  def self.type
    "visualization_msgs/InteractiveMarkerControl"
  end

  def has_header?
    false
  end

  def message_definition
    "# Represents a control that is to be displayed together with an interactive marker

# Identifying string for this control.
# You need to assign a unique value to this to receive feedback from the GUI
# on what actions the user performs on this control (e.g. a button click).
string name


# Defines the local coordinate frame (relative to the pose of the parent
# interactive marker) in which is being rotated and translated.
# Default: Identity
geometry_msgs/Quaternion orientation


# Orientation mode: controls how orientation changes.
# INHERIT: Follow orientation of interactive marker
# FIXED: Keep orientation fixed at initial state
# VIEW_FACING: Align y-z plane with screen (x: forward, y:left, z:up).
uint8 INHERIT = 0 
uint8 FIXED = 1
uint8 VIEW_FACING = 2

uint8 orientation_mode

# Interaction mode for this control
# 
# NONE: This control is only meant for visualization; no context menu.
# MENU: Like NONE, but right-click menu is active.
# BUTTON: Element can be left-clicked.
# MOVE_AXIS: Translate along local x-axis.
# MOVE_PLANE: Translate in local y-z plane.
# ROTATE_AXIS: Rotate around local x-axis.
# MOVE_ROTATE: Combines MOVE_PLANE and ROTATE_AXIS.
uint8 NONE = 0 
uint8 MENU = 1
uint8 BUTTON = 2
uint8 MOVE_AXIS = 3 
uint8 MOVE_PLANE = 4
uint8 ROTATE_AXIS = 5
uint8 MOVE_ROTATE = 6
# \"3D\" interaction modes work with the mouse+SHIFT+CTRL or with 3D cursors.
# MOVE_3D: Translate freely in 3D space.
# ROTATE_3D: Rotate freely in 3D space about the origin of parent frame.
# MOVE_ROTATE_3D: Full 6-DOF freedom of translation and rotation about the cursor origin.
uint8 MOVE_3D = 7
uint8 ROTATE_3D = 8
uint8 MOVE_ROTATE_3D = 9

uint8 interaction_mode


# If true, the contained markers will also be visible
# when the gui is not in interactive mode.
bool always_visible


# Markers to be displayed as custom visual representation.
# Leave this empty to use the default control handles.
#
# Note: 
# - The markers can be defined in an arbitrary coordinate frame,
#   but will be transformed into the local frame of the interactive marker.
# - If the header of a marker is empty, its pose will be interpreted as 
#   relative to the pose of the parent interactive marker.
Marker[] markers


# In VIEW_FACING mode, set this to true if you don't want the markers
# to be aligned with the camera view point. The markers will show up
# as in INHERIT mode.
bool independent_marker_orientation


# Short description (< 40 characters) of what this control does,
# e.g. \"Move the robot\". 
# Default: A generic description based on the interaction mode
string description

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: visualization_msgs/Marker
# See http://www.ros.org/wiki/rviz/DisplayTypes/Marker and http://www.ros.org/wiki/rviz/Tutorials/Markers%3A%20Basic%20Shapes for more information on using this message with rviz

uint8 ARROW=0
uint8 CUBE=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 LINE_STRIP=4
uint8 LINE_LIST=5
uint8 CUBE_LIST=6
uint8 SPHERE_LIST=7
uint8 POINTS=8
uint8 TEXT_VIEW_FACING=9
uint8 MESH_RESOURCE=10
uint8 TRIANGLE_LIST=11

uint8 ADD=0
uint8 MODIFY=0
uint8 DELETE=2

Header header                        # header for time/frame information
string ns                            # Namespace to place this object in... used in conjunction with id to create a unique name for the object
int32 id 		                         # object ID useful in conjunction with the namespace for manipulating and deleting the object later
int32 type 		                       # Type of object
int32 action 	                       # 0 add/modify an object, 1 (deprecated), 2 deletes an object
geometry_msgs/Pose pose                 # Pose of the object
geometry_msgs/Vector3 scale             # Scale of the object 1,1,1 means default (usually 1 meter square)
std_msgs/ColorRGBA color             # Color [0.0-1.0]
duration lifetime                    # How long the object should last before being automatically deleted.  0 means forever
bool frame_locked                    # If this marker should be frame-locked, i.e. retransformed into its frame every timestep

#Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
geometry_msgs/Point[] points
#Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
#number of colors must either be 0 or equal to the number of points
#NOTE: alpha is not yet used
std_msgs/ColorRGBA[] colors

# NOTE: only used for text markers
string text

# NOTE: only used for MESH_RESOURCE markers
string mesh_resource
bool mesh_use_embedded_materials

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

"
  end
  # Pseudo-constants
  INHERIT = 0
  FIXED = 1
  VIEW_FACING = 2
  NONE = 0
  MENU = 1
  BUTTON = 2
  MOVE_AXIS = 3
  MOVE_PLANE = 4
  ROTATE_AXIS = 5
  MOVE_ROTATE = 6
  MOVE_3D = 7
  ROTATE_3D = 8
  MOVE_ROTATE_3D = 9

  attr_accessor :name, :orientation, :orientation_mode, :interaction_mode, :always_visible, :markers, :independent_marker_orientation, :description

  @@struct_C = ::ROS::Struct.new("C")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_l3 = ::ROS::Struct.new("l3")
  @@struct_d4C3 = ::ROS::Struct.new("d4C3")
  @@struct_f4 = ::ROS::Struct.new("f4")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','geometry_msgs/Quaternion','uint8','uint8','bool','visualization_msgs/Marker[]','bool','string']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :name initialize value
  # @option args [geometry_msgs/Quaternion] :orientation initialize value
  # @option args [uint8] :orientation_mode initialize value
  # @option args [uint8] :interaction_mode initialize value
  # @option args [bool] :always_visible initialize value
  # @option args [visualization_msgs/Marker[]] :markers initialize value
  # @option args [bool] :independent_marker_orientation initialize value
  # @option args [string] :description initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
    if args[:orientation]
      @orientation = args[:orientation]
    else
      @orientation = Geometry_msgs::Quaternion.new
    end
    if args[:orientation_mode]
      @orientation_mode = args[:orientation_mode]
    else
      @orientation_mode = 0
    end
    if args[:interaction_mode]
      @interaction_mode = args[:interaction_mode]
    else
      @interaction_mode = 0
    end
    if args[:always_visible]
      @always_visible = args[:always_visible]
    else
      @always_visible = false
    end
    if args[:markers]
      @markers = args[:markers]
    else
      @markers = []
    end
    if args[:independent_marker_orientation]
      @independent_marker_orientation = args[:independent_marker_orientation]
    else
      @independent_marker_orientation = false
    end
    if args[:description]
      @description = args[:description]
    else
      @description = ''
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d4C3.pack(@orientation.x, @orientation.y, @orientation.z, @orientation.w, @orientation_mode, @interaction_mode, @always_visible))
      length = @markers.length
      buff.write(@@struct_L.pack(length))
      for val1 in @markers
        _v3627 = val1.header
        buff.write(@@struct_L.pack(_v3627.seq))
        _v3628 = _v3627.stamp
        _x = _v3628
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3627.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.ns
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_l3.pack(_x.id, _x.type, _x.action))
        _v3629 = val1.pose
        _v3630 = _v3629.position
        _x = _v3630
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3631 = _v3629.orientation
        _x = _v3631
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _v3632 = val1.scale
        _x = _v3632
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3633 = val1.color
        _x = _v3633
        buff.write(@@struct_f4.pack(_x.r, _x.g, _x.b, _x.a))
        _v3634 = val1.lifetime
        _x = _v3634
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        buff.write(@@struct_C.pack(val1.frame_locked))
        length = val1.points.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.points
          _x = val2
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        length = val1.colors.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.colors
          _x = val2
          buff.write(@@struct_f4.pack(_x.r, _x.g, _x.b, _x.a))
        end
        _x = val1.text
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.mesh_resource
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_C.pack(val1.mesh_use_embedded_materials))
      end
      buff.write(@@struct_C.pack(@independent_marker_orientation))
      _x = @description
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @orientation == nil
        @orientation = Geometry_msgs::Quaternion.new
      end
      if @markers == nil
        @markers = Visualization_msgs::Marker[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d4C3')
      (@orientation.x, @orientation.y, @orientation.z, @orientation.w, @orientation_mode, @interaction_mode, @always_visible,) = @@struct_d4C3.unpack(str[start..(end_point-1)])
      @always_visible = bool(@always_visible)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @markers = []
      length.times do
        val1 = Visualization_msgs::Marker.new
        _v3635 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3635.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3636 = _v3635.stamp
        _x = _v3636
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3635.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.ns = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('l3')
        (_x.id, _x.type, _x.action,) = @@struct_l3.unpack(str[start..(end_point-1)])
        _v3637 = val1.pose
        _v3638 = _v3637.position
        _x = _v3638
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3639 = _v3637.orientation
        _x = _v3639
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        _v3640 = val1.scale
        _x = _v3640
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3641 = val1.color
        _x = _v3641
        start = end_point
        end_point += ROS::Struct::calc_size('f4')
        (_x.r, _x.g, _x.b, _x.a,) = @@struct_f4.unpack(str[start..(end_point-1)])
        _v3642 = val1.lifetime
        _x = _v3642
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (val1.frame_locked,) = @@struct_C.unpack(str[start..(end_point-1)])
        val1.frame_locked = bool(val1.frame_locked)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.points = []
        length.times do
          val2 = Geometry_msgs::Point.new
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.points.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.colors = []
        length.times do
          val2 = Std_msgs::ColorRGBA.new
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('f4')
          (_x.r, _x.g, _x.b, _x.a,) = @@struct_f4.unpack(str[start..(end_point-1)])
          val1.colors.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.text = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.mesh_resource = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (val1.mesh_use_embedded_materials,) = @@struct_C.unpack(str[start..(end_point-1)])
        val1.mesh_use_embedded_materials = bool(val1.mesh_use_embedded_materials)
        @markers.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@independent_marker_orientation,) = @@struct_C.unpack(str[start..(end_point-1)])
      @independent_marker_orientation = bool(@independent_marker_orientation)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @description = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
