# autogenerated by genrb from InteractiveMarkerFeedback.msg. Do not edit.
require 'ros/message'

require "std_msgs/Header"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Point"
require "geometry_msgs/Pose"

module Visualization_msgs

class InteractiveMarkerFeedback <::ROS::Message
  def self.md5sum
    "ab0f1eee058667e28c19ff3ffc3f4b78"
  end

  def self.type
    "visualization_msgs/InteractiveMarkerFeedback"
  end

  def has_header?
    true
  end

  def message_definition
    "# Time/frame info.
Header header

# Identifying string. Must be unique in the topic namespace.
string client_id

# Feedback message sent back from the GUI, e.g.
# when the status of an interactive marker was modified by the user.

# Specifies which interactive marker and control this message refers to
string marker_name
string control_name

# Type of the event
# KEEP_ALIVE: sent while dragging to keep up control of the marker
# MENU_SELECT: a menu entry has been selected
# BUTTON_CLICK: a button control has been clicked
# POSE_UPDATE: the pose has been changed using one of the controls
uint8 KEEP_ALIVE = 0
uint8 POSE_UPDATE = 1
uint8 MENU_SELECT = 2
uint8 BUTTON_CLICK = 3

uint8 MOUSE_DOWN = 4
uint8 MOUSE_UP = 5

uint8 event_type

# Current pose of the marker
# Note: Has to be valid for all feedback types.
geometry_msgs/Pose pose

# Contains the ID of the selected menu entry
# Only valid for MENU_SELECT events.
uint32 menu_entry_id

# If event_type is BUTTON_CLICK, MOUSE_DOWN, or MOUSE_UP, mouse_point
# may contain the 3 dimensional position of the event on the
# control.  If it does, mouse_point_valid will be true.  mouse_point
# will be relative to the frame listed in the header.
geometry_msgs/Point mouse_point
bool mouse_point_valid

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  # Pseudo-constants
  KEEP_ALIVE = 0
  POSE_UPDATE = 1
  MENU_SELECT = 2
  BUTTON_CLICK = 3
  MOUSE_DOWN = 4
  MOUSE_UP = 5

  attr_accessor :header, :client_id, :marker_name, :control_name, :event_type, :pose, :menu_entry_id, :mouse_point, :mouse_point_valid

  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_Cd7Ld3C = ::ROS::Struct.new("Cd7Ld3C")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','string','string','string','uint8','geometry_msgs/Pose','uint32','geometry_msgs/Point','bool']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [string] :client_id initialize value
  # @option args [string] :marker_name initialize value
  # @option args [string] :control_name initialize value
  # @option args [uint8] :event_type initialize value
  # @option args [geometry_msgs/Pose] :pose initialize value
  # @option args [uint32] :menu_entry_id initialize value
  # @option args [geometry_msgs/Point] :mouse_point initialize value
  # @option args [bool] :mouse_point_valid initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:client_id]
      @client_id = args[:client_id]
    else
      @client_id = ''
    end
    if args[:marker_name]
      @marker_name = args[:marker_name]
    else
      @marker_name = ''
    end
    if args[:control_name]
      @control_name = args[:control_name]
    else
      @control_name = ''
    end
    if args[:event_type]
      @event_type = args[:event_type]
    else
      @event_type = 0
    end
    if args[:pose]
      @pose = args[:pose]
    else
      @pose = Geometry_msgs::Pose.new
    end
    if args[:menu_entry_id]
      @menu_entry_id = args[:menu_entry_id]
    else
      @menu_entry_id = 0
    end
    if args[:mouse_point]
      @mouse_point = args[:mouse_point]
    else
      @mouse_point = Geometry_msgs::Point.new
    end
    if args[:mouse_point_valid]
      @mouse_point_valid = args[:mouse_point_valid]
    else
      @mouse_point_valid = false
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @client_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @marker_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @control_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_Cd7Ld3C.pack(@event_type, @pose.position.x, @pose.position.y, @pose.position.z, @pose.orientation.x, @pose.orientation.y, @pose.orientation.z, @pose.orientation.w, @menu_entry_id, @mouse_point.x, @mouse_point.y, @mouse_point.z, @mouse_point_valid))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @pose == nil
        @pose = Geometry_msgs::Pose.new
      end
      if @mouse_point == nil
        @mouse_point = Geometry_msgs::Point.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @client_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @marker_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @control_name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('Cd7Ld3C')
      (@event_type, @pose.position.x, @pose.position.y, @pose.position.z, @pose.orientation.x, @pose.orientation.y, @pose.orientation.z, @pose.orientation.w, @menu_entry_id, @mouse_point.x, @mouse_point.y, @mouse_point.z, @mouse_point_valid,) = @@struct_Cd7Ld3C.unpack(str[start..(end_point-1)])
      @mouse_point_valid = bool(@mouse_point_valid)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
