# autogenerated by genrb from Marker.msg. Do not edit.
require 'ros/message'

require "ros/duration"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "std_msgs/ColorRGBA"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "geometry_msgs/Pose"

module Visualization_msgs

class Marker <::ROS::Message
  def self.md5sum
    "18326976df9d29249efc939e00342cde"
  end

  def self.type
    "visualization_msgs/Marker"
  end

  def has_header?
    true
  end

  def message_definition
    "# See http://www.ros.org/wiki/rviz/DisplayTypes/Marker and http://www.ros.org/wiki/rviz/Tutorials/Markers%3A%20Basic%20Shapes for more information on using this message with rviz

uint8 ARROW=0
uint8 CUBE=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 LINE_STRIP=4
uint8 LINE_LIST=5
uint8 CUBE_LIST=6
uint8 SPHERE_LIST=7
uint8 POINTS=8
uint8 TEXT_VIEW_FACING=9
uint8 MESH_RESOURCE=10
uint8 TRIANGLE_LIST=11

uint8 ADD=0
uint8 MODIFY=0
uint8 DELETE=2

Header header                        # header for time/frame information
string ns                            # Namespace to place this object in... used in conjunction with id to create a unique name for the object
int32 id 		                         # object ID useful in conjunction with the namespace for manipulating and deleting the object later
int32 type 		                       # Type of object
int32 action 	                       # 0 add/modify an object, 1 (deprecated), 2 deletes an object
geometry_msgs/Pose pose                 # Pose of the object
geometry_msgs/Vector3 scale             # Scale of the object 1,1,1 means default (usually 1 meter square)
std_msgs/ColorRGBA color             # Color [0.0-1.0]
duration lifetime                    # How long the object should last before being automatically deleted.  0 means forever
bool frame_locked                    # If this marker should be frame-locked, i.e. retransformed into its frame every timestep

#Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
geometry_msgs/Point[] points
#Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
#number of colors must either be 0 or equal to the number of points
#NOTE: alpha is not yet used
std_msgs/ColorRGBA[] colors

# NOTE: only used for text markers
string text

# NOTE: only used for MESH_RESOURCE markers
string mesh_resource
bool mesh_use_embedded_materials

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

"
  end
  # Pseudo-constants
  ARROW = 0
  CUBE = 1
  SPHERE = 2
  CYLINDER = 3
  LINE_STRIP = 4
  LINE_LIST = 5
  CUBE_LIST = 6
  SPHERE_LIST = 7
  POINTS = 8
  TEXT_VIEW_FACING = 9
  MESH_RESOURCE = 10
  TRIANGLE_LIST = 11
  ADD = 0
  MODIFY = 0
  DELETE = 2

  attr_accessor :header, :ns, :id, :type, :action, :pose, :scale, :color, :lifetime, :frame_locked, :points, :colors, :text, :mesh_resource, :mesh_use_embedded_materials

  @@struct_f4 = ::ROS::Struct.new("f4")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_l3d10f4l2C = ::ROS::Struct.new("l3d10f4l2C")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['std_msgs/Header','string','int32','int32','int32','geometry_msgs/Pose','geometry_msgs/Vector3','std_msgs/ColorRGBA','duration','bool','geometry_msgs/Point[]','std_msgs/ColorRGBA[]','string','string','bool']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [std_msgs/Header] :header initialize value
  # @option args [string] :ns initialize value
  # @option args [int32] :id initialize value
  # @option args [int32] :type initialize value
  # @option args [int32] :action initialize value
  # @option args [geometry_msgs/Pose] :pose initialize value
  # @option args [geometry_msgs/Vector3] :scale initialize value
  # @option args [std_msgs/ColorRGBA] :color initialize value
  # @option args [duration] :lifetime initialize value
  # @option args [bool] :frame_locked initialize value
  # @option args [geometry_msgs/Point[]] :points initialize value
  # @option args [std_msgs/ColorRGBA[]] :colors initialize value
  # @option args [string] :text initialize value
  # @option args [string] :mesh_resource initialize value
  # @option args [bool] :mesh_use_embedded_materials initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:header]
      @header = args[:header]
    else
      @header = Std_msgs::Header.new
    end
    if args[:ns]
      @ns = args[:ns]
    else
      @ns = ''
    end
    if args[:id]
      @id = args[:id]
    else
      @id = 0
    end
    if args[:type]
      @type = args[:type]
    else
      @type = 0
    end
    if args[:action]
      @action = args[:action]
    else
      @action = 0
    end
    if args[:pose]
      @pose = args[:pose]
    else
      @pose = Geometry_msgs::Pose.new
    end
    if args[:scale]
      @scale = args[:scale]
    else
      @scale = Geometry_msgs::Vector3.new
    end
    if args[:color]
      @color = args[:color]
    else
      @color = Std_msgs::ColorRGBA.new
    end
    if args[:lifetime]
      @lifetime = args[:lifetime]
    else
      @lifetime = ROS::Duration.new
    end
    if args[:frame_locked]
      @frame_locked = args[:frame_locked]
    else
      @frame_locked = false
    end
    if args[:points]
      @points = args[:points]
    else
      @points = []
    end
    if args[:colors]
      @colors = args[:colors]
    else
      @colors = []
    end
    if args[:text]
      @text = args[:text]
    else
      @text = ''
    end
    if args[:mesh_resource]
      @mesh_resource = args[:mesh_resource]
    else
      @mesh_resource = ''
    end
    if args[:mesh_use_embedded_materials]
      @mesh_use_embedded_materials = args[:mesh_use_embedded_materials]
    else
      @mesh_use_embedded_materials = false
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@header.seq, @header.stamp.secs, @header.stamp.nsecs))
      _x = @header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @ns
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_l3d10f4l2C.pack(@id, @type, @action, @pose.position.x, @pose.position.y, @pose.position.z, @pose.orientation.x, @pose.orientation.y, @pose.orientation.z, @pose.orientation.w, @scale.x, @scale.y, @scale.z, @color.r, @color.g, @color.b, @color.a, @lifetime.secs, @lifetime.nsecs, @frame_locked))
      length = @points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @points
        _x = val1
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @colors.length
      buff.write(@@struct_L.pack(length))
      for val1 in @colors
        _x = val1
        buff.write(@@struct_f4.pack(_x.r, _x.g, _x.b, _x.a))
      end
      _x = @text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @mesh_resource
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@mesh_use_embedded_materials))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @header == nil
        @header = Std_msgs::Header.new
      end
      if @pose == nil
        @pose = Geometry_msgs::Pose.new
      end
      if @scale == nil
        @scale = Geometry_msgs::Vector3.new
      end
      if @color == nil
        @color = Std_msgs::ColorRGBA.new
      end
      if @lifetime == nil
        @lifetime = ROS::Duration.new
      end
      if @points == nil
        @points = Geometry_msgs::Point[].new
      end
      if @colors == nil
        @colors = Std_msgs::ColorRGBA[].new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@header.seq, @header.stamp.secs, @header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @ns = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('l3d10f4l2C')
      (@id, @type, @action, @pose.position.x, @pose.position.y, @pose.position.z, @pose.orientation.x, @pose.orientation.y, @pose.orientation.z, @pose.orientation.w, @scale.x, @scale.y, @scale.z, @color.r, @color.g, @color.b, @color.a, @lifetime.secs, @lifetime.nsecs, @frame_locked,) = @@struct_l3d10f4l2C.unpack(str[start..(end_point-1)])
      @frame_locked = bool(@frame_locked)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @points = []
      length.times do
        val1 = Geometry_msgs::Point.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @points.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @colors = []
      length.times do
        val1 = Std_msgs::ColorRGBA.new
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('f4')
        (_x.r, _x.g, _x.b, _x.a,) = @@struct_f4.unpack(str[start..(end_point-1)])
        @colors.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @text = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @mesh_resource = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@mesh_use_embedded_materials,) = @@struct_C.unpack(str[start..(end_point-1)])
      @mesh_use_embedded_materials = bool(@mesh_use_embedded_materials)
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
