# autogenerated by genrb from MarkerArray.msg. Do not edit.
require 'ros/message'

require "visualization_msgs/Marker"
require "ros/duration"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "std_msgs/ColorRGBA"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "geometry_msgs/Pose"

module Visualization_msgs

class MarkerArray <::ROS::Message
  def self.md5sum
    "90da67007c26525f655c1c269094e39f"
  end

  def self.type
    "visualization_msgs/MarkerArray"
  end

  def has_header?
    false
  end

  def message_definition
    "Marker[] markers

================================================================================
MSG: visualization_msgs/Marker
# See http://www.ros.org/wiki/rviz/DisplayTypes/Marker and http://www.ros.org/wiki/rviz/Tutorials/Markers%3A%20Basic%20Shapes for more information on using this message with rviz

uint8 ARROW=0
uint8 CUBE=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 LINE_STRIP=4
uint8 LINE_LIST=5
uint8 CUBE_LIST=6
uint8 SPHERE_LIST=7
uint8 POINTS=8
uint8 TEXT_VIEW_FACING=9
uint8 MESH_RESOURCE=10
uint8 TRIANGLE_LIST=11

uint8 ADD=0
uint8 MODIFY=0
uint8 DELETE=2

Header header                        # header for time/frame information
string ns                            # Namespace to place this object in... used in conjunction with id to create a unique name for the object
int32 id 		                         # object ID useful in conjunction with the namespace for manipulating and deleting the object later
int32 type 		                       # Type of object
int32 action 	                       # 0 add/modify an object, 1 (deprecated), 2 deletes an object
geometry_msgs/Pose pose                 # Pose of the object
geometry_msgs/Vector3 scale             # Scale of the object 1,1,1 means default (usually 1 meter square)
std_msgs/ColorRGBA color             # Color [0.0-1.0]
duration lifetime                    # How long the object should last before being automatically deleted.  0 means forever
bool frame_locked                    # If this marker should be frame-locked, i.e. retransformed into its frame every timestep

#Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
geometry_msgs/Point[] points
#Only used if the type specified has some use for them (eg. POINTS, LINE_STRIP, ...)
#number of colors must either be 0 or equal to the number of points
#NOTE: alpha is not yet used
std_msgs/ColorRGBA[] colors

# NOTE: only used for text markers
string text

# NOTE: only used for MESH_RESOURCE markers
string mesh_resource
bool mesh_use_embedded_materials

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

"
  end
  attr_accessor :markers

  @@struct_C = ::ROS::Struct.new("C")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_l3 = ::ROS::Struct.new("l3")
  @@struct_f4 = ::ROS::Struct.new("f4")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['visualization_msgs/Marker[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [visualization_msgs/Marker[]] :markers initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:markers]
      @markers = args[:markers]
    else
      @markers = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      length = @markers.length
      buff.write(@@struct_L.pack(length))
      for val1 in @markers
        _v3709 = val1.header
        buff.write(@@struct_L.pack(_v3709.seq))
        _v3710 = _v3709.stamp
        _x = _v3710
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v3709.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.ns
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_l3.pack(_x.id, _x.type, _x.action))
        _v3711 = val1.pose
        _v3712 = _v3711.position
        _x = _v3712
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3713 = _v3711.orientation
        _x = _v3713
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _v3714 = val1.scale
        _x = _v3714
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v3715 = val1.color
        _x = _v3715
        buff.write(@@struct_f4.pack(_x.r, _x.g, _x.b, _x.a))
        _v3716 = val1.lifetime
        _x = _v3716
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        buff.write(@@struct_C.pack(val1.frame_locked))
        length = val1.points.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.points
          _x = val2
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        length = val1.colors.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.colors
          _x = val2
          buff.write(@@struct_f4.pack(_x.r, _x.g, _x.b, _x.a))
        end
        _x = val1.text
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.mesh_resource
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_C.pack(val1.mesh_use_embedded_materials))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @markers == nil
        @markers = Visualization_msgs::Marker[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @markers = []
      length.times do
        val1 = Visualization_msgs::Marker.new
        _v3717 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v3717.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v3718 = _v3717.stamp
        _x = _v3718
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v3717.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.ns = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('l3')
        (_x.id, _x.type, _x.action,) = @@struct_l3.unpack(str[start..(end_point-1)])
        _v3719 = val1.pose
        _v3720 = _v3719.position
        _x = _v3720
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3721 = _v3719.orientation
        _x = _v3721
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        _v3722 = val1.scale
        _x = _v3722
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v3723 = val1.color
        _x = _v3723
        start = end_point
        end_point += ROS::Struct::calc_size('f4')
        (_x.r, _x.g, _x.b, _x.a,) = @@struct_f4.unpack(str[start..(end_point-1)])
        _v3724 = val1.lifetime
        _x = _v3724
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (val1.frame_locked,) = @@struct_C.unpack(str[start..(end_point-1)])
        val1.frame_locked = bool(val1.frame_locked)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.points = []
        length.times do
          val2 = Geometry_msgs::Point.new
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.points.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.colors = []
        length.times do
          val2 = Std_msgs::ColorRGBA.new
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('f4')
          (_x.r, _x.g, _x.b, _x.a,) = @@struct_f4.unpack(str[start..(end_point-1)])
          val1.colors.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.text = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.mesh_resource = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('C')
        (val1.mesh_use_embedded_materials,) = @@struct_C.unpack(str[start..(end_point-1)])
        val1.mesh_use_embedded_materials = bool(val1.mesh_use_embedded_materials)
        @markers.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
