# autogenerated by genrb from Wall.msg. Do not edit.
require 'ros/message'

require "geometry_msgs/PoseWithCovariance"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "geometry_msgs/Pose"
require "geometry_msgs/Quaternion"
require "geometry_msgs/PoseWithCovarianceStamped"

module Yocs_msgs

class Wall <::ROS::Message
  def self.md5sum
    "6fba3b6a148ebf1773d978f0b5f0bde8"
  end

  def self.type
    "yocs_msgs/Wall"
  end

  def has_header?
    false
  end

  def message_definition
    "# Virtual wall obstacle;
#  - Assumed to be a plan, so width is ignored by now
#  - The yaw provides the orientation of x-axis
#  - Assumed vertically aligned (roll and pitch must be 0)
#  - Z provides the lower border of the wall (normally 0)

string  name
float32 length
float32 width
float32 height
geometry_msgs/PoseWithCovarianceStamped pose

================================================================================
MSG: geometry_msgs/PoseWithCovarianceStamped
# This expresses an estimated pose with a reference coordinate frame and timestamp

Header header
PoseWithCovariance pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/PoseWithCovariance
# This represents a pose in free space with uncertainty.

Pose pose

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :name, :length, :width, :height, :pose

  @@struct_d36 = ::ROS::Struct.new("d36")
  @@struct_d7 = ::ROS::Struct.new("d7")
  @@struct_f3L3 = ::ROS::Struct.new("f3L3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['string','float32','float32','float32','geometry_msgs/PoseWithCovarianceStamped']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [string] :name initialize value
  # @option args [float32] :length initialize value
  # @option args [float32] :width initialize value
  # @option args [float32] :height initialize value
  # @option args [geometry_msgs/PoseWithCovarianceStamped] :pose initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:name]
      @name = args[:name]
    else
      @name = ''
    end
    if args[:length]
      @length = args[:length]
    else
      @length = 0.0
    end
    if args[:width]
      @width = args[:width]
    else
      @width = 0.0
    end
    if args[:height]
      @height = args[:height]
    else
      @height = 0.0
    end
    if args[:pose]
      @pose = args[:pose]
    else
      @pose = Geometry_msgs::PoseWithCovarianceStamped.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      _x = @name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_f3L3.pack(@length, @width, @height, @pose.header.seq, @pose.header.stamp.secs, @pose.header.stamp.nsecs))
      _x = @pose.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7.pack(@pose.pose.pose.position.x, @pose.pose.pose.position.y, @pose.pose.pose.position.z, @pose.pose.pose.orientation.x, @pose.pose.pose.orientation.y, @pose.pose.pose.orientation.z, @pose.pose.pose.orientation.w))
      buff.write(@@struct_d36.pack(*@pose.pose.covariance))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @pose == nil
        @pose = Geometry_msgs::PoseWithCovarianceStamped.new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('f3L3')
      (@length, @width, @height, @pose.header.seq, @pose.header.stamp.secs, @pose.header.stamp.nsecs,) = @@struct_f3L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @pose.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7')
      (@pose.pose.pose.position.x, @pose.pose.pose.position.y, @pose.pose.pose.position.z, @pose.pose.pose.orientation.x, @pose.pose.pose.orientation.y, @pose.pose.pose.orientation.z, @pose.pose.pose.orientation.w,) = @@struct_d7.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += ROS::Struct::calc_size('d36')
      @pose.pose.covariance = @@struct_d36.unpack(str[start..(end_point-1)])
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
