# autogenerated by genrb from WallList.msg. Do not edit.
require 'ros/message'

require "yocs_msgs/Wall"
require "std_msgs/Header"
require "geometry_msgs/Point"
require "geometry_msgs/PoseWithCovarianceStamped"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Pose"
require "geometry_msgs/PoseWithCovariance"

module Yocs_msgs

class WallList <::ROS::Message
  def self.md5sum
    "2879979aabb372fc7f6d782228e53412"
  end

  def self.type
    "yocs_msgs/WallList"
  end

  def has_header?
    false
  end

  def message_definition
    "# Virtual wall obstacles

Wall[] obstacles
================================================================================
MSG: yocs_msgs/Wall
# Virtual wall obstacle;
#  - Assumed to be a plan, so width is ignored by now
#  - The yaw provides the orientation of x-axis
#  - Assumed vertically aligned (roll and pitch must be 0)
#  - Z provides the lower border of the wall (normally 0)

string  name
float32 length
float32 width
float32 height
geometry_msgs/PoseWithCovarianceStamped pose

================================================================================
MSG: geometry_msgs/PoseWithCovarianceStamped
# This expresses an estimated pose with a reference coordinate frame and timestamp

Header header
PoseWithCovariance pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: geometry_msgs/PoseWithCovariance
# This represents a pose in free space with uncertainty.

Pose pose

# Row-major representation of the 6x6 covariance matrix
# The orientation parameters use a fixed-axis representation.
# In order, the parameters are:
# (x, y, z, rotation about X axis, rotation about Y axis, rotation about Z axis)
float64[36] covariance

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

"
  end
  attr_accessor :obstacles

  @@struct_d36 = ::ROS::Struct.new("d36")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_f3 = ::ROS::Struct.new("f3")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['yocs_msgs/Wall[]']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [yocs_msgs/Wall[]] :obstacles initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:obstacles]
      @obstacles = args[:obstacles]
    else
      @obstacles = []
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      length = @obstacles.length
      buff.write(@@struct_L.pack(length))
      for val1 in @obstacles
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_f3.pack(_x.length, _x.width, _x.height))
        _v161 = val1.pose
        _v162 = _v161.header
        buff.write(@@struct_L.pack(_v162.seq))
        _v163 = _v162.stamp
        _x = _v163
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v162.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v164 = _v161.pose
        _v165 = _v164.pose
        _v166 = _v165.position
        _x = _v166
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v167 = _v165.orientation
        _x = _v167
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_d36.pack(*_v164.covariance))
      end
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @obstacles == nil
        @obstacles = Yocs_msgs::Wall[].new
      end
      end_point = 0
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @obstacles = []
      length.times do
        val1 = Yocs_msgs::Wall.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('f3')
        (_x.length, _x.width, _x.height,) = @@struct_f3.unpack(str[start..(end_point-1)])
        _v168 = val1.pose
        _v169 = _v168.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v169.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v170 = _v169.stamp
        _x = _v170
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v169.frame_id = str[start..(end_point-1)]
        _v171 = _v168.pose
        _v172 = _v171.pose
        _v173 = _v172.position
        _x = _v173
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v174 = _v172.orientation
        _x = _v174
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('d36')
        _v171.covariance = @@struct_d36.unpack(str[start..(end_point-1)])
        @obstacles.push(val1)
      end
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
