# autogenerated by genrb from MoveGroupAction.msg. Do not edit.
require 'ros/message'

require "ros/time"
require "geometry_msgs/Transform"
require "moveit_msgs/PlanningSceneWorld"
require "moveit_msgs/VisibilityConstraint"
require "moveit_msgs/OrientationConstraint"
require "octomap_msgs/Octomap"
require "moveit_msgs/Constraints"
require "geometry_msgs/Point"
require "geometry_msgs/Twist"
require "shape_msgs/Mesh"
require "moveit_msgs/MoveGroupActionFeedback"
require "std_msgs/ColorRGBA"
require "trajectory_msgs/MultiDOFJointTrajectory"
require "actionlib_msgs/GoalStatus"
require "moveit_msgs/LinkScale"
require "moveit_msgs/PositionConstraint"
require "shape_msgs/Plane"
require "moveit_msgs/MoveItErrorCodes"
require "moveit_msgs/AllowedCollisionEntry"
require "geometry_msgs/PoseStamped"
require "moveit_msgs/PlanningOptions"
require "moveit_msgs/ObjectColor"
require "trajectory_msgs/MultiDOFJointTrajectoryPoint"
require "ros/duration"
require "moveit_msgs/BoundingVolume"
require "moveit_msgs/JointConstraint"
require "std_msgs/Header"
require "moveit_msgs/AllowedCollisionMatrix"
require "sensor_msgs/MultiDOFJointState"
require "geometry_msgs/Pose"
require "shape_msgs/MeshTriangle"
require "moveit_msgs/TrajectoryConstraints"
require "moveit_msgs/RobotTrajectory"
require "shape_msgs/SolidPrimitive"
require "geometry_msgs/Wrench"
require "moveit_msgs/MoveGroupGoal"
require "moveit_msgs/MoveGroupActionResult"
require "geometry_msgs/TransformStamped"
require "moveit_msgs/WorkspaceParameters"
require "moveit_msgs/RobotState"
require "moveit_msgs/MoveGroupActionGoal"
require "moveit_msgs/PlanningScene"
require "octomap_msgs/OctomapWithPose"
require "moveit_msgs/MoveGroupResult"
require "trajectory_msgs/JointTrajectory"
require "sensor_msgs/JointState"
require "trajectory_msgs/JointTrajectoryPoint"
require "moveit_msgs/LinkPadding"
require "object_recognition_msgs/ObjectType"
require "moveit_msgs/MotionPlanRequest"
require "actionlib_msgs/GoalID"
require "moveit_msgs/MoveGroupFeedback"
require "moveit_msgs/AttachedCollisionObject"
require "geometry_msgs/Quaternion"
require "geometry_msgs/Vector3"
require "moveit_msgs/CollisionObject"

module Moveit_msgs

class MoveGroupAction <::ROS::Message
  def self.md5sum
    "d50bd38d1cf3e7b2d84a542b5441c796"
  end

  def self.type
    "moveit_msgs/MoveGroupAction"
  end

  def has_header?
    false
  end

  def message_definition
    "# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

MoveGroupActionGoal action_goal
MoveGroupActionResult action_result
MoveGroupActionFeedback action_feedback

================================================================================
MSG: moveit_msgs/MoveGroupActionGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalID goal_id
MoveGroupGoal goal

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.secs: seconds (stamp_secs) since epoch
# * stamp.nsecs: nanoseconds since stamp_secs
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: actionlib_msgs/GoalID
# The stamp should store the time at which this goal was requested.
# It is used by an action server when it tries to preempt all
# goals that were requested before a certain time
time stamp

# The id provides a way to associate feedback and
# result message with specific goal requests. The id
# specified must be unique.
string id


================================================================================
MSG: moveit_msgs/MoveGroupGoal
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======
# Motion planning request to pass to planner
MotionPlanRequest request

# Planning options
PlanningOptions planning_options


================================================================================
MSG: moveit_msgs/MotionPlanRequest
# This service contains the definition for a request to the motion
# planner and the output it provides

# Parameters for the workspace that the planner should work inside
WorkspaceParameters workspace_parameters

# Starting state updates. If certain joints should be considered
# at positions other than the current ones, these positions should
# be set here
RobotState start_state

# The possible goal states for the model to plan for. Each element of
# the array defines a goal region. The goal is achieved
# if the constraints for a particular region are satisfied
Constraints[] goal_constraints

# No state at any point along the path in the produced motion plan will violate these constraints (this applies to all points, not just waypoints)
Constraints path_constraints

# The constraints the resulting trajectory must satisfy
TrajectoryConstraints trajectory_constraints

# The name of the motion planner to use. If no name is specified,
# a default motion planner will be used
string planner_id

# The name of the group of joints on which this planner is operating
string group_name

# The number of times this plan is to be computed. Shortest solution
# will be reported.
int32 num_planning_attempts

# The maximum amount of time the motion planner is allowed to plan for (in seconds)
float64 allowed_planning_time

================================================================================
MSG: moveit_msgs/WorkspaceParameters
# This message contains a set of parameters useful in
# setting up the volume (a box) in which the robot is allowed to move.
# This is useful only when planning for mobile parts of 
# the robot as well.

# Define the frame of reference for the box corners
Header header

# The minumum corner of the box, with respect to the robot starting pose
geometry_msgs/Vector3 min_corner

# The maximum corner of the box, with respect to the robot starting pose
geometry_msgs/Vector3 max_corner

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 

float64 x
float64 y
float64 z
================================================================================
MSG: moveit_msgs/RobotState
# This message contains information about the robot state, i.e. the positions of its joints and links
sensor_msgs/JointState joint_state

# Joints that may have multiple DOF are specified here
sensor_msgs/MultiDOFJointState multi_dof_joint_state

# Attached collision objects (attached to some link on the robot)
AttachedCollisionObject[] attached_collision_objects

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
# This is mostly important for handling the attached bodies (whether or not to clear the attached bodies
# of a moveit::core::RobotState before updating it with this message)
bool is_diff

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: sensor_msgs/MultiDOFJointState
# Representation of state for joints with multiple degrees of freedom, 
# following the structure of JointState.
#
# It is assumed that a joint in a system corresponds to a transform that gets applied 
# along the kinematic chain. For example, a planar joint (as in URDF) is 3DOF (x, y, yaw)
# and those 3DOF can be expressed as a transformation matrix, and that transformation
# matrix can be converted back to (x, y, yaw)
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# wrench associated with them, you can leave the wrench array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.

Header header

string[] joint_names
geometry_msgs/Transform[] transforms
geometry_msgs/Twist[] twist
geometry_msgs/Wrench[] wrench

================================================================================
MSG: geometry_msgs/Transform
# This represents the transform between two coordinate frames in free space.

Vector3 translation
Quaternion rotation

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Wrench
# This represents force in free space, separated into
# its linear and angular parts.
Vector3  force
Vector3  torque

================================================================================
MSG: moveit_msgs/AttachedCollisionObject
# The CollisionObject will be attached with a fixed joint to this link
string link_name

#This contains the actual shapes and poses for the CollisionObject
#to be attached to the link
#If action is remove and no object.id is set, all objects
#attached to the link indicated by link_name will be removed
CollisionObject object

# The set of links that the attached objects are allowed to touch
# by default - the link_name is already considered by default
string[] touch_links

# If certain links were placed in a particular posture for this object to remain attached 
# (e.g., an end effector closing around an object), the posture necessary for releasing
# the object is stored here
trajectory_msgs/JointTrajectory detach_posture

# The weight of the attached object, if known
float64 weight

================================================================================
MSG: moveit_msgs/CollisionObject
# a header, used for interpreting the poses
Header header

# the id of the object (name used in MoveIt)
string id

# The object type in a database of known objects
object_recognition_msgs/ObjectType type

# the the collision geometries associated with the object;
# their poses are with respect to the specified header

# solid geometric primitives
shape_msgs/SolidPrimitive[] primitives
geometry_msgs/Pose[] primitive_poses

# meshes
shape_msgs/Mesh[] meshes
geometry_msgs/Pose[] mesh_poses

# bounding planes (equation is specified, but the plane can be oriented using an additional pose)
shape_msgs/Plane[] planes
geometry_msgs/Pose[] plane_poses

# Adds the object to the planning scene. If the object previously existed, it is replaced.
byte ADD=0

# Removes the object from the environment entirely (everything that matches the specified id)
byte REMOVE=1

# Append to an object that already exists in the planning scene. If the does not exist, it is added.
byte APPEND=2

# If an object already exists in the scene, new poses can be sent (the geometry arrays must be left empty)
# if solely moving the object is desired
byte MOVE=3

# Operation to be performed
byte operation

================================================================================
MSG: object_recognition_msgs/ObjectType
################################################## OBJECT ID #########################################################

# Contains information about the type of a found object. Those two sets of parameters together uniquely define an
# object

# The key of the found object: the unique identifier in the given db
string key

# The db parameters stored as a JSON/compressed YAML string. An object id does not make sense without the corresponding
# database. E.g., in object_recognition, it can look like: \"{'type':'CouchDB', 'root':'http://localhost'}\"
# There is no conventional format for those parameters and it's nice to keep that flexibility.
# The object_recognition_core as a generic DB type that can read those fields
# Current examples:
# For CouchDB:
#   type: 'CouchDB'
#   root: 'http://localhost:5984'
#   collection: 'object_recognition'
# For SQL household database:
#   type: 'SqlHousehold'
#   host: 'wgs36'
#   port: 5432
#   user: 'willow'
#   password: 'willow'
#   name: 'household_objects'
#   module: 'tabletop'
string db

================================================================================
MSG: shape_msgs/SolidPrimitive
# Define box, sphere, cylinder, cone 
# All shapes are defined to have their bounding boxes centered around 0,0,0.

uint8 BOX=1
uint8 SPHERE=2
uint8 CYLINDER=3
uint8 CONE=4

# The type of the shape
uint8 type


# The dimensions of the shape
float64[] dimensions

# The meaning of the shape dimensions: each constant defines the index in the 'dimensions' array

# For the BOX type, the X, Y, and Z dimensions are the length of the corresponding
# sides of the box.
uint8 BOX_X=0
uint8 BOX_Y=1
uint8 BOX_Z=2


# For the SPHERE type, only one component is used, and it gives the radius of
# the sphere.
uint8 SPHERE_RADIUS=0


# For the CYLINDER and CONE types, the center line is oriented along
# the Z axis.  Therefore the CYLINDER_HEIGHT (CONE_HEIGHT) component
# of dimensions gives the height of the cylinder (cone).  The
# CYLINDER_RADIUS (CONE_RADIUS) component of dimensions gives the
# radius of the base of the cylinder (cone).  Cone and cylinder
# primitives are defined to be circular. The tip of the cone is
# pointing up, along +Z axis.

uint8 CYLINDER_HEIGHT=0
uint8 CYLINDER_RADIUS=1

uint8 CONE_HEIGHT=0
uint8 CONE_RADIUS=1

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of postion and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: shape_msgs/Mesh
# Definition of a mesh

# list of triangles; the index values refer to positions in vertices[]
MeshTriangle[] triangles

# the actual vertices that make up the mesh
geometry_msgs/Point[] vertices

================================================================================
MSG: shape_msgs/MeshTriangle
# Definition of a triangle's vertices
uint32[3] vertex_indices

================================================================================
MSG: shape_msgs/Plane
# Representation of a plane, using the plane equation ax + by + cz + d = 0

# a := coef[0]
# b := coef[1]
# c := coef[2]
# d := coef[3]

float64[4] coef

================================================================================
MSG: trajectory_msgs/JointTrajectory
Header header
string[] joint_names
JointTrajectoryPoint[] points
================================================================================
MSG: trajectory_msgs/JointTrajectoryPoint
# Each trajectory point specifies either positions[, velocities[, accelerations]]
# or positions[, effort] for the trajectory to be executed.
# All specified values are in the same order as the joint names in JointTrajectory.msg

float64[] positions
float64[] velocities
float64[] accelerations
float64[] effort
duration time_from_start

================================================================================
MSG: moveit_msgs/Constraints
# This message contains a list of motion planning constraints.
# All constraints must be satisfied for a goal to be considered valid

string name

JointConstraint[] joint_constraints

PositionConstraint[] position_constraints

OrientationConstraint[] orientation_constraints

VisibilityConstraint[] visibility_constraints

================================================================================
MSG: moveit_msgs/JointConstraint
# Constrain the position of a joint to be within a certain bound
string joint_name

# the bound to be achieved is [position - tolerance_below, position + tolerance_above]
float64 position
float64 tolerance_above
float64 tolerance_below

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight
================================================================================
MSG: moveit_msgs/PositionConstraint
# This message contains the definition of a position constraint.

Header header

# The robot link this constraint refers to
string link_name

# The offset (in the link frame) for the target point on the link we are planning for
geometry_msgs/Vector3 target_point_offset

# The volume this constraint refers to 
BoundingVolume constraint_region

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: moveit_msgs/BoundingVolume
# Define a volume in 3D

# A set of solid geometric primitives that make up the volume to define (as a union)
shape_msgs/SolidPrimitive[] primitives

# The poses at which the primitives are located
geometry_msgs/Pose[] primitive_poses

# In addition to primitives, meshes can be specified to add to the bounding volume (again, as union)
shape_msgs/Mesh[] meshes

# The poses at which the meshes are located
geometry_msgs/Pose[] mesh_poses

================================================================================
MSG: moveit_msgs/OrientationConstraint
# This message contains the definition of an orientation constraint.

Header header

# The desired orientation of the robot link specified as a quaternion
geometry_msgs/Quaternion orientation

# The robot link this constraint refers to
string link_name

# optional axis-angle error tolerances specified
float64 absolute_x_axis_tolerance
float64 absolute_y_axis_tolerance
float64 absolute_z_axis_tolerance

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: moveit_msgs/VisibilityConstraint
# The constraint is useful to maintain visibility to a disc (the target) in a particular frame.
# This disc forms the base of a visibiliy cone whose tip is at the origin of the sensor.
# Maintaining visibility is done by ensuring the robot does not obstruct the visibility cone.
# Note:
# This constraint does NOT enforce minimum or maximum distances between the sensor
# and the target, nor does it enforce the target to be in the field of view of
# the sensor. A PositionConstraint can (and probably should) be used for such purposes.

# The radius of the disc that should be maintained visible 
float64 target_radius

# The pose of the disc; as the robot moves, the pose of the disc may change as well
# This can be in the frame of a particular robot link, for example
geometry_msgs/PoseStamped target_pose

# From the sensor origin towards the target, the disc forms a visibility cone
# This cone is approximated using many sides. For example, when using 4 sides, 
# that in fact makes the visibility region be a pyramid.
# This value should always be 3 or more.
int32 cone_sides

# The pose in which visibility is to be maintained.
# The frame id should represent the robot link to which the sensor is attached.
# It is assumed the sensor can look directly at the target, in any direction.
# This assumption is usually not true, but additional PositionConstraints
# can resolve this issue.
geometry_msgs/PoseStamped sensor_pose

# Even though the disc is maintained visible, the visibility cone can be very small
# because of the orientation of the disc with respect to the sensor. It is possible
# for example to view the disk almost from a side, in which case the visibility cone 
# can end up having close to 0 volume. The view angle is defined to be the angle between
# the normal to the visibility disc and the direction vector from the sensor origin.
# The value below represents the minimum desired view angle. For a perfect view,
# this value will be 0 (the two vectors are exact opposites). For a completely obstructed view
# this value will be Pi/2 (the vectors are perpendicular). This value defined below 
# is the maximum view angle to be maintained. This should be a value in the open interval
# (0, Pi/2). If 0 is set, the view angle is NOT enforced.
float64 max_view_angle

# This angle is used similarly to max_view_angle but limits the maximum angle
# between the sensor origin direction vector and the axis that connects the
# sensor origin to the target frame origin. The value is again in the range (0, Pi/2)
# and is NOT enforced if set to 0.
float64 max_range_angle

# The axis that is assumed to indicate the direction of view for the sensor
# X = 2, Y = 1, Z = 0
uint8 SENSOR_Z=0
uint8 SENSOR_Y=1
uint8 SENSOR_X=2
uint8 sensor_view_direction

# A weighting factor for this constraint (denotes relative importance to other constraints. Closer to zero means less important)
float64 weight

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: moveit_msgs/TrajectoryConstraints
# The array of constraints to consider along the trajectory
Constraints[] constraints

================================================================================
MSG: moveit_msgs/PlanningOptions

# The diff to consider for the planning scene (optional)
PlanningScene planning_scene_diff

# If this flag is set to true, the action
# returns an executable plan in the response but does not attempt execution  
bool plan_only

# If this flag is set to true, the action of planning &
# executing is allowed to look around  (move sensors) if
# it seems that not enough information is available about
# the environment
bool look_around

# If this value is positive, the action of planning & executing
# is allowed to look around for a maximum number of attempts;
# If the value is left as 0, the default value is used, as set
# with dynamic_reconfigure
int32 look_around_attempts

# If set and if look_around is true, this value is used as
# the maximum cost allowed for a path to be considered executable.
# If the cost of a path is higher than this value, more sensing or 
# a new plan needed. If left as 0.0 but look_around is true, then 
# the default value set via dynamic_reconfigure is used
float64 max_safe_execution_cost

# If the plan becomes invalidated during execution, it is possible to have
# that plan recomputed and execution restarted. This flag enables this
# functionality 
bool replan

# The maximum number of replanning attempts 
int32 replan_attempts

# The amount of time to wait in between replanning attempts (in seconds)
float64 replan_delay

================================================================================
MSG: moveit_msgs/PlanningScene
# name of planning scene
string name

# full robot state
RobotState robot_state

# The name of the robot model this scene is for
string robot_model_name

#additional frames for duplicating tf (with respect to the planning frame)
geometry_msgs/TransformStamped[] fixed_frame_transforms

#full allowed collision matrix
AllowedCollisionMatrix allowed_collision_matrix

# all link paddings
LinkPadding[] link_padding

# all link scales
LinkScale[] link_scale

# Attached objects, collision objects, even the octomap or collision map can have 
# colors associated to them. This array specifies them.
ObjectColor[] object_colors

# the collision map
PlanningSceneWorld world

# Flag indicating whether this scene is to be interpreted as a diff with respect to some other scene
bool is_diff

================================================================================
MSG: geometry_msgs/TransformStamped
# This expresses a transform from coordinate frame header.frame_id
# to the coordinate frame child_frame_id
#
# This message is mostly used by the 
# <a href=\"http://www.ros.org/wiki/tf\">tf</a> package. 
# See its documentation for more information.

Header header
string child_frame_id # the frame id of the child frame
Transform transform

================================================================================
MSG: moveit_msgs/AllowedCollisionMatrix
# The list of entry names in the matrix
string[] entry_names

# The individual entries in the allowed collision matrix
# square, symmetric, with same order as entry_names
AllowedCollisionEntry[] entry_values

# In addition to the collision matrix itself, we also have 
# the default entry value for each entry name.

# If the allowed collision flag is queried for a pair of names (n1, n2)
# that is not found in the collision matrix itself, the value of
# the collision flag is considered to be that of the entry (n1 or n2)
# specified in the list below. If both n1 and n2 are found in the list 
# of defaults, the result is computed with an AND operation

string[] default_entry_names
bool[] default_entry_values

================================================================================
MSG: moveit_msgs/AllowedCollisionEntry
# whether or not collision checking is enabled
bool[] enabled

================================================================================
MSG: moveit_msgs/LinkPadding
#name for the link
string link_name

# padding to apply to the link
float64 padding

================================================================================
MSG: moveit_msgs/LinkScale
#name for the link
string link_name

# scaling to apply to the link
float64 scale

================================================================================
MSG: moveit_msgs/ObjectColor
# The object id for which we specify color
string id

# The value of the color
std_msgs/ColorRGBA color

================================================================================
MSG: std_msgs/ColorRGBA
float32 r
float32 g
float32 b
float32 a

================================================================================
MSG: moveit_msgs/PlanningSceneWorld
# collision objects
CollisionObject[] collision_objects

# The octomap that represents additional collision data
octomap_msgs/OctomapWithPose octomap

================================================================================
MSG: octomap_msgs/OctomapWithPose
# A 3D map in binary format, as Octree
Header header

# The pose of the octree with respect to the header frame 
geometry_msgs/Pose origin

# The actual octree msg
octomap_msgs/Octomap octomap

================================================================================
MSG: octomap_msgs/Octomap
# A 3D map in binary format, as Octree
Header header

# Flag to denote a binary (only free/occupied) or full occupancy octree (.bt/.ot file)
bool binary

# Class id of the contained octree 
string id

# Resolution (in m) of the smallest octree nodes
float64 resolution

# binary serialization of octree, use conversions.h to read and write octrees
int8[] data

================================================================================
MSG: moveit_msgs/MoveGroupActionResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
MoveGroupResult result

================================================================================
MSG: actionlib_msgs/GoalStatus
GoalID goal_id
uint8 status
uint8 PENDING         = 0   # The goal has yet to be processed by the action server
uint8 ACTIVE          = 1   # The goal is currently being processed by the action server
uint8 PREEMPTED       = 2   # The goal received a cancel request after it started executing
                            #   and has since completed its execution (Terminal State)
uint8 SUCCEEDED       = 3   # The goal was achieved successfully by the action server (Terminal State)
uint8 ABORTED         = 4   # The goal was aborted during execution by the action server due
                            #    to some failure (Terminal State)
uint8 REJECTED        = 5   # The goal was rejected by the action server without being processed,
                            #    because the goal was unattainable or invalid (Terminal State)
uint8 PREEMPTING      = 6   # The goal received a cancel request after it started executing
                            #    and has not yet completed execution
uint8 RECALLING       = 7   # The goal received a cancel request before it started executing,
                            #    but the action server has not yet confirmed that the goal is canceled
uint8 RECALLED        = 8   # The goal received a cancel request before it started executing
                            #    and was successfully cancelled (Terminal State)
uint8 LOST            = 9   # An action client can determine that a goal is LOST. This should not be
                            #    sent over the wire by an action server

#Allow for the user to associate a string with GoalStatus for debugging
string text


================================================================================
MSG: moveit_msgs/MoveGroupResult
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# An error code reflecting what went wrong
MoveItErrorCodes error_code

# The full starting state of the robot at the start of the trajectory
moveit_msgs/RobotState trajectory_start

# The trajectory that moved group produced for execution
moveit_msgs/RobotTrajectory planned_trajectory

# The trace of the trajectory recorded during execution
moveit_msgs/RobotTrajectory executed_trajectory

# The amount of time it took to complete the motion plan
float64 planning_time


================================================================================
MSG: moveit_msgs/MoveItErrorCodes
int32 val

# overall behavior
int32 SUCCESS=1
int32 FAILURE=99999

int32 PLANNING_FAILED=-1
int32 INVALID_MOTION_PLAN=-2
int32 MOTION_PLAN_INVALIDATED_BY_ENVIRONMENT_CHANGE=-3
int32 CONTROL_FAILED=-4
int32 UNABLE_TO_AQUIRE_SENSOR_DATA=-5
int32 TIMED_OUT=-6
int32 PREEMPTED=-7

# planning & kinematics request errors
int32 START_STATE_IN_COLLISION=-10
int32 START_STATE_VIOLATES_PATH_CONSTRAINTS=-11

int32 GOAL_IN_COLLISION=-12
int32 GOAL_VIOLATES_PATH_CONSTRAINTS=-13
int32 GOAL_CONSTRAINTS_VIOLATED=-14

int32 INVALID_GROUP_NAME=-15
int32 INVALID_GOAL_CONSTRAINTS=-16
int32 INVALID_ROBOT_STATE=-17
int32 INVALID_LINK_NAME=-18
int32 INVALID_OBJECT_NAME=-19

# system errors
int32 FRAME_TRANSFORM_FAILURE=-21
int32 COLLISION_CHECKING_UNAVAILABLE=-22
int32 ROBOT_STATE_STALE=-23
int32 SENSOR_INFO_STALE=-24

# kinematics errors
int32 NO_IK_SOLUTION=-31

================================================================================
MSG: moveit_msgs/RobotTrajectory
trajectory_msgs/JointTrajectory joint_trajectory
trajectory_msgs/MultiDOFJointTrajectory multi_dof_joint_trajectory

================================================================================
MSG: trajectory_msgs/MultiDOFJointTrajectory
# The header is used to specify the coordinate frame and the reference time for the trajectory durations
Header header

# A representation of a multi-dof joint trajectory (each point is a transformation)
# Each point along the trajectory will include an array of positions/velocities/accelerations
# that has the same length as the array of joint names, and has the same order of joints as 
# the joint names array.

string[] joint_names
MultiDOFJointTrajectoryPoint[] points

================================================================================
MSG: trajectory_msgs/MultiDOFJointTrajectoryPoint
# Each multi-dof joint can specify a transform (up to 6 DOF)
geometry_msgs/Transform[] transforms

# There can be a velocity specified for the origin of the joint 
geometry_msgs/Twist[] velocities

# There can be an acceleration specified for the origin of the joint 
geometry_msgs/Twist[] accelerations

duration time_from_start

================================================================================
MSG: moveit_msgs/MoveGroupActionFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

Header header
actionlib_msgs/GoalStatus status
MoveGroupFeedback feedback

================================================================================
MSG: moveit_msgs/MoveGroupFeedback
# ====== DO NOT MODIFY! AUTOGENERATED FROM AN ACTION DEFINITION ======

# The internal state that the move arm action currently is in
string state


"
  end
  attr_accessor :action_goal, :action_result, :action_feedback

  @@struct_d7L3 = ::ROS::Struct.new("d7L3")
  @@struct_C = ::ROS::Struct.new("C")
  @@struct_C3ldCldL3 = ::ROS::Struct.new("C3ldCldL3")
  @@struct_d = ::ROS::Struct.new("d")
  @@struct_lL3 = ::ROS::Struct.new("lL3")
  @@struct_d6L3 = ::ROS::Struct.new("d6L3")
  @@struct_l2 = ::ROS::Struct.new("l2")
  @@struct_l = ::ROS::Struct.new("l")
  @@struct_L3 = ::ROS::Struct.new("L3")
  @@struct_c = ::ROS::Struct.new("c")
  @@struct_f4 = ::ROS::Struct.new("f4")
  @@struct_dL3 = ::ROS::Struct.new("dL3")
  @@struct_ld = ::ROS::Struct.new("ld")
  @@struct_d4 = ::ROS::Struct.new("d4")
  @@struct_CL3 = ::ROS::Struct.new("CL3")
  @@struct_d2Cd = ::ROS::Struct.new("d2Cd")
  @@struct_L2 = ::ROS::Struct.new("L2")
  @@struct_d3 = ::ROS::Struct.new("d3")

  @@struct_L = ::ROS::Struct.new("L")
  @@slot_types = ['moveit_msgs/MoveGroupActionGoal','moveit_msgs/MoveGroupActionResult','moveit_msgs/MoveGroupActionFeedback']

  # Constructor. You can set the default values using keyword operators.
  #
  # @param [Hash] args keyword for initializing values
  # @option args [moveit_msgs/MoveGroupActionGoal] :action_goal initialize value
  # @option args [moveit_msgs/MoveGroupActionResult] :action_result initialize value
  # @option args [moveit_msgs/MoveGroupActionFeedback] :action_feedback initialize value
  def initialize(args={})
    # message fields cannot be None, assign default values for those that are
    if args[:action_goal]
      @action_goal = args[:action_goal]
    else
      @action_goal = Moveit_msgs::MoveGroupActionGoal.new
    end
    if args[:action_result]
      @action_result = args[:action_result]
    else
      @action_result = Moveit_msgs::MoveGroupActionResult.new
    end
    if args[:action_feedback]
      @action_feedback = args[:action_feedback]
    else
      @action_feedback = Moveit_msgs::MoveGroupActionFeedback.new
    end
  end

  # internal API method
  # @return [String] Message type string.
  def _get_types
    @slot_types
  end

  # serialize message into buffer
  # @param [IO] buff buffer
  def serialize(buff)
    begin
      buff.write(@@struct_L3.pack(@action_goal.header.seq, @action_goal.header.stamp.secs, @action_goal.header.stamp.nsecs))
      _x = @action_goal.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_goal.goal_id.stamp.secs, @action_goal.goal_id.stamp.nsecs))
      _x = @action_goal.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@action_goal.goal.request.workspace_parameters.header.seq, @action_goal.goal.request.workspace_parameters.header.stamp.secs, @action_goal.goal.request.workspace_parameters.header.stamp.nsecs))
      _x = @action_goal.goal.request.workspace_parameters.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d6L3.pack(@action_goal.goal.request.workspace_parameters.min_corner.x, @action_goal.goal.request.workspace_parameters.min_corner.y, @action_goal.goal.request.workspace_parameters.min_corner.z, @action_goal.goal.request.workspace_parameters.max_corner.x, @action_goal.goal.request.workspace_parameters.max_corner.y, @action_goal.goal.request.workspace_parameters.max_corner.z, @action_goal.goal.request.start_state.joint_state.header.seq, @action_goal.goal.request.start_state.joint_state.header.stamp.secs, @action_goal.goal.request.start_state.joint_state.header.stamp.nsecs))
      _x = @action_goal.goal.request.start_state.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.request.start_state.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.request.start_state.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_goal.goal.request.start_state.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_goal.goal.request.start_state.joint_state.position.pack(pattern))
      length = @action_goal.goal.request.start_state.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_goal.goal.request.start_state.joint_state.velocity.pack(pattern))
      length = @action_goal.goal.request.start_state.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_goal.goal.request.start_state.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@action_goal.goal.request.start_state.multi_dof_joint_state.header.seq, @action_goal.goal.request.start_state.multi_dof_joint_state.header.stamp.secs, @action_goal.goal.request.start_state.multi_dof_joint_state.header.stamp.nsecs))
      _x = @action_goal.goal.request.start_state.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.request.start_state.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.request.start_state.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_goal.goal.request.start_state.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.request.start_state.multi_dof_joint_state.transforms
        _v867 = val1.translation
        _x = _v867
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v868 = val1.rotation
        _x = _v868
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @action_goal.goal.request.start_state.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.request.start_state.multi_dof_joint_state.twist
        _v869 = val1.linear
        _x = _v869
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v870 = val1.angular
        _x = _v870
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @action_goal.goal.request.start_state.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.request.start_state.multi_dof_joint_state.wrench
        _v871 = val1.force
        _x = _v871
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v872 = val1.torque
        _x = _v872
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @action_goal.goal.request.start_state.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.request.start_state.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v873 = val1.object
        _v874 = _v873.header
        buff.write(@@struct_L.pack(_v874.seq))
        _v875 = _v874.stamp
        _x = _v875
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v874.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v873.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v876 = _v873.type
        _x = _v876.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v876.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v873.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v873.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v873.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v873.primitive_poses
          _v877 = val3.position
          _x = _v877
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v878 = val3.orientation
          _x = _v878
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v873.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v873.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v873.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v873.mesh_poses
          _v879 = val3.position
          _x = _v879
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v880 = val3.orientation
          _x = _v880
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v873.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v873.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v873.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v873.plane_poses
          _v881 = val3.position
          _x = _v881
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v882 = val3.orientation
          _x = _v882
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v873.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v883 = val1.detach_posture
        _v884 = _v883.header
        buff.write(@@struct_L.pack(_v884.seq))
        _v885 = _v884.stamp
        _x = _v885
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v884.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v883.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v883.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v883.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v883.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v886 = val3.time_from_start
          _x = _v886
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_C.pack(@action_goal.goal.request.start_state.is_diff))
      length = @action_goal.goal.request.goal_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.request.goal_constraints
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.joint_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.joint_constraints
          _x = val2.joint_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
        end
        length = val1.position_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.position_constraints
          _v887 = val2.header
          buff.write(@@struct_L.pack(_v887.seq))
          _v888 = _v887.stamp
          _x = _v888
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v887.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v889 = val2.target_point_offset
          _x = _v889
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v890 = val2.constraint_region
          length = _v890.primitives.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v890.primitives
            buff.write(@@struct_C.pack(val4.type))
            length = val4.dimensions.length
            buff.write(@@struct_L.pack(length))
            pattern = "d#{length}"
            buff.write(*val4.dimensions.pack(pattern))
          end
          length = _v890.primitive_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v890.primitive_poses
            _v891 = val4.position
            _x = _v891
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v892 = val4.orientation
            _x = _v892
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          length = _v890.meshes.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v890.meshes
            length = val4.triangles.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.triangles
              buff.write(@@struct_L3.pack(*val5.vertex_indices))
            end
            length = val4.vertices.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.vertices
              _x = val5
              buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            end
          end
          length = _v890.mesh_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v890.mesh_poses
            _v893 = val4.position
            _x = _v893
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v894 = val4.orientation
            _x = _v894
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          buff.write(@@struct_d.pack(val2.weight))
        end
        length = val1.orientation_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.orientation_constraints
          _v895 = val2.header
          buff.write(@@struct_L.pack(_v895.seq))
          _v896 = _v895.stamp
          _x = _v896
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v895.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v897 = val2.orientation
          _x = _v897
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
        end
        length = val1.visibility_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.visibility_constraints
          buff.write(@@struct_d.pack(val2.target_radius))
          _v898 = val2.target_pose
          _v899 = _v898.header
          buff.write(@@struct_L.pack(_v899.seq))
          _v900 = _v899.stamp
          _x = _v900
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v899.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v901 = _v898.pose
          _v902 = _v901.position
          _x = _v902
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v903 = _v901.orientation
          _x = _v903
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(@@struct_l.pack(val2.cone_sides))
          _v904 = val2.sensor_pose
          _v905 = _v904.header
          buff.write(@@struct_L.pack(_v905.seq))
          _v906 = _v905.stamp
          _x = _v906
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v905.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v907 = _v904.pose
          _v908 = _v907.position
          _x = _v908
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v909 = _v907.orientation
          _x = _v909
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2
          buff.write(@@struct_d2Cd.pack(_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight))
        end
      end
      _x = @action_goal.goal.request.path_constraints.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.request.path_constraints.joint_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.request.path_constraints.joint_constraints
        _x = val1.joint_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_d4.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
      end
      length = @action_goal.goal.request.path_constraints.position_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.request.path_constraints.position_constraints
        _v910 = val1.header
        buff.write(@@struct_L.pack(_v910.seq))
        _v911 = _v910.stamp
        _x = _v911
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v910.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v912 = val1.target_point_offset
        _x = _v912
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v913 = val1.constraint_region
        length = _v913.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v913.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v913.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v913.primitive_poses
          _v914 = val3.position
          _x = _v914
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v915 = val3.orientation
          _x = _v915
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v913.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v913.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v913.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v913.mesh_poses
          _v916 = val3.position
          _x = _v916
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v917 = val3.orientation
          _x = _v917
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      length = @action_goal.goal.request.path_constraints.orientation_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.request.path_constraints.orientation_constraints
        _v918 = val1.header
        buff.write(@@struct_L.pack(_v918.seq))
        _v919 = _v918.stamp
        _x = _v919
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v918.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v920 = val1.orientation
        _x = _v920
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1
        buff.write(@@struct_d4.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
      end
      length = @action_goal.goal.request.path_constraints.visibility_constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.request.path_constraints.visibility_constraints
        buff.write(@@struct_d.pack(val1.target_radius))
        _v921 = val1.target_pose
        _v922 = _v921.header
        buff.write(@@struct_L.pack(_v922.seq))
        _v923 = _v922.stamp
        _x = _v923
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v922.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v924 = _v921.pose
        _v925 = _v924.position
        _x = _v925
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v926 = _v924.orientation
        _x = _v926
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        buff.write(@@struct_l.pack(val1.cone_sides))
        _v927 = val1.sensor_pose
        _v928 = _v927.header
        buff.write(@@struct_L.pack(_v928.seq))
        _v929 = _v928.stamp
        _x = _v929
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v928.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v930 = _v927.pose
        _v931 = _v930.position
        _x = _v931
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v932 = _v930.orientation
        _x = _v932
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(@@struct_d2Cd.pack(_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight))
      end
      length = @action_goal.goal.request.trajectory_constraints.constraints.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.request.trajectory_constraints.constraints
        _x = val1.name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.joint_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.joint_constraints
          _x = val2.joint_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight))
        end
        length = val1.position_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.position_constraints
          _v933 = val2.header
          buff.write(@@struct_L.pack(_v933.seq))
          _v934 = _v933.stamp
          _x = _v934
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v933.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v935 = val2.target_point_offset
          _x = _v935
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v936 = val2.constraint_region
          length = _v936.primitives.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v936.primitives
            buff.write(@@struct_C.pack(val4.type))
            length = val4.dimensions.length
            buff.write(@@struct_L.pack(length))
            pattern = "d#{length}"
            buff.write(*val4.dimensions.pack(pattern))
          end
          length = _v936.primitive_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v936.primitive_poses
            _v937 = val4.position
            _x = _v937
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v938 = val4.orientation
            _x = _v938
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          length = _v936.meshes.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v936.meshes
            length = val4.triangles.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.triangles
              buff.write(@@struct_L3.pack(*val5.vertex_indices))
            end
            length = val4.vertices.length
            buff.write(@@struct_L.pack(length))
            for val5 in val4.vertices
              _x = val5
              buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            end
          end
          length = _v936.mesh_poses.length
          buff.write(@@struct_L.pack(length))
          for val4 in _v936.mesh_poses
            _v939 = val4.position
            _x = _v939
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
            _v940 = val4.orientation
            _x = _v940
            buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          end
          buff.write(@@struct_d.pack(val2.weight))
        end
        length = val1.orientation_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.orientation_constraints
          _v941 = val2.header
          buff.write(@@struct_L.pack(_v941.seq))
          _v942 = _v941.stamp
          _x = _v942
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v941.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v943 = val2.orientation
          _x = _v943
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2.link_name
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _x = val2
          buff.write(@@struct_d4.pack(_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight))
        end
        length = val1.visibility_constraints.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.visibility_constraints
          buff.write(@@struct_d.pack(val2.target_radius))
          _v944 = val2.target_pose
          _v945 = _v944.header
          buff.write(@@struct_L.pack(_v945.seq))
          _v946 = _v945.stamp
          _x = _v946
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v945.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v947 = _v944.pose
          _v948 = _v947.position
          _x = _v948
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v949 = _v947.orientation
          _x = _v949
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          buff.write(@@struct_l.pack(val2.cone_sides))
          _v950 = val2.sensor_pose
          _v951 = _v950.header
          buff.write(@@struct_L.pack(_v951.seq))
          _v952 = _v951.stamp
          _x = _v952
          buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
          _x = _v951.frame_id
          length = _x.length
          buff.write([length, _x].pack("La#{length}"))
          _v953 = _v950.pose
          _v954 = _v953.position
          _x = _v954
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v955 = _v953.orientation
          _x = _v955
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
          _x = val2
          buff.write(@@struct_d2Cd.pack(_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight))
        end
      end
      _x = @action_goal.goal.request.planner_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @action_goal.goal.request.group_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_ld.pack(@action_goal.goal.request.num_planning_attempts, @action_goal.goal.request.allowed_planning_time))
      _x = @action_goal.goal.planning_options.planning_scene_diff.name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L3.pack(@action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.seq, @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.nsecs))
      _x = @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.position.pack(pattern))
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.velocity.pack(pattern))
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.seq, @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.nsecs))
      _x = @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms
        _v956 = val1.translation
        _x = _v956
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v957 = val1.rotation
        _x = _v957
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist
        _v958 = val1.linear
        _x = _v958
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v959 = val1.angular
        _x = _v959
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench
        _v960 = val1.force
        _x = _v960
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v961 = val1.torque
        _x = _v961
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v962 = val1.object
        _v963 = _v962.header
        buff.write(@@struct_L.pack(_v963.seq))
        _v964 = _v963.stamp
        _x = _v964
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v963.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v962.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v965 = _v962.type
        _x = _v965.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v965.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v962.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v962.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v962.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v962.primitive_poses
          _v966 = val3.position
          _x = _v966
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v967 = val3.orientation
          _x = _v967
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v962.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v962.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v962.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v962.mesh_poses
          _v968 = val3.position
          _x = _v968
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v969 = val3.orientation
          _x = _v969
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v962.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v962.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v962.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v962.plane_poses
          _v970 = val3.position
          _x = _v970
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v971 = val3.orientation
          _x = _v971
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v962.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v972 = val1.detach_posture
        _v973 = _v972.header
        buff.write(@@struct_L.pack(_v973.seq))
        _v974 = _v973.stamp
        _x = _v974
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v973.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v972.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v972.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v972.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v972.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v975 = val3.time_from_start
          _x = _v975
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_C.pack(@action_goal.goal.planning_options.planning_scene_diff.robot_state.is_diff))
      _x = @action_goal.goal.planning_options.planning_scene_diff.robot_model_name
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_goal.goal.planning_options.planning_scene_diff.fixed_frame_transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.fixed_frame_transforms
        _v976 = val1.header
        buff.write(@@struct_L.pack(_v976.seq))
        _v977 = _v976.stamp
        _x = _v977
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v976.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.child_frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v978 = val1.transform
        _v979 = _v978.translation
        _x = _v979
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v980 = _v978.rotation
        _x = _v980
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values
        length = val1.enabled.length
        buff.write(@@struct_L.pack(length))
        pattern = "C#{length}"
        buff.write(*val1.enabled.pack(pattern))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values.length
      buff.write(@@struct_L.pack(length))
      pattern = "C#{length}"
      buff.write(*@action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values.pack(pattern))
      length = @action_goal.goal.planning_options.planning_scene_diff.link_padding.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.link_padding
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_d.pack(val1.padding))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.link_scale.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.link_scale
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        buff.write(@@struct_d.pack(val1.scale))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.object_colors.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.object_colors
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v981 = val1.color
        _x = _v981
        buff.write(@@struct_f4.pack(_x.r, _x.g, _x.b, _x.a))
      end
      length = @action_goal.goal.planning_options.planning_scene_diff.world.collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_goal.goal.planning_options.planning_scene_diff.world.collision_objects
        _v982 = val1.header
        buff.write(@@struct_L.pack(_v982.seq))
        _v983 = _v982.stamp
        _x = _v983
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v982.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = val1.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v984 = val1.type
        _x = _v984.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v984.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = val1.primitives.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.primitives
          buff.write(@@struct_C.pack(val2.type))
          length = val2.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val2.dimensions.pack(pattern))
        end
        length = val1.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.primitive_poses
          _v985 = val2.position
          _x = _v985
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v986 = val2.orientation
          _x = _v986
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.meshes.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.meshes
          length = val2.triangles.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.triangles
            buff.write(@@struct_L3.pack(*val3.vertex_indices))
          end
          length = val2.vertices.length
          buff.write(@@struct_L.pack(length))
          for val3 in val2.vertices
            _x = val3
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = val1.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.mesh_poses
          _v987 = val2.position
          _x = _v987
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v988 = val2.orientation
          _x = _v988
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.planes.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.planes
          buff.write(@@struct_d4.pack(*val2.coef))
        end
        length = val1.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.plane_poses
          _v989 = val2.position
          _x = _v989
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v990 = val2.orientation
          _x = _v990
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(val1.operation))
      end
      buff.write(@@struct_L3.pack(@action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.seq, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.stamp.nsecs))
      _x = @action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d7L3.pack(@action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.position.x, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.position.y, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.position.z, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.x, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.y, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.z, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.w, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.seq, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.nsecs))
      _x = @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.binary))
      _x = @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_d.pack(@action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.resolution))
      length = @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.data.length
      buff.write(@@struct_L.pack(length))
      pattern = "c#{length}"
      buff.write(*@action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.data.pack(pattern))
      buff.write(@@struct_C3ldCldL3.pack(@action_goal.goal.planning_options.planning_scene_diff.is_diff, @action_goal.goal.planning_options.plan_only, @action_goal.goal.planning_options.look_around, @action_goal.goal.planning_options.look_around_attempts, @action_goal.goal.planning_options.max_safe_execution_cost, @action_goal.goal.planning_options.replan, @action_goal.goal.planning_options.replan_attempts, @action_goal.goal.planning_options.replan_delay, @action_result.header.seq, @action_result.header.stamp.secs, @action_result.header.stamp.nsecs))
      _x = @action_result.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_result.status.goal_id.stamp.secs, @action_result.status.goal_id.stamp.nsecs))
      _x = @action_result.status.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_result.status.status))
      _x = @action_result.status.text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_lL3.pack(@action_result.result.error_code.val, @action_result.result.trajectory_start.joint_state.header.seq, @action_result.result.trajectory_start.joint_state.header.stamp.secs, @action_result.result.trajectory_start.joint_state.header.stamp.nsecs))
      _x = @action_result.result.trajectory_start.joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_result.result.trajectory_start.joint_state.name.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.trajectory_start.joint_state.name
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_result.result.trajectory_start.joint_state.position.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_result.result.trajectory_start.joint_state.position.pack(pattern))
      length = @action_result.result.trajectory_start.joint_state.velocity.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_result.result.trajectory_start.joint_state.velocity.pack(pattern))
      length = @action_result.result.trajectory_start.joint_state.effort.length
      buff.write(@@struct_L.pack(length))
      pattern = "d#{length}"
      buff.write(*@action_result.result.trajectory_start.joint_state.effort.pack(pattern))
      buff.write(@@struct_L3.pack(@action_result.result.trajectory_start.multi_dof_joint_state.header.seq, @action_result.result.trajectory_start.multi_dof_joint_state.header.stamp.secs, @action_result.result.trajectory_start.multi_dof_joint_state.header.stamp.nsecs))
      _x = @action_result.result.trajectory_start.multi_dof_joint_state.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_result.result.trajectory_start.multi_dof_joint_state.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.trajectory_start.multi_dof_joint_state.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_result.result.trajectory_start.multi_dof_joint_state.transforms.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.trajectory_start.multi_dof_joint_state.transforms
        _v991 = val1.translation
        _x = _v991
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v992 = val1.rotation
        _x = _v992
        buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
      end
      length = @action_result.result.trajectory_start.multi_dof_joint_state.twist.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.trajectory_start.multi_dof_joint_state.twist
        _v993 = val1.linear
        _x = _v993
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v994 = val1.angular
        _x = _v994
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @action_result.result.trajectory_start.multi_dof_joint_state.wrench.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.trajectory_start.multi_dof_joint_state.wrench
        _v995 = val1.force
        _x = _v995
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        _v996 = val1.torque
        _x = _v996
        buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
      end
      length = @action_result.result.trajectory_start.attached_collision_objects.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.trajectory_start.attached_collision_objects
        _x = val1.link_name
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v997 = val1.object
        _v998 = _v997.header
        buff.write(@@struct_L.pack(_v998.seq))
        _v999 = _v998.stamp
        _x = _v999
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v998.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v997.id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _v1000 = _v997.type
        _x = _v1000.key
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        _x = _v1000.db
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v997.primitives.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v997.primitives
          buff.write(@@struct_C.pack(val3.type))
          length = val3.dimensions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.dimensions.pack(pattern))
        end
        length = _v997.primitive_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v997.primitive_poses
          _v1001 = val3.position
          _x = _v1001
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1002 = val3.orientation
          _x = _v1002
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v997.meshes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v997.meshes
          length = val3.triangles.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.triangles
            buff.write(@@struct_L3.pack(*val4.vertex_indices))
          end
          length = val3.vertices.length
          buff.write(@@struct_L.pack(length))
          for val4 in val3.vertices
            _x = val4
            buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          end
        end
        length = _v997.mesh_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v997.mesh_poses
          _v1003 = val3.position
          _x = _v1003
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1004 = val3.orientation
          _x = _v1004
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = _v997.planes.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v997.planes
          buff.write(@@struct_d4.pack(*val3.coef))
        end
        length = _v997.plane_poses.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v997.plane_poses
          _v1005 = val3.position
          _x = _v1005
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1006 = val3.orientation
          _x = _v1006
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        buff.write(@@struct_c.pack(_v997.operation))
        length = val1.touch_links.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.touch_links
          length = val2.length
          buff.write([length, val2].pack("La#{length}"))
        end
        _v1007 = val1.detach_posture
        _v1008 = _v1007.header
        buff.write(@@struct_L.pack(_v1008.seq))
        _v1009 = _v1008.stamp
        _x = _v1009
        buff.write(@@struct_L2.pack(_x.secs, _x.nsecs))
        _x = _v1008.frame_id
        length = _x.length
        buff.write([length, _x].pack("La#{length}"))
        length = _v1007.joint_names.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1007.joint_names
          length = val3.length
          buff.write([length, val3].pack("La#{length}"))
        end
        length = _v1007.points.length
        buff.write(@@struct_L.pack(length))
        for val3 in _v1007.points
          length = val3.positions.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.positions.pack(pattern))
          length = val3.velocities.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.velocities.pack(pattern))
          length = val3.accelerations.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.accelerations.pack(pattern))
          length = val3.effort.length
          buff.write(@@struct_L.pack(length))
          pattern = "d#{length}"
          buff.write(*val3.effort.pack(pattern))
          _v1010 = val3.time_from_start
          _x = _v1010
          buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
        end
        buff.write(@@struct_d.pack(val1.weight))
      end
      buff.write(@@struct_CL3.pack(@action_result.result.trajectory_start.is_diff, @action_result.result.planned_trajectory.joint_trajectory.header.seq, @action_result.result.planned_trajectory.joint_trajectory.header.stamp.secs, @action_result.result.planned_trajectory.joint_trajectory.header.stamp.nsecs))
      _x = @action_result.result.planned_trajectory.joint_trajectory.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_result.result.planned_trajectory.joint_trajectory.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.planned_trajectory.joint_trajectory.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_result.result.planned_trajectory.joint_trajectory.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.planned_trajectory.joint_trajectory.points
        length = val1.positions.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.positions.pack(pattern))
        length = val1.velocities.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.velocities.pack(pattern))
        length = val1.accelerations.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.accelerations.pack(pattern))
        length = val1.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.effort.pack(pattern))
        _v1011 = val1.time_from_start
        _x = _v1011
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_L3.pack(@action_result.result.planned_trajectory.multi_dof_joint_trajectory.header.seq, @action_result.result.planned_trajectory.multi_dof_joint_trajectory.header.stamp.secs, @action_result.result.planned_trajectory.multi_dof_joint_trajectory.header.stamp.nsecs))
      _x = @action_result.result.planned_trajectory.multi_dof_joint_trajectory.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_result.result.planned_trajectory.multi_dof_joint_trajectory.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.planned_trajectory.multi_dof_joint_trajectory.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_result.result.planned_trajectory.multi_dof_joint_trajectory.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.planned_trajectory.multi_dof_joint_trajectory.points
        length = val1.transforms.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.transforms
          _v1012 = val2.translation
          _x = _v1012
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1013 = val2.rotation
          _x = _v1013
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.velocities.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.velocities
          _v1014 = val2.linear
          _x = _v1014
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1015 = val2.angular
          _x = _v1015
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        length = val1.accelerations.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.accelerations
          _v1016 = val2.linear
          _x = _v1016
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1017 = val2.angular
          _x = _v1017
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        _v1018 = val1.time_from_start
        _x = _v1018
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_L3.pack(@action_result.result.executed_trajectory.joint_trajectory.header.seq, @action_result.result.executed_trajectory.joint_trajectory.header.stamp.secs, @action_result.result.executed_trajectory.joint_trajectory.header.stamp.nsecs))
      _x = @action_result.result.executed_trajectory.joint_trajectory.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_result.result.executed_trajectory.joint_trajectory.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.executed_trajectory.joint_trajectory.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_result.result.executed_trajectory.joint_trajectory.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.executed_trajectory.joint_trajectory.points
        length = val1.positions.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.positions.pack(pattern))
        length = val1.velocities.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.velocities.pack(pattern))
        length = val1.accelerations.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.accelerations.pack(pattern))
        length = val1.effort.length
        buff.write(@@struct_L.pack(length))
        pattern = "d#{length}"
        buff.write(*val1.effort.pack(pattern))
        _v1019 = val1.time_from_start
        _x = _v1019
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_L3.pack(@action_result.result.executed_trajectory.multi_dof_joint_trajectory.header.seq, @action_result.result.executed_trajectory.multi_dof_joint_trajectory.header.stamp.secs, @action_result.result.executed_trajectory.multi_dof_joint_trajectory.header.stamp.nsecs))
      _x = @action_result.result.executed_trajectory.multi_dof_joint_trajectory.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      length = @action_result.result.executed_trajectory.multi_dof_joint_trajectory.joint_names.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.executed_trajectory.multi_dof_joint_trajectory.joint_names
        length = val1.length
        buff.write([length, val1].pack("La#{length}"))
      end
      length = @action_result.result.executed_trajectory.multi_dof_joint_trajectory.points.length
      buff.write(@@struct_L.pack(length))
      for val1 in @action_result.result.executed_trajectory.multi_dof_joint_trajectory.points
        length = val1.transforms.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.transforms
          _v1020 = val2.translation
          _x = _v1020
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1021 = val2.rotation
          _x = _v1021
          buff.write(@@struct_d4.pack(_x.x, _x.y, _x.z, _x.w))
        end
        length = val1.velocities.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.velocities
          _v1022 = val2.linear
          _x = _v1022
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1023 = val2.angular
          _x = _v1023
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        length = val1.accelerations.length
        buff.write(@@struct_L.pack(length))
        for val2 in val1.accelerations
          _v1024 = val2.linear
          _x = _v1024
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
          _v1025 = val2.angular
          _x = _v1025
          buff.write(@@struct_d3.pack(_x.x, _x.y, _x.z))
        end
        _v1026 = val1.time_from_start
        _x = _v1026
        buff.write(@@struct_l2.pack(_x.secs, _x.nsecs))
      end
      buff.write(@@struct_dL3.pack(@action_result.result.planning_time, @action_feedback.header.seq, @action_feedback.header.stamp.secs, @action_feedback.header.stamp.nsecs))
      _x = @action_feedback.header.frame_id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_L2.pack(@action_feedback.status.goal_id.stamp.secs, @action_feedback.status.goal_id.stamp.nsecs))
      _x = @action_feedback.status.goal_id.id
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      buff.write(@@struct_C.pack(@action_feedback.status.status))
      _x = @action_feedback.status.text
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
      _x = @action_feedback.feedback.state
      length = _x.length
      buff.write([length, _x].pack("La#{length}"))
    rescue => exception
      raise "some erro in serialize: #{exception}"

    end
  end

  #  unpack serialized message in str into this message instance
  #  @param [String] str: byte array of serialized message
  def deserialize(str)

    begin
      if @action_goal == nil
        @action_goal = Moveit_msgs::MoveGroupActionGoal.new
      end
      if @action_result == nil
        @action_result = Moveit_msgs::MoveGroupActionResult.new
      end
      if @action_feedback == nil
        @action_feedback = Moveit_msgs::MoveGroupActionFeedback.new
      end
      end_point = 0
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.header.seq, @action_goal.header.stamp.secs, @action_goal.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_goal.goal_id.stamp.secs, @action_goal.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.goal.request.workspace_parameters.header.seq, @action_goal.goal.request.workspace_parameters.header.stamp.secs, @action_goal.goal.request.workspace_parameters.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.request.workspace_parameters.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d6L3')
      (@action_goal.goal.request.workspace_parameters.min_corner.x, @action_goal.goal.request.workspace_parameters.min_corner.y, @action_goal.goal.request.workspace_parameters.min_corner.z, @action_goal.goal.request.workspace_parameters.max_corner.x, @action_goal.goal.request.workspace_parameters.max_corner.y, @action_goal.goal.request.workspace_parameters.max_corner.z, @action_goal.goal.request.start_state.joint_state.header.seq, @action_goal.goal.request.start_state.joint_state.header.stamp.secs, @action_goal.goal.request.start_state.joint_state.header.stamp.nsecs,) = @@struct_d6L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.request.start_state.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.request.start_state.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_goal.goal.request.start_state.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.request.start_state.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.request.start_state.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.request.start_state.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.goal.request.start_state.multi_dof_joint_state.header.seq, @action_goal.goal.request.start_state.multi_dof_joint_state.header.stamp.secs, @action_goal.goal.request.start_state.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.request.start_state.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.request.start_state.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_goal.goal.request.start_state.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.request.start_state.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v1027 = val1.translation
        _x = _v1027
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1028 = val1.rotation
        _x = _v1028
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @action_goal.goal.request.start_state.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.request.start_state.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v1029 = val1.linear
        _x = _v1029
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1030 = val1.angular
        _x = _v1030
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @action_goal.goal.request.start_state.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.request.start_state.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v1031 = val1.force
        _x = _v1031
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1032 = val1.torque
        _x = _v1032
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @action_goal.goal.request.start_state.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.request.start_state.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v1033 = val1.object
        _v1034 = _v1033.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1034.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1035 = _v1034.stamp
        _x = _v1035
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1034.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1033.id = str[start..(end_point-1)]
        _v1036 = _v1033.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1036.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1036.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1033.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v1033.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1033.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1037 = val3.position
          _x = _v1037
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1038 = val3.orientation
          _x = _v1038
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1033.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1033.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v1033.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1033.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1039 = val3.position
          _x = _v1039
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1040 = val3.orientation
          _x = _v1040
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1033.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1033.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1033.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1033.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1041 = val3.position
          _x = _v1041
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1042 = val3.orientation
          _x = _v1042
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1033.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v1033.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v1043 = val1.detach_posture
        _v1044 = _v1043.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1044.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1045 = _v1044.stamp
        _x = _v1045
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1044.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1043.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v1043.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1043.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v1046 = val3.time_from_start
          _x = _v1046
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v1043.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @action_goal.goal.request.start_state.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_goal.goal.request.start_state.is_diff,) = @@struct_C.unpack(str[start..(end_point-1)])
      @action_goal.goal.request.start_state.is_diff = bool(@action_goal.goal.request.start_state.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.request.goal_constraints = []
      length.times do
        val1 = Moveit_msgs::Constraints.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.joint_constraints = []
        length.times do
          val2 = Moveit_msgs::JointConstraint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.joint_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.joint_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.position_constraints = []
        length.times do
          val2 = Moveit_msgs::PositionConstraint.new
          _v1047 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1047.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1048 = _v1047.stamp
          _x = _v1048
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1047.frame_id = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _v1049 = val2.target_point_offset
          _x = _v1049
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1050 = val2.constraint_region
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1050.primitives = []
          length.times do
            val4 = Shape_msgs::SolidPrimitive.new
            start = end_point
            end_point += ROS::Struct::calc_size('C')
            (val4.type,) = @@struct_C.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            pattern = "d#{length}"
            start = end_point
            end_point += ROS::Struct::calc_size("#{pattern}")
            val4.dimensions = str[start..(end_point-1)].unpack(pattern)
            _v1050.primitives.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1050.primitive_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v1051 = val4.position
            _x = _v1051
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v1052 = val4.orientation
            _x = _v1052
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v1050.primitive_poses.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1050.meshes = []
          length.times do
            val4 = Shape_msgs::Mesh.new
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.triangles = []
            length.times do
              val5 = Shape_msgs::MeshTriangle.new
              start = end_point
              end_point += ROS::Struct::calc_size('L3')
              val5.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
              val4.triangles.push(val5)
            end
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.vertices = []
            length.times do
              val5 = Geometry_msgs::Point.new
              _x = val5
              start = end_point
              end_point += ROS::Struct::calc_size('d3')
              (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
              val4.vertices.push(val5)
            end
            _v1050.meshes.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1050.mesh_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v1053 = val4.position
            _x = _v1053
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v1054 = val4.orientation
            _x = _v1054
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v1050.mesh_poses.push(val4)
          end
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
          val1.position_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.orientation_constraints = []
        length.times do
          val2 = Moveit_msgs::OrientationConstraint.new
          _v1055 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1055.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1056 = _v1055.stamp
          _x = _v1056
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1055.frame_id = str[start..(end_point-1)]
          _v1057 = val2.orientation
          _x = _v1057
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.orientation_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.visibility_constraints = []
        length.times do
          val2 = Moveit_msgs::VisibilityConstraint.new
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.target_radius,) = @@struct_d.unpack(str[start..(end_point-1)])
          _v1058 = val2.target_pose
          _v1059 = _v1058.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1059.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1060 = _v1059.stamp
          _x = _v1060
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1059.frame_id = str[start..(end_point-1)]
          _v1061 = _v1058.pose
          _v1062 = _v1061.position
          _x = _v1062
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1063 = _v1061.orientation
          _x = _v1063
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += ROS::Struct::calc_size('l')
          (val2.cone_sides,) = @@struct_l.unpack(str[start..(end_point-1)])
          _v1064 = val2.sensor_pose
          _v1065 = _v1064.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1065.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1066 = _v1065.stamp
          _x = _v1066
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1065.frame_id = str[start..(end_point-1)]
          _v1067 = _v1064.pose
          _v1068 = _v1067.position
          _x = _v1068
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1069 = _v1067.orientation
          _x = _v1069
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d2Cd')
          (_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight,) = @@struct_d2Cd.unpack(str[start..(end_point-1)])
          val1.visibility_constraints.push(val2)
        end
        @action_goal.goal.request.goal_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.request.path_constraints.name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.request.path_constraints.joint_constraints = []
      length.times do
        val1 = Moveit_msgs::JointConstraint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.joint_name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @action_goal.goal.request.path_constraints.joint_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.request.path_constraints.position_constraints = []
      length.times do
        val1 = Moveit_msgs::PositionConstraint.new
        _v1070 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1070.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1071 = _v1070.stamp
        _x = _v1071
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1070.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v1072 = val1.target_point_offset
        _x = _v1072
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1073 = val1.constraint_region
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1073.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v1073.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1073.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1074 = val3.position
          _x = _v1074
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1075 = val3.orientation
          _x = _v1075
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1073.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1073.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v1073.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1073.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1076 = val3.position
          _x = _v1076
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1077 = val3.orientation
          _x = _v1077
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1073.mesh_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @action_goal.goal.request.path_constraints.position_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.request.path_constraints.orientation_constraints = []
      length.times do
        val1 = Moveit_msgs::OrientationConstraint.new
        _v1078 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1078.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1079 = _v1078.stamp
        _x = _v1079
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1078.frame_id = str[start..(end_point-1)]
        _v1080 = val1.orientation
        _x = _v1080
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @action_goal.goal.request.path_constraints.orientation_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.request.path_constraints.visibility_constraints = []
      length.times do
        val1 = Moveit_msgs::VisibilityConstraint.new
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.target_radius,) = @@struct_d.unpack(str[start..(end_point-1)])
        _v1081 = val1.target_pose
        _v1082 = _v1081.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1082.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1083 = _v1082.stamp
        _x = _v1083
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1082.frame_id = str[start..(end_point-1)]
        _v1084 = _v1081.pose
        _v1085 = _v1084.position
        _x = _v1085
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1086 = _v1084.orientation
        _x = _v1086
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += ROS::Struct::calc_size('l')
        (val1.cone_sides,) = @@struct_l.unpack(str[start..(end_point-1)])
        _v1087 = val1.sensor_pose
        _v1088 = _v1087.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1088.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1089 = _v1088.stamp
        _x = _v1089
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1088.frame_id = str[start..(end_point-1)]
        _v1090 = _v1087.pose
        _v1091 = _v1090.position
        _x = _v1091
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1092 = _v1090.orientation
        _x = _v1092
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        _x = val1
        start = end_point
        end_point += ROS::Struct::calc_size('d2Cd')
        (_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight,) = @@struct_d2Cd.unpack(str[start..(end_point-1)])
        @action_goal.goal.request.path_constraints.visibility_constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.request.trajectory_constraints.constraints = []
      length.times do
        val1 = Moveit_msgs::Constraints.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.name = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.joint_constraints = []
        length.times do
          val2 = Moveit_msgs::JointConstraint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.joint_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.position, _x.tolerance_above, _x.tolerance_below, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.joint_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.position_constraints = []
        length.times do
          val2 = Moveit_msgs::PositionConstraint.new
          _v1093 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1093.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1094 = _v1093.stamp
          _x = _v1094
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1093.frame_id = str[start..(end_point-1)]
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _v1095 = val2.target_point_offset
          _x = _v1095
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1096 = val2.constraint_region
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1096.primitives = []
          length.times do
            val4 = Shape_msgs::SolidPrimitive.new
            start = end_point
            end_point += ROS::Struct::calc_size('C')
            (val4.type,) = @@struct_C.unpack(str[start..(end_point-1)])
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            pattern = "d#{length}"
            start = end_point
            end_point += ROS::Struct::calc_size("#{pattern}")
            val4.dimensions = str[start..(end_point-1)].unpack(pattern)
            _v1096.primitives.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1096.primitive_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v1097 = val4.position
            _x = _v1097
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v1098 = val4.orientation
            _x = _v1098
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v1096.primitive_poses.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1096.meshes = []
          length.times do
            val4 = Shape_msgs::Mesh.new
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.triangles = []
            length.times do
              val5 = Shape_msgs::MeshTriangle.new
              start = end_point
              end_point += ROS::Struct::calc_size('L3')
              val5.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
              val4.triangles.push(val5)
            end
            start = end_point
            end_point += 4
            (length,) = @@struct_L.unpack(str[start..(end_point-1)])
            val4.vertices = []
            length.times do
              val5 = Geometry_msgs::Point.new
              _x = val5
              start = end_point
              end_point += ROS::Struct::calc_size('d3')
              (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
              val4.vertices.push(val5)
            end
            _v1096.meshes.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1096.mesh_poses = []
          length.times do
            val4 = Geometry_msgs::Pose.new
            _v1099 = val4.position
            _x = _v1099
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            _v1100 = val4.orientation
            _x = _v1100
            start = end_point
            end_point += ROS::Struct::calc_size('d4')
            (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
            _v1096.mesh_poses.push(val4)
          end
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
          val1.position_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.orientation_constraints = []
        length.times do
          val2 = Moveit_msgs::OrientationConstraint.new
          _v1101 = val2.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1101.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1102 = _v1101.stamp
          _x = _v1102
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1101.frame_id = str[start..(end_point-1)]
          _v1103 = val2.orientation
          _x = _v1103
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2.link_name = str[start..(end_point-1)]
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.absolute_x_axis_tolerance, _x.absolute_y_axis_tolerance, _x.absolute_z_axis_tolerance, _x.weight,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.orientation_constraints.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.visibility_constraints = []
        length.times do
          val2 = Moveit_msgs::VisibilityConstraint.new
          start = end_point
          end_point += ROS::Struct::calc_size('d')
          (val2.target_radius,) = @@struct_d.unpack(str[start..(end_point-1)])
          _v1104 = val2.target_pose
          _v1105 = _v1104.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1105.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1106 = _v1105.stamp
          _x = _v1106
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1105.frame_id = str[start..(end_point-1)]
          _v1107 = _v1104.pose
          _v1108 = _v1107.position
          _x = _v1108
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1109 = _v1107.orientation
          _x = _v1109
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += ROS::Struct::calc_size('l')
          (val2.cone_sides,) = @@struct_l.unpack(str[start..(end_point-1)])
          _v1110 = val2.sensor_pose
          _v1111 = _v1110.header
          start = end_point
          end_point += ROS::Struct::calc_size('L')
          (_v1111.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
          _v1112 = _v1111.stamp
          _x = _v1112
          start = end_point
          end_point += ROS::Struct::calc_size('L2')
          (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          _v1111.frame_id = str[start..(end_point-1)]
          _v1113 = _v1110.pose
          _v1114 = _v1113.position
          _x = _v1114
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1115 = _v1113.orientation
          _x = _v1115
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _x = val2
          start = end_point
          end_point += ROS::Struct::calc_size('d2Cd')
          (_x.max_view_angle, _x.max_range_angle, _x.sensor_view_direction, _x.weight,) = @@struct_d2Cd.unpack(str[start..(end_point-1)])
          val1.visibility_constraints.push(val2)
        end
        @action_goal.goal.request.trajectory_constraints.constraints.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.request.planner_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.request.group_name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('ld')
      (@action_goal.goal.request.num_planning_attempts, @action_goal.goal.request.allowed_planning_time,) = @@struct_ld.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planning_options.planning_scene_diff.name = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.seq, @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.seq, @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v1116 = val1.translation
        _x = _v1116
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1117 = val1.rotation
        _x = _v1117
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v1118 = val1.linear
        _x = _v1118
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1119 = val1.angular
        _x = _v1119
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v1120 = val1.force
        _x = _v1120
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1121 = val1.torque
        _x = _v1121
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.robot_state.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v1122 = val1.object
        _v1123 = _v1122.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1123.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1124 = _v1123.stamp
        _x = _v1124
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1123.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1122.id = str[start..(end_point-1)]
        _v1125 = _v1122.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1125.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1125.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1122.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v1122.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1122.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1126 = val3.position
          _x = _v1126
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1127 = val3.orientation
          _x = _v1127
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1122.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1122.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v1122.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1122.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1128 = val3.position
          _x = _v1128
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1129 = val3.orientation
          _x = _v1129
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1122.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1122.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1122.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1122.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1130 = val3.position
          _x = _v1130
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1131 = val3.orientation
          _x = _v1131
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1122.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v1122.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v1132 = val1.detach_posture
        _v1133 = _v1132.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1133.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1134 = _v1133.stamp
        _x = _v1134
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1133.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1132.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v1132.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1132.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v1135 = val3.time_from_start
          _x = _v1135
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v1132.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.robot_state.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_goal.goal.planning_options.planning_scene_diff.robot_state.is_diff,) = @@struct_C.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.robot_state.is_diff = bool(@action_goal.goal.planning_options.planning_scene_diff.robot_state.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planning_options.planning_scene_diff.robot_model_name = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.fixed_frame_transforms = []
      length.times do
        val1 = Geometry_msgs::TransformStamped.new
        _v1136 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1136.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1137 = _v1136.stamp
        _x = _v1137
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1136.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.child_frame_id = str[start..(end_point-1)]
        _v1138 = val1.transform
        _v1139 = _v1138.translation
        _x = _v1139
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1140 = _v1138.rotation
        _x = _v1140
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.fixed_frame_transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values = []
      length.times do
        val1 = Moveit_msgs::AllowedCollisionEntry.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "C#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.enabled = str[start..(end_point-1)].unpack(pattern)
        val1.enabled = map(bool, val1.enabled)
        @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.entry_values.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "C#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values = str[start..(end_point-1)].unpack(pattern)
      @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values = map(bool, @action_goal.goal.planning_options.planning_scene_diff.allowed_collision_matrix.default_entry_values)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.link_padding = []
      length.times do
        val1 = Moveit_msgs::LinkPadding.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.padding,) = @@struct_d.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.link_padding.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.link_scale = []
      length.times do
        val1 = Moveit_msgs::LinkScale.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.scale,) = @@struct_d.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.link_scale.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.object_colors = []
      length.times do
        val1 = Moveit_msgs::ObjectColor.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v1141 = val1.color
        _x = _v1141
        start = end_point
        end_point += ROS::Struct::calc_size('f4')
        (_x.r, _x.g, _x.b, _x.a,) = @@struct_f4.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.object_colors.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.world.collision_objects = []
      length.times do
        val1 = Moveit_msgs::CollisionObject.new
        _v1142 = val1.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1142.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1143 = _v1142.stamp
        _x = _v1143
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1142.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.id = str[start..(end_point-1)]
        _v1144 = val1.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1144.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1144.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.primitives = []
        length.times do
          val2 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val2.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val2.dimensions = str[start..(end_point-1)].unpack(pattern)
          val1.primitives.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.primitive_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v1145 = val2.position
          _x = _v1145
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1146 = val2.orientation
          _x = _v1146
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.primitive_poses.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.meshes = []
        length.times do
          val2 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.triangles = []
          length.times do
            val3 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val3.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val2.triangles.push(val3)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val2.vertices = []
          length.times do
            val3 = Geometry_msgs::Point.new
            _x = val3
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val2.vertices.push(val3)
          end
          val1.meshes.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.mesh_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v1147 = val2.position
          _x = _v1147
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1148 = val2.orientation
          _x = _v1148
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.mesh_poses.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.planes = []
        length.times do
          val2 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val2.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.planes.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.plane_poses = []
        length.times do
          val2 = Geometry_msgs::Pose.new
          _v1149 = val2.position
          _x = _v1149
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1150 = val2.orientation
          _x = _v1150
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.plane_poses.push(val2)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (val1.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        @action_goal.goal.planning_options.planning_scene_diff.world.collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.seq, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planning_options.planning_scene_diff.world.octomap.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d7L3')
      (@action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.position.x, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.position.y, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.position.z, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.x, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.y, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.z, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.origin.orientation.w, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.seq, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.secs, @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.stamp.nsecs,) = @@struct_d7L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.binary,) = @@struct_C.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.binary = bool(@action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.binary)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('d')
      (@action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.resolution,) = @@struct_d.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "c#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_goal.goal.planning_options.planning_scene_diff.world.octomap.octomap.data = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('C3ldCldL3')
      (@action_goal.goal.planning_options.planning_scene_diff.is_diff, @action_goal.goal.planning_options.plan_only, @action_goal.goal.planning_options.look_around, @action_goal.goal.planning_options.look_around_attempts, @action_goal.goal.planning_options.max_safe_execution_cost, @action_goal.goal.planning_options.replan, @action_goal.goal.planning_options.replan_attempts, @action_goal.goal.planning_options.replan_delay, @action_result.header.seq, @action_result.header.stamp.secs, @action_result.header.stamp.nsecs,) = @@struct_C3ldCldL3.unpack(str[start..(end_point-1)])
      @action_goal.goal.planning_options.planning_scene_diff.is_diff = bool(@action_goal.goal.planning_options.planning_scene_diff.is_diff)
      @action_goal.goal.planning_options.plan_only = bool(@action_goal.goal.planning_options.plan_only)
      @action_goal.goal.planning_options.look_around = bool(@action_goal.goal.planning_options.look_around)
      @action_goal.goal.planning_options.replan = bool(@action_goal.goal.planning_options.replan)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_result.status.goal_id.stamp.secs, @action_result.status.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.status.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_result.status.status,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.status.text = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('lL3')
      (@action_result.result.error_code.val, @action_result.result.trajectory_start.joint_state.header.seq, @action_result.result.trajectory_start.joint_state.header.stamp.secs, @action_result.result.trajectory_start.joint_state.header.stamp.nsecs,) = @@struct_lL3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.trajectory_start.joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_start.joint_state.name = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_result.result.trajectory_start.joint_state.name.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_result.result.trajectory_start.joint_state.position = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_result.result.trajectory_start.joint_state.velocity = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      pattern = "d#{length}"
      start = end_point
      end_point += ROS::Struct::calc_size("#{pattern}")
      @action_result.result.trajectory_start.joint_state.effort = str[start..(end_point-1)].unpack(pattern)
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_result.result.trajectory_start.multi_dof_joint_state.header.seq, @action_result.result.trajectory_start.multi_dof_joint_state.header.stamp.secs, @action_result.result.trajectory_start.multi_dof_joint_state.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.trajectory_start.multi_dof_joint_state.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_start.multi_dof_joint_state.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_result.result.trajectory_start.multi_dof_joint_state.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_start.multi_dof_joint_state.transforms = []
      length.times do
        val1 = Geometry_msgs::Transform.new
        _v1151 = val1.translation
        _x = _v1151
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1152 = val1.rotation
        _x = _v1152
        start = end_point
        end_point += ROS::Struct::calc_size('d4')
        (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
        @action_result.result.trajectory_start.multi_dof_joint_state.transforms.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_start.multi_dof_joint_state.twist = []
      length.times do
        val1 = Geometry_msgs::Twist.new
        _v1153 = val1.linear
        _x = _v1153
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1154 = val1.angular
        _x = _v1154
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @action_result.result.trajectory_start.multi_dof_joint_state.twist.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_start.multi_dof_joint_state.wrench = []
      length.times do
        val1 = Geometry_msgs::Wrench.new
        _v1155 = val1.force
        _x = _v1155
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        _v1156 = val1.torque
        _x = _v1156
        start = end_point
        end_point += ROS::Struct::calc_size('d3')
        (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
        @action_result.result.trajectory_start.multi_dof_joint_state.wrench.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_start.attached_collision_objects = []
      length.times do
        val1 = Moveit_msgs::AttachedCollisionObject.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1.link_name = str[start..(end_point-1)]
        _v1157 = val1.object
        _v1158 = _v1157.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1158.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1159 = _v1158.stamp
        _x = _v1159
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1158.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1157.id = str[start..(end_point-1)]
        _v1160 = _v1157.type
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1160.key = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1160.db = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1157.primitives = []
        length.times do
          val3 = Shape_msgs::SolidPrimitive.new
          start = end_point
          end_point += ROS::Struct::calc_size('C')
          (val3.type,) = @@struct_C.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.dimensions = str[start..(end_point-1)].unpack(pattern)
          _v1157.primitives.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1157.primitive_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1161 = val3.position
          _x = _v1161
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1162 = val3.orientation
          _x = _v1162
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1157.primitive_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1157.meshes = []
        length.times do
          val3 = Shape_msgs::Mesh.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.triangles = []
          length.times do
            val4 = Shape_msgs::MeshTriangle.new
            start = end_point
            end_point += ROS::Struct::calc_size('L3')
            val4.vertex_indices = @@struct_L3.unpack(str[start..(end_point-1)])
            val3.triangles.push(val4)
          end
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          val3.vertices = []
          length.times do
            val4 = Geometry_msgs::Point.new
            _x = val4
            start = end_point
            end_point += ROS::Struct::calc_size('d3')
            (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
            val3.vertices.push(val4)
          end
          _v1157.meshes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1157.mesh_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1163 = val3.position
          _x = _v1163
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1164 = val3.orientation
          _x = _v1164
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1157.mesh_poses.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1157.planes = []
        length.times do
          val3 = Shape_msgs::Plane.new
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          val3.coef = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1157.planes.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1157.plane_poses = []
        length.times do
          val3 = Geometry_msgs::Pose.new
          _v1165 = val3.position
          _x = _v1165
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1166 = val3.orientation
          _x = _v1166
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          _v1157.plane_poses.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('c')
        (_v1157.operation,) = @@struct_c.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.touch_links = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val2 = str[start..(end_point-1)]
          val1.touch_links.push(val2)
        end
        _v1167 = val1.detach_posture
        _v1168 = _v1167.header
        start = end_point
        end_point += ROS::Struct::calc_size('L')
        (_v1168.seq,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1169 = _v1168.stamp
        _x = _v1169
        start = end_point
        end_point += ROS::Struct::calc_size('L2')
        (_x.secs, _x.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        _v1168.frame_id = str[start..(end_point-1)]
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1167.joint_names = []
        length.times do
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          start = end_point
          end_point += length
          val3 = str[start..(end_point-1)]
          _v1167.joint_names.push(val3)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        _v1167.points = []
        length.times do
          val3 = Trajectory_msgs::JointTrajectoryPoint.new
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.positions = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.velocities = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.accelerations = str[start..(end_point-1)].unpack(pattern)
          start = end_point
          end_point += 4
          (length,) = @@struct_L.unpack(str[start..(end_point-1)])
          pattern = "d#{length}"
          start = end_point
          end_point += ROS::Struct::calc_size("#{pattern}")
          val3.effort = str[start..(end_point-1)].unpack(pattern)
          _v1170 = val3.time_from_start
          _x = _v1170
          start = end_point
          end_point += ROS::Struct::calc_size('l2')
          (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
          _v1167.points.push(val3)
        end
        start = end_point
        end_point += ROS::Struct::calc_size('d')
        (val1.weight,) = @@struct_d.unpack(str[start..(end_point-1)])
        @action_result.result.trajectory_start.attached_collision_objects.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('CL3')
      (@action_result.result.trajectory_start.is_diff, @action_result.result.planned_trajectory.joint_trajectory.header.seq, @action_result.result.planned_trajectory.joint_trajectory.header.stamp.secs, @action_result.result.planned_trajectory.joint_trajectory.header.stamp.nsecs,) = @@struct_CL3.unpack(str[start..(end_point-1)])
      @action_result.result.trajectory_start.is_diff = bool(@action_result.result.trajectory_start.is_diff)
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.planned_trajectory.joint_trajectory.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.planned_trajectory.joint_trajectory.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_result.result.planned_trajectory.joint_trajectory.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.planned_trajectory.joint_trajectory.points = []
      length.times do
        val1 = Trajectory_msgs::JointTrajectoryPoint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.positions = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.velocities = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.accelerations = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.effort = str[start..(end_point-1)].unpack(pattern)
        _v1171 = val1.time_from_start
        _x = _v1171
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @action_result.result.planned_trajectory.joint_trajectory.points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_result.result.planned_trajectory.multi_dof_joint_trajectory.header.seq, @action_result.result.planned_trajectory.multi_dof_joint_trajectory.header.stamp.secs, @action_result.result.planned_trajectory.multi_dof_joint_trajectory.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.planned_trajectory.multi_dof_joint_trajectory.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.planned_trajectory.multi_dof_joint_trajectory.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_result.result.planned_trajectory.multi_dof_joint_trajectory.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.planned_trajectory.multi_dof_joint_trajectory.points = []
      length.times do
        val1 = Trajectory_msgs::MultiDOFJointTrajectoryPoint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.transforms = []
        length.times do
          val2 = Geometry_msgs::Transform.new
          _v1172 = val2.translation
          _x = _v1172
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1173 = val2.rotation
          _x = _v1173
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.transforms.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.velocities = []
        length.times do
          val2 = Geometry_msgs::Twist.new
          _v1174 = val2.linear
          _x = _v1174
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1175 = val2.angular
          _x = _v1175
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.velocities.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.accelerations = []
        length.times do
          val2 = Geometry_msgs::Twist.new
          _v1176 = val2.linear
          _x = _v1176
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1177 = val2.angular
          _x = _v1177
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.accelerations.push(val2)
        end
        _v1178 = val1.time_from_start
        _x = _v1178
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @action_result.result.planned_trajectory.multi_dof_joint_trajectory.points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_result.result.executed_trajectory.joint_trajectory.header.seq, @action_result.result.executed_trajectory.joint_trajectory.header.stamp.secs, @action_result.result.executed_trajectory.joint_trajectory.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.executed_trajectory.joint_trajectory.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.executed_trajectory.joint_trajectory.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_result.result.executed_trajectory.joint_trajectory.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.executed_trajectory.joint_trajectory.points = []
      length.times do
        val1 = Trajectory_msgs::JointTrajectoryPoint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.positions = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.velocities = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.accelerations = str[start..(end_point-1)].unpack(pattern)
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        pattern = "d#{length}"
        start = end_point
        end_point += ROS::Struct::calc_size("#{pattern}")
        val1.effort = str[start..(end_point-1)].unpack(pattern)
        _v1179 = val1.time_from_start
        _x = _v1179
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @action_result.result.executed_trajectory.joint_trajectory.points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('L3')
      (@action_result.result.executed_trajectory.multi_dof_joint_trajectory.header.seq, @action_result.result.executed_trajectory.multi_dof_joint_trajectory.header.stamp.secs, @action_result.result.executed_trajectory.multi_dof_joint_trajectory.header.stamp.nsecs,) = @@struct_L3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_result.result.executed_trajectory.multi_dof_joint_trajectory.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.executed_trajectory.multi_dof_joint_trajectory.joint_names = []
      length.times do
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        start = end_point
        end_point += length
        val1 = str[start..(end_point-1)]
        @action_result.result.executed_trajectory.multi_dof_joint_trajectory.joint_names.push(val1)
      end
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      @action_result.result.executed_trajectory.multi_dof_joint_trajectory.points = []
      length.times do
        val1 = Trajectory_msgs::MultiDOFJointTrajectoryPoint.new
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.transforms = []
        length.times do
          val2 = Geometry_msgs::Transform.new
          _v1180 = val2.translation
          _x = _v1180
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1181 = val2.rotation
          _x = _v1181
          start = end_point
          end_point += ROS::Struct::calc_size('d4')
          (_x.x, _x.y, _x.z, _x.w,) = @@struct_d4.unpack(str[start..(end_point-1)])
          val1.transforms.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.velocities = []
        length.times do
          val2 = Geometry_msgs::Twist.new
          _v1182 = val2.linear
          _x = _v1182
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1183 = val2.angular
          _x = _v1183
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.velocities.push(val2)
        end
        start = end_point
        end_point += 4
        (length,) = @@struct_L.unpack(str[start..(end_point-1)])
        val1.accelerations = []
        length.times do
          val2 = Geometry_msgs::Twist.new
          _v1184 = val2.linear
          _x = _v1184
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          _v1185 = val2.angular
          _x = _v1185
          start = end_point
          end_point += ROS::Struct::calc_size('d3')
          (_x.x, _x.y, _x.z,) = @@struct_d3.unpack(str[start..(end_point-1)])
          val1.accelerations.push(val2)
        end
        _v1186 = val1.time_from_start
        _x = _v1186
        start = end_point
        end_point += ROS::Struct::calc_size('l2')
        (_x.secs, _x.nsecs,) = @@struct_l2.unpack(str[start..(end_point-1)])
        @action_result.result.executed_trajectory.multi_dof_joint_trajectory.points.push(val1)
      end
      start = end_point
      end_point += ROS::Struct::calc_size('dL3')
      (@action_result.result.planning_time, @action_feedback.header.seq, @action_feedback.header.stamp.secs, @action_feedback.header.stamp.nsecs,) = @@struct_dL3.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.header.frame_id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('L2')
      (@action_feedback.status.goal_id.stamp.secs, @action_feedback.status.goal_id.stamp.nsecs,) = @@struct_L2.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.status.goal_id.id = str[start..(end_point-1)]
      start = end_point
      end_point += ROS::Struct::calc_size('C')
      (@action_feedback.status.status,) = @@struct_C.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.status.text = str[start..(end_point-1)]
      start = end_point
      end_point += 4
      (length,) = @@struct_L.unpack(str[start..(end_point-1)])
      start = end_point
      end_point += length
      @action_feedback.feedback.state = str[start..(end_point-1)]
      return self
    rescue => exception
      raise "message DeserializationError: #{exception}" #most likely buffer underfill
    end
  end
end # end of class
end # end of module
